define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "./_Base",
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/query",
    "dojo/_base/xhr"
    ], function(declare, lang, array, base, registry, domAttr, domConstruct, query, xhr) {
    return declare("widgets.PrizeDrawing_htapp", base, {
        indexElement: function() {
            this.inherited(arguments);
            this.PW = registry.byId("PrizeDrawing");
            this.prizeTable = query(".prizeDrawing", this.domNode)[0];
            this.prizeDra = query(".pDra", this.domNode)[0];
            var pDraImg = query(".pDraImg", this.domNode);
            this.pDraImg = [pDraImg[0], pDraImg[1], pDraImg[2], pDraImg[4], pDraImg[7], pDraImg[6], pDraImg[5], pDraImg[3]];
            this.resultCounts = registry.byId("resultCounts");
            /*if(g_sys_info.wxOrgId&&window.WeixinJSBridge){
                var node = domConstruct.create("div",{
                    style:"margin:5px;"
                },this.prizeTable,"before");
                domConstruct.create("span",{
                    innerHTML:"点击 "
                },node);
                domConstruct.create("a",{
                    innerHTML:"这里",
                    style:"color: #459ae9;",
                    onclick:function(){
                        WeixinJSBridge.invoke("profile",{
                            username:g_sys_info.wxOrgId,
                            scene:'9999'
                        });
                    },
                    href:"javascript:void(0)"
                },node);
                domConstruct.create("span",{
                    innerHTML:" 关注 "+g_sys_info.title
                },node);
            }*/
        },
        initData: function() {
            this.inherited(arguments);
            window.updateTitle("");
            this.PW.refreshList();
            this.getPDCounts();
            this.resultCounts.refreshList();
        },
        initEvent: function() {
            this.connect(this.PW, "onDefRendered", function(data) {
                items = data.data.items;
                if (items.length) {
                    window.updateTitle(items[0].ActivityName);
                    query('.pDra')[0].innerHTML = items[0].DrawLabel;
                    query('.comment')[0].innerHTML = items[0].Comment;
                }
            });
            this.connect(this.prizeDra, 'onclick', function(e) { //侦听list
                if (this._timer) {
                    return;
                }
                array.forEach(this.pDraImg, function(node, index) {
                    domAttr.set(node, "src", "../../content/htapp/images/headImg.png");
                    domAttr.set(node, "class", "pDraImg intOpcity");
                }, this);
                this.curCount = 1;
                this.pDraStart(); //开始抽奖
                this.onImport();
            });
        },
        //开始抽奖
        pDraStart: function() {
            if (this.curCount < 20||null===this.importedData) {
                array.forEach(this.pDraImg, function(node, index) {
                    domAttr.set(node, "class", "pDraImg pDraOpcity" + (1+((20-this.curCount + index)%8)));
                }, this);
                //domAttr.set(this.prizeTable,"class","prizeDrawing pDraState"+(this.curCount%8));
                this.curCount++;
                this._timer = setTimeout(lang.hitch(this, this.pDraStart), 80);
            } else {
                //获取抽奖结果
                this.updateShow();
            }
        },
        onImport: function() { //获取抽奖结果
            this.importedData = null;
            xhr("POST", {
                url: "/w/prize/draw/" + g_sys_info.code,
                content:{
                    billId:window.did,
                    srcWxId:window.srcWxId,
                    wxId:window.wx_openId
                },
                handleAs: "json",
                load: lang.hitch(this, function(result) {
                    this.importedData = result;
                    if (1 == result.rtnType) {
                        //取自己的票数
                        this.getPDCounts();
                    }
                }),
                error: function() {
                    this.importedData = {
                        rtnType:"101",
                        message:"发生错误"
                    };
                }
            });
        },
        updateShow:function(){
            if(this.importedData&&this.importedData.rtnType=="101"){
                array.forEach(this.pDraImg, function(node, index) {
                    domAttr.set(node, "class", "pDraImg intOpcity");
                }, this);
                alert(this.importedData.message);
            }else{
                var data = this.importedData.data;
                array.forEach(this.pDraImg, function(node, index) {
                    if (data[index].HEADIMGURL) {
                        domAttr.set(node, "src", data[index].HEADIMGURL);
                    } else {
                        domAttr.set(node, "src", "../../content/htapp/images/headImg.png");
                    }
                    domAttr.set(node, "class", "pDraImg intOpcity");
                    //query(".pName")[index].innerHTML = data[index].NICK;
                }, this);
            }
            window.free();
            this._timer - null;
        },
        getPDCounts: function() {
            window.loadData({
                modalName: "XSY_TCRSA_DRAWRESULTS",
                filter: "01",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "ActivityID": window.did,
                    "WXID": window.wx_openId
                }
            }).then(lang.hitch(this, function(data1) {
                if (!data1.length) {
                    query('#intPW')[0].style.display = '';
                    query('#resultPW')[0].style.display = 'none';
                } else {
                    xhr("POST", {
                        url: "/w/data/getCount/" + g_sys_info.code,
                        content: {
                            modalName: "XSY_TCRSA_DRAWRESULTS",
                            where: "[Counts]>" + data1[0].Counts
                        },
                        handleAs: "json",
                        load: lang.hitch(this, function(result) {
                            // alert(result.data);
                            //query("#MyResult")[0].innerHTML = data1[0]["WXID.NICKNAME"] + "，您当前已获得" + data1[0].Counts + "票";
                            query(".nick")[0].innerHTML = data1[0]["WXID.NICKNAME"];
                            query(".counts")[0].innerHTML = data1[0].Counts;
                            query('#intPW')[0].style.display = 'none';
                            query('#resultPW')[0].style.display = '';
                        })
                    });
                }
                window.free();
                this._timer = null;
            }));
        }
    });
});