require([
    "dojo/_base/lang",
    "dojo/_base/xhr",
    "dojo/_base/connect",
    "dojo/ready",
    "dojo/_base/array",
    "dojo/topic",
    "dojo/Deferred",
    "dojo/query",
    "dojox/mobile/TabBar",
    "dojox/mobile/TabBarButton",
    "dijit/registry",
    "widgets/userInfo",
    "widgets/orderCarRecord",
    "widgets/config/wxConfig",
    "dojo/dom-style",
    "widgets/config/shelfMatLoader"
], function(lang,xhr,connect,ready,array,topic,Deferred,query,TabBar,TabBarButton,registry,userInfo,orderCarRecord,wxConfig,domStyle,shelfMatLoader) {
    window.allInTpl = 1;
    
    // 底部按钮配置
    window.btmNav = [{
        // 标签
        label:"首页",
        checkedimgUrl:"../../Content/rct/images/mainchecked.png",
        uncheckedimgUrl:"../../Content/rct/images/mainunchecked.png",
        onClick:function(){
            window.moveToView("main");
        },
        viewId:"main"
    },{
        // 标签
        label:"动态",
        checkedimgUrl:"../../Content/rct/images/newschecked.png",
        uncheckedimgUrl:"../../Content/rct/images/newsunchecked.png",
        onClick:function(){
            window.moveToView("newsList");
        },
        viewId:"newsList"
    },{
        // 标签
        label:"联系卖家",
        checkedimgUrl:"../../Content/rct/images/msgchecked.png",
        uncheckedimgUrl:"../../Content/rct/images/msgunchecked.png",
        onClick:function(){
            window.moveToMsgList();
        },
        viewId:"msgList"
    },{
        // 标签
        label:"我的信息",
        checkedimgUrl:"../../Content/rct/images/userchecked.png",
        uncheckedimgUrl:"../../Content/rct/images/userunchecked.png",
        onClick:function(){
            window.moveToUser();
        },
        viewId:"user"
    }];
    var topSpliter = null,btmPane = null,tabbar = null,
        showFtView = ["orderList","orderDetail","matEvaList","pacTeamList","matLegalList","clientDistribute","matList"],
        viewChanged = function(){
            var isShow = false,
                curView = window.curView||"main";
            // 判断当前view与底部的哪一个按钮匹配 有 则设置为选中
            array.forEach(window.btmNav,function(btn){
                isShow = isShow||btn.viewId===curView||showFtView.indexOf(window.curView)>-1;
                btn.button.set("selected",btn.viewId===curView);
            });
            domStyle.set(btmPane.domNode,"height",isShow?"":"0px");
            topSpliter.resize();
        };
    
    // 监听视图切换方法
    connect.subscribe("widgets/show/view",window,viewChanged);
    
    ready(function(){
        connect.connect(registry.byId("topPane"),"onLoad",function(){
            // 找到容器
            topSpliter = registry.byId("topFixedSplitter");
            btmPane = registry.byId("btmPane");
            // 追加tabbarbtn
            if(!tabbar){
                // 创建tabbar容器
                tabbar = new TabBar({});
                btmPane.containerNode.appendChild(tabbar.domNode);
                tabbar.startup();
                // 给tabbar添加按钮
                array.forEach(window.btmNav,function(btn){
                    tabbar.addChild(btn.button = new TabBarButton({
                        label:btn.label,
                        onClick:btn.onClick,
                        icon1:btn.uncheckedimgUrl,
                        icon2:btn.checkedimgUrl
                    }));
                });
            }
            // 调用topFixedSplitter的resize方法
            topSpliter.resize();
        });
    });
    
    //视图配置信息
    window.viewParam = {
        //首页
        main: {
            headClass: "nothing",
            dojoType: "widgets/rct/Main",
            href: "/w/Content/common/shelf.tpl?v=2015050803"
        },
        //陶
        pottery: {
            headClass: "nothing",
            dojoType: "widgets/rct/Pottery",
            href: "/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 泥
        mud:{
            headClass:"nothing",
            dojoType:"widgets/rct/Mud",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 游
        enjoy:{
            headClass:"nothing",
            dojoType:"widgets/rct/Enjoy",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 乐
        tool:{
            headClass:"nothing",
            dojoType:"widgets/rct/Tool",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 工作室首页
        studio:{
            headClass:"nothing",
            dojoType:"widgets/rct/Studio",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },
        //分销推广
        clientDistribute:{
            headClass: "nothing",
            dojoType: "widgets/standardTmp01/ClientDistribute",
            href: "/w/Content/common/shelf.tpl?v=2015050803"
        },
        //手机验证
        newRegister:{
            headClass: "nothing",
            dojoType: "widgets/standardTmp01/NewRegister",
            href: "/w/Content/common/shelf.tpl?v=2015050803"
        },
        //会员信息
        user:{
            headClass:"nothing",
            dojoType:"widgets/rct/User",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 商品列表  2015-08-13 替换为新版本 周春花
        matList:{
            headClass: "nothing",
            dojoType:"widgets/rct/MatList",
            href:"/w/Content/common/shelf.tpl"
        },
        // 商品详情
        matDetail:{
            headClass:"nothing",
            dojoType:"widgets/standardTmp01/MatDetail1",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 动态详情
        news: {
            headClass: "nothing",
            dojoType: "widgets/standardTmp01/News",
            href: "/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 动态列表
        newsList: {
            headClass: "nothing",
            dojoType: "widgets/standardTmp01/NewsList",
            href: "/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 购物车
        /*orderCar:{
            headClass:"nothing",
            dojoType:"widgets/standardTmp01/OrderCar",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },*/
        // 提交订单
        orderInfo:{
            headClass:"nothing",
            dojoType:"widgets/standardTmp01/NqbOrderInfo",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 订单列表
        orderList:{
            headClass:"nothing",
            dojoType:"widgets/standardTmp01/OrderList",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 订单详情
        orderDetail:{
            headClass:"nothing",
            dojoType:"widgets/standardTmp01/OrderDetail",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 修改个人信息
        mdfUserInfo:{
            headClass:"nothing",
            dojoType:"widgets/standardTmp01/NewMdfuserInfo",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 投诉列表
        matLegalList:{
            headClass:"nothing",
            dojoType:"widgets/standardTmp01/MatLegalList",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 提交投诉
        matLegal:{
            headClass:"nothing",
            dojoType:"widgets/standardTmp01/MatLegal",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 投诉详情
        matLegalDtl:{
            headClass:"nothing",
            dojoType:"widgets/standardTmp01/MatLegalDtl",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 评价列表
        matEvaList:{
            headClass:"nothing",
            dojoType:"widgets/standardTmp01/MatEvaList",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 提交评价
        matEva:{
            headClass:"nothing",
            dojoType:"widgets/standardTmp01/NewMatEva",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 追加评价
        matEvaToAdd:{
            headClass:"nothing",
            dojoType:"widgets/standardTmp01/MatEvaToAdd",
            href:"/w/Content/common/shelf.tpl?v=2015050803"
        },
        shelf:{
            headClass: "nothing",
            dojoType: "widgets/zctapp/Shelf",
            href: "/w/Content/common/shelf.tpl?v=2015050803"
        },
        imgVote:{
            headClass:"nothing",
            dojoType: "widgets/achapp/ImgVote",
            href: "/w/Content/common/shelf.tpl?v=2015050803"
        },
        imgVoteWall:{
            headClass:"nothing",
            dojoType: "widgets/achapp/ImgVoteWall",
            href: "/w/Content/common/shelf.tpl?v=2015050803"
        },
        //抽奖相关界面//需要调整
        prizeDrawing: { //ok
            headClass: "headerContent",
            dojoType: "widgets/standardTmp01/PrizeDrawing",
            href: "/w/Content/common/shelf.tpl?v=2015050803"
        },
        //需要调整
        prizeDrawData: { //ok
            headClass: "headerContent",
            dojoType: "widgets/standardTmp01/PrizeDrawData",
            href: "/w/Content/common/prizeDrawData.tpl?v=2015050803"
        },
        // 个人信息设置
        userSetting:{
            headClass: "headerContent",
            dojoType: "widgets/standardTmp01/UserSetting",
            href: "/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 商品详情测试页
        matDtl:{
            headClass: "headerContent",
            dojoType: "widgets/standardTmp01/MatDetail1",
            href: "/w/Content/common/shelf.tpl?v=2015050803"
        },
        // 消息视图
        msgList:{
            headClass: "headerContent",
            dojoType: "widgets/standardTmp01/MsgList",
            href: "/w/Content/common/noScrollShelf.tpl?v=2015050803"
        },
        onlineVote:{
            headClass:"headerContent",
            dojoType:"widgets/htapp/OnlineVote",
            href: "/w/Content/common/onlineVote.tpl?v=2015062601"
        },
        svcList: {
            headClass: "nothing",
            dojoType: "widgets/cqagri/SvcList",
            href: "/w/Content/common/shelf.tpl?v=2015032001"
        },
        enterpriseMain : {
            headClass: "nothing",
            dojoType: "widgets/cqagri/EnterpriseMain",
            href: "/w/Content/common/shelf.tpl?v=2015032001"
        },
        onlineVoteList:{
            handleAs:"headerContent",
            dojoType:"widgets/htapp/OnlineVoteList",
            href:"/w/Content/common/onlineVoteList.tpl"
        },
        // 优惠券列表
        disSerList:{
            headClass: "nothing",
            dojoType:"widgets/standardTmp01/DisSerList",
            href:"/w/Content/common/shelf.tpl"
        },
        // 帮助
        help:{
            headClass: "nothing",
            dojoType:"widgets/standardTmp01/Help",
         //   href: "/w/Content/common/shelf.tpl?v=2015032001"
            href:"/w/Content/standardTmp01/help.tpl"
        },
        // 选菜
        matOption:{
            headClass: "nothing",
            dojoType:"widgets/standardTmp01/MatOption",
            href:"/w/Content/common/shelf.tpl"
        },
        // 魔方英语培训排行
        engRanking:{
            headClass: "nothing",
            dojoType:"widgets/standardTmp01/EngRanking",
            href:"/w/Content/common/shelf.tpl"
        },
        // 新版订单详情
        newOrderDetail:{
            headClass: "nothing",
            dojoType:"widgets/standardTmp01/NewOrderDetail",
            href:"/w/Content/common/shelf.tpl"
        },
        matDetailEva:{
            headClass: "nothing",
            dojoType:"widgets/standardTmp01/MatDetailEva",
            href:"/w/Content/common/shelf.tpl"
        },
        resBook:{
            headClass: "nothing",
            dojoType:"widgets/standardTmp01/ResBook",
            href:"/w/Content/common/shelf.tpl"
        },
        downAppList:{
            headClass: "nothing",
            dojoType:"widgets/standardTmp01/DownAppList",
            href:"/w/Content/common/shelf.tpl"
        },
        matEval_l:{
            headClass:"headerContent",
            dojoType:"widgets/htapp/matEval_l",
            href:"/w/Content/common/shelf.tpl"
        },
        //商家端找回密码
        getAppPwd:{
            headClass:"headerContent",
            dojoType:"widgets/standardTmp01/GetAppPwd",
            href:"/w/Content/common/getAppPwd.tpl"
        },
        prizeBigWheel:{
            headClass: "headerContent",
            dojoType: "widgets/sjmdsvc/PrizeBigWheel",
            href: "/w/Content/common/shelf.tpl?v=2015072903"
        },
        myPrize:{
            headClass: "headerContent",
            dojoType: "widgets/sjmdsvc/MyPrize",
            href: "/w/Content/common/shelf.tpl?v=2015072903"
        },
        prizeAward:{
            headClass: "headerContent",
            dojoType: "widgets/sjmdsvc/PrizeAward",
            href: "/w/Content/common/shelf.tpl?v=2015072903"
        },
        //配送明细
        distraBill:{
            headClass:"nothing",
            dojoType:"widgets/standardTmp01/DistraBill",
            href:"/w/Content/common/distraBill.tpl?v=2015050803"
        },
        //在村头首页
        village:{
            headClass:"headerContent",
            dojoType:"widgets/standardTmp01/Village",
           // dojoType:"widgets/_base",
           // href:"/w/Content/common/village.tpl?v=2015050803"
            href:"/w/Content/common/shelf.tpl"
        },
        //在村头村民列表
        villagerList:{
            headClass:"headerContent",
            dojoType:"widgets/zctapp/VillagerList",
            href:"/w/Content/common/shelf.tpl"
        },
        villager:{
            headClass:"headerContent",
            dojoType:"widgets/standardTmp01/Villager",
            href:"/w/Content/common/shelf.tpl"
        },
        dstbtList:{
            headClass:"headerContent",
            dojoType:"widgets/standardTmp01/NqbDstbtList",
            href:"/w/Content/common/shelf.tpl"
        },
        //购物车
        orderCar:{
            headClass:"headerContent",
            dojoType:"widgets/standardTmp01/NqbOrderCar",
            href:"/w/Content/common/shelf.tpl"
        },
        appRegister:{
            headClass:"headerContent",
            dojoType:"widgets/zctapp/AppRegister",
            href:"/w/Content/common/shelf.tpl?2015111101"
        },
        srcAppList:{
            headClass:"headerContent",
            dojoType:"widgets/zctapp/SrcAppList",
            href:"/w/Content/common/shelf.tpl?2015111101"
        },
        reVillager:{
            headClass:"headerContent",
            dojoType:"widgets/zctapp/ReVillager",
            href:"/w/Content/common/shelf.tpl?2015111101"
        },
        myVillage:{
            headClass:"headerContent",
            dojoType:"widgets/zctapp/MyVillage",
            href:"/w/Content/common/shelf.tpl?2015111101"
        },
        villagerEdt:{
            headClass:"headerContent",
            dojoType:"widgets/zctapp/VillagerEdt",
            href:"/w/Content/common/shelf.tpl?2015111101"
        },
        // 资讯写评价
        subNewsEva:{
            handleAs:"nothing",
            dojoType:"widgets/standardTmp01/SubNewsEva",
            href:"/w/Content/common/shelf.tpl"
        },
        // 资讯评价列表
        evasList:{
            handleAs:"nothing",
            dojoType:"widgets/standardTmp01/EvasList",
            href:"/w/Content/common/shelf.tpl"
        },
        // 收货信息列表
        myAddr:{
            handleAs:"nothing",
            dojoType:"widgets/standardTmp01/MyAddr",
            href:"/w/Content/common/shelf.tpl"
        },
        //新增收货信息
        edtAddr:{
            handleAs:"nothing",
            dojoType:"widgets/standardTmp01/EdtAddr",
            href:"/w/Content/common/shelf.tpl"
        },
        // 选择收货地址
        chooseAddr:{
            handleAs:"nothing",
            dojoType:"widgets/standardTmp01/ChooseAddr",
            href:"/w/Content/common/shelf.tpl"
        },
        traceCard:{
            handleAs:"nothing",
            dojoType:"widgets/standardTmp01/TraceCard",
            href:"/w/Content/common/shelf.tpl"
        },
        photoWall:{
            handleAs:"nothing",
            dojoType:"widgets/standardTmp01/PhotoWall",
            href:"/w/Content/common/shelf.tpl"
        },
        //讲堂
        classRoomList:{
            handleAs:"nothing",
            dojoType:"widgets/zctapp/ClassRoomList",
            href:"/w/Content/common/shelf.tpl"
        },
        //报名
        classRoomDtl:{
            handleAs:"nothing",
            dojoType:"widgets/zctapp/ClassRoomDtl",
            href:"/w/Content/common/shelf.tpl"
        },
        // 物流查询
        logQry:{
            handleAs:"nothing",
            dojoType:"widgets/standardTmp01/LogQry",
            href:"/w/Content/common/shelf.tpl"
        },
        myCoupons:{
            handleAs:"nothing",
            dojoType:"widgets/standardTmp01/MyCoupons",
            href:"/w/Content/common/shelf.tpl"
        },
        appCoupons:{
            handleAs:"nothing",
            dojoType:"widgets/standardTmp01/AppCoupons",
            href:"/w/Content/common/shelf.tpl"
        },
        pacTeamList:{
            handleAs:"nothing",
            dojoType:"widgets/standardTmp01/pacTeamList",
            href:"/w/Content/common/shelf.tpl"
        },
        pacBuyList:{
            handleAs:"nothing",
            dojoType:"widgets/standardTmp01/pacBuyList",
            href:"/w/Content/common/shelf.tpl"
        },
        pacDetail:{
            handleAs:"nothing",
            dojoType:"widgets/sjmdsvc/PacDetail",
            href:"/w/content/sjmdsvc/pacDetail.tpl?v=2015050803"
        },
        pacBuyDetail:{
            headClass:"headerContent",
            dojoType:"widgets/standardTmp01/pacBuyDetail",
            href:"/w/content/common/shelf.tpl" 
        },
        pacBuyIntroduces:{
            headClass:"headerContent",
            dojoType:"widgets/standardTmp01/pacBuyIntroduces",
            href:"/w/content/common/shelf.tpl"
        }
    };
    
    //系统相关接口
    //更新页面标题
    window.updateTitle = function(title){
        document.title = title;
    };
    
    //用户相关操作
    //默认的登录成功之后切换懂得目标视图
    window.nextPageOnLogin = "user";
    //切换到用户登录页面
    topic.subscribe("widgets/userInfo/toLogin", function() {
        window.moveToView("newRegister");
    });
    //商品相关操作
    //依据商品mid进商品详细信息
    window.matClick = function(mid, mtid) {
        if (mtid) {
            //if(g_sys_info.code=='SVC10849'){
            //    window.moveToView("matDtl", mtid);
            //}else{
                window.moveToView("matDetail", mtid);
            //}
        } else {
            //if(g_sys_info.code=='SVC10849'){
            //    window.moveToView("matDtl", mid);
            //}else{
                window.moveToView("matDetail", mid);
            //}
        }
    };
    //添加到购物车
    window.addOrderCar = function(mid, num, mname) {
        require(["widgets/orderCarRecord"],function(orderCarRecord){
            var car = orderCarRecord.getOrderCar();
            car[window.did] = (car[window.did] || 0) + parseFloat(num);
            orderCarRecord.setOrderCar(car);
            orderCarRecord.carChanged = true;
            /*var c = orderCarRecord.getOrderCar(),n = 0;
            for(var m in c){
                n += c[m]||0;
            }
            query(".cart_com",this.domNode)[0].innerHTML = n;
            array.forEach(query(".stdOrderNum",this.domNode),function(node){
                node.innerHTML = n;
            });*/
            alert("商品添加成功");
            /*if (confirm(mname + "添加成功，是否进入购物车结算？")) {
                window.moveToView("orderCar");
            }*/
        });
    };
    //立即购买
    window.singleBuyMat = function(mid, num) {
        var def = new Deferred();
        window.singleBuyMatId = mid;
        orderCarRecord.clearMats(); //清空选中商品
        orderCarRecord.addSelectedMat(mid); //将立即购买的商品添加到选中状态
        // 立即购买时直接进入orderInfo视图
        window.loadData({ //重新加载商品视图,找到立即购买的商品
            modalName: "XSY_VBSSC_MAT",
            filter: "17",
            pageSize: "1",
            pageIndex: "1",
            param: {
                "MID": mid
            }
        }).then(lang.hitch(this, function(data) {
            //如果找到了该商品
            if (data.length) {
                // 找商品的预售信息
                window.loadData({
                    modalName: "XSY_TCRMK_MAT_ADSALE",
                    filter: "01",
                    pageSize: "1",
                    pageIndex: "1",
                    param: {
                        "MID": mid
                    }
                }).then(lang.hitch(this, function(data2) {
                    window.loadData({
                        modalName: "XSY_TCRMK_MAT_ADSALEDTS",
                        filter: "01",
                        pageSize: "1",
                        pageIndex: "1",
                        param: {
                            DID: data2.length ? data2[0].DID : ""
                        }
                    }).then(lang.hitch(this, function(data3) {


                        orderCarRecord.data = {};
                        orderCarRecord.data.data = {};
                        orderCarRecord.data.data.items = data;
                        orderCarRecord.total = 0;
                        data[0].QTY = num; //立即购买的商品数量

                        if (data3.length) {
                            //if(data2.PayEarNum)
                            //data[0].AMNT = data
                            array.forEach(data3, function(data3) {
                                if (data3.QTY2 == "") {
                                    if (parseFloat(data2[0].PayEarNum) >= parseFloat(data3.QTY1)) {
                                        data[0].AMNT = data3.RE_PRICE * num;
                                        data[0].R_AMNT = data[0].T3_RetailPrice * num;
                                        data[0].PRE_REPRIC = data3.RE_PRICE;
                                        data[0].PRE_DISPRIC = data3.DIS_PRICE;
                                    }
                                } else {
                                    if (parseFloat(data2[0].PayEarNum) >= parseFloat(data3.QTY1) && parseFloat(data2[0].PayEarNum) <= parseFloat(data3.QTY2)) {
                                        data[0].AMNT = data3.RE_PRICE * num;
                                        data[0].R_AMNT = data[0].T3_RetailPrice * num;
                                        data[0].PRE_REPRIC = data3.RE_PRICE;
                                        data[0].PRE_DISPRIC = data3.DIS_PRICE;
                                    }
                                }
                            });
                        } else {
                            data[0].AMNT = data2.length ? num * data2[0].RE_PRICE : num * data[0].T3_RetailPrice; //商品小计
                            data[0].R_AMNT = data[0].T3_RetailPrice * num;
                            data[0].PRE_REPRIC = data2.length ? data2[0].RE_PRICE : "";
                            data[0].PRE_DISPRIC = data2.length ? data2[0].DIS_PRICE : "";
                        }

                        orderCarRecord.total = data[0].AMNT || 0;

                        orderCarRecord.ear = data2.length ? data2[0].EARNEST * num : "";
                        orderCarRecord.IS_PRESALE = data2.length ? 1 : 0;
                        orderCarRecord.HDID = data2.length ? data2[0].DID : "";
                        window.orderMids = [mid];
                        // 取商品优惠信息
                        xhr("GET",{
                            url:"/w/data/GetMatsCreditByQty/"+window.code+"-"+window.openId,
                            handleAs:"json",
                            content: {
                                mats: mid,
                                qtys:num
                            },
                            load:function(result) {
                                if(result&&result.data&&result.data.items){
                                    var deposit=parseFloat(result.data.items[0].CREDIT,10)||0;
                                    data[0].DIS = deposit;
                                }
                                def.resolve();
                            },
                            error:function(err){
                                //提交订单错误，返回错误及信息
                                def.resolve({
                                    rtnType:"101",
                                    message:err&&err.message||"数据错误"
                                });
                            }
                        });
                        window.moveToView("orderInfo");
                    }));
                }));
            }
        }));
    };
    //订单列表点击
    window.orderClick = function(orderId, orderAMNT) {
        window.moveToView("orderDetail", orderId);
    };
    //新闻列表点击
    window.newsClick = function(newsid) {
        window.moveToView("news", newsid);
    };
    //发送验证码
    this.isSend = true; //定义全局变量 是否发送的标志  60秒内不能重复发送
    this.isVari = true; //定义全局变量  验证码是否有效  5分钟内验证码有效
    window.sendMsg = function(phone) { //发送验证码
        if (isSend) {
            var def = new Deferred();
            xhr("GET", {
                url: "/w/data/getSmsPwd/" + g_sys_info.code + "?phone=" + phone,
                handleAs: "json",
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        alert("验证码已发送，请查看新的手机短信息！如果您的手机具备手机拦截功能，也请检查被拦截的短信息。");
                        def.resolve(true);
                        isVari = true; //验证码5分钟内有效
                        isSend = false; //60秒后方可再次发送
                        setTimeout(function(){
                            isSend=true;
                        }, 60000); //60 000ms后即60秒可以发送
                        setTimeout(function(){
                            isVari=false;
                        }, 300000); //30 000ms后即5分钟后，验证码过期，需重新发送
                    } else {
                        //执行失败
                        alert("验证码发送失败，请稍后重试。如您长时间未收到系统发送的验证码，请检查是否被拦截功能拦截，或请致电400-023-8993咨询！");
                        def.resolve(false);
                    }
                }),
                error: function() {
                    //出错
                    def.resolve();
                }
            });
            return def;
        } else {
            alert("您的发送验证码请求间隔太短，请稍候再发送验证码！");
            window.free();
        }
    };
    window.postVerCode = function(phone, code) { //验证验证码
        if (isVari) {
            var def = new Deferred();
            xhr("GET", {
                url: "/w/data/validSmsPwd/" + g_sys_info.code + "?phone=" + phone + "&pwd=" + code,
                handleAs: "json",
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        def.resolve(true);
                    } else {
                        //执行失败
                        alert("您输入的验证码不正确，请检查后重新输入！如您长时间未收到系统发送的验证码，请检查是否被拦截功能拦截，或请致电400-023-8993咨询！");
                        def.resolve(false);
                    }
                }),
                error: function() {
                    //出错
                    def.resolve(false);
                }
            });
            return def;
        } else {
            alert("验证码5分钟内有效，您的验证码已过期，请再次发送验证码！");
            window.free();
        }
    };
    window.moveToUser = function(){
        userInfo.hasLogin().then(function(s){
            if(s){
                window.moveToView("user");
            }else{
                userInfo.showLogin();
            }
        });
    };
    //重写confirm,异步函数
    window.defConfirm = function(msg, cancelBtnName, okBtnName){
		var def = new Deferred();
		wxConfig.showDialog(msg,def,"confirm",cancelBtnName,okBtnName);
		return def;
	};
    window.moveToMsgList = function(){
        //userInfo.hasLogin().then(function(s){
        //    if(s){
                window.moveToView("msgList");
        //    }else{
        //        window.nextPageOnLogin = "msgList";
        //        userInfo.showLogin();
        //    }
        //});
    };
    
    shelfMatLoader.initMatBox = function(matBox,info){
        // 依据info.MID 重新加载商品信息
        // 返回数据 
        // var item = data;
        // matBox.domNode.innerHTML = this.getMatBoxHtml(item,info.ISSHOWTITLE,info.ISSHOWPRICE,0,info.single?1:0);
        window.loadData({
            modalName:"NY_VBSSC_MAT_SIMPLE",
            filter:"01",
            param:{"MID":info.T0_MID||info.T0_MTID}
        }).then(lang.hitch(this,function(data){
            var item = {
                IconURLID:info.IMG_ID||data[0].IconURLID,
				IS_TG:data[0].IS_TG,
				IS_CX:data[0].IS_CX,
				HREF:info.HREF,
				GName:info.TITLE||data[0].GName,
				MeasureName:data[0].MeasureName,
				HighestPrice:data[0].HighestPrice,
				RetailPrice:data[0].RetailPrice,
				TPCH_NUM:data[0].TPCH_NUM
            };
            matBox.domNode.innerHTML = this.getMatBoxHtml(item,info.ISSHOWTITLE,info.ISSHOWPRICE,0,info.single?1:0);
        }));
    };
    //获取商品数据，得到标准化的商品信息
	shelfMatLoader.getMatInfoByRegion = function(pageSize){
        return window.loadData({
            modalName:"NY_TBSSC_MAT_RECOM",
            filter:"01",
            pageSize:""+pageSize,
            pageIndex:"1",
            param:{}
        }).then(this.getTargetMatInfo);
	};
	shelfMatLoader.getMatInfoByHot=function(pageSize){
		return window.loadData({
            modalName:"NY_VBSSC_MAT_SIMPLE",
            filter:"34",
            pageSize:""+pageSize,
            pageIndex:"1",
            param:{}
        }).then(this.getTargetMatInfo);
	};
	shelfMatLoader.getMatInfoByGroup=function(mgid,pageSize){
		return window.loadData({
            modalName:"NY_VBSSC_MAT_SIMPLE",
            filter:"18",
            pageSize:pageSize,
            pageIndex:"1",
            param:{"MGID":mgid,"INPUT":""}
        }).then(this.getTargetMatInfo);
	};
	//获取标准化的商品信息，方便后边使用
	shelfMatLoader.getTargetMatInfo=function(datas){
		return array.map(datas,function(data){
			var fieldPre = data["MID.MID"]?"MID.":"";
			//区分直销和分销商品
			return lang.mixin({
				HighestPrice:data[fieldPre+"HighestPrice"],
				IS_TG:data[fieldPre+"IS_TG"],
				IS_CX:data[fieldPre+"IS_CX"],
				GName:data[fieldPre+"GName"],
				MGroupID:data[fieldPre+"MGroupID"],
				MGName:data[fieldPre+"MGName"]
			},data[fieldPre+"MTID"]?{
				MID:data[fieldPre+"MTID"],
				RetailPrice:data[fieldPre+"RetailPrice"],
				MeasureName:data[fieldPre+"MeasureName"],
				IconURLID:data[fieldPre+"IconURLID"],
				TPCH_NUM:data[fieldPre+"TPCH_NUM"]
			}:{
				MID:data[fieldPre+"MID"],
				RetailPrice:data[fieldPre+"RetailPrice"],
				MeasureName:data[fieldPre+"MeasureName"],
				IconURLID:data[fieldPre+"IconURLID"],
				TPCH_NUM:data[fieldPre+"TPCH_NUM"]
			});
		});
	};
});