﻿define([
	"dojo/_base/lang",
	"dojo/Deferred"
],function(lang,Deferred){
	//提供文件系统应具备的基本功能的接口：
	//		1，本对象定义了文件系统接口的参数和返回值，所有文件系统都要继承本对象，并按照本对象定义的接口做对应实现
	//		2，只定义文件系统的接口，不做任何实现
	//		3，任何文件系统可能都只实现其中几个接口
	//		4，只有子类实现的接口才能正常工作
	return lang.mixin(lang.getObject("cqthink.fs.fsBase",true),{
		//将一组文件转为base64字符串
		readAsDataURL:function(files){
			//files为对应文件系统中的文件组成的文件列表
			var def = new Deferred();
			def.resolve([]);
			console.log("readAsDataURL 必须由子类实现之后才能正常工作");
			return def;
		},
		selectFiles:function(param){
			//param为选取文件的参数。包含的基本参数至少包含几个：
			//		mult：true/false，单选或多选
			//		fileType：要选择的文件类型
			var def = new Deferred();
			def.resolve([]);
			console.log("selectFiles 必须由子类实现之后才能正常工作");
			return def;
		}
	});
});