﻿define([
	"dojo/_base/array",
	"dojo/_base/lang",
	"dojo/dom-attr",
	"dojo/dom-construct",
	"dojo/Deferred",
	"dojo/DeferredList",
	"dojo/on",
	"./fsBase"
],function(array,lang,domAttr,domConstruct,Deferred,DeferredList,on,fsBase){
	var pendding = false,setPending = function(){
		pendding = false;
	},isPendding = function(){
		if(pendding){
			return true;
		}else{
			pendding = true;
			setTimeout(setPending,500);
			return false;
		}
	};
	//功能：选择和读取本地磁盘文件
	//		1，从本地磁盘文件系统中选取文件
	//		2，对从本地磁盘文件系统中选取的文件做处理，转base64
	var localDiskFS = lang.mixin(lang.getObject("cqthink.fs.localDiskFS",true),fsBase,{
		//读取本地文件为base64字符串
		readAsDataURL:function(files){
			return new DeferredList(array.map(files,this._readAsDataURL)).then(function(r){
				var  result = [];
				array.forEach(r,function(_r){
					result.push(_r[1]);
				},this);
				return result;
			});
		},
		//读取单个文件为base64字符串
		_readAsDataURL:function(file){
			var def = new Deferred();
			var reader = new FileReader();
			reader.onloadend = function(){
				def.resolve(reader.result);
			};
			reader.readAsDataURL(file);
			return def;
		},
		//从本地文件系统中选取文件
		selectFiles:function(param){
			if(!isPendding()){
				var def = new Deferred();
				//初始化需要的节点
				this._initNode();
				//设置选取文件的模式，单选/多选
				domAttr.set(fileInput,"multiple",!!(param&&param.mult));
				//控制选择的文件类型
				domAttr.set(fileInput,"accept",param&&param.fileType||"");
				//记录选取文件的异步对象，选取文件之后操作结束
				this._fileDef = def;
				on.emit(fileInput,"click",{
					cancelable: true,
					bubbles: true
				});
				return def;
			}
		},
		_onFileSelected:function(){
			if(this._fileDef&&fileInput){
				if(fileInput.files){
					this._fileDef.resolve(fileInput.files);
				}else if(fileInput.value){
					var file = fileInput;
					fileForm.removeChild(fileInput);
					file.onchange = null;
					fileInput = domConstruct.create("input",{
						type:"file",
						style:"display:none",
						onchange:lang.hitch(this,this._onFileSelected),
						oncancel:lang.hitch(this,this._onFileSelected)
					},fileForm);
					this._fileDef([file]);
				}else{
					this._fileDef.resolve([]);
				}
				this._fileDef = null;
			}
		},
		_initNode:function(){
			//重置文件列表
			fileForm.reset();
		}
	}),fileForm = domConstruct.create("form",{
		style:"width:auto;height:0px;"
	},document.body),fileInput = domConstruct.create("input",{
		type:"file",
		style:"display:none",
		onchange:lang.hitch(localDiskFS,localDiskFS._onFileSelected),
		oncancel:lang.hitch(localDiskFS,localDiskFS._onFileSelected)
	},fileForm);
	return localDiskFS;
});