define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/array",
	"dojo/_base/json",
	"dojo/_base/xhr",
	"dojo/dom-construct",
	"dojo/dom-style",
	"dojo/query",
	"dojo/touch",
	"dojo/Deferred",
	"dojox/mobile/FixedSplitter",
	"dojox/mobile/Pane",
	"dojox/mobile/ScrollablePane",
	"dojox/mobile/Button",
	"dojox/mobile/TextBox",
	"cqthink/wb/List3",
	"cqthink/image/common",
	"cqthink/mobile/imgPrc/capture"
],function(declare,lang,array,json,xhr,domConstruct,domStyle,query,touch,Deferred,FixedSplitter,Pane,ScrollablePane,Button,TextBox,List3,imageCommon,capture){
	//domConstruct.create("style",{
	//	type:"text/css",
	//	innerHTML:'.leftd,.rightd{display:block;margin-top:15px}.leftd>div{text-align:left}.rightd>div{text-align:right}.chartTime>label{text-align:center;display:block}.userLeftPic,.userRightPic{display:inline-block}.userRightPic{float:right}.userLeftPic>img,.userRightPic>img{max-width:60px}div.speech{margin:3px 0;padding:8px;table-layout:fixed;word-break:break-all;position:relative;background:-webkit-gradient(linear,50% 0,50% 100%,from(#fff),color-stop(0.1,#ececec),color-stop(0.5,#dbdbdb),color-stop(0.9,#dcdcdc),to(#8c8c8c));-webkit-border-radius:8px;-moz-border-radius:8px;border-radius:8px;display:inline-block;max-width:72%;text-align:left;vertical-align:top}.speech>img{max-width:100%}div.speech.left{background:#97c94c;background:-webkit-gradient(linear,left top,left bottom,from(#cf9),to(#9c3));background:-webkit-linear-gradient(#cf9,#9c3);background:-moz-linear-gradient(#cf9,#9c3);background:-ms-linear-gradient(#cf9,#9c3);background:-o-linear-gradient(#cf9,#9c3);background:linear-gradient(#cf9,#9c3);-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;padding:10px 15px;left:15px}div.speech.right{padding:10px 15px;right:15px}div.speech.left:before,.speech.left:after,.speech.right:before,.speech.right:after{content:"";display:block;overflow:hidden;top:10px;position:absolute;font-size:0;line-height:0;bottom:auto;left:auto;right:auto;border-style:solid dashed dashed;border-width:0}div.speech.left:before{left:-15px;border-width:8px 15px 8px 0;border-color:transparent #bf6 transparent transparent}div.speech.right:after{right:-15px;border-width:8px 0 8px 15px;border-color:transparent transparent transparent #eae8e8}.clear{clear:both}.chartNameLabel{font-size:12px;padding-left:6px;padding-top:15px}'
	//},document.head);
	//消息对话对话框
	//	功能结构
	//		FixedSplitter
	//			Pane
	//				ScrollablePane
	//					List3
	//			Pane
	//				TextBox
	//				imagePicker
	//				Button
	return declare("cqthink.mobile.TalkMsgList",[FixedSplitter],{
		baseClass:"cqMsgList",
		//界面划分需要的属性
		//垂直切分界面
		orientation:"V",
		//第一部分高度变化
		variablePane:0,
		style:"height:100%;",
		
		//消费者端的属性
		pid:"",
		wxId:"",
		//商家端员工对话时也存在这个问题
		tuid:"",
		
		//商家端的属性
		uid:"",
		path:"",
		wxPath:"",
		twxId:"",
		//消费者发送给消费者也需要的属性
		tpid:"",
		isWxServiceMessage:false,
		
		//是不是消费者端的 标志
		isClient:true,
		//网站根目录地址
		host:"",
		code:"",
		svcName:"",
		svcLogo:"",
		
		//自己维护的属性
		//消息列表对应的拖动区域
		_scrollPane:null,
		//对话信息列表
		_msgList:null,
		//录入要发送的信息的文本框
		_msgTextBox:null,
		//选择图片的安妮
		_imgPicker:null,
		//发送按钮
		_msgSendBtn:null,
		//头像链接到的个人资料页面名称
		resumePage:"",
		
        typeName:{
            voice:"语音",vedio:"视频"
        },
        typeAppend:{
            voice:"amr",vedio:"mp4"
        },
		
		//初始化界面元素
		buildRendering:function(){
			this.inherited(arguments);
			var curPane = null;
			//头部可滑动区域
			this.addChild(topPane = new Pane());
			topPane.containerNode.appendChild((this._scrollPane = curPane = new ScrollablePane({
				height:"100%",
				"class":"cqMsgListScrollPane"
			})).domNode);
			this._msgList = new List3({
				dir:"bottom2top",
				"class":"cqMsgListTalk",
				"id":this.id+"MsgList",
				showReleaseNode:function(){},
				showLoadingNode:function(){},
				showListPenddingNode:function(){},
				showPullToLoadMoreNode:function(){}
			},domConstruct.create("div",{
				innerHTML:"{%for item in items%}{{item.htmlStr|safe}}{%endfor%}"
			}));
			curPane.containerNode.appendChild(this._msgList.domNode);
			
			//底部区域界面
			this.addChild(curPane = new Pane());
			curPane.containerNode.innerHTML = '<table class="cqMsgListSendTable"><tr><td class="cqMsgListImgTd"><div class="msgImgDiv"></td><td><form onsubmit="return false;" class="msgForm"></form></td><td class="cqMsgListBtnDiv"><div class="msgSendBtnDiv"></div></td></tr></table>';
		},
		startup:function(){
			if(!this._sendBtn){
				this.own(touch.release(query(".msgImgDiv",this.domNode)[0],lang.hitch(this,this._onSelectImg)));
				this._msgTextBox = new TextBox({},domConstruct.create("input",{
					type:"text",
					style:"width:100%;"
				},query(".msgForm",this.domNode)[0]));
				this._msgTextBox.startup();
				
				this._msgSendBtn = new Button({
					label:"发送",
					onClick:lang.hitch(this,this._onSendMsg)
				},domConstruct.create("span",{},query(".msgSendBtnDiv",this.domNode)[0]));
				//form提交时表示要发送文本内容
				this.connect(query(".msgForm",this.domNode)[0],"onsubmit",this._onSendMsg);
				//刷新消息列表本身是加载数据并刷新显示
				this.connect(this._msgList,"refreshList",this._loadMsgData);
			}
			this.inherited(arguments);
			this._msgList.rendered = false;
		},
		
		//用户企图选择并上传图片
		_onSelectImg:function(){
			imageCommon.selectImg().then(lang.hitch(this,function(url){
				if(url){
					imageCommon.resizeImage(url,640,640).then(lang.hitch(this,function(url1){
						this.onSendImg(url1).then(lang.hitch(this,function(){
							this.refreshMsgList();
						}));
					}));
				}
			}));
		},
		//发送文本消息
		_onSendMsg:function(){
			if(this._msgTextBox.get("value")){
				var value = this._msgTextBox.get("value");
				this._msgTextBox.set("value","");
				this.onSendText(value).then(lang.hitch(this,function(){
					this.refreshMsgList();
				}));
			}
		},
		//确定流程的接口
		_loadMsgData:function(page){
			this._msgList.curPage = this._pageIndex = page||1;
			this.loadMsgData(page).then(lang.hitch(this,this._onDataReady));
		},
		//获取要显示的内容
		_getItemStr:function(item){
			var type,content = item.MESSCONTENT,date = item.SENDDATE;
			//处理图片和语音
			if(0<content.indexOf(",IMG:")){
				type = content.split(",")[0].split(":")[1].toLowerCase();
				type = type.substr(1);
				type = type.substr(0,type.length-1);
				content = content.split(":").pop();
				content = content.substr(0,content.length-1);
				if("image"===type){
					content = "<img src='"+this.host+"/w/img/load/"+(this.code||g_sys_info.code)+"-"+content+".png'/>";
				}else{
					content = '查看<a href="'+this.host+"/w/img/load/"+(this.code||window.g_sys_info.code)+"-"+content+"."+this.typeAppend[type]+'">'+this.typeName[type]+'</a>';
				}
			}else{
				type = "text";
			}
			//处理消费者发给消费者的消息的显示
			//判断是商家还是消费者端
				//是商家端this.isClient===false
					//有item.SENDER||item.SENDPID显示在左边
					//显示在右边
				//否则this.isClient===true
					//item.SENDPID===this.pid,消费者发送的消息,显示在右边
					//否则,接受到的消息,显示在左边
			var htmlStr="";
			if(this.isClient)
			{
				if((this.pid&&item.SENDPID===this.pid)||item.SENDER===this.wxId)
				{
					htmlStr=this.jointClientRightHtmlStr(item,content,date);
				}else{
					htmlStr=this.jointClientLeftHtmlStr(item,content,date);
				}
			}else{
				if(item.SENDER||item.SENDPID)
				{
					htmlStr=this.jointBizLeftHtmlStr(item,content,date);
				}else
				{
					htmlStr=this.jointBizRightHtmlStr(item,content,date);
				}
			}
			return htmlStr;
			/*var isRight=true;
			if(this.tpid){
				if(item.SENDPID===this.pid){
					isRight=true;
				}else{
					isRight=false;
				}
			}else{
				isRight=this.isClient;
			}
			if(item.SENDER||item.SENDPID){
				return '<div class="'+(isRight?"right":"left")+'td"><div class="chartTime"><label class="chartTimeLabel">'+date+
					'</label></div><div><div class="user'+(isRight?"Right":"Left")+'Pic"><div class="chartNameLabel">'+
					(isRight?"":(item["SENDPID.PartnerName"]||item["SENDER.NICKNAME"]))+'</div><img src="'+
					(item["SENDER.HEADIMGURL"]||(item["SENDPID.Logo"]&&(this.host+"/w/img/load/"+(this.code||window.g_sys_info.code)+"-"+
					item["SENDPID.Logo"]+".png"))||"http://www.cqthink.com/image/defaultUser.jpg")+'"></div><div class="speech '+
					(isRight?"right":"left")+'">'+content+'</div></div></div>';
			}else if(item.SENDID){
				return '<div class="'+(isRight?"left":"right")+'td"><div class="chartTime"><label class="chartTimeLabel">'+
					date+'</label></div><div><div class="user'+(isRight?"Left":"Right")+'Pic"><div class="chartNameLabel">'+
					(isRight?item["SENDID.T1_EmpName"]:"")+'</div><img src="'+this.host+"/w/img/load/"+(this.code||window.g_sys_info.code)+
					"-"+item["SENDID.T1_Icon"]+'.png"></div><div class="speech '+(isRight?"left":"right")+'">'+content+'</div></div></div>';
			}else{
				return '<div class="'+(isRight?"left":"right")+'td"><div class="chartTime"><label class="chartTimeLabel">'+
					date+'</label></div><div><div class="user'+(isRight?"Left":"Right")+'Pic"><div class="chartNameLabel">'+
					(isRight?this.svcName:"")+'</div><img src="'+this.host+"/w/img/load/"+(this.code||window.g_sys_info.code)+
					"-"+this.svcLogo+'.png"></div><div class="speech '+(isRight?"left":"right")+'">'+content+'</div></div></div>';
			}*/
		},
		//页面显示的函数
		jointBizRightHtmlStr:function(item,content,date){
			var htmlStr="",senderLogoUrl="";
			senderLogoUrl=(item["SENDID.T1_Icon"]||this.svcLogo)?this.host+"/w/img/load/"+(this.code||window.g_sys_info.code)+"-"+(item["SENDID.T1_Icon"]||this.svcLogo)+".png":"http://www.cqthink.com/image/defaultUser.jpg";
			html='<div class="righttd"><div class="chartTime"><label class="chartTimeLabel">'+
					date+'</label></div><div><div class="userRightPic"><div class="chartNameLabel">'+senderName+'</div><img src="'
					senderLogoUrl+'" /></div><div class="speech right">'+content+'</div></div></div>';
			return htmlStr;
		},
		jointBizLeftHtmlStr:function(item,content,date){
			var htmlStr="",senderName="",senderLogoUrl="";
			senderName=(item["SENDPID.PartnerName"]||item["SENDER.NICKNAME"]);
			senderLogoUrl=(item["SENDER.HEADIMGURL"]||(item["SENDPID.Logo"]&&(this.host+"/w/img/load/"+(this.code||window.g_sys_info.code)+"-"+
						item["SENDPID.Logo"]+".png"))||"http://www.cqthink.com/image/defaultUser.jpg");
			htmlStr='<div class="lefttd"><div class="chartTime"><label class="chartTimeLabel">'+date+
				'</label></div><div><div class="userLeftPic"><div class="chartNameLabel">'+
				senderName+'</div><img src="'+senderLogoUrl+'"></div><div class="speech left">'+content+'</div></div></div>';
			return htmlStr;
		},
		jointClientRightHtmlStr:function(item,content,date){
			var htmlStr="",senderLogoUrl="";
			senderLogoUrl=(item["SENDER.HEADIMGURL"]||(item["SENDPID.Logo"]&&(this.host+"/w/img/load/"+(this.code||window.g_sys_info.code)+"-"+
					item["SENDPID.Logo"]+".png"))||"http://www.cqthink.com/image/defaultUser.jpg");
			htmlStr='<div class="righttd"><div class="chartTime"><label class="chartTimeLabel">'+
					date+'</label></div><div><div class="userRightPic"><div class="chartNameLabel">'+
					""+'</div><img src="'+senderLogoUrl+'"></div><div class="speech right">'+content+'</div></div></div>';
			return htmlStr;
		},
		jointClientLeftHtmlStr:function(item,content,date){
			var htmlStr="",senderName="",senderLogoUrl="",senderResumeUrl="javascript:void(0);";
			if(item.SENDER||item.SENDPID)//客户发过来的消息
			{
				senderName=(item["SENDPID.PartnerName"]||item["SENDER.NICKNAME"]);
				senderLogoUrl=(item["SENDER.HEADIMGURL"]||(item["SENDPID.Logo"]&&(this.host+"/w/img/load/"+(this.code||window.g_sys_info.code)+"-"+
				item["SENDPID.Logo"]+".png"))||"http://www.cqthink.com/image/defaultUser.jpg");
				senderResumeUrl=this.resumePage?("#"+this.resumePage+"-"+item.SENDPID):"javascript:void(0);"
			}	
			else if(item.SENDID){//专家发过来的消息
				senderName=item["SENDID.T1_EmpName"];
				senderLogoUrl=item["SENDID.T1_Icon"]?this.host+"/w/img/load/"+(this.code||window.g_sys_info.code)+"-"+item["SENDID.T1_Icon"]+".png":"http://www.cqthink.com/image/defaultUser.jpg";
				senderResumeUrl=this.resumePage?("#"+this.resumePage+"-"+item.SENDID):"javascript:void(0);"
			}else{//商家发过来的消息
				senderName=this.svcName;
				senderLogoUrl=this.host+"/w/img/load/"+(this.code||window.g_sys_info.code)+"-"+this.svcLogo+".png";
			}
			htmlStr='<div class="lefttd"><div class="chartTime"><label class="chartTimeLabel">'+date+
				'</label></div><div><a href="'+senderResumeUrl+'"><div class="userLeftPic"><div class="chartNameLabel">'+senderName+'</div><img src="'+
				senderLogoUrl+'"></div></a><div class="speech left">'+content+'</div></div></div>';
			return htmlStr;
		},
		//数据加载完成之后刷新显示
		_onDataReady:function(data){
			//当前是消费者端还是商家端
			this.isClient = !this.path;
			//处理组装要显示的内容
			if(data&&data.data&&data.data.items){
				array.forEach(data.data.items,function(item){
					item.htmlStr = this._getItemStr(item);
				},this);
			}
			//刷新列表显示 
			this._msgList.onDataReady(data);
			//刷新第一页时滚动到最后
			if(1===this._pageIndex){
				this._scrollPane.scrollTo({
					x:0,
					y:domStyle.get(this._scrollPane.domNode,"height")-domStyle.get(this._msgList.domNode,"height")
				});
				this._scrollPane.resize();
			}
		},
		
		//对外提供的接口
		//创建方可以调用但不能重写的方法
		//刷新消息列表
		refreshMsgList:function(){
			//如果当前为消费者端，标记消费者收到本会话的所有消息已读
			//"../../user/ReadMsg/SVC00000",参数pid/wxid/tuid
			if(!this.path){
				xhr("GET",{
					url:"../../user/ReadMsg/" + (this.code||window.g_sys_info.code),
					handleAs:"json",
					preventCache:true,
					content:{
						pid:this.pid||"",
						wxId:this.wxId||"",
						tuid:this.tuid||"",
						tpid:this.tpid||""
					}
				});
			}
			this._msgList.refreshList(0);
		},
		getImageContent:function(imgId){
			return '{TYPE:"image",MEDIAID:"",IMG:'+imgId+'}';
		},
		
		//创建方必须实现的方法
		//加载指定页消息数据
		loadMsgData:function(index,pageSize){
			var def = null;
			if(!this.path){
				def = new Deferred();
				//判断是否是消费者发送给消费者的消息
				var filter=0,ids="",param;
				if(this.tuid!==""){
					//取专家发给消费者的消息
					filter=20;
					param={WXID:this.wxId,PID:this.pid||"",TUID:this.tuid}
				}else if(this.tpid!==""){
					//取消费者发给消费的消息
					filter=50;
					param={PID:this.pid||"",TPID:this.tpid};
				}else{
					//取商家发给消费者的消息
					filter=40;
					param={WXID:this.wxId,PID:this.pid||""}
				}
				ids = encodeURIComponent(json.toJson(param));
				//console.log("cqthink.mobile.TalkMsgList的方法loadMsgData必须由创建放实现");
				xhr("GET",{
					url: window.g_sys_info.url_usr,
					handleAs: "json",
					load: lang.hitch(this,function(data){
						def.resolve(data);
					}),
					sync: false,
					preventCache:true,
					content: {
						tp: "query3",
						modalName: "XSY_TSSUS_MSG_LIST",
						pageSize: pageSize||20,
						pageIndex: index||1,
						filter: filter,
						orderBy: "[MESSID] DESC",
						groupBy: "",
						egg:"",
						appId: window.g_sys_info.aid,
						hash: ids
					}
				});
			}else{
				var sqlString = "[AID]=@AID AND ([SENDER]='"+this.twxId+"' OR [RECEIVER]='"+this.twxId+"' OR [RCPTPID]='"+this.tpid+"' OR [SENDPID]='"+this.tpid+"') ";
				if(this.uid){
					sqlString += "AND ([RCPTID]='" + this.uid +"' OR [SENDID]='" + this.uid + "') ";
				}
				def = g_d.open(this.path,{
					where:sqlString,
					pageSize:pageSize||20,
					pageIndex:index||1,
					orderBy:"[MESSID] DESC"
				},true,true);
			}
			return def;
		},
		onSendImg:function(url){
			var def = new Deferred(),callback = null,imageAdded = null;
			if(this.path){
				g_u.busy();
				callback = function(url){
					imageCommon.clearAddedImg().then(function(){
						imageCommon.addImgToPath(url).then(imageAdded);
					});
				};
				imageAdded = lang.hitch(this,function(imageItem){
					g_d.update(imageCommon.addPath,"RID","XSY_TCRCS_PARTNER");
					g_d.update(imageCommon.addPath,"RIID",this.tpid);
					this._sendServerTextMsg2(this.getImageContent(imageItem.DID)).then(lang.hitch(this,function(){
						g_d.saveAll([this.path,imageCommon.addPath]).then(function(){
							def.resolve();
						});
					}));
				});
				def.then(function(){
					g_u.free();
				});
			}else{
				window.busy();
				callback = lang.hitch(this,function(url){
					xhr("POST",{
						url:"/w/data/update/"+(this.code||window.g_sys_info.code),
						handleAs: "json",
						load:imageAdded,
						content:{
							data: json.toJson({
								modalName: "APP_TBSSC_IMG_LIB",
								data: [{n:{
									RID:"XSY_TCRCS_PARTNER",
									RIID:this.pid,
									URL:url
								}}]
							})
						}
					});
				});
				imageAdded = lang.hitch(this,function(result){
					if(result&&result.data&&result.data.items&&result.data.items.length){
						this._sendClientTextMsg(this.getImageContent(result.data.items[0].DID)).then(function(){
							def.resolve();
						});
					}else{
						def.resolve();
					}
				});
				def.then(function(){
					window.free();
				});
			}
			if(url){
				callback(url);
			}else{
				def.resolve();
			}
			return def;
		},
		onSendText:function(text){
			//console.log("cqthink.mobile.TalkMsgList的方法onSendText必须由创建放实现");
			if(this.path){
				var def = new Deferred();
				this._sendServerTextMsg(text).then(lang.hitch(this,function(){
					g_d.save(this.path).then(function(){
						def.resolve();
					});
				}));
				return def;
			}else{
				return this._sendClientTextMsg(text);
			}
		},
		_sendServerTextMsg:function(text){
			if(this.isWxServiceMessage&&this.twxId){
				var def = new Deferred();
				g_d.open(this.wxPath,{
					where: "[AID]=@AID AND [OPENID]='" + this.twxId + "' AND [SUBSCRIBED]=1" 
				}).then(lang.hitch(this,function(){
					if(g_d.getCount(this.wxPath)){
						g_d.execute({
							strSql: "EXEC DBO.PWBCM_MSG_SVC_SEND '"+this.twxId+"',"+g_d.websocket.appId+",'text','"+text.replace(/'/g,"")+"',NULL; "  
						}).then(function(){
							def.resolve();
						});
					}else{
						this._sendServerTextMsg2(text).then(function(){
							def.resolve();
						});
					}
				}));
				return def;
			}else{
				return this._sendServerTextMsg2(text);
			}
		},
		_sendServerTextMsg2:function(text){
			var def = new Deferred();
			g_d.open(this.path,null).then(lang.hitch(this,function(){
				g_d.add(this.path).then(lang.hitch(this,function(){
					g_d.update(this.path,"RECEIVER",this.twxId);
					g_d.update(this.path,"RCPTPID",this.tpid);
					g_d.update(this.path,"MESSCONTENT",text);
					g_d.update(this.path,"SENDDATE",g_s.getDateTime());
					g_d.update(this.path,"NATUREID","8");
					// 服务端发送用户ID
					g_d.update(this.path,"SENDID",this.uid);
					def.resolve();
				}));
			}));
			return def;
		},
		_sendClientTextMsg:function(text){
			//赵春辉	改用调用服务端的客户和商家对话中的发送消息接口，处理APP通知商家	2015-12-09
			var def = new Deferred();
			//判断是否是消费者发送给消费者的消息
			var msgData={
				SENDER:this.wxId,
				SENDDATE:g_s.getDateTime(),
				MESSCONTENT:text,
				ISREAD:"0",
				NATUREID:"7",
				AID:window.g_sys_info.aid,
				SENDPID:this.pid
			}
			if(this.tpid){
				msgData.RCPTPID=this.tpid;
			}else{
				msgData.RCPTID=this.tuid;
			}
			
			xhr("POST", {
				url:"/w/user/SendMsg/" + (this.code||window.g_sys_info.code),
				handleAs:"json",
				load:function(data){
					def.resolve(data);
				},
				sync:false,
				preventCache:true,
				content:{
					data:json.toJson(msgData)
				}
			});
			return def;
			
			//var def = new Deferred();
			//xhr("POST",{
			//	url:"/w/data/update/"+(this.code||window.g_sys_info.code),
			//	handleAs: "json",
			//	load: function(data){
			//		def.resolve(data);
			//	},
			//	sync: false,
			//	preventCache:true,
			//	content:{
			//		data: json.toJson({
			//			modalName: "XSY_TSSUS_MSG_LIST",
			//			data: [{
			//				n:{
			//					SENDER:this.wxId,
			//					SENDDATE:g_s.getDateTime(),
			//					MESSCONTENT:text,
			//					ISREAD:"0",
			//					NATUREID:"7",
			//					AID:window.g_sys_info.aid,
			//					SENDPID:this.pid,
								// 服务端接收人ID(专家ID)
			//					RCPTID:this.tuid
			//				}
			//			}]
			//		})
			//	}
			//});
			//return def;
		},
		
		//定时刷新相关
		_timer:null,
		_onDataLoadedHandler:null,
		//标记每次刷新取到的最大MESSID，用来确定每次刷新是否有取到新消息
		maxMessID:"",
		startTimer:function(){
			this.maxMessID = 0;
			this.stopTimer();
			this._timer = setInterval(lang.hitch(this,function(){
				//定时加载数据，判断最大消息ID是否大于当前显示消息最大ID
				this.loadMsgData(1,2).then(lang.hitch(this,function(data){
					if(data&&data.data&&data.data.items&&data.data.items.length&&this.maxMessID<data.data.items[0].MESSID){
						//若有新的消息，执行刷新
						this.refreshMsgList();
					}
				}));
			}),5000);
			this._onDataLoadedHandler = this.connect(this,"_onDataReady",function(data){
				//截取当前显示的消息中最大的消息ID
				if(data&&data.data&&data.data.items&&data.data.items.length){
					if(this.maxMessID<data.data.items[0].MESSID){
						this.maxMessID = Math.max(this.maxMessID||0,data.data.items[0].MESSID-0);
					}
				}
			});
		},
		stopTimer:function(){
			if(this._timer){
				clearInterval(this._timer);
				this._onDataLoadedHandler.remove();
				this._timer = null;
				this._onDataLoadedHandler = null;
			}
		},
		destroyRecursive:function(){
			//销毁时要清空定时检查是否有新消息的定时器
			this.stopTimer();
			this.inherited(arguments);
		}
	});
});
/*
require(["cqthink/mobile/TalkMsgList"],function(msg){window.msg = msg})
widgets.userInfo.hasLogin()
m=new msg({pid:widgets.userInfo.getUserInfo().partnerId,style:"height:100%;"})
document.body.appendChild(m.domNode)
m.startup()
m.resize()
*/