﻿define([
	"dojo/dom",
	"dojo/dom-attr",
	"dojo/dom-construct",
	"dojo/dom-geometry",
	"dojo/dom-style",
	"dojo/_base/event",
	"dojo/has",
	"dojo/on",
	"dojo/query",
	"dojo/touch",
	"dojo/_base/lang",
	"dojo/Deferred",
	"dojox/mobile/Button",
	"dojox/mobile/_css3",
	"dojox/mobile/scrollable"
],function(dom,domAttr,domConstruct,domG,domStyle,event,has,on,query,touch,lang,Deferred,Button,css3,scrollable){//iconUtils
	return lang.mixin(lang.getObject("cqthink.mobile.imgPrc.selector",true),{
		//当前是否处于拖动状态
		draging:false,
		//开始拖动时第一个手指或者鼠标的位置
		startPos:null,
		//开始拖动时第二个手指的坐标
		startPos2:null,
		//截取区域的尺寸
		curSize:null,
		//要选择的区域的高度和宽度
		_selectSize:null,
		//缩放比例：当本对象的高度或宽度小于要截取的区域的高度或宽度时，需要对截取区域做适当的研所才能看到全貌
		screenScale:1,
		//图片的当前状态
		imgProp:null,
		//原始图片尺寸
		imgOrgSize:null,
		//选择区域的左边距
		leftMargin:0,
		//选择区域的上边距
		topMargin:0,
		//调整位置到选择区域内
		correctImgPositon:function(){
			//处理粘连
			if(this.imgProp.l>this.leftMargin&&20>this.imgProp.l-this.leftMargin){
				this.imgProp.l = this.leftMargin;
			}else if(this.imgProp.l+this.imgProp.w<this.curSize.w+this.leftMargin&&20>this.curSize.w+this.leftMargin-this.imgProp.l-this.imgProp.w){
				this.imgProp.l = this.curSize.w+this.leftMargin-this.imgProp.w;
			}
			if(this.imgProp.t>this.topMargin&&20>this.imgProp.t-this.topMargin){
				this.imgProp.t = this.topMargin;
			}else if(this.imgProp.t+this.imgProp.h<this.curSize.h+this.topMargin&&20>this.curSize.h+this.topMargin-this.imgProp.t-this.imgProp.h){
				this.imgProp.t = this.curSize.h+this.topMargin-this.imgProp.h;
			}
			//这里不做配置
			if(this.imgProp.w<this.curSize.w){
				this.imgProp.l = this.leftMargin+(this.curSize.w-this.imgProp.w)/2;
			}
			if(this.imgProp.h<this.curSize.h){
				this.imgProp.t = this.topMargin+(this.curSize.h-this.imgProp.h)/2;
			}
		},
		//将当前的位置信息生成css字符串
		getCss3Str:function(){
			var x = this.imgProp.l+(this.imgProp.w-this.imgOrgSize.w)/2,
				y = this.imgProp.t+(this.imgProp.h-this.imgOrgSize.h)/2,
				str = (has("translate3d")?"translate3d("+x+"px,"+y+"px,0px":"translate("+x+","+y)+") scale("+(this.imgProp.w/this.imgOrgSize.w)+","+(this.imgProp.h/this.imgOrgSize.h)+")";
			this.imgProp.ow = this.imgProp.w;
			this.imgProp.oh = this.imgProp.h;
			this.imgProp.ot = this.imgProp.t;
			this.imgProp.ol = this.imgProp.l;
			return str;
		},
		//调整图片的位置应用到图片的显示上
		coordinateImgPosition:function(){
			this.correctImgPositon();
			var cssStr = this.getCss3Str(),node = this.img;
			if(has("ios") >= 6 || has("android") || has("bb")){
				setTimeout(function(){
					domStyle.set(node,css3.add({},{
						transform:cssStr
					}));
				},0);
			}else{
				domStyle.set(node,css3.add({},{
					transform:cssStr
				}));
			}
		},
		//获取两点之间的距离
		getDistance:function(pos1,pos2){
			//获取两点之间的距离
			return Math.sqrt((pos1.x-pos2.x)*(pos1.x-pos2.x)+(pos1.y-pos2.y)*(pos1.y-pos2.y));
		},
		initDom:function(){
			//初始化界面元素
			if(!this.domNode){
				//本对象需要的一些样式，非选择区域透明度低，选择区域透明度高，便于区分
				document.head.appendChild(domConstruct.toDom('<style type="text/css">.imgSelectorCur{border:0;margin:0;padding:0;background-color:black;opacity:0.01;filter:alpha(opacity=1);-moz-opacity:0.01;-khtml-opacity:0.01;}.imgSelectorBg{border:0;margin:0;padding:0;background-color:black;opacity:0.5;filter:alpha(opacity=50);-moz-opacity:0.5;-khtml-opacity:0.5;}</style>'));
				this.domNode = domConstruct.create("div",{
					style:"width:100%;height:100%;"
				});
				//被截取的图片
				this.img = domConstruct.create("img",{
					style:"position:absolute;top:0;left:0;",onload:lang.hitch(this,this._onImgLoad)
				},this.domNode);
				//用于覆盖图片，标示是否选择区域的标记层
				this.cover = domConstruct.create("div",{
					style:"width:100%;height:100%;left:0;top:0;margin:0;padding:0;border:0;position:absolute;"
				},this.domNode);
				this.coverBorder = domConstruct.create("div",{
					style:"position:absolute;"
				},this.cover);
				this.coverTop = domConstruct.create("div",{
					style:"width:100%;","class":"imgSelectorBg"
				},this.cover);
				this.curBeforeNode = domConstruct.create("div",{
					style:"display:inline-block;vertical-align:top;","class":"imgSelectorBg"
				},this.cover);
				this.curNode = domConstruct.create("div",{
					style:"display:inline-block;vertical-align:top;","class":"imgSelectorCur"
				},this.cover);
				this.curAfterNode = domConstruct.create("div",{
					style:"display:inline-block;vertical-align:top;","class":"imgSelectorBg"
				},this.cover);
				this.coverBottom = domConstruct.create("div",{
					style:"width:100%;","class":"imgSelectorBg"
				},this.cover);
				
				//活动和缩放事件响应
				touch.press(this.domNode,lang.hitch(this,this.onCoverPress));
				touch.move(this.domNode,lang.hitch(this,this.onCoverMove));
				touch.release(this.domNode,lang.hitch(this,this.onCoverRelease));
				
				//工具栏
				var toolbarDiv = domConstruct.create("div",{
					style:"position:absolute;top:0;right:0;display:inline-block;"
				},this.domNode,"last");
				//缩小按钮
				(new Button({
					label:"缩小",
					onClick:lang.hitch(this,function(e){
						this._zoomIn();
						event.stop(e);
					})
				},domConstruct.create("div",{
					style:"display:inline-block;",
					"class":"cqImgSelectBtnCancel"
				},toolbarDiv))).startup();
				//放大按钮
				(new Button({
					label:"放大",
					onClick:lang.hitch(this,function(e){
						this._zoomOut();
						event.stop(e);
					})
				},domConstruct.create("div",{
					style:"display:inline-block;",
					"class":"cqImgSelectBtnCancel"
				},toolbarDiv))).startup();
				//确定按钮
				(new Button({
					label:"确定",
					onClick:lang.hitch(this,function(e){
						this.finish();
						event.stop(e);
					})
				},domConstruct.create("div",{
					style:"display:inline-block;",
					"class":"cqImgSelectBtnOk"
				},toolbarDiv))).startup();
				//取消按钮
				(new Button({
					label:"取消",
					onClick:lang.hitch(this,function(e){
						this.cancel();
						event.stop(e);
					})
				},domConstruct.create("div",{
					style:"display:inline-block;",
					"class":"cqImgSelectBtnCancel"
				},toolbarDiv))).startup();
			}
		},
		_zoomOut:function(){
			//放大，放大为原来的1.1倍，但是最大不能超过图片的原始大小
			this._scaleImg({
				x:this.curSize.x+this.curSize.w/2,y:this.curSize.y+this.curSize.h/2
			},Math.min(1.1,this.imgOrgSize.h/this.imgProp.h,this.imgOrgSize.w/this.imgProp.w));
		},
		_zoomIn:function(){
			//缩小，缩小为原来的0.9，但是最小不能小于要选择的区域
			this._scaleImg({
				x:this.curSize.x+this.curSize.w/2,y:this.curSize.y+this.curSize.h/2
			},Math.max(0.9,Math.min(this.curSize.h/this.imgProp.h,this.curSize.w/this.imgProp.w)));
		},
		_onImgLoad:function(){
			//图片加载完成之后初始化各种参数
			//包小英 小图片放大 2016-2-19
			if(this.img.width < this._selectSize.w || this.img.height < this._selectSize.h){
					if(this._selectSize.w / this._selectSize.h > this.img.width / this.img.height){
						if(this.forceImageSize == "contain"){
							domStyle.set(this.img,"height" ,this._selectSize.h +"px");	
						}else if(this.forceImageSize == "cover"){
							domStyle.set(this.img,"width" ,this._selectSize.w +"px");
						}
					}else{
						if(this.forceImageSize == "contain"){
							domStyle.set(this.img,"width" ,this._selectSize.w +"px");	
						}else if(this.forceImageSize == "cover"){
							domStyle.set(this.img,"height" ,this._selectSize.h +"px");
						}
					}
			}
			//界面整体缩放比例
			var w = domStyle.get(this.cover,"width"),h = domStyle.get(this.cover,"height");
			this.screenScale = Math.min((w-40)/this._selectSize.w,1);
			this.screenScale = Math.min(this.screenScale,(h-40)/this._selectSize.h);
			//赵春辉	调整各个区域的长宽，改为div后需要手工处理	2014-11-13
			var cw = this._selectSize.w*this.screenScale,ch = this._selectSize.h*this.screenScale;
			this.leftMargin = (w-cw)/2;
			this.topMargin = (h-ch)/2;
			domStyle.set(this.coverTop,"height",this.topMargin+"px");
			domStyle.set(this.coverBottom,"height",this.topMargin+"px");
			domStyle.set(this.curBeforeNode,{"width":this.leftMargin+"px","height":ch+"px"});
			domStyle.set(this.curAfterNode,{"width":this.leftMargin+"px","height":ch+"px"});
			domStyle.set(this.curNode,{width:cw+"px",height:ch+"px",border:"2px solid black;"});
			this.curSize = domG.position(this.curNode);
			domStyle.set(this.coverBorder,{
				top:this.curSize.y+"px",
				left:this.curSize.x+"px",
				width:cw-4+"px",
				height:ch-4+"px",
				border:"2px solid #FFFFFF"
			});
			//图片大小
			domStyle.set(this.img,{width:this.img.width*this.screenScale+"px",height:this.img.height*this.screenScale+"px"});
			this.imgOrgSize = {w:this.img.width,h:this.img.height};
			//调整图片位置，保证选择区域被其完全覆盖
			this.imgProp = {t:0,ot:0,l:0,ol:0,w:this.imgOrgSize.w,ow:this.imgOrgSize.w,h:this.imgOrgSize.h,oh:this.imgOrgSize.h};
			var scale = Math.max(1,Math.min(this.imgProp.w/w,this.imgProp.h/h));
			this.imgProp.w = this.imgProp.w/scale;
			this.imgProp.h = this.imgProp.h/scale;
			this.imgProp.t = (h-this.imgProp.h)/2;
			this.imgProp.l = (w-this.imgProp.w)/2;
			
			//赵春辉	备选图片小于要选择的图片	2015-07-15
			//赵春辉	图片缩放之后可能存在小数问题	2015-10-22
			if(this.img.height<Math.floor(this._selectSize.h*this.screenScale)||this.img.width<Math.floor(this._selectSize.w*this.screenScale)){
				//尺寸不满足要求时
				if(this.forceImageSize == true){
					//若强制要求图片尺寸，给出提示并返回
					alert("图片不得小于 "+this._selectSize.w+"×"+this._selectSize.h);
					this.cancel();
				}else if(this.forceImageSize == "contain"){	
					this.finish();
				}else if(confirm("图片小于 "+this._selectSize.w+"×"+this._selectSize.h)){
					//否则直接返回原始图片
					this.finish();
				}else{
					this.cancel();
				}
				return;
			}
			
			this.coordinateImgPosition();
		},
		onCoverPress:function(e){
			//手指或鼠标按下时的响应函数，可能是拖动也可能是缩放
			this.draging = true;
			this.startPos = {x:e.touches?e.touches[0].pageX:e.pageX,y:e.touches?e.touches[0].pageY:e.pageY};
			this.startPos2 = e.touches&&e.touches.length>1?{x:e.touches[1].pageX,y:e.touches[1].pageY}:null;
			this.startPos3 = this.startPos2?{
				x:(this.startPos.x+this.startPos2.x)/2,
				y:(this.startPos.y+this.startPos2.y)/2
			}:this.startPos;
		},
		onCoverMove:function(e){
			//手指或鼠标移动的响应函数，调整图片的位置，或者调整图片的大小与位置
			if(this.draging){
				var curPos = {
					x:e.touches?e.touches[0].pageX:e.pageX,
					y:e.touches?e.touches[0].pageY:e.pageY
				};
				
				if(e.touches&&e.touches.length>1&&this.startPos2){
					try{
						curPos = {
							x:(e.touches[0].pageX+e.touches[1].pageX)/2,
							y:(e.touches[0].pageY+e.touches[1].pageY)/2
						};
						//手势缩放，若是放大，不能大于图片的原始大小，若缩小，不能小于要选择的区域
						var d = this.getDistance({x:e.touches[0].pageX,y:e.touches[0].pageY},{x:e.touches[1].pageX,y:e.touches[1].pageY}),od = this.getDistance(this.startPos,this.startPos2);
						//执行缩放操作
						this._scaleImg({x:(this.startPos.x+this.startPos2.x+e.touches[0].pageX+e.touches[1].pageX)/4,y:(this.startPos.y+this.startPos2.y+e.touches[0].pageY+e.touches[1].pageY)/4},d/od>1?Math.min(1.05,Math.min(d/od,this.imgOrgSize.h/this.imgProp.h,this.imgOrgSize.w/this.imgProp.w)):Math.max(d/od,this.curSize.h/this.imgProp.h,this.curSize.w/this.imgProp.w));
					}catch(ee){
						alert(ee.message);
					}
				}//else{
					var x = curPos.x-this.startPos3.x,y = curPos.y-this.startPos3.y;
					if(x===0&&y===0){
						return;
					}
					//拖动
					this.imgProp.l += x;
					this.imgProp.t += y;
				//}
				this.coordinateImgPosition();
				this.onCoverPress(e);
			}
		},
		onCoverRelease:function(){
			//手指或鼠标松开的响应，结束拖动或缩放
			this.draging = false;
		},
		_scaleImg:function(center,scale){
			if(scale!==1){
				//调整左上角坐标，调整长宽
				this.imgProp.w = this.imgProp.w*scale;
				this.imgProp.h = this.imgProp.h*scale;
				this.imgProp.l = (1-scale)*(center.x-this.curSize.x+this.leftMargin)+scale*this.imgProp.l;
				this.imgProp.t = (1-scale)*(center.y-this.curSize.y+this.topMargin)+scale*this.imgProp.t;
				this.coordinateImgPosition();
			}
		},
		_finishDomNode:function(){
			domStyle.set(this.domNode.parentNode,"overflow",this._parentOverflow);
			domStyle.set(this.domNode,"display","none");
			while(this._penddingNodes.length){
				domConstruct.place(this._penddingNodes.shift(),this.domNode,"before");
			}
			this.domNode.parentNode.removeChild(this.domNode);
		},
		finish:function(){
			//完成图片截取
			//若图片不满足基本的规格要求
			var validSize = true,screenScale = this.screenScale,
				imgProp = this.imgProp,imgOrgSize = this.imgOrgSize,curSize = this.curSize,leftMargin = this.leftMargin,topMargin = this.topMargin;
			//赵春辉	处理图片的裁剪	2015-07-18
			this.imgProp = this.imgOrgSize = this.curSize = null;
			if(imgOrgSize.w<curSize.w||imgOrgSize.h<curSize.h){
				validSize = false;
				if(imgOrgSize.w>curSize.w){
					//若宽度足够，高度不足
					imgProp.l = leftMargin;
					imgProp.h = imgOrgSize.h/imgOrgSize.w*curSize.w;
					imgProp.w = curSize.w;
					imgProp.t = topMargin+(curSize.h-imgProp.h)/2;
				}else if(imgOrgSize.h>curSize.h){
					//若高度足够，宽度不足
					imgProp.t = topMargin;
					imgProp.w = imgOrgSize.w/imgOrgSize.h*curSize.h;
					imgProp.h = curSize.h;
					imgProp.l = leftMargin+(curSize.w-imgProp.w)/2;
				}else if(imgOrgSize.w/imgOrgSize.h>curSize.w/curSize.h){
					//宽度高度都不足，但是更宽
					curSize.h = curSize.h/curSize.w*imgOrgSize.w;
					curSize.w = imgOrgSize.w;
					imgProp.l = leftMargin;
					imgProp.t = topMargin+(curSize.h-imgOrgSize.h)/2;
				}else{
					//宽度高度都不足，但是更高
					curSize.w = curSize.w/curSize.h*imgOrgSize.h;
					curSize.h = imgOrgSize.h;
					imgProp.t = topMargin;
					imgProp.l = leftMargin+(curSize.w-imgOrgSize.w)/2;
					if(imgOrgSize.w/imgOrgSize.h===curSize.w/curSize.h){
						validSize = true;
					}
				}
			}
			
			var c = document.createElement("canvas"),ctx = c.getContext("2d"),w = imgProp.w/screenScale,h = imgProp.h/screenScale;
			c.width = curSize.w/screenScale;
			c.height = curSize.h/screenScale;
			if(false===validSize){
				ctx.fillStyle="#FFFFFF";
				ctx.fillRect(0,0,c.width,c.height); 
			}
			domAttr.set(this.img,"style","display:none;top:0;left:0;border:0;width:"+w+"px;height:"+h+"px;");
			//获取图片的指定区域
			ctx.drawImage(this.img,-(leftMargin-imgProp.l)/screenScale,-(topMargin-imgProp.t)/screenScale,w,h);
			//隐藏图片选取器
			this._finishDomNode();
			//返回对应的图片数据
			validSize = validSize&&(-1<this.img.src.split(".").pop().toLowerCase()==="png"||-1<this.img.src.toLowerCase().indexOf("data:image/png;base64,"));
			//赵春辉	依据传入的图片格式来处理剪切到的图片的格式	2015-07-14
			if(validSize){
				//赵春辉	png文件不存在压缩比的问题	2015-09-09
				this._selectDef.resolve(c.toDataURL());
			}else{
				//赵春辉	处理图片压缩比	2015-09-09
				//赵春辉	支持配置图片压缩比	2015-10-09
				var q = ((window.cqthink&&cqthink.app&&cqthink.app.configer&&cqthink.app.configer.imageQuality)-0)||1;
				this._selectDef.resolve(c.toDataURL("image/jpeg",q));
			}
		},
		cancel:function(){
			this._finishDomNode();
			//取消截取图片
			this._selectDef.resolve();
		},
		//forceImageSize: contain填充满整个选取区域(有留白)；cover 放大到比选取区大; false 不放大直接填充; ture 强制满足尺寸才上传;
		selectImg:function(withNode,size,url,forceImageSize){
			this.forceImageSize = forceImageSize;	
			//发起截图请求
			this._selectDef = new Deferred();
			this.initDom();
			var pos = domG.position(withNode||document.body);
			if(withNode){
				this._penddingNodes = [withNode];
				domConstruct.place(this.domNode,withNode,"before");
				withNode.parentNode.removeChild(withNode);
			}else{
				this._penddingNodes = [];
				while(document.body.childNodes.length){
					this._penddingNodes.push(document.body.childNodes[0]);
					document.body.removeChild(document.body.childNodes[0]);
				}
				document.body.appendChild(this.domNode);
			}
			this._parentOverflow = domStyle.get(this.domNode.parentNode,"overflow");
			domStyle.set(this.domNode.parentNode,"overflow","hidden");
			domStyle.set(this.domNode,{display:"block",width:pos.w+"px",height:pos.h+"px"});
			
			//赵春辉	清除图片的高度和宽度属性	2015-10-22
			domStyle.set(this.img,{
				"width":"",
				"height":""
			});
			//界面初始化时图片要处理
			domAttr.set(this.img,"style","display:block;top:0;left:0;border:0;position:absolute;");
			this._selectSize = {w:size.width,h:size.height};
			//赵春辉	之前的处理错误	2015-10-22
			if(this.img.src===url){
				setTimeout(lang.hitch(this,this._onImgLoad),10);
			}else{
				domAttr.set(this.img,"src",url);
			}
			return this._selectDef;
		}
	});
});