﻿define([
	"dojo/_base/lang",
	"dojo/dom-construct",
	"dojo/dom-style",
	"dojo/_base/connect",
	"dojo/dom-class",
	"dojo/Deferred",
	"dijit/registry",
	"cqthink/util"
], function (lang, domConstruct, domStyle, connect, domClass, Deferred, registry, util) {
    //mobile。util应该是对util的扩展
    lang.setObject("cqthink.mobile.util", util);
    lang.mixin(util, {
        createOpener: function () {
            require(["dojox/mobile/Pane", "dojox/mobile/Opener","dojox/mobile/Overlay"], lang.hitch(this, function (Pane, Opener, Overlay) {
                this.opener = new (util.getDevice()==="Android"?Overlay:Opener)();
                document.body.appendChild(this.opener.domNode);
				this.opener.startup();
                var h = "";
                if (cqthinkinfo.deviceType == "iphone") h = "300px";
                else h = "480px";
                this.contentPane = new Pane({
					style:"min-width:240px;margin:0;padding:0;"
				});
                this.contentPane.startup();
                this.opener.domNode.appendChild(this.contentPane.domNode);
                this.opener.contentNode = this.contentPane.containerNode;
                this.opener.connect(this.opener, "hide", lang.hitch(this, function () {
                    this.opened = false;
                }));
                this.dh = connect.connect(this.opener.domNode, "onclick", this, function (e) {
                    if(e.target===this.contentPane.domNode){
						this.hideOpener();
					}else{
						e.stopPropagation();
					}
                });
                this.ch = connect.connect(this.opener.cover, "onclick", this, function (e) {
					if(this.opened){
						this.hideOpener();
					}
                });
                this._showInOpener();
            }));
        },
        showInOpener: function (contentNode, roundNode, position) {
			//赵春辉	处理菜单点击时需要等待的问题，实际上本操作变成了一个异步操作，执行完成之前，要显示的内容可能不在dom中，从而导致错误	2015-03-03
			var def = new Deferred();
			setTimeout(lang.hitch(this,function(){
				try{
					this._showInOpenerNow(contentNode, roundNode, position);
					def.resolve(true);
				}catch(e){
					console.log(e);
					def.resolve(false);
				}
			}),100);
			return def;
        },
		_showInOpenerNow:function (contentNode, roundNode, position) {
            if (this.opened) {
                return;
            }
            this.opened = true;
            if (this.visiable(roundNode)) {
                this._bakRoundNode = roundNode;
            }
			this._bakContentNode = contentNode;
			this._bakPosition = position;
			if (this.opener) {
				this._showInOpener();
			} else {
				this.createOpener();
			}
		},
        _showInOpener: function () {
            if (this.opener.contentNode.firstElementChild) {
                domConstruct.place(this._bakContentNode, this.opener.contentNode.firstElementChild, "replace");
            } else {
                this.opener.contentNode.appendChild(this._bakContentNode);
            }
			if("Android"===util.getDevice()){
				var h = domStyle.get(this._bakContentNode,"height"),hh = domStyle.get(document.body,"height");
				if(h>hh-20){
					domStyle.set(this._bakContentNode,"height",hh-20+"px");
				}
				this.opener.show();
			}else{
				this.opener.show(this._bakRoundNode, this._bakPosition && this._bakPosition.length ? this._bakPosition : null);
			}
		},
        getIosVersion: function () {
            if (/(iPhone)/i.test(navigator.userAgent) || /(iPad)/i.test(navigator.userAgent)) {
                var os = navigator.userAgent.match(/\b[0-9]+_[0-9]+(?:_[0-9]+)?\b/);
                var osVersion = os && os.length > 0 ? os[0] : "0";
                return osVersion;
            }else{
				return "0";
			}
        },
        hideOpener: function () {
            this.opener&&this.opener.hide();
        },
        //依据一个节点找到其ElementContainer
        getParentElementContainer: function (dom) {
            var p = registry.getEnclosingWidget(dom);
            while (p && (!domClass.contains(p.domNode, "cqMblContainer"))) {
                p = p.getParent();
            }
            p = p || registry.getEnclosingWidget(dom);
            return p;
        }
    });
    //侦听返回事件
    connect.subscribe("cqthink/ehr/canback", function (info) {
        if (info && info.back && false === info.abortFlag && util.opened) {
            util.hideOpener();
            info.abortFlag = true;
        }
    });
    return util;
});