define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/event",
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/query",
    "dijit/registry",
    "dojox/mobile/ContentPane",
    "dojox/mobile/iconUtils",
    "cqthink/mobile/SlideShow",
    "dojo/dom-class",
    "../widgets/config/shelfMatLoader",
    "dojo/touch"
],function(declare,array,connect,event,json,lang,domAttr,domConstruct,domStyle,query,registry,ContentPane,iconUtils,SlideShow,domClass,shelfMatLoader,touch){
    //console.error("shelfmixin begin");
    var BoxClass = declare("",null,{
        constructor:function(data){
            this.data = data;
            if(this.data){
                this.shelf = this.data.shelf;
                this.domNode = data.domNode;
                this.linkNode = query("a",this.domNode)[0];
                this.imgNode = query("img",this.domNode)[0];
                this.titleNode = query("strong",this.domNode)[0];
                this.prcNode = query("span",this.domNode)[0];//۸ڵ
				this._updateTitle(this.data.TITLE);
                domAttr.set(this.imgNode,"src",this.shelf.getImageUrl(this.data.IMG_ID));
                domStyle.set(this.imgNode,"display",this.data.IMG_ID?"":"none");
                this.setUrl(this.data.HREF);
            }
            // console.error("boxclass cons");
        },
        _updateTitle:function(title){
            if(this.titleNode){
                this.titleNode.innerHTML = title;
                this.data.TITLE = title;
                domStyle.set(this.titleNode,"display",0<this.data.ISSHOWTITLE?"":"none");
                domStyle.set(this.titleNode.parentNode,"display",0<this.data.ISSHOWTITLE||0<this.data.ISSHOWPRICE?"":"none");
                domStyle.set(this.prcNode,"display",0<this.data.ISSHOWPRICE?"":"none");
            }
        },
        showTitle:function(title){
            if(this.data){
                this.data.ISSHOWTITLE = 1;
                this._updateTitle(title);
            }
        },
        setUrl:function(url){
            if(this.data&&this.linkNode){
                this.data.href = url;
                var node = domConstruct.create("a",{
                    href:this.data.href||"javascript:void(0)"
                },this.linkNode,"replace");
                while(this.linkNode.children.length){
                    node.appendChild(this.linkNode.children[0]);
                }
                this.linkNode = node;
            }
        }
    });
    var FloorClass = declare("",null,{
        //¥ʽ
        _templateStrings:{
            // һ
            "1":"<div class='shop_module_item shop_module_single_activity cbox min_height_floor backgroundColor' style='position:relative;'>"+
                "<a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con shop_module_single_activity_title biggerSize'>"+
                "<strong class='shop_module_item_title'>"+
                
                "</strong>"+
                "<span class='pic'>"+"</span>"+
                "</div></a></div>",
            // 
            "2":"<div class='shop_module_item shop_module_double_activity min_height_floor'>"+
                "<li class='cbox backgroundColor'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize'>"+"<strong class='shop_module_item_title'>"+
                
                "</strong>"+
                "<span class='pic'>"+"</span>"+"</div></a></li>"+
                "<li class='cbox backgroundColor'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize'>"+"<strong class='shop_module_item_title'>"+
                "</strong>"+
                "<span class='pic'>"+"</span>"+"</div></a></li>"+"</div>",
            "22":"<div class='shop_module_item shop_module_double_activity min_height_floor no_border'>"+
                "<li class='cbox backgroundColor'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize'>"+"<strong class='shop_module_item_title'>"+
                "</strong>"+
                "<span class='pic'>"+"</span>"+"</div></a></li>"+
                "<li class='cbox backgroundColor'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize'>"+"<strong class='shop_module_item_title'>"+
                "</strong>"+
                "<span class='pic'>"+"</span>"+"</div></a></li>"+"</div>",
            // һҶ
            "3":"<div class='shop_module_item shop_module_three_activity'>"+
                "<div class='shop_module_item_left cbox backgroundColor min_height_floor'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "</a>"+"</div>"+
                "<div class='shop_module_item_right'><li class='cbox shop_module_item_right_img_background shop_module_item_right_top backgroundColor'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "</a></li>"+
                "<li class='cbox backgroundColor shop_module_item_right_img_background shop_module_item_right_bottom'><a class='shop_module_item_right_img' href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "</a></li></div>"+"</div>",
            // 
            "4":"<div class='shop_module_item shop_module_h_three_activity'>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li></div>",
            "44":"<div class='shop_module_item shop_module_h_three_activity no_border'>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li></div>",
            // 
            "5":"<div class='shop_module_item shop_module_four_activity '>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize' style=''>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li></div>",
            "55":"<div class='shop_module_item shop_module_four_activity no_border'>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize' style=''>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con biggerSize'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li></div>",
            "6":"<div class='shop_module_item shop_module_single_activity cbox'><ul></ul>"+//{link:''}
                "</div>",//õƬ
            "7":"<div class='shop_module_item shop_module_fourbtn_activity'>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con' style=''>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li></div>",
            "8":"<div class='shop_module_item shop_module_five_activity'>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con' style=''>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li>"+
                "<li class='cbox'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con'>"+
                "<strong class='shop_module_item_title'></strong>"+
                "<span class='pic'></span>"+
                "</div></a></li></div>",
            "12":"<div class='shop_module_item shop_module_twelve_activity min_height_floor'>"+
                "<li class='cbox backgroundColor kuan'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con'>"+"<strong class='shop_module_item_title'>"+"</strong>"+"<span>"+"</span>"+"</div></a></li>"+
                "<li class='cbox backgroundColor zai'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con'>"+"<strong class='shop_module_item_title'>"+"</strong>"+"<span>"+"</span>"+"</div></a></li></div>",//+
            "1212":"<div class='shop_module_item shop_module_twelve_activity min_height_floor no_border'>"+
                "<li class='cbox backgroundColor kuan'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con'>"+"<strong class='shop_module_item_title'>"+"</strong>"+"<span>"+"</span>"+"</div></a></li>"+
                "<li class='cbox backgroundColor zai'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con'>"+"<strong class='shop_module_item_title'>"+"</strong>"+"<span>"+"</span>"+"</div></a></li></div>",//+
            "13":"<div class='shop_module_item shop_module_thirteen_activity min_height_floor'>"+
                "<li class='cbox backgroundColor zai'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con'>"+"<strong class='shop_module_item_title'>"+"</strong>"+"<span>"+"</span>"+"</div></a></li>"+
                "<li class='cbox backgroundColor kuan'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con'>"+"<strong class='shop_module_item_title'>"+"</strong>"+"<span>"+"</span>"+"</div></a></li></div>",//+
            "1313":"<div class='shop_module_item shop_module_thirteen_activity min_height_floor no_border'>"+
                "<li class='cbox backgroundColor zai'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con'>"+"<strong class='shop_module_item_title'>"+"</strong>"+"<span>"+"</span>"+"</div></a></li>"+
                "<li class='cbox backgroundColor kuan'><a href='javascript:void(0)'>"+
                "<div class='imgNode'><img src=''/></div>"+
                "<div class='shop_module_item_con'>"+"<strong class='shop_module_item_title'>"+"</strong>"+"<span>"+"</span>"+"</div></a></li></div>"//+
        },
		//շȡƷϢ
        initGroupMatFloor:function(){
			var info = this._getDataInfo(0),pageSize = parseInt(this.data.MAT_QTY)?parseInt(this.data.MAT_QTY):"4";
            ("9"==this.data.LAYOUT?this.shelf.getMatInfoByHot(pageSize):this.shelf.getMatInfoByGroup(this.data.CATEGORYID1,pageSize)).then(lang.hitch(this,function(datas){
			    var total = datas.length,title = "9"==this.data.LAYOUT?'Ʒ':datas&&datas[0]?datas[0].MGName:"Ʒ",mgid = "9"==this.data.LAYOUT?"":(datas&&datas[0]?(datas[0].MGroupID):"");//"-"+
                this.domNode.innerHTML = this.shelf.getGroupMatHeader(title,mgid)+array.map(datas||[],function(item,index){
					return this.shelf.getMatHtml(item,1,1,index,total);
				},this).join("");
			}));
        },
		//ƼƷȡƷϢ
		initHotMatFloor:function(){
			var info = this._getDataInfo(0);
			this.shelf.getMatInfoByRegion(parseInt(this.data.MAT_QTY)?parseInt(this.data.MAT_QTY):1).then(lang.hitch(this,function(datas){
                var total = datas.length;
				this.domNode.innerHTML = this.shelf.getGroupMatHeader("ƼƷ","")+array.map(datas||[],function(item,index){
					return this.shelf.getMatHtml(item,1,1,index,total);
				},this).join("");
            }));
        },
        // ƴƷѯƷϢ
        initPacMatFloor: function() {
            var info = this._getDataInfo(0);
			this.shelf.getMatInfoByPac(parseInt(this.data.MAT_QTY, 10)?parseInt(this.data.MAT_QTY, 10):2).then(lang.hitch(this,function(datas){
                var total = datas.length;
				this.domNode.innerHTML = this.shelf.getPacMatHeader("ʱ","")+array.map(datas||[],function(item,index){
					return this.shelf.getPacMatHtml(item,1,1,index,total);
				},this).join("");
            }));
        },
		//ȡslideShowĲ
		_getSlideShowParam:function(index,param){
			var url = this.data["HREF"+index];
			if(this.data["IMG_ID"+index]){
				param.push({
					"link":"/w/img/load/"+g_sys_info.code+"-"+this.data["IMG_ID"+index]+".png",
					title:this.data["TITLE"+index],
					onclick:""===window.location.pathname||-1===url.toLowerCase().indexOf(window.location.pathname.toLowerCase())?function(){
						window.location.href=url;
					}:function(){
						window.moveToView(url.split("#").pop());
					}
				});
				param.showTitle = param.showTitle||1==this.data["ISSHOWTITLE"+index];
			}
		},
		_getDataInfo:function(index,domNode){
			var idx = ""+(index+1);
			return {
			    shelf:this.shelf,
				IMG_ID:this.data["IMG_ID"+idx],
				TITLE:this.data["TITLE"+idx],
				HREF:this.data["HREF"+idx],
				ISSHOWTITLE:this.data["ISSHOWTITLE"+idx],
				ISSHOWPRICE:this.data["ISSHOWPRICE"+idx],
				domNode:domNode
			};
		},
		_getMatInfo:function(index){
			var info = this._getDataInfo(index),idx = ""+(index+1),pre = "MATERIALID"+idx+".";
			for(var k in this.data){
				if(-1<k.indexOf(pre)){
					info[k.replace(pre,"")] = this.data[k];
				}
			};
			info.single = "1"==this.data.LAYOUT;
			return info;
		},
        initSlideShowFloor:function(){
            var param = [];
			this._getSlideShowParam(1,param);
			this._getSlideShowParam(2,param);
			this._getSlideShowParam(3,param);
			this._getSlideShowParam(4,param);
            this.boxes.push(new SlideShow({
                panelsHeight:2==this.data.SLD_TP?200:1==this.data.SLD_TP?149:100,
                srcField:'link',
                items:param,
                lazy:false,
                playInterval:5000,
                auto:true,
                titleField:"title",
                showTitle:param.showTitle
            },query(".cbox",this.domNode)[0].firstChild));
            this.boxes[0].startup();
        },
        constructor:function(data,shelf){
            this.data = data;
			this.shelf = shelf;
            this.boxes = [];
            var USE_BORDER = this.data.USE_BORDER,
                LAYOUT = this.data.LAYOUT;
            if(USE_BORDER&&USE_BORDER==0&&this._templateStrings[LAYOUT+LAYOUT]){
				LAYOUT = LAYOUT+""+LAYOUT;
            }
            this.domNode = domConstruct.create("div",{
                class:"clear"
            });
			
            this.domNode.innerHTML = this._templateStrings[LAYOUT];
            if("10"==this.data.LAYOUT||"9"==this.data.LAYOUT){
                this.initGroupMatFloor();
            }else if("11"==this.data.LAYOUT){
                this.initHotMatFloor();
            } else if("14" == this.data.LAYOUT) {
                this.initPacMatFloor();
            }
            else if("6"==this.data.LAYOUT){
                this.initSlideShowFloor();
            }else{
                //ӳλ
                query(".cbox", this.domNode).forEach(function(domNode, index) {
                    var i = index+1,box = null;
					if(4==this.data["IMG_CLASSID"+(index+1)]&&this.data["TPL"+(index+1)+".URL"]){
						//׼λ
                        domStyle.set(domNode,"opacity",0);
                        //׼
                        this.boxes.push(box = new ContentPane({
                            href:this.data["TPL"+i+".URL"],
                            onLoad:lang.hitch(this,function(){
                                domStyle.set(domNode,"opacity",1);
                                this.shelf.onTplLoaded(box);
                            })
                        },domNode));
                        setTimeout(function(){
                            box.startup();
                        },0);
					}else if(this.data["MATERIALID"+(index+1)+".T0_MID"]){
						//Ʒλ
						var box = new BoxClass({
							domNode:domNode,
							shelf:this.shelf
						});
						this.boxes.push(box);
						this.shelf.initMatBox(box,this._getMatInfo(index));
					}else{
						//λ
						this.boxes.push(new BoxClass(this._getDataInfo(index,domNode)));
						if(this.data.LAYOUT=="1" && this.data["HREF"+i] && !this.data["IMG_ID"+i] && this.data["ISSHOWTITLE"+i]=="1"){
							//¥ͨ0λӣͼƬʾ⣬Ҳʾఴť
							//һֺͼͷ
							var div = domConstruct.create("div", {
								style: "position:absolute;bottom:-8px;right:10px;"
							}, this.boxes[this.boxes.length-1].domNode, "last");
							var name = this.boxes[this.boxes.length-1].titleNode.innerHTML;
							//޸ҳģʽ
							if(name==""||name=="Ʒ"||name=="ҵ"){
								this.boxes[this.boxes.length-1].domNode.parentNode.style.margin="18px";
								this.boxes[this.boxes.length-1].domNode.parentNode.style.paddingTop="6px";
								this.boxes[this.boxes.length-1].domNode.parentNode.style.paddingBottom="6px";
								this.boxes[this.boxes.length-1].domNode.parentNode.style.backgroundColor="#f0f0f4";
							}
							//
							div.innerHTML = "<div class='mblDomButtonGrayArrow' style='-webkit-transform:rotate(0deg);transform:rotate(00deg);display:inline-block;margin-bottom:3px;'></div>";
							//һһDOMBUTTON
							iconUtils.createDomButton(div.lastChild);
							// ¼
							connect.connect(div, "onclick", lang.hitch(this, function() {
								window.location=this.data["HREF"+i];
							}));
						}
					}
                }, this);
            }
            // console.error("floor cons");
        }
    });
    return declare("widgets._ShelfMixin",null,{
        //ϽϢʾ
        reserveMsgNode:false,
        reserveMsgDivBtn:null,
        //ͷ¥ǷзذťĬ
        withBack:true,
        withBackBtn:null,
        //ǷϽʾﳵ
        showOrderCarNum:false,
		_orderCarNumNode:null,
		
		// Ƿʾϵͷť Ĭϲʾ
		//showCsBtn:false,
		//_csBtnNode:null,
		//headerĸڵ
        headerNode:null,
		//¥㣬ֻһ
        headerFloor:null,
		//ݸڵ
        bodyNode:null,
		//ܵ¥
        floors:null,
		//ײڵ
        footerNode:null,
		//ײ¥㣬ֻһ
        footerFloor:null,
		
        //canMoveBodyNode:true,
        // ǵǰҳĽ˳
        paneSelected:false,
        currPane:null,
        onAfterTransitionIn:function(){
            this.inherited(arguments);
            this.paneSelected = true;
            this.currPane = this.centerPane;
            this._updateCenterPaneHeight();
        },
        onBeforeTransitionOut:function(){
            this.inherited(arguments);
            this.paneSelected = false;
            this.currPane = null;
        },
		
        updateOrderCarNum:function(){
            var node = this._orderCarNumNode;
            if(node){
                require(["widgets/orderCarRecord"],function(orderCarRecord){
                    var orderCar = orderCarRecord.getOrderCar(),
                        num = 0;
                    for (var mid in orderCar) {
                        if (mid && orderCar[mid]) {
                            num += parseFloat(orderCar[mid]);
                        }
                    }
                    //ʾָλ
                    node.innerHTML = num;
                });
            }
        },
        scrollTo:function(pos){
            if(this.centerPane&&this.centerPane.scrollTo){
                this.centerPane.scrollTo(pos);
            }
        },
        _resizeTimer:null,
        _updateCenterPaneHeight:function(){
            if(this._resizeTimer){
                clearTimeout(this._resizeTimer);
                this._resizeTimer = null;
            }
            setTimeout(lang.hitch(this,this.updateCenterPaneHeight),300);
        },
        updateCenterPaneHeight:function(){
            if(this.headerPane){
                this.headerPane.getParent().resize();
            }else{
                var h = domStyle.get(document.body,"height")-domStyle.get(this.headerNode,"height")-domStyle.get(this.footerNode,"height");
                this.centerPane.set("height",h+"px");
                domStyle.set(this.centerPane.domNode,"height",h+"px");
                this.centerPane.resize();
            }
        },
        destroyLast:function(){
            if(this.headerPane){
                this.headerPane.getChildren().forEach(function(i){
                    i.destroyRecursive();
                });
                this.bodyPane.getChildren().forEach(function(i){
                    i.destroyRecursive();
                });
                this.footerPane.getChildren().forEach(function(i){
                    i.destroyRecursive();
                });
            }else{
                array.forEach(this.getChildren(),function(w){
                    if(w===this.centerPane){
                        w.getChildren().forEach(function(ww){
                            ww.destroyRecursive();
                        });
                    }else{
                        w.destroyRecursive();
                    }
                },this);
            }
            this.headerNode.innerHTML = this.bodyNode.innerHTML = this.footerNode.innerHTML = "";
        },
        indexElement:function(){
        // console.error("indexElement1");
            this.inherited(arguments);
            this.headerNode = query(".shelfHeader",this.domNode)[0];
            this.bodyNode = query(".shelfBody",this.domNode)[0];
            this.footerNode = query(".shelfFooter",this.domNode)[0];
            this.headerPane = registry.byNode(this.headerNode);
            this.bodyPane = registry.byNode(this.bodyNode);
            this.footerPane = registry.byNode(this.footerNode);
            this.centerPane = this.bodyPane||this.getChildren()[0];
            domStyle.set(this.domNode,"height","100%");
            // console.error("indexElement2");
        },
        initEvent:function(){
        // console.error("initEvent");
            if(this.showOrderCarNum){
                this.subscribe("widgets/orderCarRecord/setOrderCar",this.updateOrderCarNum);
            }
            this.inherited(arguments);
            // windowresize¼,¼ʱ޸centerPaneĸ߶
            this.connect(window,"onresize",function(){
                if(this.paneSelected){
                    this._updateCurrPaneHeight();
                }
            });
            // ϵͷڵϵͷ ¼
            //if(this.showCsBtn&&this._csBtnNode){
            //    this.connect(this._csBtnNode,"onclick",this.csBtnNodeClick);
            //}
            // console.error("initEvent2");
        },
        _updateCurrPaneHeight:function(){
            if(this._resizeTimer){
                clearTimeout(this._resizeTimer);
                this._resizeTimer = null;
            }
            setTimeout(lang.hitch(this,this.updateCurrPaneHeight),300);
        },
        updateCurrPaneHeight:function(){
            var h = domStyle.get(document.body,"height")-domStyle.get(this.headerNode,"height")-domStyle.get(this.footerNode,"height");
            this.centerPane.set("height",h+"px");
            domStyle.set(this.centerPane.domNode,"height",h+"px");
            this.centerPane.resize();
        },
        getBaseShelfId:function(){
            return "";
        },
        getShelfId:function(){
            return window.did;
        },
        initData:function(){
        	console.error("initData");
            this.inherited(arguments);
            if(this.shelfId!==this.getShelfId()){
                this.onBeforeInitShelfData();
                this.shelfId = this.getShelfId();
                this.loadShelfDtlById(this.shelfId,true).then(lang.hitch(this,function(datas){
                    //ݿܰҳˢ֮ǰҪ
                    this.destroyLast();
                    this.floors = [];
                    this.headerFloor = this.footerFloor = null;
                    var onTplLoaded = lang.hitch(this,this.onTplLoaded);
                    array.forEach(datas,function(data,i){
                        if(1==data.POS&&(!this.headerFloor)){
                            this.headerFloor = new FloorClass(data,this);
                            this.headerNode.appendChild(this.headerFloor.domNode);
                            query(".shop_module_item_con",this.headerFloor.domNode).forEach(function(n){
                                domClass.remove(n,"biggerSize");
                            });
                        }else if(3==data.POS&&(!this.footerFloor)){
                            this.footerFloor = new FloorClass(data,this);
                            this.footerNode.appendChild(this.footerFloor.domNode);
                            query(".shop_module_item_con",this.footerFloor.domNode).forEach(function(n){
                                domClass.remove(n,"biggerSize");
                            });
                        }else{
                            this.floors.push(new FloorClass(data,this));
                            this.bodyNode.appendChild(this.floors[this.floors.length-1].domNode);
                            if(i>0&&datas[i-1].LAYOUT==data.LAYOUT&&data.LAYOUT==7){
                                domStyle.set(this.floors[this.floors.length-1].domNode,"margin-top","0");
                            }
                            if(i>0&&datas[i-1].LAYOUT==data.LAYOUT&&data.LAYOUT==8){
                                domStyle.set(this.floors[this.floors.length-1].domNode,"margin-top","0");
                            }
                        }
                    },this);
                    if(this.getBaseShelfId()&&this.getBaseShelfId()!=this.getShelfId()&&(!this.footerFloor)){
                        this.loadShelfDtlById(this.getBaseShelfId(),false).then(lang.hitch(this,function(datas){
                            array.forEach(datas,function(data,i){
                                if(3==data.POS&&(!this.footerFloor)){
                                    this.footerFloor = new FloorClass(data,this);
                                    this.footerNode.appendChild(this.footerFloor.domNode);
                                    query(".shop_module_item_con",this.footerFloor.domNode).forEach(function(n){
                                        domClass.remove(n,"biggerSize");
                                    });
                                }
                            },this);
                            this._onShelfLoaded();
                        }));
                    }else{
                        this._onShelfLoaded();
                    }
                }));
            }
            console.error("initData2");
        },
		
		//ȡƷϢĽӿ
		initMatBox:function(matBox,info){
			//ֱͷƷ
			/*var item = {
				IconURLID:info.IMG_ID||info.T0_IconURLID,
				IS_TG:info.IS_TG,
				IS_CX:info.IS_CX,
				HREF:info.HREF,
				GName:info.TITLE||info.T0_GName,
				MeasureName:info.T7_MeasureName||info.T4_MeasureName,
				HighestPrice:info.T8_HighestPrice,
				RetailPrice:info.T7_RetailPrice||info.T8_RetailPrice
			};
			matBox.domNode.innerHTML = this.getMatBoxHtml(item,info.ISSHOWTITLE,info.ISSHOWPRICE,0,info.single?1:0);*/
			return shelfMatLoader.initMatBox(matBox,info);
		},
		
		//ȡƷݣõ׼ƷϢ
		getMatInfoByRegion:function(pageSize){
            return shelfMatLoader.getMatInfoByRegion(pageSize);
		},
		getMatInfoByHot:function(pageSize){
		    return shelfMatLoader.getMatInfoByHot(pageSize);
		},
		getMatInfoByPac: function(pageSize) {
		    return shelfMatLoader.getMatInfoByPac(pageSize);  
		},
		getMatInfoByGroup:function(mgid,pageSize){
			return shelfMatLoader.getMatInfoByGroup(mgid,pageSize);
		},
		//ȡ׼ƷϢʹ
		/*getTargetMatInfo:function(datas){
			return shelfMatLoader.getTargetMatInfo(datas);
		},*/
		//ȡƷصҳʾϢ
		getGroupMatHeader:function(title,mgid){
			return shelfMatLoader.getGroupMatHeader(title,mgid);
		},
		// ȡƴƷصʾϢ
		getPacMatHeader: function(title,pmid) {
            return shelfMatLoader.getPacMatHeader(title,pmid);  
		},
		getMatHtml:function(item,showTitle,showPrice,index,total){
			return shelfMatLoader.getMatHtml(item,showTitle,showPrice,index,total);
		},
		getPacMatHtml: function(item,showTitle,showPrice,index,total) {
            return shelfMatLoader.getPacMatHtml(item,showTitle,showPrice,index,total);
		},
		getMatBoxHtml:function(item,showTitle,showPrice,index,total){
			return shelfMatLoader.getMatBoxHtml(item,showTitle,showPrice,index,total);
		},
        getBackView:function(){
            //ĬΪ-1һͼԷػ˼ͼ-2ҲֱӷתĿͼͲ,matDetail-12333
            return -1;
        },
        _onShelfLoaded:function(){
        // console.error("onshelfloaded");
            //ͼƬµĸ߶Ȳһ
            if(this._headerFloorImgHandlers){
                while(this._headerFloorImgHandlers.length){
                    this._headerFloorImgHandlers.pop().remove();
                }
            }
            this._headerFloorImgHandlers = [];
            query("img",this.domNode).forEach(function(node){
                var loadHandler = this.connect(node,"onload",function(){
                    loadHandler.remove();
                    this._updateCenterPaneHeight();
                });
            },this);
            
            var div1 = null,div = null;
            if(this.headerFloor&&this.withBack){
                div1 = domConstruct.create("div",{
                    style:"width:64px;height:100%;"
                },this.headerFloor.boxes[0].domNode,"first");
                div = domConstruct.create("div",{
                    "class":"mblDomButtonGrayArrow mblDomButtonPosition"
                },div1);
                iconUtils.createDomButton(div);
                domStyle.set(div,{
                    "-webkit-transform":"rotate(180deg)",
                    "transform":"rotate(180deg)",
                    "position":"absolute",
                    "z-index":9999,
                    "bottom":"0",
                    "margin":"8px 10px"
                });
                this.withBackBtn = div1;
                if(this._backClickHandler){
                    this._backClickHandler.remove();
                }
                // ޸ĵ¼ ֻϵ㲻ذť
                this._backClickHandler = this.own(touch.release(div1,lang.hitch(this,function(){
                    //ṩذťĽӿڣغ˼ͼתĸͼ
                    var backParam = this.getBackView();
                    if(backParam-0===backParam){
                        if(backParam+history.length>0){
                            history.go(backParam);
                        }else{
                            window.moveToView("main");
                        }
                    }else{
                        window.moveToView(backParam);
                    }
                })));
            }
            if(this.showOrderCarNum){//this.headerFloor&&
                this._orderCarNumNode = this.initOrderCarNumberNode();
                this.updateOrderCarNum();
            }
            // ϵͷڵ  ڻд
            // tel:18688888888
            /*if(this.showCsBtn&&!this._csBtnNode){
                // ѯ̼Ƿ ͷ绰
                // ڵ
                this._csBtnNode = domConstruct.create("div",{
                    class:"csBtn"
                },this.domNode);
                
            }*/
            if(this.footerFloor){
                domStyle.set(this.footerNode,"height","46px");
            }
            this.onShelfLoaded();
            this.updateCenterPaneHeight();
            // console.error("onshelfLoaded2");
        },
        initOrderCarNumberNode:function(){
            if(!this._orderCarNumNode && this.headerFloor){
                var div = domConstruct.create("div",{
                    style:"position:absolute;bottom:0;right:0;"
                },this.headerFloor.boxes[0].domNode);
                domConstruct.create("a",{
                    "class":"cart",href:"javascript:void(0)"
                },div);
                this.connect(div,"onclick",function(e){
                    event.stop(e);
                    window.moveToView("orderCar");
                });
                this._orderCarNumNode = domConstruct.create("i",{
                    "class":"cart_com"
                },div);
            }
            return this._orderCarNumNode;
        },
        onShelfLoaded:function(){
            var reserveMsgDiv = null,reserveMsgImgDiv = null;
            if(this.headerFloor&&this.reserveMsgNode){
                reserveMsgDiv = domConstruct.create("div",{
                    "style":"width: 39px;height: 0;float: right;line-height:39px;"
                },this.headerFloor.boxes[0].domNode,"first");
                reserveMsgImgDiv = domConstruct.create("img",{"class":"msgImage","src":"../../Content/htapp/images/msg.png","style":"width:29px;height:29px;"},reserveMsgDiv);
                this.reserveMsgDivBtn = reserveMsgDiv;
                this.connect(reserveMsgDiv,"onclick",function(e){
                    window.moveToView("conversList");
                });
            }
        },
        onTplLoaded:function(pane){
        },
        //ͼƬIDתΪͼƬַķأṩλõĽӿ
        getImageUrl:function(imageId){
            return "/w/img/load/"+g_sys_info.code+"-"+imageId+".png";
        },
        onBeforeInitShelfData:function(){},
        loadShelfDtlById:function(shelfId,isShelfBody){
            return window.loadData({
                modalName:"XSY_TWBCM_SHELFDTS",
                filter:"10",
                pageSize:1,
                pageIndex:1,
                orderBy:"[DID]",
                param:{"DID":shelfId}
            });
        }
    });
})