define([
    "dojo/_base/declare",
    "dojo/_base/connect",
    "dojo/_base/lang"
],function(declare,connect,lang){
    return declare("widgets.common.Timer",null,{
        //截至时间
        deadline: "",
        //定时器
        timer: "",
        //侦听事件handler缓存
        eventCache: null,
        constructor:function(){
            this.eventCache = [];
        },
        
        //秒转为天时分秒
        secondToTime:function(second){
            var s = +second;// 秒
            var m = 0;// 分
            var h = 0;// 小时
            var d = 0;// 天
            if(s > 60) {
                m = parseInt(s/60, 10);
                s = parseInt(s%60, 10);
                if(m > 60) {
                    h = parseInt(m/60, 10);
                    m = parseInt(m%60, 10);
                    if (h >= 24){
                        d = parseInt(h/24, 10);
                        h = parseInt(h%24, 10);
                    }
                }
            }
            // 补零
            var zero = function(v) {
                return (v >> 0) < 10 ? "0" + v : v;
            };
            // 返回 当前秒数表示的天数和时间
            return zero(d) + "天" + [zero(h),zero(m),zero(s)].join(":");
        },
        //距离指定事件倒计时
        initTimer:function(endTime){
            clearInterval(this.timer);
            // 获取当前时间与结束时间的时间秒数差
            this.deadline = endTime;
            if(g_s.dateDiff("s",g_s.getDateTime(),endTime)>0){
                this.timer = setInterval(lang.hitch(this,function(){
                    var seconds = g_s.dateDiff("s",g_s.getDateTime(),this.deadline);
                    if(0<seconds){
                        this.onTickTock(seconds);
                    }else{
                        clearInterval(this.timer);
                        this.onTimeEnd();
                    }
                }),1000);
                this.onTickTock(g_s.dateDiff("s",g_s.getDateTime(),this.deadline));
            }else{
                return false;
            }
        },
        //TODO  n秒倒计时
        initSecondsTimer:function(){
            
        },
        //每隔一秒发生一次
        onTickTock:function(secondsRemaining){},
        //倒计时结束
        onTimeEnd:function(){},
        //提供侦听事件的方法，确保定时器销毁时能够清理干净
        connect:function(event,callback){
            this.eventCache.push(connect.connect(this,event,callback));
        },
        //销毁定时器的方法
        destroy:function(){
            clearInterval(this.timer);
            while(this.eventCache.length){
                this.eventCache.pop().remove();
            }
        }
    });
});