define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dijit/registry",
    "dojo/query",
    "widgets/userInfo",
    "dojo/topic",
    "dojo/dom-attr",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "cqthink/mobile/geoUtil",
    "cqthink/app/plugins/geolocation"
],function(declare, lang, domConstruct, registry, query, userInfo,topic,domAttr,json,xhr,geoUtil,geolocation){
    return declare("widgets.achapp.AddRouate",null,{
        isCheckCity:false,
        isAddRouteLoaded:function(){
            return !!this.startCity;
        },
        indexAddRouteElement:function(){
            this.inherited(arguments);
            //this.newRouteStart = registry.byId("newRoute-start");
            //this.newRouteEnd = registry.byId("newRoute-end");
            this.start  = query(".startCity",this.domNode)[0];//起点城市
            this.end = query(".endCity",this.domNode)[0];//终点城市
            this.startNode = query(".start",this.domNode)[0];
            this.endNode = query(".end",this.domNode)[0];
            this.startCity = query("#startPoint",this.domNode)[0];//起点街道
            this.endCity = query("#endPoint",this.domNode)[0];//终点街道
            this.routeTime = query("#routeTime",this.domNode)[0];
            this.routeTimePicker = registry.byId("routeTimePicker");
            this.onCancel = query(".cancel",this.routeTimePicker.domNode)[0];
            this.onOk = query(".ok",this.routeTimePicker.domNode)[0];
            this.routeTimeValue = query(".routeTimeValue",this.domNode)[0];
            this.routeCycle = query("#routeCycle",this.domNode)[0];
            this.postRouteButton = query(".postRouteButton",this.domNode)[0];
        },
        getCurrentCity:function(){
            //获取当前城市
            geolocation.getCurrentPosition("需要获取您当前位置信息。").then(lang.hitch(this, function(data) {
                var lon = "",lat = "";
                if (data) {
                    lat = data.coords.latitude;
                    lon = data.coords.longitude;
                }
                geoUtil.geoToAddr(lon,lat).then(lang.hitch(this,function(data1){
                    if(data1){
                        this.start.innerHTML = data1.city?data1.city:data1.province;
                        this.end.innerHTML = data1.city?data1.city:data1.province;
                    }
                }));
            }));
            
        },
        refreshAllList:function(){
            this.inherited(arguments);
            if (window.titleNode) {
                window.titleNode.innerHTML = "新增路线";
            }
            if(!this.isCheckCity){
                this.getCurrentCity();
            }
            this.isCheckCity = false;
        },
        initAddRouteEvent:function(){
            this.inherited(arguments);
            this.connect(this.startCity,"onclick",this.chooseStartArea);
            this.connect(this.endCity,"onclick",this.chooseEndArea);
            this.connect(this.routeTime,"onclick",this.chooseRouteTime);
            this.connect(this.onCancel,"onclick",this.onCancelFuc);
            this.connect(this.onOk,"onclick",this.onOkFuc);
            this.connect(this.postRouteButton,"onclick",this.postRoute);
            this.connect(this.routeCycle,"onclick",this.changeCycle);
            this.connect(this.start,"onclick",this.chooseStartCity);
            this.connect(this.end,"onclick",this.chooseEndCity);
            //获取当前城市或者侦听选择城市的广播
            this.subscribe("cqthink/wx/chooseCity/startCity/addRoute",function(cityName){
                this.isCheckCity = true;
                this.start.innerHTML = cityName;
            });
            this.subscribe("cqthink/wx/chooseCity/endCity/addRoute",function(cityName){
                this.isCheckCity = true;
                this.end.innerHTML = cityName;
            });
            //侦听广播
            this.subscribe("cqthink/wx/choosePlace/startPlace",function(addrDtl){
                this.isCheckCity = true;
                //修改起点街道
                query("span",this.startCity)[0].innerHTML = addrDtl.name;
                //设置起点的经纬度
                domAttr.set(this.startCity,"lon",addrDtl.location.lng);
                domAttr.set(this.startCity,"lat",addrDtl.location.lat);
                geoUtil.geoToAddr(addrDtl.location.lng,addrDtl.location.lat).then(lang.hitch(this,function(data){
                    if(data){
                        this.start.innerHTML = data.city?data.city:data.province;
                    }
                }));
            });
            this.subscribe("cqthink/wx/choosePlace/endPlace",function(addrDtl){
                this.isCheckCity = true;
                //修改起点街道
                query("span",this.endCity)[0].innerHTML = addrDtl.name;
                //设置起点的经纬度
                domAttr.set(this.endCity,"lon",addrDtl.location.lng);
                domAttr.set(this.endCity,"lat",addrDtl.location.lat);
                geoUtil.geoToAddr(addrDtl.location.lng,addrDtl.location.lat).then(lang.hitch(this,function(data){
                    if(data){
                        this.end.innerHTML = data.city?data.city:data.province;
                    }
                }));
            });
        },
        chooseStartCity:function(){
            window.moveToView("chooseCity","addRouteStart");
        },
        chooseEndCity:function(){
            window.moveToView("chooseCity","addRouteEnd");
        },
        chooseStartArea:function(e){
            var dom = e.target;
            while(dom&&dom.tagName!="DIV"){
                dom = dom.parentNode;
            }
            var s = this.start.innerHTML;
            //var s = query(".startCity",this.newRouteStart.domNode)[0].value;
            //if(s==0){
                //alert("请先选择起点城市。");
            //}else{
                
            //}
            window.moveToView("choosePlace",s+"_s");
        },
        chooseEndArea:function(e){
            var dom = e.target;
            while(dom&&dom.tagName!="DIV"){
                dom = dom.parentNode;
            }
            var s = this.end.innerHTML;
            //var s = query(".endCity",this.newRouteEnd.domNode)[0].value;
            //if(s==0){
                //alert("请先选择终点城市。");
            //}else{
                
            //}
            window.moveToView("choosePlace",s+"_e");
        },
        chooseRouteTime:function(e){
            var dom = e.target;
            while(dom&&dom.tagName!="DIV"){
                dom = dom.parentNode;
            }
            this.routeTimePicker.show();
        },
        onCancelFuc:function(){
            //隐藏时间选择器
            this.routeTimePicker.hide();
        },
        onOkFuc:function(){
            //隐藏时间选择器
            this.routeTimePicker.hide();
            var time = registry.byId("timePicker").get("values").join(":");
            //更新所选时间
            this.routeTimeValue.innerHTML = time;
            domAttr.set(this.routeTimeValue,"time",time);
        },
        postRoute:function(){
            //检查起始点是否选择
            if(!domAttr.get(this.startCity,"LAT")){
                alert("请选择起点。");
                return;
            }
            if(!domAttr.get(this.endCity,"LAT")){
                alert("请选择终点。");
                return;
            }
            if(!domAttr.get(this.routeTimeValue,"time")){
                alert("请选择时间。");
                return;
            }
            query("input",this.routeCycle).forEach(function(node){
                if(domAttr.get(node,"checked")){
                    CYCID = domAttr.get(node,"value");
                }
            });
            var d = new Date(),dtime,day;
                day= d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate();
                dtime = day+" "+d.getHours()+":"+d.getMinutes()+":"+d.getSeconds();
            var data = {
                n:{
                    "S_ADDR":query("span",this.startCity)[0].innerHTML,
                    "E_ADDR":query("span",this.endCity)[0].innerHTML,
                    "S_LAT":domAttr.get(this.startCity,"LAT"),
                    "S_LON":domAttr.get(this.startCity,"LON"),
                    "E_LAT":domAttr.get(this.endCity,"LAT"),
                    "E_LON":domAttr.get(this.endCity,"LON"),
                    "S_PID":userInfo.getUserInfo().partnerId,
                    "R_TIME":(CYCID==2?day:"1900-01-01")+" "+this.routeTimeValue.innerHTML+":00",
                    "TYPEID":0,
                    "CYCID":CYCID,//
                    "IDENT":1,
                    "S_CITY":this.start.innerHTML,
                    "E_CITY":this.end.innerHTML,
                    "D_DATE":dtime
                }
            };
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    data["n"].PID = userInfo.getUserInfo().partnerId;
                    xhr("POST", {
                        url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                        handleAs: "json",
                        content: {
                            data: json.toJson({
                                modalName: "XST_TCRMK_SUPPLYORNEED",
                                data: [data]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                alert("发布路线成功。");
                                window.free();
                                window.moveToView("myWay");
                            } else {
                                alert(result.message || "数据错误!");
                                window.free();
                            }
                        })
                    });
                }else{
                    alert("未登录");
                }
            }));
            
        },
        changeCycle:function(e){
            var dom = e.target;
            if(dom.tagName=="INPUT"){
                domAttr.set(dom,"checked",true);
            }
            query("input",this.routeCycle).forEach(function(node){
                if(node!=dom&&dom.tagName=="INPUT"){
                    domAttr.set(node,"checked",false);
                }
            });
        }
    });
});