define([
    "dojo/_base/declare", 
    "dojo/dom-attr",
    "dijit/registry",
    "dojo/_base/array"
], function(declare,domAttr,registry,array) {
    return declare("widgets.common._AllSectionMixin",null,{
        indexSectionElement:function(){
            this.slideShow = registry.byId("wrapper");
            this.sectionList = registry.byId("sectionList");
        },
        initSectionListEvent:function(){
            this.connect(this.slideShow, "onBeforeRender", function() {
                if (this.slideShow.items.length > 0) {
                    array.forEach(this.slideShow.items, function(item, i) {
                        item.src = "/w/img/load/" + g_sys_info.code + "-" + item.SLIDE_IMG + ".png";
                        item.title = item.TITLE;
                        item.onclick = this.slideCilck;
                    },this);
                }
            });
            this.connect(this.sectionList, "onDefRendered", function(data) {
                if (data.data.items.length > 0) {
                    var hash = this.sectionHash = {};
                    array.forEach(data.data.items, function(item) {
                        hash[item.SECTION_ID] = item;
                        if(item.PARENT_ID==""||item.WX_TP==1){
                            item.TYPE = 1;
                        }else{
                            item.TYPE = 2;
                        }
                    });
                    data.data.items.sort(function(a,b){
                        var a1 = a,b1 = b;
                        if(a.PARENT_ID.SECTION_ID===b.PARENT_ID.SECTION_ID){
                            return a.S_CODE>b.S_CODE?1:-1;
                        }
                        if(a.PARENT_ID&&a.PARENT_ID.SECTION_ID){
                            a1 = hash[a.PARENT_ID.SECTION_ID]||a;
                        }
                        if(b.PARENT_ID&&b.PARENT_ID.SECTION_ID){
                            b1 = hash[b.PARENT_ID.SECTION_ID]||b;
                        }
                        if(a.PARENT_ID.SECTION_ID===b1.SECTION_ID){
                            return 1;
                        }else if(a1.SECTION_ID===b1.PARENT_ID.SECTION_ID){
                            return -1;
                        }else{
                            return a1.S_CODE>b1.S_CODE?1:-1;
                        }
                    });
                }
            });
            this.connect(this.sectionList.domNode,"onclick",function(e){
                var dom = e.target;
                while(dom&&"a"!==dom.tagName.toLowerCase()&&dom!=this.domNode){
                    dom = dom.parentNode;
                }
                dom = dom&&this.sectionHash[domAttr.get(dom,"class")];
                if(dom){
                    this.slideCilck(dom);
                }
            });
        },
        slideCilck:function(item){
            //判断是什么类型的栏目
            //资讯栏目，不做处理
            if(item.WX_TP==1){
                
            }else if(item.WX_TP==2){
                window.moveToView("newsList",item.SECTION_ID);
            }else if(item.WX_TP==3){
                window.moveToView("matList",item.MGID);
            }else if(item.WX_TP==4){
                if(""===window.location.pathname||-1===item.PATH.toLowerCase().indexOf(window.location.pathname.toLowerCase())){
                    window.location.href=item.PATH;
                }else{
                    //只有页面内跳转才采用加井号的方式跳转
                    window.moveToView(item.PATH.split("#").pop());
                }
            }else if(item.WX_TP==5){// 自动回复
                window.moveToView("autoReply",item.TITLE); // 跳转到自动回复
            }else if(item.WX_TP==6){
                if(item.M_SER==9022){ // 找回密码,未登陆就可以找回密码
                    window.moveToView("getPwd");
                }else{
                    require(["widgets/userInfo"],function(userInfo){
                        userInfo.hasLogin().then(function(success){
                            if(success){
                                if(item.M_SER==9021){// 消费明细
                                    window.moveToView("orderList",userInfo.getUserInfo().partnerId);
                                }else if(item.M_SER==9020){//我的余额
                                    window.moveToView("user");
                                }
                            }else{
                                userInfo.showLogin().then(function(success){
                                    if(success){
                                        if(item.M_SER==9021){// 消费明细
                                            window.moveToView("orderList",userInfo.getUserInfo().partnerId);
                                        }else if(item.M_SER==9020){//我的余额
                                            window.moveToView("user");
                                        }
                                    }
                                });
                            }
                        });
                    })
                }
            }
        },
        refreshAllList:function(){
            if(this.slideShow){
                this.slideShow.refresh();
                this.sectionList.refreshList();
            }
        }
    });
});