define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "dojo/query",
    "../userInfo",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "dojo/_base/lang"
],function(declare,base,query,userInfo,array,json,xhr,lang){
    return declare("widgets.common._AppRegisterMixin",[base],{
        indexAppRegisterElement:function(){
            array.forEach([
                "appRegistSubmitBtn",
                "registBusinessName",
                "registFullName",
                "registPhone",
                "registSalesTerritory" ,
                "registAddress", 
                "registVCode",
                "getRegistVCodeBtn",
                "registRemark"
            ], function(cls) {
                this[cls] = query("." + cls, this.domNode)[0];
            }, this);
        },
        getRegistVCode:function(){
            // 检查手机号是否输入
            if(!this.registPhone.value)
            {
                alert("请输入手机号");
                return;
            }
            if(!userInfo.validPhoneNumber(this.registPhone.value)){
                alert("格式错误，请核对您输入的手机号码，它一般是以1开头的11位数字!");
                return false;
            }
            window.sendMsg(this.registPhone.value);
        },
        getAppInfo:function(){
            var info = {
                APP_TITLE:this.registBusinessName.value,// 企业名称
                CONTACT:this.registFullName.value,// 联系人
                PHONE:this.registPhone.value, // 电话
                ADDR:this.registAddress.value,
                M_BUSS:this.registRemark.value
            };
            return info;
        },
        validAppInfo:function(){
            var info = this.getAppInfo();
            if(!info.APP_TITLE||!info.CONTACT||!info.PHONE||!info.M_BUSS||!info.ADDR)
            {
                return false;
            }else{
                return true;
            }
        },
        appRegistSubmit:function(){
            userInfo.hasLogin().then(lang.hitch(this,function(success){
                if(success){
                    // 发送请求 去处理 注册信息
                // 检查必填项
                if(!this.validAppInfo()){
                    alert("请先完善建村信息");
                    return;
                }
                var info = this.getAppInfo();
                // 验证验证码
                window.postVerCode(info.PHONE,this.registVCode.value).then(lang.hitch(this,function(s){
                    if(s){
                        // 验证通过
                        xhr("POST", {
                        url: "/w/user/SvcAdminRegist/" + window.code,
                        handleAs: "json",
                        content: {
                            product:"农企宝",
                            phone:info.PHONE,
                            contact:info.CONTACT,
                            title:info.APP_TITLE,
                            addr:info.ADDR,
                            region:"",
                            info:json.toJson(info),
                            repTips:"不能重复建村。",
                            isSendMsg:0,
                            wxMsgSevice:1
                        },
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                confirm("你的建村申请已提交，请等待审核，审核成功后在村头工作人员会在24小时内联系你，请保持电话畅通，谢谢！");
                                window.moveToView("srcAppList");
                            } else {
                                alert(result.message || "数据错误!");
                                window.free();
                            }
                        })
                        });
                    }
                    else
                    {
                        alert("验证失败.");
                    }
                }));
                }else{
                    alert("请先登录。");
                    window.moveToView(window.nextPageOnLogin||"user");
                    userInfo.showLogin();
                }
            }));
        },
        initAppRegisterEvent:function(){
            this.connect(this.getRegistVCodeBtn,"onclick",this.getRegistVCode);
            this.connect(this.appRegistSubmitBtn,"onclick",this.appRegistSubmit);
        }
    });
});