define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dijit/registry",
    "widgets/userInfo",
    "dojo/query",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/_base/json",
    "dojo/_base/xhr"
],function(declare,lang,domConstruct,registry,userInfo,query,domAttr,domStyle,json,xhr){
    return declare("widgets.common._CarpoolMixin",null,{
        isCarpoolLoaded:function(){
            return !!this.carpoolHeader;
        },
        indexCarpoolElement:function(){
            this.carpoolHeader = query("#carpoolHeader",this.domNode)[0];
            this.myInfo = registry.byId("myInfo");
            this.inherited(arguments);
        },
        refreshAllList:function(){
            this.inherited(arguments);
            if (window.titleNode) {
                window.titleNode.innerHTML = "顺风车";
            }
            //取客户的拼车信息
            //window.loadData({
            //    modalName:""
            //});
            xhr("POST",{
                url:"/w/exec/executeSelect/"+window.code+"-"+window.openId,
                handleAs: "json",
                content:{
                    tp:"supply_or_need_num",
                    paramStr:"[TYPEID]=0"
                },
                load:lang.hitch(this,function(r){
                    if(1===r.rtnType){
                        var item = r.data.items[0];
                        query("#findingCarNum",this.domNode)[0].innerHTML = item.FINDINGCAR_NUM;
                        query("#onCarNum",this.domNode)[0].innerHTML = item.ONCAR_NUM;
                        query("#comNum",this.domNode)[0].innerHTML = item.COM_NUM;
                        this.myInfo.refreshList();
                    }
                })
            });
            
        },
        initCarpoolEvent:function(){
            this.inherited(arguments);
            //验证用户是否登录，若未登录，则应先登录，登录后才能注册为商家
            userInfo.hasLogin().then(lang.hitch(this, function(s) {
                if(!s){
                    window.nextPageOnLogin = "carpool";
                    userInfo.showLogin();
                }
            }));
            this.connect(this.carpoolHeader,"onclick",function(e){
                var dom = e.target;
                while(dom&&dom.tagName!="LI"&&dom!=this.carpoolHeader){
                    dom = dom.parentNode;
                }
                if(dom&&dom.tagName=="LI"){
                    domAttr.set(dom,"class","tableLiChecked");
                    domStyle.set(query("."+domAttr.get(dom,"name"))[0],"display","");
                    query("li",this.carpoolHeader).forEach(function(node){
                       if(dom!=node){
                           domAttr.set(node,"class","tableLi");
                           domStyle.set(query("."+domAttr.get(node,"name"))[0],"display","none");
                       } 
                    });
                }
            });
        }
    });
});