define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/topic",
    "dojo/dom-attr",
    "dojo/query",
    "dojo/_base/lang"
],function(declare,registry,topic,domAttr,query,lang){
    return declare("widgets.common._ChooseCityMixin",null,{
        routeId:"",
        isChooseCityLoaded:function(){
            return !!this.distList;
        },
        indexChooseCityElement:function(){
            this.distList = registry.byId("distList");
            this.chooseCityInput = query(".chooseCityInput",this.domNode)[0];
            this.chooseCityButton = query(".chooseCityButton",this.domNode)[0];
        },
        initChooseCityEvent:function(){
            this.connect(this.distList.domNode,"onclick",this.cityOnclick);
            this.connect(this.chooseCityButton,"onkeydown",function(e){
                if(e.keyCode==13){
                    this.searchCity();
                }
            });
            this.connect(this.chooseCityButton,"onclick",function(){
                this.searchCity();
            });
            var timer = null;
            this.connect(this.chooseCityInput,"oninput",function(){
                clearTimeout(timer);
                if(this.chooseCityInput.value){
                    timer = setTimeout(lang.hitch(this,this.searchCity),200);
                }
            });
        },
        refreshAllList:function(){
            this.distList.refreshList();
        },
        cityOnclick:function(e){
            var dom = e.target;
            if(dom&&dom.tagName=="LI"&&dom!=this.distList.domNode){
                var name = domAttr.get(dom,"name");
                if(window.did=="addRouteStart"){
                    topic.publish("cqthink/wx/chooseCity/startCity/addRoute",name);
                    window.moveToView("addRoute");
                }else if(window.did=="addRouteEnd"){
                    topic.publish("cqthink/wx/chooseCity/endCity/addRoute",name);
                    window.moveToView("addRoute");
                }else if(window.did=="publishCarpoolStart"){
                    topic.publish("cqthink/wx/chooseCity/startCity/publishCarpool",name);
                    window.moveToView("publishCarpool");
                }else if(window.did=="publishCarpoolEnd"){
                    topic.publish("cqthink/wx/chooseCity/endCity/publishCarpool",name);
                    window.moveToView("publishCarpool");
                }else if(window.did=="mdfRouteStart"){
                    topic.publish("cqthink/wx/chooseCity/startCity/mdfRoute",name);
                    window.moveToView("mdfRoute",window.did);//需要带参数
                }else if(window.did=="mdfRouteEnd"){
                    topic.publish("cqthink/wx/chooseCity/endCity/mdfRoute",name);
                    window.moveToView("mdfRoute",window.did);
                }
            }
        },
        searchCity:function(){
            if(this.chooseCityInput.value){
                this.distList.rs_wb_param = "({INPUT:'"+this.chooseCityInput.value+"'})";
                this.distList.refreshList();
            }
        }
    });
});