define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dijit/registry",
    "dojo/query",
    "dojo/_base/connect",
    "widgets/userInfo",
    "dojo/dom-style",
    "dojo/dom-attr",
	"cqthink/mobile/MapPane",
	"dojo/topic"
],function(declare, lang, domConstruct, registry, query, connect, userInfo, domStyle, domAtrr, MapPane,topic){
    return declare("widgets.common._ChoosePlaceMixin",null,{
        results:{},
        isChoosePlaceLoaded:function(){
            return !!this.mapContainer;
        },
        indexChoosePlaceElement:function(){
            this.inherited(arguments);
            this.mapContainer = query("#mapContainer", this.domNode)[0];
            this.placeName = query("#choosePlace_Name", this.domNode)[0];
            this.searchImg = query("#searchImg", this.domNode)[0];
            this.searchResults = query(".searchResults",this.domNode)[0];
            this.map = new MapPane({
                enableEdit:true
            }, this.mapContainer);
            this.map.startup();
            this.map.initMapElement();
        },
        refreshAllList:function(){
            this.inherited(arguments);
            if (window.titleNode) {
                window.titleNode.innerHTML = "选择地点";
            }
            if(this.did!=window.did){
                this.did = window.did;
            }
        },
        sear:function(){
            if(!this.placeName.value){
                //alert("请输入关键字！");
            }else{
                //if(domStyle.get(this.mapContainer, "display") === 'block'){
                this.map.search(window.did.split("_")[0], this.placeName.value, lang.hitch(this,this.searchSuccess), lang.hitch(this,this.searchError));
                //}
            }
        },
        initChoosePlaceEvent:function(){
            this.inherited(arguments);
            //搜索地理位置
            //回车搜索
            connect.connect(this.placeName, "onkeydown", lang.hitch(this, function(event){
                if(event.keyCode==13){
                    this.sear();
                }
            }));
            //点击搜索按钮
            connect.connect(this.searchImg, "onclick", lang.hitch(this, function(){
                    this.sear();
            }));
            var timer = null;
            //一边输入一边查询
            connect.connect(this.placeName,"oninput",lang.hitch(this,function(){
                clearTimeout(timer);
                if(this.placeName.value){
                    timer = setTimeout(lang.hitch(this,this.sear),200);
                }
            }));
            
            //点击某一个li时发布广播,将新增页面需要的参数传过去
            this.connect(this.searchResults,"onclick",function(e){
                var dom = e.target;
                while(dom&&dom.tagName!="LI"&&dom!=this.searchResults){
                    dom = dom.parentNode;
                }
                var  i = domAtrr.get(dom,"value");
                if(dom.tagName=="LI"){
                    if(window.did.split("_")[1]=="s"){
                        topic.publish("cqthink/wx/choosePlace/startPlace",this.results.poiList.pois[i]);
                        window.moveToView("addRoute");
                    }else if(window.did.split("_")[1]=="e"){
                        topic.publish("cqthink/wx/choosePlace/endPlace",this.results.poiList.pois[i]);
                        window.moveToView("addRoute");
                    }else if(window.did.split("_")[1]=="cars"){
                        topic.publish("cqthink/wx/choosePlace/carpoolStartPlace",this.results.poiList.pois[i]);
                        window.moveToView("publishCarpool");
                    }else if(window.did.split("_")[1]=="care"){
                        topic.publish("cqthink/wx/choosePlace/carpoolEndPlace",this.results.poiList.pois[i]);
                        window.moveToView("publishCarpool");
                    }else if(window.did.split("_")[1]=="mdfRouteStart"){
                        topic.publish("cqthink/wx/choosePlace/mdfRouteStart",this.results.poiList.pois[i]);
                        window.moveToView("mdfRoute",window.did.split("_")[2]);
                    }else if(window.did.split("_")[1]=="mdfRouteEnd"){
                        topic.publish("cqthink/wx/choosePlace/mdfRouteEnd",this.results.poiList.pois[i]);
                        window.moveToView("mdfRoute",window.did.split("_")[2]);
                    }
                    //清空查询条件和结果
                    this.placeName.value = "";
                    this.searchResults.innerHTML = "";
                }
            });
        },
        searchSuccess:function(results){
        //查询成功回调函数
            //在地图上标记results返回的结果
            if(results.poiList.pois.length > 0){
                //显示查询结果
                var str = "",h = {};
                for(var i = 0; i < results.poiList.pois.length; i++){
                   str += "<li value = '" + i + "'>" + results.poiList.pois[i].name + "</li>";
                }
                this.results = results;
                //将之前的查询结果清空
                this.searchResults.innerHTML = "";
                this.searchResults.appendChild(domConstruct.create("div",{
                    innerHTML:str
                }));
                domStyle.set(this.mapContainer, "display","none");
                //在地图上标记返回的结果
                var showResult = query("#result", this.domNode)[0];
                connect.connect(showResult, 'onchange', lang.hitch(this, function(){
                    domStyle.set(showResult, "display","none");
                    domStyle.set(this.mapContainer, "display","");
                    
                    var index = showResult.value;
                    this.placeName.value = results.poiList.pois[index].name;
                    //清除所有的标记
                    this.map.clearAllMarks();
                    //标记所有的地理位置信息
                    results.poiList.pois[index].lon = results.poiList.pois[index].location.lng;
                    results.poiList.pois[index].lat = results.poiList.pois[index].location.lat;
                    this.map.addMark(results.poiList.pois[index]);
                    //设置中心点
                    this.map.setCenter(results.poiList.pois[index].lon, results.poiList.pois[index].lat);
                }));
                
            }
        },
        searchError:function(results){
        //查询失败回调函数
            //alert("抱歉，未能找到该地点！");
        }
    });
});