define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dojo/_base/lang",
    "widgets/userInfo",
    "dojo/query",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/dom-attr",
    "dojo/_base/event",
    "dojox/mobile/ProgressIndicator",
    "dojo/_base/window"
    ], function(declare,registry,xhr,json,lang,userInfo,query,domConstruct,domStyle,domAttr,event,progressIndicator,win) {
    return declare("widgets.common._ClientDistributeMixin", null, {
        isClientDistributeLoaded:function(){
            return !!this.cd;
        },

        indexClientDistributeElement:function(){
            this.cd = registry.byId("myMsgforWX");
            this.rrd = registry.byId("retrievalRecordDetail");
            this.lofd = registry.byId("LevelOneFansDetail");
            //创建二维码名片节点
            var backgroundDivNode = domConstruct.create("div",{style:'width:100%;height:100%;background-color:rgba(0,0,0,0.5);z-index:998;position: absolute;visibility:hidden;',class:"backgroundDiv",id:"backgroundDiv"},document.body,"first");
            
            var imgNode = domConstruct.create("img",{style:'width:80%;z-index:999;margin: 52px 10% 0;position:relative;',class:"concelQRImg"});
            backgroundDivNode.appendChild(imgNode);
            
            var circleNode = domConstruct.create("div",{class:"sk-fading-circle",style:"visibility:hidden;z-index:998;",innerHTML:'<div class="sk-circle1 sk-circle"></div><div class="sk-circle2 sk-circle"></div><div class="sk-circle3 sk-circle"></div><div class="sk-circle4 sk-circle"></div><div class="sk-circle5 sk-circle"></div><div class="sk-circle6 sk-circle"></div><div class="sk-circle7 sk-circle"></div><div class="sk-circle8 sk-circle"></div><div class="sk-circle9 sk-circle"></div><div class="sk-circle10 sk-circle"></div><div class="sk-circle11 sk-circle"></div><div class="sk-circle12 sk-circle"></div>'});
            backgroundDivNode.appendChild(circleNode);
            
            var buttonNode = domConstruct.create("div",{innerHTML:"<span style='width:100%;z-index:999;color: #e5004f;font-size:14px;line-height:36px;'>重新获取二维码</span>",style:'width:80%;z-index:999;display:none;background-color: #fff;height:36px;text-align:center;margin: 0 10%;',class:'getQRCode'});
            backgroundDivNode.appendChild(buttonNode);
            
            // //创建修改签名节点
            // var backgroundDivNode2 = domConstruct.create("div",{style:'width:100%;height:100%;background-color:rgba(0,0,0,0.3);z-index:998;position: absolute;display:none;',class:"modifySignatureBackground",id:"modifySignatureBackground"},document.body,"first");
            // var textareaDivNode = domConstruct.create("div",{innerHTML:"<textarea maxlength='28' placeholder='限28字' class='modifySignatureTextareaNode' cols='14' rows='2' style='resize:none;overflow-y:hidden;position:absolute;top:50%;left:18.75%;z-index:999;width:62.5%;height:30px;margin-top:-15px;'></textarea>",autofocus:"true"},backgroundDivNode2);
            // var cancelDivNode = domConstruct.create("div",{innerHTML:"<span style='position:absolute;width:31%;height:20px;line-height:20px;background-color:#fff;top:50%;left:19%;margin-top:16px;text-align:center;'>取消</span>",style:"z-index:999;",class:"modifySignatureCancel"},textareaDivNode);
            // var okDivNode = domConstruct.create("div",{innerHTML:"<span style='position:absolute;width:31%;height:20px;line-height:20px;background-color:#fff;top:50%;left:50.5%;margin-top:16px;text-align:center;'>确定</span>",style:"z-index:999;",class:"modifySignatureOk"},textareaDivNode);
        },
        //隐藏选择数量区域
        hideQRImg:function(){
            query(".concelQRImg",document.body)[0].click();
        },
        initClientDistributeEvent:function(){
            domStyle.set(query(".mblScrollablePane",this.domNode)[0],{"backgroundColor":"white"});
            
            //var prog = progressIndicator.getInstance();
            var prog = new progressIndicator({size:0,center:true});
            win.body().appendChild(prog.domNode);
            
            // 执行 浏览器 前进事件(进入页面)
            this.connect(this,"onBeforeTransitionIn",function(){
                this.hideQRImg();
            });
            // 执行 浏览器 后退事件(退出页面)
            this.connect(this,"onBeforeTransitionOut",function(){
                this.hideQRImg();
            });
            
            //domStyle.set(query(".maxWithdrawn",this.domNode)[0],"width",parseInt(domStyle.get(query(".withdrawAmount",this.domNode)[0],"width"),10)-parseInt(domStyle.get(query(".withdrawAmount>span",this.domNode)[0],"width"),10)+"px");
            //input失去焦点事件
            modifySignatureOnBlur = function(){
                domStyle.set(query(".modifySignatureTextareaNode",this.domNode)[0],{"outline":"none","border-radius":"","-webkit-transition":"","-moz-transition":"","border":"none","box-shadow":""});
                xhr("POST", {
                    url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                    handleAs: "json",
                    content: {
                        data: json.toJson({
                            modalName: "XSY_TCRCS_CLIENT_DCARD",
                            data: [{
                                o:{
                                    "PID":window.userInfo.partnerId
                                },
                                n:{
                                    "CINFO":query(".modifySignatureTextareaNode",this.domNode)[0].value
                                }
                            }]
                        })
                    },
                    load: lang.hitch(this, function(result) {
                        if (1 === result.rtnType) {
                        } else {
                            alert(result.message || "数据错误!");
                        }
                    })
                });
            };
            //input获取焦点事件
            modifySignatureOnfoucs = function(){
                domStyle.set(query(".modifySignatureTextareaNode",this.domNode)[0],{"outline":"none","border-radius":"3px","-webkit-transition":"box-shadow 0.30s ease-in-out","-moz-transition":"box-shadow 0.30s ease-in-out","border":"1px solid #87C6F9","box-shadow":"0 0 8px rgba(103, 166, 217, 1)"});
            };
            
            // //修改签名监听事件
            // this.connect(query(".modifySignature")[0],"onclick",function(){
            //     domStyle.set(query(".modifySignatureBackground")[0],"display","block");
            // });
            
            // //取消修改签名弹出框
            // this.connect(query(".modifySignatureBackground")[0],"onclick",function(){
            //     domStyle.set(query(".modifySignatureBackground")[0],"display","none");
            // });
            
            //"我的二维码"监听
            this.connect(query(".cdQRCodeDiv",this.domNode)[0],"onclick",function(e){
                //可视窗的宽高
                var concelQRImgNode = query(".concelQRImg",document.body)[0];
                var getQRCodeNode = query(".getQRCode",document.body)[0];
                //var sfcNode = query(".sk-fading-circle",document.body)[0];
                var backgroundDivNode = query(".backgroundDiv",document.body)[0];
                
                //var screenW = document.body.offsetWidth;
                //var screenH = document.body.offsetHeight;
                // domStyle.set(concelQRImgNode,"height",screenH*0.5821+"px");
                // domStyle.set(sfcNode,"top",screenH*0.5821/2+"px");
                // domStyle.set(concelQRImgNode,"width",screenH*0.5821*0.7733+"px");
                
                //domStyle.set(concelQRImgNode,"margin","52px "+(screenW-parseInt(domStyle.get(concelQRImgNode,"width"),10))/2/screenW*100+"% 0");
                //domStyle.set(getQRCodeNode,"width",screenH*0.5821*0.7733+"px");
                //domStyle.set(getQRCodeNode,"margin","0 "+(screenW-parseInt(domStyle.get(concelQRImgNode,"width"),10))/2/screenW*100+"% 0");
                
                //domStyle.set(sfcNode,{"visibility":"visible"});
                window.busy();
                if(this.cardId){
                    window.free();
                    //window.location="/w/img/load/"+window.code+"-"+this.cardId;
                    domAttr.set(concelQRImgNode,"src","/w/img/load/"+window.code+"-"+this.cardId);
                    domStyle.set(backgroundDivNode,{"visibility":"visible"});
                    domStyle.set(concelQRImgNode,{/*"z-index":parseInt(domStyle.get(sfcNode,"z-index"),10)+1,*/"visibility":"visible"});
                    domStyle.set(getQRCodeNode,{"display":"block"});
                }else{
                    //调用接口
                    xhr("POST", {
                    url: "/w/user/GetWxBusinessCard/" + window.code,
                    handleAs: "json",
                    content: {
                        
                    },
                    load: lang.hitch(this, function(result) {
                        if (1 === result.rtnType) {
                            window.free();
                            //显示二维码
                            this.cardId = result.imageId;
                            //window.location="/w/img/load/"+window.code+"-"+result.imageId;
                            domAttr.set(concelQRImgNode,"src","/w/img/load/"+window.code+"-"+this.cardId);
                            domStyle.set(backgroundDivNode,{"visibility":"visible"});
                            domStyle.set(concelQRImgNode,{/*"z-index":parseInt(domStyle.get(sfcNode,"z-index"),10)+1,*/"visibility":"visible"});
                            domStyle.set(getQRCodeNode,{"display":"block"});
                        } else {
                            window.free();
                            alert(result.message || "数据错误!");
                            //domStyle.set(sfcNode,"visibility","hidden");
                        }
                    })
                    });
                }
            });
            //"图片弹出重新获取二维码"监听事件
            this.connect(query(".getQRCode")[0],"onclick",function(e){
                //domStyle.set(query(".sk-fading-circle",document.body)[0],{"z-index":parseInt(domStyle.get(query(".concelQRImg",document.body)[0],"z-index"),10)+1,"visibility":"visible"});
                window.busy();
                //this.disconnect(handler);
                
                xhr("POST", {
                    url: "/w/user/GetWxBusinessCard/" + window.code,
                    handleAs: "json",
                    content: {

                    },
                    load: lang.hitch(this, function(result) {
                        if (1 === result.rtnType) {
                            //显示二维码
                            window.free();
                            this.cardId = result.imageId;
                            //window.location="/w/img/load/"+window.code+"-"+result.imageId;
                            domAttr.set(query(".concelQRImg",document.body)[0],"src","/w/img/load/"+window.code+"-"+this.cardId);
                            domAttr.set(query(".backgroundDiv",document.body)[0],"visibility","visible");
                            domStyle.set(query(".concelQRImg",document.body)[0],{/*"z-index":parseInt(domStyle.get(query(".sk-fading-circle",document.body)[0],"z-index"),10)+1,*/"visibility":"visible"});
                            domAttr.set(query(".getQRCode",document.body)[0],"display","block");
                        } else {
                            window.free();
                            alert(result.message || "数据错误!");
                            domStyle.set(query(".sk-fading-circle",document.body)[0],"visibility","hidden");
                            domStyle.set(query(".concelQRImg",document.body)[0],"visibility","hidden");
                            domStyle.set(query(".backgroundDiv",document.body)[0],"visibility","hidden");
                            domAttr.set(query(".getQRCode",document.body)[0],"display","none");
                        }
                    })
                });
            });
            
            //"图片弹出取消"监听事件
            var handler = this.connect(query(".concelQRImg")[0],"onclick",function(e){
                //domStyle.set(query(".sk-fading-circle",document.body)[0],"visibility","hidden");
                domStyle.set(query(".concelQRImg",document.body)[0],"visibility","hidden");
                domStyle.set(query(".backgroundDiv",document.body)[0],"visibility","hidden");
                domAttr.set(query(".getQRCode",document.body)[0],"display","none");
            });
            //"我的粉丝"监听事件
            this.connect(query(".myFans",this.domNode)[0],"onclick",function(e){
                var node1 = query(".LevelOneFans",this.domNode)[0];
                var node2 = query(".levelTwoFans",this.domNode)[0];
                var node3 = query(".levelThreeFans",this.domNode)[0];
                var isShow1 = domAttr.get(node1,"isshow");
                var isShow2 = domAttr.get(node2,"isshow");
                var isShow3 = domAttr.get(node3,"isshow");
                
                var lofdNode = query(".LevelOneFansDetail",this.domNode)[0];
                var stateNode = query(".NICKAndTime>span:last-child",this.domNode);
                
                domStyle.set(lofdNode,"display","none");
                domAttr.set(lofdNode,"isshow","0");
                
                if(isShow1==="0"){
                    domAttr.set(node1,"isshow","1");
                    domStyle.set(query(".arrows2",this.domNode)[0],"border-width","2px 0 0 2px");
                    domStyle.set(node1,"display","block");
                }else{
                    domAttr.set(node1,"isshow","0");
                    domStyle.set(query(".arrows2",this.domNode)[0],"border-width","0 2px 2px 0");
                    domStyle.set(node1,"display","");
                }
                if(isShow2==="0"){
                    domAttr.set(node2,"isshow","1");
                    domStyle.set(query(".arrows2",this.domNode)[0],"border-width","2px 0 0 2px");
                    domStyle.set(node2,"display","block");
                }else{
                    domAttr.set(node2,"isshow","0");
                    domStyle.set(query(".arrows2",this.domNode)[0],"border-width","0 2px 2px 0");
                    domStyle.set(node2,"display","");
                }
                if(isShow3==="0"){
                    domAttr.set(node3,"isshow","1");
                    domStyle.set(query(".arrows2",this.domNode)[0],"border-width","2px 0 0 2px");
                    domStyle.set(node3,"display","block");
                }else{
                    domAttr.set(node3,"isshow","0");
                    domStyle.set(query(".arrows2",this.domNode)[0],"border-width","0 2px 2px 0");
                    domStyle.set(node3,"display","");
                }
                event.stop(e);
            });
            //"我的收入"监听事件
            this.connect(query(".myIncome",this.domNode)[0],"onclick",function(e){
                var node1 = query(".toPromoteIncome",this.domNode)[0];
                var node2 = query(".salesProceeds",this.domNode)[0];
                var node3 = query(".withdrawn",this.domNode)[0];
                var isShow1 = domAttr.get(node1,"isshow");
                var isShow2 = domAttr.get(node2,"isshow");
                var isShow3 = domAttr.get(node3,"isshow");
                if(isShow1==="0"){
                    domAttr.set(node1,"isshow","1");
                    domStyle.set(query(".arrows3",this.domNode)[0],"border-width","2px 0 0 2px");
                    domStyle.set(node1,"display","block");
                }else{
                    domAttr.set(node1,"isshow","0");
                    domStyle.set(query(".arrows3",this.domNode)[0],"border-width","0 2px 2px 0");
                    domStyle.set(node1,"display","");
                }
                if(isShow2==="0"){
                    domAttr.set(node2,"isshow","1");
                    domStyle.set(query(".arrows3",this.domNode)[0],"border-width","2px 0 0 2px");
                    domStyle.set(node2,"display","block");
                }else{
                    domAttr.set(node2,"isshow","0");
                    domStyle.set(query(".arrows3",this.domNode)[0],"border-width","0 2px 2px 0");
                    domStyle.set(node2,"display","");
                }
                if(isShow3==="0"){
                    domAttr.set(node3,"isshow","1");
                    domStyle.set(query(".arrows3",this.domNode)[0],"border-width","2px 0 0 2px");
                    domStyle.set(node3,"display","block");
                }else{
                    domAttr.set(node3,"isshow","0");
                    domStyle.set(query(".arrows3",this.domNode)[0],"border-width","0 2px 2px 0");
                    domStyle.set(node3,"display","");
                }
                event.stop(e);
            });
            
            //一级粉丝监听事件
            this.connect(query(".LevelOneFans",this.domNode)[0],"onclick",function(e){
                var lofdNode = query(".LevelOneFansDetail",this.domNode)[0];
                var stateNode = query(".NICKAndTime>span:last-child",this.domNode);
                if(domAttr.get(lofdNode,"isshow") == 0){
                    domStyle.set(lofdNode,"display","block");
                    domAttr.set(lofdNode,"isshow","1");
                }else{
                    domStyle.set(lofdNode,"display","none");
                    domAttr.set(lofdNode,"isshow","0");
                }
                
                stateNode.forEach(function(node){
                    if(node.innerHTML == "关注中" && domAttr.get(lofdNode,"isshow") == 1){
                        domStyle.set(node,"background","#ff4401");
                    }else{
                        domStyle.set(node,"background","#78909c");
                    }
                });
                
                //日期格式化
                query(".subscribeTime",this.domNode).forEach(function(node){
                    var dat = node.innerHTML.toString().split(" ")[0];
                    var tim = node.innerHTML.toString().split(" ")[1];
                    node.innerHTML = dat + " " + tim.substring(0,5);
                });
            });
            
            //修改 Radio选中状态
            updateRadioChecked = function(node){
                domAttr.set(query("input[name='aw']:checked",this.domNode)[0],"checked",false);
                
                if(domAttr.get(node,"value") == "r1") {
                    domAttr.set(query("input[name='aw'][value='r1']",this.domNode)[0],"checked",true);
                    domStyle.set(query(".bgd1",this.domNode)[0],"display","inline-block");
                    domStyle.set(query(".bgd2",this.domNode)[0],"display","none");
                }else if(domAttr.get(node,"value") == "r2") {
                    domAttr.set(query("input[name='aw'][value='r2']",this.domNode)[0],"checked",true);
                    domStyle.set(query(".bgd1",this.domNode)[0],"display","none");
                    domStyle.set(query(".bgd2",this.domNode)[0],"display","inline-block");
                }
            };
            
            //点击 Radio父层事件
            this.connect(query(".radioPDiv",this.domNode)[0],"onclick",function(e){
               var node = e.target;
               if("div" === node.tagName.toLowerCase() && "radioPDiv" === domAttr.get(node,"class")){
                   return false;
               }else{
                   updateRadioChecked(node);
               }
            });
            
            var that = this,
            //获取 收入函数
            accordingToIncome = function(th){
                var showMeg;
                window.loadData({
                    modalName:"XSY_TCRCS_CLIENT_DCARD",
                    filter:"01",
                    pageSize:"1",
                    pageIndex:"1",
                    param:{PID:userInfo.getUserInfo().partnerId}
                }).then(lang.hitch(this,function(data){
                    if(th) th.cardId = data[0].CARDID;
                    //显示收入
                    this.myIncome = data[0].INCOME;
                    query(".myIncomeValue",this.domNode)[0].innerHTML= window.fixedTo(this.myIncome,3)+"元";
                    query(".totalIncome",this.domNode)[0].innerHTML = window.fixedTo(this.myIncome,3);
                    
                    this.myIncomeDist = data[0].INCOME_UNE?data[0].INCOME_UNE:0;
                    query(".UNEIncomeValue",this.domNode)[0].innerHTML= window.fixedTo(this.myIncomeDist,3)+"元";
                    
                    this.myIncomeSale = data[0].INCOME_WITHDRAW?data[0].INCOME_WITHDRAW:0;
                    query(".WITHDRAWValue",this.domNode)[0].innerHTML= window.fixedTo(this.myIncomeSale,3)+"元";
                    
                    if(+this.myIncomeSale - +that.MIN_AMT < 0) {
                        showMeg = "可提现金额不足" + fixedTo(that.MIN_AMT,3) + "元,无法提现";
                        domAttr.set(query(".maxWithdrawn",this.domNode)[0],"disabled","disabled");
                        // domStyle.set("::-webkit-input-placeholder","color","red");
                    } else if(+that.MIN_AMT - +this.myIncomeSale <= 0 && +this.myIncomeSale - +that.MAX_AMT <= 0) {
                        showMeg = "可提现:" + fixedTo(this.myIncomeSale,3) + "元";
                    } else if(+that.MAX_AMT) {
                        showMeg = "单笔最高提现金额" + fixedTo(that.MAX_AMT,3) + "元";
                    }  else {
                        showMeg = "可提现:" + fixedTo(this.myIncomeSale,3) + "元";
                    }
                    domAttr.set(query(".maxWithdrawn",this.domNode)[0],"placeholder",showMeg);
                    
                    this.myIncomeWitndrawn = data[0].INCOME_WITHDRAWN?data[0].INCOME_WITHDRAWN:0;
                    query(".WITHDRAWNValue",this.domNode)[0].innerHTML= window.fixedTo(this.myIncomeWitndrawn,3)+"元";
                }));
            };
            
            //获取 粉丝函数
            forFansNumber = function(th){
                xhr("POST", {
                    url: "/w/Exec/executeSelect/" + window.code,
                    handleAs: "json",
                    content: {
                        tp: "wx_distribute_num"
                    },
                    load: lang.hitch(this, function(result) {
                        if (1 === result.rtnType) {
                            //求总人数
                            var total = 0;
                            total = parseInt(result.data.items[0].Q1,10)+parseInt(result.data.items[0].Q2,10)+parseInt(result.data.items[0].Q3,10);
                            //显示总人数
                            query(".myFansValue",this.domNode)[0].innerHTML = total+"人";
                            //显示一级人数
                            query(".leveloneFanNum",this.domNode)[0].innerHTML = result.data.items[0].Q1+"人";
                            //显示二级人数
                            query(".leveltwoFanNum",this.domNode)[0].innerHTML = result.data.items[0].Q2+"人";
                            //显示三级人数
                            query(".levelthreeFanNum",this.domNode)[0].innerHTML = result.data.items[0].Q3+"人";
                            //this.refreshAllList();
                        } else {
                            alert(result.message || "数据错误!");
                        }
                    })
                });
            };
            
            //提交 监听事件
            this.connect(query(".sub",this.domNode)[0],"onclick",function(e){
                var maxWithdrawnValue = query(".maxWithdrawn",this.domNode)[0];
                
                if(domAttr.get(query("input[name='aw']:checked",this.domNode)[0],"value")=="r2"){
                    alert("暂不支持微信钱包提现业务");
                    maxWithdrawnValue.value="";
                }else{
                    //声明 提现金额正则表达式
                    var exp = /^([1-9][\d]{0,7}|0)(\.[\d]{1,2})?$/;
                    if(maxWithdrawnValue.value.replace(/\s/g,'') === ""){
                        alert("请输入提取金额！");
                        maxWithdrawnValue.focus();
                    }else if(exp.test(maxWithdrawnValue.value)){
                        var maxw = query(".WITHDRAWValue",this.domNode)[0].innerHTML.split("元")[0];
                        maxw = parseFloat(maxw,10);
                        if(maxw === 0){
                            alert("可提现金额为0！无法提现");
                        }else if(maxWithdrawnValue.value == 0){
                            alert("请确认提现金额大于0！");
                            maxWithdrawnValue.select();
                        } else if(+this.MIN_AMT && maxWithdrawnValue.value - +this.MIN_AMT <= 0) {
                            alert("单笔提现下限为" + fixedTo(this.MIN_AMT,3) + "元,请重新输入！");
                            maxWithdrawnValue.select();
                        } else if(+this.MAX_AMT && +this.MAX_AMT - maxWithdrawnValue.value <= 0) {
                            alert("单笔提现上限为" + fixedTo(this.MAX_AMT,3) + "元,请重新输入！");
                            maxWithdrawnValue.select();
                        } else if(maxWithdrawnValue.value > maxw && maxw > 0){
                            if(confirm("由于输入提现金额大于可提现金额，是否全部提现？")){
                                var mwv = domAttr.get(query(".maxWithdrawn",this.domNode)[0],"placeholder").split(":")[1];
                                xhr("POST", {
                                    url: "/w/user/DisWithDrawAmt/" + window.code,
                                    handleAs: "json",
                                    content: {
                                        amt: mwv.substring(0,mwv.length-1)
                                    },
                                    load: lang.hitch(this, function(result) {
                                        if (1 === result.rtnType) {
                                            alert("提现成功!");
                                            maxWithdrawnValue.value="";
                                            accordingToIncome();
                                            this.rrd.refreshList();
                                        } else {
                                            alert(result.message || "数据错误!");
                                        }
                                    })
                                });
                                return;
                            }
                        }else{
                            xhr("POST", {
                                url: "/w/user/DisWithDrawAmt/" + window.code,
                                handleAs: "json",
                                content: {
                                    amt: maxWithdrawnValue.value
                                },
                                load: lang.hitch(this, function(result) {
                                    if (1 === result.rtnType) {
                                        alert("提现成功!");
                                        maxWithdrawnValue.value="";
                                        accordingToIncome();
                                        this.rrd.refreshList();
                                    } else {
                                        alert(result.message || "数据错误!");
                                    }
                                })
                            });
                        }
                    }else{
                        alert("提现失败！请确认提现金额格式！");
                    }
                }
           });
           
           //提现记录 监听事件
           this.connect(query(".retrievalRecordDiv",this.domNode)[0],"onclick",function(e){
               if(e.target && domAttr.get(e.currentTarget,"class")=="retrievalRecordDiv" ){
                    if(domAttr.get(e.currentTarget,"isshow") == "0"){
                        domAttr.set(e.currentTarget,"isshow","1");
                        domStyle.set(query(".retrievalRecordTitle",this.domNode)[0],"display","block");
                        domStyle.set(query(".arrows5",this.domNode)[0],"border-width","2px 0 0 2px");
                        domStyle.set(query("#retrievalRecordDetail",this.domNode)[0],"display","block");
                    }else{
                        domAttr.set(e.currentTarget,"isshow","0");
                        domStyle.set(query(".retrievalRecordTitle",this.domNode)[0],"display","none");
                        domStyle.set(query(".arrows5",this.domNode)[0],"border-width","0 2px 2px 0");
                        domStyle.set(query("#retrievalRecordDetail",this.domNode)[0],"display","none");
                    }
               }
           });
           
           //返回 监听事件
           this.connect(query(".backto",this.domNode)[0],"onclick",function(e){
                this.centerPane.scrollTo({x: 0, y: 0});
                domStyle.set(query(".myWithdrawPDiv",this.domNode)[0],"display","none");
                domStyle.set(query(".hideDiv",this.domNode)[0],"display","block");
           });
           //提现 监听事件
           this.connect(query(".myWithdraw",this.domNode)[0],"onclick",function(e){
               //日期格式化
                query(".formatDate",this.domNode).forEach(function(node){
                    var dat = node.innerHTML.toString().split(" ")[0];
                    var tim = node.innerHTML.toString().split(" ")[1];
                    node.innerHTML = dat + " " + tim.substring(0,5);
                });
               
                this.centerPane.scrollTo({x: 0, y: 0});
                domStyle.set(query(".hideDiv",this.domNode)[0],"display","none");
                domStyle.set(query(".myWithdrawPDiv",this.domNode)[0],"display","block");
                
                domAttr.set(query(".retrievalRecordDiv",this.domNode)[0],"isshow","1");
                domStyle.set(query(".arrows5",this.domNode)[0],"border-width","2px 0 0 2px");
                domStyle.set(query("#retrievalRecordDetail",this.domNode)[0],"display","block");
           });
           
           //提交提现 监听事件
           this.connect(query(".maxWithdrawn",this.domNode)[0],"onkeypress",function(e){
                //获取 
                var keynum = e.keyCode || e.which;
                var keychar = String.fromCharCode(keynum);
                
                if(!isNaN(parseInt(keychar,10)) || keychar == "."){
                    
                }
                
           });
           
            //判断客户是否存在
            this.connect(this.cd,"onDefRendered",function(data){
                //window.busy();
                prog.start();
                //如果不存在向资源自动添加当前登陆用户
                if(data.data.items.length === 0){
                    xhr("POST", {
                        url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                        handleAs: "json",
                        content: {
                            data: json.toJson({
                                modalName: "XSY_TCRCS_CLIENT_DCARD",
                                data: [{
                                    n:{
                                        "PID":window.userInfo.partnerId,
                                        "TYPE":0,
                                        "INCOME":0
                                    }
                                }]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                accordingToIncome(this);
                                forFansNumber(this);
                            } else {
                                alert(result.message || "数据错误!");
                            }
                        })
                    });
                }else{
                    //显示收入
                    accordingToIncome(this);
                    //获取粉丝数
                    forFansNumber(this);
                }
                //window.free();
                prog.stop();
            });
        },
        // 提取下限
        MIN_AMT: 0,
        // 提取上限
        MAX_AMT: 0,
        refreshAllList: function() {
            // 判断用户是否已经登录
            userInfo.hasLogin().then(lang.hitch(this,function(hasLogin) {
                if (hasLogin) {
                    //确保 每次页面跳转都显示导航页面
                    if("http://www.cqthink.com/w/home/index/"+window.code+"#clientDistribute"==document.location.href){
                        domStyle.set(query(".hideDiv",this.domNode)[0],"display","block");
                        domStyle.set(query(".myWithdrawPDiv",this.domNode)[0],"display","none");
                    }
                    //判断 提现类型
                    window.loadData({
                        modalName:"XSY_TSSCF_DSTBT",
                        filter:"999",
                        pageSize:"1",
                        pageIndex:"1",
                        param:{}
                    }).then(lang.hitch(this,function(data){
                        if(data.length){
                            this.MIN_AMT = data[0].MIN_AMT;
                            this.MAX_AMT = data[0].MAX_AMT;
                            if(data[0].WITHDRAW == 0){
                                query("[value='r2']",this.domNode).forEach(function(node){
                                    domStyle.set(node,"display","none");
                                });
                            } else if(data[0].WITHDRAW == 1){
                                domStyle.set(query(".bgd2[value='r2']",this.domNode)[0],"display","none");
                                domStyle.set(query("span[value='r2']",this.domNode)[0],"display","inline-block");
                            }
                        }
                    }));
                    this.cd.refreshList();
                    this.rrd.refreshList();
                    this.lofd.refreshList();
                } else {
                    window.nextPageOnLogin = "clientDistribute";
                    // 若没有登录
                    userInfo.showLogin();
                }
            }));
        }
    });
});