define([
    "dojo/_base/declare",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/query",
    "dojo/_base/array",
    "../userInfo",
    "dojo/_base/lang",
    "dojo/_base/xhr",
    "dojo/_base/json"
],function(declare,domAttr,domStyle,query,array,userInfo,lang,xhr,json){
    return declare("widgets.common._ComRepMixin",null,{
        //配置是否右上角显示购物车
        showOrderCarNum:false,
        isComRepLoaded:function(){
            return !!this.complainType;
        },
        indexComRepElement:function(){
            this.complain = query("#complain")[0];//报事div
            this.repair = query("#repair")[0];//报修div
            this.comRepHead = query(".comRepHeadClass")[0];//头部
            //报事
            this.complainType = query("#complainType")[0]; //投诉类型
            this.complainRemark = query("#complainRemark")[0];//投诉内容
            this.complainSubmit = query(".complainSubmit")[0];//确定
            //报修
            this.repairSubmit = query(".repairSubmit")[0];
            this.repairType = query("#repairType")[0];
            /*this.repairRemark = query(".repairRemark")[0];*/
            this.repairRemark = query("#repairRemark")[0];
        },
        initComRepEvent:function(){
            this.connect(this.comRepHead, "onclick", this.comRepFuc);//tab页面头部
            this.connect(this.repairSubmit,"onclick",this.postRepairFuc);//提交报修
            this.connect(this.complainSubmit,"onclick",this.postComplainFuc);//提交报事
        },
        postRepairFuc:function(){
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                var d = new Date();
                if(s){
                    if(this.repairType.value==-1){
                        alert("请先选择报修类型。");
                        return;
                    }
                    xhr("POST", {
                        url: "../../data/update/"+window.code+"-"+window.openId+"?token="+window.userInfo.token,
                        handleAs: "json",
                        content:{
                            data:json.toJson({
                                modalName:"XSY_TSCSF_WB",
                                data:[{
                                    n:{
                                        CLIENT:userInfo.getUserInfo().partnerId,
                                        TYPEID:1,
                                        REPAIRTYPE:this.repairType.value,
                                        REMARK:this.repairRemark.value,
                                        MADEDTAE:d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds()
                                    }
                                }]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                alert("报修成功。");
                                window.free();
                                this.repairRemark.value = "";
                                this.repairType.value = -1;
                            } else {
                                alert(result.message || "数据错误!");
                                this.repairRemark.value = "";
                                this.repairType.value = -1;
                                window.free();
                            }
                        })
                    });    
                }else{
                    alert("请先登录");
                }
            }));
        },
        postComplainFuc:function(){
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                var d = new Date();
                if(s){
                    if(this.complainType.value==0){
                        alert("请先选择投诉类型。");
                        return;
                    }
                    xhr("POST", {
                        url: "../../data/update/"+window.code+"-"+window.openId+"?token="+window.userInfo.token,
                        handleAs: "json",
                        content:{
                            data:json.toJson({
                                modalName:"XSY_TSCSF_WB",
                                data:[{
                                    n:{
                                        CLIENT:userInfo.getUserInfo().partnerId,
                                        TYPEID:2,
                                        CMPLINTYPE:this.complainType.value,
                                        REMARK:this.complainRemark.value,
                                        MADEDTAE:d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds()
                                    }
                                }]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                alert("报事成功。");
                                window.free();
                                this.complainRemark.value = "";
                                this.complainType.value = 0;
                            } else {
                                alert(result.message || "数据错误!");
                                this.complainRemark.value = "";
                                this.complainType.value = 0;
                                window.free();
                            }
                        })
                    });    
                }else{
                    alert("请先登录");
                }
            }));
        },
        refreshAllList:function(){
            domAttr.set(this.repair, "class", "tableLi");
            if (window.titleNode) {
                window.titleNode.innerHTML = "报事报修";
            }
            userInfo.hasLogin().then(lang.hitch(this,function(success){
                if(success){
                }else{
                    window.nextPageOnLogin = "comRep";
                    // 若没有登录
                    userInfo.showLogin();
                }
            }));
            this.resize;
        },
         //tab页面的切换
        comRepFuc: function(e) {
            var dom = e.target; //点击的节点
            if (dom && dom.tagName.toLowerCase() == "li") {
                //ul标签的显示隐藏
                var cls = domAttr.get(dom, "class"),
                    name = domAttr.get(dom, "name");
                //点击后显示
                domAttr.set(dom, "class", (cls == "tableLi" || cls == "tableLiChecked") ? "tableLiChecked" : "tableLi");
                //点击后隐藏
                query("li", this.comRepHead).forEach(function(n) {
                    if (n != dom) {
                        domAttr.set(n, "class", "tableLi");
                    }
                });
                //div的显示隐藏
                domStyle.set(query("#" + name, this.domNode)[0],"display","block");
                array.forEach([this.complain, this.repair], function(n) {
                    if (domAttr.get(n, "id") != name) {
                        domStyle.set(n,"display","none");
                    }
                });
            }
        }        
    });
});