define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/query",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "../userInfo",
    "dojo/_base/json",
    "dojo/_base/xhr"], function(declare,registry,query,lang,array,domAttr,userInfo,json,xhr) {
    return declare("widgets.common.Complain",null, {
        //配置是否右上角显示购物车
        showOrderCarNum:false,
        isComplainLoaded:function(){
            return !!this.complainType;
        },
        indexComplainElement: function() {
            this.inherited(arguments);
            this.complainType = query("#complainType")[0]; //投诉类型
            this.complainRemark = query("#complainRemark")[0];//投诉内容
            this.complainSubmit = query(".complainSubmit")[0];//确定
             //头部ID
            this.comRep = query("#comRep", this.domNode)[0];
        },
        onTplLoaded:function(){
            this.inherited(arguments);
            this.connect(this.complainSubmit,"onclick",this.postComplain);
        },
        refreshAllList: function() {
            this.inherited(arguments);
            window.updateTitle("投诉");
            userInfo.hasLogin().then(lang.hitch(this,function(success){
                if(success){
                }else{
                    window.nextPageOnLogin = "complain";
                    // 若没有登录
                    userInfo.showLogin();
                }
            }));
            this.resize;
        },
        postComplain:function(){
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    if(this.complainType.value==0){
                        alert("请先选择投诉类型。");
                        return;
                    }
                    xhr("POST", {
                        url: "../../data/update/"+window.code+"-"+window.openId+"?token="+window.userInfo.token,
                        handleAs: "json",
                        content:{
                            data:json.toJson({
                                modalName:"XSY_TSCSF_WB",
                                data:[{
                                    n:{
                                        CLIENT:userInfo.getUserInfo().partnerId,
                                        TYPEID:2,
                                        CMPLINTYPE:this.complainType.value,
                                        REMARK:this.complainRemark.value
                                    }
                                }]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                alert("报修成功。");
                                window.free();
                                this.complainRemark.value = "";
                                this.complainType.value = 0;
                            } else {
                                alert(result.message || "数据错误!");
                                this.complainRemark.value = "";
                                this.complainType.value = 0;
                                window.free();
                            }
                        })
                    });    
                }else{
                    alert("请先登录");
                }
            }));
        }
    });
});