define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/dom-style",
    "dijit/registry",
    "dojo/query",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/dom-attr",
    "dojo/_base/xhr",
    "widgets/userInfo"
    ], function(declare, array, domClass, domStyle, registry, query, lang, Deferred, domAttr, xhr, userInfo) {
    return declare("widgets.common._ConversListMixin", null, {
        pageSize: 100,
        pid:"noPid",
        isConversListLoaded: function() {
            return !!this.conversList;
        },
        indexConversListElement: function() {
            this.conversList = registry.byId("conversationList");
        },
        initConversListEvent: function() {
            this.connect(this.conversList, "onDefRendered", function(data) {
                window.updateTitle("会话列表");
                // 解决会话列表下拉内容丢失问题，阻止LIST3下拉时自动刷新
                // this.conversList.dir = "bottom2top";
                this.conversList._top2bottomNext = function() {};
                //console.log(data);
                this.conversListDataLoaded(data);
            });
        },
        //会话数据加载完成的接口
        conversListDataLoaded:function(data){
            var listData=data&&data.data&&data.data.items;
                if(listData.length){
                    array.forEach(listData,function(item){
                        if(item.SENDPID.PartnerID&&item.RCPTPID.PartnerID){
                            if(item.SENDPID.PartnerID==this.pid){
                                item.ptpid=item.RCPTPID.PartnerID;
                                item.Logo=item.RCPTPID.Logo;
                                item.Cname=item.RCPTPID.PartnerName;
                            }else{
                                item.ptpid=item.SENDPID.PartnerID;
                                item.Logo=item.SENDPID.Logo;
                                item.Cname=item.SENDPID.PartnerName;
                            }
                        }
                    },this);
                }
        },
        getConverseWhere:function(hasLogin){
            this.pid = hasLogin&&userInfo.getUserInfo().partnerId;
            this.wxId = (hasLogin?userInfo.getUserInfo().wxId:"")||g_s.getGuid();
            return "[SENDER]='"+this.wxId+"' OR [RECEIVER]='"+this.wxId+"'"+(this.pid?" OR [SENDPID]='"+this.pid+"' OR [RCPTPID]='"+this.pid+"'":"");
        },
        getConverseGroupBy:function(){
            return "[SENDID],[SENDID.T1_EmpName],[SENDID.T1_Icon],[SENDID.T1_Remark],"
                    +"[RCPTID],[RCPTID.T1_EmpName],[RCPTID.T1_Icon],[RCPTID.T1_Remark],"
                    +"[SENDPID],[SENDPID.PartnerName],[SENDPID.Logo],"
                    +"[RCPTPID],[RCPTPID.PartnerName],[RCPTPID.Logo]"
        },
        _loadConverseListData:function(hasLogin){
            var def = new Deferred();
            // 获取会话人
            xhr("GET", {
                url: g_sys_info.url_usr,
                handleAs: "json",
                load: lang.hitch(this, function(data) {
                    // 过滤dt，将dt中重复的专家和用户过滤掉
                    data = this.fltDts(data);
                    def.resolve(data);
                }),
                sync: false,
                preventCache: true,
                content: {
                    modalName: "XSY_TSSUS_MSG_LIST",
                    pageSize: this.pageSize,
                    pageIndex: this.curPageIndex || 1,
                    orderBy: "max([MESSID]) DESC",
                    groupBy: this.getConverseGroupBy(),
                    egg: "[MESSID]:max",
                    appId: window.g_sys_info.aid,
                    where: this.getConverseWhere(hasLogin)
                }
            });
            return def;
        },
        _loadLastMsg:function(data){
            var def = new Deferred();
            data = data && data.data && data.data.items;
            if (data && data.length) {
                xhr("GET", {
                    url: g_sys_info.url_usr,
                    handleAs: "json",
                    load: lang.hitch(this, function(dt) {
                        array.map(dt.data.items, function(item) {
                            if (item.MESSCONTENT.indexOf('{TYPE:"image",MEDIAID:') === 0) {
                                item.TYPE = "[图片]";
                            }
                        });
                        def.resolve(dt);
                    }),
                    sync: false,
                    preventCache: true,
                    content: {
                        modalName: "XSY_TSSUS_MSG_LIST",
                        pageSize: this.pageSize,
                        pageIndex: this.curPageIndex || 1,
                        orderBy: "[MESSID] DESC",
                        groupBy: "",
                        egg: "",
                        appId: window.g_sys_info.aid,
                        where: "[MESSID] IN ('"+array.map(data,function(item){
                            return item.MESSID
                        }).join("','")+"')"
                    }
                });
            }else{
                def.resolve({data:{items:[]}});
            }
            return def;
        },
        _loadAndRefreshNum:function(data){
            data = data && data.data && data.data.items;
            if (data && data.length) {
                //未读 且 (接收客户不为空 或 接收人不为空) 且 
                //  若当前客户为空  接收人=当前wxid
                //  否则 接收客户=当前客户
                
                
                // 未读且接收者为当前客户
                var sqlStr = "[ISREAD]=0 AND "
                + (userInfo.getUserInfo().partnerId?"[RCPTPID]="+userInfo.getUserInfo().partnerId:("[RCPTPID] IS NULL"+ " AND [RECEIVER]='" + g_s.getGuid()))
                /*+" AND ("+array.map(data,function(item){
                    var tpid = "",twxId = "",tuid = "";
                    if(this.pid&&this.pid==item.SENDPID||this.wxid&&this.wxid==item.SENDER){
                        tpid = item.RCPTPID;
                        twxId = item.RECEIVER;
                        tuid = item.RCPTID;
                    }else{
                        tpid = item.SENDPID;
                        twxId = item.SENDER;
                        tuid = item.RCPTID;
                    }
                    if(tpid){
                        return "[SENDPID]='"+tpid+"'"+(twxId?" OR [SENDER]='"+twxId+"'":"");
                    }else if(twxId){
                        return "[SENDER]='"+twxId+"'";
                    }else if(tuid){
                        return "[SENDID]='"+tuid+"'";
                    }else{
                        return "[SENDPID] IS NULL AND [SENDER] IS NULL"
                    }
                },this).join(" OR ")+")";
                
                //每一项：
                //我发给专家
                //  有接收专家                      发送专家为本条接收专家
                //专家发给我
                //  有发送专家                      
                //我发给客户
                //  有接收客户，且接收客户不是我
                //客户发给我
                //  有发送客户，且发送客户不是我
                //我发给商家
                //  其他
                
                
                
                var flag = false;
                // 最近消息只有一条即只有商家消息
                if (data.length == 1 && !data[0].SENDID && !data[0].RCPTID) {
                    sqlStr += "AND [SENDID] IS NULL AND [RCPTID] IS NULL ";
                } else { // 和专家有聊天记录
                    var sendidStr = "";//专家发送给当前用户
                    var rcptidStr = "";//当前用户发送给专家
                    var sendpidStr = "";//用户发送给我的
                    var rcptpIdStr = "";//我发送给用户的
                    var flag1 = false;
                    var flag2 = false;
                    var flag3 = false;
                    var flag4 = false;
                    array.forEach(data, function(item, index) {
                        if (!item.SENDID && !item.RCPTID && !(item.SENDPID&&item.RCPTPID)) {
                            //没有SENDID且没有RCPTID且SENDPID和RCPTPID只存在一个则为商家消息
                            flag = true;
                            return;
                        } else if (item.SENDID) {
                            //专家发的消息
                            if (sendidStr.length === 0) {
                                flag1 = true;
                                sendidStr += "[SENDID] IN (" + item.SENDID + ",";
                            } else {
                                sendidStr += item.SENDID + ",";
                            }
                        } else if(item.RCPTID){
                            //发给专家的消息
                            if (rcptidStr.length === 0) {
                                flag2 = true;
                                rcptidStr += "[RCPTID] IN (" + item.RCPTID + ",";
                            } else {
                                rcptidStr += item.RCPTID + ",";
                            }
                        } else if(item.SENDPID&&(item.RCPTPID == this.PID)){
                            //消费者发给我的消息
                            if (sendpidStr.length === 0) {
                                flag3 = true;
                                sendpidStr += "[SENDPID] IN (" + item.SENDPID + ",";
                            } else {
                                sendpidStr += item.SENDPID + ",";
                            }
                        } else if(item.RCPTPID&&(item.SENDPID == this.PID)){
                            //我发送给消费者的消息
                            if (rcptpIdStr.length === 0) {
                                flag2 = true;
                                rcptpIdStr += "[RCPTPID] IN (" + item.RCPTPID + ",";
                            } else {
                                rcptpIdStr += item.RCPTPID + ",";
                            }
                        }
                    });
                    if (flag1) {
                        sqlStr += " AND (" + sendidStr.substring(0, sendidStr.length - 1) + ")";
                    }
                    if (flag2) {
                        if (sqlStr.substring(sqlStr.length-2) === ") ") {
                            sqlStr += " AND (" + rcptidStr.substring(0, rcptidStr.length - 1);
                        } else {
                            sqlStr += " OR " + rcptidStr.substring(0, rcptidStr.length - 1);
                        }
                        sqlStr += ") ";
                    }
                    if(flag3){
                        sqlStr += " AND (" + sendpidStr.substring(0, sendpidStr.length - 1) + ")";
                    }
                    if(flag4){
                        sqlStr += " AND (" + rcptpIdStr.substring(0, rcptpIdStr.length - 1) + ")";
                    }
                    if (flag) {
                        sqlStr += "OR [SENDID] IS NULL AND [RCPTID] IS NULL ";
                    }
                    sqlStr += ") ";
                }*/
                xhr("GET", {
                    url: g_sys_info.url_usr,
                    handleAs: "json",
                    error: function(data) {
                    },
                    load: lang.hitch(this, function(dt) {
                        // 只有接受的消息才有未读消息数量
                        dt = this.fltSendDts(dt);
                        var messCount = query(".messCount", this.domNode);
                        if (dt && dt.length) {
                            var m = 0;
                            messCount.forEach(function(item, index) {
                                if (dt[m] && (dt[m].SENDID === data[index].SENDID.T0_UID || !dt[m].SENDID && !data[index].SENDID.T0_UID)) {
                                    messCount[index].innerHTML = dt[m].SENDDATE;
                                    m++;
                                }else if(dt[m] && (dt[m].SENDPID && data[index].SENDPID.PartnerID) && (dt[m].SENDPID === data[index].SENDPID.PartnerID)){
                                    messCount[index].innerHTML = dt[m].SENDDATE;
                                    m++;
                                }
                            });
                        }
                    }),
                    sync: false,
                    preventCache: true,
                    content: {
                        modalName: "XSY_TSSUS_MSG_LIST",
                        pageSize: this.pageSize,
                        pageIndex: this.curPageIndex || 1,
                        orderBy: "max([MESSID]) DESC",
                        groupBy: "[SENDID],[RCPTID],[SENDPID],[RCPTPID]",
                        egg: "[SENDDATE]:count",
                        appId: window.g_sys_info.aid,
                        where: sqlStr
                    }
                });
            }
        },
        // 获取未读消息，通过发送人分组，取得每个发送人的最近的一条消息,统计未读消息数量
        loadDataFun: function(hasLogin) {
            this._loadConverseListData(hasLogin).then(lang.hitch(this,function(data){
                this._loadLastMsg(data).then(lang.hitch(this,function(dt){
                    //统计未读消息数量
                    this._loadAndRefreshNum(dt);
                    this.conversList.onDataReady(dt);
                }));
            }));
        },
        fltSendDts: function(dts) {
            // 专家有回复
            var sends = array.filter(dts.data.items, function(data) {
                return data.SENDID;
            });
            // 所有我发给专家
            // var receives = array.filter(dts.data.items, function(data) {
            //     return data.RCPTID;
            // });
            // 非专家，商家
            var admin = array.filter(dts.data.items, function(data) {
                return (!data.SENDID) && (!data.RCPTID) && !(data.SENDPID && data.RCPTPID);
            });
            //消费者回复给我
            var psends = array.filter(dts.data.items, function(data) {
                return data.SENDPID&&(data.RCPTPID == this.pid);
            },this);
            return sends.concat(admin).concat(psends);
        },
        //去除同一对象的多条消息,保留最新的一条
        fltDts: function(dts) {
            // 专家有回复
            var sends = array.filter(dts.data.items, function(data) {
                return data.SENDID;
            });
            // 通过SENDID倒序排列
            sends = sends.sort(function(item1, item2){
                return item2.SENDID - item1.SENDID;
            });
            // 所有我发给专家的
            var receives = array.filter(dts.data.items, function(data) {
                return data.RCPTID;
            });
            // 通过RCPTID倒序排列
            receives = receives.sort(function(item1, item2){
                return item2.RCPTID - item1.RCPTID;
            });
            // 非专家，商家
            var admin = array.filter(dts.data.items, function(data) {
                return (!data.SENDID) && (!data.RCPTID) && !(data.SENDPID && data.RCPTPID);
            });
            //消费者有回复
            var psends = array.filter(dts.data.items, function(data) {
               return data.SENDPID&&(data.RCPTPID == this.pid);
            },this);
            // 通过SENDPID倒序排列
            psends = psends.sort(function(item1, item2){
                return item2.SENDPID - item1.SENDPID;
            });
            // 所有我发给消费者的
            var preceives = array.filter(dts.data.items, function(data) {
                return (data.SENDPID == this.pid)&&data.RCPTPID;
            },this);
            // 通过RCPTID倒序排列
            preceives = preceives.sort(function(item1, item2){
                return item2.RCPTPID - item1.RCPTPID;
            });
            //?
            //sends和receives中，如果有同一个专家，则将MESSID大的保留
            var expMsgs = [];
            if(!sends || sends.length === 0){
                expMsgs = receives || [];
            }else if(!receives || receives.length === 0){
                expMsgs = sends;
            }else{
                var i = 0;//i用于标记sends数组下标
                // 发送数量必然多于或者等于接收数量, 
                // RCPTID 始终大于或者等于 SENDID
                for(var index = 0;index < receives.length;index++){
                    if(!sends[i]){
                        expMsgs[expMsgs.length] = receives[index];
                    }else if(receives[index].RCPTID > sends[i].SENDID){
                        expMsgs[expMsgs.length] = receives[index];
                    }else if(receives[index].RCPTID == sends[i].SENDID){
                        expMsgs[expMsgs.length] = (receives[index].MESSID > sends[i].MESSID) ? receives[index] : sends[i];
                        i++;
                    }else{
                        expMsgs[expMsgs.length] = sends[i++];
                    }
                }
            }
            //psends和preceives中，如果有同一个用户，则将MESSID大的保留
            var pexpMsgs = [];
            if(!psends || psends.length === 0){
                pexpMsgs = preceives || [];
            }else if(!preceives || preceives.length === 0){
                pexpMsgs = psends;
            }else{
                //i用于标记sends数组下标
                // 发送数量必然多于或者等于接收数量, 
                // RCPTID 始终大于或者等于 SENDID
                // for(var index = 0;index < preceives.length;index++){
                //     if(!psends[i]){
                //         pexpMsgs[pexpMsgs.length] = preceives[index];
                //     }else if(preceives[index].RCPTPID > psends[i].SENDPID){
                //         pexpMsgs[pexpMsgs.length] = preceives[index];
                //     }else if(preceives[index].RCPTPID == psends[i].SENDPID){
                //         pexpMsgs[pexpMsgs.length] = (preceives[index].MESSID > psends[i].MESSID) ? preceives[index] : psends[i];
                //         i++;
                //     }else{
                //         pexpMsgs[pexpMsgs.length] = psends[i++];
                //     }
                // }
                // //
                //psends 其它用户发给我的,preceives我发给其它用户的
                if(psends.length<=preceives.length){
                    var i = 0;
                    for(var index = 0;index < preceives.length;index++){
                        if(!psends[i]){
                            pexpMsgs[pexpMsgs.length] = preceives[index];
                        }else if(preceives[index].RCPTPID > psends[i].SENDPID){
                            pexpMsgs[pexpMsgs.length] = preceives[index];
                        }else if(preceives[index].RCPTPID == psends[i].SENDPID){
                            pexpMsgs[pexpMsgs.length] = (preceives[index].MESSID > psends[i].MESSID) ? preceives[index] : psends[i];
                            i++;
                        }else{
                            pexpMsgs[pexpMsgs.length] = psends[i++];
                        }
                    }
                }else{
                    var i=0;
                    for(var index = 0;index < psends.length;index++){
                        if(!preceives[i]){
                            pexpMsgs[pexpMsgs.length] = psends[index];
                        }else if(psends[index].SENDPID > preceives[i].RCPTPID){
                            pexpMsgs[pexpMsgs.length] = psends[index];
                        }else if(psends[index].SENDPID == preceives[i].RCPTPID){
                            pexpMsgs[pexpMsgs.length] = (psends[index].MESSID > preceives[i].MESSID) ? psends[index] : preceives[i];
                            i++;
                        }else{
                            pexpMsgs[pexpMsgs.length] = preceives[i++];
                        }
                    }
                    
                }
            }
            // 通过MESSID排序,倒序
            dts.data.items = expMsgs.concat(admin).concat(pexpMsgs).sort(function(item1, item2) {
                return item2.MESSID - item1.MESSID;
            });
            return dts;
        },
        refreshAllList: function() {
            userInfo.hasLogin().then(lang.hitch(this, function(s) {
                this.loadDataFun(s);
            }));
            this.inherited(arguments);
        }
    });
});