define([
    "dojo/_base/declare",
    "dojo/dom-attr",
    "dijit/registry",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/_base/lang"
    ], function(declare, domAttr, registry, array, domAttr, lang) {
    return declare("widgets.common._CountyListMixin", null, {
        isEnterpriseLoaded: function() {
            return !!this.currentCounty;
        },
        indexCountyElement: function() {
            this.currentCounty = registry.byId("distList1");
        },
        initCountyListEvent: function() {
            this.connect(this.currentCounty.domNode, "onclick", function(e) {
                var dom = e.target;
                while (dom && "li" !== dom.tagName.toLowerCase() && dom != this.currentCounty) {
                    dom = dom.parentNode;
                }
                if (dom && dom.tagName.toLowerCase() == "li" && dom != this.currentCounty) {
                    var distid = domAttr.get(dom, "distid");
                    if (distid) {
                        //依据区划ID到货主区划表中寻找对应的货主AID
                        window.loadData({
                            modalName: "XSY_TBSAV_DISTAPP",
                            filter: "01",
                            pageSize: 1,
                            pageIndex: 1,
                            param: {
                                "DISTID": distid,
                                "TYPEID": 1
                            }
                        }).then(lang.hitch(this, function(datas) {
                            if(datas.length == 0){
                                alert("该区域暂未提供服务。");
                                return;
                            }
                            this.app_id = datas.length ? datas[0].APP_ID : g_sys_info.aid;
                            //取得当前区划等级，4为县，5为镇
                            this.distLevel = datas[0]["DISTID.Level"];
                            if (this.distLevel == 4) {
                                window.moveToView("countyMain", this.app_id);
                            } else if(this.distLevel == 5){
                                window.moveToView("townMain", this.app_id);
                            }else{
                                window.moveToView("villageMain",this.app_id);//乡村级
                            }
                        }));
                    }
                }
            });
        },
        refreshAllList: function() {
            if (window.did != this.did) {
                this.did = window.did;
                this.currentCounty.refreshList();
            }
        }
    });
});