define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/query",
    "dojo/_base/array",
    "dojo/dom-style",
    "dojo/dom-class",
    "cqthink/app/plugins/geolocation",
     "dojo/Deferred"
    ], function(declare,lang,registry,domAttr,query,array,domStyle,domClass,location,Deferred) {
    return declare("widgets.common._DeptList_Mixin", null, {
        isDeptListLoaded:function(){
            return !!this.dpList;
        },
        refreshAllList:function(){
            //查AID 如果是SVC11105，platform；如果不是
            //aid === 40786 platform=40786; appid = aid
            this.depParam={"PLATFORM":"","APPID":"","DP":"","DC":"","DX":"","APPTITLE":"","LAT":"","LON":"","DISTANCE":"","BIZID":""};
            this.depParam.DC=localStorage.cityID||"";
            /*
            PLATFORM:平台参数(不用传具体的值，数据库会自动匹配对应的AID参数)
            APPID：商家
            DP：省
            DC：市
            DX：区
            APPTITLE：商家部门名称
            LAT：维度
            LON：经度
            DISTANCE：距离
            BIZID：商圈
            **/
            
            /*window.loadData({
                modalName: "XSY_TSSCF_APP2",
                filter: "09",
                pageSize: "100",
                pageIndex: "1",
                param: {
                    AID:window.g_sys_info.aid
                } 
            }).then(lang.hitch(this,function(data){*/
                
            window.isPlatform().then(lang.hitch(this,function(result){
                var groupID="";
                this.IsPlatform=result;
                if(this.IsPlatform){
                    this.depParam.PLATFORM=window.g_sys_info.aid;
                }
                else{
                    this.depParam.APPID=window.g_sys_info.aid;
                }
                
                if(window.did!=""&&window.did.indexOf('srv_')>=0){
                this.depParam.APPID=window.did;
                }
                //获取当前位置信息
                this.getPosition();
                
                //引入高德地图插件
                if(window.AMap){
                    AMap.service('AMap.Geocoder',function(){//回调函数
                        window.geocoder = new AMap.Geocoder({
                            city: "010"//城市，默认：“全国”
                        });
                    });
                }
                
                // 是平台
                if(result) {
                    // 不存在cityID
                    if(!localStorage.cityID) {
                        // 强制显示 城市选择列表
                        moveToView("chooseCity");
                        return;
                    }
                    this.refreshDep_Dis_HotList();
                } else {
                    // 是商家
                    
                    // 不存在cityID
                    // if(!localStorage.cityID) {
                    //     get_XSY_TSSCF_APP_PUBLIC().then(lang.hitch(this, function(data) {
                    //         localStorage.cityID=data["D_C.DistID"];
                    //         this.depParam.DC=localStorage.cityID||"";
                    //         if(data["D_C.DistName"].indexOf("辖区") !== -1) {
                    //             data["D_C.DistName"] = data["D_C.DistName"].substr(0,data["D_C.DistName"].length - 2);
                    //         }
                    //         localStorage.setItem("business" + localStorage.cityID, data["D_C.DistName"]);
                    //         this.refreshDep_Dis_HotList();
                    //     }));
                    // }
                    
                    // 将之前无效的对象删除
                    if(localStorage.cityID) {
                        localStorage.removeItem("business" + localStorage.cityID);
                    }
                    // 为了防止 在打开页面的情况下 商家端直接多次修改省市信息 SO:每次都要执行此方法
                    window.getPublicAppInfo().then(lang.hitch(this, function(data) {
                        localStorage.cityID=data["D_C.DistID"];
                        this.depParam.DC=localStorage.cityID||"";
                        if(data["D_C.DistName"].indexOf("辖区") !== -1) {
                            data["D_C.DistName"] = data["D_C.DistName"].substr(0,data["D_C.DistName"].length - 2);
                        }
                        localStorage.setItem("business" + localStorage.cityID, data["D_C.DistName"]);
                        this.refreshDep_Dis_HotList();
                    }));
                }
                this._closeNavDropDownItem();
            }));
        },
        refreshDep_Dis_HotList: function(){
            //刷新门店列表
            this.depOrder={};
            this.dpList.rs_wb_param="("+JSON.stringify(this.depParam)+")";
            window.busy();
            this.dpList.refreshList();
            window.free();
            
            //刷新行政区列表
            this.districtList.rs_wb_param="({DID:"+localStorage.cityID+"})";
            this.districtList.refreshList();
            
            //刷新商圈
            this.hotArea.rs_wb_param="({'D_C':"+localStorage.cityID+"})";
            this.hotArea.refreshList();
        },
        indexDeptListElement:function(){
            if(!this.isDeptListLoaded())
            {
               this.dpList= registry.byId("dpList");     //门店列表
            }
            this.topUl=query("#topUl",this.domNode)[0];  //顶部UL
            this.topUl_li=query("li",this.topUl);        //顶部li
            this.nav_dropdown_items = query(".nav_dropdowm_item", this.domNode);  //子菜单集合
            
            this.nav_dropdowm = query(".nav_dropdowm", this.domNode)[0];          //子菜单
            this.nav_dropdownbg = query(".nav_dropdownbg", this.domNode)[0];      //子菜单空白地方
            this.subAreaScroll=query("#subAreaScroll",this.domNode)[0];           //二级菜单
            this.sortUl=query("#sortUl",this.domNode)[0];                         //排序
            this.SearchTxt=query(".searchExpert",this.domNode)[0];                             //搜索
            
            //List2集合
            this.districtList=registry.byId("districtList");   //行政区子菜单
            this.hotArea=registry.byId("hotArea");             //热门商圈
            this.districtBIZD=registry.byId("districtBIZD");        //行政区商圈
            
            
            //顶部菜单移动到头部模板中去，解决列表滑动问题
            var search=query(".m-list-0",this.domNode)[0];
            this.shelfHeader=query(".shelfHeader",this.domNode)[0];
            this.shelfHeader.appendChild(search);
            
            var head=query(".m-list-1",this.domNode)[0];
            this.shelfHeader.appendChild(head);
            var show=query(".locationText",this.domNode)[0];
            this.shelfHeader.appendChild(show);
        },
        initDeptListEvent:function(){
            this.connect(this.dpList,"onDefRendered",function(data){
                if(data.data.items.length>0)
                {
                    array.forEach(data.data.items,function(item,index)
                    {
                        item.distance="";
                        if(item.T0_D_LAT!=""&&item.T0_D_LON!=""&&window.position)
                        {
                            //利用经纬度计算距离
                            item.distance=parseInt(location.getDistance(window.position.coords.latitude,window.position.coords.longitude,parseFloat(item.T0_D_LAT),parseFloat(item.T0_D_LON)))+"米";
                        }
                        if(window.did.indexOf('srv')>-1)
                        {
                            item.href="matList";
                            item.param="srvDept_"+item.T0_AID.APP_ID+"_"+item.T0_DeptID;
                        }
                        else if(window.did.indexOf('aid')>-1)
                        {
                            item.href="matList";
                            item.param="aid_"+item.T0_AID.APP_ID;
                        }
                        else
                        {
                            item.href="deptDetail";
                            item.param=item.T0_DeptID;
                        }
                    })
                }
            });
            
            //返回的全部商圈
            this.connect(this.hotArea,"onDefRendered",function(data){
                if(data&&data.data&&data.data.items && !this._groupHash){
                    //初始化行政区商圈信息
                    this._groupHash = {};
                    var hotBizd=[];
                    var len = data.data.items.length;
                    while(len--){        //遍历所有商圈
                        this._groupHash[data.data.items[len].UpDistID.DistID] = this._groupHash[data.data.items[len].UpDistID.DistID]||[];
                        //将本商圈添加到行政区商圈信息中
                        this._groupHash[data.data.items[len].UpDistID.DistID].push(data.data.items[len]);
                    }
                   //前10商圈
                    data.data.items.splice(10,data.data.items.length-10);
                }
            });
            
            //门店点击事件
            this.connect(this.deList,"onclick",function(event){
                var dom=event.target;
                //if(event&&event.target&&event.target.)
                //点击门店链接到...
            });
            
            //顶部菜单的点击事件
            if(this.topUl){
                this.connect(this.topUl,"onclick",lang.hitch(this,this._navUlClicked));
            }
            //子菜单空白区域点击事件
            this.connect(this.nav_dropdownbg, "onclick", lang.hitch(this, this._closeNavDropDownItem));
            
            //一级菜单
            this.connect(this.districtList.domNode, "onclick", lang.hitch(this, function(evt){
                var dom = evt.target;
                if(dom.tagName=="LI")
                {
                    var fujin=domAttr.get(dom,"fujin");
                    var hArea=domAttr.get(dom,"hotarea");
                    var areaId=domAttr.get(dom,"areaid");
                    var dropIndex=parseInt(domAttr.get(dom,"dropindex"));
                    
                    var secondMenuList=query("ul",query("#subAreaScroll",this.domNode)[0]);
                    
                    //隐藏所有二级显示菜单
                    array.forEach(secondMenuList,function(item,index){
                        if(dropIndex==index){
                            domStyle.set(secondMenuList[index],{display:"block"})
                        }
                        else{
                            domStyle.set(secondMenuList[index],{display:"none"})
                            array.forEach(query("li",secondMenuList[index]),function(item){
                                domClass.remove(item,"beSelected");
                            });
                        }
                    });
                    
                    if(fujin=="1"){         //附近   一级
                       //domAttr.set(query("li",this.districtBIZD.domNode)[0],"t_c",areaId);
                    }
                    else if(hArea=="1"){   //热门商圈   一级
                        domAttr.set(query("li",this.hotArea.domNode)[0],"cityBzid",this.cityId);
                    }
                    else if(areaId!=""){   //行政区   一级
                        if(this._groupHash[areaId]){
                            this.districtBIZD.onDataReady({
                                data:{items:this._groupHash[areaId]}
                            });
                        } else {
                            // 如果行政区 没有商圈
                            this.districtBIZD.onDataReady({
                                data:{items:[]}
                            });
                        }
                        domAttr.set(query("li",this.districtBIZD.domNode)[0],"t_c",areaId);
                    }
                    
                    array.forEach(query("ul>li",this.districtList.domNode),function(item){
                         domClass.remove(item, "beSelected");
                         domClass.remove(item,"cur");
                         domStyle.set(item,{"border-top":"0px"});
                    });
                    domAttr.set(dom,"class","beSelected");
                    domClass.add(event.target,"cur");
                    domStyle.set(event.target,{"border-top":"1px solid white"})
                    evt.stopPropagation();  //阻止事件冒泡
                }
            }));
            
            //二级菜单
            this.connect(this.subAreaScroll,"onclick",lang.hitch(this,function(event){
                var dom=event.target;
                if(dom.tagName=="LI")
                {
                    var area_distance=domAttr.get(dom,"area_distance");
                    var cityBzid=domAttr.get(dom,"cityBzid");
                    var t_c=domAttr.get(dom,"t_c");
                    var districtId=domAttr.get(dom,"districtId");
                    //更改顶部菜单的文字
                    query(".depTopUL>li.beSelected",this.domNode)[0].innerText=dom.innerText;
                    if(area_distance&&area_distance!=""){        //距离500米，1000米... 
                        this.orderByDistance();
                        this.depParam.DISTANCE="";
                        if(area_distance!="fujin"){
                            this.depParam.DISTANCE=area_distance;
                        }
                        this.depParam.DX="";
                        this.depParam.BIZID="";
                        this.dpList.rs_wb_param="("+JSON.stringify(this.depParam)+")";
                        window.busy();
                        this.dpList.refreshList();
                        window.free();
                    }
                    else if(cityBzid&&cityBzid!=""){            //全部  热门商圈
                        this.orderByDistance();
                        this.depParam.DISTANCE="";
                        this.depParam.BIZID="";
                        this.depParam.DX="";
                        this.dpList.rs_wb_param="("+JSON.stringify(this.depParam)+")";
                        window.busy();
                        this.dpList.refreshList();
                        window.free();
                    }
                    else if(t_c&&t_c!=""){                     //全部  行政区商圈
                        //更改菜单栏标题
                        query(".depTopUL>li.beSelected",this.domNode)[0].innerText=query("ul>li.beSelected",query("#districtList",this.domNode)[0])[0].innerText;
                        
                        this.orderByDistance();
                        this.depParam.DISTANCE="";
                        this.depParam.DX=t_c;
                        this.depParam.BIZID="";
                        this.dpList.rs_wb_param="("+JSON.stringify(this.depParam)+")";
                        window.busy();
                        this.dpList.refreshList();
                        window.free();
                    }
                    else if(districtId&&districtId!=""){        //商圈
                        this.orderByDistance();
                        this.depParam.BIZID=districtId;
                        this.depParam.DISTANCE="";
                        var dis=domAttr.get(query("li",dom.parentNode)[0],"t_c");
                        this.depParam.DX=dis||"";
                        this.dpList.rs_wb_param="("+JSON.stringify(this.depParam)+")";
                        window.busy();
                        this.dpList.refreshList();
                        window.free();
                    }
                    array.forEach(query("li",dom.parentNode),function(item){
                        domClass.remove(item, "beSelected");
                    });
                   domAttr.set(dom,"class","beSelected");
                   this._closeNavDropDownItem();
                }
            }));
            
            
            this.connect(this.sortUl,"onclick",function(event){
                if(event&&event.target&&event.target.tagName=="LI"){
                    var wborder=domAttr.get(event.target,"wborder");
                    if(wborder=="distance"){                          //按距离排序
                        this.orderByDistance();
                        this.dpList.rs_wb_param="("+JSON.stringify(this.depParam)+")";
                        
                        window.busy();
                        this.dpList.refreshList();
                        window.free();
                    }
                    else if(wborder=="sale"){                         //按销量排序
                        
                    }
                    else if(wborder=="eval"){                         //按评价排序
                        
                    }
                    else if(wborder=="IntelligentSorting"){           //智能排序
                        this.orderByDistance();
                        this.dpList.rs_wb_param="("+JSON.stringify(this.depParam)+")";
                        window.busy();
                        this.dpList.refreshList();
                        window.free();
                    }
                    var sortList=query("ul>li",query("#sortUl",this.domNode)[0]);
                    array.forEach(sortList,function(item,index){
                        domClass.remove(item,"beSelected");
                    })
                    //更改菜单栏标题
                    query(".depTopUL>li.beSelected",this.domNode)[0].innerText=event.target.innerText;
                    
                    domClass.add(event.target, "beSelected");
                    this._closeNavDropDownItem();
                    event.stopPropagation();  //阻止事件冒泡
                }
            })
            
             //搜索框的ENTER事件
            this.connect(this.SearchTxt,"onkeydown",function(e){
                if(e.keyCode==13){
                    this.searchEvent();
                }
            });
            
            //取消搜索
            this.connect(query(".cancel",this.domNode)[0],"onclick",function(){
                this.SearchTxt.value="";
                this.depParam.APPTITLE="";
                this.dpList.rs_wb_param="("+JSON.stringify(this.depParam)+")";
                window.busy();
                this.dpList.refreshList();
                window.free();
            });
            
            //点击搜索
            this.connect(this.SearchTxt,"onclick",function(){
                this._closeNavDropDownItem();
            });
            
            //显示定位信息
            this.connect(query(".location",this.domNode)[0],"onclick",function(event){
                query(".locationText>p.show",this.domNode)[0].innerText="正在定位...";
                domStyle.set(query(".locationText>p.location",this.domNode)[0],{display:"none"});
                this.getPosition();
                event.stopPropagation(); 
            });
            
        },
        //顶部菜单点击方法
         _navUlClicked: function(e){
            var dom = e.target;
            
            // 判断事件源是否是导航栏前4个li元素
            if(dom.tagName === "LI" && !domClass.contains(dom, "beSelected") && !domClass.contains(dom, "changeViewLi")){
                
                // 先清除上次点击的li元素的beSelected类
                array.forEach(this.topUl_li, function(nthLi){
                    domClass.remove(nthLi, "beSelected");
                });
                
                // 为当前事件源添加beSelected
                domClass.add(dom, "beSelected");
                
                // 隐藏上一次显示的div，并显示本次事件源所对应的div
                array.forEach(this.nav_dropdown_items, function(item, index){
                    if(index == domAttr.get(dom,"dropindex")){
                        domStyle.set(item,{display:"block"});
                    }else{
                        domStyle.set(item,{display:"none"});
                    }
                });
                domStyle.set(this.nav_dropdownbg, {display: "block"});
                domStyle.set(this.nav_dropdowm, {display: "block"});
            }
            // registry.byId("subAreaScroll").scrollTo({x:0,y:0});//解决scrollablePane初始位置的问题
        },
       // 关闭弹出层方法
        _closeNavDropDownItem:function(itemIndex){
            domStyle.set(this.nav_dropdowm, {display:"none"});
            domStyle.set(this.nav_dropdownbg, {display:"none"});
            array.forEach(this.topUl_li, function(nthLi){
                domClass.remove(nthLi, "beSelected");
            });
        },
        //按距离排序
        orderByDistance:function(){
            if(window.position&&window.position.coords){
                this.depParam.LAT=""+window.position.coords.latitude+"";
                this.depParam.LON=""+window.position.coords.longitude+"";
                this.dpList.rs_wb_order="DBO.fnGetDistance(ISNULL([T0_D_LAT],0),ISNULL([T0_D_LON],0),"+window.position.coords.latitude+","+window.position.coords.longitude+")";
            }
            else{
                this.depParam.LAT="";
                this.depParam.LON="";
                this.dpList.rs_wb_order="";
            }
        },
        
        //定位
        getPosition:function(){
            location.getCurrentPositionQuiet().then(lang.hitch(this,function(data){
               //是否定位成功
                var isPosition=false;
                if (data.coords) {
                       window.position=data;
                       if(window.position&&window.position.coords){
                            //alert(window.position.coords.latitude+","+window.position.coords.longitude);
                            this.orderByDistance();
                           // this.dpList.rs_wb_order="DBO.fnGetDistance(ISNULL([T0_D_LAT],0),ISNULL([T0_D_LON],0),"+window.position.coords.latitude+","+window.position.coords.longitude+")";
                            this.dpList.rs_wb_param="("+JSON.stringify(this.depParam)+")";
                            window.busy();
                            this.dpList.refreshList();
                            query(".locationText>p.show",this.domNode)[0].innerText="定位成功";
                            window.free();
                            isPosition=true;
                            if(window.geocoder){
                                this.getAddressInfo();
                            }
                       }
                }else{
                    isPosition=false;
                    switch(data.status){
                        case "unknown":
                            if(!parseInt(sessionStorage.getItem("asked"))){
                                if(curView === "deptList") {
                                    alert("暂时无法获取您的位置!");
                                }
                            }
                            break;
                        case "cancel":
                            if(!parseInt(sessionStorage.getItem("asked"))){
                                if(curView === "deptList") {
                                    alert("您阻止了定位!");
                                }
                            }
                            break;
                        case "timeout":
                            if(!parseInt(sessionStorage.getItem("asked"))){
                                if(curView === "deptList") {
                                    alert("获取位置超时!");
                                }
                            }
                            break;
                    }
                    query(".locationText>p.show",this.domNode)[0].innerText="定位失败，重新";
                    domStyle.set(query(".locationText>p.location",this.domNode)[0],{display:"inline"});
                }
                return isPosition;
            }));
        },
        searchEvent:function(){
            if(this.SearchTxt.value=="")
            {
                return false;
            }
            this.depParam.APPTITLE=this.SearchTxt.value;
            this.orderByDistance();
            this.dpList.rs_wb_param="("+JSON.stringify(this.depParam)+")";
            window.busy();
            this.dpList.refreshList();
            window.free();
        },
        getAddressInfo:function(){
             query(".locationText>p.show",this.domNode)[0].innerText="正在获取地址...";
            //逆地理编码
            //alert(window.position.coords.longitude+","+window.position.coords.latitude)
            var lnglatXY=[window.position.coords.longitude,window.position.coords.latitude];
            if(window.geocoder){
                geocoder.getAddress(lnglatXY, function(status, result) {
                    if (status === 'complete' && result.info === 'OK') {
                       query(".locationText>p.show",this.domNode)[0].innerText=result.regeocode.formattedAddress;
                       //domStyle.set(query(".locationText>p.location")[0],{display:"none"});
                    }else{
                       //获取地址失败
                       query(".locationText>p.show",this.domNode)[0].innerText="定位失败，重新";
                       domStyle.set(query(".locationText>p.location",this.domNode)[0],{display:"inline"});
                    }
                }); 
            }
        }
    })
})