define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/xhr",
    "dojo/query",
    "dijit/registry",
    "widgets/userInfo"
],function(declare,lang,xhr,query,registry,userInfo){
    return declare("widgets.common._DisSerList",null,{
        indexDisSerElement:function(){
            this.disSerInput = query(".inp-search",this.domNode)[0];
            this.disOkBtn = query(".clickBtn",this.domNode)[0];
            this.disSerList = registry.byNode(query(".disSerList",this.domNode)[0]);
        },
        initDisSerEvent:function(){
            var pendding = false;
            this.connect(this.disOkBtn,"onclick",function(){
                if(pendding){
                    return;
                }
                var ser = this.disSerInput.value;
                if(ser){
                    pendding = true;
                    setTimeout(function(){
                        pendding = false;
                    },500);
                    xhr("GET",{
                        "url":"/w/user/useSn/"+window.code+"-"+window.openId,
                        handleAs:"json",
                        content:{
                            sn:ser
                        },
                        load:lang.hitch(this,function(result){
                            alert(result.message);
                            this.disSerInput.value = "";
                            if(1===result.rtnType){
                                window.moveToView("user");
                            }
                        }),
                        error:function(){
                            alert("数据错误");
                        }
                    });
                }else{
                    alert("请输入序列号");
                }
            });
        },
        isDisSerListLoaded:function(){
            return !!this.disSerList;
        },
        refreshAllList:function(){
            // 判断用户是否已经登录
            userInfo.hasLogin().then(lang.hitch(this,function(hasLogin) {
                if (hasLogin) {
                    window.partnerId = userInfo.getUserInfo().partnerId;
                    this.disSerList.refreshList();
                } else {
                    window.nextPageOnLogin = "disSerList";
                    // 若没有登录
                    userInfo.showLogin();
                }
            }));
        }
    });
});