define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/registry",
    "dojo/query",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "widgets/userInfo",
    "dojo/Deferred"
], function(declare,lang, registry,query,array,domAttr,domClass,xhr,json,userInfo,Deferred) {
    return declare("widgets.common._EvasListMixin", null, {
        isEvasListLoaded: function() {
            return !!this.newsEvaList;
        },
        indexEvasListElement: function() {
            //this.nList = registry.byId("newsId");
            //this.TOTAL_C_QTY = query(".TOTAL_C_QTY",this.domNode)[0];// 评价数
            //this.TOTAL_P_QTY = query(".TOTAL_P_QTY",this.domNode)[0];// 点赞数
            this.newsEvaList = registry.byNode(query(".news-eva-list",this.domNode)[0]);//评论列表
            //this.eva_TOTAL_P_QTY = query(".eva-TOTAL_P_QTY",this.domNode)[0];// 资讯评论的点赞数
            //this.newsPraBtn = query(".news-praise",this.domNode)[0];//资讯点赞
            this.noEvas = query(".no-evasList",this.domNode)[0];//无评价时的样式
        },
        initEvasListEvent: function() {
            this.connect(this.newsEvaList,"onDefRendered",function(data){
                var items = data.data.items;
                if(items.length)
                {
                    domClass.add(this.noEvas,"hide");
                    array.forEach(items,function(item){
                        item.isPraise = 0;
                        if(window.evaIds&&window.evaIds[item.DID]&&window.evaIds[item.DID]==1)
                        {
                            item.isPraise = 1;
                        }
                    });
                } else {
                    domClass.remove(this.noEvas,"hide");
                }
            });
            this.connect(this.newsEvaList.domNode,"onclick",this.newsEvaListonClick);
        },
        //资讯的每条评论的点赞
        newsEvaListonClick:function(e){
            var dom = e.target,praId;
            while (dom && dom.tagName.toLowerCase() != 'a' && dom != this.domNode) {
                dom = dom.parentNode;
            }
            praId = domAttr.get(dom,"praId");
            if(praId&&praId.split("-")[0] == "praise"){//处理资讯的每条评论的点赞和取消点赞
                this.priaseFuc(dom,praId.split("-")[1]);
            }
        },
        priaseFuc:function(dom,did){
            if(this.isBusy){
                return;
            } else {
                this.isBusy = true;
            }
            //如果已经点赞 则remove news-prasied样式，否则加上该样式
            if(domClass.contains(dom,"news-prasied")||domClass.contains(query(".praise-"+did,this.domNode)[0],"news-prasied")){
                domClass.remove(dom,"news-prasied")||domClass.remove(query(".praise-"+did,this.domNode)[0],"news-prasied");
            } else {
                domClass.add(dom,"news-prasied");
            }
            /*window.loadData({
                modalName: "NY_TBSAV_PRAISE", //加载点赞资源
                filter: "05",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "DID":did
                }
            }).then(lang.hitch(this,function(data){*/
            xhr("POST",{
                url:"/w/order/praise/" + window.code,
                handleAs: "json",
                content:{
                    RID:"NY_TBSAV_NEWS_CMMNT",
                    RIID:did,
                    P_FIELD:"TOTAL_P_QTY",
                    KEY_ID:"DID"
                },
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        if(domClass.contains(dom,"news-prasied")){
                            domAttr.set(query(".praise-"+did,this.domNode)[0],"src","../../Content/standardTmp01/images/praise03.png");
                            var n = parseFloat(query(".eva-TOTAL_P_QTY_"+did,this.domNode)[0].innerHTML);
                            query(".eva-TOTAL_P_QTY_"+did,this.domNode)[0].innerHTML = n+1;
                            this.isBusy = false;
                        } else {
                            domAttr.set(query(".praise-"+did,this.domNode)[0],"src","../../Content/standardTmp01/images/praise01.png");
                            var n = parseFloat(query(".eva-TOTAL_P_QTY_"+did,this.domNode)[0].innerHTML);
                            query(".eva-TOTAL_P_QTY_"+did,this.domNode)[0].innerHTML = n-1;
                            this.isBusy = false;
                        }
                        //刷新点赞按钮的显示
                        //this.loadEvaPraData(did);
                        this.isBusy = false;
                        //window.free();
                    } else {
                        alert(result.message || "数据错误!");
                        this.isBusy = false;
                       // window.free();
                    }
                })
            });
            //}));
        },
        refreshAllList: function() {
            /*if (window.did != this.did) {
                this.did = window.did;
                // 加载资讯评论点赞数据
                this.loadEvaPraData().then(lang.hitch(this,function(){
                    this.newsEvaList.refreshList();
                    setTimeout(lang.hitch(this,function(){
                        this.resize();
                    }),500);
                }));
            } else {
                window.updateTitle(this.mGroupName);
            }*/
            if(this.isEvasListLoaded){
                // 加载资讯评论点赞数据
                this.loadEvaPraData().then(lang.hitch(this,function(){
                    //刷新评论列表
                    this.newsEvaList.refreshList();
                }));
            }
        },
        //资讯的每条评论的点赞图标
        loadEvaPraData:function(){
            var def = new Deferred();
            window.loadData({
                modalName: "NY_TBSAV_PRAISE", //加载资讯评论资源
                filter: "06",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "RID":"NY_TBSAV_NEWS_CMMNT",
                    "PID":userInfo.getUserInfo().partnerId
                }
            }).then(lang.hitch(this,function(evaPraiseData){
                window.evaIds = {};
                array.forEach(evaPraiseData,function(item){
                    window.evaIds[item.RIID] = 1;
                });
                def.resolve();
            }));
            return def;
        }
    });
});