define([
    "dojo/_base/declare", 
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/query",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom-style",
    "widgets/userInfo",
], function(declare, registry,domAttr,query,array,lang,domStyle,userInfo) {
    return declare("widgets.common._ExpList_sjmd",null,{
        isExpList_sjmdLoaded:function(){
            return !!this.expList;
        },
        /*
         *  1.this.sorting:排序
         *  2.this.expertsCategory:专家类别ID
         *  3.this.searchExpert:专家姓名
         */
        refreshAllList:function(){
            window.updateTitle("专家列表");
            window.hasMessageCount();
            //综合条件
            if(this.sorting){
                if(this.expertsCategory){
                    /* 1 2 3 */
                    if(this.searchExpert){
                        //1
                        if(this.sorting === "[T0_EmpCode]") {
                            this.expList.rs_wb_order = "";
                        } else {
                            this.expList.rs_wb_order = "CAST([T6_ExpertEvaluation] AS INT) DESC";
                        }
                        //2 3
                        this.expList.rs_wb_flt = "05";
                        this.params = {"MGID":this.expertsCategory,"INPUT":this.searchExpert};
                        this.expList.rs_wb_param="("+JSON.stringify(this.params)+")";
                    } else {
                        /* 1 2 */
                        //1
                        if(this.sorting === "[T0_EmpCode]") {
                            this.expList.rs_wb_order = "";
                        } else {
                            this.expList.rs_wb_order = "CAST([T6_ExpertEvaluation] AS INT) DESC";
                        }
                        //2
                        this.expList.rs_wb_flt = "03";
                        this.expList.rs_wb_param="("+JSON.stringify({"MGID":this.expertsCategory})+")";
                    }
                } else if(this.searchExpert) {
                    /* 1 3 */
                    //1
                    if(this.sorting === "[T0_EmpCode]") {
                        this.expList.rs_wb_order = "";
                    } else {
                        this.expList.rs_wb_order = "CAST([T6_ExpertEvaluation] AS INT) DESC";
                    }
                    //3
                    this.expList.rs_wb_flt = "04";
                    this.expList.rs_wb_param="("+JSON.stringify({"INPUT":this.searchExpert})+")";
                } else {
                    /* 1 */
                    if(this.sorting === "[T0_EmpCode]") {
                        this.expList.rs_wb_order = "";
                    } else {
                        this.expList.rs_wb_order = "CAST([T6_ExpertEvaluation] AS INT) DESC";
                    }
                }
            } else if(this.expertsCategory) {
                if(this.searchExpert){
                    /* 2 3 */
                    //非1
                    this.expList.rs_wb_order = "";
                    //2 3
                    this.expList.rs_wb_flt = "05";
                    this.params = {"MGID":this.expertsCategory,"INPUT":this.searchExpert};
                    this.expList.rs_wb_param="("+JSON.stringify(this.params)+")";
                } else {
                    /* 2 */
                    //非1
                    this.expList.rs_wb_order = "";
                    //2
                    this.expList.rs_wb_flt = "03";
                    this.expList.rs_wb_param="("+JSON.stringify({"MGID":this.expertsCategory})+")";
                }
            } else if(this.searchExpert){
                /* 3 */
                //非1
                this.expList.rs_wb_order = "";
                //3
                this.expList.rs_wb_flt = "04";
                this.expList.rs_wb_param="("+JSON.stringify({"INPUT":this.searchExpert})+")";
            } else {
                //有参数 的默认情况
                if(window.did) {
                    this.expertsCategory = window.did;
                    this.expList.rs_wb_flt = "03";
                    this.expList.rs_wb_param="("+JSON.stringify({"MGID":this.expertsCategory})+")";
                } else {
                    //无查询条件且无参数 全显示
                    this.expList.rs_wb_order = "";
                    this.expList.rs_wb_flt = "01";
                    this.expList.rs_wb_param="("+JSON.stringify({})+")";
                }
            }
            
            this.expList.refreshList(); 
        },
        indexExpList_sjmdElement:function(){
            if(!this.isExpList_sjmdLoaded()){
                this.expList = registry.byId("expertList");
            }
            var head = query(".m-list-1",this.domNode)[0];
            var shelfHeader = query(".shelfHeader",this.domNode)[0];
            shelfHeader.appendChild(query(".m-list-0",this.domNode)[0]);
            shelfHeader.appendChild(query(".black",this.domNode)[0]);
            shelfHeader.appendChild(head);
            setTimeout(function(){
                var headNext = query(".expListDiv",this.domNode)[0];
                shelfHeader.appendChild(headNext);
            },100);
        }
        
    });
});