define([
    "dojo/_base/declare",
    "dojo/dom-attr",
    "dijit/registry",
    "dojo/dom",
    "../userInfo",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/_base/xhr",
    "dojo/_base/json"
    ], function(declare, domAttr, registry, dom, userInfo, array, lang, xhr, json) {
    return declare("widgets.common._ForumPostMixin", null, {
        isForumPostLoaded: function() {
            return !!this.forumPostTitle;
        },
        indexForumPostElement: function() {
            this.titleNode = dom.byId("forumPostTitle");
            this.contentNode = dom.byId("forumPostContent");
            this.postNode = dom.byId("forumPostBtn");
        },
        initForumPostEvent: function() {
            this.connect(this.postNode,"onclick",this.postForum);
        },
        //提交帖子
        postForum:function(){
            window.busy();
            var d = new Date(),
                d = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds(),
                data = {
                    n: {
                        "TOPIC": this.titleNode.value,
                        "CONTENT": this.contentNode.value,
                        "P_ID": userInfo.getUserInfo().partnerId, 
                        "MAKEDATE": d,
                        "TOPICID":window.did
                    }
                };
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    data["n"].P_ID = userInfo.getUserInfo().partnerId;
                    if ((data["n"].TOPIC === "")||data["n"].TOPIC.length < 4) {
                        alert("标题必填，并且标题不能少于4个字")
                        window.free();
                    }else{
                        if (data["n"].CONTENT.length < 4) {
                            alert("内容不能少于4个字");
                            window.free();
                        } else {
                            xhr("POST", {
                                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                                handleAs: "json",
                                content: {
                                    data: json.toJson({
                                        modalName: "XSY_TCRMK_TRAVDTS",
                                        data: [data]
                                    })
                                },
                                load: lang.hitch(this, function(result) {
                                    if (1 === result.rtnType) {
                                        alert("发布成功");
                                        this.refreshAllList();
                                        window.moveToView('forumPostList',window.did);
                                        
                                        window.free();
                                    } else {
                                        alert(result.message || "数据错误!");
                                        window.free();
                                    }
                                })
                            });
                        }
                    }
                }else{
                    alert("请先登录。");
                }
            }));
            
            
        },
        refreshAllList: function() {
            this.contentNode.value = "";
            this.titleNode.value = "";
        }
    });
});