define([
    "dojo/_base/declare",
    "../userInfo",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-attr",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/Deferred",
    "dojo/DeferredList"
], function(declare,  userInfo, registry, query, domAttr, array, json, xhr, lang,domStyle,Deferred,DeferredList) {
    return declare("widgets.common._FriGroupMixin", null, {
        isFriGroupLoaded:function(){
            return !!this.allDynamic;
        },
        indexFriGroupElement: function() {
            //读取关注者信息
            userInfo.getWxInfo().then(lang.hitch(this,function(result){
                if("1"==result.rtnType){
                    this.WXID = result.data.OPENID;
                    this.HEADIMGURL = result.data.HEADIMGURL;
                    this.NICKNAME = result.data.NICKNAME;
                }else{
                    this.ERRMSG = result.message;
                }
            }));
            this.allDynamic = query(".allDynamic", this.domNode)[0];
            this.myDynamic = query(".myDynamic", this.domNode)[0];
            this.myFriend = query(".myFriend", this.domNode)[0];
            this.allDynamic_01 = registry.byId("allDynamic_01");
            this.myDynamic_01 = registry.byId("myDynamic_01");
            this.myFriend_01 = registry.byId("myFriend_01");
            //头部ID
            this.travel = query("#travel", this.domNode)[0];
            //发布按钮
            this.publish=query("#publish",this.domNode)[0];
            //发布内容
            this.WB_input_value = query(".WB_input_value", this.domNode)[0];
        },
        initFriGroupEvent: function() {
            this.connect(this.travel, "onclick", this.travelFuc);
            this.connect(this.publish, "onclick", this.publishFuc);
            //加载页面前数据处理
            this.connect(this.allDynamic_01, "onDefRendered", this.onDefFuc);
            this.connect(this.myDynamic_01, "onDefRendered",  this.onDefFuc);
            //侦听页面list2节点的点击事件
            this.connect(this.allDynamic_01.domNode, "onclick", function(e){
                this.onclickFuc(e,this.allDynamic_01);
            });
            this.connect(this.myDynamic_01.domNode, "onclick", function(e){
                this.onclickFuc(e,this.myDynamic_01);
            });
            this.connect(this.WB_input_value,"onkeyup",function(){
                if(this.WB_input_value.value){
                    domAttr.set(this.publish, "class", "WB_publish_Button");
                }else{
                    domAttr.set(this.publish, "class", "WB_publish_Button_b");
                }
            });
        },
        refreshAllList: function() {
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    domAttr.set(query("#publish")[0], "class", "WB_publish_Button_b");
                    domStyle.set(this.allDynamic,"display","");
                    //this.allDynamic.style.display = "";
                    domAttr.set(query("#allDynamic")[0], "class", "tableLiChecked");
                    domAttr.set(query("#myDynamic")[0], "class", "tableLi");
                    domAttr.set(query("#myFriend")[0], "class", "tableLi");
                    domStyle.set(this.myFriend,"display","none");
                    domStyle.set(this.myDynamic,"display","none");
                    if (window.titleNode) {
                        window.titleNode.innerHTML = "好友圈";
                    }
                    this.allDynamic_01.refreshList();
                    this.myDynamic_01.refreshList();
                }else{
                    userInfo.showLogin();
                    window.nextPageOnLogin = "friendList";
                }
            }));
            
        },
        //加载前页面数据处理函数
        onDefFuc:function(data) {
            var items = data.data.items;
            //定义动态点赞记录变量
            var praWXList = [];
            array.forEach(items, function(item) {
                //判断是否当前人的动态
                //如果是,则不能点击头像
                if (window.wx_openId == item.P_ID.T1_WXID) {
                    item.h = "javascript:void(0);";
                } else {//否则允许点击头像
                    item.h = "#wxconnect-" + window.wx_openId + "&" + item.P_ID.T1_WXID;
                }
                //判断当前人是否点过改行记录的赞
                //若已点,则标记已点样式
                if(item.PRA_CONT.indexOf(window.wx_openId)>-1){
                    item.isPraise = 1;
                }else{//否则标记未点样式
                    item.isPraise = 0;
                }
                //将点赞记录依据;分割
                praWXList = item.PRA_CONT.split(";");
                //设置点赞人的html片段
                item.praWXListStr = "";
                //循环分割后的点击记录数组
                for(var i = 0;i<praWXList.length;i++){
                    //如果该数组项有值,才处理
                    if(praWXList[i]){
                        //将一维数组依据,再次分割,得到二维数组
                        praWXList[i] = praWXList[i].split(",");
                        //如果得到的第一层数组长度大于10,则不再追加html片段,添加更多按钮
                        if(i>=9){
                            item.praWXListStr+="<a class='more' id='praWXList-"+item.DID+"'><i class='ui-icon icon-more'></i></a>";
                            break;
                        }else{//反之,追加html片段
                            if (window.wx_openId == praWXList[i][0]) {//如果得到的点赞人为当前人,则将a标签设置为不可点击
                                item.praWXListStr += "<a href='javascript:void(0);'><img src="+praWXList[i][1]+"/></a>";
                            } else {//否则允许点击头像,并设置链接到与之对话的页面
                                item.praWXListStr += "<a href='#wxconnect-"+window.wx_openId + "&" + praWXList[i][0]+"'><img src="+praWXList[i][1]+"/></a>";
                            }
                        }
                    }
                }
            }, this);
            setTimeout(lang.hitch(this,function(){
                this._isMdf = false;
                window.free();
            }),100);
        },
        //页面list2节点的点击事件
        onclickFuc: function(e,list) {
            var dom = e.target,id;
            while (dom && dom.tagName.toLowerCase() != 'a' && dom != this.domNode) {
                dom = dom.parentNode;
            }
            id = domAttr.get(dom, "id");
            if (id) {
                if (id.split("-")[0] == "praise") {
                    this.praiseFuc(domAttr.get(dom, "dt_id"),list);
                }else if(id.split("-")[0] == "praWXList"){
                    window.moveToView("praList",id.split("-")[1]);
                }
            }
        },
        //tab页面的切换
        travelFuc: function(e) {
            var dom = e.target; //点击的节点
            if (dom && dom.tagName.toLowerCase() == "li") {
                //ul标签的显示隐藏
                var cls = domAttr.get(dom, "class"),
                    id = domAttr.get(dom, "id");
                //点击后显示
                domAttr.set(dom, "class", (cls == "tableLi" || cls == "tableLiChecked") ? "tableLiChecked" : "tableLi");
                //点击后隐藏
                query("li", this.travel).forEach(function(n) {
                    if (n != dom) {
                        domAttr.set(n, "class", "tableLi");
                    }
                });
                //div的显示隐藏
                domStyle.set(query("." + id, this.domNode)[0],"display","block");
                registry.byId(id + "_01").refreshList();
                array.forEach([this.allDynamic, this.myDynamic, this.myFriend], function(n) {
                    if (domAttr.get(n, "class") != id) {
                        domStyle.set(n,"display","none");
                    }
                });
            }
        },
        //发布
        publishFuc: function(){
            //发请求，保存旅行记录数据
            window.busy();
            var d = new Date(),
                d = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds(),
                data = {
                    n: {
                        "CONTENT": this.WB_input_value.value,
                        "P_ID": userInfo.getUserInfo().partnerId, 
                        "MAKEDATE": d,
                        "OPENID": window.wx_openId
                    }
                };
            if (data["n"].CONTENT === "") {
                window.free();
            }else{
                domAttr.set(query("#publish")[0], "class", "WB_publish_Button");
                if (this.WB_input_value.value.length > 150) {
                    alert("输入的字数不能超过150");
                    window.free();
                } else {
                    xhr("POST", {
                        url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                        handleAs: "json",
                        content: {
                            data: json.toJson({
                                modalName: "XSY_TCRMK_TRAVDTS",
                                data: [data]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                domAttr.set(this.publish, "class", "WB_publish_Button_b");
                                this.allDynamic_01.refreshList();
                                window.free();
                            } else {
                                alert(result.message || "数据错误!");
                                window.free();
                            }
                            this.WB_input_value.value = "";
                        })
                    });
                }
            }
        },
        //保存点赞
        postPraise: function(data, data1) {
            var def1 = new Deferred(),def2 = new Deferred();
            //点赞者、点赞的记录
            xhr("POST", {
                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    data: json.toJson({
                        modalName: "XSY_TBSAV_PRAISE",
                        data: [data]
                    })
                },
                load: function(result) {
                    if (1 === result.rtnType) {
                    } else {
                        alert(result.message || "数据错误!");
                    }
                    def1.resolve();
                },
                error:function(){
                    def1.resolve();
                }
            });
            //修改旅行记录中点赞人的数量
            xhr("POST", {
                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    data: json.toJson({
                        modalName: "XSY_TCRMK_TRAVDTS",
                        data: [data1]
                    })
                },
                load: function(result) {
                    if (1 === result.rtnType) {
                    }else{
                        alert(result.message || "数据错误!");
                    }
                    def2.resolve();
                    window.free();
                },
                error:function(){
                    def2.resolve();
                    window.free();
                }
            });
            return new DeferredList([def1,def2]);
        },
        //改变点赞状态
        praiseFuc: function(did,list) {
            if(this._isMdf){
                return;
            }
            window.busy();
            this._isMdf = true;
            var callback = lang.hitch(list,list.refreshList),errorback = lang.hitch(this,function(){
                this._isMdf = false;
                window.free();
            });
            var num,rmk,hasPraWXs;
            window.loadData({
                modalName: "XSY_TCRMK_TRAVDTS", //加载旅行记录
                filter: "05",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "DID": did
                }
            }).then(lang.hitch(this, function(a) {
                if(this.WXID){
                    var data = {},rmk = a[0].PRA_CONT,num = (a[0].PRA_NUM-0)||0;
                    if(-1<rmk.indexOf(this.WXID)){
                        rmk = array.filter(rmk.split(";"),function(str){
                            return -1===str.indexOf(this.WXID);
                        },this).join(";");
                        data.o = {
                            "TRAVELID":did,
                            "OPENID":this.WXID
                        };
                        num = num-1;
                    }else{
                        rmk = this.WXID+","+this.HEADIMGURL+","+this.NICKNAME + ";" + rmk;
                        if(";"===rmk[rmk.length-1]){
                            rmk = rmk.substr(0,rmk.length-1);
                        }
                        num = num + 1;
                        var d = new Date();
                        data.n = {
                            "PID":userInfo.getUserInfo().partnerId,
                            "TRAVELID":did,
                            "OPENID":this.WXID,
                            DDATE:d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds()
                        }
                    }
                    this.postPraise(data, {
                        o: {
                            "DID": did
                        },
                        n: {
                            "PRA_NUM": num,
                            "PRA_CONT":rmk
                        }
                    }).then(callback,callback);
                }else{
                    alert(this.ERRMSG);
                }
            }),errorback);
        }
    });
});