define([
    "dojo/_base/declare",
    "dojo/query",
    "dojo/_base/lang",
    "dojo/_base/array",
    "../userInfo"], function(declare, query, lang, array, userInfo) {
    return declare("widgets.common._GetPwdMixin", null, {
        isGetPwdLoaded:function(){
            return !!this.getPwdPhone;
        },
        indexGetPwdElement:function(){
            array.forEach(["getPwdPhone","getPwdPwd","getPwdPwdConfirm","getPwdVCode","getPwdVCodeBtn","getPwdSubmitBtn"],function(cls){
                this[cls] = query("."+cls,this.domNode)[0];
            },this);
        },
        initGetPwdEvent: function() {
            this.connect(this.getPwdVCodeBtn,"onclick",this.findPwdSendMsg);
            this.connect(this.getPwdSubmitBtn,"onclick",this.findPwdSub);
        },
        refreshAllList:function(){
            if(window.titleNode){
                window.titleNode.innerHTML = "找回密码";
            }
        },
        //找回密码发送验证码
        findPwdSendMsg: function() {
            var phone = this.getPwdPhone.value;
            if (userInfo.validPhoneNumber(phone)) { //手机号码合法性检查
                userInfo.checkUName(phone).then(lang.hitch(this, function(msg) { //检查用户名是否已可用
                    if (!msg) { //如果未注册，跳转注册页面
                        if (confirm("您输入的手机号码还没有被注册，需要注册吗？")) {
                            window.moveToView("register");
                        }
                    } else {
                        this.phone = phone;
                        window.busy();
                        window.sendMsg(phone).then(function() {
                            window.free();
                        });
                    }
                }));
            } else {
                alert("您输入的手机号码有误或未注册，请检查或注册后再输入!");
            }
        },
        //找回密码提交
        findPwdSub: function() { //找回密码密码提交
            var info = {
                newPwd: this.getPwdPwd.value,
                RPwd: this.getPwdPwdConfirm.value
            };
            //验证手机验证码
            var phone = this.getPwdPhone.value;
            var verCode = this.getPwdVCode.value;
            if (userInfo.validPhoneNumber(phone)) { //手机号码合法性检查
                window.busy();
                userInfo.checkUName(phone).then(lang.hitch(this, function(msg) { //检查用户名是否已可用
                    if (!msg) { //如果未注册，跳转注册页面
                        if (confirm("您输入的手机号码还没有被注册，需要注册吗？")) {
                            window.moveToView("register");
                        }
                        window.free();
                    } else {
                        window.postVerCode(phone, verCode).then(lang.hitch(this,function(success) { //发送验证码
                            if (success) {
                                window.openId = this.getPwdPhone.value; //手机号码
                                userInfo.onResetPwd(info).then(lang.hitch(this,function(success) {
                                    if (success) {
                                        alert("密码修改成功！");
                                        // 请空找回密码信息
                                        this.getPwdPhone.value = "";
                                        this.getPwdPwdConfirm.value = "";
                                        this.getPwdVCode.value = "";
                                        this.getPwdPwd.value = "";
                                        userInfo.onLogin(window.openId,info.newPwd).then(function(){
                                            window.moveToView(window.nextPageOnLogin||"user");
                                        });
                                    } else {
                                        window.free();
                                    }
                                }));
                            } else {
                                window.free();
                            }
                        }));
                    }
                }));

            } else {
                alert("您输入的手机号码有误或未注册，请检查或注册后再输入!");
            }
        }
    });
});