define([
    "dojo/_base/declare",  
    "dojo/query", 
    "dojo/_base/lang",
    "dojo/dom-style",
    "../userInfo", 
    "dijit/registry"], function(declare, query, lang,domStyle, userInfo, registry) {
    return declare("widgets.common._LoginMixin", null, {
        isLoginLoaded:function(){
            return !!this.loginDiv;
        },
        indexLoginElement:function(){
            this.loginDiv = query(".loginDiv",this.domNode)[0];
            this.loginBtn = query("#Login", this.domNode)[0];
            this.registBtn = query("#Regist", this.domNode)[0];
            this.quickLoginDiv = query(".quickLoginDiv",this.domNode)[0];
            this.quickLoginBtn = query(".quickLoginBtn",this.domNode)[0];
            this.otherLogin = query(".otherLogin",this.domNode)[0];
        },
        refreshAllList:function(){
            if(window.titleNode){
                window.titleNode.innerHTML = "登录";
            }
            if(window.wx_openId&&window.wx_pid){
                this.showQuickLoginDiv();
            }else{
                this.showLoginDiv();
            }
        },
        initLoginEvent:function(){
            //从cookie中读取需要的  userName=""; 信息
            var name = "userName="; //我们需要的登录过的用户名  所在的字符串
            var d = ""; //我们要初始化的用户名
            var ca = document.cookie.split(';'); //把整个cookie按“;”切分
            for (var i = 0; i < ca.length; i++) { //遍历整个cookie
                var c = ca[i].trim();
                if (c.indexOf(name) == 0) //找到我们需要的 userName字符串
                d = c.substring(name.length, c.length); //取到我们要找的 用户名
            }
            query("#loginUName")[0].value = d; //初始化时读取cookies
            //登录
            this.connect(this.loginBtn,"onclick",function() {
                //登录成功后  用户名写入cookies
                userInfo._onLoginOk(query("#loginUName")[0].value, query("#loginPwd")[0].value).then(lang.hitch(this, function(success) {
                    if(success&&window.wx_openId&&confirm("绑定当前微信？")){
                        //创建cookies
                        userInfo.bindWx();
                        document.cookie = "userName" + "=" + query("#loginUName")[0].value + ";"; //创建cookies
                    }
                    if(window.nextPageOnLogin){
                        window.moveToView(window.nextPageOnLogin);
                    }
                }));

                query("#loginPwd")[0].value = "";
            });
            this.connect(this.registBtn,"onclick",function() {
                //if(window.util.versions.weixin){
                    //如果不是微信浏览器就可以注册
                //    alert("请在微信中发送“BD+手机号”给我们实现注册。");
                //}else{
                    userInfo.showRegistView();
                //}
            });
            this.connect(this.quickLoginBtn,"onclick",function(){
                userInfo.loginWx().then(lang.hitch(this,function(success){
                    if(!success){
                        this.showLoginDiv();
                    }else{
                        if(window.nextPageOnLogin){
                            window.moveToView(window.nextPageOnLogin);
                        }
                    }
                }));
            });
            this.connect(this.otherLogin,"onclick",this.showLoginDiv);
        },
        showLoginDiv:function(){
            domStyle.set(this.quickLoginDiv,"display","none");
            domStyle.set(this.loginDiv,"display","");
        },
        showQuickLoginDiv:function(){
            domStyle.set(this.loginDiv,"display","none");
            domStyle.set(this.quickLoginDiv,"display","");
        },
    });
});