define([
    "dojo/_base/declare", 
    "dojo/_base/array", 
    "dojo/dom-class",
    "dojo/dom-style",
    "dijit/registry", 
    "dojo/query",
    "dojo/_base/lang", 
    "dojo/Deferred",
    "dojo/dom-attr",
    "widgets/common/_DepositMixin",
    "widgets/orderCarRecord",
    "cqthink/mobile/imgPrc/bigImg",
    "widgets/common/couponMixin"
], function(declare, array,domClass,domStyle, registry,query, lang,Deferred,domAttr,DepositMixin,orderCarRecord,bigImg,couponMixin) {
    return declare("widgets.common._MatDetailMixin", DepositMixin, {
        isMatDetailLoaded:function(){
            return !!this.picItemsScan;
        },
        indexMatDetailElement:function(){
            this.picItemsScan = registry.byId("picItems"); //图片滚动器
            this.MatDetailList = registry.byId("materDetail"); //商品价格等信息
            this.materContent = registry.byId("materContent");  //商品介绍
            this.materCom = registry.byId("materCom");// 推荐信息
            this.XXmsg = registry.byId("XXmsg"); //温馨提示
            this.XXeva = registry.byId("XXeva"); //评价
            this._tabs_ul = query("#tabs-ul",this.domNode)[0]; // 标题
        },

        initMatDetailEvent:function(){
            // 获取图片地址
            this.connect(this.picItemsScan, "onBeforeRender", function() {
                if (this.picItemsScan.items.length > 0) {
                    array.forEach(this.picItemsScan.items, function(item) {
                        item.src = "/w/img/load/" + g_sys_info.code + "-" + item.DID + ".png";
                        item.title = "";
                    });
                }
            });
            // 商品详情的监听事件 点击图片看大图
            this.connect(this.materContent.domNode,"onclick",function(event){
                var src=query("img",this.materContent.domNode);
                var index=0;  
                var srcArr=array.map(src,function(item,i){  //路径的数组对象
                    if(item==event.target) {
                        index=i;
                    }
                    return  {src:domAttr.get(item,"src")};
                });
                bigImg.show(srcArr,index);
            });
            // 取商品详细信息
            this.connect(this.MatDetailList,"onDefRendered",function(data){
                if(data.data.items.length){
                    document.title = data.data.items[0].T0_GName;
                    var item = data.data.items[0];
                    item.canAdd = item.singleBuy = 0;
                    if("1"==item.T0_IsUse.toString()&&"1"===item.T0_IsAllowSale.toString()&&0<item.T9_SHELF_QTY&&"1"===item.T0_IS_ONLINESALE.toString()){//使用、允许销售、有货架库存
                        if("1"===item.T0_IsAllSO.toString()||item.T0_AID==g_sys_info.aid){//允许分销或者是当前货主的产品
                            item.singleBuy = 1;
                            item.canAdd = 1;
                            if(item.T0_AID==g_sys_info.aid){
                                item.canAdd = 1;
                            }
                        }
                    }
                    if(window.preDataDts.length){
                        item.PRE_EDATE = window.preData[0].EDATE;
                        item.F_SDATE = window.preData[0].FINAL_PAY_SDATE;
                        item.F_EDATE = window.preData[0].FINAL_PAY_EDATE;
                        item.IS_PRESALE = 1;//是否预售商品
                        item.PRESALE_RULES = window.preData[0].REMAKR;//预售规则
                        item.PRE_EAR = window.preData[0].EARNEST;//定金
                        item.payEarNum = window.preData[0].PayEarNum;//已付定金数量
                        item.PRE_REPRIC = "";//预售零售价
                        item.PRI_CON = "";
                        array.forEach(window.preDataDts,function(preDataDts){
                            if(preDataDts.QTY2==""){
                                if(parseFloat(item.payEarNum)>=parseFloat(preDataDts.QTY1)){
                                    window.DQPRI = preDataDts.RE_PRICE;
                                    item.PRI_CON = item.PRI_CON+"累计预定"+window.fixedTo(preDataDts.QTY1,0)+"以上，尾款￥"+window.fixedTo(preDataDts.RE_PRICE,2)+"<br/>";
                                }else{
                                    item.PRI_CON = item.PRI_CON+"<font style='color: #666;font-size: 12px;font-weight: normal;'>累计预定"+window.fixedTo(preDataDts.QTY1,0)+"以上，尾款￥"+window.fixedTo(preDataDts.RE_PRICE,2)+"</font><br/>";
                                }
                            }else{
                                if(parseFloat(item.payEarNum)>=parseFloat(preDataDts.QTY1)&&parseFloat(item.payEarNum)<=parseFloat(preDataDts.QTY2)){
                                    window.DQPRI = preDataDts.RE_PRICE;
                                    item.PRI_CON = item.PRI_CON + "累计预定"+window.fixedTo(preDataDts.QTY1,0)+"到"+window.fixedTo(preDataDts.QTY2,0)+"，尾款￥"+window.fixedTo(preDataDts.RE_PRICE,2)+"<br/>";
                                }else{
                                    item.PRI_CON = item.PRI_CON + "<font style='color: #666;font-size: 12px;font-weight: normal;'>累计预定"+window.fixedTo(preDataDts.QTY1,0)+"到"+window.fixedTo(preDataDts.QTY2,0)+"，尾款￥"+window.fixedTo(preDataDts.RE_PRICE,2)+"</font><br/>";
                                }
                            }
                        });
                        item.PRI_CON = "￥"+window.fixedTo(window.DQPRI,2)+"/"+item.T0_MainUnitID.MeasureName+"<br/>"+item.PRI_CON;
                    }else{
                        item.PRE_REPRIC_F = "";
                        item.PRE_REPRIC_T = "";
                        if(window.preData.length){
                            item.IS_PRESALE = 1;
                            item.PRESALE_RULES = window.preData[0].REMAKR;
                            item.PRE_REPRIC = window.preData[0].RE_PRICE;
                            item.PRE_EAR = window.preData[0].EARNEST;
                            item.payEarNum = window.preData[0].PayEarNum;
                            item.PRE_EDATE = window.preData[0].EDATE;
                            item.F_SDATE = window.preData[0].FINAL_PAY_SDATE;
                            item.F_EDATE = window.preData[0].FINAL_PAY_EDATE;
                        }else{
                            item.IS_PRESALE = 0;
                            item.PRESALE_RULES = "";
                            item.PRE_REPRIC = "";
                            item.PRE_EAR = "";
                            item.payEarNum = "";
                        }
                    }
                    var mats = window.did;
                    this._dealDeposit(mats,1).then(lang.hitch(this,function(Deposit){
                        if(Deposit){
                            this._updateBonusPointsInfo("购买即送积分"+window.fixedTo(Deposit,0)+"元"+(item.T0_MainUnitID.MeasureName?("/"+item.T0_MainUnitID.MeasureName):""));  
                        }
                        // 取商品的邮费信息
                        // 按照新的规则获取邮费信息
                        window.loadData({
                            modalName:"XSY_TSSCF_APP",
                            filter:"999",
                            pageSize:"1",
                            pageIndex:"1",
                            param:{"AID":item.T0_AID.APP_ID,"INPUT":""}
                        }).then(lang.hitch(this,function(data){
                            // 如果有对应的物流货主，那么货主设置的邮费政策不起作用
                            if(data[0].TRAN_AID){
                                this._updateBonusLogisticsInfo(data.length?(data[0].TRAN_REGION?("限"+data[0].TRAN_REGION+"，邮费￥0"):"邮费￥0"):"邮费￥0");
                            }else{
                                this._updateBonusLogisticsInfo(data.length?(data[0].TRAN_REGION?("限"+data[0].TRAN_REGION+"，"):"")+(data[0].DIR_LMT>0?"未满￥"+window.fixedTo(item.T0_AID==g_sys_info.aid?data[0].DIR_LMT:data[0].DIS_LMT,3)+"，收取邮费￥"+window.fixedTo(data[0].TRAN_FEE,3):"邮费￥0"):"");
                            }
                        }));
                    }));
                    window.updateTitle(item.T0_GName);
                    //处理库存默认值
                    this.matShelfQty = item.T9_SHELF_QTY = (item.T9_SHELF_QTY||0) - 0;
                    //处理限购数量
                    this.TPCH_NUM = item.T0_TPCH_NUM = (item.T0_TPCH_NUM||0);
                }
            });
            // 侦听购物车
            this.connect(this.MatDetailList.domNode, "onclick", this._MatDetailClick); 
            
            //侦听标题
            this.connect(this._tabs_ul,"onclick",this._tabs_ul_fuc);
            this.connect(this.materCom,"onDefRendered",function(data){
                //this.hasRecomment = true;
                var c = query("#XX-01",this.domNode)[0];
                domStyle.set(c,"display",data.data.items.length?"":"none");
                //this._tabs_ul_fuc({
                //    target:data.data.items.length?c:query("#XX-02",this.domNode)[0]
                //});
            });
            this.connect(this.XXmsg,"onDefRendered",function(data){
                domStyle.set(query("#XX-04",this.domNode)[0],"display",data.data.items.length?"":"none");
            });
            this.connect(this.XXeva,"onDefRendered",function(data){
                if(!data.data.items.length){
                    query("#evaNums",this.domNode)[0].innerHTML = "0";
                }else{
                    query("#evaNums",this.domNode)[0].innerHTML = data.data.totalCount;
                    
                    array.forEach(data.data.items, function(item) {
                        var k='';
                        for(h=0;h<item.MAKER.length-1;h++){
                            k=k+'*';
                        }
                        item.MAKER = item.MAKER.substr(0,1)+k;
                    });
                }
            });
            
            //this.connect(this.MatDetailList.domNode,"onclick",this.materDetailFuc);
            //立即购买
           // this.connect(this.buynow,"onclick",this.buynowFuc);
        },
        // 获取备用数据
        loadDataFuc:function(){
            var def = new Deferred();
            // 预售主表数据
            window.preData = [];
            // 预售明细数据
            window.preDataDts = [];
            // 分时限购数据
            window.fsData = [];
            // 商家是否有优惠券
            window.hasCoupons = false;
            // 积分政策数据
            window.priceData = [];
            
            // 判断商家是否有优惠券
            couponMixin.getAppCoupons().then(lang.hitch(this,function(hasCoupons){
                window.hasCoupons = hasCoupons;
            })).then(lang.hitch(this,function(){
                // 查询商品是否有分时限购活动
                window.loadData({
                    modalName:"NY_TSDCD_PRICEDTS",
                    filter:"03",
                    pageSize:"2",
                    pageIndex:"1",
                    param:{"MID":window.did}
                }).then(lang.hitch(this,function(priceData){
                    if(priceData.length)
                    {
                        window.priceData = priceData;
                    }
                    window.loadData({
                        modalName:"NY_TBSSC_MAT_ACTIVITY",
                        filter:"01",
                        pageSize:"1",
                        pageIndex:"1",
                        param:{"MID":window.did,"CURTIME":g_s.getDateTime()}
                    }).then(lang.hitch(this,function(fsData){
                        if(fsData.length>0){
                            window.fsData = fsData;
                        }
                        window.loadData({
                            modalName:"XSY_TCRMK_MAT_ADSALE",//预售主表
                            filter:"01",
                            pageSize:"1",
                            pageIndex:"1",
                            param:{"MID":window.did}
                        }).then(lang.hitch(this,function(data){
                            // 如果是预售商品
                            if(data.length){
                                // 修改商品的标记
                                window.preData = data;
                                window.loadData({
                                    modalName:"XSY_TCRMK_MAT_ADSALEDTS",
                                    filter:"01",
                                    pageSize:"1",
                                    pageIndex:"1",
                                    param:{DID:window.preData[0].DID}
                                }).then(lang.hitch(this,function(dataDts){//预售明细
                                    if(dataDts.length){
                                        window.preDataDts = dataDts;
                                    }
                                    if (window.did != this.did) {
                                        this.did = window.did;
                                        //刷新图片
                                        this.picItemsScan.where = "[RID]='XSY_TBSSC_MAT' AND [RIID]='" + window.did+"'"; /* + " AND [TYPE]<>1"*/
                                        this.picItemsScan.refresh();
                                    }
                                    this.MatDetailList.refreshList(); /*刷新商品基本信息*/
                                    this.materContent.refreshList();/*刷新商品介绍*/
                                    this.materCom.refreshList();/*刷新推荐信息*/
                                    this.XXmsg.refreshList();/*刷新温馨提示*/
                                    // 新版商品详情处不直接刷新评价列表 2015-12-08  刘轩
                                    //this.XXeva.refreshList();/*刷新评价*/
                                    def.resolve();
                                }));
                            }else{
                                if (window.did != this.did) {
                                    this.did = window.did;
                                    //刷新图片
                                    this.picItemsScan.where = "[RID]='XSY_TBSSC_MAT' AND [RIID]='" + window.did+"'"; /* + " AND [TYPE]<>1"*/
                                    this.picItemsScan.refresh();
                                }
                                this.MatDetailList.refreshList(); /*刷新商品基本信息*/
                                this.materContent.refreshList();/*刷新商品介绍*/
                                this.materCom.refreshList();/*刷新推荐信息*/
                                this.XXmsg.refreshList();/*刷新温馨提示*/
                                // 新版商品详情处不直接刷新评价列表 2015-12-08  刘轩
                                //this.XXeva.refreshList();/*刷新评价*/
                            }
                            def.resolve();
                        }));
                    }));
                }));
            }));
            return def;
        },
        refreshAllList:function(){
            var car = orderCarRecord.getOrderCar(),n = 0;
            for(var mid in car){
                n += car[mid]||0;
            }
            if(query(".stdOrderNum",this.domNode)[0]){
                query(".stdOrderNum",this.domNode)[0].innerHTML = n;
            }
            this.loadDataFuc();
            this.inherited(arguments);
        },
        _tabs_ul_fuc:function(e){
            var dom = e.target;
            while(dom&&"li"!==dom.tagName.toLowerCase()&&dom!=this._tabs_ul){
                dom = dom.parentNode;
            }
            if(dom&&"li"==dom.tagName.toLowerCase()){
                //设置样式
                domClass.remove(query(".on",this._tabs_ul)[0],"on");
                domClass.add(dom,"on");
                
                /*query("li",this._tabs_ul).forEach(function(node){
                    domAttr.set(node,"class",dom===node?"on":"");
                });*/
                var domId = domAttr.get(dom,"id");
                dom = this._tabs_ul.nextSibling;
                while(dom){
                    if(dom.tagName&&"div"===dom.tagName.toLowerCase()){
                        domStyle.set(dom,"display",domClass.contains(dom,domId)?"":"none");
                    }
                    dom = dom.nextSibling;
                }
            }
        },
        //当前界面点击事件响应函数
        _MatDetailClick:function(e){
            if (e.target) {
                if (domClass.contains(e.target,"add")) {
                    this._addMatNum(1);
                } else if (domClass.contains(e.target,"dec")) {
                    this._addMatNum(-1);
                }
            }
        },
        //当前商品选中数量变更响应
        _addMatNum:function(inc){
            var matNode = query("#buy_num",this.domNode),msg = "";
            matNode = matNode.length&&matNode[0];
            if(matNode){
                // 页面上显示
                //增加数量时  如果超过库存或者限购数量则不能增加
                var matNum = inc-0+(matNode.value-0);
                if(0<matNum){
                    if(matNum<=this.matShelfQty){
                        query("#show_msg",this.domNode)[0].style.display = "none";
                        if(this.TPCH_NUM>0&&matNum>this.TPCH_NUM){
                            query("#show_msg",this.domNode)[0].style.display = "";
                            query("#show_msg",this.domNode)[0].innerHTML = "超过限购数量。";
                        }else{
                            matNode.value = matNum;
                            query("#show_msg",this.domNode)[0].style.display = "none";
                        }
                    }else{
                        query("#show_msg",this.domNode)[0].style.display = "";
                        query("#show_msg",this.domNode)[0].innerHTML = "库存不足。";
                    }
                }
            }
        },
        //更新优惠积分的显示
        _updateBonusPointsInfo:function(msg){
            //优惠信息
            var node1 = query(".BonusPoint",this.domNode)[0];
            var node = query(".BonusPoints",this.domNode)[0];
            domStyle.set(node,"display",msg?"":"none");
            domStyle.set(node1,"display",msg?"":"none");
            node.innerHTML = msg;
        },
        //更新运费信息的显示
        _updateBonusLogisticsInfo:function(msg){
            //运费信息
            query(".logisticsInfo",this.domNode)[0].innerHTML = msg;
        }
    });
});