define([
    "dojo/_base/declare", 
    "dojo/_base/array", 
    "dojo/dom-class",
    "dojo/dom-style",
    "dijit/registry", 
    "dojo/query",
    "dojo/_base/lang", 
    "dojo/Deferred",
    "dojo/dom-attr",
    "widgets/common/_DepositMixin",
    "widgets/orderCarRecord"
], function(declare, array,domClass,domStyle, registry,query, lang,Deferred,domAttr,DepositMixin,orderCarRecord) {
    return declare("widgets.common._MatDetailMixin", DepositMixin, {
        isMatDetailLoaded:function(){
            return !!this.picItemsScan;
        },
        indexMatDetailElement:function(){
            this.picItemsScan = registry.byId("picItems"); //图片滚动器
            this.MatDetailList = registry.byId("materDetail"); //商品价格等信息
            this.materContent = registry.byId("materContent");  //商品介绍
            this.XXeva = registry.byId("XXeva"); //评价
            this._tabs_ul = query("#tabs-ul",this.domNode)[0]; // 标题
        },
        initMatDetailEvent:function(){
            // 修改图片信息
            this.connect(this.picItemsScan, "onBeforeRender", function() {
                if (this.picItemsScan.items.length > 0) {
                    array.forEach(this.picItemsScan.items, function(item) {
                        item.src = "/w/img/load/" + g_sys_info.code + "-" + item.DID + ".png";
                        item.title = "";
                    });
                }
            });
            // 取商品详细信息
            this.connect(this.MatDetailList,"onDefRendered",function(data){
                if(data.data.items.length){
                    var item = data.data.items[0];
                    item.canAdd = item.singleBuy = 0;
                    if("1"==item.T0_IsUse.toString()&&"1"===item.T0_IsAllowSale.toString()&&0<item.T9_SHELF_QTY&&"1"===item.T0_IS_ONLINESALE.toString()){//使用、允许销售、有货架库存
                        if("1"===item.T0_IsAllSO.toString()||item.T0_AID==g_sys_info.aid){//允许分销或者是当前货主的产品
                            item.singleBuy = 1;
                            item.canAdd = 1;
                            if(item.T0_AID==g_sys_info.aid){
                                item.canAdd = 1;
                            }
                        }
                    }
                    if(window.preDataDts.length){
                        item.PRE_EDATE = window.preData[0].EDATE;
                        item.F_SDATE = window.preData[0].FINAL_PAY_SDATE;
                        item.F_EDATE = window.preData[0].FINAL_PAY_EDATE;
                        item.IS_PRESALE = 1;//是否预售商品
                        item.PRESALE_RULES = window.preData[0].REMAKR;//预售规则
                        item.PRE_EAR = window.preData[0].EARNEST;//定金
                        item.payEarNum = window.preData[0].PayEarNum;//已付定金数量
                        item.PRE_REPRIC = "";//预售零售价
                        item.PRI_CON = "";
                        array.forEach(window.preDataDts,function(preDataDts){
                            if(preDataDts.QTY2==""){
                                if(parseFloat(item.payEarNum)>=parseFloat(preDataDts.QTY1)){
                                    window.DQPRI = preDataDts.RE_PRICE;
                                    item.PRI_CON = item.PRI_CON+"累计预定"+window.fixedTo(preDataDts.QTY1,0)+"以上，尾款￥"+window.fixedTo(preDataDts.RE_PRICE,2)+"<br/>";
                                }else{
                                    item.PRI_CON = item.PRI_CON+"<font style='color: #666;font-size: 12px;font-weight: normal;'>累计预定"+window.fixedTo(preDataDts.QTY1,0)+"以上，尾款￥"+window.fixedTo(preDataDts.RE_PRICE,2)+"</font><br/>";
                                }
                            }else{
                                if(parseFloat(item.payEarNum)>=parseFloat(preDataDts.QTY1)&&parseFloat(item.payEarNum)<=parseFloat(preDataDts.QTY2)){
                                    window.DQPRI = preDataDts.RE_PRICE;
                                    item.PRI_CON = item.PRI_CON + "累计预定"+window.fixedTo(preDataDts.QTY1,0)+"到"+window.fixedTo(preDataDts.QTY2,0)+"，尾款￥"+window.fixedTo(preDataDts.RE_PRICE,2)+"<br/>";
                                }else{
                                    item.PRI_CON = item.PRI_CON + "<font style='color: #666;font-size: 12px;font-weight: normal;'>累计预定"+window.fixedTo(preDataDts.QTY1,0)+"到"+window.fixedTo(preDataDts.QTY2,0)+"，尾款￥"+window.fixedTo(preDataDts.RE_PRICE,2)+"</font><br/>";
                                }
                            }
                        });
                        item.PRI_CON = "￥"+window.fixedTo(window.DQPRI,2)+"/"+item.T0_MainUnitID.MeasureName+"<br/>"+item.PRI_CON;
                    }else{
                        item.PRE_REPRIC_F = "";
                        item.PRE_REPRIC_T = "";
                        if(window.preData.length){
                            item.IS_PRESALE = 1;
                            item.PRESALE_RULES = window.preData[0].REMAKR;
                            item.PRE_REPRIC = window.preData[0].RE_PRICE;
                            item.PRE_EAR = window.preData[0].EARNEST;
                            item.payEarNum = window.preData[0].PayEarNum;
                            item.PRE_EDATE = window.preData[0].EDATE;
                            item.F_SDATE = window.preData[0].FINAL_PAY_SDATE;
                            item.F_EDATE = window.preData[0].FINAL_PAY_EDATE;
                        }else{
                            item.IS_PRESALE = 0;
                            item.PRESALE_RULES = "";
                            item.PRE_REPRIC = "";
                            item.PRE_EAR = "";
                            item.payEarNum = "";
                        }
                    }
                    var mats = window.did;
                    this._dealDeposit(mats,1).then(lang.hitch(this,function(Deposit){
                        if(Deposit){
                            this._updateBonusPointsInfo("购买即送积分"+window.fixedTo(Deposit,0)+"元/"+item.T0_MainUnitID.MeasureName);  
                        }
                    }));
                    window.updateTitle(item.T0_GName);
                    //处理库存默认值
                    this.matShelfQty = item.T9_SHELF_QTY = (item.T9_SHELF_QTY||0) - 0;
                    //处理限购数量
                    this.TPCH_NUM = item.T0_TPCH_NUM = (item.T0_TPCH_NUM||0);
                }
            });
            // 侦听购物车
            this.connect(this.MatDetailList.domNode, "onclick", this._MatDetailClick); 
            //侦听标题
            this.connect(this._tabs_ul,"onclick",this._tabs_ul_fuc);
            this.connect(this.XXeva,"onDefRendered",function(data){
                if(!data.data.items.length){
                    query("#evaNums",this.domNode)[0].innerHTML = "0";
                }else{
                    query("#evaNums",this.domNode)[0].innerHTML = data.data.totalCount;
                    
                    array.forEach(data.data.items, function(item) {
                        var k='';
                        for(h=0;h<item.MAKER.length-1;h++){
                            k=k+'*';
                        }
                        item.MAKER = item.MAKER.substr(0,1)+k;
                    });
                }
            });
        },
        // 在刷新list2之前去取到要用到的预售数据
        loadDataFuc:function(){
            var def = new Deferred();
            window.preData = [];
            window.preDataDts = [];
            window.loadData({
                modalName:"XSY_TCRMK_MAT_ADSALE",//预售主表
                filter:"01",
                pageSize:"1",
                pageIndex:"1",
                param:{"MID":window.did}
            }).then(lang.hitch(this,function(data){
                // 如果是预售商品
                if(data.length){
                    // 修改商品的标记
                    window.preData = data;
                    window.loadData({
                        modalName:"XSY_TCRMK_MAT_ADSALEDTS",
                        filter:"01",
                        pageSize:"1",
                        pageIndex:"1",
                        param:{DID:window.preData[0].DID}
                    }).then(lang.hitch(this,function(dataDts){//预售明细
                        if(dataDts.length){
                            window.preDataDts = dataDts;
                        }
                        if (window.did != this.did) {
                            this.did = window.did;
                            //刷新图片
                            this.picItemsScan.where = "[RID]='XSY_TBSSC_MAT' AND [RIID]=" + window.did; /* + " AND [TYPE]<>1"*/
                            this.picItemsScan.refresh();
                            this.MatDetailList.refreshList(); /*刷新商品基本信息*/
                        }
                        this.materContent.refreshList();/*刷新商品介绍*/
                        this.XXeva.refreshList();/*刷新评价*/
                        def.resolve();
                    }));
                }else{
                    if (window.did != this.did) {
                        this.did = window.did;
                        //刷新图片
                        this.picItemsScan.where = "[RID]='XSY_TBSSC_MAT' AND [RIID]=" + window.did; /* + " AND [TYPE]<>1"*/
                        this.picItemsScan.refresh();
                        this.MatDetailList.refreshList(); /*刷新商品基本信息*/
                    }
                    this.materContent.refreshList();/*刷新商品介绍*/
                    this.XXeva.refreshList();/*刷新评价*/
                }
                def.resolve();
            }));
            return def;
        },
        refreshAllList:function(){
            var car = orderCarRecord.getOrderCar(),n = 0;
            for(var mid in car){
                n += car[mid]||0;
            }
            if(query(".stdOrderNum",this.domNode)[0]){
                query(".stdOrderNum",this.domNode)[0].innerHTML = n;
            }
            this.loadDataFuc();
            this.inherited(arguments);
        },
        _tabs_ul_fuc:function(e){
            var dom = e.target;
            while(dom&&"li"!==dom.tagName.toLowerCase()&&dom!=this._tabs_ul){
                dom = dom.parentNode.parentNode;
            }
            if(dom&&"li"==dom.tagName.toLowerCase()){
                //设置样式
                query("li",this._tabs_ul).forEach(function(node){
                    domAttr.set(node,"class",dom===node?"on":"");
                });
                var domId = domAttr.get(dom,"id");
                dom = this._tabs_ul.nextSibling;
                while(dom){
                    if(dom.tagName&&"div"===dom.tagName.toLowerCase()){
                        domStyle.set(dom,"display",domId===domAttr.get(dom,"class")?"":"none");
                    }
                    dom = dom.nextSibling;
                }
            }
        }
    });
});