define([
    "dojo/_base/declare", 
    "dojo/_base/array", 
    "dojo/dom-class",
    "dojo/dom-style",
    "dijit/registry", 
    "dojo/query",
    "dojo/_base/lang", 
    "dojo/Deferred",
    "dojo/dom-attr",
    "widgets/common/_DepositMixin",
    "widgets/orderCarRecord",
    "cqthink/mobile/imgPrc/bigImg",
    "widgets/common/couponMixin"
], function(declare, array,domClass,domStyle, registry,query, lang,Deferred,domAttr,DepositMixin,orderCarRecord,bigImg,couponMixin) {
    return declare("widgets.common._MatDetail_sjmdMixin", DepositMixin, {
        isMatDetailLoaded:function(){
            return !!this.picItemsScan;
        },
        indexMatDetailElement:function(){
            this.picItemsScan = registry.byId("picItems"); //图片滚动器
            this.MatDetailList = registry.byId("materDetail"); //商品价格等信息
            this.materContent = registry.byId("materContent");  //商品介绍
            this.materCom = registry.byId("materCom");// 推荐信息
            this.XXmsg = registry.byId("XXmsg"); //温馨提示
            this.XXeva = registry.byId("XXeva"); //评价
            this._tabs_ul = query("#tabs-ul",this.domNode)[0]; // 标题
        },
        initMatDetailEvent:function(){
            this.connect(this.MatDetailList,"onDefRendered",function(data){
                window.busy();
                setTimeout(lang.hitch(this,function(){
                    this.matMsg = query(".matMsg",this.MatDetailList.domNode)[0];
                    this.totalNum = query(".totalNum",this.MatDetailList.domNode)[0];
                    var totalNum1 = this.totalNum.innerHTML.substring(0,2);
                    var totalNum = parseInt(this.totalNum.innerHTML.substring(2),10);
                    
                    if(totalNum<1000){
                    }else if(totalNum<10000){
                        this.totalNum.innerHTML = totalNum1 + (totalNum/1000==1?totalNum/1000+"千":(totalNum/1000+"").substring(0,(totalNum/1000+"").indexOf('.')+3)+"千+");
                    }else if(totalNum<100000000){
                        this.totalNum.innerHTML = totalNum1 + (totalNum/10000==1?totalNum/10000+"万":(totalNum/10000+"").substring(0,(totalNum/10000+"").indexOf('.')+3)+"万+");
                    }else{
                        this.totalNum.innerHTML = totalNum1 + (totalNum/100000000==1?totalNum/100000000+"亿":(totalNum/100000000+"").substring(0,(totalNum/100000000+"").indexOf('.')+3)+"亿+");
                    }
				}),100);
				
				this.mdlfree = true;
				this.addfreefn();
            });
            this.connect(this.materDetail01,"onDefRendered",function(){
               this.md01free = true;
               this.addfreefn();
            });
            this.connect(this.materContent,"onDefRendered",function(){
                this.mconfree = true;
                this.addfreefn();
            });
            this.connect(this.XXeva,"onDefRendered",function(){
                this.xxevafree = true;
                this.addfreefn();
            });
            
            // 修改图片信息
            this.connect(this.picItemsScan, "onBeforeRender", function() {
                if (this.picItemsScan.items.length > 0) {
                    array.forEach(this.picItemsScan.items, function(item) {
                        item.src = "/w/img/load/" + g_sys_info.code + "-" + item.DID + ".png";
                        item.title = "";
                    });
                }
            });
        },
        
        // 由原来的window.fsData 演变而来 分时限购数据
        fsData: [],
        // 由原来的window.priceData 演变而来 预售数据
        priceData: [],
        // 优惠券
        hasCoupons: false,
        // 在刷新list2之前去取到要用到的预售数据
        loadDataFuc:function(){
            var def = new Deferred();
            var didParam = window.did.split("_")[window.did.split("_").length - 1];
            window.preData = [];
            window.preDataDts = [];
            
            // 判断商家是否有优惠券
            couponMixin.getAppCoupons().then(lang.hitch(this,function(hasCoupons){
                this.hasCoupons = hasCoupons;
            })).then(lang.hitch(this,function(){
                // 查询商品是否有分时限购活动
                window.loadData({
                    modalName:"NY_TSDCD_PRICEDTS",
                    filter:"03",
                    pageSize:"2",
                    pageIndex:"1",
                    param:{"MID":didParam}
                }).then(lang.hitch(this,function(priceData){
                    this.priceData = priceData;
                    window.loadData({
                        modalName:"NY_TBSSC_MAT_ACTIVITY",
                        filter:"01",
                        pageSize:"1",
                        pageIndex:"1",
                        param:{"MID":didParam,"CURTIME":g_s.getDateTime()}
                    }).then(lang.hitch(this,function(fsData){
                        window.fsData = this.fsData = fsData;
                    window.loadData({
                        modalName:"XSY_TCRMK_MAT_ADSALE",//预售主表
                        filter:"01",
                        pageSize:"1",
                        pageIndex:"1",
                        param:{"MID":didParam}
                    }).then(lang.hitch(this,function(data){
                        // 如果是预售商品
                        if(data.length){
                            // 修改商品的标记
                            window.preData = data;
                            window.loadData({
                                modalName:"XSY_TCRMK_MAT_ADSALEDTS",
                                filter:"01",
                                pageSize:"1",
                                pageIndex:"1",
                                param:{DID:window.preData[0].DID}
                            }).then(lang.hitch(this,function(dataDts){//预售明细
                                window.preDataDts = this.preDataDts = dataDts;
                                if (didParam != this.mid) {
                                    this.mid = didParam;
                                    //刷新图片
                                    this.picItemsScan.where = "[RID]='XSY_TBSSC_MAT' AND [RIID]=" + didParam;
                                    this.picItemsScan.refresh();
                                }
                                this.MatDetailList.refreshList(); /*刷新商品基本信息*/
                                this.materContent.refreshList();/*刷新商品介绍*/
                                this.materCom.refreshList();/*刷新推荐信息*/
                                this.XXmsg.refreshList();/*刷新温馨提示*/
                                this.XXeva.refreshList();/*刷新评价*/
                                this.bgMatInfoList.refreshList();
                                def.resolve();
                            }));
                        }else{
                            if (didParam != this.mid) {
                                this.mid = didParam;
                                //刷新图片
                                this.picItemsScan.where = "[RID]='XSY_TBSSC_MAT' AND [RIID]=" + didParam;
                                this.picItemsScan.refresh();
                            }
                            this.MatDetailList.refreshList(); /*刷新商品基本信息*/
                            this.materContent.refreshList();/*刷新商品介绍*/
                            this.materCom.refreshList();/*刷新推荐信息*/
                            this.XXmsg.refreshList();/*刷新温馨提示*/
                            this.XXeva.refreshList();/*刷新评价*/
                            this.bgMatInfoList.refreshList();
                        }
                        def.resolve();
                    }));
                }));
            }));
        }));
            return def;
        },
        refreshAllList:function(){
            var car = orderCarRecord.getOrderCar(),n = 0;
            for(var mid in car){
                n += car[mid]||0;
            }
            if(query(".stdOrderNum",this.domNode)[0]){
                query(".stdOrderNum",this.domNode)[0].innerHTML = n;
            }
            this.loadDataFuc();
            if(query("#buynum",this.bgPane)[0]) {
                domAttr.set(query("#buynum",this.bgPane)[0],"value","1");
            }
            this.inherited(arguments);
        },
        _tabs_ul_fuc:function(e){
            var dom = e.target;
            while(dom&&"li"!==dom.tagName.toLowerCase()&&dom!=this._tabs_ul){
                dom = dom.parentNode;
            }
            if(dom&&"li"==dom.tagName.toLowerCase()){
                //设置样式
                domClass.remove(query(".on",this._tabs_ul)[0],"on");
                domClass.add(dom,"on");
                
                var domId = domAttr.get(dom,"id");
                dom = this._tabs_ul.nextSibling;
                while(dom){
                    if(dom.tagName&&"div"===dom.tagName.toLowerCase()){
                        domStyle.set(dom,"display",domId===domAttr.get(dom,"class")?"":"none");
                    }
                    dom = dom.nextSibling;
                }
            }
        },
        //当前界面点击事件响应函数
        _MatDetailClick:function(e){
            if (e.target) {
                if (domClass.contains(e.target,"add")) {
                    this._addMatNum(1);
                } else if (domClass.contains(e.target,"dec")) {
                    this._addMatNum(-1);
                }
            }
        },
        //当前商品选中数量变更响应
        _addMatNum:function(inc){
            var matNode = query("#buy_num",this.domNode),msg = "";
            matNode = matNode.length&&matNode[0];
            if(matNode){
                // 页面上显示
                //增加数量时  如果超过库存或者限购数量则不能增加
                var matNum = inc-0+(matNode.value-0);
                if(0<matNum){
                    if(matNum<=this.matShelfQty){
                        query("#show_msg",this.domNode)[0].style.display = "none";
                        if(this.TPCH_NUM>0&&matNum>this.TPCH_NUM){
                            query("#show_msg",this.domNode)[0].style.display = "";
                            query("#show_msg",this.domNode)[0].innerHTML = "超过限购数量。";
                        }else{
                            matNode.value = matNum;
                            query("#show_msg",this.domNode)[0].style.display = "none";
                        }
                    }else{
                        query("#show_msg",this.domNode)[0].style.display = "";
                        query("#show_msg",this.domNode)[0].innerHTML = "库存不足。";
                    }
                }
            }
        },
        //更新优惠积分的显示
        _updateBonusPointsInfo:function(msg){
            //优惠信息
            var node1 = query(".BonusPoint",this.domNode)[0];
            var node = query(".BonusPoints",this.domNode)[0];
            domStyle.set(node,"display",msg?"":"none");
            domStyle.set(node1,"display",msg?"":"none");
            node.innerHTML = msg;
        },
        //更新运费信息的显示
        _updateBonusLogisticsInfo:function(msg){
            //运费信息
            query(".logisticsInfo",this.domNode)[0].innerHTML = msg;
        }
    });
});