define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojox/mobile/Rating",
    "dojo/_base/lang", 
    "widgets/userInfo",
    "dojo/_base/array",
    "dojo/query",
    "dojo/dom-attr",
    "dojo/dom-style",
    ], function(declare, registry, Rating,lang,userInfo,array,query,domAttr,domStyle) {
    return declare("widgets.common._MatEvaListMixin", null, {
        isMatEvaListLoaded:function(){
            return !!this.eList;
        },
        indexMatEvaListElement:function(){
            this.evaHead = query(".evaHead")[0];//找到订单列表的头部
            this.eList = registry.byId("evaList");
            this.inherited(arguments);
        },
        refreshAllList: function() {
            this.inherited(arguments);
            window.updateTitle("评价列表");
            userInfo.hasLogin().then(lang.hitch(this, function(s) {
                if (s) {
                    this.eList.refreshList();
                } else {
                    window.nextPageOnLogin = "matEvaList";
                    userInfo.showLogin();
                }
            }));
            this.scrollTo({
                x: 0,
                y: 0
            });
            /*domStyle.set(query(".evaHead")[0],"border-bottom","1px solid #ff6633");*/
        },
        initMatEvaListEvent:function(){
            this.inherited(arguments);
            if(this.evaHead){// 判断是否有商品列表中的排序节点
               /* domStyle.set(query(".evaHead")[0],"border-bottom","1px solid #ff6633");*/
                this.connect(this.evaHead,"onclick",function(e){
                    window.busy();
                    var dom = e.target;
                    if(dom&&dom.tagName.toLowerCase()=="li"){
                        var cls = domAttr.get(dom,"class"),
                        name = domAttr.get(dom,"name");
                        this.clearState(dom,name);
                        domAttr.set(dom,"class",(("tableLiChecked"===cls)||cls=="")?"tableLi":"tableLiChecked");
                        domAttr.set(dom,"class","tableLiChecked");
                        registry.byId(name).domNode.style.display = "";
                        registry.byId(name).refreshList();
                        window.free();
                    }
                });
            }
        },
        clearState:function(node,name){
            if(this.evaHead){
                query("li",this.evaHead).forEach(function(n){
                    if(n!==node){
                        domAttr.set(n,"class","tableLi");
                        //n.style.display = "none";
                    }
                });
                array.forEach(["evaList","wbEvaList"],function(node){
                    if(node!=name){
                        registry.byId(node).domNode.style.display = "none";
                    }else{
                        registry.byId(name).domNode.style.display = "";
                    }
                });
            }
        }
    });
});