define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojox/mobile/Rating",
    "dojo/query",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "dojo/_base/lang",
    "widgets/userInfo",
    "dijit/registry"
    ], function(declare, array, Rating, query, json, xhr, lang, userInfo, registry) {
    return declare("widgets.common._MatEvaMixin", null, {
        isMatEvaLoaded:function(){
            return !!this.subEvaEle;
        },
        indexMatEvaElement: function() {
            this.inherited(arguments);
            var node = query(".star", this.domNode)[0];
            var scoreWidget = this.scoreWidget = new Rating({
                image: "../../Content/htapp/images/star-orange.png",
                numStars: 5,
                value: 5,
                id: "rating"
            });
            node.appendChild(this.scoreWidget.domNode);
            this.scoreWidget.on("click", function(e) {
                var node = e.target;
                while (node && node.parentNode !== this) {
                    node = node.parentNode;
                }
                scoreWidget.set("value", array.indexOf(this.childNodes, node) + 1);
            });
            this.subEvaEle = query(".subEva", this.domNode)[0];
        },
        refreshAllList: function() {
            this.inherited(arguments);
            this.scoreWidget.set("value", window.score = 5);
            if (window.did) {
                var params = window.did.split("_");
                if (params.length === 1) {
                    this.did = params[0]; //评论ID
                    window.loadData({
                        modalName: "XSY_TBSAV_MAT_CMMNT",
                        where: "[DID]='" + this.did + "'"
                    }).then(lang.hitch(this, function(data) {
                        if (data.length) {
                            this.scoreWidget.set("value", data[0].SCORE);
                            query(".evaContent", this.domNode)[0].value = data[0].CONTENT;
                        } else {
                            this.did = "";
                        }
                    }));
                    window.updateTitle("修改评价");
                } else if (params.length == 2) {
                    this.wbid = params[0];
                    this.wcid = params[1];
                    this.did = "";
                    window.updateTitle("服务评价");
                } else {
                    this.did = "";
                    this.eid = params[0]; //订单明细ID
                    this.mid = params[1]; //商品ID
                    this.entryId = params[2];
                    this.wbid = params[3];
                    window.updateTitle("商品评价");
                }
            }
        },
        initMatEvaEvent: function() {
            this.inherited(arguments);
            this.connect(this.subEvaEle, "onclick", this.subEva);
        },
        realSub: function(data,a,score) {
            xhr("POST", {
                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    data: json.toJson({
                        modalName: "APP_TBSAV_CMMNT",
                        data: [data]
                    })
                },
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        alert("发表评论成功。");
                        if (this.did) {
                            window.moveToView("matEvaList", "");
                        } else if (this.wbid) {
                                if(window.code==="SVC11105"){
                                    window.moveToView("wbList_sjmd");
                                }else{
                                    window.moveToView("wbList");
                                }
                            } else {
                            window.moveToView("orderDetail", this.entryId);
                        }
                        window.free();
                        query(".evaContent", this.domNode)[0].value = "";
                        this.scoreWidget.set("value", window.score = 5);

                    } else {
                        alert(result.message || "数据错误!");
                        query(".evaContent", this.domNode)[0].value = "";
                        this.scoreWidget.set("value", window.score = 5);
                        window.free();
                    }
                })
            });
            //修改订单明细的已评价
            if (!this.did && !this.wbid) {
                xhr("POST", {
                    url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                    handleAs: "json",
                    content: {
                        data: json.toJson({
                            modalName: "XSY_TSDSG_DELIVERYBILLDTS",
                            data: [{
                                n: {
                                    IS_EVA: 1
                                },
                                o: {
                                    EntryID: this.eid
                                }
                            }]
                        })
                    }
                });
                //修改商品的评价评价和累计评价
                xhr("POST",{
                    url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                    handleAs: "json",
                    content: {
                        data: json.toJson({
                            modalName: "XSY_TBSSC_MAT_DESIGN",
                            data: [{
                                n: {
                                    EVAS: parseFloat(a[0].EVAS||0)+1,
                                    AV_EVAS:(parseFloat(a[0].EVAS||0)*parseFloat(a[0].AV_EVAS||0)+parseFloat(score))/(parseFloat(a[0].EVAS||0)+1)
                                },
                                o: {
                                    MID: this.mid
                                }
                            }]
                        })
                    }
                });
            }
            if (this.wbid) {
                //修改工单的已评价
                xhr("POST", {
                    url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                    handleAs: "json",
                    content: {
                        data: json.toJson({
                            modalName: "XSY_TSCSF_WB",
                            data: [{
                                n: {
                                    IS_EVA: 1
                                },
                                o: {
                                    WBID: this.wbid
                                }
                            }]
                        })
                    }
                });
            }
        },
        subEva: function() { //提交评价
            var con = query(".evaContent", this.domNode)[0].value,
                score = this.scoreWidget.get("value");

            if (score == 0) {
                alert("请先给本次评价给分。");
                return;
            }
            if (!con) {
                alert("请填写评价内容。");
                return;
            }
            window.busy();
            userInfo.hasLogin().then(lang.hitch(this, function(success) {
                if (success) {
                    var data = this.did ? {
                        n: {
                            CONTENT: con,
                            SCORE: score
                        },
                        o: {
                            "DID": this.did
                        }
                    } : this.wbid ? {
                        n: {
                            CONTENT: con, // 评价内容
                            RID: "XSY_TBSSC_WC",// 评价对象资源
                            RIID: this.wcid, // 评价对象ID
                            AID: g_sys_info.aid, // 帐套
                            PID: window.userInfo.partnerId, // 客户ID
                            TITLE: "", // 标题
                            WBID: this.wbid, // 工单ID
                            //BILLID: this.eid,
                            MAKER: userInfo.getUserInfo().name, // 客户名称
                            SCORE: score  // 得分
                        }
                    } : {
                        n: {
                            CONTENT: con,
                            RID: "XSY_TBSSC_MAT",
                            RIID: this.mid,
                            AID: g_sys_info.aid,
                            PID: window.userInfo.partnerId,
                            TITLE: "",
                            BILLID: this.eid,
                            MAKER: userInfo.getUserInfo().name,
                            SCORE: score
                        }
                    };
                    if(this.mid){
                        window.loadData({
                            modalName: "XSY_TBSSC_MAT_DESIGN",
                            filter:"01",
                            pageSize:"1",
                            pageIndex:"1",
                            param:{"MID":this.mid}
                        }).then(lang.hitch(this,function(a){
                            this.realSub(data,a,score);
                        }));
                    }else{
                        this.realSub(data);
                    }
                }else{
                    alert("您还未登录，请登录后再做评价。");
                }
            }));
        }
    });

});