define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "dojo/_base/lang",
    "../userInfo",
    "dojo/query"
    ], function(declare, registry, array, json, xhr, lang, userInfo, query) {
    return declare("widgets.common._MatLegalMixin", null, {
        isMatLegalLoaded:function(){
            return !!this.legalReason;
        },
        indexMatLegalElement: function() {
            array.forEach(["legalReason", "legalMethods", "legalRemark", "legalSubmit"], function(cls) {
                this[cls] = query("." + cls, this.domNode)[0];
            }, this);
            this.orderDtl = registry.byId("orderDtl");
        },
        getAID: function(item) {
            return item && item.toString();
        },
        refreshAllList: function() {
            if (window.titleNode) {
                window.titleNode.innerHTML = "商品投诉";
            }
            if (window.did) {
                var a = window.did;
                window.did = a.split("_")[0];
                window.bid = a.split("_")[1];
            }
            this.refOrderDtl();
        },
        refOrderDtl: function() {
            window.loadData({
                modalName: "XSY_TSDSG_DELIVERYBILLDTS",
                filter: "02",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "EntryID": window.did
                }
            }).then(lang.hitch(this, function(data) {
                var aid = data[0].AID;
                window.loadData({
                    modalName: "XSY_TSSCF_APP",
                    filter: "999",
                    pageSize: "1",
                    pageIndex: "1",
                    param: {
                        "INPUT": "",
                        "AID": aid
                    }
                }).then(lang.hitch(this, function(data1) {
                    window.DIRPLATFORM = data1[0].PLATFORM;
                    this.orderDtl.refreshList();
                }));
            }));
        },
        initMatLegalEvent: function() {
            this.connect(this.orderDtl, "onDefRendered", function(data) { //加载购物车list2之前
                if (data.data.items.length) {
                    window.AID = this.getAID(data.data.items[0].T0_AID); //分销货主
                    window.DIRAID = this.getAID(data.data.items[0].T4_AID); //供货货主
                    //window.DIRPLATFORM = data.data.items[0].T0_AID;//供货货主平台
                    window.PLATFORM = this.getAID(data.data.items[0].T0_PLATFORM); //分销货主平台
                    window.A1 = data.data.items[0].T4_A1; //订单号
                }
            });
            this.connect(this.legalSubmit, "onclick", this.legalSubmitTo);
        },
        legalSubmitTo: function() {
            if (this.legalReason.value == -1) {
                alert("请选择投诉原因。");
                return;
            }
            if (this.legalMethods.value == -1) {
                alert("请选择您希望的处理方式。");
                return;
            }
            if (!this.legalRemark.value && (this.legalReason.value == 2 || this.legalMethods.value == 3)) {
                alert("请填写备注。");
                return;
            }
            window.busy();
            userInfo.hasLogin().then(lang.hitch(this, function(success) {
                if (success) {
                    this.postMatLegal();
                } else {
                    alert("您还未登录，请登录后再评价。");
                    window.free();
                }
            }));
        },
        postMatLegal: function() {
            xhr("POST", {
                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    data: json.toJson({
                        modalName: "XSY_TWBCM_SERVICE",
                        data: [{
                            n: {
                                SRC: 1,
                                PARTNER: userInfo.getUserInfo().name,
                                BILLID: window.did,
                                AID: window.AID, //分销货主
                                DIRAID: window.DIRAID, //供货货主
                                DIRPLATFORM: window.DIRPLATFORM, //供货货主平台
                                PLATFORM: window.PLATFORM, //分销货主平台
                                RQRSN: this.legalReason.value,
                                RQSLTN: this.legalMethods.value,
                                RQRMRK: this.legalRemark.value,
                                PID: userInfo.getUserInfo().partnerId,
                                BILLCODE: window.A1
                            }
                        }]
                    })
                },
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        alert("提交投诉成功。");
                        window.free();
                        this.legalRemark.value = "";
                        this.legalReason.value = -1;
                        this.legalMethods.value = -1;
                        window.moveToView("orderDetail", window.bid);
                    } else {
                        alert(result.message || "数据错误!");
                        this.legalRemark.value = "";
                        this.legalReason.value = -1;
                        this.legalMethods.value = -1;
                        window.free();
                    }
                })
            });
        }
    });
});