define([
    "dojo/_base/declare", 
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/query",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-class",
    "dijit/focus"
], function(declare, registry,domAttr,query,array,lang,domStyle,domClass,focusUtil) {
    return declare("widgets.common._MatListMixin",null,{
        // 当前分类ID
        currentmgid:window.did.split("_").length>1?"":window.did,
        // 替换掉刷新商品列表的字段
        fieldMap:{
            PGName:"T0_ProductGroupID.PGName",
            MGName:"T4_MGName",
            TPCH_NUM:"T0_TPCH_NUM",
            MGID:"T0_MGroupID"
        },
        // 参数带aid的默认过滤器
        defultAidFlt:"20",
        // 参数带aid的默认过滤参数
        defultAidParam:{
            "APP_ID":"",
            "INPUT":""
        },
        // 自己商品列表默认过滤器
        defultMFlt:"18",
        // 自己商品列表过滤参数
        defultMParam:{
            "MGID":"",
            "INPUT":""
        },
        // 当前分类名称
        mGroupName:"",
        // 是否加载好数据
        isMatListLoaded:function(){
            return !!this.matList;
        },
        onBeforeTransitionOut:function(){
            // 去掉节点的光标事件
            var activeElement = focusUtil.curNode;
            focusUtil.curNode && focusUtil.curNode.blur();
            this.inherited(arguments);
        },
        setMr:function(){
            if(this.order_control){
                this.matList.rs_wb_order = "ISNULL([T12_TOTAL_SALE],[T18_TOTAL_SALE]) DESC";
                query("a",this.order_control).forEach(function(n){
                    if(!domAttr.get(n,"changeViewEf")){
                        if(domAttr.get(n,"name")=="ISNULL([T12_TOTAL_SALE],[T18_TOTAL_SALE])"){
                            domAttr.set(n,"class","arrow-down");
                            domAttr.set(n,"selected","true");
                        }else{
                            domAttr.set(n,"class","");
                            domAttr.set(n,"selected","false");
                        }
                    }
                });
            }
        },
        refreshAllList:function(){
            this.setMr();
            if(window.did.indexOf('aid_')>-1){
                this.did = window.did;
                this.aid = window.did.split("_")[1];
                this.matList.rs_wb_flt = this.defultAidFlt;
                this.defultAidParam.APP_ID = window.did.split("_")[1];
                this.matList.rs_wb_param = "("+JSON.stringify(this.defultAidParam)+")";
                this.matList.refreshList();
                this.curMatList = this.matList;
            }else if(window.did.indexOf('std_')>-1){
                this.did = window.did;
                this.matList.rs_wb_flt = "24";
                this.matList.rs_wb_param = "({MGID:"+window.did.split("_")[1]+",INPUT:''})";
                this.matList.refreshList();
                this.curMatList = this.matList;
            }else if(window.did.indexOf('matgroup_')>-1){
                this.did = window.did;
                this.matList.rs_wb_flt = "03";
                this.matList.rs_wb_param = "({AID:"+window.did.split("_")[1]+",MGID:"+window.did.split("_")[2]+",INPUT:''})";
                this.matList.refreshList();
                this.curMatList = this.matList;
            }else if(window.did.indexOf('dist_')>-1){
                this.did = window.did;
                this.matList.rs_wb_flt = "27";
                this.matList.rs_wb_param = "({DistID:"+window.did.split("_")[1]+",PGID:"+window.did.split("_")[2]+",INPUT:''})";
                this.matList.refreshList();
                this.curMatList = this.matList;
            }else{
                //if (window.did != this.did) {
                    this.did = window.did;
                    this.matList.rs_wb_flt = this.defultMFlt;
                    this.defultMParam.MGID = this.currentmgid||"";
                    this.matList.rs_wb_param = "("+JSON.stringify(this.defultMParam)+")";
                    this.matList.refreshList();
                //}else{
                    window.updateTitle(this.mGroupName);
                //}
                this.curMatList = this.matList;//记录当前list2
            }
            setTimeout(window.free,100);
        },
        indexMatListElement:function(){
            //找到商品列表中的排序
            this.order_control = query(".order_control",this.bodyNode)[0];
            //得到matlist节点的id
            this.matList = registry.byId("materList");
            this.searchMatBtn = query(".btn-search",this.bodyNode)[0];
            this.searchName = document.getElementById('search_name');
        },
        matControlClick:function(e){
            var dom = e.target;
            while(dom&&"a"!==dom.tagName.toLowerCase()&&dom!=this.order_control){
                dom = dom.parentNode;
            }
            if(dom&&dom!==this.order_control){
                if(!domAttr.get(dom,"changeViewEf")){
                    var name = domAttr.get(dom,"name");
                    var cls = domAttr.get(dom,"class");
                    var orderDesc = domAttr.get(dom,"orderDesc");
                    var selected = domAttr.get(dom,"selected");
                    if(selected=="true"){
                        //更新查询条件
                        domAttr.set(dom,"class",(cls===""||cls==="arrow-down")?"arrow-up":"arrow-down");
                        this.curMatList.rs_wb_order = name?((cls===""||cls==="arrow-down")?name:name+" DESC"):"";
                    }else{
                        domAttr.set(dom,"selected","true");
                        this.curMatList.rs_wb_order = name+" "+orderDesc;
                        domAttr.set(dom,"class",orderDesc==="DESC"?"arrow-down":"arrow-up");
                    }
                    this._clearSearchBarStart(dom);
                    this.curMatList.refreshList();
                }else{
                    this.changeClass(dom);
                }
            }
        },
        changeClass:function(dom){
            domAttr.set(dom,"class",domAttr.get(dom,"class")==="verticalList2"?
            "levelList":"verticalList2");
            if(domClass.contains(this.matList.domNode,"n-list")){
                domClass.remove(this.matList.domNode,"n-list");
                domClass.add(this.matList.domNode,"n-l-list");
            }else{
                domClass.remove(this.matList.domNode,"n-l-list");
                domClass.add(this.matList.domNode,"n-list");
            }
        },
        handleMatListData:function(data){
            var items = data.data.items;
            if(!window.did||window.did.indexOf("aid_")>-1){
                //界面标题更新为商品列表
                this.mGroupName = "商品列表";
            }else if(window.did.indexOf("std_")>-1){
                //界面标题为品类名"T0_ProductGroupID.PGName"
                this.mGroupName = items[0][this.fieldMap.PGName];
            }else{
                //界面标题为商品类别//"T4_MGName"
                if(items.length){
                    this.mGroupName = items[0][this.fieldMap.MGName];
                }else{
                    this.mGroupName = '暂无商品';
                }
            }
            array.forEach(items,function(item,i){
                if((i+1)%2==1){
                    item.li = "left";
                    item.matlistli = "left";
                }else{
                    item.li = "right";
                    item.matlistli = "right";
                }
                if(item[this.fieldMap.TPCH_NUM]&&item[this.fieldMap.TPCH_NUM]!=0)
                {
                    item.IS_XG = 1;
                }
                else
                {
                    item.IS_XG = 0;
                }
            },this);
            //处理界面的标题
            window.updateTitle(this.mGroupName);
        },
        initMatListEvent:function(){
            this.connect(this.matList, "onDefRendered", function(data) {
                this.handleMatListData(data);
            });
            if(this.searchMatBtn){
                this.searchMatBtn.onclick = lang.hitch(this,this._onMatListSearch);
            }
            if(this.searchName){
                this.searchName.onkeydown = lang.hitch(this,function(){
                    if(event.keyCode==13){
                        this._onMatListSearch();
                    }
                });
            }
            if(this.order_control){// 判断是否有商品列表中的排序节点
                this.connect(this.order_control,"onclick",this.matControlClick);
            }
        },
        _clearSearchBarStart:function(node){
            if(this.order_control){
                query("a",this.order_control).forEach(function(n){
                    if(n!==node&&!domAttr.get(n,"changeViewEf")){
                        domAttr.set(n,"class","");
                        domAttr.set(n,"selected","false");
                    }
                });
            }
        },
        _onMatListSearch:function(){
            // 去掉节点的光标事件
            var activeElement = focusUtil.curNode;
            focusUtil.curNode && focusUtil.curNode.blur();
            
            if(window.did.indexOf("aid_")>-1){
                this.defultAidParam.INPUT = this.searchName.value;
                this.curMatList.rs_wb_param = "("+JSON.stringify(this.defultAidParam)+")";//{APP_ID:'"+window.did.split("_")[1]+"',MGID:'"+this.currentmgid+"',INPUT:'"+this.searchName.value+"'}
            }else if(window.did.indexOf("std_")>-1){
                this.curMatList.rs_wb_param = "({MGID:'"+window.did.split("_")[1]+"',INPUT:'"+this.searchName.value+"'})";
            }else{
                this.defultMParam.INPUT = this.searchName.value;
                this.curMatList.rs_wb_param = "("+JSON.stringify(this.defultMParam)+")";//{MGID:'"+this.currentmgid+"',INPUT:'"+this.searchName.value+"'}
            }
            this.curMatList.refreshList();
        },
    });
});