define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/query",
    "dojo/dom-class",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "../userInfo",
    "dojo/_base/lang"], function(declare, registry, array, domAttr, domStyle, query, domClass, json, xhr, userInfo, lang) {
    return declare("widgets.common._MatOptionMixin", null, {
        isMatOptionLoaded:function(){
            return !!this.matOPTEle;
        },
        indexMatOptionElement: function() {
            this.matOPTEle = registry.byId("matOPT");
            //this.optsPost = query(".optsPost")[0];
            this.errorInfo = query(".errorInfo")[0];
            this.matRemark = query(".matRemark")[0];
            this.remark = query(".errorInfo1")[0];
        },
        refreshAllList: function() {
            window.updateTitle("");
            this.b = window.did;
            this.a = window.did.split("_");
            this.did = window.did = this.a[0]; //
            this.inherited(arguments);
            userInfo.hasLogin().then(lang.hitch(this, function(s) {
                if (s) {
                    this.matOPTEle.refreshList();
                } else {
                    window.nextPageOnLogin = "matOption-" + this.b;
                    userInfo.showLogin();
                }
            }));
            this.scrollTo({
                x: 0,
                y: 0
            });
        },
        initMatOptionEvent: function() {
            this.connect(this.matOPTEle, "onDefRendered", function(data) {
                if (data.data.items.length) {
                    items = data.data.items;
                    window.ttlNum = items[0].T0_O_MAX;
                    window.updateTitle(items[0].T0_O_TAG);
                    window.tag = items[0].T0_O_TAG;
                    if(data.data.items[0].T0_REMARK){
                        this.remark.innerHTML = data.data.items[0].T0_REMARK;
                        domStyle.set(this.remark,"display","");
                    } else {
                        domStyle.set(this.remark,"display","none");  
                    }
                }
            });
            this.connect(this.matOPTEle.domNode, "onclick", this.matOPTEleClick);
        },
        matOPTEleClick: function(e) {
            var dom = e.target;
            if (dom) {
                var c = domAttr.get(dom, "name");
                if (-1 < c.indexOf("opts")) {
                    this.optToSel(dom);
                }
            }
        },
        optToSel: function(dom) {
            while (dom && "span" !== dom.tagName.toLowerCase() && dom != this.matOPTEle) {
                dom = dom.parentNode;
            }
            if (dom) {
                this.checkOpts(dom);
            }
        },
        checkOpts: function(dom) {
            var name = domAttr.get(dom, "name"),
                cls = domAttr.get(dom, "class"),
                nodes = this.matOPTEle.domNode,
                i = 0;
            if (this.matOPTEle.domNode.children) { //如果有选菜记录registry.byId("matOPT").domNode.children
                array.forEach(nodes.children, function(node) {
                    if (domClass.contains(node, "optSelected")) {
                        if (cls === "optUnSelected") {
                            i++;
                        } else {
                            i--;
                        }
                    }
                });
                if (i - (window.ttlNum - 0 + 0) >= 0) {
                    this.updateInfo("最多可选" + window.fixedTo(window.ttlNum, 0) + "种");
                    return;
                } else {
                    this.updateInfo();
                }
                domAttr.set(dom, "class", (("optSelected" === cls) || cls === "") ? "optUnSelected" : "optSelected");
            }
        },
        updateInfo: function(info) {
            if (info) {
                this.errorInfo.innerHTML = info;
                domStyle.set(this.errorInfo,"display","");
            } else {
                this.errorInfo.innerHTML = "";
                domStyle.set(this.errorInfo,"display","none");
            }
        },
        onShelfLoaded:function(){
            // 修改footer的样式
            domClass.add(this.footerFloor.boxes[0].domNode,"post");
            // 侦听事件
            this.connect(this.footerFloor.boxes[0].domNode,"onclick",this.optsPostClick);
        },
        optsPostClick: function() {
            window.busy();
            var nodes = this.matOPTEle.domNode,
                remark = "";
            array.forEach(nodes.children, function(node) {
                if (domClass.contains(node, "optSelected")) {
                    remark = remark + node.innerHTML + "，";
                }
            });
            if (!remark) {
                this.updateInfo("请先选菜");
                window.free();
                return;
            }
            remark = remark.substring(0, remark.length - 1);
            this.updateInfo();
            //userInfo.hasLogin().then(lang.hitch(this, function(success) {
            //    if(success){
            //var data,
            //var d = g_s.getDateTime();//new Date();
            //d = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds();
            //查询最近两天的选菜记录
            //window.loadData({
            //    modalName: "XSY_TSDSG_REMARK",
            //    filter: "01",
            //    pageSize: "1",
            //    pageIndex: "1",
            //    param: {
            //        "PID": window.userInfo.partnerId
            //    }
            //}).then(lang.hitch(this, function(reData) {
            //    if (!reData.length) {
            //        data = {
            //            n: {
            //                TXT: remark,
            //                PID: window.userInfo.partnerId,
            //                AID: g_sys_info.aid,
            //                Remark: this.matRemark.value,
            //                GName: window.tag
            //            }
            //        };
            //    } else {

            //        data = {
            //            n: {
            //                TXT: remark,
            //                DT: d,
            //                Remark: this.matRemark.value,
            //                GName: window.tag
            //            },
            //            o: {
            //                DID: reData[0].DID
            //            }
            //        };
            //    }
            this.postRemark(remark);
            //}));
            //    }else{
            //        alert("您还未登录，请登录后再选菜。");
            //    }
            //}));
        },
        postRemark: function(remark) {
            xhr("POST", {
                url: "../../data/UpdateMatoption/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    //data: json.toJson({
                    //    modalName: "XSY_TSDSG_REMARK",
                    //    data: [data]
                    //})
                    entryId: this.a[2],
                    txt: remark,
                    rmk:this.matRemark.value
                },
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        alert("选菜成功。");
                        this.matRemark.value = "";
                        window.free();
                        window.moveToView("orderDetail", this.a[1]);
                    } else {
                        alert(result.message || "数据错误!");
                        this.matRemark.value = "";
                        window.free();
                    }
                })
            });
            // 修改订单明细的备注字段
            //xhr("POST", {
            //    url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
            //    handleAs: "json",
            //    content: {
            //        data: json.toJson({
            //            modalName: "XSY_TSDSG_DELIVERYBILLDTS",
            //            data: [{
            //                n: {
            //                    Remark: d + " 已选：" + remark
            //                },
            //                o: {
            //                    EntryID: this.a[2]
            //                }
            //            }]
            //        })
            //    }
            //});
        }
    });
});