define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/query",
    "cqthink/mobile/geoUtil",
    "dojo/_base/lang",
    "widgets/userInfo",
    "dojo/_base/json",
    "dojo/_base/xhr"
],function(declare,registry,array,domAttr,query,geoUtil,lang,userInfo,json,xhr){
    return declare("widgets.common._MdfRouteMixin",null,{
        isMdfRouteLoaded:function(){
            return !!this.routeDtl;
        },
        indexMdfRouteElement:function(){
            this.routeDtl = registry.byId("routeDtl");
            this.mdfRouteTimePicker = registry.byId("mdfRouteTimePicker");
            this.mdfTtimePicker = registry.byId("mdfTtimePicker");
            this.ok = query(".ok",this.mdfRouteTimePicker.domNode)[0];
            this.cancel = query(".cancel",this.mdfRouteTimePicker.domNode)[0];
            this.postMdfRouteButton = query(".postMdfRouteButton",this.domNode)[0];
        },
        initMdfRouteEvent:function(){
            this.connect(this.routeDtl,"onDefRendered",function(data){
                array.forEach(data.data.items,function(item){
                    item.time = item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                });
            });
            this.connect(this.routeDtl.domNode,"onclick",function(e){
                var dom = e.target;
                while(dom&&dom.tagName!="DIV"&&dom!=this.routeDtl.domNode){
                    dom = dom.parentNode;
                }
                //选择起点
                if(dom&&dom.tagName=="DIV"){
                    var id = domAttr.get(dom,"id"),cls = domAttr.get(dom,"class");
                    if(id=="startPoint1"){
                        window.moveToView("choosePlace",query(".startCity",this.routeDtl.domNode)[0].innerHTML+"_mdfRouteStart_"+window.did);
                    }else if(id=="endPoint1"){
                        window.moveToView("choosePlace",query(".endCity",this.routeDtl.domNode)[0].innerHTML+"_mdfRouteEnd_"+window.did);
                    }else if(id=="startCity1"){
                        window.moveToView("chooseCity","mdfRouteStart_"+window.did);
                    }else if(id=="endCity1"){
                        window.moveToView("chooseCity","mdfRouteEnd_"+window.did);
                    }else if(id=="routeTime1"){
                        //选择时间
                        this.mdfRouteTimePicker.show();
                    }else if(cls=="routeCycle"){
                        this.changeCycle(e);
                    }
                }
            });
            this.subscribe("cqthink/wx/chooseCity/startCity/mdfRoute",function(name){
                query(".startCity",this.routeDtl.domNode)[0].innerHTML = name;
            });
            this.subscribe("cqthink/wx/chooseCity/endCity/mdfRoute",function(name){
                query(".endCity",this.routeDtl.domNode)[0].innerHTML = name;
            });
            this.subscribe("cqthink/wx/choosePlace/mdfRouteStart",function(addrDtl){
                query("span",query("#startPoint1",this.routeDtl.domNode)[0])[0].innerHTML = addrDtl.name;
                domAttr.set(query("#startPoint1",this.routeDtl.domNode)[0],"lat",addrDtl.location.lat);
                domAttr.set(query("#startPoint1",this.routeDtl.domNode)[0],"lon",addrDtl.location.lng);
                geoUtil.geoToAddr(addrDtl.location.lng,addrDtl.location.lat).then(lang.hitch(this,function(data){
                    if(data){
                        query(".startCity",this.routeDtl.domNode)[0].innerHTML = data.city?data.city:data.province;
                    }
                }));
            });
            this.subscribe("cqthink/wx/choosePlace/mdfRouteEnd",function(addrDtl){
                query("span",query("#endPoint1",this.routeDtl.domNode)[0])[0].innerHTML = addrDtl.name;
                domAttr.set(query("#endPoint1",this.routeDtl.domNode)[0],"lat",addrDtl.location.lat);
                domAttr.set(query("#endPoint1",this.routeDtl.domNode)[0],"lon",addrDtl.location.lng);
                geoUtil.geoToAddr(addrDtl.location.lng,addrDtl.location.lat).then(lang.hitch(this,function(data){
                    if(data){
                        query(".endCity",this.routeDtl.domNode)[0].innerHTML = data.city?data.city:data.province;
                    }
                }));
            });
            this.connect(this.ok,"onclick",function(){
                var time = this.mdfTtimePicker.get("values").join(":");
                query("span",query("#routeTime1",this.routeDtl.domNode)[0])[0].innerHTML = time;
                domAttr.set(query("span",query("#routeTime",this.routeDtl.domNode)[0])[0],"time",time);
                this.mdfRouteTimePicker.hide();
            });
            this.connect(this.cancel,"onclick",function(){
                this.mdfRouteTimePicker.hide();
            });
            this.connect(this.postMdfRouteButton,"onclick",this.postMdfRoute);
        },
        refreshAllList:function(){
            if(this.did!=window.did){
                this.did = window.did;
                this.routeDtl.refreshList();
            }
        },
        changeCycle:function(e){
            var dom = e.target;
            while(dom&&dom.tagName!="DIV"){
                dom = dom.parentNode;
            }
            if(dom&&dom.tagName=="DIV"){
                domAttr.set(query("input",dom)[0],"checked",true);
                query("input",query("#routeCycle1",this.routeDtl.domNode)[0]).forEach(function(node){
                    if(node!=query("input",dom)[0]){
                        domAttr.set(node,"checked",false);
                    }
                });
            }
        },
        deleteRoute:function(){
            window.busy();
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    var data = {
                        o:{
                            "DID":window.did
                        }
                    };
                    xhr("POST", {
                        url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                        handleAs: "json",
                        content: {
                            data: json.toJson({
                                modalName: "XST_TCRMK_SUPPLYORNEED",
                                data: [data]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                alert("路线删除成功。");
                                window.free();
                                window.moveToView("myWay");
                            } else {
                                alert(result.message || "数据错误!");
                                window.free();
                            }
                        })
                    });
                }else{
                    alert("未登录。");
                    window.free();
                }
            }));
        },
        postMdfRoute:function(){
            //检查起始点是否选择
            if(!domAttr.get(query("#startPoint1",this.routeDtl.domNode)[0],"LAT")){
                alert("请选择起点。");
                return;
            }
            if(!domAttr.get(query("#endPoint1",this.routeDtl.domNode)[0],"LAT")){
                alert("请选择终点。");
                return;
            }
            if(!domAttr.get(query("span",query("#routeTime1",this.routeDtl.domNode)[0])[0],"time")){
                alert("请选择时间。");
                return;
            }
            query("input",query("#routeCycle1",this.routeDtl.domNode)[0]).forEach(function(node){
                if(domAttr.get(node,"checked")){
                    CYCID = domAttr.get(node,"value");
                }
            });
            var d = new Date(),dtime,day;
                day= d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate();
                dtime = day+" "+d.getHours()+":"+d.getMinutes()+":"+d.getSeconds();
                
            var data = {
                n:{
                    "S_ADDR":query("span",query("#startPoint1",this.routeDtl.domNode)[0])[0].innerHTML,
                    "E_ADDR":query("span",query("#endPoint1",this.routeDtl.domNode)[0])[0].innerHTML,
                    "S_LAT":domAttr.get(query("#startPoint1",this.routeDtl.domNode)[0],"LAT"),
                    "S_LON":domAttr.get(query("#startPoint1",this.routeDtl.domNode)[0],"LON"),
                    "E_LAT":domAttr.get(query("#endPoint1",this.routeDtl.domNode)[0],"LAT"),
                    "E_LON":domAttr.get(query("#endPoint1",this.routeDtl.domNode)[0],"LON"),
                    "R_TIME":(CYCID==2?day:"1900-01-01")+" "+query("span",query("#routeTime1",this.routeDtl.domNode)[0])[0].innerHTML+":00",
                    "CYCID":CYCID,//
                    "S_CITY":query(".startCity",this.routeDtl.domNode)[0].innerHTML,
                    "E_CITY":query(".endCity",this.routeDtl.domNode)[0].innerHTML
                },
                o:{
                    "DID":window.did
                }
            };
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    xhr("POST", {
                        url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                        handleAs: "json",
                        content: {
                            data: json.toJson({
                                modalName: "XST_TCRMK_SUPPLYORNEED",
                                data: [data]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                alert("修改路线成功。");
                                window.free();
                                window.moveToView("myWay");
                            } else {
                                alert(result.message || "数据错误!");
                                window.free();
                            }
                        })
                    });
                }else{
                    alert("未登录");
                }
            }));
        }
    });
});