define([
    "dojo/_base/declare", 
    "../userInfo", 
    "dojo/query", 
    "dojo/_base/lang", 
    "dijit/registry"], function(declare, userInfo, query, lang, registry) {
    return declare("widgets.common._MdfUserInfoMixin", null, {
        isMdfUserInfoLoaded:function(){
            return !!this.mdfInfoPost;
        },
        indexMdfUserInfoElement:function(){
            this.mdfInfoPost = query("#mdfInfoPost", this.domNode)[0];
            this.engineNum = query(".engineNum",this.domNode)[0];
            this.engineNumTitle = query(".engineNumTitle",this.domNode)[0];
        },
        initMdfUserInfoEvent:function(){
            this.mdfInfoPost.onclick = lang.hitch(this, this.mdfUserInfo);
        },
        refreshAllList:function(){
            if(window.titleNode){
                window.titleNode.innerHTML = "信息维护";
            }
            if(g_sys_info.code.toUpperCase()=='SVC10060'){//爱车会,隐藏地址
                query("#plateNum", this.domNode)[0].style.display = "";
                query(".frameNum", this.domNode)[0].style.display = "";
                this.engineNum.style.display = "";
                query("#plateNumTitle", this.domNode)[0].style.display = "";
                query(".frameNumTitle", this.domNode)[0].style.display = "";
                this.engineNumTitle.style.display = "";
                query("#user_addr1", this.domNode)[0].style.display="none";
                query("#userAddrTitle", this.domNode)[0].style.display="none";
                query("#userAddrTitleACH", this.domNode)[0].style.display="";
                query("#userAddrACH", this.domNode)[0].style.display="";
            }else{//否则显示地址,隐藏车牌信息
                query("#plateNum", this.domNode)[0].style.display = "none";
                query(".frameNum", this.domNode)[0].style.display = "none";
                this.engineNum.style.display = "none";
                query("#plateNumTitle", this.domNode)[0].style.display = "none";
                query(".frameNumTitle", this.domNode)[0].style.display = "none";
                this.engineNumTitle.style.display = "none";
                query("#user_addr1", this.domNode)[0].style.display="";
                query("#userAddrTitle", this.domNode)[0].style.display="";
                query("#userAddrTitleACH", this.domNode)[0].style.display="none";
                query("#userAddrACH", this.domNode)[0].style.display="none";
            }
            //重新取客户信息
            userInfo.hasLogin().then(lang.hitch(this,function(){
                window.loadData({
                    modalName:"XSY_TBSCR_ADDRESS_S",
                    filter:"01",
                    pageSize:"1",
                    pageIndex:"1",
                    param:{"OPENID":userInfo.getUserInfo().openId}
                }).then(lang.hitch(this,function(data){
                    if(data.length){
                        if(data[0].Sex){
                            if(data[0].Sex=="168"){
                                query("#user_sex1", this.domNode)[0].value = "f";
                            }else{
                                query("#user_sex1", this.domNode)[0].value = "m";
                            }
                        }
                        if(data[0].BirthDay){
                            var BirthDay = data[0].BirthDay;
                            if(BirthDay.indexOf(" ")>-1){
                                BirthDay = BirthDay.substring(0,BirthDay.length-9);
                            }
                            BirthDay = BirthDay.split("-");
                            query("#to_year1", this.domNode)[0].value = BirthDay[0];
                            query("#to_month1", this.domNode)[0].value = BirthDay[1];
                            query("#to_day1", this.domNode)[0].value = BirthDay[2];
                        }
                        query("#user_fullname1", this.domNode)[0].value = data[0].ConsigneeName;
                        query("#user_mobile1", this.domNode)[0].value = data[0].Fax;
                        query("#user_addr1", this.domNode)[0].value = data[0].DetailAddress;
                        //query("#user_email1", this.domNode)[0].value = data[0].CompEmail;
                        query("#plateNum", this.domNode)[0].value = data[0].PLATE_NUM;
                        query(".frameNum", this.domNode)[0].value = data[0].FRAME_NUM;
                        this.engineNum.value = data[0].ENGINE_NUM;
                    }
                }));
            }));
        },
        mdfUserInfo: function() {
            window.busy();
            var y = query("#to_year1", this.domNode)[0].value,m = query("#to_month1", this.domNode)[0].value,d = query("#to_day1", this.domNode)[0].value;
            var s = query("#user_sex1", this.domNode)[0].value;
            
            var info = {
                "ConsigneeName": query("#user_fullname1", this.domNode)[0].value,
                "Fax": query("#user_mobile1", this.domNode)[0].value,
                "DetailAddress": g_sys_info.code.toUpperCase()!='SVC10060'?query("#user_addr1", this.domNode)[0].value:query("#userAddrACH", this.domNode)[0].value,
                "BirthDay":(y&&m&&d)?(y+"-"+m+"-"+d):"",
                //"CompEmail": query("#user_email1", this.domNode)[0].value,
                "PLATE_NUM":(query("#plateNum", this.domNode)[0].value.replace(/[ ]/g,"")).toUpperCase(),//替换字符串空格 转大写
                "FRAME_NUM":query(".frameNum", this.domNode)[0].value.replace(/[ ]/g,""),//替换字符串空格
                "ENGINE_NUM":this.engineNum.value.replace(/[ ]/g,""),
                "Sex":s?("m" === s ? "167" : "168"):""
            };
            if (!info.ConsigneeName) {
                alert("请输入姓名！");
                window.free();
                return false;
            }
            if(info.BirthDay){//如果年月日都有填
                var birthDay = info.BirthDay;
                var r = birthDay.match(/^(\d{1,4})(-|\/)(\d{1,2})\2(\d{1,2})$/);
                if(!r){
                    alert("生日格式错误！");
                    window.free();
                    return false;
                }
                var d1= new Date(r[1], r[3]-1, r[4]);
                if(!(d1.getFullYear()==r[1]&&(d1.getMonth()+1)==r[3]&&d1.getDate()==r[4])){
                    alert("生日格式错误！");
                    window.free();
                    return false;
                }
            }
            if (!info.Fax) {
                alert("请输入电话！");
                window.free();
                return false;
            }else{//验证电话格式
                if(!(/(^1[3|4|5|7|8][0-9]{9}$)/.test(info.Fax))){
                    alert("电话格式错误！");
                    window.free();
                    return false;
                }
            }
            if (!info.DetailAddress&&g_sys_info.code.toUpperCase()!='SVC10060') {
                alert("请输入地址！");
                window.free();
                return false;
            }
            userInfo.mdfUserInfo(info).then(function(success) {
                if (success) {
                    window.free();
                    window.moveToView("user");
                } else {
                    alert("修改信息失败！");
                    window.free();
                }
            });
        }
    });
});