define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/_base/lang",
    "widgets/userInfo",
    "dojo/_base/xhr",
    "dojo/_base/json"
],function(declare,registry,domAttr,lang,userInfo,xhr,json){
    return declare("widgets.common._MyCarpoolDtlMixin",null,{
        isMyCarpoolDtlLoaded:function(){
            return !!this.carpoolDtl;
        },
        indexMyCarpoolDtlElement:function(){
            this.carpoolDtl = registry.byId("carpoolDtl");
            this.carpoolDtl01 = registry.byId("carpoolDtl01");
        },
        initMyCarpoolDtlEvent:function(){
            this.connect(this.carpoolDtl.domNode,"onclick",function(e){
                var dom = e.target;
                if(dom&&dom.tagName=="A"&&domAttr.get(dom,"class")=="payCarpoolOrder"){
                    this.createOrderNPay();
                }
                if(dom&&dom.tagName=="A"&&domAttr.get(dom,"class")=="cancelCarpoolOrder"){
                    this.cancelCarpoolOrder();
                }
                if(dom&&dom.tagName=="A"&&domAttr.get(dom,"class")=="confirmOrder"){
                    this.confirmOrder();
                }
            });
            this.connect(this.carpoolDtl,"onDefRendered",function(data){
                if(data.data.items.length){
                    var item = data.data.items[0];
                    if(item.State>=0){
                        item.findCar = 1;
                        if(item.State>=1){
                            item.toOnCar = 1;
                            if(item.State>=2){
                                item.pay = 1;
                                if(item.State>=3){
                                    item.onCar = 1;
                                    if(item.State>=4){
                                        item.eva = 1;
                                    }
                                }
                            }
                        }
                    }
                }
            });
        },
        refreshAllList:function(){
            var params = window.did.split("_");
            window.did = this.did = params[0];
            this.needPay = params.length > 1;
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    this.carpoolDtl.refreshList();
                    this.carpoolDtl01.refreshList();
                    if(this.needPay){
                        this.createOrderNPay(true);
                    }
                }else{
                    window.nextPageOnLogin = "myCarpoolDtl-" + window.did;
                    userInfo.showLogin();
                }
            }));
        },
        //创建并支付订单
        createOrderNPay:function(withWx){
            window.busy();
            require(["widgets/common/orderHandler"],lang.hitch(this,function(orderHandler){
                userInfo.hasLogin().then(lang.hitch(this,function(s){
                    if(s){
                        var name,tel,addr,remark,matInfo,type,spid;
                        name = userInfo.getUserInfo().name;
                        tel  = userInfo.getUserInfo().tel;
                        addr = userInfo.getUserInfo().addr;
                        remark = "",matInfo = {},odInfo = {
                            "SNDID":window.did
                        };
                        window.loadData({
                            modalName: "XST_TCRMK_SUPPLYORNEED",
                            filter: "07",
                            pageSize: "1",
                            pageIndex: "1",
                            param: {"DID":window.did}
                        }).then(lang.hitch(this,function(data){
                            if(data.length){
                                matInfo[120377] = {QTY:1,AMT:data[0].FEE};//商品金额
                                spid = data[0].N_PID;//服务提供者
                                orderId = data[0].ORDERID;
                            }
                            if(orderId){//如果供求信息中已经有订单ID,直接支付该订单
                                window.loadData({
                                    modalName: "XSY_TSDSG_DELIVERYBILL",
                                    filter: "09",
                                    pageSize: "1",
                                    pageIndex: "1",
                                    param: {"DeliBillID":orderId}
                                }).then(lang.hitch(this,function(order){
                                    if(order.length){
                                        if(withWx){
                                            orderHandler.payOrder(order[0].DeliBillCode,"weixin",lang.hitch(this,this.refreshAllList),order[0].TotalPrice,true);
                                        }else{
                                            orderHandler.payOrder(order[0].DeliBillCode,"",lang.hitch(this,this.refreshAllList),order[0].TotalPrice,true);
                                        }
                                    }
                                }));
                            }else{
                                orderHandler.postVirtualOrder(name,tel,addr,remark,matInfo,1,spid,"",odInfo).then(lang.hitch(this,function(a){
                                    if(1==a.rtnType){
                                        //依据订单ID去查询订单号
                                        window.loadData({
                                            modalName: "XSY_TSDSG_DELIVERYBILL",
                                            filter: "09",
                                            pageSize: "1",
                                            pageIndex: "1",
                                            param: {"DeliBillID":a.data}
                                        }).then(lang.hitch(this,function(order){
                                            if(order.length){
                                                var data = {
                                                    n:{
                                                        "ORDERID":order[0].DeliBillID
                                                    },o:{
                                                        "DID":window.did
                                                    }
                                                };
                                                xhr("POST",{
                                                    url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                                                    handleAs: "json",
                                                    content: {
                                                        data: json.toJson({
                                                            modalName: "XST_TCRMK_SUPPLYORNEED",
                                                            data: [data]
                                                        })
                                                    },
                                                    load: lang.hitch(this, function(result) {
                                                        if (1 === result.rtnType) {
                                                            if(withWx){
                                                                orderHandler.payOrder(order[0].DeliBillCode,"weixin",lang.hitch(this,this.refreshAllList),order[0].TotalPrice,true);
                                                            }else{
                                                                orderHandler.payOrder(order[0].DeliBillCode,"",lang.hitch(this,this.refreshAllList),order[0].TotalPrice,true);
                                                            }
                                                        }
                                                    })
                                                });
                                            }
                                        }));
                                    }else if(a.message){
                                        alert(a.message);
                                        window.free();
                                    }
                                }));
                            }
                        }));
                    }else{
                        alert("未登录。");
                        window.free();
                    }
                }));
                
            }));   
        },
        //取消拼车查找
        cancelCarpoolOrder:function(){
            window.busy();
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    xhr("POST", {
                        url: "/w/exec/exec/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token+"&tp=cancel_supply_or_need&paramStr="+window.did,
                        handleAs: "json",
                        load: lang.hitch(this, function(result) {
                            if (1 == result.rtnType) {
                                this.carpoolDtl.refreshList();
                                window.free();
                            } else {
                                alert(result.message || "数据错误!");
                                window.free();
                            }
                        })
                    });
                }else{
                    alert("未登录");
                    window.free();
                }
            }));
        },
        confirmOrder:function(){
            window.busy();
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    var data = {
                        n:{
                            "State":3
                        },
                        o:{
                            "DID":window.did
                        }
                    };
                    xhr("POST", {
                        url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                        handleAs: "json",
                        content: {
                            data: json.toJson({
                                modalName: "XST_TCRMK_SUPPLYORNEED",
                                data: [data]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                alert("确认上车成功。");
                                this.carpoolDtl.refreshList();
                                window.free();
                                /*window.loadData({
                                    modalName:"XSY_TCRCS_CLIENT",
                                    filter:"01",
                                    pageSize:"1",
                                    pageIndex:"1",
                                    param:{"PartnerID":userInfo.getUserInfo().partnerId}
                                }).then(lang.hitch(this,function(info){
                                    //if()
                                    var data = {
                                        n:{
                                            "COM_NUM":parseFloat(info[0].COM_NUM||0)+1
                                        },
                                        o:{
                                            "ClientID":info[0].ClientID
                                        }
                                    };
                                    xhr("POST",{
                                        url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                                        handleAs: "json",
                                        content: {
                                            data: json.toJson({
                                                modalName: "XSY_TCRCS_CLIENT",
                                                data: [data]
                                            })
                                        },
                                        load: lang.hitch(this, function(r) {
                                            if(1===r.rtnType){
                                                
                                            }
                                        })
                                    });
                                    
                                }));*/
                            } else {
                                alert(result.message || "数据错误!");
                                window.free();
                            }
                        })
                    });
                }else{
                    alert("未登录");
                    window.free();
                }
            }));
        }
    });
});