define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-attr",
    "dojo/_base/array"
],function(declare,registry,query,domAttr,array){
    return declare("widgets.common._MyCarpoolList",null,{
        isMyCarpoolListLoaded:function(){
            return !!this.carpoolList;
        },
        indexMyCarpoolListElement:function(){
            this.carpoolList = registry.byId("carpoolList");
            this.carpoolListHearder = query(".carpoolListHearder",this.domNode)[0];
        },
        initMyCarpoolListEvent:function(){
            this.connect(this.carpoolListHearder,"onclick",function(e){
                var dom = e.target;
                if(dom&&dom.tagName=="LI"){
                    var name = domAttr.get(dom,"name");
                    domAttr.set(dom,"class","tableLiChecked");
                    query("li",this.carpoolListHearder).forEach(function(node){
                        if(node!=dom){
                            domAttr.set(node,"class","tableLi");
                        }
                    });
                    //修改查询条件
                    this.carpoolList.rs_wb_flt = name;
                    this.carpoolList.refreshList();
                }
            });
            this.connect(this.carpoolList,"onDefRendered",function(data){
                if(data.data.items.length){
                    array.forEach(data.data.items,function(item){
                       var time = item.R_TIME.split(" ")[0].split("-");
                       var carrentTime = new Date();
                       if(carrentTime.getFullYear()==time[0]&&(carrentTime.getMonth()+1)==time[1]){
                           if(carrentTime.getDate()==time[2]){
                               item.time = "今天"+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                           }else if(carrentTime.getDate()-time[2]==-1){
                               item.time = "明天"+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                           }else if(carrentTime.getDate()-time[2]==1){
                               item.time = "昨天"+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                           }else{
                               item.time = item.R_TIME.split(" ")[0].split("-")[1]+"-"+ item.R_TIME.split(" ")[0].split("-")[2]+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                           }
                       }else{
                            item.time = item.R_TIME.split(" ")[0].split("-")[1]+"-"+ item.R_TIME.split(" ")[0].split("-")[2]+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                       }
                    });
                }
            });
        },
        refreshAllList:function(){
            //if(this.did!=window.did){
            //    this.did = window.did;
                query("li",this.carpoolListHearder).forEach(function(node){
                    if(domAttr.get(node,"name")==window.did){
                        domAttr.set(node,"class","tableLiChecked");
                    }else{
                        domAttr.set(node,"class","tableLi");
                    }
                });
                this.carpoolList.rs_wb_flt = window.did;
                this.carpoolList.refreshList();
            //}
            
        }
    });
});