define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dijit/registry",
    "widgets/userInfo",
    "dojo/_base/array",
    "dojo/query",
    "dojo/dom-attr",
    "dojo/_base/json",
    "dojo/_base/xhr"
],function(declare,lang,domConstruct,registry,userInfo,array,query,domAttr,json,xhr){
    return declare("widgets.common._MyWayMixin",null,{
        isMyWayLoaded:function(){
            return !!this.myWayList;
        },
        indexMyWayElement:function(){
            this.inherited(arguments);
            this.myWayList = registry.byId("myWayList");
            //this.switchRoute = query("#switchRoute",this.domNode)[0];
        },
        refreshAllList:function(){
            this.inherited(arguments);
            if (window.titleNode) {
                window.titleNode.innerHTML = "我的路线";
            }
            this.myWayList.refreshList();
        },
        initMyWayEvent:function(){
            this.inherited(arguments);
            this.connect(this.myWayList,"onDefRendered",function(data){
                if(data.data.items.length){
                    array.forEach(data.data.items,function(item){
                        //如果类型是今天的话,直接显示今天的日期
                        if(item.CYCID==2){
                            item.showCycle = item.R_TIME.split(" ")[0].split("-")[1]+"-"+item.R_TIME.split(" ")[0].split("-")[2];
                        }else if(item.CYCID==1){
                            item.showCycle = "工作日";
                        }else{
                            item.showCycle = "每天";
                        }
                        item.time = item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                    });
                }
            });
            //验证用户是否登录，若未登录，则应先登录，登录后才能注册为商家
            //点击开关按钮
            this.connect(this.myWayList.domNode,"onclick",function(e){
                var dom  = e.target,routeId,isUse;
                while(dom&&dom.tagName!="DIV"&&dom!=this.switchRoute){
                    dom = dom.parentNode;
                }
                if(dom&&dom.tagName=="DIV"){
                    if(domAttr.get(dom,"did")&&domAttr.get(dom,"did").indexOf("switchRoute")>-1){
                        routeId  = domAttr.get(dom,"routeId");
                        isUse = domAttr.get(dom,"class")=="routeUnLocked"?1:0;
                        domAttr.set(dom,"class","routeUnLocked"?"routeLocked":"routeUnLocked");
                        //修改本条路线的使用状态
                        this.mdfRoute(routeId,isUse);
                    }
                    if(domAttr.get(dom,"class")=="myWays"){
                        window.moveToView("mdfRoute",domAttr.get(dom,"routeId"));
                    }
                }
            });
        },
        mdfRoute:function(routeId,isUse){
            window.busy();
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    var data = {
                        n:{
                            "IsClosed":isUse
                        },
                        o:{
                            "DID":routeId
                        }
                    };
                    xhr("POST", {
                        url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                        handleAs: "json",
                        content: {
                            data: json.toJson({
                                modalName: "XST_TCRMK_SUPPLYORNEED",
                                data: [data]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                //alert("路线已修改。");
                                this.myWayList.refreshList();
                                window.free();
                            } else {
                                alert(result.message || "数据错误!");
                                window.free();
                            }
                        })
                    });
                }else{
                    alert("请先登录");
                    window.free();
                }
            }));
        }
    });
});