define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dijit/registry",
    "cqthink/app/plugins/geolocation",
    "widgets/userInfo"
    ], function(declare, array, lang, registry, geolocation, userInfo) {
    return declare("widgets.common._NearByUserListMixin", null, {
        isNearByUserListLoaded:function(){
            return !!this.nearByUser;
        },
        indexNearByUserListElement: function() {
            this.nearByUser = registry.byId("nearByUser");
        },
        initNearByUserListEvent: function() {
            this.connect(this.nearByUser, "onDefRendered", function(data) {
                if (data.data.items.length) {
                    var items = data.data.items;
                    array.forEach(items, function(item) {
                        item.NICKNAME = item.T19_NICKNAME || item.T0_PartnerName || item.T1_ConsigneeName || "无名氏";
                        item.HEADIMGURL = item.T19_HEADIMGURL || "";
                        //判断进入聊天页面应该传哪一个ID,partnerid还是openid
                        item.pvp = window.wx_openId ? '<div><a style="color:blue;" href="#wxconnect-' + encodeURIComponent(window.wx_openId + "&" + item.T1_WXID) + '">和TA对话</a></div>' : "";
                    });
                }
            });
        },
        refreshAllList: function() {
            window.updateTitle("附近会员");
            userInfo.hasLogin().then(lang.hitch(this, function(s) {
                if (s) {
                    geolocation.getCurrentPosition("查看附近会员需要获取您当前位置信息。").then(lang.hitch(this, function(data) {
                        if (data) {
                            //修改自己的地址信息
                            var info = {
                                "D_LON":data.coords.longitude||"",
                                "D_LAT":data.coords.latitude||""
                            };
                            userInfo.onMdfUserInfo(info);
                            this.nearByUser.rs_wb_order = "DBO.fnGetDistance([T1_D_LAT],[T1_D_LON]," + data.coords.latitude + ',' + data.coords.longitude + ")";
                        }
                        this.nearByUser.refreshList();
                    }));
                }else{
                    window.nextPageOnLogin = "nearByUserList";
                    userInfo.showLogin();
                }
            }));
        }
    });
});