define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/_base/array",
    "dojo/query",
    "cqthink/app/plugins/geolocation",
    "widgets/userInfo",
    "dojo/_base/lang",
    "dojo/_base/json", 
    "dojo/_base/xhr",
    "dojo/dom-attr"
],function(declare,registry,array,query,geolocation,userInfo,lang,json,xhr,domAttr){
    return declare("widgets.commom._NearbyCarpoolMixin",null,{
        isNearbyCarpoolLoaded:function(){
            return !!this.nearbyCarpoolList;
        },
        indexNearbyCarpoolElement:function(){
            this.nearbyCarpoolList = registry.byId("nearbyCarpoolList");
            //this.grabOrderButton = query(".grabOrderButton",this.domNode)[0];
        },
        initNearbyCarpoolEvent:function(){
            this.connect(this.nearbyCarpoolList,"onDefRendered",function(data){
                if(data.data.items.length){
                    array.forEach(data.data.items,function(item){
                       var time = item.R_TIME.split(" ")[0].split("-");
                       var carrentTime = new Date();
                       if(carrentTime.getFullYear()==time[0]&&(carrentTime.getMonth()+1)==time[1]){
                           if(carrentTime.getDate()==time[2]){
                               item.time = "今天"+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                           }else if(carrentTime.getDate()-time[2]==-1){
                               item.time = "明天"+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                           }else if(carrentTime.getDate()-time[2]==1){
                               item.time = "昨天"+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                           }else{
                               item.time = item.R_TIME.split(" ")[0].split("-")[1]+"-"+ item.R_TIME.split(" ")[0].split("-")[2]+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                           }
                       }else{
                            item.time = item.R_TIME.split(" ")[0].split("-")[1]+"-"+ item.R_TIME.split(" ")[0].split("-")[2]+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                       }
                    });
                }
            });
            this.connect(this.nearbyCarpoolList.domNode,"onclick",this.grabOrder);
        },
        refreshAllList:function(){
            userInfo.hasLogin().then(lang.hitch(this, function(s) {
                if(s){
                    geolocation.getCurrentPosition("查看附近拼车需要获取您当前位置信息。").then(lang.hitch(this, function(data) {
                        if (data) {
                            //修改自己的地址信息
                            var info = {
                                "D_LON":data.coords.longitude||"",
                                "D_LAT":data.coords.latitude||""
                            };
                            userInfo.onMdfUserInfo(info);
                            this.nearbyCarpoolList.rs_wb_order = "DBO.fnGetDistance([S_LAT],[S_LON]," + data.coords.latitude + ',' + data.coords.longitude + ")";
                        }
                        this.nearbyCarpoolList.refreshList();
                    }));
                }
            }));
        },
        grabOrder:function(e){
            //抢单,直接生成订单？
            //先做一个标记
            window.busy();
            var dom = e.target;
            if(!(dom&&dom.tagName=="A"&&domAttr.get(dom,"class","grabOrderButton"))){
                window.free();
                return;   
            }
            var infoId = domAttr.get(dom,"infoId"),
                data = {
                    n:{
                        "State":"1",
                        "N_PID":userInfo.getUserInfo().partnerId,
                        "DID":infoId
                    },
                    o:{
                        "State":0,
                        "DID":infoId
                    }
                },pid = domAttr.get(dom,"pid");
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    data["n"].N_PID = userInfo.getUserInfo().partnerId;
                    xhr("POST", {
                        url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                        handleAs: "json",
                        content: {
                            data: json.toJson({
                                modalName: "XST_TCRMK_SUPPLYORNEED",
                                data: [data]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                if(result.data&&result.data.items&&result.data.items.length){
                                    alert("抢单成功。");
                                    this.nearbyCarpoolList.refreshList();
                                    //给乘客发送短信
                                    window.loadData({
                                        modalName: "XSY_TBSCR_ADDRESS",
                                        filter: "03",
                                        pageSize: "1",
                                        pageIndex: "1",
                                        param: {
                                            "PartnerID": pid
                                        }
                                    }).then(lang.hitch(this,function(ss){
                                        if(ss.length){
                                            xhr("POST",{
                                                url:"/w/exec/exec/"+window.code+"-"+window.openId,
                                                handleAs: "json",
                                                content:{
                                                    tp:"sms",
                                                    paramStr:"'"+ss[0].Fax+"','您发布的拼车已经被车主抢单，请进入拼车支付拼车或直接联系车主。车主："+(widgets.userInfo.getUserInfo().name)+"，"+(userInfo.getUserInfo().tel)+"','todaynicsms'"
                                                }
                                            });
                                        }
                                    }));
                                }else{
                                    alert("手慢了，已经被别人抢了哦~");
                                }
                            } else {
                                alert(result.message || "数据错误!");
                            }
                            window.free();
                        })
                    });
                }else{
                    window.free();
                    alert("未登录。");
                }
            }));
        }
    });
});