define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-attr",
    "dojo/_base/array",
    "dojo/dom-style"
],function(declare,registry,query,domAttr,array,domStyle){
    return declare("widgets.common._NewCarpoolMixin",null,{
        isNewCarpoolLoaded:function(){
            return !!this.myCarpoolList;
        },
        indexNewCarpoolElement:function(){
            this.myCarpoolList = registry.byId("perCarpoolList");
            this.myCarpoolHeader = query(".myCarpoolHeader",this.domNode)[0];
            this.newCarpool = query(".newCarpool",this.domNode)[0];
            this.myCarpoolListNode = query(".myCarpoolListNode",this.domNode)[0];
        },
        initNewCarpoolEvent:function(){
            this.connect(this.myCarpoolHeader,"onclick",this.headerClick);
            this.connect(this.myCarpoolList,"onDefRendered",function(data){
                if(data.data.items.length){
                    array.forEach(data.data.items,function(item){
                       var time = item.R_TIME.split(" ")[0].split("-");
                       var carrentTime = new Date();
                       if(carrentTime.getFullYear()==time[0]&&(carrentTime.getMonth()+1)==time[1]){
                           if(carrentTime.getDate()==time[2]){
                               item.time = "今天"+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                           }else if(carrentTime.getDate()-time[2]==-1){
                               item.time = "明天"+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                           }else if(carrentTime.getDate()-time[2]==1){
                               item.time = "昨天"+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                           }else{
                               item.time = item.R_TIME.split(" ")[0].split("-")[1]+"-"+ item.R_TIME.split(" ")[0].split("-")[2]+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                           }
                       }else{
                            item.time = item.R_TIME.split(" ")[0].split("-")[1]+"-"+ item.R_TIME.split(" ")[0].split("-")[2]+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                       }
                    });
                }
            });
        },
        refreshAllList:function(){
            if(window.did=="newCarpool"){//新的拼车
                domStyle.set(this.newCarpool,"display","");
                domStyle.set(this.myCarpoolListNode,"display","none");
                
            }else{//正在拼车,完成拼车
                domStyle.set(this.newCarpool,"display","none");
                domStyle.set(this.myCarpoolListNode,"display","");
                this.myCarpoolList.rs_wb_flt = window.did;
                this.myCarpoolList.refreshList();
            }
            query("li",this.myCarpoolHeader).forEach(function(node){
                if(domAttr.get(node,"name")==window.did){
                    domAttr.set(node,"class","tableLiChecked");
                }else {
                    domAttr.set(node,"class","tableLi");
                }
            });
        },
        headerClick:function(e){
            var dom = e.target;
            if(dom&&dom.tagName=="LI"){
                var name = domAttr.get(dom,"name");
                domAttr.set(dom,"class",domAttr.get(dom,"class")=="tableLi"?"tableLiChecked":"tableLi");
                query("li",this.myCarpoolHeader).forEach(function(node){
                    if(node!=dom){
                        domAttr.set(node,"class","tableLi");
                    }
                });
                if(name=="newCarpool"){
                    domStyle.set(this.newCarpool,"display","");
                    domStyle.set(this.myCarpoolListNode,"display","none");
                }else{
                    domStyle.set(this.newCarpool,"display","none");
                    domStyle.set(this.myCarpoolListNode,"display","");
                    this.myCarpoolList.rs_wb_flt = name;
                    this.myCarpoolList.refreshList();
                }
            }
        }
    });
});