define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/query",
    "widgets/userInfo",
     "dojo/_base/xhr",
     "dojo/_base/json",
     "dojo/_base/lang"
],function(declare,registry,query,userInfo,xhr,json,lang){
    return declare("widgets.common._NewMdfuserInfoMixin",null,{
        isNewMdfuserInfoLoaded:function(){
            return !!this.stdMdfUserInfo;
        },
        indexNewMdfuserInfoElement:function(){
            this.stdMdfUserInfo = registry.byId("stdMdfUserInfo");
            this.postMdfUserInfo = query(".postMdfUserInfo",this.domNode)[0];
        },
        initNewMdfuserInfoEvent:function(){
            this.connect(this.stdMdfUserInfo,"onDefRendered",function(data){
                var items = data.data.items;
                if(items.length){
                    items[0].B_Y = items[0].T1_BirthDay?items[0].T1_BirthDay.split("-")[0]:"";
                    items[0].B_M = items[0].T1_BirthDay?items[0].T1_BirthDay.split("-")[1]:"";
                    items[0].B_D = items[0].T1_BirthDay?items[0].T1_BirthDay.split("-")[2]:"";
                }
            });
            this.connect(this.postMdfUserInfo,"onclick",this.postMdfFuc);
        },
        postMdfFuc:function(){
            window.busy();
            var y = query(".pYear", this.stdMdfUserInfo.domNode)[0].value,
                m = query(".pMonth", this.stdMdfUserInfo.domNode)[0].value,
                d = query(".pDay", this.stdMdfUserInfo.domNode)[0].value,
                s = query(".pSex", this.stdMdfUserInfo.domNode)[0].value;
            var info = {
                "ConsigneeName": query(".pName", this.stdMdfUserInfo.domNode)[0].value,
                "Fax": query(".pTel", this.stdMdfUserInfo.domNode)[0].value,
                "DetailAddress": query(".pAddr", this.stdMdfUserInfo.domNode)[0].value,
                "BirthDay":(y&&m&&d)?(y+"-"+m+"-"+d):"",
                "Sex":(s!=0&&s!="")?("m" === s ? "167" : "168"):""
            };
            if (!info.ConsigneeName) {
                alert("请输入姓名！");
                window.free();
                return false;
            }
            if(info.BirthDay){//如果年月日都有填
                var birthDay = info.BirthDay;
                var r = birthDay.match(/^(\d{1,4})(-|\/)(\d{1,2})\2(\d{1,2})$/);
                if(!r){
                    alert("生日格式错误！");
                    window.free();
                    return false;
                }
                var d1= new Date(r[1], r[3]-1, r[4]);
                if(!(d1.getFullYear()==r[1]&&(d1.getMonth()+1)==r[3]&&d1.getDate()==r[4])){
                    alert("生日格式错误！");
                    window.free();
                    return false;
                }
            }
            if (!info.Fax) {
                alert("请输入电话！");
                window.free();
                return false;
            }else{//验证电话格式
                if(!(/(^1[3|4|5|7|8][0-9]{9}$)/.test(info.Fax))){
                    alert("电话格式错误！");
                    window.free();
                    return false;
                }
            }
            if (!info.DetailAddress) {
                alert("请输入地址！");
                window.free();
                return false;
            }
            userInfo.mdfUserInfo(info).then(function(success) {
                if (success) {
                     var data = {
                        n:{
                            PartnerName:info.ConsigneeName
                        },
                        o:{
                            PartnerID:userInfo.info.partnerId
                        }
                    };
                    xhr("POST", {
                    url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                    handleAs: "json",
                    content: {
                        data: json.toJson({
                            modalName: "XSY_TCRCS_PARTNER ",
                            data: [data]
                        })
                    },
                    load: lang.hitch(this, function(result) {
                        if (1 === result.rtnType) {
                             window.free();
                            window.moveToView("user");
                        } else {
                            talert("修改信息失败！");
                            window.free();
                        }
                    })
                });
            } else {
                    alert("修改信息失败！");
                    window.free();
                }
            });
        },
        refreshAllList:function(){
            this.stdMdfUserInfo.refreshList();
        }
    });
});