define([
    "dojo/_base/declare",
    "dojo/query",
    "widgets/userInfo",
    "dojo/_base/lang",
    "dijit/focus",
    "dojo/dom-style"
],function(declare,query,userInfo,lang,focusUtil,domStyle){
    return declare("widgets.common._NewRegisterMixin",null,{
        isNewRegisterLoaded:function(){
            return !!this.PhoneNum;
        },
        indexNewRegisterElement:function(){
            this.PhoneNum = query(".PhoneNum",this.domNode)[0];
            this.VCode = query(".VCode",this.domNode)[0];
            this.postRegist = query(".postRegist",this.domNode)[0];
            this.getVCode = query(".getVCode",this.domNode)[0];
            this.resetTime = 0;
        },
        initNewRegisterEvent:function(){
            this.connect(this.postRegist,"onclick",this.postRegistFuc);
            this.connect(this.getVCode,"onclick",this.getVCodeFuc);
        },
        refreshAllList:function(){},
        //在获取验证码中添加倒计时文字
        timerFunction:function(){
            var timer = setTimeout(lang.hitch(this,function(){
                this.timerFunction();
            }),1000);
            if(this.resetTime == 0){
                domStyle.set(query(".getVCode",this.domNode)[0],"color","#fe4f00");
                query(".getVCode",this.domNode)[0].innerText= "重新获取";
                clearTimeout(timer);
            }else{
                domStyle.set(query(".getVCode",this.domNode)[0],"color","#ccc");
                query(".getVCode",this.domNode)[0].innerText = "重新获取("+this.resetTime+")";
                this.resetTime = this.resetTime - 1;
            }
            
        },
        getVCodeFuc:function(){
            //2015-10-08 向文波  点击获取验证码时,使手机号文本框失去焦点  苹果手机中键盘挡住了提示信息
            //判断拥有焦点的节点,如果是手机号文本框,使其失去焦点
            var activeElement = focusUtil.curNode;
            if(this.PhoneNum == activeElement){
                focusUtil.curNode && focusUtil.curNode.blur();
            }
            // 设置定时器
            if(!userInfo.validPhoneNumber(this.PhoneNum.value)){
                alert("手机不合法。");
            }else{
                //倒计时完成直接发送验证码
                if(this.resetTime == 0){
                    window.sendMsg(this.PhoneNum.value);
                    this.resetTime = 60;
                    this.timerFunction();
                 } 
            }
        },
        randPassword: function() {
            var text = ['abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', '1234567890', '~!@#$%^&*()_+;,./?<>'];
            var rand = function(min, max) {
                return Math.floor(Math.max(min, Math.random() * (max + 1)));
            };
            var len = rand(6, 10); // 长度为6-10 
            var pw = '';
            for (i = 0; i < len; ++i) {
                var strpos = rand(0, 2);
                pw += text[strpos].charAt(rand(0, text[strpos].length));
            }
            return pw;
        },
        postRegistFuc:function(){
            if(!this.PhoneNum.value||!this.VCode.value){
                alert("请填写手机号和验证码。");
            }else{
                window.busy();
                window.postVerCode(this.PhoneNum.value,this.VCode.value).then(lang.hitch(this,function(s){
                    if(s){
                        //判断手机号是否已经注册
                        userInfo.checkUName(this.PhoneNum.value).then(lang.hitch(this,function(ss){
                            //已注册
                            if(ss){
                                /*window.moveToView("user");*/
                                if(window.nextPageOnLogin){
                                    window.moveToView(window.nextPageOnLogin);
                                }
                                //this.postOrder();
                                this.VCode.value = "";
                            }
                            //未注册
                            else{
                                var info = {
                                    "OPENID": this.PhoneNum.value,
                                 //   "ConsigneeName": this.PhoneNum.value, //姓名
                                    "Fax":this.PhoneNum.value,
                                    "PWD":this.randPassword()//生成随机密码
                                };
                                userInfo.regist(info).then(lang.hitch(this, function(success) {
                                    if (success) {
                                        //userInfo.onLogin(info.OPENID, info.PWD).then(lang.hitch(this,function() {
                                            //如果有微信ID,绑定微信
                                            //alert(window.wx_openId);
                                            if (window.wx_openId) {
                                               userInfo.bindWx();
                                            }
                                            /*this.postOrder();*/
                                            if(window.nextPageOnLogin){
                                                window.moveToView(window.nextPageOnLogin);
                                            }
                                        //}));
                                     this.VCode.value = "";
                                    } else {
                                        alert("注册失败！");
                                        window.free();
                                    }
                                }));
                            }
                        }));
                    }else{
                        window.free();
                    }
                }));
            }
        }
    });
});