define([
    "dojo/_base/declare",
    "dojo/query",
    "widgets/userInfo",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-style"
],function(declare,query,userInfo,lang,domAttr,domStyle){
    return declare("widgets.common._NewRegister_sjmdMixin",null,{
        isNewRegister_sjmdLoaded:function(){
            return !!this.PhoneNum;
        },
        indexNewRegister_sjmdElement:function(){
            this.PhoneNum = query(".PhoneNum",this.domNode)[0];
            this.VCode = query(".VCode",this.domNode)[0];
            this.postRegist = query(".postRegist",this.domNode)[0];
            this.getVCode = query(".getVCode",this.domNode)[0];
            
            var imgPath = window.g_sys_info.icon;
            domAttr.set(query(".logoImg",this.domNode)[0],"src",imgPath);
            domStyle.set(query(".mblScrollablePane",this.domNode)[0],"background-color","#ffffff");
        },
        initNewRegister_sjmdEvent:function(){
            this.connect(this.postRegist,"onclick",this.postRegistFuc);
            this.connect(this.getVCode,"onclick",this.getVCodeFuc);
        },
        refreshAllList:function(){},
        getVCodeFuc:function(){
            if(!userInfo.validPhoneNumber(this.PhoneNum.value)){
                alert("手机不合法。");
            }else{
                window.sendMsg(this.PhoneNum.value);
            }
        },
        randPassword: function() {
            var text = ['abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', '1234567890', '~!@#$%^&*()_+;,./?<>'];
            var rand = function(min, max) {
                return Math.floor(Math.max(min, Math.random() * (max + 1)));
            };
            var len = rand(6, 10); // 长度为6-10 
            var pw = '';
            for (i = 0; i < len; ++i) {
                var strpos = rand(0, 2);
                pw += text[strpos].charAt(rand(0, text[strpos].length));
            }
            return pw;
        },
        postRegistFuc:function(){
            if(!this.PhoneNum.value||!this.VCode.value){
                alert("请填写手机号和验证码。");
            }else{
                window.busy();
                window.postVerCode(this.PhoneNum.value,this.VCode.value).then(lang.hitch(this,function(s){
                    if(s){
                        //判断手机号是否已经注册
                        userInfo.checkUName(this.PhoneNum.value).then(lang.hitch(this,function(ss){
                            //已注册
                            if(ss){
                                /*window.moveToView("user");*/
                                if(window.nextPageOnLogin){
                                    window.moveToView(window.nextPageOnLogin);
                                }
                                //this.postOrder();
                                this.VCode.value = "";
                            }
                            //未注册
                            else{
                                var info = {
                                    "OPENID": this.PhoneNum.value,
                                 //   "ConsigneeName": this.PhoneNum.value, //姓名
                                    "Fax":this.PhoneNum.value,
                                    "PWD":this.randPassword()//生成随机密码
                                };
                                userInfo.regist(info).then(lang.hitch(this, function(success) {
                                    if (success) {
                                        //userInfo.onLogin(info.OPENID, info.PWD).then(lang.hitch(this,function() {
                                            //如果有微信ID,绑定微信
                                            if (window.wx_openId) {
                                               userInfo.bindWx();
                                            }
                                            /*this.postOrder();*/
                                            if(window.nextPageOnLogin){
                                                window.moveToView(window.nextPageOnLogin);
                                            }
                                        //}));
                                     this.VCode.value = "";
                                    } else {
                                        alert("注册失败！");
                                        window.free();
                                    }
                                }));
                            }
                        }));
                    }else{
                        window.free();
                    }
                }));
            }
        }
    });
});