define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/registry",
    "dojo/query",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "widgets/userInfo",
    "dojo/Deferred",
    "cqthink/mobile/imgPrc/bigImg"
], function(declare,lang, registry,query,array,domAttr,domClass,xhr,json,userInfo,Deferred,bigImg) {
    return declare("widgets.common._NewsMixin", null, {
        isNewsLoaded: function() {
            return !!this.nList;
        },
        indexNewsElement: function() {
            this.nList = registry.byId("newsId");
            this.TOTAL_C_QTY = query(".TOTAL_C_QTY",this.domNode)[0];// 评价数
            this.TOTAL_P_QTY = query(".TOTAL_P_QTY",this.domNode)[0];// 点赞数
            this.newsEvaList = registry.byNode(query(".news-eva-list",this.domNode)[0]);//评论列表
            this.newsPraBtn = query(".news-praise",this.domNode)[0];//资讯点赞
        },
        initNewsEvent: function() {
            this.connect(this.nList, "onDefRendered", function(data) {
                var items = data.data.items;
                if (data.data && data.data.items && data.data.items.length) {
                    this.mGroupName = data.data.items[0].TITLE;
                } else {
                    this.mGroupName = "暂无资讯";
                }
                window.updateTitle(this.mGroupName);
                // 更新标题
                if(query(".shop_module_item_title",this.domNode)[0])
                {
                    query(".shop_module_item_title",this.domNode)[0].innerHTML = this.mGroupName;
                }
                // 设置评价和点赞数
                this.TOTAL_P_QTY.innerHTML = items[0].TOTAL_P_QTY||0;
                this.TOTAL_C_QTY.innerHTML = items[0].TOTAL_C_QTY||0;
                if(items[0].IS_VISUAL==1||items[0].IS_VISUAL==""){
                    domClass.remove(query(".discussList",this.domNode)[0],"hide");
                    //提交评论后，返回该页面时刷新评论内容
                    this.newsEvaList.refreshList();
                }else{
                    domClass.add(query(".discussList",this.domNode)[0],"hide");
                    domAttr.set(query(".write_discuss",this.domNode)[0],"onclick","");
                }
                 
            });
            this.connect(this.newsEvaList,"onDefRendered",function(data){
                var items = data.data.items;
                if(items.length)
                {
                    array.forEach(items,function(item){
                        item.isPraise = 0;
                        if(window.evaIds&&window.evaIds[item.DID]&&window.evaIds[item.DID]==1)
                        {
                            item.isPraise = 1;
                        }
                    });
                }
            });
            this.connect(this.newsPraBtn,"onclick",this.newsPraBtnClick);//资讯点赞
            this.connect(this.newsEvaList.domNode,"onclick",this.newsEvaListonClick);
            this.connect(this.nList.domNode,"onclick",function(event){
                // 如果不是点击的图片 还是执行原有程序
                var dom = event.target;
                if(dom.tagName!="IMG"){
                    return;
                }else{
                    var src=query("img",this.nList.domNode),index=0,
                    newSrcArr = array.filter(src,function(i){
                        return !domClass.contains(i,"news");
                    }),
                    srcArr=array.map(newSrcArr,function(item,i){  //路径的数组对象
                        if(item==event.target) {
                            index=i;
                        }
                        return  {src:domAttr.get(item,"src")};
                    });
                    bigImg.show(srcArr,index);
                }
            });
        },
        //资讯点赞
        newsPraBtnClick:function(e){
            if(this.isBusy){
                return;
            } else {
                this.isBusy = true;
            }
            var dom = e.target;
            //如果已经点赞 则remove news-prasied样式，否则加上该样式
            if(domClass.contains(dom,"news-prasied")){
                domClass.remove(dom,"news-prasied");
            } else {
                domClass.add(dom,"news-prasied");
            }
            window.loadData({
                modalName: "NY_TBSAV_PRAISE", //加载点赞资源
                filter: "05",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "DID":window.did
                }
            }).then(lang.hitch(this,function(data){
                xhr("POST",{
                    url:"/w/order/praise/" + window.code,
                    handleAs: "json",
                    content:{
                            RID:"XSY_TWBCM_NEWS",
                            RIID:window.did,
                            P_FIELD:"TOTAL_P_QTY",
                            KEY_ID:"NEWS_ID"
                    },
                    load: lang.hitch(this, function(result) {
                        if (1 === result.rtnType) {
                            //刷新点赞按钮的显示和点赞数量
                            if(domClass.contains(dom,"news-prasied")){
                                domAttr.set(query(".news-comPra-img",this.domNode)[0],"src","../../Content/standardTmp01/images/praise03.png");
                                this.TOTAL_P_QTY.innerHTML = parseInt(this.TOTAL_P_QTY.innerHTML) + 1;
                                this.isBusy = false;
                            } else {
                                domAttr.set(query(".news-comPra-img",this.domNode)[0],"src","../../Content/standardTmp01/images/praise01.png");
                                this.TOTAL_P_QTY.innerHTML = parseInt(this.TOTAL_P_QTY.innerHTML) - 1;
                                this.isBusy = false;
                            }
                            this.isBusy = false;
                        } else {
                            alert(result.message || "数据错误!");
                            this.isBusy = false;
                        }
                    })
                });
            }));
        },
        //资讯的每条评论的点赞
        newsEvaListonClick:function(e){
            var dom = e.target,praId;
            while (dom && dom.tagName.toLowerCase() != 'a' && dom != this.domNode) {
                dom = dom.parentNode;
            }
            praId = domAttr.get(dom,"praId");
            if(praId&&praId.split("-")[0] == "praise"){//处理资讯的每条评论的点赞和取消点赞
                this.priaseFuc(dom,praId.split("-")[1]);
            }
        },
        priaseFuc:function(dom,did){
            if(this.isBusy){
                return;
            } else {
                this.isBusy = true;
            }
            //如果已经点赞 则remove news-prasied样式，否则加上该样式
            if(domClass.contains(dom,"news-prasied")||domClass.contains(query(".praise-"+did,this.domNode)[0],"news-prasied")){
                domClass.remove(dom,"news-prasied")||domClass.remove(query(".praise-"+did,this.domNode)[0],"news-prasied");
            } else {
                domClass.add(dom,"news-prasied");
            }
            xhr("POST",{
                url:"/w/order/praise/" + window.code,
                handleAs: "json",
                content:{
                    RID:"NY_TBSAV_NEWS_CMMNT",
                    RIID:did,
                    P_FIELD:"TOTAL_P_QTY",
                    KEY_ID:"DID"
                },
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        if(domClass.contains(dom,"news-prasied")){
                            domAttr.set(query(".praise-"+did,this.domNode)[0],"src","../../Content/standardTmp01/images/praise03.png");
                            var n = parseFloat(query(".eva-TOTAL_P_QTY_"+did,this.domNode)[0].innerHTML);
                            query(".eva-TOTAL_P_QTY_"+did,this.domNode)[0].innerHTML = n+1;
                            this.isBusy = false;
                        } else {
                            domAttr.set(query(".praise-"+did,this.domNode)[0],"src","../../Content/standardTmp01/images/praise01.png");
                            var n = parseFloat(query(".eva-TOTAL_P_QTY_"+did,this.domNode)[0].innerHTML);
                            query(".eva-TOTAL_P_QTY_"+did,this.domNode)[0].innerHTML = n-1;
                            this.isBusy = false;
                        }
                        this.isBusy = false;
                    } else {
                        alert(result.message || "数据错误!");
                        this.isBusy = false;
                    }
                })
            });
        },
        refreshAllList: function() {
            /*if (window.did != this.did) {
                this.did = window.did;
                // 加载资讯点赞数据
                this.loadNewsPraData().then(lang.hitch(this,function(){
                    this.loadEvaPraData().then(lang.hitch(this,function(){
                        this.nList.refreshList();
                        this.newsEvaList.refreshList();
                        setTimeout(lang.hitch(this,function(){
                            this.resize();
                        }),500);
                    }));
                    window.updateTitle(this.mGroupName);
                }));
            } else {
                this.loadEvaPraData().then(lang.hitch(this,function(){
                    this.newsEvaList.refreshList();
                    window.updateTitle(this.mGroupName);
                }));
            }*/
            this.loadNewsPraData().then(lang.hitch(this,function(){
                this.loadEvaPraData().then(lang.hitch(this,function(){
                    this.nList.refreshList();//提交评论后，返回该页面时刷新评论数量
                    setTimeout(lang.hitch(this,function(){
                        this.resize();
                    }),500);
                }));
                window.updateTitle(this.mGroupName);
            }));
        },
        //资讯的每条评论的点赞图标
        loadEvaPraData:function(){
            var def = new Deferred();
            window.loadData({
                modalName: "NY_TBSAV_PRAISE", //加载资讯评论资源
                filter: "06",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "RID":"NY_TBSAV_NEWS_CMMNT",
                    "PID":userInfo.getUserInfo().partnerId
                }
            }).then(lang.hitch(this,function(evaPraiseData){
                window.evaIds = {};
                array.forEach(evaPraiseData,function(item){
                    window.evaIds[item.RIID] = 1;
                });
                def.resolve();
            }));
            return def;
        },
        //资讯的点赞图标
        loadNewsPraData:function(){
            var def = new Deferred();
            window.loadData({
                modalName: "NY_TBSAV_PRAISE", //加载资讯资源
                filter: "04",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "RIID": window.did,
                    "RID":"XSY_TWBCM_NEWS",
                    "PID":userInfo.getUserInfo().partnerId
                }
            }).then(lang.hitch(this,function(newsPraiseData){
                if(newsPraiseData.length)
                {
                    domAttr.set(query(".news-comPra-img",this.domNode)[0],"src","../../Content/standardTmp01/images/praise03.png");
                    domClass.add(query(".news-comPra-img",this.domNode)[0],"news-prasied");
                }
                else
                {
                    domAttr.set(query(".news-comPra-img",this.domNode)[0],"src","../../Content/standardTmp01/images/praise01.png");
                    domClass.remove(query(".news-comPra-img",this.domNode)[0],"news-prasied");
                }
                def.resolve();
            }));
            return def;
        }
    });
});