define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/xhr",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/query",
    "dojo/_base/connect",
    "dijit/registry",
    "dijit/_WidgetBase"
],function(declare,lang,array,xhr,domAttr,domClass,domConstruct,domStyle,query,connect,registry,_WidgetBase){
    domConstruct.create("style",{
        type:"text/css",
        innerHTML:".voteTitle,.voteQList,.voteSubmitDiv,.voteDesc{margin-top:20px;font-size:16px;font-family:Verdana,微软雅黑,Geneva,sans-serif;}.voteTitle{font-size:22px;font-weight:bold;text-align:center;padding-bottom:15px;border-bottom:1px solid #333;}.cqVoteQ{padding:0px 10px 10px 10px;}.cqVoteQTitle{font-weight:bold;margin-bottom: 10px;}.cqVoteQTitle>label{font-weight: 100;vertical-align:top;margin:1px 16px;display:inline-block;}.cqVoteQOption{margin-top:5px;color:#333;}.cqVoteQItem>input{margin:3px 3px 3px 0px;}.cqVoteQItem>label{padding:0 5px;}.voteDesc{padding:10px;background-color:#eee;border-radius:3px;}.voteOkBtn{width:120px;height:40px;font-size:18px;margin:auto;display:block;}"+
        ".cqVoteQIndex{display:inline-block;float:left;width:32px;}.cqVoteQContent{display:block;margin-left:32px;}.cqVoteQRate{height: 18px;width:120px;margin-left: 80px;background-color: #EEE;}.cqVoteQRate>div:first-child{float: left;margin-left: -80px;}.cqVoteQRate>div:last-child{height: 100%;background-color: #ED0000;}.cqVoteQTitle>label,.cqVoteQItem>label{display:inline-block;float:none;}"
    },document.head,"first");
    //选择题对象
    var optionStr = "ABCDEFGHIIJKLMNOPQRSTUVWXYZ",Question = declare("",[_WidgetBase],{
        //根节点对应的class
        baseClass:"cqVoteQ",
        //问题ID
        QID:"",
        //问题的标题
        QNAME:"",
        //本问题的总票数
        count:0,
        //问题备选答案，数组
        answers:null,
        //最多允许选择的数量，为0时表示可全选，为1时为单选，否则为多选
        maxOption:0,
        //问题的序号，从零开始
        qindex:0,
        //是否已回答，回答过的可以看投票情况，否则参与之后才能查看
        answered:false,
        //初始化界面元素和事件
        postCreate:function(){
            this.inherited(arguments);
            if(!this.maxOption){
                this.maxOption = this.answers.length;
            }
            domConstruct.create("div",{
                "class":"cqVoteQTitle",
                innerHTML:(this.qindex+1)+"，"+this.QNAME+"<label>["+(
                    1===this.maxOption?
                    "单选题":this.maxOption===this.answers.length?
                    "多选题":this.answers.length+"选"+this.maxOption
                )+"]</label>"
            },this.domNode);
            this.domNode.appendChild(domConstruct.toDom("<div>"+array.map(this.answers,this._getOptionStr,this).join("")+"</div>"));
            //处理当前节点的点击事件
            this.own(connect.connect(this.domNode,"click",this,this.onClick));
        },
        _getOptionStr:function(answer,index){
            if(this.answered){
                var rate = Math.round(this.count&&answer.count?answer.count/this.count*10000:0)/100;
                return '<div class="cqVoteQOption"><div class="cqVoteQIndex">'+this._getOptionIndex(index)+'，</div><div class="cqVoteQContent" name="'+answer.ASID+'"><div class="cqVoteQRate"><div>'+answer.count+'/'+this.count+'</div><div style="width:'+rate+'%;"></div></div><div class="cqVoteQItem" name="'+answer.ASID+'"><label>'+answer.ASNAME+'</label></div></div></div>';
            }else{
                return '<div class="cqVoteQOption"><div class="cqVoteQBox"><div class="cqVoteQItem" name="'+answer.ASID+'"><input type="checkbox"/><label>'+answer.ASNAME+'</label></div></div></div>';
            }
        },
        _getOptionIndex:function(index){
            var len = this.answers.length,str = "";
            while(len){
                str = optionStr[index%26]+str;
                index = (index-(index%26))/26;
                len = (len-(len%26))/26;
            }
            return str;
        },
        //检查当前选中的选项数量是否是可以接受的：没有超过最大可选数量
        _validCheckStatus:function(){
            var selectedNum = 0;
            //找到所有的checkbox，计算选中的checkbox的数量
            query("input",this.domNode).forEach(function(n){
                if(domAttr.get(n,'checked')){
                    selectedNum++;
                }
            });
            return selectedNum<=this.maxOption;
        },
        _updateChecked:function(node){
            setTimeout(lang.hitch(this,function(){
                //若被点击的是checkbox，checkbox的选中状态已经发生了变化，检查是否需要恢复本次操作
                if(1===this.maxOption){
                    //单选控制
                    //如果当前的节点已选中
                    //if(node.checked){
                    query("input",this.domNode).forEach(function(n){
                        domAttr.set(n,"checked",n===node);
                    });
                    //}else{
                        //domAttr.set(node,"checked",true);
                    //}
                }else // if(node.checked)
                {
                    // 检查已勾选 是否 大于 允许勾选的最大值
                    // 若大于 则直接不允许设置节点的选中
                    if(node.checked)
                    {
                        domAttr.set(node,"checked",false);
                    }
                    else
                    {
                        //若超过了最大可选数量，取消选中
                        //domAttr.set(node,"checked",false);
                        domAttr.set(node,"checked",true);
                        if(!this._validCheckStatus())
                        {
                            domAttr.set(node,"checked",false);
                        }
                    }
                }
            }),0);
        },
        //点击事件处理函数
        onClick:function(e){
            var node = e.target;
            if(this.answered){
                while(node&&node!=this.domNode){
                    if(domClass.contains(node,"cqVoteQContent")){
                        //点击的为得票率节点，跳转到投票人相关信息界面
                        window.moveToView("onlineVoteList",domAttr.get(node,"name"));
                        return;
                    }
                    node = node.parentNode;
                }
            }else{
                if("input"===node.tagName.toLowerCase()){
                    this._updateChecked(node);
                }else{
                    while(node&&node!==this.domNode){
                        if(domClass.contains(node,"cqVoteQItem")){
                            //点击的不是checkbox，判断是不是checkbox的父节点或者兄弟节点
                            //var checked = domAttr.get(node.firstChild,"checked");
                            //先改变checkbox的选中状态，达到和直接点击checkbox相同的效果
                            //domAttr.set(node.firstChild,"checked",!checked);
                            this._updateChecked(node.firstChild);
                            return;
                        }
                        node = node.parentNode;
                    }
                }
            }
        },
        getResultInfo:function(){
            var info = {
                QID:this.QID,checked:[]
            };
            //找到所有选中的checkbox对应的选项
            query("input",this.domNode).forEach(function(node){
                if(domAttr.get(node,"checked")){
                    info.checked.push(domAttr.get(node.parentNode,"name"));
                }
            });
            return info;
        },
    });
    return declare("widgets.common._OnlineVoteMixin",null,{
        //找到投票相关界面元素
        indexVoteElement:function(){
            //标题所在节点
            this._voteTitleDiv = query(".voteTitle",this.domNode)[0];
            //问题列表所在列表
            this._voteQListDiv = query(".voteQList",this.domNode)[0];
            //说明信息所在界面
            this._voteDescDiv = query(".voteDesc",this.domNode)[0];
            //提交答案按钮
            this._voteOkBtn = registry.byNode(query(".voteOkBtn",this.domNode)[0]);
        },
        //初始化投票相关页面元素相关事件
        iniVoteEvent:function(){
            this.connect(this._voteOkBtn,"onClick",this.onVoteOkClick);
        },
        //提交投票结果
        onVoteOkClick:function(){
            var index = -1,result = [];
            if(array.some(this.getChildren(),function(item,i){
                if(item!==this._voteOkBtn){
                    var info = item.getResultInfo();
                    if(-1===index&&0===info.checked.length){
                        index = i;
                        return true;
                    }
                    while(info.checked.length){
                        //将答案加入到答案列表中
                        result.push(info.checked[0]);
                        info.checked.shift();
                    }
                }
            },this)){
                return alert("第"+(index+1)+"题还没有回答");
            }
            window.busy();
            xhr("POST",{
                url:"/w/prize/onlineVoted/"+window.code,
                handleAs:"json",
                content:{
                    VID:window.did,
                    aswids:result.join(",")
                },
                load:lang.hitch(this,this._onVoteResultLoaded),
                error:lang.hitch(this,this._onVoteError)
            });
        },
        //刷新本界面所有数据
        refreshAllList:function(){
            window.busy();
            //加载当前投票信息
            xhr("GET",{
                url:"/w/prize/onlineVoteInfo/"+window.code,
                handleAs:"json",
                content:{
                    VID:window.did
                },
                load:lang.hitch(this,this._onVoteResultLoaded),
                error:lang.hitch(this,this._onVoteError)
            });
        },
        //投票或加载数据成功的处理函数
        _onVoteResultLoaded:function(data){
            this._empotyVote();
            if(data&&data.data){
                this._voteTitleDiv.innerHTML = data.data.vote.VTITLE;
                this._voteDescDiv.innerHTML = data.data.vote.VREMARK;
                var questions = data.data.questions,hash = {},ahash = {};
                //初始化问题列表
                array.forEach(questions,function(question,index){
                    //建立索引，方便后边使用
                    hash[question.QID] = question;
                    //初始化备选答案
                    question.answers = [];
                    //是否已回答的标志——是否可以再次回答
                    question.answered = !data.data.canVote;
                    //备选答案的选择数量
                    question.count = 0;
                    //依据选择提的类型判断单选还是多选
                    question.maxOption = "0"===question.QTYPE?1:question.MOPTION?question.MOPTION:0;
                    //问题的序号
                    question.qindex = index;
                });
                //初始化问题备选答案
                array.forEach(data.data.answers,function(answer){
                    //备选答案建立索引，方便后边使用
                    ahash[answer.ASID] = answer;
                    //初始化本备选答案的被选中数量
                    answer.count = 0;
                    if(hash[answer.QID]){
                        //加入到对应问题的备选答案列表中
                        hash[answer.QID].answers.push(answer);
                    }
                });
                //初始化投票结果
                array.forEach(data.data.voteDatas,function(voteData){
                    //找到对应备选答案
                    var answer = ahash[voteData.ASID];
                    if(answer){
                        //设置备选答案的选中数量
                        answer.count = (voteData.VOTES-0)||0;
                        //找到对应的问题
                        var question = hash[answer.QID];
                        if(question){
                            //找到对应的问题的得票数
                            question.count += answer.count;
                        }
                    }
                });
                //将问题显示到界面中
                array.forEach(questions,function(question){
                    (new Question(question,domConstruct.create("div",{},this._voteQListDiv))).startup();
                },this);
                if(data.data.canVote){
                    domStyle.set(this._voteOkBtn.domNode,"display","block");
                }
            }
            if(data.message){
                //若有提示信息，将提示信息呈现给用户
                alert(data.message);
            }
            window.free();
        },
        //投票或加载数据失败的处理函数
        _onVoteError:function(){
            //销毁原有内容
            this._empotyVote();
            alert("系统错误，请稍后重试");
            window.free();
        },
        _empotyVote:function(){
            //销毁原有内容
            this.getChildren().forEach(function(item){
                if(item!==this._voteOkBtn){
                    item.destroyRecursive();
                }
            },this);
            this._voteDescDiv.innerHTML = "";
            this._voteTitleDiv.innerHTML = "";
            domStyle.set(this._voteOkBtn.domNode,"display","none");
        }
    });
});