define([
    "dojo/_base/declare",
    "dijit/registry",
    "widgets/userInfo",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/query",
    "dijit/_WidgetBase",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/_base/connect",
    "dojo/_base/event"
],function(declare,registry,userInfo,lang,domStyle,query,_WidgetBase,xhr,json,array,domAttr,domClass,domConstruct,connect,event){
    var optionStr = "ABCDEFGHIIJKLMNOPQRSTUVWXYZ",Question = declare("",[_WidgetBase],{
        //根节点对应的class
        baseClass:"cqVoteQ",
        //问题ID
        QID:"",
        //问题的标题
        QNAME:"",
        //本问题的总票数
        count:0,
        //问题备选答案，数组
        answers:null,
        //最多允许选择的数量，为0时表示可全选，为1时为单选，否则为多选
        maxOption:0,
        //问题的序号，从零开始
        qindex:0,
        //是否已回答，回答过的可以看投票情况，否则参与之后才能查看
        answered:false,
        //初始化界面元素和事件
        postCreate:function(){
            this.inherited(arguments);
            if(!this.maxOption){
                this.maxOption = this.answers.length;
            }
            
            domConstruct.create("div",{class:"stallDiv"},this.domNode);
            domConstruct.create("div",{style:"",class:"voteName",innerHTML:'<span style="" class="vn">'+this.QNAME+'</span>'},this.domNode);
            
            var vnw = domStyle.get(query(".voteName",this.domNode)[0],"width");
            var vnsw = domStyle.get(query(".voteName>span",this.domNode)[0],"width");
            var vnw_vnsw = (parseInt(vnw,10)-parseInt(vnsw,10))/2 + "px";
            domStyle.set(query(".vn",this.domNode)[0],"marginLeft",vnw_vnsw);
            
            this.domNode.appendChild(domConstruct.toDom("<div class='voteContentPDiv' questionname="+this.QNAME+">"+array.map(this.answers,this._getOptionStr,this).join("")+"</div>"));
            
            changeOption();
                
            window.onresize=function(){
                query(".voteName>span",this.domNode).forEach(function(node){
                    domStyle.set(node,"marginLeft",(parseInt(domStyle.get(node.parentNode,"width"),10)-parseInt(domStyle.get(node,"width"),10))/2 + "px");
                });
            };
            
            this.own(connect.connect(this.domNode,"click",this,this.onClick));
        },
        _getOptionStr:function(answer,index){
            return  '<div class="voteContent">'+
                        '<img src="/w/img/load/'+window.code+'-'+answer.ASICON+'" class="voteAnwserIMG" />'+
                        '<div class="voteDetailDiv">'+
                            '<div>'+
                                '<div class="voteContentNameDiv"><span class="voteContentName">'+answer.ASNAME+'</span></div>'+
                                '<div class="voteContentPollDiv"><span class="voteContentPoll">'+answer.count+'</span></div>'+
                            '</div>'+
                            '<div class="clickVote" ASIDAttr='+answer.ASID+'>'+
                                '<span class="clickVoteSpan" ASIDAttr='+answer.ASID+'>点击投票</span>'+
                            '</div>'+
                            '<div style="clear:both;"></div>'+
                        '</div>'+
                    '</div>';
        }
    });
    
    //查询 已投选项并做处理
    changeOption = function(){
        //创建  已投选项结果集
        var ASIDresults;
        //加载 "投票结果"资源
        window.loadData({
            modalName:"XSY_TWBCM_VOTERESULT",
            filter:"02",
            pageSize:"20",
            pageIndex:"1",
            param:{VID:window.did,PID:window.userInfo.partnerId}
        }).then(lang.hitch(this,function(data){
            //判断 是否有数据
            if(data.length){
                //创建 已投过票选项的数组并赋值
                ASIDresults = [];
                for(var i=0; i<data.length; i++){
                    ASIDresults.push(data[i].ASID);
                }
                //去除 数组重复元素
                var hash = {},newASIDresults=[];
                for (var j = 0, elem; (elem = ASIDresults[j]) != null; j++) {
                    if (!hash[elem]) {
                        newASIDresults.push(elem);
                        hash[elem] = true;
                    }
                }
                //查询 已投票选项并改变其样式
                query(".clickVote",this.domNode).forEach(function(node){
                    for(i = 0; i < newASIDresults.length; i++){
                        if(newASIDresults.toString().indexOf(domAttr.get(node,"asidattr")) != -1){
                            domStyle.set(node,"background","#e5e5e5");
                            domAttr.set(node,"noListener","true");
                            domAttr.set(node.firstChild,"noListener","true");
                            node.firstChild.innerHTML="已投";
                            domStyle.set(node.firstChild,"line-height","32px");
                        }
                    }
                });
            }else{
                //alert('没有数据');
            }
        }));
    };
    
    return declare("widgets.common._OnlineVote_ElectMixin",null,{
        isOnlineVote_ElectLoaded:function(){
            return !!this.voteDetail;
        },
        indexOnlineVote_ElectElement:function(){
            this.voteDetail = registry.byId("voteDetailUl");
            //问题列表所在列表
            this._voteQListDiv = query(".oVoteQList",this.domNode)[0];
            //说明信息所在界面
            this._voteDescDiv = query(".voteDesc",this.domNode)[0];
            //提交答案按钮
            this._voteOkBtn = registry.byNode(query(".voteOkBtn",this.domNode)[0]);
            //"点击投票"按钮
            this._clickVote = query(".clickVote",this.domNode)[0];
        },
        initOnlineVote_ElectEvent:function(){
            domStyle.set(query(".mblScrollablePane",this.domNode)[0],{"backgroundColor":"white"});
            
            //预加载 "调查活动"资源
            window.loadData({
                modalName:"XSY_TWBCM_VOTE",
                filter:"02",
                pageSize:"1",
                pageIndex:"1",
                param:{VID:window.did}
            }).then(lang.hitch(this,function(data){
                //判断 是否有数据
                if(data.length){
                    //判断 投票权限为注册会员时的登录状态
                    if(data[0].VLIMIT==2){
                        userInfo.hasLogin().then(lang.hitch(this,function(hasLogin) {
                            if (hasLogin) {
                                
                            } else {
                                window.nextPageOnLogin = "onlineVote_Elect-"+window.did;
                                userInfo.showLogin();
                            }
                        }));
                    }
                }else{
                    //alert('没有该投票ID');
                }
            }));
            
            //"点击投票" 单击事件
            this.connect(this._clickVote,"onclick",function(e){
                //接收 点击对象
                var clickVoteNode = e.target;
                //判断 点击对象
                if(domAttr.get(clickVoteNode,"class")=="clickVote"||domAttr.get(clickVoteNode,"class")=="clickVoteSpan"){
                //已投节点无事件
                if(domAttr.get(clickVoteNode,"noListener") == "true"){return false;}
                //获取 拥有可选数属性的节点
                var optionalnumberNode = clickVoteNode.parentNode.parentNode.parentNode;
                //获取 投票剩余次数
                // var optionalnumber = parseInt(domAttr.get(domAttr.has(optionalnumberNode,"optionalnumber")===true?optionalnumberNode:optionalnumberNode.parentNode,"optionalnumber"),10);
                // var questionName = domAttr.get(domAttr.has(optionalnumberNode,"optionalnumber")===true?optionalnumberNode:optionalnumberNode.parentNode,"questionname");
                // if(optionalnumber - 1 > 0) alert("投票成功！("+questionName+")还有"+(optionalnumber-1)+"次投票机会！");
                // else if(optionalnumber - 1 === 0) alert("投票成功！("+questionName+")已无剩余投票数！");
                // else if(optionalnumber - 1 < 0) alert("("+questionName+")已无剩余投票次数。");
                //提交 投票结果
                var result = [domAttr.get(clickVoteNode,"ASIDAttr")];
                xhr("POST",{
                    url:"/w/prize/onlineVoted/"+window.code,
                    handleAs:"json",
                    content:{
                        VID:window.did,
                        aswids:result[0]
                    },
                    load:lang.hitch(this,this._onVoteResultClicked),
                    error:lang.hitch(this,this._onVoteError)
                });
                }
            });
        },
        
        //投票
        _onVoteResultClicked:function(data){
            window.abc = data;
            if(data&&data.data){
                this._voteDescDiv.innerHTML = data.data.vote.VREMARK;
                var questions = data.data.questions,hash = {},ahash = {};
                //初始化问题列表
                array.forEach(questions,function(question,index){
                    //建立索引，方便后边使用
                    hash[question.QID] = question;
                    //初始化备选答案
                    question.answers = [];
                    //是否已回答的标志——是否可以再次回答
                    question.answered = !data.data.canVote;
                    //备选答案的选择数量
                    question.count = 0;
                    //依据选择提的类型判断单选还是多选
                    question.maxOption = "0"===question.QTYPE?1:0;
                    //问题的序号
                    question.qindex = index;
                });
                //初始化问题备选答案
                array.forEach(data.data.answers,function(answer){
                    //备选答案建立索引，方便后边使用
                    ahash[answer.ASID] = answer;
                    //初始化本备选答案的被选中数量
                    answer.count = 0;
                    if(hash[answer.QID]){
                        //加入到对应问题的备选答案列表中
                        hash[answer.QID].answers.push(answer);
                    }
                });
                //初始化投票结果
                array.forEach(data.data.voteDatas,function(voteData){
                    //找到对应备选答案
                    var answer = ahash[voteData.ASID];
                    if(answer){
                        //设置备选答案的选中数量
                        answer.count = (voteData.VOTES-0)||0;
                        //找到对应的问题
                        var question = hash[answer.QID];
                        if(question){
                            //找到对应的问题的得票数
                            question.count += answer.count;
                        }
                    }
                });
                //更改 投票样式
                changeOption();
                //更改 投票数量
                var voteContentPollNode = query(".voteContentPoll",this.domNode);
                for(var i = 0; i<data.data.answers.length; i++){
                    voteContentPollNode[i].innerHTML = data.data.answers[i].count;
                }
                
                //计算 剩余可投票数
                // for(i = 0; i < data.data.questions.length; i++){
                //     domAttr.set(query(".voteContentPDiv")[i],"optionalnumber",parseInt(data.data.questions[i].MOPTION,10)===0?parseInt(domAttr.get(query(".voteContentPDiv")[i],"optionalnumber"),10) - parseInt(data.data.questions[i].count,10):parseInt(data.data.questions[i].MOPTION,10) - parseInt(data.data.questions[i].count,10));
                // }
            }
            if(data.message){
                if(data.message != "票数已用尽")
                //若有提示信息，将提示信息呈现给用户
                alert(data.message);
                else
                alert("当前投票项目的"+data.message);
            }
            if(data.remain){
                //提示剩余次数
                alert("投票成功！还剩余"+data.remain+"次投票机会！");
            }
        },
        
        //加载数据成功的处理函数
        _onVoteResultLoaded:function(data){
            this._empotyVote();
            window.abc = data;
            if(data&&data.data){
                // query(".shop_module_item_title")[0].innerHTML=data.data.vote.VTITLE;
                // this._voteTitleDiv.innerHTML = data.data.vote.VTITLE;
                this._voteDescDiv.innerHTML = data.data.vote.VREMARK;
                var questions = data.data.questions,hash = {},ahash = {};
                //初始化问题列表
                array.forEach(questions,function(question,index){
                    //建立索引，方便后边使用
                    hash[question.QID] = question;
                    //初始化备选答案
                    question.answers = [];
                    //是否已回答的标志——是否可以再次回答
                    question.answered = !data.data.canVote;
                    //备选答案的选择数量
                    question.count = 0;
                    //依据选择提的类型判断单选还是多选
                    question.maxOption = "0"===question.QTYPE?1:0;
                    //问题的序号
                    question.qindex = index;
                });
                //初始化问题备选答案
                array.forEach(data.data.answers,function(answer){
                    //备选答案建立索引，方便后边使用
                    ahash[answer.ASID] = answer;
                    //初始化本备选答案的被选中数量
                    answer.count = 0;
                    if(hash[answer.QID]){
                        //加入到对应问题的备选答案列表中
                        hash[answer.QID].answers.push(answer);
                    }
                });
                //初始化投票结果
                array.forEach(data.data.voteDatas,function(voteData){
                    //找到对应备选答案
                    var answer = ahash[voteData.ASID];
                    if(answer){
                        //设置备选答案的选中数量
                        answer.count = (voteData.VOTES-0)||0;
                        //找到对应的问题
                        var question = hash[answer.QID];
                        if(question){
                            //找到对应的问题的得票数
                            question.count += answer.count;
                        }
                    }
                });
                //将问题显示到界面中
                array.forEach(questions,function(question){
                    (new Question(question,domConstruct.create("div",{},this._voteQListDiv))).startup();
                },this);
                
                //初始化 可投票数
                // for(i = 0; i < data.data.questions.length; i++){
                //     domAttr.set(query(".voteContentPDiv")[i],"optionalnumber",data.data.questions[i].MOPTION != "0"?(parseInt(data.data.questions[i].MOPTION,10) - parseInt(data.data.questions[i].count,10)):1 - parseInt(data.data.questions[i].count,10));
                // }
            }
            if(data.message){
                //若有提示信息，将提示信息呈现给用户
                alert(data.message);
            }
        },
        
        //投票或加载数据失败的处理函数
        _onVoteError:function(){
            //销毁原有内容
            this._empotyVote();
            alert("系统错误，请稍后重试");
        },
        _empotyVote:function(){
            //销毁原有内容
            this._voteOkBtn.getParent().getChildren().forEach(function(item){
                if(item!==this._voteOkBtn){
                    item.destroyRecursive();
                }
            },this);
            this._voteDescDiv.innerHTML = "";
            // this._voteTitleDiv.innerHTML = "";
            domStyle.set(this._voteOkBtn.focusNode,"display","none");
        },
        refreshAllList:function(){
            //加载当前投票信息
            xhr("GET",{
                url:"/w/prize/onlineVoteInfo/"+window.code,
                handleAs:"json",
                content:{
                    VID:window.did
                },
                load:lang.hitch(this,this._onVoteResultLoaded),
                error:lang.hitch(this,this._onVoteError)
            });
        }
    });
});