define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/query",
    "dijit/registry",
    "dojo/Deferred",
    "dojo/_base/xhr",
    "widgets/orderCarRecord",
    "widgets/userInfo"
], function(declare, lang, array, domAttr, query, registry, Deferred, xhr, orderCarRecord,userInfo) {
    return declare("widgets.common._OrderCarMixin",null,{
        isOrderCarLoaded:function(){
            return !!this.orderCarList;
        },
        indexOrderCarElement:function(){
            this.orderCarList = registry.byId("orderCarList"); //购物车list2
            this.ttlPrice = query(".ttlPrice span",this.domNode)[0]||query(".ttlPrice span")[0]; //侦听购物车总计
            this.settlement = query(".checkOut",this.domNode)[0]||query(".checkOut")[0]; //侦听结算
            this.jifen = query(".jifen",this.domNode)[0]||query(".jifen")[0]; //积分
        },
        initOrderCarEvent:function(){
            this.connect(this.orderCarList, "onDefRendered", function(data) { //加载购物车list2之前
                orderCarRecord.data = data; // 购物车中数据
                orderCarRecord.total = 0; //定义购物车总计为0
                window.jifen = 0; //定义积分为0
                var orderCar = orderCarRecord.getOrderCar(),
                    appMats = []; //定义购物车中商品、数量
                array.forEach(data.data.items, function(item, index) { // 循环购物车中商品、数量
                    item.type = index > 0 && item.T0_AID.APP_ID == data.data.items[index - 1].T0_AID.APP_ID ? 0 : 1;
                    if (item.T0_MID) { // 如果有商品
                        //限购商品是0或者没有值的时候就在购物车数量和库存数量中取最小值，其中库存为0时会自动删除该商品
                        if (!item.T0_TPCH_NUM || item.T0_TPCH_NUM == 0) {
                            item.QTY = Math.min(orderCar[item.T0_MID], item.T9_SHELF_QTY);
                        } else {
                            item.QTY = Math.min(orderCar[item.T0_MID], item.T9_SHELF_QTY, item.T0_TPCH_NUM);
                        }
                        array.forEach(window.data, function(data12) { // 多买模式匹配商品优惠信息
                            if (item.T0_MID == data12.MID || item.T0_MID == data12["MID.T0_MTID"]) {
                                //item.DIS = data12.Price * item.QTY;
                                item.DIS = data12.Price;
                                item.DIS_D = data12.Price;
                                window.jifen += data12.Price;
                            }
                        });
                        item.AMNT = item.QTY * item.T3_RetailPrice;
                        item.PRI = item.T0_MainUnitID.MeasureName;
                        orderCarRecord.total += item.AMNT;
                        item.SHELF_QTY = item.T9_SHELF_QTY; //库存数量

                        if (index > 0 && item.T0_AID.APP_ID == data.data.items[index - 1].T0_AID.APP_ID) {
                            array.forEach(appMats, function(appMats) {
                                if (item.T0_AID.APP_ID == appMats.appMatAid) {
                                    appMats.appMatAmnt = parseFloat(appMats.appMatAmnt) + parseFloat(item.AMNT);
                                }
                            });
                        } else {
                            appMats.push({
                                appMatAid: item.T0_AID.APP_ID,
                                appMatAmnt: item.AMNT
                            });
                        }

                        array.forEach(window.appData, function(appData) { //循环货主信息
                            if (item.T0_AID.APP_ID == appData.APP_ID) {
                                item.district = appData.TRAN_REGION;
                                if (appData.TRAN_AID) { //如果有物流货主，邮费为0
                                    item.postAge = "0";
                                    item.bagAmnt = "0";
                                } else {
                                    item.postAge = appData.TRAN_FEE;
                                    if (item.T0_AID.APP_ID == g_sys_info.aid) {
                                        item.bagAmnt = appData.DIR_LMT || "0";
                                    } else {
                                        item.bagAmnt = appData.DIS_LMT || "0";
                                    }
                                }
                            }
                        });
                    } else {
                        item.AMNT = "";
                    }
                }, this);
                array.forEach(data.data.items, function(item) {
                    array.forEach(appMats, function(appMats) {
                        if (item.T0_AID.APP_ID == appMats.appMatAid) {
                            item.isPostBag = (item.bagAmnt - appMats.appMatAmnt > 0) ? "0" : "1";
                            item.appMatAmnt = appMats.appMatAmnt;
                        } else {
                            //item.isPostBag = "0";
                        }
                    });
                });
                //多买模式  更新本地购物车
                if (this.did) {
                    orderCarRecord.setOrderCar(orderCar);
                }
                this.ttlPrice.innerHTML = "￥" + window.fixedTo(orderCarRecord.total, 3);
                this.jifen.innerHTML = window.fixedTo(window.jifen, 0); // 更新积分
                window.orderMids = data.data.items.length ? window.orderMids : [];
                this.updateFooter();
            });
            this.connect(this.orderCarList.domNode, "onclick", this._orderMatListClick); // 侦听购物车
            this.settlement.onclick = lang.hitch(this, this._settleDown); // 侦听结算按钮
            this.subscribe("widgets/show/view", function(id) {
                if (id === this.id) {
                    this.updateFooter();
                }
            });
            this.connect(query(".gobuy.clear", this.domNode)[0], "onclick", function() {
                orderCarRecord.setOrderCar({});
                orderCarRecord.carChanged = true;
                var car = orderCarRecord.getOrderCar(),n = 0;
                for(var mid in car){
                    n += car[mid]||0;
                }
                var carNodes = query(".stdOrderNum");
                if(carNodes){
                    array.forEach(carNodes,function(node){
                        node.innerHTML = n;
                    });
                }
                this.refreshAllList();
            });
        },
        _settleDown: function() {
            // 判断是否有商品
            if (window.orderMids.length == "0") {
                alert("您还没有选购商品,不能结算！");
                return false;
            }
            //区分单买模式和购物车模式
            userInfo.hasLogin().then(function(s){
                if(s){
                    window.moveToView("orderInfo");
                }else{
                     window.nextPageOnLogin = "orderInfo";
                    userInfo.showLogin();
                    //.then(function(s1){
                    //    if(s1){
                    //        window.moveToView("orderInfo");
                    //    }
                    //});
                }
            });
            //window.moveToView("orderInfo"); //this.did?"orderInfo-singleBuy":
        },
        refreshAllList:function(){
            window.updateTitle("购物车");
            if (window.did) {
                window.orderMids = [window.singleBuyMatId];
                this.disInfo();
            } else {
                if (this.did || orderCarRecord.carChanged) {
                    orderCarRecord.carChanged = false;
                    var car = orderCarRecord.getOrderCar(),
                        mids = [];
                    for (var mid in car) {
                        if (mid) {
                            mids.push(mid);
                        }
                    }
                    window.orderMids = mids;
                    this.disInfo();
                }
            }
            this.did = window.did;
            this.updateFooter();
        },
        updateFooter: function() {
            if (g_sys_info.temp != "lx2") {
                if (window.orderMids.length) {
                    query(".m-cart-e.add", this.domNode)[0].style.display = "none";
                    query(".m-cart-e.clear", this.domNode)[0].style.display = "";
                    query(".footer")[0].style.display = "";
                } else {
                    query(".m-cart-e.add", this.domNode)[0].style.display = "";
                    query(".m-cart-e.clear", this.domNode)[0].style.display = "none";
                    query(".footer")[0].style.display = "none";
                }
            }
        },
        disInfo: function() {
            // 取商品优惠信息
            window.loadData({
                modalName: "XSY_TSDCD_PRICEDTS",
                filter: "02",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "MID": window.orderMids
                }
            }).then(lang.hitch(this, function(data) {
            //this._dealDeposits(window.orderMids).then(lang.hitch(this,function(){
                if (data.length) {
                    window.data = data;
                }
                var mats = [];
                array.forEach(window.data,function(mat){
                    mats.push(mat.MID);
                });
                this._dealDeposits(mats).then(lang.hitch(this,function(){
                window.loadData({
                    modalName: "XSY_VBSSC_MAT",
                    filter: "07",
                    pageSize: "1",
                    pageIndex: "1",
                    param: {
                        "MID": window.orderMids
                    }
                }).then(lang.hitch(this, function(data1) {
                    var appIds = [],
                        car = orderCarRecord.getOrderCar(),
                        car1 = {}, orderMids = [],
                        num = 0;
                    if (data1.length) {
                        for (var i = 0; i < data1.length; i++) {
                            appIds.push(data1[i].T0_AID);
                            var mid = data1[i].T0_MID;
                            if (data1[i].T0_AID == g_sys_info.aid) { //如果是当前货主
                                if (data1[i].T0_IsUse == 0 || data1[i].T0_IsAllowSale == 0 || data1[i].T9_SHELF_QTY <= 0||data1[i].T0_IS_ONLINESALE==0) {
                                    delete car[mid];
                                    window.orderMids.splice(array.indexOf(window.orderMids, mid), 1);
                                } else {
                                    car1[mid] = car[mid];
                                    orderMids.push(mid);
                                }
                            } else {
                                if (data1[i].T0_IsUse == 0 || data1[i].T0_IsAllowSale == 0 || data1[i].T9_SHELF_QTY <= 0 || data1[i].T0_IsAllSO == 0||data1[i].T0_IS_ONLINESALE==0) {
                                    delete car[mid];
                                    window.orderMids.splice(array.indexOf(window.orderMids, mid), 1);
                                } else {
                                    car1[mid] = car[mid];
                                    orderMids.push(mid);
                                }
                            }
                        }
                        orderCarRecord.setOrderCar(car1);
                        window.orderMids = orderMids;
                        for (var mid in car1) {
                            if (mid && car1[mid]) {
                                num = num + 1; //num += orderCar[mid] - 0;
                            }
                        }
                        //将数量显示在指定位置
                        if(this.showOrderCarNum){
                            query(".cart_com")[0].innerHTML = num;
                        }
                    }
                    if (appIds.length) {
                        window.loadData({ //找货主的邮费信息
                            modalName: "XSY_TSSCF_APP",
                            filter: "999",
                            pageSize: "1",
                            pageIndex: "1",
                            param: {
                                "AID": appIds,
                                "INPUT": ''
                            }
                        }).then(lang.hitch(this, function(appData) {
                            if (appData.length) {
                                window.appData = appData;
                            }
                            this.orderCarList.refreshList(); // 不管是否有优惠信息都要刷新购物车
                        }));
                    } else {
                        this.orderCarList.refreshList(); // 不管是否有优惠信息都要刷新购物车
                    }
                }));
            }));
            }));
            this.scrollTo({
                x: 0,
                y: 0
            });
        },
        _orderMatListClick: function(e) {
            if (e.target) {
                var c = domAttr.get(e.target, "class");
                if (-1 < c.indexOf("add_")) {
                    this._addMatNum(c.split("_")[1], 1);
                } else if (-1 < c.indexOf("des_")) {
                    this._addMatNum(c.split("_")[1], - 1);
                } else if (-1 < c.indexOf("del_")) { // 点击删除按钮时
                    this._delMat(c.split("_")[1]);
                    //this.disInfo();
                } else {
                    return;
                }
            } else {
                return;
            }
        },
        _delMat: function(mid) {
            window.busy();
            var car = orderCarRecord.getOrderCar(),
                index = orderCarRecord.data.data.items.length;
            while (index--) {
                if (orderCarRecord.data.data.items[index].T0_MID == mid) {
                    break;
                }
            }
            if (-1 < index) {
                delete car[mid];
                window.orderMids.splice(array.indexOf(window.orderMids, mid), 1);
                if (!this.did) { //如果是购物车模式
                    orderCarRecord.setOrderCar(car);
                }
                var node = query(".MID_" + mid, this.orderCarList.domNode)[0];
                node.parentNode.removeChild(node);
                orderCarRecord.total = orderCarRecord.total - orderCarRecord.data.data.items[index].QTY * orderCarRecord.data.data.items[index].T3_RetailPrice;
                //window.jifen = window.jifen - orderCarRecord.data.data.items[index].QTY * orderCarRecord.data.data.items[index].DIS_D || 0;
                var jifenlength = orderCarRecord.data.data.items.length;
                window.jifen=0;
                while (jifenlength--) {
                    if (orderCarRecord.data.data.items[jifenlength].DIS_D) {
                        window.jifen += orderCarRecord.data.data.items[jifenlength].DIS_D || 0;
                    }
                }
                this.ttlPrice.innerHTML = "￥" + window.fixedTo(orderCarRecord.total, 3);
                this.jifen.innerHTML = window.fixedTo(window.jifen, 0); // 更新积分
                orderCarRecord.data.data.items.splice(index, 1);
            }
            this.disInfo();
            window.free();
        },
        _addMatNum: function(mid, inc) {
            var car = orderCarRecord.getOrderCar(),
                index = orderCarRecord.data.data.items.length;
            while (index--) {
                if (orderCarRecord.data.data.items[index].T0_MID == mid) {
                    break;
                }
            }
            //增加数量时  如果超过库存或者限购数量则不能增加
            if (index < 0 || (orderCarRecord.data.data.items[index].QTY - 1 + 1 + inc) > orderCarRecord.data.data.items[index].SHELF_QTY) {
                return;
            } else {
                if (index < 0 || (orderCarRecord.data.data.items[index].QTY - 1 + 1 + inc) > (orderCarRecord.data.data.items[index].T0_TPCH_NUM || 0) && (orderCarRecord.data.data.items[index].T0_TPCH_NUM || 0) > 0) {
                    return;
                }
                orderCarRecord.data.data.items[index].QTY += inc;

            }
            orderCarRecord.data.data.items[index].AMNT = orderCarRecord.data.data.items[index].QTY * orderCarRecord.data.data.items[index].T3_RetailPrice;
            // 更新积分
            //orderCarRecord.data.data.items[index].DIS = orderCarRecord.data.data.items[index].QTY * orderCarRecord.data.data.items[index].DIS_D;
            //window.jifen += inc * orderCarRecord.data.data.items[index].DIS_D || 0;
            orderCarRecord.data.data.items[index].DIS = orderCarRecord.data.data.items[index].DIS_D;
            var jifenlength = orderCarRecord.data.data.items.length;
                window.jifen=0;
                while (jifenlength--) {
                    if (orderCarRecord.data.data.items[jifenlength].DIS_D) {
                        window.jifen += orderCarRecord.data.data.items[jifenlength].DIS_D || 0;
                    }
                }
            orderCarRecord.total += inc * orderCarRecord.data.data.items[index].T3_RetailPrice;
            this.ttlPrice.innerHTML = "￥" + window.fixedTo(orderCarRecord.total, 3);
            this.jifen.innerHTML = window.fixedTo(window.jifen, 0); // 更新积分
            //如果是多买模式  更新到orderCarRecord
            if (!this.did) {
                car[mid] += inc;
                if (0 === car[mid]) {
                    delete car[mid];
                    window.orderMids.splice(array.indexOf(window.orderMids, mid), 1);
                    orderCarRecord.setOrderCar(car);
                }
                orderCarRecord.setOrderCar(car);
            }
            if (orderCarRecord.data.data.items[index].QTY) {
                query(".QTY_" + mid, this.orderCarList.domNode)[0].innerHTML = orderCarRecord.data.data.items[index].QTY;
                query(".AMNT_" + mid, this.orderCarList.domNode)[0].innerHTML = "小计：￥<span>" + window.fixedTo(orderCarRecord.data.data.items[index].AMNT, 3) + "</span>";

            } else {
                var node = query(".MID_" + mid, this.orderCarList.domNode)[0];
                node.parentNode.removeChild(node);
            }
            this.disInfo();
        },
        _dealDeposits: function(mats) {
            var def = new Deferred();
            //加载分销商品ID，只有本帐套的商品才能定优惠政策
            window.loadData({
                modalName: "XSY_VBSSC_MAT",
                filter: "15",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "MID":array.map(mats,function(mat){
                        return mat;
                    })
                }
            }).then(lang.hitch(this,function(matData){
                //找到商品ID和商品ID之间的对应关系
                var mids = [],midHash = {},qtys = [];
                array.forEach(matData,function(mat){
                    mids.push(mat.T0_MID);
                    qtys.push(orderCarRecord.getOrderCar()[mat.T0_MID]);
                    midHash[mat.T0_MID] = mat.T0_MID;
                    midHash[mat.T0_MTID] = mat.T0_MID;
                });
                xhr("GET",{
                    url:"/w/data/GetMatsCreditByQty/"+window.code+"-"+window.openId,
                    handleAs:"json",
                    content: {
                        mats: mids.join(","),
                        qtys:qtys.join(",")
                    },
                    load:function(result) {
                        var desInfo = {};
                        if(result&&result.data&&result.data.items){
                            //商品的积分政策
                            array.forEach(result.data.items, function(item) {
                                desInfo[item.MID] = parseFloat(item.CREDIT,10)||0;
                            });
                        }
                        array.forEach(window.data,function(mat){
                            mat.Price = desInfo[midHash[mat.MID]]||0;
                        });
                        //将提交结果直接返回给调用者
                        def.resolve(window.data);
                    },
                    error:function(err){
                        //提交订单错误，返回错误及信息
                        def.resolve({
                            rtnType:"101",
                            message:err&&err.message||"数据错误"
                        });
                    }
                });
            }));
            return def;
        }
    });
});