define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/query",
    "dojo/_base/lang",
    "../userInfo",
    "dojo/dom-style",
    "dojo/_base/xhr",
    "dojo/_base/array",
    "dojo/dom-construct",
    "widgets/orderPayHandler",
    "dojo/dom-attr",
    "dojo/Deferred"], function(declare, registry, query, lang, userInfo, domStyle, xhr, array, domConstruct, orderPayHandler, domAttr, Deferred) {
    return declare("widgets.common._OrderDetailMixin", null, {
        billCode: "",
        totalPrice: "",
        //isTest: false,
        isPay: false, //是否支付
        isCancel: false, //是否作废
        isPayEar: false,
        isPreOrder: false,
        canPay: false,
        pacbuyID:"",  //是否是拼团订单
        pacbuyTYPE:"",  //拼团类型
        isWbOrder:false,
        getDtlByMyShelf:false,
        isOrderDetailLoaded: function() {
            return !!this.tradeDetailList;
        },
        indexOrderDetailElement: function() {
            if (!this.isOrderDetailLoaded()) {
                this.pointPayBtn = query("#pointpay")[0]; //积分支付
                this.aliPayBtn = query("#alipay")[0]; //支付宝支付
                this.weixinPayBtn = query("#weixinpay")[0]; //微信支付
                this.tradeHeadList = registry.byId("tradeHead");
                this.tradeDetailList = registry.byId("tradeDetail");
                this.toPayHElement = query(".orderfooter")[0]; //底部
            }
        },
        initOrderDetailEvent: function() {
            // 监听积分支付按钮
            this.connect(this.pointPayBtn, "click", function() {
                this.toPay("point");
            });
            // 监听支付宝支付按钮
            this.connect(this.aliPayBtn, "click", function() {
                this.toPay("alipaywap");
            });
            // 监听微信支付按钮
            this.connect(this.weixinPayBtn, "click", function() {
                this.toPay("weixin");
            });
            //订单头部
            this.connect(this.tradeHeadList, "onDefRendered", function(data) { 
                this.getOrderState(data, true);
            });
            // 订单明细
            this.connect(this.tradeDetailList, "onDefRendered", function(data) {
                this.getOrderInfo(data);
            });
            this.subscribe("widgets/show/view", function(id) {
                if (id === this.id) {
                    this.updateFooter();
                }
            });
            // 监听订单明细点击事件
            this.connect(this.tradeDetailList.domNode, "onclick", this.tradeDetailClick);
        },
        getOrderInfo:function(data){
            // 计算本张订单所获得积分
            this.points = 0; 
            // 计算本张订单的运费
            this.ttlPostage = 0;
            // 计算订单使用的积分/代金券/优惠券信息
            this.or_point = 0;
            // 存各个货主的总金额以及邮费、包含的商品数
            var appMats = [],items = data.data.items,len,
            // 运费数据
            postItem = array.filter(items,function(item){
                return item.T4_MID==29999;
            }),
            // 不包含运费的数据
            itemNotPost = array.filter(items,function(item){
                return item.T4_MID!=29999;
            });
            // 计算总运费
            array.forEach(postItem,function(item){
                this.ttlPostage += parseFloat(item.T4_DeliAmount || 0);
            },this);
            // 不包含运费的数据长度
            len = itemNotPost.length;
            // 获取各个商家的第一个和最后一个商品
            array.forEach(itemNotPost, function(item, index) {
                item.last = index < len - 1 && this.getAID(item.T4_AID) == this.getAID(itemNotPost[index + 1].T4_AID) ? 0 : 1;
                // 本张订单获得的积分数
                this.points += parseFloat(item.T4_Deposit || 0); 
            },this);
            //循环订单明细
            array.forEach(items, function(item, index) {  
                this.or_point += parseFloat(item.T4_POINT||0)+parseFloat(item.T4_COIN||0)+parseFloat(item.T4_COUPONAMT||0);
                // 记录按钮数量
                item.btnNum = 0;
                item.T4_D_TIMES = parseFloat(item.T4_D_TIMES||0);
                item.T4_DeliveryQty = parseFloat(item.T4_DeliveryQty||0);
                item.btnList = [];
                // 1.评价
                // 童颜
                if(this.isTongYan=="1"){
                    //是否显示评价（已支付、已审核、已发货、未取消）童颜
                    if (item.T0_C4==0&&item.T4_State == 1&&(item.T4_IS_SIGN==1 ||(item.T4_MID.T0_SERVICE_TYPE==1 && item.T4_DeliveryQty==item.T4_D_TIMES)) && item.T4_IS_CANCEL == 0 && (item.T4_IS_EVA == 0 || item.T4_IS_EVA == "")) {
                        item.canSubEva = 1;
                        item.btnNum++;
                    }else {
                        item.canSubEva = 0;
                    }
                    //是否加载预约按钮  童颜
                    item.SERVICE_TYPE=0;
                    if(item.T4_IS_CANCEL == 0 &&item.T4_State == 1&&item.T0_C4 == 0 && (item.T4_MID.T0_SERVICE_TYPE ==1 || item.T4_MID.T0_SERVICE_TYPE==2) && item.T4_DeliveryQty < item.T4_D_TIMES)
                    {
                        item.SERVICE_TYPE=1;
                    }
                }
                // 农企宝   
                else { 
                    // 是否显示评价按钮
                    if (item.T0_C4 == 0 && item.T4_State == 1&& item.T4_IS_SIGN==1 && item.T4_IS_APR == 1 && item.T4_IS_CANCEL == 0 && (item.T4_IS_EVA == 0 || item.T4_IS_EVA == "")) {
                        item.btnNum++;
                        item.canSubEva = 1;
                    } else {
                        item.canSubEva = 0;
                    }
                }
                // 3.签收
                // 判断能否签收
                if(item.T4_IS_CANCEL==0&&(item.T4_IS_SIGN==0||item.T4_IS_SIGN=="")&&item.T0_C4==0&&item.T4_IS_APR==1){
                    item.canQs = 1;
                    item.btnNum++;
                }else{
                    item.canQs = 0;
                }
                // 4.追溯/查询物流
                // 能否追溯
                item.Zs = 0;
                if((g_sys_info.aid==305957||g_sys_info.aid==40775||g_sys_info.aid=="40972")&&item.canDd&&item.canDd==1){
                    item.Zs = 1;
                    item.btnNum++;
                }
                item.canQryWl = 0;
                // 能否查询物流
                if(item.canDd&&item.canDd==1&&item.T4_IS_CYCLE==0){
                    item.canQryWl = 1;
                    item.btnNum++;
                    item.logQryUrl = (item.logProvider&&item.logCode&&
                    "http://m.kuaidi100.com/result.jsp?com="+item.logProvider+"&nu="+
                    item.logCode.split(/[,，]/g)[0])||"#logQry";
                }
                
                if(item.T0_SERVICE_TYPE ==1){
                    this.isWbOrder=true;
                }
                // 5.选菜
                // 判断能否选菜
                if(item.T0_C4 == 0 && item.T4_State == 1 && item.T4_IS_CANCEL == 0 && (item.T4_D_TIMES - item.T4_DeliveryQty) > 0&&item.T4_IS_CYCLE==1&&item.T4_IS_PAUSE==0&&item.T4_MID.T12_OPT){
                    item.showXc = 1;
                    item.btnNum++;
                    // 如果按钮>4个 则要将选菜放到更多中
                    if(item.btnNum>4){
                        item.btnList.push({
                            entryId:item.T4_EntryID,
                            name:"选菜",
                            onclick:"window.moveToView('matOption','"+item.T4_MID.T12_OPT+"_"+item.T0_DeliBillID+"_"+item.T4_EntryID+"')"
                        });
                        item.showXc = 0;
                    }
                }else{
                    item.showXc = 0;
                }
                // 6.暂停/恢复配送
                // 判断是够暂停配送
                if (item.T0_C4 == 0 && item.T4_State == 1 && item.T4_IS_CANCEL == 0 && (item.T4_D_TIMES - item.T4_DeliveryQty) > 0&&item.T4_IS_CYCLE==1) {
                    item.showA = 1;
                    item.btnNum++;
                    if(item.btnNum>4){
                        item.btnList.push({
                            entryId:item.T4_EntryID,
                            name:item.T4_IS_PAUSE==0?"暂停配送":"恢复配送",
                            class:item.T4_IS_PAUSE==0?"pauseOrder":"recoveryOrder",
                            onclick:""
                        });
                        item.showA = 0;
                    }
                } else {
                    item.showA = 0;
                }
                // 7.配送详情
                // 显示配送详情
                if(item.T0_C4 == 0 && item.T4_State == 1 && item.T4_IS_APR == 1&&item.T4_IS_CYCLE == 1){
                    item.showDis = 1;
                    item.btnNum++;
                    if(item.btnNum>4){
                        item.btnList.push({
                            entryId:item.T4_EntryID,
                            name:"配送详情",
                            onclick:"window.moveToView('distraBill',"+item.T4_EntryID+")"
                        });
                        item.showDis = 0;
                    }
                }else{
                    item.showDis = 0;
                }
                // 默认显示按钮 评价 签收 追溯 若按钮超过三个 则显示更多
                
                // 2.投诉
                // 判断能否投诉
                if(item.T0_C4==0){
                    item.showTs = 1;
                    item.btnNum++;
                    if(item.btnNum>4){
                        item.btnList.push({
                            entryId:item.T4_EntryID,
                            name:"投诉",
                            onclick:"window.moveToView('matLegal','"+item.T4_EntryID+"_"+item.T0_DeliBillID+"')"
                        });
                        item.showTs = 0;
                    }
                }else{
                    item.showTs = 0;
                }
                
                if(item.btnNum>4){
                    item.showMore = 1;
                }else{
                    item.showMore = 0;
                }
                //如果明细AID等于当前帐套ID
                if (item.T4_AID == g_sys_info.aid) { 
                    //订单积分
                    item.POINT = item.T0_POINT || "0"; 
                } else {
                    item.POINT = "0";
                }
                item.COIN = item.T0_COIN || "0"; //订单代金券
                item.type = index > 0 && this.getAID(item.T4_AID) == this.getAID(data.data.items[index - 1].T4_AID) ? 0 : 1; //判断是否某一货主的第一个订单
                
                
                //求出各个货主的商品总额
                var appid = this.getAID(item.T4_AID);
                //商品不是运费时
                if (item.T4_MID.T0_MID != 29999) { 
                    if (index > 0 && this.getAID(item.T4_AID) == this.getAID(data.data.items[index - 1].T4_AID)) { //如果是第二行且与上一行的AID一致
                        array.forEach(appMats, function(appMats) {
                            if (appMats.appMatAid == this.getAID(item.T4_AID)) {
                                appMats.appMatAmnt = parseFloat(appMats.appMatAmnt) + parseFloat(item.T4_DeliAmount);
                                appMats.appMatQty = parseFloat(appMats.appMatQty) + parseFloat(item.T4_AppliedQty);
                            }
                        }, this);
                    } else {
                        appMats.push({
                            appMatAid: appid, //货主
                            appMatAmnt: item.T4_DeliAmount, //货主金额
                            appMatQty: item.T4_AppliedQty, //货主商品数量
                            appMatPost: 0 // 邮费
                        });
                    }
                } 
                //商品是运费。累加货主金额，不累加商品数量
                else { 
                    if (appMats) {
                        array.forEach(appMats, function(appMats) {
                            if (this.getAID(item.T4_AID) == appMats.appMatAid) {
                                appMats.appMatAmnt = parseFloat(appMats.appMatAmnt) + parseFloat(item.T4_DeliAmount);
                                appMats.appMatPost = parseFloat(appMats.appMatPost) + parseFloat(item.T4_DeliAmount);
                            }
                        }, this);
                    } else {
                        appMats.push({
                            appMatAid: appid,
                            appMatAmnt: item.T4_DeliAmount,
                            appMatQty: 0,
                            appMatPost: item.T4_DeliAmount
                        });
                    }
                }
                array.forEach(data.data.items, function(item) {
                    array.forEach(appMats, function(appMats) {
                        if (this.getAID(item.T4_AID) == appMats.appMatAid) {
                            item.appMatAmnt = appMats.appMatAmnt;
                            item.appMatQty = appMats.appMatQty;
                            item.appMatPost = appMats.appMatPost;
                        }
                    }, this);
                }, this);
                
                //订单处理状态
                if(this.isTongYan=="1"){   //童颜
                     if(item.T4_IS_CANCEL==0){
                        if(item.T4_MID.T0_SERVICE_TYPE==0||item.T4_MID.T0_SERVICE_TYPE==""){   //普通商品
                            if(item.T4_IS_EVA==1){
                                item.MSG="已完成";
                            }
                            else if(item.T4_IS_SIGN==1){
                                item.MSG="待评价";
                            }
                            else if(item.T4_IS_APR == 1){
                                 item.MSG="待收货";
                            }
                            else if(item.T4_State == 1||item.T0_C4 == 0){
                                 item.MSG="待发货";
                            }
                            else{
                                item.MSG="未付款";
                            }
                        }
                        else{   //服务商品
                            if(item.T4_IS_EVA==1&&item.T4_DeliveryQty==item.T4_D_TIMES&&item.T0_C4==0)//已评价、可预约==总预约、已支付
                            {
                                item.MSG="已完成";
                            }
                             else if(item.T4_IS_EVA==0&&item.T4_DeliveryQty==item.T4_D_TIMES&&item.T0_C4==0) //可预约==总预约、未评价、已支付
                            {
                                item.MSG="待评价";
                            }
                            else if(item.T4_DeliveryQty<item.T4_D_TIMES&&item.T0_C4==0){ //可预约<总预约、已支付
                                item.MSG="待预约";
                            }
                            else
                            {
                                item.MSG="未付款";
                            }
                        }
                    }
                    else{
                        item.MSG="已取消";
                    }
                }
                else{   //农企宝
                    if (item.T4_IS_CANCEL == 1) {
                        item.MSG = "已取消，取消时间：" + item.T4_CanrDate;
                        item.MSG1 = "已取消";
                    } else {
                        if (item.T4_IS_APR == 1) {
                            if(item.T4_IS_SIGN == 1){
                                //应该是订单的计划发货日期才是准确的
                                item.MSG1 = "已签收"; 
                            }else{
                                //应该是订单的计划发货日期才是准确的
                                item.MSG = "已安排发货，发货时间：" + item.T4_DDate; 
                                //应该是订单的计划发货日期才是准确的
                                item.MSG1 = "已安排发货"; 
                            }
                            
                        } else {
                            if (item.T4_State == 1) {
                                item.MSG = "已审核，审核时间：" + item.T4_VerifyDate;
                                item.MSG1 = "已审核";
                            } else {
                                if (item.T0_C4 == 0) {
                                    item.MSG = "未处理";
                                    item.MSG1 = "未处理";
                                } else {
                                    item.MSG = "未付款";
                                    item.MSG1 = "未付款";
                                }
                            }
                        }
                    }
                }
            }, this);
            if (items.length) {
                this.billAid = this.getAID(items[0].T4_AID);
            } else {
                this.billAid = "";
            }
            items[0].points = this.points;
            
            this.loadOrderDtl();
        },
        loadOrderDtl:function(){
            window.loadData({
                modalName: "XSY_TSDSG_DELIVERYBILL",
                filter: "04",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    DeliBillID:window.did
                }
            }).then(lang.hitch(this,function(data){
                var oData = {};
                oData.data = {};
                oData.data.items = data;
                this.getOrderState(oData, false).then(lang.hitch(this,function(){
                    //isCancel：是否取消 true ：取消，false：未取消
                    //isPay:是否支付 true:已经支付 ，false:未支付
                    //isPayEar：是否支付定金 true：已经支付，false：未支付
                    //canPay:是否预售订单 true:是 ，false：否
                   // if(!(this.isCancel || this.isPay || (this.isPayEar && !this.canPay)||this.totalPrice>-userInfo.getUserInfo().arAmnt)){
                    if(!this.isCancel&&((!this.isPay)||(!this.isPayEar&&this.canPay))){
                        xhr("POST", {
                            url: "/w/order/refreshOrderPoint/" + window.code,
                            handleAs: "json",
                            content:{
                               // bid:item.DeliBillID,
                                bid:window.did,
                                type:this.isPreOrder&&!this.isPayEar?"earest":""
                            },
                            load: lang.hitch(this, function(result) {
                                if (1 === result.rtnType) {
                                    
                                    this.tradeHeadList.refreshList();
                                } else {
                                    alert(result.message  || "数据错误!");
                                }
                            })
                        });
                    } else {
                        this.tradeHeadList.onDataReady(oData);
                    }
                }));
            }));
        },
        getOrderState:function(data, isRefresh){
            var def = new Deferred();
            // 设置支付按钮不显示
            domStyle.set(this.toPayHElement, "display", "none"); 
            //如果有数据
            if (data.data.items.length) {
                var item = data.data.items[0];
                item.OR_POINT = parseFloat(this.or_point,3);
                item.cash = window.fixedTo(parseFloat(item.TotalPrice)-item.OR_POINT,3);
                
                item.RETA = parseFloat(item.TotalPrice);
                item.STATUS = 0;
                var beg = item.HDID.FINAL_PAY_SDATE;//支付尾款开始时间
                var end = item.HDID.FINAL_PAY_EDATE;//支付尾款结束时间
                var curr = g_s.getDateTime();//当前时间
                //未到支付时间:还没到支付时间 items.STATUS = 0;
                //未支付：到了支付时间，但是还没有支付 items.STATUS = 1;
                //已完成: 已经支付(不用判断时间) items.STATUS = 2;
                //已取消: 过了支付时间,但是还没有支付 items.STATUS = 3;
                //如果支付开始时间小于今天并且支付结束时间大于今天
                if(g_s.dateDiff('s',curr,beg) <=0 && g_s.dateDiff('s',curr,end)>=0){
                    if(item.C4==0){
                    item.STATUS=2; 
                    }else{
                        item.STATUS=1;
                    }
                }
                //如果还没到支付时间
                else if(g_s.dateDiff('s',curr,beg) >0){
                    item.STATUS=0; 
                }else{
                     item.STATUS=3; 
                }
                this.billCode = item.DeliBillCode;
                this.totalPrice = item.TotalPrice;
                this.point = item.POINT || 0;
                this.coin = item.COIN || 0;
                this.earnest = item.Earnest || 0;
                this.epoint = item.EPOINT || 0;
                this.ecoin = item.ECOIN || 0;
                this.couponAmt = item.COUPONAMT || 0;
                //订单邮费
                item.YF = this.ttlPostage; 
                
                if (0 != item.C4) { //如果未付款
                    this.isPay = false;
                }
                if (1 != item.IS_CANCEL) { //如果未取消
                    this.isCancel = false;
                } else {
                    this.isCancel = true;
                }
                if(item.PACBUY_TEAMID.T0_DID){   //标识是否是拼团订单
                    this.pacbuyID=item.PACBUY_TEAMID.T0_DID;
                    this.pacbuyTYPE=item.PACBUY_TEAMID.T1_PTYPE;
                }
                else{
                    this.pacbuyID="";
                    this.pacbuyTYPE='';
                }
                this.isPreOrder = item.IS_PRESALE == 1 ? true : false;
                this.isPayEar = this.isPreOrder == 1 ? (item.IS_PAYEAR == 1 ? true : false) : false;
                //如果有活动ID
                window.loadData({
                    modalName: "XSY_TCRMK_MAT_ADSALE",
                    filter: "02",
                    pageSize: "1",
                    pageIndex: "1",
                    param: {
                        "DID": (item.HDID.DID ? item.HDID.DID : item.HDID.DID)||""
                    }
                }).then(lang.hitch(this, function(hdData) {
                    if (hdData.length) {
                        this.canPay = true;
                    } else {
                        this.canPay = false;
                    }
                    if (this.needPay && (!(this.isCancel || this.isPay || (this.isPayEar && !this.canPay)))) {
                        alert("请再次点击微信支付以完成本次支付");
                    }
                    if(!this.isCancel || this.isPay || (this.isPayEar && !this.canPay)){
                        if(isRefresh){
                            this.updateFooter(); //更新底部的显示    
                        }
                    }
                    def.resolve();
                }));
            } else {
                this.billCode = "";
                this.totalPrice = "";
                def.resolve();
            }
            return def;
        },
        // 自己取数据
        loadOrderDtls:function(){
            window.loadData({
                modalName:"XSY_VSDSG_DELIVERYBILL2",
                filter:"01",
                param:{DeliBillID:window.did},
                orderBy:"[T4_AID],[T4_MID.T0_MID] DESC",
                pageIndex:1,
                pageSize:1
            }).then(lang.hitch(this,function(orderData){
                var billIds = [];
                var items = orderData;
                array.forEach(items,function(item){
                    billIds.push(item.T4_EntryID);
                });
                // 查找订单的配送记录
                window.loadData({
                    modalName:"XSY_TSDSG_DISTRABILLDTS",
                    where:"[SourceBillID] IN ("+billIds.join(",")+") OR [S_ENTRYID] IN ("+billIds.join(",")+")",
                    pageSize:1,
                    pageIndex:1
                }).then(lang.hitch(this,function(billData){
                    var billHash = {};
                    array.forEach(billData,function(i){
                        billHash[i.S_ENTRYID?i.S_ENTRYID:i.SourceBillID] = {
                            billId:i.BillID,
                            logCode:i.WAYBLLL_NO,
                            logProvider:i["LOG_PROVIDER.NameDes"]
                        };
                    });
                    array.forEach(items,function(i){
                        i.dd = billHash&&billHash[i.T4_EntryID]&&billHash[i.T4_EntryID].billId||"";
                        i.logCode = billHash&&billHash[i.T4_EntryID]&&billHash[i.T4_EntryID].logCode||"";
                        i.logProvider = billHash&&billHash[i.T4_EntryID]&&billHash[i.T4_EntryID].logProvider||"";
                        i.canDd = i.dd?1:0;
                    });
                    var o = {};
                    o.data = {};
                    o.data.items = orderData;
                    this.tradeDetailList.onDataReady(o);
                }));
            }));
        },
        refreshAllList: function() {
            this.isPay = true;
            this.isCancel = true;
            this.isPayEar = true;
            if (window.titleNode) {
                window.titleNode.innerHTML = "消费明细";
            }
            var params = window.did.split("_");
            window.did = this.did = params[0];
            this.needPay = params.length > 1;
            userInfo.hasLogin().then(lang.hitch(this, function(s) {
                if (s) {
                    // 如果是我自己准备数据 则将准备好的数据给list2
                    // 否则 直接调用list的刷新方法
                    if(this.getDtlByMyShelf){
                        // 获取订单明细数据
                        this.loadOrderDtls();
                    }
                    else{
                        this.tradeDetailList.refreshList(); //刷新订单明细
                    }
                } else {
                    window.nextPageOnLogin = "orderDetail-" + window.did;
                    userInfo.showLogin();
                }
            }));
        },
        getAID: function(item) {
            return item && item.toString();
        },
        // 修改订单暂停/恢复状态
        _changeOrState:function(entryId){
            window.busy();
            xhr("POST", {
                url: "/w/order/switchTran/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token + "&entryId=" + entryId,
                handleAs: "json",
                load: lang.hitch(this, function(result) {
                    window.free();
                    if (1 === result.rtnType) {
                        if(this.getDtlByMyShelf){
                            // 获取订单明细数据
                            this.loadOrderDtls();
                        }
                        else{
                            this.tradeDetailList.refreshList(); //刷新订单明细
                        }
                    } else {
                        alert(result.message || "数据错误!");
                    }
                })
            });
        },
        //暂停配送
        pauseOrderFun: function(entryId) {
            this._changeOrState(entryId);
        },
        //恢复配送
        recoveryOrderFun: function(entryId) {
            this._changeOrState(entryId);
        },
        // 取消订单
        cancelOrderFun: function(did) {
            window.busy();
            xhr("POST", {
                url: "/w/order/cancelOrder/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token + "&did=" + did,
                handleAs: "json",
                load: lang.hitch(this, function(result) {
                    window.free();
                    if (1 === result.rtnType) {
                        if(this.getDtlByMyShelf){
                            // 获取订单明细数据
                            this.loadOrderDtls();
                        }
                        //刷新订单明细
                        else{
                            this.tradeDetailList.refreshList(); 
                        }
                    } else {
                        alert(result.message || "数据错误!");
                    }
                })
            });
        },
        // 签收订单
        sign:function(entryId){
            //童颜
            if(this.isTongYan=="1"){  
                if(!confirm("确认收到货品？")){
                    window.free();
                    return false;
                }
                // 如果有订单明细ID
                else if(entryId){
                    this._sign(entryId);
                }
            }
            //农企宝
            else{
                this._sign(entryId);
            }
        },
        // 签收
        _sign:function(entryId){
            window.busy();
            xhr("post",{
                url:"/w/order/orderSign/"+window.code+ "-" + window.openId + "?token=" + window.userInfo.token + "&EntryID=" + entryId,
                handleAs: "json",
                content: {
                    EntryID:entryId
                },
                load:lang.hitch(this,function(results){
                    window.free();
                    if(results.rtnType === 1){
                        if(this.getDtlByMyShelf){
                            // 获取订单明细数据
                            this.loadOrderDtls();
                        }
                        else{
                            this.tradeDetailList.refreshList(); //刷新订单明细
                        }
                    }else{
                       alert(results.message || "数据错误!");
                    }
                })
            });
        },
        tradeDetailClick: function(e) {
            if (e.target) {
                var c = domAttr.get(e.target, "class");
                if (-1 < c.indexOf("pauseOrder")) {
                    this.pauseOrderFun(c.split("_")[1], 1);
                } else if (-1 < c.indexOf("recoveryOrder")) {
                    this.recoveryOrderFun(c.split("_")[1], - 1);
                } else if (-1 < c.indexOf("cancelOrder")) {
                    this.cancelOrderFun(c.split("_")[1], - 1);
                } else if(-1<c.indexOf("sign")) {
                    this.sign(c.split("_")[1],-1);
                }
            }
        },
        initPayButton: function() {
            this.toPayElement.innerHTML = "";
            this.pointPayBtn = domConstruct.create("a", {
                "class": "payButton",
                onclick: lang.hitch(this, function() {
                    this.toPay("alipaywap");
                }),
                "style": "width:50%;display:none;",
                innerHTML: "积分支付",
                "href": "javascript:void(0);"
            }, this.toPayElement, "last");
            this.alipayBtn = domConstruct.create("a", {
                "class": "payButton",
                onclick: lang.hitch(this, function() {
                    this.toPay("alipaywap");
                }),
                "style": "width:100%;",
                innerHTML: "支付",
                "href": "javascript:void(0);"
            }, this.toPayElement, "last");
        },
        // 显示隐藏底部按钮
        updateFooter: function() {
            if (this.isCancel || this.isPay || (this.isPayEar && !this.canPay)) { // 作废或者已经支付
                domStyle.set(this.toPayHElement,"display","none");
                //this.toPayHElement.style.display = "none";
            } else {
                domStyle.set(this.toPayHElement,"display","");
                //this.toPayHElement.style.display = "";
                //this.initPayTypeElemet();
                var pointDisplay = ((this.isPreOrder&&!this.isPayEar) ? this.earnest - this.epoint - this.ecoin : this.totalPrice - this.coin - this.point) ? "none" : "",
                onlineDisplay = pointDisplay ? "" : "none";
                domStyle.set(this.pointPayBtn, "display", pointDisplay); 
                domStyle.set(this.aliPayBtn, "display", onlineDisplay);
                domStyle.set(this.weixinPayBtn, "display", onlineDisplay);
            }
        },
        // 支付
        toPay: function(payType) {
            window.busy();
            return require([
                "widgets/orderPayHandler"
                ], lang.hitch(this, function(orderPayHandler) {
                    var url="";
                    if(this.pacbuyID){
                        if(this.pacbuyTYPE==='2'){
                            url=g_sys_info.url+"/home/index/"+g_sys_info.code+"#pacDetailNew-"+this.pacbuyID;
                        }
                        else{
                            url=g_sys_info.url+"/home/index/"+g_sys_info.code+"#pacDetail-"+this.pacbuyID;
                        }
                    }
                    else if(this.isWbOrder){
                        url=g_sys_info.url+"/home/index/"+g_sys_info.code+"#wbList";
                    }
                //orderPayHandler.pay({
                //    billCode:this.billCode,payType:"alipaywap"||"point"
                //},lang.hitch(this,this.initData));
                //赵春辉    支持微信支付，弃用支付宝手机网页支付    2015-02-04
                if(url!=""){
                    orderPayHandler[this.isPreOrder && false === this.isPayEar ? "payEarnest" : "pay"]({
                        billCode: this.billCode,
                        payType: payType,
                        isPreOrder: this.isPreOrder && false === this.isPayEar,
                        returnUrl:url
                    }, lang.hitch(this,function(data){
                            window.loadData({
                            modalName: "XSY_TSDSG_DELIVERYBILL",
                            filter: "04",
                            pageSize: "1",
                            pageIndex: "1",
                            param: {
                                DeliBillID:window.did
                            }
                            }).then(lang.hitch(this,function(data){
                                if(data[0].C4==0){
                                    if(this.pacbuyID){
                                        if(this.pacbuyTYPE==='2'){
                                            window.moveToView("pacDetailNew",this.pacbuyID);
                                        }
                                        else{
                                            window.moveToView("pacDetail",this.pacbuyID);
                                        }
                                    }
                                    else if(this.isWbOrder){
                                        window.moveToView("wbList","");
                                    }
                                    else{
                                        this.refreshAllList();
                                    }
                                }
                                else{
                                    this.refreshAllList();
                                }
                            }));
                    }));
                }
                else{
                    orderPayHandler[this.isPreOrder && false === this.isPayEar ? "payEarnest" : "pay"]({
                        billCode: this.billCode,
                        payType: payType,
                        isPreOrder: this.isPreOrder && false === this.isPayEar
                    }, lang.hitch(this,function(data){
                        window.loadData({
                            modalName: "XSY_TSDSG_DELIVERYBILL",
                            filter: "04",
                            pageSize: "1",
                            pageIndex: "1",
                            param: {
                                DeliBillID:window.did
                            }
                            }).then(lang.hitch(this,function(data){
                                this.refreshAllList();
                            }));
                    }));
                }
            }));
        }
    });
});