define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/query",
    "dojo/_base/lang",
    "../userInfo",
    "dojo/dom-style",
    "dojo/_base/xhr",
    "dojo/_base/array",
    "dojo/dom-construct",
    "widgets/orderPayHandler",
    "dojo/dom-attr",
    "dojo/Deferred",
    "dijit/_WidgetBase",
    "dojo/dom-class",
    "widgets/orderPayHandler"], function(declare, registry, query, lang, userInfo, domStyle, xhr, array, domConstruct, orderPayHandler, domAttr, Deferred,_WidgetBase,domClass,orderPayHandler) {
    return declare("widgets.common._OrderDetailMixin", null, {
        billCode: "",
        totalPrice: "",
        isTest: false,
        isPay: false, //是否支付
        isCancel: false, //是否作废
        isPayEar: false,
        isPreOrder: false,
        canPay: false,
        isOrderDetailLoaded: function() {
            return !!this.tradeDetailList;
        },
        indexOrderDetailElement: function() {
            if (!this.isOrderDetailLoaded()) {
                this.pointPayBtn = query("#pointpay",this.domNode)[0]; //积分支付
                this.aliPayBtn = query("#alipay",this.domNode)[0]; //支付宝支付
                this.weixinPayBtn = query("#weixinpay",this.domNode)[0]; //微信支付
                this.tradeHeadList = registry.byId("tradeHead");
                this.tradeDetailList = registry.byId("tradeDetail");
                this.toPayHElement = query(".orderfooter",this.domNode)[0]; //底部
                this.shelfFooter=query(".shelfFooter",this.domNode)[0];
                
                this.lastWb= registry.byId("lastWb");       //最近预约
            }
        },
        initOrderDetailEvent: function() {
            this.connect(this.pointPayBtn, "click", function() {
                this.toPay("point");
            });
            this.connect(this.aliPayBtn, "click", function() {
                this.toPay("alipaywap");
            });
            this.connect(this.weixinPayBtn, "click", function() {
                this.toPay("weixin");
            });
            this.connect(this.tradeHeadList, "onDefRendered", function(data) { //订单头部
                domStyle.set(this.toPayHElement, "display", "none"); //设置支付按钮不显示
                var item = data.data.items[0];
                if (data.data.items.length) { //如果有数据
                    this.billCode = item.DeliBillCode;
                    this.totalPrice = item.TotalPrice;
                    this.point = item.POINT || 0;
                    this.coin = item.COIN || 0;
                    this.earnest = item.Earnest || 0;
                    this.epoint = item.EPOINT || 0;
                    this.ecoin = item.ECOINT || 0;
                    item.YF = window.yFee; //订单邮费
                    item.points = window.points; //订单积分
                    if (0 != item.C4) { //如果未付款
                        this.isPay = false;
                    }
                    if (1 != item.IS_CANCEL) { //如果未取消
                        this.isCancel = false;
                    } else {
                        this.isCancel = true;
                    }
                    if(item.WB_ORDER==1){
                        this.lastWb.refreshList();
                        domStyle.set(query("#lastWb",this.domNode)[0],{display:"block"});
                    }
                    else{
                        domStyle.set(query("#lastWb",this.domNode)[0],{display:"none"});
                    }
                    this.isPreOrder = item.IS_PRESALE == 1 ? true : false;
                    this.isPayEar = this.isPreOrder == 1 ? (item.IS_PAYEAR == 1 ? true : false) : false;
                    //如果有活动ID
                   /* window.loadData({
                        modalName: "XSY_TCRMK_MAT_ADSALE",
                        filter: "02",
                        pageSize: "1",
                        pageIndex: "1",
                        param: {
                            "DID": item.HDID.DID ? item.HDID.DID : ""item.HDID""""
                        }
                    }).then(lang.hitch(this, function(hdData) {
                        if (hdData.length) {
                            this.canPay = true;
                        } else {
                            this.canPay = false;
                        }
                        this.updateFooter(); //更新底部的显示
                        if(this.needPay&&(!(this.isCancel || this.isPay || (this.isPayEar && !this.canPay)))){
                            alert("请再次点击微信支付以完成本次支付");
                        }
                    }));*/
                    this.updateFooter(); 
                } else {
                    this.billCode = "";
                    this.totalPrice = "";
                }
            });
            
            this.connect(this.lastWb,"onDefRendered",function(data){
                if(data.data.items.length>0){
                    
                }
                else{
                    
                }
            });
            
            var appMats = []; //存各个货主的总金额以及邮费、包含的商品数
            this.connect(this.tradeDetailList, "onDefRendered", function(data) {
                window.points = 0; //计算本张订单所获得积分
                window.yFee = 0; //计算本张订单的邮费
                array.forEach(data.data.items, function(item, index) { //循环订单明细
                    item.T4_D_TIMES=parseInt(item.T4_D_TIMES);
                    item.T4_DeliveryQty=parseInt(item.T4_DeliveryQty);
                    //判断订单是够允许评论,已支付、已审核、已发货、未取消
                    if (item.T0_C4==0&&item.T4_State == 1&&(item.T4_IS_SIGN==1 ||(item.T4_MID.T0_SERVICE_TYPE==1 && item.T4_DeliveryQty==item.T4_D_TIMES)) && item.T4_IS_CANCEL == 0 && (item.T4_IS_EVA == 0 || item.T4_IS_EVA == "")) {
                        item.canSubEva = 1;
                    } else {
                        item.canSubEva = 0;
                    }
                    //判断是否加载签收按钮(已发货没签收)
                    item.IS_SIGN=0;
                     if(item.T0_C4 == 0 && (item.T4_MID.T0_SERVICE_TYPE==0 ||item.T4_MID.T0_SERVICE_TYPE=="")&& item.T4_State == 1 && item.T4_IS_APR == 1 && item.T4_IS_CANCEL == 0 && item.T4_IS_SIGN==0)
                     {
                        item.IS_SIGN=1;
                     }
                     //是否加载预约按钮
                     item.SERVICE_TYPE=0;
                     if(item.T4_IS_CANCEL == 0 && item.T0_C4 == 0 && (item.T4_MID.T0_SERVICE_TYPE ==1 || item.T4_MID.T0_SERVICE_TYPE==2) && item.T4_DeliveryQty < item.T4_D_TIMES&&item.T4_State == 1)
                     {
                         item.SERVICE_TYPE=1;
                     }
                     
                   /* if(item.T0_C4 == 0&& item.T4_State == 1 && item.T4_IS_APR == 1 && item.T4_IS_CANCEL == 0)*/
                   
                    //判断是够暂停配送
                    if (item.T0_C4 == 0 && item.T4_State == 1 && item.T4_IS_CANCEL == 0 && (item.T4_D_TIMES - item.T4_DeliveryQty) > 0) {
                        item.showA = 1;
                    } else {
                        item.showA = 0;
                    }
                    window.points += parseFloat(item.T4_Deposit || 0); //运费
                    if (item.T4_AID == g_sys_info.aid) { //如果明细AID等于当前帐套ID
                        item.POINT = item.T0_POINT || "0"; //订单积分
                    } else {
                        item.POINT = "0";
                    }
                    item.COIN = item.T0_COIN || "0"; //订单代金券
                    item.type = index > 0 && this.getAID(item.T4_AID) == this.getAID(data.data.items[index - 1].T4_AID) ? 0 : 1; //判断是否某一货主的第一个订单
                    //求出各个货主的商品总额
                    var appid = this.getAID(item.T4_AID);
                    if (item.T4_MID.T0_MID != 29999) { //商品不是运费时
                        if (index > 0 && this.getAID(item.T4_AID) == this.getAID(data.data.items[index - 1].T4_AID)) { //如果是第二行且与上一行的AID一致
                            array.forEach(appMats, function(appMats) {
                                if (appMats.appMatAid == this.getAID(item.T4_AID)) {
                                    appMats.appMatAmnt = parseFloat(appMats.appMatAmnt) + parseFloat(item.T4_DeliAmount);
                                    appMats.appMatQty = parseFloat(appMats.appMatQty) + parseFloat(item.T4_AppliedQty);
                                }
                            }, this);
                        } else {
                            appMats.push({
                                appMatAid: appid, //货主
                                appMatAmnt: item.T4_DeliAmount, //货主金额
                                appMatQty: item.T4_AppliedQty, //货主商品数量
                                appMatPost: 0 // 邮费
                            });
                        }
                    } else { //商品是运费。累加货主金额，不累加商品数量
                        if (appMats) {
                            array.forEach(appMats, function(appMats) {
                                if (this.getAID(item.T4_AID) == appMats.appMatAid) {
                                    appMats.appMatAmnt = parseFloat(appMats.appMatAmnt) + parseFloat(item.T4_DeliAmount);
                                    appMats.appMatPost = parseFloat(appMats.appMatPost) + parseFloat(item.T4_DeliAmount);
                                }
                            }, this);
                        } else {
                            appMats.push({
                                appMatAid: appid,
                                appMatAmnt: item.T4_DeliAmount,
                                appMatQty: 0,
                                appMatPost: item.T4_DeliAmount
                            });
                        }
                    }
                    array.forEach(data.data.items, function(item) {
                        array.forEach(appMats, function(appMats) {
                            if (this.getAID(item.T4_AID) == appMats.appMatAid) {
                                item.appMatAmnt = appMats.appMatAmnt;
                                item.appMatQty = appMats.appMatQty;
                                item.appMatPost = appMats.appMatPost;
                            }
                        }, this);
                    }, this);
                    if (item.T4_MID.T0_MID == 29999) { //总运费
                        window.yFee += parseFloat(item.T4_DeliAmount || 0);
                    }
                    //订单处理状态
                     //订单明细显示状态
                    if(item.T4_IS_CANCEL==0){
                        if(item.T4_MID.T0_SERVICE_TYPE==0||item.T4_MID.T0_SERVICE_TYPE==""){   //普通商品
                            if(item.T4_IS_EVA==1){
                                item.MSG="已完成";
                            }
                            else if(item.T4_IS_SIGN==1){
                                item.MSG="待评价";
                            }
                            else if(item.T4_IS_APR == 1){
                                 item.MSG="待收货";
                            }
                            else if(item.T4_State == 1||item.T0_C4 == 0){
                                 item.MSG="待发货";
                            }
                            else{
                                item.MSG="未付款";
                            }
                        }
                        else{   //服务商品
                            if(item.T4_IS_EVA==1&&item.T4_DeliveryQty==item.T4_D_TIMES&&item.T0_C4==0)//已评价、可预约==总预约、已支付
                            {
                                item.MSG="已完成";
                            }
                             else if(item.T4_IS_EVA==0&&item.T4_DeliveryQty==item.T4_D_TIMES&&item.T0_C4==0) //可预约==总预约、未评价、已支付
                            {
                                item.MSG="待评价";
                            }
                            else if(item.T4_DeliveryQty<item.T4_D_TIMES&&item.T0_C4==0){ //可预约<总预约、已支付
                                item.MSG="待预约";
                            }
                            else
                            {
                                item.MSG="未付款";
                            }
                        }
                    }
                    else{
                        item.MSG="已取消"
                    }
                }, this);
                if (data.data.items.length) {
                    this.billAid = this.getAID(data.data.items[0].T4_AID);
                } else {
                    this.billAid = "";
                }
                this.tradeHeadList.refreshList();
                
            });
            this.subscribe("widgets/show/view", function(id) {
                if (id === this.id) {
                    this.updateFooter();
                }
            });
            this.connect(this.tradeDetailList.domNode, "onclick", this.tradeDetailClick);
            
        },
        refreshAllList: function() {
            this.isPay = true;
            this.isCancel = true;
            this.isPayEar = true;
            if (window.titleNode) {
                window.titleNode.innerHTML = "消费明细";
            }
            var params = window.did.split("_");
            window.did = this.did = params[0];
            this.needPay = params.length > 1;
            userInfo.hasLogin().then(lang.hitch(this, function(s) {
                if (s) {
                    this.loadDataFuc();
                    this.tradeDetailList.refreshList(); //刷新订单明细
                    
                } else {
                    window.nextPageOnLogin = "orderDetail-" + window.did;
                    userInfo.showLogin();
                }
            }));
            this.shelfFooter=query(".shelfFooter",this.domNode)[0];
            this.shelfFooter.id="shelfFooter_1";
        },
        getAID: function(item) {
            return item && item.toString();
        },
        loadDataFuc: function() {
            var def = new Deferred();
            window.loadData({
                modalName: "XSY_TCRMK_MAT_ADSALE",
                filter: "01",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "MID": window.did
                }
            });
        },
        pauseOrderFun: function(entryId) {
            //暂停配送
            window.busy();
            xhr("POST", {
                url: "/w/order/switchTran/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token + "&entryId=" + entryId,
                handleAs: "json",
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        this.tradeDetailList.refreshList();
                        window.free();
                    } else {
                        alert(result.message || "数据错误!");
                        window.free();
                    }
                })
            });
        },
        recoveryOrderFun: function(entryId) {
            //恢复配送
            window.busy();
            xhr("POST", {
                url: "/w/order/switchTran/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token + "&entryId=" + entryId,
                handleAs: "json",
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        this.tradeDetailList.refreshList();
                        window.free();
                    } else {
                        alert(result.message || "数据错误!");
                        window.free();
                    }
                })
            });
        },
        cancelOrderFun: function(did) {
            window.busy();
            xhr("POST", {
                url: "/w/order/cancelOrder/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token + "&did=" + did,
                handleAs: "json",
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        this.tradeDetailList.refreshList();
                        window.free();
                    } else {
                        alert(result.message || "数据错误!");
                        window.free();
                    }
                })
            });
        },
        tradeDetailClick: function(e) {
            if (e.target) {
                var c = domAttr.get(e.target, "class");
                if (-1 < c.indexOf("pauseOrder")) {
                    this.pauseOrderFun(c.split("_")[1], 1);
                } else if (-1 < c.indexOf("recoveryOrder")) {
                    this.recoveryOrderFun(c.split("_")[1], - 1);
                } else if (-1 < c.indexOf("cancelOrder")) {
                    this.cancelOrderFun(c.split("_")[1], - 1);
                }
                //签收货品
                if(domClass.contains(e.target, "SIGN"))
                {
                    if(!confirm("确认收到货品？")){
                        window.free();
                        return false;
                    }
                    else
                    {
                        var entryId= domAttr.get(e.target, "entryId");
                       if(entryId){
                            xhr("POST",{
                                url:"/w/exec/exec/"+window.code+"?token=" + window.userInfo.token,
                                content: {
                                        tp:"order_sign",
                                        entryId:entryId
                                    },
                                handleAs: "json",
                                load:lang.hitch(this, function(result) {
                                    if (1 === result.rtnType) {
                                       this.refreshAllList();
                                    } else {
                                       alert("数据异常！签收失败")
                                    }
                                 })
                            });
                       }
                    }
                }
            }
        },
        initPayButton: function() {
            this.toPayElement.innerHTML = "";
            this.pointPayBtn = domConstruct.create("a", {
                "class": "payButton",
                onclick: lang.hitch(this, function() {
                    this.toPay("alipaywap");
                }),
                "style": "width:50%;display:none;",
                innerHTML: "积分支付",
                "href": "javascript:void(0);"
            }, this.toPayElement, "last");
            this.alipayBtn = domConstruct.create("a", {
                "class": "payButton",
                onclick: lang.hitch(this, function() {
                    this.toPay("alipaywap");
                }),
                "style": "width:100%;",
                innerHTML: "支付",
                "href": "javascript:void(0);"
            }, this.toPayElement, "last");
        },
        initPayTypeElemet: function() {
            userInfo.hasLogin().then(lang.hitch(this, function() {
                //if(this.billAid==window.g_sys_info.aid&&(window.g_sys_info.isCredit||(this.totalPrice<=-userInfo.getUserInfo().arAmnt))){
                //	domStyle.set(this.pointPayBtn,"display","");
                //	domStyle.set(this.alipayBtn,{
                //		"background-color":"#6db248",
                //		"width":"50%"
                //	});
                //}else{
                domStyle.set(this.pointPayBtn, "display", "none");
                domStyle.set(this.alipayBtn, {
                    "background-color": "",
                    "width": "100%"
                });
                //}
            }));
        },
        updateFooter: function() {
            if (this.isCancel || this.isPay || (this.isPayEar && !this.canPay)) { // 作废或者已经支付
             this.toPayHElement.style.display = "none";
             
              //创建继续购物按钮
            var divid=query("#mydivid",this.domNode)[0];
             if(!divid){
                var mydiv=document.createElement("a");
        　       mydiv.id　=　"mydivid";
        　       this.shelfFooter.appendChild(mydiv);
                mydiv.innerHTML="继续购物";
               this.connect(mydiv,"onclick", this.toshop);
             }
                
                //显示预约按钮
              var toOder=query(".toOder",this.domNode);
                for(var i=0;i<toOder.length;i++){
                        domStyle.set(toOder[i], "display", "");
                    }
            } else {
                //删除预约按钮
                var toOder=query(".toOder",this.domNode);
                for(var i=0;i<toOder.length;i++){
                        domStyle.set(toOder[i], "display", "");
                    }
                 //删除购买按钮
                 var divid=query("#mydivid",this.domNode)[0];
                 if(divid){
        　            this.shelfFooter.removeChild(divid);
                }
                 
                this.toPayHElement.style.display = "";
                //this.initPayTypeElemet();
                var pointDisplay = (this.isPreOrder ? this.earnest - this.epoint - this.ecoin : this.totalPrice - this.coin - this.point) ? "none" : "",
                    onlineDisplay = pointDisplay ? "" : "none";
                // 判断是否显示微信支付
                var validPayType = orderPayHandler.getValidPayType(g_sys_info.aid,this.isPreOrder?this.earnest:this.totalPrice);
                var weixinDisplay = "none";
                if(onlineDisplay === ""){
                    for(var j = 0;j < validPayType.length;j++){
                        if(validPayType[j].type === "weixin"){
                            weixinDisplay = "";
                        }
                    }
                }
                domStyle.set(this.pointPayBtn, "display", pointDisplay);
                domStyle.set(this.aliPayBtn, "display", onlineDisplay);
                domStyle.set(this.weixinPayBtn, "display", weixinDisplay);
                domStyle.set(this.aliPayBtn,"margin-left",(weixinDisplay === "none")?"71%":"45%");
            }
        },
        toshop: function(){
            window.moveToView("main");
        },
        toPay: function(payType) {
            window.busy();
            return require([
                "widgets/orderPayHandler"
                ], lang.hitch(this, function(orderPayHandler) {
                //orderPayHandler.pay({
                //    billCode:this.billCode,payType:"alipaywap"||"point"
                //},lang.hitch(this,this.initData));
                //赵春辉    支持微信支付，弃用支付宝手机网页支付    2015-02-04
                orderPayHandler[this.isPreOrder&&false===this.isPayEar ? "payEarnest" : "pay"]({
                    billCode: this.billCode,
                    payType: payType,
                    isPreOrder: this.isPreOrder&&false===this.isPayEar
                }, lang.hitch(this, this.refreshAllList));
            }));
        }
    });
});