define([
    "dojo/_base/declare",
    "dojo/_base/lang", 
    "dojo/_base/array", 
    "dojo/_base/json", 
    "dojo/_base/xhr", 
    "dojo/dom-class", 
    "dojo/dom-style", 
    "dojo/dom-attr", 
    "dojo/query", 
    "dijit/registry", 
    "../orderCarRecord", 
    "../userInfo", 
    "dojo/Deferred",
    "dojo/has",
    "widgets/common/couponMixin"],function(declare,lang,array,json,xhr,domClass,domStyle,domAttr,query,registry,orderCarRecord,userInfo,Deferred,has,couponMixin){
    return declare("widgets.common._OrderInfoMixin",null,{
        isOrderInfoLoaded:function(){
            return !!this.radios;
        },
        onBeforeTransitionOut:function(){
            this.bgPane&&domClass.add(this.bgPane,"hide");
            this.inherited(arguments);
        },
        indexOrderInfoElement:function(){
            this.orderCarPost = query("#orderCarPost");
            this.orderCarPost = this.orderCarPost.length&&this.orderCarPost[0]||{};
            this.currentPrice = query(".currentPrice");
            this.currentPrice = this.currentPrice.length&&this.currentPrice[0]||{};
            this.PSmsg = registry.byId("PSmsg");
            this.transType = query("#transType");//配送方式
            this.radios = query("#radios")[0];
            this.coupon = query(".coupon",this.domNode)[0];//店铺优惠
            this.couponBgPane = query(".bgPane",this.domNode)[0];
            this.couponType = registry.byNode(query(".couponType",this.domNode)[0]);
            this.couponbgFixed = registry.byId("couponbgFixed");
            this.couponOk = query(".couponOk",this.domNode)[0];//优惠活动pane 确认按钮
            this.couponCancel = query(".couponCancel",this.domNode)[0];//优惠活动pane 取消按钮
            this.bgFixedTop = query(".bgFixedTop",this.domNode)[0];
            this.bgPane = query(".bgPane",this.domNode)[0];
        },
        radiosClick:function(e){
            var btn = e.target.nodeName;
            var domTarget = e.target || e.srcElement; //点击的节点
            if(has("touch")){  //兼容手机端checkbox无法选中问题
                //if(domTarget.checked == true){ 
                //   domTarget.checked=false;
                //}else{
                // 无论是true或者false 都要选中 2015-12-17 刘轩
                domTarget.checked=true;
                //}
            }
        },
        initOrderInfoEvent:function(){
            this.orderCarPost.onclick = lang.hitch(this, this._postOrder2);
            this.connect(this.PSmsg, "onDefRendered", function(data) {
                if (data.data.items.length == 0) {
                    data.data.items[0] = {
                        C_R: ""
                    };
                }
            });
            var node = query("#goOrderCar");
            node = node.length&&node[0]||{};
            this.connect(node,"onclick",function(){
               window.moveToView("orderCar",this.did||""); 
            });//返回购物车
            if(this.radios)
            {
                this.connect(this.radios,"onclick",this.radiosClick);
            }
            //侦听优惠券点击事件
            this.connect(this.coupon, "onclick",this.showBgPane);
            //侦听优惠活动pane 确认按钮点击事件
            this.connect(this.couponOk, "onclick",this.couponOkFuc);
            //侦听优惠活动pane 取消按钮点击事件
            this.connect(this.couponCancel, "onclick",this.couponCancelFuc);
            this.connect(this.bgFixedTop,"onclick",function(e){
                domClass.add(this.bgPane,"hide");
            });
            this.connect(this.couponType,"onDefRendered",function(data){
                var avicou = {},firstAvi = "";
                //如果有可以使用的优惠券
                if(window.availableCoupons.length)
                {
                    
                    array.forEach(window.availableCoupons,function(vcou,i){
                        avicou[vcou.DID] = 1;
                        if(i==0)
                        {
                            //将找到的第一行可用优惠券的数据 的TXT 显示在店铺优惠右侧
                            query(".couponTxt",this.domNode)[0].innerHTML = vcou["BID2.TXT"];
                            domAttr.set(query(".couponTxt",this.domNode)[0],"did",vcou["DID"]);
                            firstAvi = vcou["DID"];
                        }
                    });
                }
                else
                {
                    //如果没有可以使用的优惠券
                    query(".couponTxt",this.domNode)[0].innerHTML= "无可用优惠券";
                    domAttr.set(query(".couponTxt",this.domNode)[0],"DID","");
                }
                var items = data.data.items;
                if(items.length){
                    //移出店铺优惠的hide样式
                    domClass.remove(this.coupon,"hide");
                }
                array.forEach(items,function(item){
                    item.available = 0;
                    if(avicou&&avicou[item.DID])
                    {
                        // 可用
                        item.available = 1;
                    }
                    if(item.DID==firstAvi)
                    {
                        item.couponChecked = "couponChecked";
                    }
                    else
                    {
                        item.couponChecked = "";
                    }
                });
            });
            this.connect(this.couponType.domNode,"onclick",function(e){
                var dom = e.target;
                // 点击可用的优惠券
                if(dom&&dom.tagName=="LABEL"&&domClass.contains(dom,"available"))
                {
                    // 清除之间选中的节点的选中
                    if(query(".couponChecked",this.couponType.domNode)[0])
                    {
                        domClass.remove(query(".couponChecked",this.couponType.domNode)[0],"couponChecked");
                    }
                    domClass.add(dom,"couponChecked");
                }
            });
        },
        couponOkFuc:function(e){
            // 找到选中的那一个节点
            // 如果有选中的节点
            if(query(".couponChecked",this.couponType.domNode)[0])
            {
                // 更新优惠信息处的备注
                query(".couponTxt",this.domNode)[0].innerHTML = domAttr.get(query(".couponChecked",this.couponType.domNode)[0],"txt");
                domAttr.set(query(".couponTxt",this.domNode)[0],"did",domAttr.get(query(".couponChecked",this.couponType.domNode)[0],"did"));
            }
            domClass.add(this.couponBgPane,"hide");
        },
        couponCancelFuc:function(e){
            //点击取消按钮，隐藏pane
            domClass.add(this.couponBgPane,"hide");
        },
        showBgPane:function(e){
            // 显示选择选择优惠活动的页面
            domClass.remove(this.couponBgPane,"hide");
            // 将节点移动到body中
            document.body.appendChild(this.couponBgPane);
            this.couponbgFixed.resize();
        },
        refreshAllList:function(){
            if(window.titleNode){
                window.titleNode.innerHTML = "收货信息";
            }
            this.did = window.did;
            this.currentPrice.innerHTML = "￥" + window.fixedTo(orderCarRecord.total, 3);// 修改订单的金额
            userInfo.hasLogin().then(lang.hitch(this,function(success){
                if(success){
                    query("#to_user", this.domNode)[0].value = userInfo.getUserInfo().name; // 姓名
                    query("#to_mobile", this.domNode)[0].value = userInfo.getUserInfo().tel; // 电话
                    query("#to_location", this.domNode)[0].value = userInfo.getUserInfo().addr; // 地址
                    query("#to_remark", this.domNode)[0].value = ""; // 备注
                    window.availableCoupons = [];
                    couponMixin.getAvailableCoupons().then(lang.hitch(this,function(availableCoupons){
                        // 如果是拼团活动 则不允许使用优惠券
                        var PACBUY_TEAMID = "";
                        if(window.did.indexOf("PACBUY_TEAMID") !== -1){
                            var arr =  window.did.match(/\d+/g);
                            PACBUY_TEAMID = arr[0]; // 拼团活动ID
                        }
                        // 如果有 可用优惠券 且不是拼团活动 才能使用优惠券
                        if(availableCoupons&&(PACBUY_TEAMID==""))
                        {
                            window.availableCoupons = availableCoupons;
                        }
                        this.couponType.refreshList();//刷新优惠券
                    }));
                }else{
                    window.nextPageOnLogin = this.did?"orderInfo-"+this.did:"orderInfo";
                    // 若没有登录
                    userInfo.showLogin();
                }
            }));
        },
        _postOrder2:function(){
            window.busy();
            var name = query("#to_user", this.domNode)[0].value,
                tel = query("#to_mobile", this.domNode)[0].value,
                addr = query("#to_location", this.domNode)[0].value,
                remark = query("#to_remark",this.domNode)[0].value,
                delType = this.radios?query("input:checked",this.radios)[0].value:"2",
                couponId = domAttr.get(query(".couponTxt",this.domNode)[0],"did");
                require(["widgets/common/orderHandler"],lang.hitch(this,function(orderHandler){
                    orderHandler.postOrder(name,tel,addr,remark,null,delType,null,couponId).then(lang.hitch(this,function(result){
                        if (1 === result.rtnType) {
                            if(!this.did){
                                orderCarRecord.setOrderCar({});
                                orderCarRecord.carChanged = true;
                            }
                            window.moveToView("orderDetail",result.data);
                            if(result.timeout){
                                alert("请在"+result.timeout+"内完成支付，否则订单会自动取消。");
                            }
                        } else if(result.message){
                            alert(result.message);
                        }
                    }));
                }));
        }
    });
});