define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/dom-style",
    "dijit/registry",
    "dojo/query",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/dom-attr",
    "dojo/_base/xhr",
    "widgets/userInfo",
    "dojo/_base/json",
    "dojo/cookie"
    ], function(declare, array, domClass, domStyle, registry, query, lang, Deferred, domAttr, xhr, userInfo,json,cookie) {
    return declare("widgets.common._TeamDetailMixin", null, {
        onBeforeTransitionOut:function(){
            domClass.add(this.bcardPane,"hide");
            domClass.add(this.sharePane,"hide");
            domClass.add(this.ewmPane,"hide");
            this.inherited(arguments);
        },
        indexPacDetailElement:function(){
            // 拼团活动List
            this.actDetail = registry.byNode(query(".actDtl",this.domNode)[0]);
            // 拼团介绍List
            this.teamMessage = registry.byNode(query(".teamMsg",this.domNode)[0]);
            // 拼团成员List
            this.memberList = registry.byNode(query(".memList",this.domNode)[0]);
            // 点击关注公众号后分享开团
            this.attDiv = query(".attentionDiv", this.domNode)[0];
            // 扫码分享 分享给朋友
            this.shareDiv = query(".shareDiv", this.domNode)[0];
            // 重新开团 其他商品
            this.failDiv = query(".failDiv", this.domNode)[0];
            // 我要参团 我要开团
            this.pacingDiv = query(".pacingDiv", this.domNode)[0];
            // 我要开团 其他商品
            this.sucDiv = query(".successDiv", this.domNode)[0];
            // 立即付款
            this.payDiv = query(".payDiv", this.domNode)[0];
            // 二维码弹出框
            this.bcardPane = query(".bcardPane", this.domNode)[0];
            // 扫码分享
            this.bcardShare = query(".bcardShare", this.domNode)[0];
            // 分享给朋友
            this.shareToFri = query(".shareToFri", this.domNode)[0];
            // 分享给朋友箭头
            this.sharePane = query(".sharePane", this.domNode)[0];
            // 重新开团
            this.pacAgain = query(".pacAgain", this.domNode)[0];
            // 其他商品
            this.otherPro = query(".otherPro", this.domNode)[0];
            // 我要参团
            this.buyNowBtn = query(".buyNow", this.domNode)[0];
            // 我要开团
            this.pacBySelf = query(".pacByMySelf", this.domNode)[0];
            // 我要开团
            this.pacBySelf1 = query(".pacByMySelf1", this.domNode)[0];
            // 其他商品
            this.otherPro1 = query(".otherPro1", this.domNode)[0];
            // 参团成功
            this.ewmPane = query(".ewmPane", this.domNode)[0];
            // 按钮区域
            this.attOrShaDiv = query(".attentionOrShare", this.domNode)[0];
            //呼唤朋友
            this.call_friend = query(".call_friend",this.domNode)[0];
            //this.attOrShaDiv.parentNode.parentNode.parentNode.appendChild(this.attOrShaDiv);
            //domStyle.set(this.attOrShaDiv,{"marginTop":"-40px"});
            
            
            // 没有用到
            //this.msgDtl = query(".msgDtl", this.domNode)[0];
            //this.msgTitle = query(".msgTitle", this.msgDtl)[0];
            
            //this.widthHeader = query(".widthHeader",this.domNode)[0];
            //this.widthHeader.appendChild(this.bcardPane);
            //this.widthHeader.appendChild(this.sharePane);
            //this.widthHeader.appendChild(this.ewmPane);
            document.body.appendChild(this.bcardPane);
            document.body.appendChild(this.sharePane);
            document.body.appendChild(this.ewmPane);
            
            domStyle.set(this.domNode,"height","100%");
            
            registry.byId("pacFixed").resize();
            
            //var line_clamp = parseInt(domStyle.get(document.body,"height")*0.7*0.153/15 - 1, 10);
            //domStyle.set(this.msgTitle, {"-webkit-line-clamp": line_clamp});
        },
        initPacDetailEvent:function(){
            this.connect(this.actDetail, "onDefRendered", lang.hitch(this, function(data){
                var state = data.data.items[0].T0_STATE;
                // 开团支付成功后 进入这个页面 有可能团队的状态还未修改成功 但此页面不会出现STATE=0的情况
                state = (state==0)?1:state;
                // 去掉了图片
                data.data.items[0].img = (state==0)?"state0.png":
                    ((state==1)?"state1.png":
                    ((state==2)?"state2.png":
                    "state3.png"));
                data.data.items[0].content = (state==0)?"准备开团":
                    (state==1?"等待参团":
                    (state==2?"拼团成功":"拼团失败"));
                domAttr.set(query(".msgImg",this.bcardPane)[0],"src","/w/img/load/" + g_sys_info.code + "-" + data.data.items[0].T6_T0_IconURLID + ".png");
                
                query(".msgTitle", this.bcardPane)[0].innerHTML = data.data.items[0].T1_TITLE;
                query(".msgPrice", this.bcardPane)[0].innerHTML = "￥" + window.fixedTo(data.data.items[0].T1_PACPRICE,3);
                
                
                //this.FREEPOST = data.data.items[0].T1_FREEPOST;
                //this.PACPRICE = data.data.items[0].T1_PACPRICE;
                //this.RIID = data.data.items[0].T0_PMID.MID;
                
                // 微信发送给朋友和分享需要重置分享标题和内容
                this.shareData = {
                    "MININFO":data.data.items[0].T1_MINFO,
                    "TITLE":data.data.items[0].T1_TITLE
                };
                
                // 依据拼团人数修改 page
                this.teamMessage.rs_wb_page = data.data.items[0].T1_PACNUM;
                // 刷新拼团介绍List
                this.teamMessage.refreshList();
                
                // 设置网页标题
                document.title = data.data.items[0].T1_TITLE;
                
            }));
            this.connect(this.teamMessage, "onDefRendered", lang.hitch(this, function(data){
                var items = data.data.items;
                array.forEach(items, function(item, index){
                    if(index === 0){
                        item.rl = 1;
                    }
                    items[index].INDATE = items[index].INDATE.substr(0,items[index].INDATE.length-3);
                });
                
                // 刷新拼团成员List
                this.memberList.onDataReady(data);
                
                // 总拼团人数-成功入团人数 追加几行空数据
                var num = this.teamMessage.rs_wb_page-items.length;
                if(num > 0){
                    for(var i = 0;i < num; i++){
                        items[items.length] = {};
                    }
                }
            }));
            
            //开团成功 呼唤朋友
            this.connect(this.call_friend,"onclick",lang.hitch(this,function(){
                //window.busy();
                xhr("GET", {
                    url: "/w/market/senInvitePacMsg/" + window.code,
                    handleAs: "json",
                    content: {
                        "actionId":window.did
                    },
                    load:lang.hitch(this, function(data){
                        if(data.rtnType == 1){
                            //window.free();
                            alert("已给您的朋友发送拼团邀请");
                            // window.singleBuyMat(this.mid,1,["PACBUY_TEAMID_"+data.data.items[0].DID+"_FREEPOST_"+this.FREEPOST,this.PACPRICE]);
                        }else{
                            //window.free();
                            alert(data.message);
                        }
                    })
                });
            }));
            // 开团成功 我要开团--非团长
            this.connect(this.pacBySelf1, "onclick", lang.hitch(this, function(){
                window.busy();
                xhr("GET", {
                    url: "/w/market/NewTeam/" + window.code,
                    handleAs: "json",
                    content: {
                        "actionId":this.actionId
                    },
                    load:lang.hitch(this, function(data){
                        if(data.rtnType == 1){
                            window.free();
                            alert('开团成功');
                            window.singleBuyMat(this.mid,1,["PACBUY_TEAMID_"+data.data.items[0].DID+"_FREEPOST_"+this.FREEPOST,this.PACPRICE]);
                        }else{
                            window.free();
                            alert(data.message);
                        }
                    })
                });
            }));
            
            // 开团成功 其它商品
            this.connect(this.otherPro1, "onclick", lang.hitch(this, function(){
                window.moveToView("pacBuyList");
            }));
            // 代付款 立即购买
            this.connect(this.payDiv, "onclick", lang.hitch(this, function(){
                window.moveToView("orderDetail", this.billId);
            }));
            // 立即购买
            this.connect(this.buyNowBtn, "onclick", lang.hitch(this, function(){
                window.singleBuyMat(this.mid,1,["PACBUY_TEAMID_"+window.did+"_FREEPOST_"+this.FREEPOST,this.PACPRICE]);
            }));
            // 其它商品
            this.connect(this.otherPro, "onclick", lang.hitch(this, function(){
                window.moveToView("pacBuyList");
            }));
            // 拼团失败
            // 团长--重新开团
            this.connect(this.pacAgain, "onclick", lang.hitch(this, function(){
                window.busy();
                xhr("GET", {
                    url: "/w/market/NewTeam/" + window.code,
                    handleAs: "json",
                    content: {
                        "actionId":this.actionId
                    },
                    load:lang.hitch(this, function(data){
                        if(data.rtnType == 1){
                            window.free();
                            alert('开团成功');
                            window.singleBuyMat(this.mid,1,["PACBUY_TEAMID_"+data.data.items[0].DID+"_FREEPOST_"+this.FREEPOST,this.PACPRICE]);
                        }else{
                            window.free();
                            alert(data.message);
                        }
                    })
                });
            }));
            // 团员--自己开团
            this.connect(this.pacBySelf, "onclick", lang.hitch(this, function(){
                window.busy();
                xhr("GET", {
                    url: "/w/market/NewTeam/" + window.code,
                    handleAs: "json",
                    content: {
                        "actionId":this.actionId
                    },
                    load:lang.hitch(this, function(data){
                        if(data.rtnType == 1){
                            window.free();
                            alert('开团成功');
                            window.singleBuyMat(this.mid,1,["PACBUY_TEAMID_"+data.data.items[0].DID+"_FREEPOST_"+this.FREEPOST,this.PACPRICE]);
                        }else{
                            window.free();
                            alert(data.message);
                        }
                    })
                });
            }));
            // 二维码分享监听
            this.connect(this.bcardShare, "onclick", lang.hitch(this, function(){
                require([
                        "cqthink/image/qrCode"
                    ],lang.hitch(this,function(qrCode){
                        var qrCard = qrCode.generatePNG(window.location.href, {
                            modulesize: 5,
                            margin: 2,
                            ecclevel: "M"
                        });
                        domAttr.set(query(".pacEwm", this.bcardPane)[0],"src",qrCard);
                        domClass.remove(this.bcardPane,"hide");
                    }));
            }));
            // 分享给朋友监听
            this.connect(this.shareToFri, "onclick", lang.hitch(this, function(){
                domClass.remove(this.sharePane,"hide");
            }));
            this.connect(this.sharePane, "onclick", lang.hitch(this, function(){
                domClass.add(this.sharePane,"hide");
            }));
            this.connect(this.bcardPane, "onclick", lang.hitch(this, function(){
                domClass.add(this.bcardPane,"hide");
            }));
            // 好友分享监听
            document.addEventListener('WeixinJSBridgeReady', function onBridgeReady() {
                // 发送给好友
                WeixinJSBridge.on('menu:share:appmessage', function (argv) {
                    WeixinJSBridge.invoke('sendAppMessage', {
                        "desc": this.shareData.MININFO,
                        "title": this.shareData.TITLE
                    }, function (res) {
                        _report('send_msg', res.err_msg);
                    });
                });
                // 分享到朋友圈
                WeixinJSBridge.on('menu:share:timeline', function (argv) {
                    WeixinJSBridge.invoke('shareTimeline', {
                        "desc": this.shareData.MININFO,
                        "title": this.shareData.TITLE
                    }, function (res) {
                        _report('timeline', res.err_msg);
                    });
                });
            }, false);
            //  WeixinJSBridge.call('closeWindow');
            //  点击打开二维码关注
            this.connect(this.attDiv,"onclick",function(){
                domClass.remove(this.ewmPane,"hide");
            });
            this.connect(this.ewmPane,"onclick",function(){
                domClass.add(this.ewmPane,"hide");
            });
        },
        getCurrentDate:function(){
            var def = new Deferred();
            // 获取服务器当前时间
            xhr("GET",{
                url:"/w/data/GetDataTime/" + window.code,
                handleAs:"json",
                load:lang.hitch(this, function(time){
                    def.resolve(time);
                }),
                connect:{}
            });
            return def;
        },
        formatSeconds:function(time) { 
            // 计算
            var h = 0,
                i = 0,
                d = 0,
                s = parseInt(time);
            if (s > 60) {
                i = parseInt(s / 60);
                s = parseInt(s % 60);
                if (i > 60) {
                    h = parseInt(i / 60);
                    i = parseInt(i % 60);
                    if (h >=24){
                        d = parseInt(h / 24);
                        h = parseInt(h % 24);
                    }
                }
            }
            // 补零
            var zero = function(v) {
                return (v >> 0) < 10 ? "0" + v : v;
            };
            return {
                d:parseInt(zero(d)),
                t:[zero(h),zero(i), zero(s)].join(":")
            };
        },
        autoRegistPartner:function(){
            var def = new Deferred();
            xhr("GET",{
                url:"/w/user/WxAutoRegist/" + window.code,
                handleAs:"json",
                load:lang.hitch(this, function(result){
                    if(result.rtnType == 1){
                        userInfo.serverUserInfoBack(result.data);
                        def.resolve();
                    }else{
                        alert("注册会员失败");
                        def.resolve();
                    }
                })
            });
            return def;
        },
        // 获取当前人在当前团队的成员信息
        loadMyMemberInfoInCurrentTeam:function(){
            var def = new Deferred();
            window.loadData({
                modalName:"XSY_TCRMK_PACAGE_MEMBER",
                where:"[AID]=@AID AND [PTID]='"+ window.did + 
                    "' AND ([WXID]='" + window.wx_openId + 
                    "' OR [PID]='" + (userInfo.getUserInfo().partnerId||"") + "')"
            }).then(lang.hitch(this,function(data){
                def.resolve(data);
            }));
            return def;
        },
        // 判断当前客户是否 加入团队 如果没有加入团队 则加入团队
        joinCurrentTeam:function(){
            var def = new Deferred(),
            data = {
                n:{
                    PMID:this.actionId || "",
                    PTID:window.did,
                    PID:userInfo.getUserInfo().partnerId||"",
                    WXID:window.wx_openId,
                    STATE:"0",
                    INDATE:g_s.getDateTime()
                }
            };
            xhr("POST",{
                url:"/w/data/update/" + window.code||window.g_sys_info.code,
                handleAs:"json",
                load:lang.hitch(this, function(result){
                    def.resolve();
                }),
                content:{
                    data:json.toJson({
                        modalName:"XSY_TCRMK_PACAGE_MEMBER",
                        data:[data]
                    })
                }
            });
            return def;
        },
        // 加载拼团活动
        loadPacAct:function(){
            var def = new Deferred();
            window.loadData({
                modalName:"XSY_VCRMK_PACAGE_TEAM",
                filter:"02",
                param:{DID:window.did}
            }).then(lang.hitch(this,function(data){
                if(data.length){
                    data[0].discount = data[0].T1_PACPRICE/data[0].T6_T3_RetailPrice*10; //折扣
                    if(data[0].discount<0.1){
                        data[0].discount = 0.1;
                    }
                }
                def.resolve(data);
            }));
            return def;
        },
        // 依据条件显示隐藏按钮
        updateBtnShowState:function(s1,s2,s3,s4,s5,s6){
            // 点击关注公众号
            domClass[s1?"remove":"add"](this.attDiv,"hide");
            // 扫码分享 分享给朋友
            domClass[s2?"remove":"add"](this.shareDiv,"hide");
            // 重新开团 其他商品
            domClass[s3?"remove":"add"](this.failDiv,"hide");
            // 我要参团 我要开团
            domClass[s4?"remove":"add"](this.pacingDiv,"hide");
            // 我要开团 其他商品
            domClass[s5?"remove":"add"](this.sucDiv,"hide");
            // 立即付款
            domClass[s6?"remove":"add"](this.payDiv,"hide");
        },
        updateCurrentTeamState:function(){
            var pacItems = query(".pacItem",this.domNode);
            switch(this.actState){
                // 开团成功
                case "1":
                    domClass.add(pacItems[0], "pacComStep");
                    domClass.add(pacItems[1], "pacComStep");
                    domClass.add(pacItems[2], "pacComStep");
                    domClass.remove(pacItems[3], "pacComStep");
                    domClass.add(query(".pacState", this.domNode)[0],"hide");
                    break;
                // 拼团成功
                case "2":
                    domClass.add(pacItems[0], "pacComStep");
                    domClass.add(pacItems[1], "pacComStep");
                    domClass.add(pacItems[2], "pacComStep");
                    domClass.add(pacItems[3], "pacComStep");
                    domClass.remove(query(".pacState", this.domNode)[0],"hide");
                    query(".pacState", this.domNode)[0].firstElementChild.src = "/w/Content/sjmdsvc/image/ptcgz.png";
                    break;
                // 拼团失败
                case "3":
                    domClass.add(pacItems[0], "pacComStep");
                    domClass.remove(pacItems[1], "pacComStep");
                    domClass.remove(pacItems[2], "pacComStep");
                    domClass.remove(pacItems[3], "pacComStep");
                    domClass.remove(query(".pacState", this.domNode)[0],"hide");
                    query(".pacState", this.domNode)[0].firstElementChild.src = "/w/Content/sjmdsvc/image/ptsbz.png";
                    break;
                case "0":
                    domClass.add(pacItems[0], "pacComStep");
                    domClass.remove(pacItems[1], "pacComStep");
                    domClass.remove(pacItems[2], "pacComStep");
                    domClass.remove(pacItems[3], "pacComStep");
                    domClass.add(query(".pacState", this.domNode)[0],"hide");
                    break;
            }
            
        },
        setThisProperty:function(actData){
            // 当前商品
            this.mid = actData&&actData[0]&&actData[0]["T0_PMID.MID"];
            // 当前拼团活动
            this.actionId = actData&&actData[0]&&actData[0]["T0_PMID.DID"];
            // 当前拼团状态
            var state = actData&&actData[0].T0_STATE;
            this.actState = ((state == 0)?1:state);
            // 当前拼团商品是否包邮 0,不包邮 1,包邮
            this.FREEPOST = actData&&actData[0]&&actData[0].T1_FREEPOST;
            // 当前拼团商品价格
            this.PACPRICE = actData&&actData[0]&&actData[0].T1_PACPRICE;
            // 当前活动开始时间
            this.teamEndDate = actData&&actData[0]&&actData[0].T0_DDATE;
            // 当前活动结束时间
            this.teamStartDate = actData&&actData[0]&&actData[0].T0_SDATE;
            
        },
        pacPayTimerFuc:function(billDate){
            // 获取服务器时间
            this.getCurrentDate().then(lang.hitch(this,function(data){
                if(this.pacPayTimer){
                    clearInterval(this.pacPayTimer);
                }
                // 比较服务器当前时间与订单提交时间的时间差
                // 订单提交时间+30分钟 拼团的订单取消时间为30分钟
                billDate = g_s.toDateTimeString(g_s.dateAdd(billDate,"n","30"));
                var delayed = g_s.dateDiff("s",data.nowTime,billDate);
                this.pacPayTimer = setInterval(lang.hitch(this, function() { //节点加载出来后获取倒计时的节点
                    if (delayed > 0) {
                        delayed--;
                         var time = this.formatSeconds(delayed),
                            d = time.d,
                            s = time.t;
                            var realDelayed ="";
                            realDelayed = (d?d+"天":"") + s;
                        if(query(".pacRemaind",this.payDiv)[0]){
                            query(".pacRemaind",this.payDiv)[0].innerHTML = realDelayed;
                        }
                    } else {
                        this.refreshAllList();
                        clearInterval(this.pacPayTimer);
                    }
                }), 1000);
            }));
        },
        pacTimerFuc:function(){
            // 拼团成功或失败时不显示拼团时间 等信息
            if(this.actState!=1){
                domClass.add(query(".pacTimerNode",this.actDetail.domNode)[0],"hide");
                return;
            }
            //domClass.remove(query(".pacTimerNode",this.actDetail.domNode)[0],"hide");
            // 从服务器上获取当前时间
            this.getCurrentDate().then(lang.hitch(this,function(data){
                // 用服务器时间做定时器
                // 如果有定时器 先清除定时器
                if(this.pacTimer){
                    clearInterval(this.pacTimer);
                }
                domClass.remove(query(".pacTimerNode",this.actDetail.domNode)[0],"hide");
                // 比较服务器当前时间与结束时间的时间差
                var delayed = g_s.dateDiff("s",data.nowTime,this.teamEndDate);
                this.pacTimer = setInterval(lang.hitch(this, function() { //节点加载出来后获取倒计时的节点
                    if (delayed > 0) {
                        delayed--;
                         var time = this.formatSeconds(delayed),
                            d = time.d,
                            s = time.t;
                            var realDelayed ="";
                            realDelayed = (d?d+"天":"") + s;
                        if(query(".pacTimer",this.actDetail.domNode)[0]){
                            query(".pacTimer",this.actDetail.domNode)[0].innerHTML = realDelayed;
                        }
                    } else {
                        //this.refreshAllList();
                        clearInterval(this.pacTimer);
                    }
                }), 1000);
            }));
        },
        
        // 加载数据 并做判断
        refreshAllList:function(){
            // 清除页面定时器
            if(this.pacPayTimer){
                clearInterval(this.pacPayTimer);
            }
            if(this.pacTimer){
                clearInterval(this.pacTimer);
            }
            // 进入页面时记录当前用户的COOKIE
            cookie(g_sys_info.code+"_PT",window.did,{
                path:"/"
            });
            // 刷新当前团队成员信息
            this.memberList.refreshList();
            // 获取到当前人的会员信息
            // 判断有没有登录 
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                // 如果没有登录 但有会员信息 则给当前人注册一个新的客户
                if(!s && window.wx_openId){
                    this.autoRegistPartner().then(lang.hitch(this,function(){
                        // 刷新拼团活动和参团人员以及团成员信息
                        this.loadPacAct().then(lang.hitch(this,function(actData){
                            var o = {};
                            o.data = {};
                            o.data.items = actData;
                            this.setThisProperty(actData);
                            // 刷新拼团活动
                            this.actDetail.onDataReady(o);
                            
                            // 如果团队状态=1 设置定时器
                            setTimeout(lang.hitch(this,this.pacTimerFuc),100);
                            // 更新当前团队状态显示
                            this.updateCurrentTeamState();
                            
                            // 加入团队
                            // 只有团队允许加入时 才能加入
                            if(this.actState==1){
                                this.joinCurrentTeam().then(lang.hitch(this,function(){
                                    // 获取到我加入团队的信息后 
                                    // 依据条件显示隐藏按钮
                                    
                                    this.updateBtnShowState(false,false,false,true,false,false);
                                }));
                            }
                            // 不允许加入时 显示
                            else if(this.actState==2){
                                this.updateBtnShowState(false,false,false,false,true,false);
                            }else{
                                this.updateBtnShowState(false,false,false,true,false,false);
                            }
                        }));
                    }));
                }else{
                    this.loadPacAct().then(lang.hitch(this,function(actData){
                        var o = {};
                        o.data = {};
                        o.data.items = actData;
                        this.setThisProperty(actData);
                        // 刷新拼团活动
                        this.actDetail.onDataReady(o);
                        
                        // 如果团队状态=1 设置定时器
                        setTimeout(lang.hitch(this,this.pacTimerFuc),100);
                        // 更新当前团队状态显示
                        this.updateCurrentTeamState();
                        
                        // 判断当前人是否加入当前团队
                        this.loadMyMemberInfoInCurrentTeam().then(lang.hitch(this,function(memberData){
                            // 当前人已经加入团队
                            if(memberData.length){
                                // 判断当前成员在团队的状态
                                // 判断当前团队的状态
                                
                                // 团队成员状态
                                // {{0,已报名}{1,待付款}{2,已购买}{3,已退出}}
                                // 团队状态
                                // {{0,准备开团}{1,开团成功}{2,拼团成功}{3,拼团失败}}
                                
                                // 如果团员状态是 已报名或者已退出
                                if((memberData[0].STATE==0||memberData[0].STATE==3)){
                                    // 开团成功 但还未满人数
                                    if(this.actState==1){
                                        this.updateBtnShowState(false,false,false,true,false,false);
                                    }
                                    // 拼团成功 
                                    else if(this.actState==2){
                                        this.updateBtnShowState(false,false,false,false,true,false);
                                    }
                                    // 拼团失败
                                    else{
                                        this.updateBtnShowState(false,false,true,false,false,false);
                                    }
                                }
                                // 团员状态是待付款
                                else if(memberData[0].STATE==1){
                                    // 当前团购的订单ID
                                    this.billId = memberData[0].BILLID;
                                    // 设置付款定时器
                                    this.pacPayTimerFuc(memberData[0]["BILLID.BillDate"]);
                                    this.updateBtnShowState(false,false,false,false,false,true);
                                }
                                // 团员状态是购买成功
                                else if(memberData[0].STATE==2){
                                    // 查询我的关注状态
                                    window.loadData({
                                        modalName:"XSY_TWBCM_WXM",
                                        filter:"02",
                                        param:{OPENID:window.wx_openId}
                                    }).then(lang.hitch(this,function(wxData){
                                        if(wxData.length&&wxData[0].SUBSCRIBED==1){
                                            // 已关注
                                            // 开团成功 但还未满人数
                                            if(this.actState==1){
                                                domClass.remove(this.call_friend,"hide");
                                                this.updateBtnShowState(false,true,false,false,false,false);
                                            }
                                            // 拼团成功 或者 拼团失败
                                            else{
                                                this.updateBtnShowState(false,false,true,false,true,false);
                                            }
                                            //
                                        }else{
                                            window.loadData({
                                                modalName:"XSY_TSSCF_APP_SET",
                                                where:"[APP_ID]=@AID"
                                            }).then(lang.hitch(this,function(setData){
                                                if(setData.length&&setData[0].EWM_ID){
                                                    domAttr.set(query(".appEwm",this.ewmPane)[0],"src","/w/img/load/" + window.code + "-" + setData[0].EWM_ID);
                                                    domClass.remove(this.ewmPane, "hide");
                                                }
                                                // 未关注
                                                this.updateBtnShowState(true,false,false,false,false,false);
                                            }));
                                        }
                                    }));
                                    
                                }
                            }else if(!memberData.length){
                                if(this.actState==1){
                                    this.joinCurrentTeam().then(lang.hitch(this,function(){
                                        // 获取到我加入团队的信息后 
                                        // 依据条件显示隐藏按钮
                                        this.updateBtnShowState(false,false,false,true,false,false);
                                    }));
                                }
                                // 可以选择自己开团或者
                                // 不允许加入时 显示
                                else if(this.actState==2){
                                    this.updateBtnShowState(false,false,false,false,true,false);
                                }else{
                                    this.updateBtnShowState(false,false,false,true,false,false);
                                }
                            }
                        }));
                    }));
                }
            }));
        },
        // 加载会员信息
        loadDataFun:function(){
            var def = new Deferred(),def1 = new Deferred(),def2 = new Deferred();
            // 加载微信会员信息
            xhr("GET",{
                url:window.g_sys_info.url_usr,
                handleAs:"json",
                load:lang.hitch(this, function(data){
                    this.wxm = data && data.data && data.data.items[0];
                    def.resolve(data && data.data && data.data.items[0]);
                }),
				content:{
                    modalName:"XSY_TWBCM_WXM",
                    filter:"02",
                    hash:encodeURIComponent(json.toJson({
                        AID:window.g_sys_info.aid,
                        OPENID:window.wx_openId
                    }))
				}
            });
            def.then(lang.hitch(this, function(data){
                userInfo.hasLogin().then(lang.hitch(this, function(s){
                    if(!s && this.wxm){// 未关注 未注册
                        xhr("GET",{
                            url:"/w/user/WxAutoRegist/" + window.code,
                            handleAs:"json",
                            load:lang.hitch(this, function(result){
                                if(result.rtnType == 1){
                                    userInfo.serverUserInfoBack(result.data);
                                    // userInfo.mdfUserInfo(result.data);
                                    def1.resolve();
                                }else{
                                    alert("当前没有客户且读不到对应微信关注者");
                                }
                            }),
                            error:function(msg){
                            },
                            sync: false,
                            preventCache: true
                        });
                    }else{
                        def1.resolve();
                    }
                }));
            }));
            // 判断客户是否加入团队,如果没有则加入
            def1.then(lang.hitch(this, function(){
                xhr("GET",{
                    url:window.g_sys_info.url_usr,
                    handleAs:"json",
                    load:lang.hitch(this, function(data){
                        if(data.data && data.data.items && data.data.items.length){
                            // 各人状态
                            def2.resolve(data);
                        }else{
                            // 加入团队,设置状态为已加入(只有团队状态为1，才允许加入)
                            if(this.actState == 1){
                                xhr("POST",{
                                    url:"/w/data/update/" + window.code||window.g_sys_info.code,
                                    handleAs:"json",
                                    load:lang.hitch(this, function(result){
                                        xhr("GET",{
                                            url:window.g_sys_info.url_usr,
                                            handleAs:"json",
                                            load:lang.hitch(this, function(data){
                                                //alert(data.data);
                                                def2.resolve(data);
                                            }),
                                            sync:false,
                                            preventCache:true,
                                            content:{
                                                modalName:"XSY_TCRMK_PACAGE_MEMBER",
                                                where:"[AID]='" + window.g_sys_info.aid + "' AND [PTID]='"
                                                    + window.did + "' AND ([WXID]='" + window.wx_openId + 
                                                    "' OR [PID]='" + (window.userInfo.partnerId?window.userInfo.partnerId:"") + "')"
                                            }
                                        });
                                    }),
                                    error:function(msg){
                                        // alert(msg);
                                    },
                                    content:{
                                        data:json.toJson({
                                            modalName:"XSY_TCRMK_PACAGE_MEMBER",
                                            data:[{n:{
                                                AID:window.g_sys_info.aid,
                                                PMID:this.actionId || '',
                                                PTID:window.did,
                                                PID:(window.userInfo.partnerId?window.userInfo.partnerId:""),
                                                WXID:window.wx_openId,
                                                STATE:'0',
                                                INDATE:g_s.getDateTime()
                                            }}]
                                        })
                                    }
                                });
                            }else{// state = 0/2/3 准备开团或者拼团成功或者拼团失败
                                def2.resolve();
                            }
                        }
                    }),
                    error:function(msg){
                        // alert(msg);
                    },
                    sync:false,
                    preventCache:true,
                    content:{
                        modalName:"XSY_TCRMK_PACAGE_MEMBER",
                        where:"[AID]='" + window.g_sys_info.aid + "' AND [PTID]='"
                            + window.did + "' AND ([WXID]='" + window.wx_openId + 
                            "' OR [PID]='" + (window.userInfo.partnerId?window.userInfo.partnerId:"") + "')"
                    }
                });
            }));
            def2.then(lang.hitch(this, function(data){
                // 团队状态：开团成功、拼团成功(人数满)/拼团失败
                // 客户状态：已加入、代付款、已付款
                if(this.timer){
                    clearInterval(this.timer);
                    this.timer = null;
                }
                if(this.timer1){
                    clearInterval(this.timer1);
                    this.timer1 = null;
                }
                switch(this.actState){
                    case "1":
                        query(".stateContent1", this.domNode)[0].innerHTML = "等待参团";
                        query(".countDown", this.domNode)[0].firstElementChild.firstElementChild.innerHTML = "距离结束";
                        var timerSpam = query(".timer", this.domNode)[0];
                        // 获取服务器当前时间
                        xhr("GET",{
                            url:"/w/data/GetDataTime/" + window.code,
                            handleAs:"json",
                            load:lang.hitch(this, function(data){
                                var sysj = (new Date(Date.parse(this.teamEndDate.replace(/-/g,"/"))).getTime() - new Date(Date.parse(data.nowTime.replace(/-/g,"/"))).getTime())/1000;
                                if(sysj<=0){
                                    this.actState = "3";
                                }else{
                                    this.timer1 = setInterval(lang.hitch(this, function(){
                                        sysj--;
                                        var h = Math.floor(sysj/3600);
                                        var m = Math.floor((sysj%3600)/60);
                                        m = (m<10)?("0" + m):m;
                                        var s = Math.floor((sysj%60));
                                        s = (s<10)?("0" + s):s;
                                        timerSpam.innerHTML = "" + h + ":" + m + ":" + s;
                                        if(sysj <= 0){
                                            clearInterval(this.timer1);
                                            this.timer1 = null;
                                        }
                                    }), 1000);
                                }
                            }),
                            content:{}
                        });
                        domClass.add("choiceProduct", "playColor");
                        domClass.add("payOrJoinTeam", "playColor");
                        domClass.add("waitForFriend", "playColor");
                        domClass.remove("teamSuccess", "playColor");
                        //domStyle.set(query(".pacState", this.domNode)[0],{"display":"none"});
                        
                        domClass.add(query(".pacState",this.domNode)[0],"hide");
                        break;
                    case "2":
                        query(".stateContent1", this.domNode)[0].innerHTML = "拼团成功";
                        query(".countDown", this.domNode)[0].firstElementChild.firstElementChild.innerHTML = "开团时间";
                        query(".timer", this.domNode)[0].innerHTML = this.teamStartDate;
                        domClass.add("choiceProduct", "playColor");
                        domClass.add("payOrJoinTeam", "playColor");
                        domClass.add("waitForFriend", "playColor");
                        domClass.add("teamSuccess", "playColor");
                        //domStyle.set(query(".pacState", this.domNode)[0],{"display":"block"});
                        domClass.remove(query(".pacState", this.domNode)[0],"hide");
                        query(".pacState", this.domNode)[0].firstElementChild.src = "/w/Content/sjmdsvc/image/ptcgz.png";
                        break;
                    case "3":
                        query(".stateContent1", this.domNode)[0].innerHTML = "拼团失败";
                        query(".countDown", this.domNode)[0].firstElementChild.firstElementChild.innerHTML = "开团时间";
                        query(".timer", this.domNode)[0].innerHTML = this.teamStartDate;
                        domClass.add("choiceProduct", "playColor");
                        domClass.remove("payOrJoinTeam", "playColor");
                        domClass.remove("waitForFriend", "playColor");
                        domClass.remove("teamSuccess", "playColor");
                        //domStyle.set(query(".pacState", this.domNode)[0],{"display":"block"});
                        domClass.remove(query(".pacState", this.domNode)[0],"hide");
                        query(".pacState", this.domNode)[0].firstElementChild.src = "/w/Content/sjmdsvc/image/ptsbz.png";
                        break;
                    case "0":
                        //window.moveToView("pacTeamList");
                        break;
                }
                if(!data){
                    // state = 2/3 团队成功或者失败  并且客户未加入团队
                    // TODO 
                    domClass.add(this.pacingDiv,"hide");
                    domClass.add(this.attDiv,"hide");
                    domClass.add(this.shareDiv,"hide");
                    domClass.add(this.failDiv,"hide");
                    domClass.add(this.payDiv,"hide");
                    domClass.remove(this.sucDiv,"hide");
                }
                if(""===(data&&data.data&&data.data.items&&data.data.items[0]||"")){
                    domClass.add(this.pacingDiv,"hide");
                    domClass.add(this.attDiv,"hide");
                    domClass.remove(this.shareDiv,"hide");
                    domClass.add(this.failDiv,"hide");
                    domClass.add(this.payDiv,"hide");
                    domClass.add(this.sucDiv,"hide");
                }else if(data.data.items[0].STATE == 0 || data.data.items[0].STATE == 3){
                    if(this.actState == 1){
                        domClass.remove(this.pacingDiv,"hide");
                        domClass.add(this.attDiv,"hide");
                        domClass.add(this.shareDiv,"hide");
                        domClass.add(this.failDiv,"hide");
                        domClass.add(this.payDiv,"hide");
                        domClass.add(this.sucDiv,"hide");
                    }else if(this.actState == 2){
                        domClass.add(this.pacingDiv,"hide");
                        domClass.add(this.attDiv,"hide");
                        domClass.add(this.shareDiv,"hide");
                        domClass.add(this.failDiv,"hide");
                        domClass.add(this.payDiv,"hide");
                        domClass.remove(this.sucDiv,"hide");
                    }else{
                        domClass.add(this.pacingDiv,"hide");
                        domClass.add(this.attDiv,"hide");
                        domClass.add(this.shareDiv,"hide");
                        domClass.remove(this.failDiv,"hide");
                        domClass.add(this.payDiv,"hide");
                        domClass.add(this.sucDiv,"hide");
                    }
                }else if(data.data.items[0].STATE == 1){
                    this.billId = data.data.items[0].BILLID;
                    // 获取服务器当前时间
                    xhr("GET",{
                        url:"/w/data/GetDataTime/" + window.code,
                        handleAs:"json",
                        load:lang.hitch(this, function(result){
                            // 付款倒计时 设置定时器
                            var bgdate = new Date(Date.parse(data.data.items[0]["BILLID.BillDate"].replace(/-/g,"/")));
                            var djs = (bgdate.setDate(bgdate.getDate() + 1) - 
                            new Date(Date.parse(result.nowTime.replace(/-/g,"/"))).getTime())/1000;
                            if(djs <= 0){
                                // TODO 付款时间结束
                            }else{
                                this.timer = setInterval(lang.hitch(this, function(){
                                    djs--;
                                    var h = Math.floor(djs/3600);
                                    var m = Math.floor((djs%3600)/60);
                                    m = (m<10)?("0" + m):m;
                                    var s = Math.floor(djs%60);
                                    s = (s<10)?("0" + s):s;
                                    this.payDiv.innerHTML = "立即付款(付款剩余时间:" + h +":" + m + ":" + s +")";
                                    if(djs <= 0){
                                        domAttr.set(this.payDiv, {"disabled":"true"});
                                        clearInterval(this.timer);
                                        this.timer = null;
                                    }
                                }),1000);
                            }
                        }),
                        content:{}
                    });
                    domClass.add(this.pacingDiv,"hide");
                    domClass.add(this.attDiv,"hide");
                    domClass.add(this.shareDiv,"hide");
                    domClass.add(this.failDiv,"hide");
                    domClass.remove(this.payDiv,"hide");
                    domClass.add(this.sucDiv,"hide");
                }else if(data.data.items[0].STATE == 2){
                    if(!this.wxm || this.wxm.SUBSCRIBED == 0){
                        xhr("GET",{
                            url:g_sys_info.url_usr,
                            handleAs:"json",
                            load:lang.hitch(this, function(dt){
                                query(".bcardCont2", this.domNode)[0].firstElementChild.src="/w/img/load/" + window.code + "-" + dt.data.items[0].EWM_ID;
                                domStyle.set(this.ewmPane, {"display" : "block"});
                            }),
                            sync:false,
                            preventCache:true,
                            content:{
                                modalName:"XSY_TSSCF_APP_SET",
                                where:"[APP_ID]='" + window.g_sys_info.aid + "'"
                            }
                        });
                        xhr("GET",{
                            url:g_sys_info.url_usr,
                            handleAs:"json",
                            load:lang.hitch(this, function(dt){
                                query(".ewmMsgImg", this.domNode)[0].firstElementChild.src = "/w/img/load/" + window.code + "-" + dt.data.items[0].LOGO;
                                query(".appTitle", this.domNode)[0].innerHTML = dt.data.items[0].APP_TITLE;
                            }),
                            sync:false,
                            preventCache:true,
                            content:{
                                modalName:"XSY_TSSCF_APP",
                                where:"[APP_ID]='" + window.g_sys_info.aid + "'"
                            }
                        });
                        domClass.add(this.pacingDiv,"hide");
                        domClass.remove(this.attDiv,"hide");
                        domClass.add(this.shareDiv,"hide");
                        domClass.add(this.failDiv,"hide");
                        domClass.add(this.payDiv,"hide");
                        domClass.add(this.sucDiv,"hide");
                    }else if(this.wxm.SUBSCRIBED == 1){
                        domClass.add(this.pacingDiv,"hide");
                        domClass.add(this.attDiv,"hide");
                        domClass.remove(this.shareDiv,"hide");
                        domClass.add(this.failDiv,"hide");
                        domClass.add(this.payDiv,"hide");
                        domClass.add(this.sucDiv,"hide");
                    }
                }
            }));
        }
    });
});