define([
    "dojo/_base/declare",
    "dijit/registry",
    "cqthink/mobile/MapPane",
    "dojo/query",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "widgets/userInfo",
    "cqthink/mobile/geoUtil",
    "cqthink/app/plugins/geolocation"
],function(declare,registry,MapPane,query,lang,domAttr,json,xhr,userInfo,geoUtil,geolocation){
    return declare("widgets.common._PerCarpoolDtlMixin",null,{
        
        isPerCarpoolDtlLoaded:function(){
            return !!this.perCarpoolDtlList;
        },
        indexPerCarpoolDtlElement:function(){
            this.perCarpoolDtlList = registry.byId("perCarpoolDtlList");
            this.distanceNode = query("#distanceNode",this.domNode)[0];
            this.mapContainer = query("#showMapPane",this.domNode)[0];
            //创建地图
            this.map = new MapPane({
                enableEdit:false
            }, this.mapContainer);
            this.map.startup();
            this.map.initMapElement();
            //清除地图中标记的位置信息
            //this.map.clearAllMarks();
            //清除地图中驾车路线
        },
        initPerCarpoolDtlEvent:function(){
            this.connect(this.perCarpoolDtlList,"onDefRendered",function(data){
                if(data.data.items.length){
                    var item = data.data.items[0];
                    //item.time = item.R_TIME.split(" ")[0].split("-")[1]+"-"+item.R_TIME.split(" ")[0].split("-")[2]+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                    //判断是否是自己的抢单,确认是否可以取消
                    if(window.userInfo.partnerId==item.N_PID.T0_PartnerID){
                        item.showCancel = 1;
                    }else{
                        item.showCancel = 0;
                    }
                    var time = item.R_TIME.split(" ")[0].split("-");
                    var carrentTime = new Date();
                    if(carrentTime.getFullYear()==time[0]&&(carrentTime.getMonth()+1)==time[1]){
                        if(carrentTime.getDate()==time[2]){
                            item.time = "今天"+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                        }else if(carrentTime.getDate()-time[2]==-1){
                            item.time = "明天"+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                        }else if(carrentTime.getDate()-time[2]==1){
                            item.time = "昨天"+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                        }else{
                            item.time = item.R_TIME.split(" ")[0].split("-")[1]+"-"+ item.R_TIME.split(" ")[0].split("-")[2]+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                        }
                    }else{
                            item.time = item.R_TIME.split(" ")[0].split("-")[1]+"-"+ item.R_TIME.split(" ")[0].split("-")[2]+" "+item.R_TIME.split(" ")[1].split(":")[0]+":"+item.R_TIME.split(" ")[1].split(":")[1];
                    }
                    //获取驾车路线
                    var startPoint = {
                        lon:data.data.items[0].S_LON,
                        lat:data.data.items[0].S_LAT
                    },
                    endPoint = {
                        lon:data.data.items[0].E_LON,
                        lat:data.data.items[0].E_LAT
                    };
                    this.map.drivingDrawLine(startPoint,endPoint).then(lang.hitch(this,this.calDistance));
                }
            });
            this.connect(this.perCarpoolDtlList.domNode,"onclick",this.perCarpoolDtlListClick);
        },
        //计算起始点的距离
        calDistance:function(results){
            var d = window.fixedTo(results.routes[0].distance/1000,2);
            this.distanceNode.innerHTML = d;
        },
        getCurrentPosition:function(){
            //获取当前城市
            geolocation.getCurrentPosition("").then(lang.hitch(this, function(data) {
                var lon = "",lat = "";
                if (data) {
                    lat = data.coords.latitude;
                    lon = data.coords.longitude;
                }
                this.map.setCenter(lon,lat);
            }));
        },
        refreshAllList:function(){
            if(this.did!=window.did){
                this.did = window.did;
                this.map.clearAllMarks();//清空标注
                this.perCarpoolDtlList.refreshList();
            }
            
            //设置我的当前位置
            this.getCurrentPosition();
        },
        routeSuccess:function(results){},
        routeError:function(results){},
        perCarpoolDtlListClick:function(e){
            var dom = e.target;
            if(dom&&dom.tagName=="A"&&domAttr.get(dom,"class")=="cancelCarpool"){
                this.cancelCarpool(window.did);
            }
        },
        //取消本次拼车
        cancelCarpool:function(did){
            window.busy();
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    xhr("POST", {
                        url: "/w/exec/exec/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token+"&tp=cancel_supply_or_need&paramStr="+did,
                        handleAs: "json",
                        load: lang.hitch(this, function(result) {
                            if (1 == result.rtnType) {
                                this.perCarpoolDtlList.refreshList();
                                window.free();
                            } else {
                                alert(result.message || "数据错误!");
                                window.free();
                            }
                        })
                    });
                }else{
                    alert("未登录。");
                    window.free();
                }
            }));
        }
    });
});