define([
    "dojo/_base/declare",
    "dojo/dom-attr",
    "dijit/registry",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom",
    "../userInfo",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dojo/_base/connect"
    ], function(declare, domAttr, registry, array,  lang, dom, userInfo, xhr, json, connect) {
    return declare("widgets.common._PostDetailListMixin", null, {
        isPostDetailLoaded: function() {
            return !!this.forumPostDetail;
        },
        indexPostDetailElement: function() {
            this.forumPostDetail = registry.byId("forumPostDetail");
            this.forumReply = registry.byId("forumReply");
            this.postReplyNode = dom.byId("forumReplyBtn");
            this.forumReplyContent = dom.byId("forum_reply_input");
        },
        initPostDetailEvent: function() {
            connect.connect(this.postReplyNode,"onclick",lang.hitch(this,function(e){
                var did=window.did;
                this.replyContentFuc(did);
            }));
            this.connect(this.forumReply,"onDefRendered",function(data){
                window.wx_openId = window.wx_openId?window.wx_openId:userInfo.getUserInfo().wxId;
                if(data.data.items.length){
                    array.forEach(data.data.items,function(item){
                        if(item.OPENID==window.wx_openId&&!window.wx_openId){
                            item.HREF = "javascript:void(0);";
                        }else{
                            item.HREF = "window.moveToView('wxconnect','"+window.wx_openId+"&"+item.OPENID+"')";
                        }
                    },this);
                }
            });
        },
        refreshAllList: function() {
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    if(window.did!=this.did){
                        this.did = window.did;
                        this.forumPostDetail.refreshList();
                        this.forumReply.refreshList();
                    }
                }
            }));
        },
        //评论数据
        replyContentFuc: function(did) {
            window.busy();
            //重新获取客户信息
            userInfo.hasLogin().then(lang.hitch(this, function(s) {
                if (s) {
                    //取旅行记录数量
                    var num = 0;
                    window.loadData({
                        modalName: "XSY_TCRMK_TRAVDTS", //旅行记录
                        filter: "05",
                        pageSize: "1",
                        pageIndex: "1",
                        param: {
                            "DID": did
                        }
                    }).then(lang.hitch(this, function(a) {
                        //如果取到对应的记录
                        if (a.length) {
                            //设置变量num的值为旅行记录的评论数量
                            num = parseFloat(a[0].COM_NUM || 0);
                        } else {
                            //否则设置为0
                            num = 0;
                        }
                        //定义新的变量
                        var openId = window.wx_openId?window.wx_openId:userInfo.getUserInfo().wxId;
                        var d = new Date(), //当前时间
                            data = {
                                n: {
                                    "CONTENT": this.forumReplyContent.value, //评论内容
                                    "RID": "XSY_TCRMK_TRAVDTS", //评论的资源
                                    "RIID": did, //评论的资源的主键
                                    "PID": userInfo.getUserInfo().partnerId, //评论的客户
                                    "OPENID": openId
                                }
                            }, //提交评论的数据
                            data1 = {
                                n: {
                                    COM_NUM: num + 1
                                },
                                o: {
                                    "DID": did
                                }
                            }; //修改评论数量的数据
                        //拼写当前时间
                        d = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds();
                        //如果没有填写评论内容
                        if (data["n"].CONTENT === "") {
                       //     alert("请输入评论内容");
                            window.free();
                        } else {
                            data["n"].MKDT = d; //评论时间
                            //提交评论
                            this.postReply(data, data1, did);
                        }
                    }));
                }
                //未登录时提示客户先登录
                else {
                    alert("请先登录");
                    window.free();
                }
            }));
        },
        //提交评论
        postReply: function(data, data1, did) {
            //评价内容提交
            xhr("POST", {
                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    data: json.toJson({
                        modalName: "APP_TBSAV_CMMNT",
                        data: [data]
                    })
                },
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        this.forumReplyContent.value="";
                        this.forumReply.refreshList();
                        window.free();
                    } else {
                        alert(result.message || "数据错误!");
                        window.free();
                    }
                })
            });
            //修改旅行记录中评论数量
            xhr("POST", {
                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    data: json.toJson({
                        modalName: "XSY_TCRMK_TRAVDTS",
                        data: [data1]
                    })
                }
            });
        },
    });
});