define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/query",
    "dojo/_base/xhr",
    "dojo/dom-style"
    ], function(declare, lang, array, registry, domAttr, domConstruct, query, xhr,domStyle) {
    return declare("widgets.common._PrizeBigWheelMixin", null, {
        TName:"",
        isPrizeBigWheelLoaded:function(){
            return !!this.PW;
        },
        indexPrizeBigWheelElement: function() {
            
        },
        refreshAllList: function() {
            
        },
        initPrizeBigWheelEvent: function() {
            
        },
        //开始抽奖
        pDraStart: function() {
            if (this.curCount < 20||null===this.importedData) {
                array.forEach(this.pDraImg, function(node, index) {
                    domAttr.set(node, "class", "pDraImg pDraOpcity" + (1+((20-this.curCount + index)%8)));
                }, this);
                this.curCount++;
                this._timer = setTimeout(lang.hitch(this, this.pDraStart), 80);
            } else {
                //获取抽奖结果
                this.updateShow();
            }
        },
        onImport: function() { //获取抽奖结果
            this.importedData = null;
            xhr("POST", {
                url: "/w/prize/draw/" + g_sys_info.code,
                content:{
                    billId:window.did,
                    srcWxId:window.srcWxId,
                    wxId:window.wx_openId
                },
                handleAs: "json",
                load: lang.hitch(this, function(result) {
                    this.importedData = result;
                    if (1 == result.rtnType) {
                        //取自己的票数
                        this.getPDCounts();
                    }
                }),
                error: function() {
                    this.importedData = {
                        rtnType:"101",
                        message:"发生错误"
                    };
                }
            });
        },
        updateShow:function(){
            if(this.importedData&&this.importedData.rtnType=="101"){
                array.forEach(this.pDraImg, function(node, index) {
                    domAttr.set(node, "class", "pDraImg intOpcity");
                }, this);
                alert(this.importedData.message);
            }else{
                var data = this.importedData.data;
                array.forEach(this.pDraImg, function(node, index) {
                    if (data[index].HEADIMGURL) {
                        domAttr.set(node, "src", data[index].HEADIMGURL);
                    } else {
                        domAttr.set(node, "src", "../../Content/htapp/images/headImg.png");
                    }
                    domAttr.set(node, "class", "pDraImg intOpcity");
                }, this);
            }
            window.free();
            this._timer = null;
        },
        getPDCounts: function() {
            window.loadData({
                modalName: "XSY_TCRSA_DRAWRESULTS",
                filter: "01",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "ActivityID": window.did,
                    "WXID": window.wx_openId
                }
            }).then(lang.hitch(this, function(data1) {
                if (!data1.length) {
                    domStyle.set(this.intPW,"display","");
                    domStyle.set(this.resultPW,"display","none");
                    //query('#intPW')[0].style.display = '';
                    //query('#resultPW')[0].style.display = 'none';
                } else {
                    xhr("POST", {
                        url: "/w/data/getCount/" + g_sys_info.code,
                        content: {
                            modalName: "XSY_TCRSA_DRAWRESULTS",
                            where: "[Counts]>" + data1[0].Counts
                        },
                        handleAs: "json",
                        load: lang.hitch(this, function(result) {
                            // alert(result.data);
                            //query("#MyResult")[0].innerHTML = data1[0]["WXID.NICKNAME"] + "，您当前已获得" + data1[0].Counts + "票";
                            //domStyle.set(this.nick,"display");
                            this.nick.innerHTML = data1[0]["WXID.NICKNAME"];
                            this.counts.innerHTML = data1[0].Counts;
                            domStyle.set(this.intPW,"display","none");
                            domStyle.set(this.resultPW,"display","");
                            //query('#intPW')[0].style.display = 'none';
                            //query('#resultPW')[0].style.display = '';
                        })
                    });
                }
                window.free();
                this._timer = null;
            }));
        }
    });
});