define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-attr",
    "cqthink/mobile/MapPane",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "widgets/userInfo",
    "dojo/_base/lang",
    "cqthink/mobile/geoUtil",
    "cqthink/app/plugins/geolocation"
],function(declare,registry,query,domAttr,MapPane,json,xhr,userInfo,lang,geoUtil,geolocation){
    return declare("widgets.common._PublishCarpoolMixin",null,{
        isCheckCity:false,
        isPublishCarpoolLoaded:function(){
            return !!this.carpoolStart;
        },
        indexPublishCarpoolElement:function(){
            //this.carpoolInfostart = registry.byId("carpoolInfo-start");//起点城市
            //this.carpoolInfoend = registry.byId("carpoolInfo-end");//终点城市
            this.start = query(".startCity",this.domNode)[0];
            this.end = query(".endCity",this.domNode)[0];
            this.carpoolStart = query("#carpoolStart",this.domNode)[0];//起点节点
            this.carpoolEnd = query("#carpoolEnd",this.domNode)[0];//终点节点
            this.carpoolTimePickerNode = query("#carpoolTimePickerNode",this.domNode)[0];//选择时间节点
            this.carpoolTimePicker = registry.byId("carpoolTimePicker");
            this.hidePicker = query(".cancel",this.carpoolTimePicker.domNode)[0];
            this.showPicker = query(".ok",this.carpoolTimePicker.domNode)[0];
            this.routeTimeValue = query(".routeTimeValue",this.carpoolTimePickerNode)[0];
            this.carPoolPri = query(".carPoolPri",this.domNode)[0];
            this.pubButton = query(".pubButton",this.domNode)[0];
            this.distanceKm = query(".distanceKm",this.domNode)[0];
            this.distancePri = query(".distancePri",this.domNode)[0];
            this.inherited(arguments);
        },
        getCurrentCity:function(){
            //获取当前城市
            geolocation.getCurrentPosition("需要获取您当前位置信息。").then(lang.hitch(this, function(data) {
                var lon = "",lat = "";
                if (data) {
                    lat = data.coords.latitude;
                    lon = data.coords.longitude;
                }
                geoUtil.geoToAddr(lon,lat).then(lang.hitch(this,function(data1){
                    if(data1){
                        this.start.innerHTML = data1.city?data1.city:data1.province;
                        this.end.innerHTML = data1.city?data1.city:data1.province;
                    }
                }));
            }));
        },
        refreshAllList:function(){
            this.inherited(arguments);
            if (window.titleNode) {
                window.titleNode.innerHTML = "上下班拼车";
            }
            if(!this.isCheckCity){
                this.getCurrentCity();
            }
            this.isCheckCity = false;
        },
        initPublishCarpoolEvent:function(){
            this.connect(this.carpoolStart,"onclick",this.chooseStartArea);
            this.connect(this.carpoolEnd,"onclick",this.chooseEndArea);
            this.connect(this.carpoolTimePickerNode,"onclick",this.chooseCarpoolTime);
            this.connect(this.hidePicker,"onclick",this.hideFuc);
            this.connect(this.showPicker,"onclick",this.showFuc);
            this.connect(this.carPoolPri,"onclick",this.changePri);
            this.connect(this.pubButton,"onclick",this.publishCarpoolInfo);
            this.connect(this.start,"onclick",function(){
                window.moveToView("chooseCity","publishCarpoolStart");
            });
            this.connect(this.end,"onclick",function(){
                window.moveToView("chooseCity","publishCarpoolEnd");
            });
            //获取当前城市或者侦听选择城市的广播
            this.subscribe("cqthink/wx/chooseCity/startCity/publishCarpool",function(cityName){
                this.isCheckCity = true;
                this.start.innerHTML = cityName;
            });
            this.subscribe("cqthink/wx/chooseCity/endCity/publishCarpool",function(cityName){
                this.isCheckCity = true;
                this.end.innerHTML = cityName;
            });
            this.subscribe("cqthink/wx/choosePlace/carpoolStartPlace",function(addrDtl){
                this.isCheckCity = true;
                //修改起点街道
                query("span",this.carpoolStart)[0].innerHTML = addrDtl.name;
                //设置起点的经纬度
                domAttr.set(this.carpoolStart,"lon",addrDtl.location.lng);
                domAttr.set(this.carpoolStart,"lat",addrDtl.location.lat);
                //重新更新起点城市
                geoUtil.geoToAddr(addrDtl.location.lng,addrDtl.location.lat).then(lang.hitch(this,function(data){
                    if(data){
                        this.start.innerHTML = data.city?data.city:data.province;
                    }
                }));
                //计算起点和终点之间的距离
                //如果有终点位置,则计算
                if(domAttr.get(this.carpoolEnd,"lon")){
                    var endPoint = {
                        lon:domAttr.get(this.carpoolEnd,"lon"),
                        lat:domAttr.get(this.carpoolEnd,"lat")
                    },
                    startPoint = {
                        lon:domAttr.get(this.carpoolStart,"lon"),
                        lat:domAttr.get(this.carpoolStart,"lat")
                    };
                    geoUtil.getDrivingRoute(startPoint,endPoint,lang.hitch(this,this.onSuccess),lang.hitch(this,this.onError));
                }
            });
            this.subscribe("cqthink/wx/choosePlace/carpoolEndPlace",function(addrDtl){
                this.isCheckCity = true;
                //修改起点街道
                query("span",this.carpoolEnd)[0].innerHTML = addrDtl.name;
                //设置起点的经纬度
                domAttr.set(this.carpoolEnd,"lon",addrDtl.location.lng);
                domAttr.set(this.carpoolEnd,"lat",addrDtl.location.lat);
                //重新更新终点城市
                geoUtil.geoToAddr(addrDtl.location.lng,addrDtl.location.lat).then(lang.hitch(this,function(data){
                    if(data){
                        this.end.innerHTML = data.city?data.city:data.province;
                    }
                }));
                //计算起点和终点之间的距离
                //如果有终点位置,则计算
                if(domAttr.get(this.carpoolStart,"lon")){
                    var endPoint = {
                        lon:domAttr.get(this.carpoolEnd,"lon"),
                        lat:domAttr.get(this.carpoolEnd,"lat")
                    },
                    startPoint = {
                        lon:domAttr.get(this.carpoolStart,"lon"),
                        lat:domAttr.get(this.carpoolStart,"lat")
                    };
                    geoUtil.getDrivingRoute(startPoint,endPoint,lang.hitch(this,this.onSuccess),lang.hitch(this,this.onError));
                }
            });
        },
        onSuccess:function(results){
            var d = window.fixedTo(results.routes[0].distance/1000,2);
            this.distanceKm.innerHTML = d;
        },
        chooseStartArea:function(e){
            //var dom = e.target;
            //while(dom&&dom.tagName!="DIV"){
            //    dom = dom.parentNode;
            //}
            var s = this.start.innerHTML;
            //var s = query(".startCity",this.carpoolInfostart.domNode)[0].value;
            //if(s==0){
                //alert("请先选择起点城市。");
            //}else{
                
            //}
            window.moveToView("choosePlace",s+"_cars");
        },
        chooseEndArea:function(e){
            //var dom = e.target;
            //while(dom&&dom.tagName!="DIV"){
            //    dom = dom.parentNode;
            //}
            var s = this.end.innerHTML;
            //var s = query(".endCity",this.carpoolInfoend.domNode)[0].value;
            //if(s==0){
                //alert("请先选择终点城市。");
            //}else{
                
            //}
            window.moveToView("choosePlace",s+"_care");
        },
        chooseCarpoolTime:function(){
            this.carpoolTimePicker.show();
        },
        hideFuc:function(){
            this.carpoolTimePicker.hide();
        },
        showFuc:function(){
            //取选择的时间
            var date = registry.byId("carpoolDate").get("value"),
                time = registry.byId("carpoolTime").get("values").join(":");
            //更新时间显示
            this.routeTimeValue.innerHTML = date+" "+time;
            domAttr.set(this.routeTimeValue,"time",date+" "+time);
            this.carpoolTimePicker.hide();
        },
        changePri:function(e){
            var dom = e.target;
            //如果点击的是a标签
            if(dom&&dom.tagName=="A"){
                var cls = domAttr.get(dom,"class");
                if(cls.indexOf("addPri")>-1){
                    this.addPri(1);
                }else{
                    this.addPri(-1);
                }
            }
        },
        addPri:function(inc){
            var pri = parseFloat(query(".pri",this.carPoolPri)[0].value),newPri = pri+inc;
            if(newPri<1){
                return;
            }
            query(".pri",this.carPoolPri)[0].value = newPri;
        },
        publishCarpoolInfo:function(){
            //检查起始点是否选择
            if(!domAttr.get(this.carpoolStart,"LAT")){
                alert("请选择起点。");
                return;
            }
            if(!domAttr.get(this.carpoolEnd,"LAT")){
                alert("请选择终点。");
                return;
            }
            if(!domAttr.get(this.routeTimeValue,"time")){
                alert("请选择时间。");
                return;
            }
            /*if(query(".pri",this.carPoolPri)[0].value<=0){
                alert("分摊费不能为空。");
            }*/
            var d = new Date(),dtime,day;
                day= d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate();
                dtime = day+" "+d.getHours()+":"+d.getMinutes()+":"+d.getSeconds();
            var data = {
                n:{
                    "S_ADDR":query("span",this.carpoolStart)[0].innerHTML,
                    "E_ADDR":query("span",this.carpoolEnd)[0].innerHTML,
                    "S_LAT":domAttr.get(this.carpoolStart,"LAT"),
                    "S_LON":domAttr.get(this.carpoolStart,"LON"),
                    "E_LAT":domAttr.get(this.carpoolEnd,"LAT"),
                    "E_LON":domAttr.get(this.carpoolEnd,"LON"),
                    "S_PID":userInfo.getUserInfo().partnerId,
                    "R_TIME":this.routeTimeValue.innerHTML+":00",
                    "TYPEID":0,
                    "FEE":query(".pri",this.carPoolPri)[0].value||0,
                    //"CYCID":CYCID,//
                    "IDENT":0,
                    "S_CITY":this.start.innerHTML,
                    "E_CITY":this.end.innerHTML,
                    "D_DATE":dtime
                }
            };
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    data["n"].PID = userInfo.getUserInfo().partnerId;
                    xhr("POST", {
                        url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                        handleAs: "json",
                        content: {
                            data: json.toJson({
                                modalName: "XST_TCRMK_SUPPLYORNEED",
                                data: [data]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                 alert("发布拼车信息成功。");
                                window.free();
                                window.moveToView("myCarpoolList","03");
                                 /*window.loadData({
                                     modalName:"XSY_TCRCS_CLIENT",
                                    filter:"01",
                                    pageSize:"1",
                                    pageIndex:"1",
                                    param:{"PartnerID":userInfo.getUserInfo().partnerId}
                                 }).then(lang.hitch(this,function(info){
                                     var data = {
                                         n:{
                                             "FINDINGCAR_NUM":parseFloat(info[0].FINDINGCAR_NUM||0)+1
                                         },
                                         o:{
                                             "ClientID":info[0].ClientID
                                         }
                                     };
                                     xhr("POST", {
                                         url:"../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                                         handleAs: "json",
                                        content: {
                                            data: json.toJson({
                                                modalName: "XSY_TCRCS_CLIENT",
                                                data: [data]
                                            })
                                        },
                                        load:lang.hitch(this,function(r){
                                            if(1===r.rtnType){
                                                
                                            }
                                        })
                                     });
                                 }));*/
                            } else {
                                alert(result.message || "数据错误!");
                                window.free();
                            }
                        })
                    });
                }else{
                    alert("未登录");
                }
            }));
        }
    });
});