define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "dijit/registry",
    "dojo/query",
    "dojo/_base/array"
],function(declare,base,registry,query,array){
    return declare("widgets.common._ReVillagerMixin",[base],{
        indexReVillagerElement:function(){
            this.inherited(arguments);
            this.hrgList = registry.byNode(query(".hrgList",this.domNode)[0]);
            this.mrgList = registry.byNode(query(".mrgList",this.domNode)[0]);
            this.zxgzList = registry.byNode(query(".zxgzList",this.domNode)[0]);
        },
        getItemPos:function(i){
            var appendClass = "";
            if((i+1)%4==0)
            {
                appendClass = "villagerRightItem";
            }
            return appendClass;
        },
        initReVillagerEvent:function(){
            this.inherited(arguments);
            this.connect(this.hrgList,"onDefRendered",function(data){
                var items = data.data.items;
                array.forEach(items,function(item,i){
                    // 如果行数/4的余数为0
                    //item.appendClass = this.getItemPos(i);
                    
                    item.appendClass = "";
                    if((i+1)%3==0){
                        item.appendClass = "margin-right:0;";
                    }
                    if(i>2){
                        item.appendClass += "margin-top:10px;";
                    }
                },this);
            });
            this.connect(this.mrgList,"onDefRendered",function(data){
                var items = data.data.items;
                array.forEach(items,function(item,i){
                    // 如果行数/4的余数为0
                    //item.appendClass = this.getItemPos(i);
                    item.appendClass = "";
                    if((i+1)%3==0){
                        item.appendClass = "margin-right:0;";
                    }
                    if(i>2){
                        item.appendClass += "margin-top:10px;";
                    }
                },this);
            });
            this.connect(this.zxgzList,"onDefRendered",function(data){
                var items = data.data.items;
                array.forEach(items,function(item,i){
                    // 如果行数/4的余数为0
                    //item.appendClass = this.getItemPos(i);
                    item.appendClass = "";
                    if((i+1)%3==0){
                        item.appendClass = "margin-right:0;";
                    }
                    if(i>2){
                        item.appendClass += "margin-top:10px;";
                    }
                },this);
            });
        },
        refreshAllList:function(){
            this.hrgList.refreshList();
            this.mrgList.refreshList();
            this.zxgzList.refreshList();
        }
    });
});