define([
    "dojo/_base/declare",
    "dojo/query",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dojo/dom-style",
    "../userInfo",
    "dijit/registry"],function(declare, query, lang, array, xhr, json, domStyle, userInfo, registry){
    return declare("widgets.common._RegisterMixin",null,{
        isRegisterLoaded:function(){
            return !!this.registClientRemark;
        },
        indexRegisterElement:function(){
            array.forEach(["registSCodeTitle","registSCode","registClientRemarkTitle","registClientRemark","registPhone","registFullNameTitle" ,"registFullName", "registSexTitle","registSex", "registAddr", "registPwd", "registPwdConfirmTitle", "registPwdTitle", "registPwdConfirm","registVCode", "frameNum", "engineNum", "registLicense", "getRegistVCodeBtn", "registSubmitBtn", "registLicenseTitle", "frameNumTitle", "engineNumTitle", "registAddrTitle","registAddrTitleACH","registAddrACH"], function(cls) {
                this[cls] = query("." + cls, this.domNode)[0];
            }, this);
        },
        refreshAllList:function(){
            if (window.titleNode) {
                window.titleNode.innerHTML = "会员资料";
            }
            if(g_sys_info.quickLogin){
                var pwd = this.randPassword();
                this.registPwd.value=pwd;
                this.registPwdConfirm.value=pwd;
                this.registPwd.style.display = "none";
                this.registPwdConfirm.style.display = "none";
                this.registPwdTitle.style.display = "none";
                this.registPwdConfirmTitle.style.display = "none";
            }
            if (g_sys_info.code.toUpperCase() == 'SVC10060') { //爱车会,隐藏地址
                this.registAddr.style.display = "none";
                this.registAddrTitle.style.display = "none";
                this.registLicenseTitle.style.display = "";
                this.registLicense.style.display = "";
                this.frameNumTitle.style.display = "";
                this.frameNum.style.display = "";
                this.engineNumTitle.style.display = "";
                this.engineNum.style.display = "";
                this.registAddrTitleACH.style.display = "";
                this.registAddrACH.style.display = "";
            } else { //否则显示地址,隐藏车牌相关
                this.registAddr.style.display = "";
                this.registAddrTitle.style.display = "";
                this.registLicenseTitle.style.display = "none";
                this.registLicense.style.display = "none";
                this.frameNumTitle.style.display = "none";
                this.frameNum.style.display = "none";
                this.engineNumTitle.style.display = "none";
                this.engineNum.style.display = "none";
                this.registAddrTitleACH.style.display = "none";
                this.registAddrACH.style.display = "none";
                
                //除爱车会的其他货主的注册页面都只保留手机号码、验证码和领取优惠券/代金券的序列号
                //隐藏地址
                //this.registAddr.style.display = "none";
                //this.registAddrTitle.style.display = "none";
                //隐藏性别
                //domStyle.set(this.registSexTitle,"display","none");
                //domStyle.set(this.registSex,"display","none");
                //隐藏姓名
                //domStyle.set(this.registFullNameTitle,"display","none");
                //domStyle.set(this.registFullName,"display","none");
            }
        },
        initRegisterEvent:function(){
            this.registSubmitBtn.onclick = lang.hitch(this, this.postRegister);
            this.connect(this.getRegistVCodeBtn, 'onclick', function() {
                var phone = this.registPhone.value;
                if (userInfo.validPhoneNumber(phone)) {
                    window.busy();
                    userInfo.checkUName(phone).then(lang.hitch(this, function(msg) { //检查用户名是否已可用
                        if (msg) {
                            if (confirm("您输入的手机号码已经注册，需要找回密码吗？")) {
                                window.moveToView("getPwd");
                            }
                            window.free();
                        } else {
                            window.sendMsg(phone).then(function() { //发送验证码
                                window.free();
                            });
                        }
                    }));
                } else {
                    alert("格式错误，请核对您输入的手机号码，它一般是以1开头的11位数字!");
                }
            });
        },
        randPassword: function() {
            var text = ['abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', '1234567890', '~!@#$%^&*()_+;,./?<>'];
            var rand = function(min, max) {
                return Math.floor(Math.max(min, Math.random() * (max + 1)));
            };
            var len = rand(6, 10); // 长度为6-10 
            var pw = '';
            for (i = 0; i < len; ++i) {
                var strpos = rand(0, 2);
                pw += text[strpos].charAt(rand(0, text[strpos].length));
            }
            return pw;
        },
        validRegisterInfo:function(info){
            if(this.registClientRemark&&this.registClientRemark.value){
                //客户填写的推荐人信息
                info.CLT_Remark = this.registClientRemark.value;
            }
            info.Mobile = info.Tel = info.Fax = info.OPENID;
            if (window.wxId) {
                info.WXID = window.wxId;
            }
            window.setOpenId(openId);
            if (!info.OPENID) {
                alert("请输入手机号！");
                return false;
            }
            if(!userInfo.validPhoneNumber(info.OPENID)){
                alert("格式错误，请核对您输入的手机号码，它一般是以1开头的11位数字!");
                return false;
            }
            if(!this.registVCode.value){
                alert("请输入验证码！");
                return false;
            }
            if(!info.ConsigneeName){//2014-11-19,刘,姓名应该必填
                alert("请输入姓名！");
                return false;
            }
            if (!info.DetailAddress && g_sys_info.code.toUpperCase() != "SVC10060") { //爱车会不检查地址
                alert("请输入地址!");
                return false;
            }
            if (!info.PWD) {
                alert("请输入密码！");
                return false;
            }
            if (info.PWD != this.registPwdConfirm.value) {
                alert("确认密码有误！");
                return false;
            }
        },
        postRegister: function() {
            var info = {
                "OPENID": this.registPhone.value,
                "ConsigneeName": this.registFullName.value, //姓名
                "Sex": this.registSex.value, //性别
                "DetailAddress": g_sys_info.code.toUpperCase() != "SVC10060"?this.registAddr.value:this.registAddrACH.value, //地址
                "PWD": this.registPwd.value, //密码
                "PLATE_NUM": (this.registLicense.value.replace(/[ ]/g, "")).toUpperCase(), //车牌号 替换字符中的空格\转大写
                "ENGINE_NUM": (this.engineNum.value.replace(/[ ]/g, '')),
                "FRAME_NUM": this.frameNum.value.replace(/[ ]/g, "") //车架号 替换字符中的空格
            };
            this.validRegisterInfo(info);
            if (info.OPENID && userInfo.validPhoneNumber(info.OPENID)) { //手机号合法性判断
                window.busy();
                window.postVerCode(info.OPENID, this.registVCode.value).then(lang.hitch(this, function(success) { //验证验证码
                    if (success) {
                        userInfo.regist(info).then(lang.hitch(this, function(success) {
                            if (success) {
                                // 清空注册信息
                                this.registPhone.value = "";
                                this.registFullName.value = "";
                                this.registPwd.value = "";
                                this.registPwdConfirm.value = "";
                                this.registVCode.value = "";
                                this.frameNum.value = "";
                                this.engineNum.value = "";
                                this.registLicense.value = "";
                                this.registAddr.value = "";
                                this.registAddrACH.value = "";
                                userInfo.onLogin(info.OPENID, info.PWD).then(lang.hitch(this,function() {
                                    if (window.wx_openId) {
                                       userInfo.bindWx();
                                    }
                                    //爱车会的爱心接力活动注册后跳转到活动页面。
                                    if(window.isInLove && window.wx_openId){
                                        window.moveToView("love",window.wx_openId);
                                    }else{
                                        window.moveToView(window.nextPageOnLogin||"user");
                                    }
                                    if(this.registSCode.value){
                                        xhr("POST", {
                                            url: "/w/user/useSn/" + window.code + "-" + window.openId,
                                            handleAs: "json",
                                            content: {
                                                sn:this.registSCode.value
                                            },
                                            load: lang.hitch(this, function(result) {
                                                if (1 === result.rtnType) {
                                                    alert(result.message);
                                                } else {
                                                    alert(result.message || "数据错误!");
                                                }
                                                this.registSCode.value = "";
                                            })
                                        });
                                    }else{
                                        this.registSCode.value = "";
                                    }
                                }));
                            } else {
                                alert("注册失败！");
                                window.free();
                            }
                        }));
                    } else {
                        window.free();
                    }
                }));
            } else {
                alert("格式错误，请核对您输入的手机号码，它一般是以1开头的11位数字!");
            }
        }
    });
});