define([
    "dojo/_base/declare",
    "dijit/registry",
    "../userInfo",
    "dojo/_base/lang",
    "dojo/query",
    "dojo/_base/json", 
    "dojo/_base/xhr"], function(declare,registry,userInfo,lang,query,json,xhr) {
    return declare("widgets.common._RepairMixin",null, {
        isRepairLoaded:function(){
            return !!this.repairSubmit;
        },
        refreshAllList: function() {
            this.inherited(arguments);
            window.updateTitle("报修");
            userInfo.hasLogin().then(lang.hitch(this,function(success){
                if(success){
                }else{
                    window.nextPageOnLogin = "repair";
                    // 若没有登录
                    userInfo.showLogin();
                }
            }));
            this.resize;
        },
        indexRepairElement: function() {
            this.inherited(arguments);
            this.repairSubmit = query(".repairSubmit")[0];
            this.repairReason = query(".repairReason")[0];
            this.repairRemark = query(".repairRemark")[0];
        },
        initRepairEvent:function(){
            this.inherited(arguments);
            this.connect(this.repairSubmit,"onclick",this.postRepair);
        },
        postRepair:function(){
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    if(this.repairReason.value==-1){
                        alert("请先选择维修项目。");
                        return;
                    }
                    xhr("POST", {
                        url: "../../data/update/"+window.code+"-"+window.openId+"?token="+window.userInfo.token,
                        handleAs: "json",
                        content:{
                            data:json.toJson({
                                modalName:"XSY_TSCSF_WB",
                                data:[{
                                    n:{
                                        CLIENT:userInfo.getUserInfo().partnerId,
                                        TYPEID:1,
                                        REPAIRTYPE:this.repairReason.value,
                                        REMARK:this.repairRemark.value
                                    }
                                }]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                alert("报修成功。");
                                window.free();
                                this.repairRemark.value = "";
                                this.repairReason.value = -1;
                            } else {
                                alert(result.message || "数据错误!");
                                this.repairRemark.value = "";
                                this.repairReason.value = -1;
                                window.free();
                            }
                        })
                    });    
                }else{
                    alert("请先登录");
                }
            }));
        }
    });
});