define([
    "dojo/_base/declare", 
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/query",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom-style",
    "widgets/userInfo",
    "dojo/dom-construct",
    "dojo/cookie",
], function(declare, registry,domAttr,query,array,lang,domStyle,userInfo,domConstruct,cookie) {
    return declare("widgets.common._SearchMatMixin",null,{
        isSearchMatLoaded:function(){
            return !!this.searchDiv;
        },
        refreshAllList:function(){
            //this.searchDiv.refreshList();
        },
        indexSearchElement:function(){
            this.inherited(arguments);
            this.SearchBtn=query(".searchBtn",this.domNode)[0];//搜索按钮
            this.SearchTxt=query("#searchTxt",this.domNode)[0];//搜索内容
            this.SearchHistory=query("#lastSearch_name",this.domNode)[0];//搜索历史框
            this.searchHistoryDiv=query(".lastSearch_body",this.domNode)[0];//搜索历史DIv
            this.HotSearch=query(".hotSearch_name",this.domNode)[0];//热门搜索
            this.clearSearch=query(".lastSearch_clear",this.domNode)[0];//清除记录
        },
        iniSearchEvent:function(){
            this.inherited(arguments);
            this.refresh();
            var history='';
            if(localStorage.getItem("SearchHistory"))
            {
                history=localStorage.getItem("SearchHistory");
            }
            else{
                domStyle.set(this.searchHistoryDiv,{"display":"none"});
            }
            this.connect(this.SearchBtn,"onclick",function(){//搜索按钮点击事件
                if(this.SearchTxt.value=="")
                {
                    return false;
                }
                if(window.localStorage){//记录搜索历史
                    if(localStorage.getItem("SearchHistory"))
                    {
                        history=localStorage.getItem("SearchHistory");
                        history+=","+this.SearchTxt.value;
                    }
                    else{
                        history=this.SearchTxt.value;
                    }
                    localStorage.setItem("SearchHistory",history);
                }else{
                  cookie("SearchHistory",this.SearchTxt.value);
                }
                //window.search=this.SearchTxt.value;
                alert(this.SearchTxt.value);
                cookie("SearchHistory",this.SearchTxt.value);
                window.moveToView("matList",window.did);//转到搜索页面
            });
            //点击搜索记录事件
            this.connect(query("#lastSearch_name",this.domNode)[0],"onclick",function(e){
                var dom=e.target;
                if(dom){
                    cookie("SearchHistory",dom.innerHTML);
                    alert(dom.innerHTML);
                    window.moveToView("matList",window.did);//转到搜索页面
                }
            });
            //清除搜索记录
            this.connect(this.clearSearch,"onclick",function(){
                localStorage.removeItem("SearchHistory");
                domStyle.set(this.searchHistoryDiv,{"display":"none"});
            });
            this.connect(query(".lastSearch",this.domNode)[0],"onclick",function(){
                domStyle.set(query(".hotSearch_body",this.domNode)[0],{"display":"none"});
                domStyle.set(query(".lastSearch_line",this.domNode)[0],{"border-bottom-color":"#e5004f"});
                domStyle.set(query(".hotSearch_line",this.domNode)[0],{"border-bottom-color":"#8b8b8b"});
                if(localStorage.getItem("SearchHistory")){
                    domStyle.set(query(".lastSearch_body",this.domNode)[0],{"display":"block"});    
                };
                
            });
            this.connect(query(".hotSearch",this.domNode)[0],"onclick",function(){
                domStyle.set(query(".hotSearch_body",this.domNode)[0],{"display":"block"});
                domStyle.set(query(".lastSearch_body",this.domNode)[0],{"display":"none"});
                domStyle.set(query(".lastSearch_line",this.domNode)[0],{"border-bottom-color":"#8b8b8b"});
                domStyle.set(query(".hotSearch_line",this.domNode)[0],{"border-bottom-color":"#e5004f"});
               
            });
            
        },
        initData: function() {
            if (this.isSearchMatLoaded()) {
               // this.refreshAllList();
                window.free();
            };
            this.inherited(arguments);
            window.updateTitle("搜索商品");
            this.centerPane.scrollTo({
                x: 0,
                y: 0
            });
            if(this.SearchHistory){
                this.refresh();
            }
        },
        refresh:function(){
            if(localStorage.getItem("SearchHistory")){
                //显示搜索记录
                domConstruct.empty(this.SearchHistory);
                var histories=localStorage.getItem("SearchHistory").split(",");
                for(i=histories.length-1;i>=0;i--)
                {
                    if(histories.length-i==10)//最多记录10条记录
                    {
                        break;
                    };
                    this.SearchHistory.innerHTML+="<div id='lastSearch_names'>"+histories[i]+"</div>";
                };
                domStyle.set(this.searchHistoryDiv,{"display":"block"});
            };
        }
    });
});