define([
    "dojo/_base/declare",
    "../userInfo",
    "dojo/query",
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojo/dom-style"],function(declare,userInfo,query,registry,domAttr,xhr,json,lang,domStyle){
    return declare("widgets.common._ShowCommentMixin",null,{
        isShowCommentLoaded:function(){
            return !!this.commented;
        },
        indexShowCommentElement:function(){
            this.commented=registry.byId("commented");
            //评论发表按钮
            this.comment_btn=query("#comment_btn",this.domNode)[0];
            //评论的内容
            this.W_input = query(".W_input", this.domNode)[0];
        },
        refreshAllList:function(){
            if(window.titleNode) window.titleNode.innerHTML="评论";
            domAttr.set(this.comment_btn, "class", "WB_publish_Button_b");
            this.commented.refreshList();
        },
        initShowCommentEvent:function(){
            this.connect(this.comment_btn, "onclick", function(){
                var did=window.did;
                this.comment_con(did);
            });
            this.connect(this.W_input,"onkeyup",function(){
                if(this.W_input.value){
                    domAttr.set(this.comment_btn, "class", "WB_publish_Button");
                }else{
                    domAttr.set(this.comment_btn, "class", "WB_publish_Button_b");
                }
            });
        },
        //评论数据
        comment_con: function(did) {
            window.busy();
            //重新获取客户信息
            userInfo.hasLogin().then(lang.hitch(this, function(s) {
                if (s) {
                    //取旅行记录数量
                    var num = 0;
                    window.loadData({
                        modalName: "XSY_TCRMK_TRAVDTS", //旅行记录
                        filter: "05",
                        pageSize: "1",
                        pageIndex: "1",
                        param: {
                            "DID": did
                        }
                    }).then(lang.hitch(this, function(a) {
                        //如果取到对应的记录
                        if (a.length) {
                            //设置变量num的值为旅行记录的评论数量
                            num = parseFloat(a[0].COM_NUM || 0);
                        } else {
                            //否则设置为0
                            num = 0;
                        }
                        //定义新的变量
                        var d = new Date(), //当前时间
                            data = {
                                n: {
                                    "CONTENT": this.W_input.value, //评论内容
                                    "RID": "XSY_TCRMK_TRAVDTS", //评论的资源
                                    "RIID": did, //评论的资源的主键
                                    "PID": userInfo.getUserInfo().partnerId, //评论的客户
                                    "OPENID": window.wx_openId
                                }
                            }, //提交评论的数据
                            data1 = {
                                n: {
                                    COM_NUM: num + 1
                                },
                                o: {
                                    "DID": did
                                }
                            }; //修改评论数量的数据
                        //拼写当前时间
                        d = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds();
                        //如果没有填写评论内容
                        if (data["n"].CONTENT === "") {
                       //     alert("请输入评论内容");
                            window.free();
                        } else {
                            data["n"].MKDT = d; //评论时间
                            //提交评论
                            this.postCom(data, data1, did);
                        }
                    }));
                }
                //未登录时提示客户先登录
                else {
                    alert("请先登录");
                    window.free();
                }
            }));
        },
        //提交评论
        postCom: function(data, data1, did) {
            //评价内容提交
            xhr("POST", {
                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    data: json.toJson({
                        modalName: "APP_TBSAV_CMMNT",
                        data: [data]
                    })
                },
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        this.W_input.value="";
                        domAttr.set(this.comment_btn, "class", "WB_publish_Button_b");
                        this.commented.refreshList();
                        window.free();
                    } else {
                        alert(result.message || "数据错误!");
                        window.free();
                    }
                })
            });
            //修改旅行记录中评论数量
            xhr("POST", {
                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    data: json.toJson({
                        modalName: "XSY_TCRMK_TRAVDTS",
                        data: [data1]
                    })
                }
            });
        },
    });
});