define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dijit/registry",
    "dojo/query",
    "cqthink/app/plugins/geolocation",
    "dojo/dom-attr",
    "dojo/dom-style",
     "dojo/dom-class",
    "dojo/_base/array"
    ], function(declare, lang, Deferred, registry, query, location, domAttr, domStyle,domClass, array) {
    return declare("widgets.common._SrvList_sjmdMixin", null, {
        svcListOrderDef: false,
        defaultflt:"01",
        srvMatOrder:"",
        isSrvListLoaded: function() {
            return !!this.srvMatList;
        },
         refreshAllList: function() {
             /*  服务列表参数详解
             
                APPID:商家ID、平台ID、门店ID
                INPUT：商家名称、门店名称、商品名称
                childMGID:商品、平台二级分类
                parentMGID：商品、平台父级分类
                T_P：省
                T_C：市
                T_X：区
                BIZID：商圈
                DISTANCE：距离
                LAT：纬度
                LNG：经度
                IS_CX：促销
                IS_TG：团购
                TPCH_NUM：限购
                
             */
             this.bigParam={"APPID":"","INPUT":"","childMGID":"","parentMGID":"","T_P":"","T_C":"","T_X":"","BIZID":"","DISTANCE":"","LAT":"","LNG":"","IS_CX":"","IS_TG":"","TPCH_NUM":""};
             this.bigParam.T_C=localStorage.cityID||"";
             AMap.service('AMap.Geocoder',function(){//回调函数
                window.geocoder = new AMap.CitySearch({
                    //city:城市区号，默认：“全国”
                });
            })
             //获取当前位置信息
            this.getPosition();
            window.loadData({
                modalName: "XSY_TSSCF_APP2",
                filter: "09",
                pageSize: "100",
                pageIndex: "1",
                param: {
                    AID:window.g_sys_info.aid
                } 
            }).then(lang.hitch(this,function(data){
                var groupID="";
                this.IsPlatform=data[0].APP_ID==data[0].PLATFORM;
                this.did = window.did;
                if(this.IsPlatform){
                    groupID=window.g_sys_info.aid;               //取平台分类ID
                    if(window.did==""){                          //平台不带参数
                        this.defaultflt="01";
                        this.bigParam.APPID=window.g_sys_info.aid;
                    }
                    else if(window.did.indexOf('aid_')>-1){      //平台带门店ID参数
                        this.did = window.did;
                        var aid=window.did.split("_")[1];
                        this.bigParam.APPID=aid;
                        this.defaultflt="02";
                    }else if(window.did.indexOf('child')>-1){     //平台带二级级分类ID
                        this.defaultflt="01";
                        this.bigParam.APPID=window.g_sys_info.aid;
                        this.bigParam.childMGID=window.did;
                    }
                    else{                                         //平台带一级分类ID
                        this.defaultflt="01";
                        this.bigParam.APPID=window.g_sys_info.aid;
                        this.bigParam.parentMGID=window.did;
                    }
                }
                else{
                    groupID=window.g_sys_info.aid;               //取商家分类ID
                    if(window.did==""){                          //商家不带参数
                        this.defaultflt="03";
                        this.bigParam.APPID=window.g_sys_info.aid;
                    }
                    else if(window.did.indexOf('aid_')>-1){      //商家带门店ID参数
                        this.did = window.did;
                        var aid=window.did.split("_")[1];
                        this.bigParam.APPID=aid;
                        this.defaultflt="04";
                    }else if(window.did.indexOf('child_')>-1){    //平台带二级分类ID
                        this.defaultflt="03";
                        this.bigParam.APPID=window.g_sys_info.aid;
                        this.bigParam.childMGID=window.did;
                    }
                    else{                                        //平台带一级分类ID
                        this.defaultflt="03";
                        this.bigParam.APPID=window.g_sys_info.aid;
                        this.bigParam.parentMGID=window.did;
                    }
                }
                
                //刷新服务列表
                this.myRefreshList("("+JSON.stringify(this.bigParam)+")",this.srvMatOrder,this.defaultflt)
                
                //刷新商品分类
                this.matGroup.rs_wb_param = "({AID:"+groupID+"})";
                this.matGroup.refreshList();
                
                //刷新行政区
                this.districtList.rs_wb_param="({DID:"+localStorage.cityID+"})";
                this.districtList.refreshList();
                
                //刷新热门商圈
                this.hotArea.rs_wb_param="({D_C:"+localStorage.cityID+"})";
                this.hotArea.refreshList();
                
            }));
            
            
            
            
        },
        myRefreshList:function(param,order,flt){
            this.srvMatList.rs_wb_param=param;
            this.srvMatList.rs_wb_order=order||this.srvMatList.rs_wb_order;
            this.srvMatList.rs_wb_flt=flt||this.srvMatList.rs_wb_flt;
            this.scrollTo({x:0,y:0});
            window.busy();
            this.srvMatList.refreshList();
            window.free();
            this._closeNavDropDownItem();
        },
        indexSrvListElement: function() {
           // if(isSrvListLoaded){
            var head=query(".m-list-1",this.domNode)[0];
            var search=query(".m-list-0",this.domNode)[0];
            this.shelfHeader=query(".shelfHeader",this.domNode)[0];
            this.SearchTxt=query(".searchExpert",this.domNode)[0];                        //搜索
            
            this.shelfHeader.appendChild(search);
            this.shelfHeader.appendChild(head);
            var show=query(".locationText",this.domNode)[0];
            this.shelfHeader.appendChild(show);
            
            this.srvMatList=registry.byId("srvMatList",this.domNode); //得到服务列表节点
            
            this.matGroup=registry.byId("MatGroup",this.domNode);   //得到商品分类的节点
            this.districtList=registry.byId("districtList",this.domNode); //区域节点
            this.hotArea=registry.byId("hotArea",this.domNode); //热门商圈
            this.subAreaScroll=query("#subAreaScroll",this.domNode)[0];           //二级菜单
            //}
            
            this.topUl=query("#topUl",this.domNode)[0];  //顶部UL
            this.topUl_li=query("li",this.topUl);        //顶部li
            this.nav_dropdown_items = query(".nav_dropdowm_item", this.domNode);
            this.nav_dropdowm = query(".nav_dropdowm", this.domNode)[0];
            this.nav_dropdownbg = query(".nav_dropdownbg", this.domNode)[0];
            
            this.childMG=registry.byId("ChildMG",this.domNode);   //得到商品二级节点
            this.orderDiv=registry.byId("orderUl",this.domNode);  //得到商品排序节点
            this.districtBIZD=registry.byId("districtBIZD",this.domNode);   //行政区商圈
            this.pointType=registry.byId("pointType",this.domNode);  //得到商品类型的节点
 
        },
        initSvcListEvent: function() {
            
            //顶部菜单的点击事件
            this.connect(this.topUl.domNode,"onclick",lang.hitch(this,this._navUlClicked));
            
            //商品分类数据加载完成
            this.connect(this.matGroup,"onDefRendered",function(data){
               var indexAid=window.did.indexOf('aid_')||-1;
                if(data&&data.data&&data.data.items){
                    //初始化二级分类信息
                    this._groupHash = {};
                    var len = data.data.items.length;
                    data.data.items.isBeSelected=0;
                    
                    while(len--){
                        data.data.items[len].selected=0;
                        //遍历所有分类
                        
                        if(indexAid==-1&&window.did!=""&&(((data.data.items[len].MGID==this.bigParam.parentMGID||data.data.items[len].MGID==this.bigParam.childMGID)&&window.historys)||(data.data.items[len].MGID==window.did&&!window.historys)))
                        {
                            //设置首页进入的分类名称
                            query("#topUl li",this.domNode)[1].innerText=data.data.items[len].MGName;
                            data.data.items[len].selected=1;
                            data.data.items.isBeSelected=1;
                            //this.cate_id=data.data.items[len].MGID;
                            
                        }
                        //若是二级分类
                        if(data.data.items[len].UpLevelMGID.MGID){
                            this._groupHash[data.data.items[len].UpLevelMGID.MGID] = this._groupHash[data.data.items[len].UpLevelMGID.MGID]||[];
                            //将本分类添加到二级分类信息中
                            this._groupHash[data.data.items[len].UpLevelMGID.MGID].push(data.data.items[len]);
                            //将当前分类从加载到的分类信息中删除
                            data.data.items.splice(len,1);
                        }
                    }
                    this.childMG.onDataReady({
                        data:{items:this._groupHash[this.cate_id]||[]}
                    });
                }
            });
            
            //商品一级分类点击事件 
            this.connect(this.matGroup.domNode,"onclick",function(event){
                if(event&&event.target&&event.target.tagName=="LI"){
                    var str=domAttr.get(event.target,"cate_id");
                    
                    if(str)
                    {
                        array.forEach(dojo.query("#MatGroup li",this.domNode),function(item){
                            if (domClass.contains(item, "beSelected")){
                                domClass.remove(item,"beSelected");
                            }
                            domClass.remove(item,"cur");
                            domStyle.set(item,{"border-top":"0px"});
                        });
                        domClass.add(event.target,"beSelected");
                        //domStyle.set(event.target,{"border-top":"1px solid white"});
                        if(str=="0")
                        {
                            str="";
                        }
                        window.dids=str;
                        //加载二级分类信息
                        if(this._groupHash[str]){
                            this.childMG.onDataReady({
                                data:{items:this._groupHash[str]}
                            });
                            var firstNode=query("#ChildMG li",this.domNode)[0];
                            if(firstNode)
                            {
                                domAttr.set(firstNode,"mgName",event.target.innerText);
                                domAttr.set(firstNode,"cate_id_all",str);
                            }
                        }else{
                            //刷新商品列表的数据
                            query("#topUl li",this.domNode)[0].innerText=event.target.innerText+" ";
                            
                            //清空参数信息
                            this.bigParam.parentMGID=str;
                            this.bigParam.childMGID='';
                            this.myRefreshList("("+JSON.stringify(this.bigParam)+")",this.matOrder);
                            this.childMG.onDataReady({   //清空二级分类信息
                                data:{items:[]}
                            });
                        }
                    }
                }
                event.stopPropagation();
            });
            
            //二级分类点击事件
            this.connect(this.childMG.domNode,"onclick",function(event){
                if(event&&event.target&&event.target.tagName=="LI"){
                    var str=domAttr.get(event.target,"cate_id");
                    array.forEach(dojo.query("li",this.childMG.domNode),function(item){
                        if (domClass.contains(item, "beSelected")){
                            domClass.remove(item,"beSelected");
                        }
                        //domClass.remove(item,"cur");
                        //domStyle.set(item,{"border-top":"0px"});
                    });
                    domClass.add(event.target,"beSelected");
                    if(str)
                    { 
                        
                        
                        //传入二级分类ID刷新list（点击二级分类）
                        query("#topUl li",this.domNode)[0].innerText=event.target.innerText+" ";
                            
                        //清空参数信息
                        this.bigParam.parentMGID='';
                        this.bigParam.childMGID=str;
                        this.myRefreshList("("+JSON.stringify(this.bigParam)+")",this.matOrder);
                    }
                    else
                    {
                        var cate_id_all=domAttr.get(event.target,"cate_id_all");
                        if(cate_id_all){
                            //传入一级分类ID刷新list（点击全部）
                            this.bigParam.childMGID='';
                            this.bigParam.parentMGID=cate_id_all;
                            this.myRefreshList("("+JSON.stringify(this.bigParam)+")",this.srvMatOrder,this.defaultflt)
                            var mgName=domAttr.get(event.target,"mgName");
                            if(mgName){
                                 query("#topUl li",this.domNode)[0].innerText=mgName+" ";
                            }
                        }
                    }
                }
                event.stopPropagation();
            });
            
            //子菜单空白区域点击事件
            this.connect(this.nav_dropdownbg, "onclick", lang.hitch(this, this._closeNavDropDownItem));
            
            //商品行政区点击事件
            this.connect(this.districtList.domNode,"onclick",function(evt){
                var dom = evt.target;
                if(dom.tagName=="LI")
                {
                    var fujin=domAttr.get(dom,"fujin");
                    var hArea=domAttr.get(dom,"hotarea");
                    var areaId=domAttr.get(dom,"areaid");
                    var dropIndex=parseInt(domAttr.get(dom,"dropindex"));
                    
                    var secondMenuList=query("ul",query("#subAreaScroll",this.domNode)[0]);
                    
                    //隐藏所有二级显示菜单
                    array.forEach(secondMenuList,function(item,index){
                        if(dropIndex==index){
                            domStyle.set(secondMenuList[index],{display:"block"})
                        }
                        else{
                            domStyle.set(secondMenuList[index],{display:"none"})
                            array.forEach(query("li",secondMenuList[index]),function(item){
                                domClass.remove(item,"beSelected");
                            });
                        }
                    });
                    registry.byId("subAreaScroll").scrollTo({x:0,y:0});
                    if(fujin=="1"){         //附近   一级
                       //domAttr.set(query("li",this.districtBIZD.domNode)[0],"t_c",areaId);
                    }
                    else if(hArea=="1"){   //热门商圈   一级
                        domAttr.set(query("li",this.hotArea.domNode)[0],"cityBzid",this.cityId);
                    }
                    else if(areaId!=""){   //行政区   一级
                        if(this._groupHashArea[areaId]){
                            this.districtBIZD.onDataReady({
                                data:{items:this._groupHashArea[areaId]}
                            });
                        }
                        domAttr.set(query("li",this.districtBIZD.domNode)[0],"t_c",areaId);
                    }
                    
                    array.forEach(query("ul>li",this.districtList.domNode),function(item){
                         domClass.remove(item, "beSelected");
                         domClass.remove(item,"cur");
                         domStyle.set(item,{"border-top":"0px"});
                    });
                    domAttr.set(dom,"class","beSelected");
                    domClass.add(event.target,"cur");
                    domStyle.set(event.target,{"border-top":"1px solid white"})
                    evt.stopPropagation();  //阻止事件冒泡
                }
            });
            
            //返回的全部商圈
            this.connect(this.hotArea,"onDefRendered",function(data){
                if(data&&data.data&&data.data.items){
                    //初始化行政区商圈信息
                    this._groupHashArea = {};
                    var hotBizd=[];
                    var len = data.data.items.length;
                    while(len--){        //遍历所有商圈
                        this._groupHashArea[data.data.items[len].UpDistID.DistID] = this._groupHashArea[data.data.items[len].UpDistID.DistID]||[];
                        //将本商圈添加到行政区商圈信息中
                        this._groupHashArea[data.data.items[len].UpDistID.DistID].push(data.data.items[len]);
                    }
                   //前10商圈
                    data.data.items.splice(10,data.data.items.length-10);
                }
            });
            
            //活动商品的筛选
            this.connect(this.pointType.domNode,"onclick",function(event){
               // if(event&&event.target&&event.target.tagName=="LI"){
                    var cancel=domAttr.get(event.target,"myCancel");
                    var complete=domAttr.get(event.target,"myComplete");
                    var dom=event.target;
                    while(dom!=this.pointType.domNode){
                        if(dom.tagName=="LI"){
                            break;
                        }
                        dom=dom.parentNode;
                    }
                    if(event&&dom&&dom.tagName=="LI")
                    {
                        //设置选中样式
                        var check=query(".divCheckbox",dom)[0];
                        domClass.toggle(check, "divInput");
                        if(domClass.contains(check, "divInput")){
                            domStyle.set(check,{backgroundColor:"#e5004f"});
                        }
                        else{
                            domStyle.set(check,{backgroundColor:"white"});
                        }
                    }
                    var checkList=query("div.divInput",dom.parentNode);
                    if(cancel){   //重置
                        //清空选中
                        array.forEach(checkList,function(item){
                            domClass.remove(item,"divInput");
                            domStyle.set(item,{backgroundColor:"white"});
                        });
                        this.bigParam.TPCH_NUM="";   
                        this.bigParam.IS_CX="";   
                        this.bigParam.IS_TG="";  
                        this.bigParam.SERVICE_TYPE="";
                        this.myRefreshList("("+JSON.stringify(this.bigParam)+")",this.matOrder);
                    }
                    else if(complete){   //完成
                        this.bigParam.TPCH_NUM="";   
                        this.bigParam.IS_CX="";   
                        this.bigParam.IS_TG="";  
                        this.bigParam.SERVICE_TYPE="";
                        array.forEach(checkList,lang.hitch(this,function(item){
                            var T0_TPCH_NUM=domAttr.get(item.parentNode,"T0_TPCH_NUM");
                            var myCx=domAttr.get(item.parentNode,"IS_CX");
                            var IS_TG=domAttr.get(item.parentNode,"IS_TG");
                            var ServiceType=domAttr.get(item.parentNode,"ServiceType");
                            if(T0_TPCH_NUM){
                                this.bigParam.TPCH_NUM=T0_TPCH_NUM;
                            }
                            else if(myCx){
                                this.bigParam.IS_CX=myCx;
                            }
                            else if(IS_TG){
                                this.bigParam.IS_TG=IS_TG;
                            }
                            else if(ServiceType){
                                this.bigParam.SERVICE_TYPE=ServiceType;
                            }
                        }));
                        this.myRefreshList("("+JSON.stringify(this.bigParam)+")",this.matOrder);
                    }
                     event.stopPropagation();
                //}
            })
            
             //搜索框的ENTER事件
            this.connect(this.SearchTxt,"onkeydown",function(e){
                if(e.keyCode==13){
                    this.searchEvent();
                }
            });
            
            //取消搜索
            if(query(".cancel",this.domNode)&&query(".cancel",this.domNode)[0])
            {
                this.connect(query(".cancel",this.domNode)[0],"onclick",lang.hitch(this,function(){
                    this.SearchTxt.value="";
                    this.bigParam.INPUT="";
                    this.myRefreshList("("+JSON.stringify(this.bigParam)+")",this.srvMatOrder,this.defaultflt)
                }));
            }
           
            //点击搜索关闭导航菜单
            this.connect(this.SearchTxt,"onclick",function(){
                this._closeNavDropDownItem();
            });
            
            //服务商品的数据加载完成事件
            this.connect(this.srvMatList, "onDefRendered", function(data) {
                if(!window.did||window.did.indexOf("aid_")>-1){
                    this.mGroupName = "服务列表";                        //界面标题更改
                }
                //规范数据中 T0_TPCH_NUM (限购) 的值
                for(var i=0;i<data.data.items.length;i++)
                {
                    //限购，，取小数点前的数字
                    if(data.data.items[i].MTID==""){
                        data.data.items[i].TPCH_NUM=data.data.items[i].TPCH_NUM.substring(0,data.data.items[i].TPCH_NUM.indexOf('.',0))||0;
                    }
                  /*  array.forEach(data.data.items,function(item,i){
                       
                    });*/
                }
            });
            
             //二级菜单
            this.connect(this.subAreaScroll,"onclick",lang.hitch(this,function(event){
                var dom=event.target;
                if(dom.tagName=="LI")
                {
                    var area_distance=domAttr.get(dom,"area_distance");
                    var cityBzid=domAttr.get(dom,"cityBzid");
                    var t_c=domAttr.get(dom,"t_c");
                    var districtId=domAttr.get(dom,"districtId");
                    //更改顶部菜单的文字
                    query(".srvTopUL>li",this.domNode)[1].innerText=dom.innerText+" ";
                    if(area_distance&&area_distance!=""){        //距离500米，1000米... 
                        this.bigParam.DISTANCE="";
                        if(area_distance!="fujin"){
                            this.bigParam.DISTANCE=area_distance;
                        }
                        this.bigParam.T_X="";
                        this.bigParam.BIZID="";
                        
                        this.myRefreshList("("+JSON.stringify(this.bigParam)+")",this.srvMatOrder,this.defaultflt);
                    }
                    else if(cityBzid&&cityBzid!=""){            //全部  热门商圈
                        this.bigParam.DISTANCE="";
                        this.bigParam.BIZID="";
                        this.bigParam.T_X="";
                        this.myRefreshList("("+JSON.stringify(this.bigParam)+")",this.srvMatOrder,this.defaultflt);
                    }
                    else if(t_c&&t_c!=""){                     //全部  行政区商圈
                        //更改菜单栏标题
                        query(".srvTopUL>li.beSelected",this.domNode)[0].innerText=query("ul>li.beSelected",query("#districtList",this.domNode)[0])[0].innerText+" ";
                        this.bigParam.DISTANCE="";
                        this.bigParam.T_X=t_c;
                        this.bigParam.BIZID="";
                        this.myRefreshList("("+JSON.stringify(this.bigParam)+")",this.srvMatOrder,this.defaultflt);
                    }
                    else if(districtId&&districtId!=""){        //商圈
                        this.bigParam.BIZID=districtId;
                        this.bigParam.DISTANCE="";
                        var dis=domAttr.get(query("li",dom.parentNode)[0],"t_c");
                        this.bigParam.T_X=dis||"";
                        this.myRefreshList("("+JSON.stringify(this.bigParam)+")",this.srvMatOrder,this.defaultflt);
                    }
                    array.forEach(query("li",dom.parentNode),function(item){
                        domClass.remove(item, "beSelected");
                    });
                   domAttr.set(dom,"class","beSelected");
                   this._closeNavDropDownItem();
                }
            }));
            
            //显示定位信息
            this.connect(query(".location",this.domNode)[0],"onclick",function(event){
                query(".locationText>p.show",this.domNode)[0].innerText="正在定位...";
                domStyle.set(query(".locationText>p.location",this.domNode)[0],{display:"none"});
                this.getPosition();
                event.stopPropagation(); 
            });
            
            //商品排序点击事件
            this.connect(this.orderDiv.domNode,"onclick",function(event){
                if(event&&event.target&&event.target.tagName=="LI"){
                    var wborder=domAttr.get(event.target,"wborder");
                    if(wborder=="DISTANCE")
                    {
                        if(window.position&&window.position.coords){
                            var str="DBO.fnGetDistance(ISNULL([T0_D_LAT],0),ISNULL([T0_D_LON],0),"+window.position.coords.latitude+","+window.position.coords.longitude+")";
                            this.myRefreshList("("+JSON.stringify(this.bigParam)+")",str);
                            this.srvMatOrder=str;
                        }
                    }
                    else if(wborder){
                        this.myRefreshList("("+JSON.stringify(this.bigParam)+")",wborder);
                        this.srvMatOrder=wborder;
                    }
                    query("#topUl li",this.domNode)[2].innerText=event.target.innerText;
                }
                event.stopPropagation(); 
            });
            
        },
       
       _navUlClicked:function(e){
            var dom = e.target;
            
            // 判断事件源是否是导航栏前4个li元素
            if(dom.tagName === "LI" && !domClass.contains(dom, "beSelected") && !domClass.contains(dom, "changeViewLi")){
                
                // 先清除上次点击的li元素的beSelected类
                array.forEach(this.topUl_li, function(nthLi){
                    domClass.remove(nthLi, "beSelected");
                });
                
                // 为当前事件源添加beSelected
                domClass.add(dom, "beSelected");
                
                // 隐藏上一次显示的div，并显示本次事件源所对应的div
                array.forEach(this.nav_dropdown_items, function(item, index){
                    if(index == domAttr.get(dom,"dropindex")){
                        domStyle.set(item,{display:"block"});
                    }else{
                        domStyle.set(item,{display:"none"});
                    }
                });
                domStyle.set(this.nav_dropdownbg, {display: "block"});
                domStyle.set(this.nav_dropdowm, {display: "block"});
            }
       },
        _clearUlStyle:function(){
            query("#topUl li",this.domNode)[2].innerText="默认排序 ";
            query("#topUl li",this.domNode)[3].innerText="筛选 ";
            
            //清空样式信息
            var orde=query(".smartSort li.beSelected",this.domNode)[0];
            var flit=query(".nav_dropdowm_item_slider li.beSelected",this.domNode)[0];
            if(orde){
                 domClass.remove(orde,"beSelected");
            }
            if(flit){
                domClass.remove(flit,"beSelected");
            }
        },
        // 关闭弹出层方法
        _closeNavDropDownItem:function(itemIndex){
            domStyle.set(this.nav_dropdowm, {display:"none"});
            domStyle.set(this.nav_dropdownbg, {display:"none"});
            array.forEach(this.topUl_li, function(nthLi){
                domClass.remove(nthLi, "beSelected");
            });
        },
        searchEvent:function(){
            this.bigParam.INPUT=this.SearchTxt.value;
            this.myRefreshList("("+JSON.stringify(this.bigParam)+")",this.srvMatOrder,this.defaultflt);
        },
        //定位
        getPosition:function(){
            location.getCurrentPositionQuiet().then(lang.hitch(this,function(data){
               //是否定位成功
                var isPosition=false;
                if (data.coords) {
                       window.position=data;
                       if(window.position&&window.position.coords){
                            //alert(window.position.coords.latitude+","+window.position.coords.longitude);
                            var str="DBO.fnGetDistance(ISNULL([D_LAT],0),ISNULL([D_LON],0),"+window.position.coords.latitude+","+window.position.coords.longitude+")";
                            this.myRefreshList("("+JSON.stringify(this.bigParam)+")",str+","+this.srvMatOrder,this.defaultflt);
                            query(".locationText>p.show",this.domNode)[0].innerText="定位成功";
                            domStyle.set(query(".locationText>p.location",this.domNode)[0],{display:"inline"});
                            isPosition=true;
                            if(window.geocoder){
                                this.getAddressInfo();
                            }
                       }
                }else{
                    isPosition=false;
                    switch(data.status){
                        case "unknown":
                            if(!parseInt(sessionStorage.getItem("asked"))){
                                alert("暂时无法获取您的位置!");
                            }
                            break;
                        case "cancel":
                            if(!parseInt(sessionStorage.getItem("asked"))){
                                alert("您阻止了定位!");
                            }
                            break;
                        case "timeout":
                            if(!parseInt(sessionStorage.getItem("asked"))){
                                alert("获取位置超时!");
                            }
                            break;
                    }
                    query(".locationText>p.show",this.domNode)[0].innerText="定位失败，";
                    domStyle.set(query(".locationText>p.location",this.domNode)[0],{display:"inline"});
                }
                return isPosition;
            }));
        },
        getAddressInfo:function(){
             query(".locationText>p.show",this.domNode)[0].innerText="正在获取地址...";
            //逆地理编码
            //alert(window.position.coords.longitude+","+window.position.coords.latitude)
            var lnglatXY=[window.position.coords.longitude,window.position.coords.latitude];
            if(window.geocoder){
                geocoder.getAddress(lnglatXY, function(status, result) {
                    if (status === 'complete' && result.info === 'OK') {
                       query(".locationText>p.show",this.domNode)[0].innerText=result.regeocode.formattedAddress;
                       domStyle.set(query(".locationText>p.location",this.domNode)[0],{display:"inline"});
                    }else{
                       //获取地址失败
                       query(".locationText>p.show",this.domNode)[0].innerText="定位失败,";
                       domStyle.set(query(".locationText>p.location",this.domNode)[0],{display:"inline"});
                    }
                }); 
            }
        }
    })
});