define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dijit/registry",
    "dojo/query",
    "cqthink/app/plugins/geolocation",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/_base/array"
    ], function(declare, lang, Deferred, registry, query, geolocation, domAttr, domStyle, array) {
    return declare("widgets.common._SvcListMixin", null, {
        svcListOrderDef: false,
        isSvcListLoaded: function() {
            return !!this.svcList1;
        },
        indexSvcListElement: function() {
            this.search_name = query("#search_name", this.domNode)[0];
            this.btn_search = query(".btn-search", this.domNode)[0];
            this.svcList1 = registry.byId("svcList1");
        },
        initSvcListEvent: function() {
            this._svcInfos = {},
            //页面加载前获取服务信息
            this.connect(this.svcList1, "onDefRendered", function(data) {
                if (data.data.items) {
                    array.forEach(data.data.items, function(item) {
                        this._svcInfos[item.APP_ID] = item;
                    }, this);
                }
            }),
            //服务列表的点击事件
            this.connect(this.svcList1.domNode, "onclick", function(e) {
                var node = e.target;
                while (node && node !== this.svcList1.domNode && "li" !== node.tagName.toLowerCase()) {
                    node = node.parentNode;
                }
                if (node && node !== this.svcList1.domNode) {
                    var aid = domAttr.get(node, "svc_aid");
                    this.svcListClick(this._svcInfos[aid]);
                }
            });
            this.connect(this.btn_search, "onclick", this.refreshAllList);
            //侦听回车键
            if (document.getElementById('search_name')) {
                document.getElementById('search_name').onkeydown = lang.hitch(this, function() {
                    if (event.keyCode == 13) {
                        this.refreshAllList();
                    }
                });
            }
        },
        refreshAllList: function() {
            var search_nameValues = this.search_name.value;
            search_nameValues = search_nameValues.replace(/"/g, "").replace(/'/g, "");
            if (window.did.indexOf('dist_') > -1) {
                this.did = window.did;
                this.svcList1.rs_wb_flt = "15";
                this.svcList1.rs_wb_param = "({DID:" + window.did.split("_")[1] + ",IND:'30001'})";
                this.svcList1.refreshList();
                this.cursvcList1 = this.svcList1;
            } else {
                this.svcList1.rs_wb_param = '({IND:window.did,INPUT:"' + search_nameValues + '"})';
                this.updateSvcListOrderBy().then(lang.hitch(this, function() {
                this.svcList1.refreshList();
            }));
                this.svcList1.refreshList();
            }
            this.search_name.value = "";

        },
        svcListClick: function(svcInfos) {
            window.moveToView("matList", "aid_" + svcInfos.APP_ID);
        },
        showSearArea: function(show) {
            if(this.search_name){
                domStyle.set(this.search_name.parentNode, "display", show ? "" : "none");
            }
        },
        updateSvcListOrderBy: function() {
            if (!this.svcListOrderDef) {
                this.svcListOrderDef = new Deferred();
                geolocation.getCurrentPosition("查看附近行业需要获取您当前位置信息。").then(lang.hitch(this, function(data) {
                    if (data) {
                        this.svcList1.rs_wb_order = "DBO.fnGetDistance(ISNULL([D_LAT],0),ISNULL([D_LON],0)," + data.coords.latitude + ',' + data.coords.longitude + ")";
                    }
                    this.svcListOrderDef.resolve();
                }));
            }
            return this.svcListOrderDef;
        }
    });
});