define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/dom-style",
    "dijit/registry",
    "dojo/query",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/dom-attr",
    "dojo/_base/xhr",
    "widgets/userInfo"
    ], function(declare, array, domClass, domStyle, registry, query, lang, Deferred, domAttr, xhr, userInfo) {
    return declare("widgets.common._TeamDetailMixin", null, {
        isTeamDetailLoaded:function(){
            return !!this.actDetail;
        },
        indexTeamDetailElement:function(){
            this.actDetail = registry.byId("actDtl");
            this.teamMessage = registry.byId("teamMsg");
            this.teamStt = registry.byId("teamState1");
            this.memberList = registry.byId("memList");
        },
        initTeamDetailEvent:function(){
            this.connect(this.actDetail, "onDefRendered", lang.hitch(this, function(data){
                var state = data.data.items[0].T0_STATE;
                data.data.items[0].img = "/w/content/sjmdsvc/" + (state==0)?"state0.png":(state==1?"state1.png":(state==2?"state2.png":"state3.png"));
                data.data.items[0].content = (state==0)?"准备开团":(state==1?"开团成功":(state==2?"拼团成功":"拼团失败"));
                teamMessage.rs_wb_page = data.data.items[0].T1_PACNUM;
            }));
            this.connect(this.teamMessage, "onDefRendered", lang.hitch(this, function(data){
                array.forEach(data.data.items, function(item, index){
                    if(index === 0){
                        item.rl = 1;
                    }
                });
                this.memberList.onDataReady(data);
                var num = teamMessage.rs_wb_page-data.data.items.length;
                if(num > 0){
                    for(var i = 0;i < num; i++){
                        data.data.items[data.data.items.length] = {};
                    }
                }
            }));
        },
        refreshAllList:function(){
            this.actDetail.refreshList();
            this.teamMessage.refreshList();
            this.memberList.refreshList();
        }
    });
});