define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/registry",
    "../userInfo",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "dojo/query",
    "dojo/dom-attr",
    "dojo/_base/array",
    "dojo/Deferred",
    "dojo/DeferredList",
    "dojo/dom-style"
    ], function(declare, lang, registry,userInfo, json, xhr, query,domAttr,array,Deferred,DeferredList,domStyle) {
    return declare("widgets.common._UserConnectMixin", null, {
        isWxConnectLoaded:function(){
            return !!this.traList;
        },
        indexWxConnectElement:function(){
            this.headList = registry.byId("userConnect_head");
            this.traList = registry.byId("traList");
            this.friend = query(".friend")[0];
            this.cfriend = query(".c-friend")[0];
        },
        refreshAllList: function() {
            userInfo.hasLogin().then(lang.hitch(this, function(s) {
                if (s) {
                    // 记录会员ID
                    this.pid = userInfo.getUserInfo().partnerId;
                    if (window.titleNode) {
                        window.titleNode.innerHTML = "会员动态";
                    }
                    this.did = window.did;
                    window.loadData({
                        modalName: "XSY_TWBCM_FRIENDS",
                        filter: "06",
                        pageSize: "1",
                        pageIndex: "1",
                        param: {
                            "F_PID": window.did,
                            "P_ID": this.pid
                        }
                    }).then(lang.hitch(this, function(data) {
                        if (window.did == this.pid) { //不能关注自己
                            domStyle.set(this.friend,"display","none");
                            domStyle.set(this.cfriend,"display","none");
                        } else {
                            // 如果找到好友
                            if (data.length) {
                                // 判断关注标志
                                if (data[0].IS_F == 1) {
                                    // 隐藏关注
                                    domStyle.set(this.friend,"display","none");
                                    domStyle.set(this.cfriend,"display","");
                                } else {
                                    // 隐藏取消关注
                                    domStyle.set(this.friend,"display","");
                                    domStyle.set(this.cfriend,"display","none");
                                }
                            } else { //没有找到好友
                                // 隐藏取消关注
                                domStyle.set(this.friend,"display","");
                                domStyle.set(this.cfriend,"display","none");
                            }
                        }
                        this.traList.refreshList();
                        this.headList.refreshList();
                    }
                    ));

                }
            }));
        },
        initWxConnectEvent: function() {
            this.connect(this.friend, "onclick", this.addFriend);
            this.connect(this.cfriend, "onclick", this.cancelFriend);
        },
        addFriend: function() {
            // 在好友表中加数据
            // 查找是否已有好友数据
            window.busy();
            var data,
            d = new Date();
            d = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds();
            window.loadData({
                modalName: "XSY_TWBCM_FRIENDS",
                filter: "06",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "P_ID": this.pid,
                    "F_PID": window.did
                }
            }).then(lang.hitch(this, function(data1) {
                if (data1.length) {
                    data = {
                        o: {
                            PARTNERID: this.pid,
                            F_PID: window.did
                        },
                        n: {
                            IS_F: 1,
                            ATION_DATE: d
                        }
                    };
                } else {
                    data = {
                        n: {
                            PARTNERID: this.pid,
                            F_PID: window.did,
                            IS_F: 1,
                            ATION_DATE: d
                        }
                    };
                }
                xhr("POST", {
                    url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                    handleAs: "json",
                    content: {
                        data: json.toJson({
                            modalName: "XSY_TWBCM_FRIENDS",
                            data: [data]
                        })
                    },
                    load: lang.hitch(this, function(result) {
                        if (1 === result.rtnType) {
                            alert("关注成功，登录后可以在我的好友中找到TA哦~");
                            domStyle.set(this.friend,"display","none");
                            domStyle.set(this.cfriend,"display","");
                            //query(".friend")[0].style.display = "none";
                            //query(".c-friend")[0].style.display = "";
                            window.free();
                        } else {
                            alert(result.message || "数据错误!");
                            window.free();
                        }
                    })
                });
            }));

        },
        cancelFriend: function() {
            // 在好友中删除数据
            window.busy();
            var data,
            d = new Date();
            d = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds();
            window.loadData({
                modalName: "XSY_TWBCM_FRIENDS",
                filter: "06",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "P_ID": this.pid,
                    "F_PID": window.did
                }
            }).then(lang.hitch(this, function(data1) {
                if (data1.length) {
                    data = {
                        o: {
                            PARTNERID: this.pid,
                            F_PID: window.did
                        },
                        n: {
                            IS_F: 0,
                            UATION_DATE: d
                        }
                    };
                }
                xhr("POST", {
                    url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                    handleAs: "json",
                    content: {
                        data: json.toJson({
                            modalName: "XSY_TWBCM_FRIENDS",
                            data: [data]
                        })
                    },
                    load: lang.hitch(this, function(result) {
                        if (1 === result.rtnType) {
                            alert("取消关注成功。");
                            domStyle.set(this.friend,"display","");
                            domStyle.set(this.cfriend,"display","none");
                            window.free();
                        } else {
                            alert(result.message || "数据错误!");
                            window.free();
                        }
                    })
                });
            }));
        }
    });
});