define([
    "dojo/_base/declare",
    "dojo/query", 
    "dojo/_base/lang",
    "../userInfo", 
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/_base/json",
    "dojo/_base/xhr"],function(declare,query,lang,userInfo,registry,domAttr,domStyle,json,xhr){
    return declare("widgets.common._userMixin",null,{
        isUserListLoaded:function(){
            return !!this.userInfoNode;
        },
        //初始化我页面节点
        indexUserElement:function(){
            if(!this.isUserListLoaded()){
                this.user_loginout = query("#user_loginout", this.domNode)[0];//注销
                this.user_mdfPwd = query("#user_mdfpwd", this.domNode)[0];//修改密码
                this.user_comInfo = query("#user_cominfo", this.domNode)[0];//修改资料
                this.user_order = query("#user_order", this.domNode)[0];//我的订单
                this.userInfoNode = registry.byId("userInfo");//list
                this.userDiv = query(".userDiv")[0];//我的页面
                this.userArm = registry.byId("ARM");
            }
        },
        //侦听页面节点
        initUserEvent:function(){
            this.user_loginout.onclick = lang.hitch(this, this.userLoginout); // 注销
            this.user_mdfPwd.onclick = lang.hitch(this, this.userMdfpwd); // 修改密码
            this.user_comInfo.onclick = lang.hitch(this, this.userCominfo); // 完善个人信息
            this.user_order.onclick = lang.hitch(this, this.showOrderList); // 完善个人信息
            this.connect(this.userInfoNode, "onDefRendered", function(data) {
                if (data.data.items.length) {
                    window.partnerId = data.data.items[0].PartnerID;
					data.data.items[0].ClientLevel = this.ClientLevelID;
					this.userArm.refreshList();
                }
            });
            this.connect(this.userArm, "onDefRendered", function(data) {
                if (data.data.items.length) {
                    if(data.data.items[0].ARAmount==0){
                        data.data.items[0].arAmnt = data.data.items[0].ARAmount*(-1)+'0';
                    }else{
                        data.data.items[0].arAmnt = data.data.items[0].ARAmount*(-1);
                    }
                    if(data.data.items[0].ARAmount2==0){
                        data.data.items[0].arAmnt2 = data.data.items[0].ARAmount2*(-1)+'0';
                    }else{
                        data.data.items[0].arAmnt2 = data.data.items[0].ARAmount2*(-1);
                    }
                }
            });
            this.connect(this.userInfoNode.domNode, "onclick", this.userInfoNodeClick);
        },
        refreshAllList:function(){
            if(window.titleNode){
                window.titleNode.innerHTML = "我";
            }
            // 判断用户是否已经登录
            userInfo.hasLogin().then(lang.hitch(this,function(hasLogin) {
                if (hasLogin) {
                    this.getCLevel();
                } else {
                    window.nextPageOnLogin = "user";
                    // 若没有登录
                    userInfo.showLogin();
                }
            }));
        },
        onBeforeTransitionIn:function(){
            this.inherited(arguments);
            if(this.userDiv){
                this.userDiv.style.display = "none";
            }
        },
        userInfoNodeClick:function(e){
            if (e.target) {
                var c = domAttr.get(e.target, "class");
                if (-1 < c.indexOf("disableGChat")) {
                    this.disableGChat();
                } else if (-1 < c.indexOf("enableGChat")) {
                    this.enableGChat();
                } 
            }
        },
        disableGChat:function(){
            window.busy();
            var info = {
                "SUBSCRIBE":0
            };
            userInfo.mdfUserInfo(info).then(lang.hitch(this,function(success) {
                if (success) {
                    this.userInfoNode.refreshList();
                    window.free();
                } else {
                    alert("禁用群聊失败！");
                    window.free();
                }
            }));
        },
        enableGChat:function(){
            window.busy();
            var info = {
                "SUBSCRIBE":1
            };
            userInfo.mdfUserInfo(info).then(lang.hitch(this,function(success) {
                if (success) {
                    this.userInfoNode.refreshList();
                    window.free();
                } else {
                    alert("启用群聊失败！");
                    window.free();
                }
            }));
        },
        //注销
        userLoginout: function() {
            userInfo.logout();
            window.moveToView("main");
        },
        // 修改密码
        userMdfpwd: function() {
            userInfo.mdfPwd();
        },
        //修改资料
        userCominfo: function() {
            window.moveToView("mdfUserInfo");
        },
        //我的订单
        showOrderList:function(){
            window.moveToView('orderList',userInfo.getUserInfo().partnerId);
        },
        getCLevel:function(){
            window.loadData({
                modalName:"XSY_TCRCS_CLIENTMNG",
                filter:"02",
                pageSize:"1",
                pageIndex:"1",
                param:{"ClientID":userInfo.getUserInfo().partnerId}
            }).then(lang.hitch(this,function(data){
                if(data.length){
                    this.ClientLevelID = data[0].ClientLevelID;
                }else{
                    this.ClientLevelID = 0;
                }
                if(this.userInfoNode){
                    this.userInfoNode.refreshList();
                }
                this.userDiv.style.display = "block";
            }));
        }
    });
});