define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/xhr",
    "dojo/_base/lang",
    "dojo/_base/json",
    "dojo/query",
    "dojo/Deferred",
    "dojo/dom",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/dom-class",
    "dijit/registry",
    "../userInfo"], function(declare, array, connect, xhr, lang, json, query, Deferred, dom, domAttr, domStyle, domClass, registry, userInfo) {
    return declare("widgets.common._UserRechargeMixin", null, {
        isUserRechargeLoaded: function() {
            return !!this.userRecharge;
        },
        indexUserRechargeElement: function() {
            this.inherited(arguments);
            this.userRecharge = registry.byId("user_recharge");
            this.rechargenow = query(".rechargenow", this.domNode)[0];
        },
        refreshAllList: function() {
            this.inherited(arguments);
            //若用户已登录，刷新页面，未登录则登录后返回
            userInfo.hasLogin().then(lang.hitch(this, function(success) {
                if (success) {
                    this.userRecharge.refreshList();
                } else {
                    window.nextPageOnLogin = "userRecharge";
                    userInfo.showLogin();
                }
            }));
            this.scrollTo({
                x: 0,
                y: 0
            });
            window.updateTitle("积分充值");
        },
        initUserRechargeEvent: function() {
            this.inherited(arguments);
            //侦听对节点的点击事件
            this.connect(this.userRecharge.domNode, "onclick", this.userRechargeClick);
            //侦听充值按钮点击事件
            this.connect(this.rechargenow, "onclick", this.Rechargenow);
        },
        userRechargeClick: function(e) {
            //定义dom节点
            var dom = e.target;
            //点击的不是span节点则返回父节点
            while (dom && "span" !== dom.tagName.toLowerCase() && dom != this.userRecharge) {
                dom = dom.parentNode;
            }
            if (dom) {
                //定义并获取dom及诶单的name和class
                var name = domAttr.get(dom, "name"),
                    cls = domAttr.get(dom, "class");
                //找到所有节点
                query("span", this.userRecharge.domNode).forEach(function(node) {
                    //如果这些节点不为当前点中节点
                    if (node != dom) {
                        //将非当前节点样式设置为未选中
                        domAttr.set(node, "class", "usercharge_unselected");
                    }
                });
                //改变选中节点的样式,选中状态则改为未选中状态
                domAttr.set(dom, "class", (("usercharge_unselected" === cls)) ? "usercharge_selected" : "usercharge_unselected");
                //将mid设置为this的一个属性，以供在提交订单时获取商品mid
                this.mid = domAttr.get(dom, "mid");
                //更新选中节点的商品的积分政策
                this.updateRemark(domAttr.get(dom, "mid"));
            }
        },
        updateRemark: function(mid) {
            //加载积分政策,mid为选中节点mid
            window.loadData({
                modalName: "XSY_TSDCD_PRICEDTS",
                filter: "02",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "MID": mid
                }
            }).then(lang.hitch(this, function(data1) {
                //将积分政策中的备注显示出来
                dom.byId("user_remarks").innerHTML = data1[0].Remark;
            }));
        },
        Rechargenow:function(){
            window.busy();
            //获取收货人信息
            var name = userInfo.getUserInfo().name,
                tel = userInfo.getUserInfo().tel,
                addr = userInfo.getUserInfo().addr,
                remark = "";
                orderWay=1;//订货途径：充值
            //定义matInfo,可传入商品的数量，金额等
            var matInfo = {};
            matInfo[this.mid] = {QTY:1};
            //引用生成订单接口
            require(["widgets/common/orderHandler"],lang.hitch(this,function(orderHandler){
                    orderHandler.postVirtualOrder(name,tel,addr,remark,matInfo,null,null,orderWay).then(lang.hitch(this,function(result){
                    if (1 === result.rtnType) {
                        //生成订单成功，跳转到订单详情
                        window.moveToView("orderDetail",result.data);
                        if(result.timeout){
                            alert("请在"+result.timeout+"内完成支付，否则订单会自动取消。");
                        }
                    } else if(result.message){
                        alert(result.message);
                    }
                }));
            }));
        }
    });
});