define([
    "dojo/_base/declare",
    "dojo/query",
    "widgets/userInfo",
    "dijit/registry",
    "dojo/_base/lang",
    "dojo/dom-attr"
],function(declare,query,userInfo,registry,lang,domAttr){
    return declare("widgets.common._UserSettingMixin",null,{
        isUserSettingLoaded:function(){
            return !!this.userInfoSetting;
        },
        indexUserSettingElement:function(){
            this.userInfoSetting = query(".userInfoSetting",this.domNode)[0];
            this.myAddr = query(".myAddr",this.domNode)[0];
            //this.mdfUserInfoPwd = query(".mdfUserInfoPwd",this.domNode)[0];
            this.loginoutCurent = query(".loginoutCurent",this.domNode)[0];
            this.userInfoSub = registry.byId("userInfoSub");
            //this.iosswitch = query(".ios-switch",this);
        },
        initUserSettingEvent:function(){
            this.connect(this.userInfoSetting,"onclick",function(){
                moveToView("mdfUserInfo");
            });
            this.connect(this.myAddr,"onclick",function(){
                moveToView("myAddr");
            })
            /*this.connect(this.mdfUserInfoPwd,"onclick",function(){
                moveToView("mdfPwd");
            });*/
            this.connect(this.loginoutCurent,"onclick",function(){
                userInfo.logout();
                window.moveToView("main");
            });
            this.connect(this.userInfoSub.domNode,"onclick",function(e){
                var dom = e.target;
                if(domAttr.get(dom,"class")&&domAttr.get(dom,"class").indexOf("ios-switch")>-1){
                    if(domAttr.get(dom,"class").indexOf("disableGChat")>-1){
                        this.disableGChat();   
                    }
                    else if(domAttr.get(dom,"class").indexOf("enableGChat")>-1){
                        this.enableGChat();
                    }
                }
            });
        },
        disableGChat:function(){
            //window.busy();
            this.isFinish = false;
            var info = {
                "SUBSCRIBE":0
            };
            if(this.isFinish){
                return;
            }
            userInfo.mdfUserInfo(info).then(lang.hitch(this,function(success) {
                //window.free();
                this.isFinish = true;
                if (success) {
                    alert("禁用成功");
                    this.userInfoSub.refreshList();
                } else {
                    alert("禁用失败");
                    //window.free();
                }
            }));
        },
        enableGChat:function(){
            //window.busy();
            this.isFinish = false;
            if(this.isFinish){
                return;
            }
            var info = {
                "SUBSCRIBE":1
            };
            userInfo.mdfUserInfo(info).then(lang.hitch(this,function(success) {
                this.isFinish = true;
                if (success) {
                    this.userInfoSub.refreshList();
                    alert("启用成功");
                    //window.free();
                } else {
                    alert("启用失败");
                    //window.free();
                }
            }));
        },
        refreshAllList:function(){
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    this.userInfoSub.refreshList();
                }
                else{
                    window.nextPageOnLogin = "userSetting";
                    userInfo.showLogin();
                }
            }));
        }
    });
});