define([
    "dojo/_base/declare",
    "dijit/registry",
    "widgets/userInfo",
    "dojo/_base/lang",
    "dojo/query",
    "cqthink/image/common",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/touch",
    "cqthink/mobile/imgPrc/capture"
],function(declare,registry,userInfo,lang,query,imgCom,json,xhr,domAttr,domClass,touch){
    return declare("widgets.common._NewUserMixin",null,{
        isUser_sjmdLoaded:function(){
            return !!this.userInfoList;
        },
        indexUser_sjmdElement:function(){
            this.userInfoList = registry.byId("userInfoList");
            this.myAllOrder = query(".myAllOrder",this.domNode)[0];
            this.myBooking = query(".myBooking",this.domNode)[0];
            this.myCelectList = query(".myCelectList",this.domNode)[0];
            this.myCardCoupons = query(".myCardCoupons",this.domNode)[0];
            this.myDistribution = query(".myDistribution",this.domNode)[0];
            this.myFightGroups = query(".myFightGroups",this.domNode)[0];
            this.myEvaList = query(".myEvaList",this.domNode)[0];
            this.myPrizeList = query(".myPrizeList", this.domNode)[0];
            this.myTousuList = query(".myTousuList",this.domNode)[0];
            this.informationList = query(".informationList",this.domNode)[0];
            this.NOT_PAY = query(".NOT_PAY",this.domNode)[0];
            this.NOT_DELI = query(".NOT_DELI",this.domNode)[0];
            //this.NOT_ACCEPT = query(".NOT_ACCEPT",this.domNode)[0];
            this.NOT_COMMENT = query(".NOT_COMMENT",this.domNode)[0];
            
            this.NOT_COMPLETE = query(".NOT_COMPLETE", this.domNode)[0];
        },
        initUser_sjmdEvent:function(){
            this.connect(this.userInfoList,"onDefRendered",function(data){
                if (data.data.items.length) {
                    if(data.data.items[0].T2_ARAmount==0){
                        data.data.items[0].arAmnt = data.data.items[0].T2_ARAmount*(-1)+'0';
                    }else{
                        data.data.items[0].arAmnt = data.data.items[0].T2_ARAmount*(-1);
                    }
                    if(data.data.items[0].T2_ARAmount2==0){
                        data.data.items[0].arAmnt2 = data.data.items[0].T2_ARAmount2*(-1)+'0';
                    }else{
                        data.data.items[0].arAmnt2 = data.data.items[0].T2_ARAmount2*(-1);
                    }
                }
            });
            this.connect(this.myAllOrder,"onclick",function(){
                window.moveToView("orderList-02");
            });
            this.connect(this.myBooking,"onclick",function(){
                window.moveToView("wbList"); 
            });
            this.connect(this.myCelectList,"onclick",function(){
                window.moveToView("productCelect");
            });
            this.connect(this.myCardCoupons,"onclick",function(){
                moveToView("myCoupons");
            });
            this.connect(this.myDistribution,"onclick",function(){
                window.moveToView("clientDistribute");
            });
            this.connect(this.myFightGroups,"onclick",function(){
                window.moveToView("pacTeamList");
            });
            this.connect(this.myEvaList,"onclick",function(){
                window.moveToView("listEvas");
            });
            this.connect(this.myPrizeList,"onclick",function(){
                window.moveToView("myPrize");
            });
            this.connect(this.myTousuList,"onclick",function(){
                window.moveToView("matLegalList");
            });
            this.connect(this.informationList,"onclick",function() {
                moveToView("newsList");
            });
            this.own(touch.release(this.userInfoList.domNode,lang.hitch(this,this.userInfoListClick)));
        },
        userInfoListClick:function(e){
            var dom = e.target;
            while(dom&&dom!==this.userInfoListClick.domNode){
                if(domAttr.get(dom,"class")){
                    if(domAttr.get(dom,"class")=="userLogo"){
                        return this.onUserLogoClick();
                    }
                    else if(domAttr.get(dom,"class")=="userSetting"){
                        return window.moveToView("userSetting");
                    }
                }
                dom = dom.parentNode;
            }
        },
        onUserLogoClick:function(){
            imgCom.selectImg().then(lang.hitch(this,function(url){
                if(url){
                    imgCom.cutImage(url,128,128).then(lang.hitch(this,this.onLogoSelected));
                }
            }));
        },
        onLogoSelected:function(url){
            if(!url){
                return;
            }
            window.busy();
            xhr("POST", {
                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    data: json.toJson({
                        modalName: "APP_TBSSC_IMG_LIB",
                        data: [{n:{
                            RID:"XSY_TCRCS_PARTNER",
                            RIID:userInfo.getUserInfo().partnerId,
                            URL:url
                        }}]
                    })
                },
                load:lang.hitch(this,function(result){
                    if(result.rtnType==1&&result.data&&result.data.items&&result.data.items.length){
                        var imgId = result.data.items[0].DID;
                        xhr("POST", {
                            url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                            handleAs: "json",
                            content: {
                                data: json.toJson({
                                    modalName: "XSY_TCRCS_PARTNER",
                                    data: [{n:{
                                        Logo:imgId
                                    },o:{
                                        PartnerID:userInfo.getUserInfo().partnerId
                                    }}]
                                })
                            },
                            load: lang.hitch(this, function(result) {
                                if (1 === result.rtnType) {
                                    domAttr.set(query(".userLogo>img",this.domNode)[0],"src","/w/img/load/"+window.code+"-"+imgId+".png");
                                    window.free();
                                } else {
                                    alert(result.message || "数据错误!");
                                    window.free();
                                }
                            })
                        });
                    }else{
                        alert(result.message || "数据错误!");
                        window.free();
                    }
                })
            });
        },
        refreshAllList:function(){
            // 判断用户是否已经登录
            userInfo.hasLogin().then(lang.hitch(this,function(hasLogin) {
                if (hasLogin) {
                    //this.getCLevel();
                    this.userInfoList.refreshList();
                    this.setStdNum();
                } else {
                    window.nextPageOnLogin = "user";
                    // 若没有登录
                    userInfo.showLogin();
                }
            }));
        },
        setStdNum:function(){
            xhr("POST", {
                url: "/w/order/getOrderNum/" + window.code,
                handleAs: "json",
                /*content: {
                    data: json.toJson({
                        modalName: "XST_TCRMK_SUPPLYORNEED",
                        data: [data]
                    })
                },*/
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        this.NOT_PAY.innerHTML = result.data.NOT_PAY;
                        this.NOT_DELI.innerHTML = result.data.NOT_DELI;
                        //this.NOT_ACCEPT.innerHTML = result.data.NOT_ACCEPT;
                        this.NOT_COMMENT.innerHTML = result.data.NOT_COMMENT;
                        
                        this.NOT_COMPLETE.innerHTML = result.data.NOT_COMPLETE;
                    } else {
                        this.NOT_PAY.innerHTML = 0;
                        this.NOT_DELI.innerHTML = 0;
                        //this.NOT_ACCEPT.innerHTML = 0;
                        this.NOT_COMMENT.innerHTML = 0;
                        
                        this.NOT_COMPLETE.innerHTML = 0;
                    }
                    if(this.NOT_PAY.innerHTML == 0){
                        domClass.add(this.NOT_PAY,"hide");
                    }else{
                        domClass.remove(this.NOT_PAY,"hide");
                    }
                    if(this.NOT_DELI.innerHTML == 0){
                        domClass.add(this.NOT_DELI,"hide");
                    }else{
                        domClass.remove(this.NOT_DELI,"hide");
                    }
                    /*if(this.NOT_ACCEPT.innerHTML == 0){
                        domClass.add(this.NOT_ACCEPT,"hide");
                    }else{
                        domClass.remove(this.NOT_ACCEPT,"hide");
                    }*/
                    if(this.NOT_COMMENT.innerHTML == 0){
                        domClass.add(this.NOT_COMMENT,"hide");
                    }else{
                        domClass.remove(this.NOT_COMMENT,"hide");
                    }
                    
                    if(this.NOT_COMPLETE.innerHTML || this.NOT_COMMENT.innerHTML == 0){
                        domClass.add(this.NOT_COMPLETE,"hide");
                    }else{
                        domClass.remove(this.NOT_COMPLETE,"hide");
                    }
                })
            });
        }
    });
});