define([
    "dojo/_base/declare",
    "dojo/query",
    "dojo/Deferred",
    "dojo/dom-attr",
    "dojo/_base/connect",
    "dojo/_base/xhr",
    "dojo/_base/lang",
    "dojo/_base/json",
    "../userInfo",
    "../orderCarRecord",
    "dijit/registry"], function(declare, query, Deferred, domAttr, connect, xhr, lang, json, userInfo, orderCarRecord, registry) {
    return declare("widgets.common._WGChargesMixin", null, {
        TName:"",
        isWGChargesLoaded:function(){
            return !!this.wuGuanFee;    
        },
        indexWGChargesElement: function() {
            this.wuGuanFee = registry.byId("wuguanfee");
            this.subpayfee = query("#subpayfee", this.domNode)[0];
            //this.remark = query('.remark')[0];
            //this.timeslot = query('.timeslot')[0];
        },
        refreshAllList: function() {
            this.wuGuanFee.refreshList();
        },
        initWGChargesEvent: function() {
            this.connect(this.wuGuanFee, "onDefRendered", function(data) {
                items = data.data.items;
                if (items.length) {
                    this.TName = items[0].A_TITLE;
                    //this.remark.innerHTML = items[0].REMARK;
                    //this.timeslot.innerHTML = '活动时间：'+items[0].START_TIME+'至'+items[0].END_TIME;
                }else{
                    this.TName = "暂无相关活动";
                }
                window.updateTitle(this.TName);
            });
            this.connect(this.subpayfee, "onclick", this.topayFee);
        },
        //”缴纳物管费“被点击事件响应函数
        topayFee: function() {
            window.address = []; //存客户信息表信息的数组
            window.proprietor = []; //存业主表信息的数组
            //加载缴费优惠活动表中的数据
            window.loadData({
                modalName: "XSY_TCRMK_PROMOTION",
                filter: "01",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "DID": window.did
                }
            }).then(lang.hitch(this, function(data) {
                //判断当前时间是否在活动时间范围内
                var d = new Date();
                var my_Date = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate();
                var n_time = my_Date.split("-"),
                    s_time = data[0].START_TIME.split("-"),
                    e_time = data[0].END_TIME.split("-");
                //当前时间活动小于开始时间，显示活动开始时间
                if (new Date(n_time[0] - 0, n_time[1] - 1, n_time[2] - 0) < new Date(s_time[0] - 0, s_time[1] - 1, s_time[2] - 0)) {
                    alert("活动还没有开始！");
                } else {
                    //当前时间大于活动结束时间，显示活动已结束
                    if (new Date(n_time[0] - 0, n_time[1] - 1, n_time[2] - 0) > new Date(e_time[0] - 0, e_time[1] - 1, e_time[2] - 0)) {
                        alert("活动已经结束！");
                    } else {
                        //在活动时间范围内，判断是否已经登录账号
                        userInfo.hasLogin().then(lang.hitch(this, function(success) {
                            if (success) {
                                //已经登录，判断是否认证
                                window.loadData({
                                    modalName: "XSY_TBSCR_ADDRESS",
                                    filter: "03",
                                    pageSize: "1",
                                    pageIndex: "1",
                                    param: {
                                        "PartnerID": window.userInfo.partnerId
                                    }
                                }).then(lang.hitch(this, function(p_address) {
                                    if (p_address.length) {
                                        window.address = p_address;
                                    }
                                    if (!window.address[0].R_N) {
                                        //未认证，提示”请发送@认证 房间号+业主姓名“认证房间信息
                                        alert("请发送‘@认证 房间号 业主姓名’认证房间信息！");
                                        return false;
                                    } else {
                                        //已经认证，校验是否限购、是否满足条件、设置商品的数量为活动定义的数量
                                        //、零售和分销价均为业主单月物业费、订单处理提交之后的提醒
                                        //跳转到订单详情页面
                                        var mats = [];
                                        var p_m = [];
                                        window.loadData({
                                            modalName: "XSY_TCRCS_PROPRIETOR",
                                            filter: "01",
                                            pageSize: "1",
                                            pageIndex: "1",
                                            param: {
                                                "COM_NAME": window.address[0].Payee,
                                                "R_NUM": window.address[0].R_N,
                                                "AID": window.address[0].AID
                                            }
                                        }).then(lang.hitch(this, function(p_m) {
                                            //获取商品mid,qty,amt
                                            var MID = data[0].MID,
                                                qty = data[0].QTY,
                                                amt = data[0].QTY * data[0].FEE * p_m[0].P_M_FEE;
                                            //定义matInfo,将数量金额存入其中
                                            var matInfo = {};
                                            matInfo[data[0].MID] = {QTY:qty,AMT:amt};
                                            this.postOrder(matInfo);
                                        }));
                                    }
                                }));
                            } else {
                                //没有登录，跳转到登录页面
                                window.nextPageOnLogin = window.did ? "wuGuanFee-" + window.did : "wuGuanFee";
                                userInfo.showLogin();
                            }
                        }));
                    }
                }
            }));
        },
        postOrder:function(matInfo){
            window.busy();
            //获取收货人电话、姓名、地址、备注等信息
            var name = userInfo.getUserInfo().name,
                tel = userInfo.getUserInfo().tel,
                addr = userInfo.getUserInfo().addr,
                remark = "";
            require(["widgets/common/orderHandler"],lang.hitch(this,function(orderHandler){
                    orderHandler.postVirtualOrder(name,tel,addr,remark,matInfo).then(lang.hitch(this,function(result){
                    if (1 === result.rtnType) {
                        window.moveToView("orderDetail",result.data);
                        if(result.timeout){
                            alert("请在"+result.timeout+"内完成支付，否则订单会自动取消。");
                        }
                    } else if(result.message){
                        alert(result.message);
                    }
                }));
            }));
        }
    });
});