define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "dojo/_base/lang",
    "../userInfo"], function(declare, registry,domAttr,json, xhr, lang,userInfo) {
    return declare("widgets.WbList_htapp", null, {
        isWbListLoaded:function(){
            return !!this.wb_list;
        },
        indexWbListElement: function() {
            this.wb_list = registry.byId("wb_list");
        },
        initWbListEvent:function(){
            this.connect(this.wb_list.domNode,"onclick",this.wb_list_onclick);
        },
        refreshAllList: function() {
            window.updateTitle("预约列表");
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    this.wb_list.refreshList();
                }else{
                    window.nextPageOnLogin = "wbList";
                    userInfo.showLogin();
                }
            }));
            
        },
        wb_list_onclick:function(e){
            if(e.target&&e.target.tagName.toLowerCase()=="a"){
                var wb_id = domAttr.get(e.target,"wb_id"),
                    wb_eva = domAttr.get(e.target,"wb_eva"),
                    wb_wcid = domAttr.get(e.target,"wb_wcid");
                if(wb_id){
                    this.cancelWb(wb_id);
                }else{
                    window.moveToView("matEva",wb_eva+"_"+wb_wcid); // “—_+工作中心ID
                }
            }
        },
        cancelWb:function(w){
            window.busy();
            var data = {
                n:{
                    "WBSTATE":4
                },
                o:{
                    "WBID":w
                }
            };
            xhr("POST", {
                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    data: json.toJson({
                        modalName: "XSY_TSCSF_WB",
                        data: [data]
                    })
                },
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        alert("取消成功。");
                        window.free();
                        this.wb_list.refreshList();
                    } else {
                        alert(result.message || "数据错误!");
                        window.free();
                    }
                })
            });
        }
    });
});