define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "dojo/_base/lang",
    "dojo/query",
    "dojo/_base/array",
    "dojo/dom-style",
    "../userInfo"], function(declare, registry,domAttr,json, xhr, lang, query, array, domStyle, userInfo) {
    return declare("widgets.common._WbList_sjmdMixin", null, {
        isWbList_sjmdLoaded:function(){
            return !!this.wb_list;
        },
        indexWbList_sjmdElement: function() {
            if(!this.isWbList_sjmdLoaded()){
                this.wb_list = registry.byId("wb_list");
                this.tradeListInfo = query("#tradeListInfo",this.domNode)[0];
                this.orderHead = query(".orderHead",this.domNode)[0];//找到订单列表的头部
            }
            
            //this.wb_list = registry.byId("wb_list");
        },
        initWbList_sjmdEvent:function(){
            //this.connect(this.wb_list.domNode,"onclick",this.wb_list_onclick);
            
            if(this.orderHead){// 判断是否有商品列表中的排序节点
                this.connect(this.orderHead,"onclick",function(e){
                    var dom = e.target;
                    while(dom&&"li"!==dom.tagName.toLowerCase()&&dom!=this.orderHead){
                        dom = dom.parentNode;
                    }
                    if(dom){
                        var name = domAttr.get(dom,"name");
                        var cls = domAttr.get(dom,"class");
                        this.clearState(dom);
                        domAttr.set(dom,"class",(("tableLiChecked"===cls)||cls==="")?"tableLi":"tableLiChecked");
                        domAttr.set(dom,"class","tableLiChecked");
                        this.wb_list.rs_wb_flt = name;
                        window.busy();
                        this.wb_list.refreshList();
                        window.free()
                    }
                });
            }
        },
        refreshAllList: function() {
            window.updateTitle("预约列表");
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    if (this.wb_list) {
                        if(this.orderHead){
                            if(window.did){
                                query("li",this.orderHead).forEach(function(n){
                                    if(domAttr.get(n,"name")==window.did){
                                        domAttr.set(n,"class","tableLiChecked");
                                    }else{
                                        domAttr.set(n,"class","tableLi");
                                    }
                                });
                                this.wb_list.rs_wb_flt = window.did;
                            }
                        }
                        this.wb_list.refreshList();
                        this.scrollTo({x:0,y:0});
                    }
                    //this.wb_list.refreshList();
                }else{
                    window.nextPageOnLogin = "wbList_sjmd"+window.did?("-"+window.did):"";
                    //window.nextPageOnLogin = "wbList_sjmd";
                    userInfo.showLogin();
                }
            }));
        },
        wb_list_onclick:function(e){
            if(e.target&&e.target.tagName.toLowerCase()=="a"){
                var wb_id = domAttr.get(e.target,"wb_id"),
                    wb_eva = domAttr.get(e.target,"wb_eva");
                    wb_wcid = domAttr.get(e.target,"wb_wcid");
                if(wb_id){
                    this.cancelWb(wb_id);
                }else{
                    window.moveToView("matEva_sjmd",wb_eva+"_"+wb_wcid);
                }
            }
        },
        cancelWb:function(w){
            window.busy();
            var data = {
                n:{
                    "WBSTATE":4
                },
                o:{
                    "WBID":w
                }
            };
            xhr("POST", {
                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    data: json.toJson({
                        modalName: "XSY_TSCSF_WB",
                        data: [data]
                    })
                },
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        alert("取消成功。");
                        window.free();
                        this.wb_list.refreshList();
                    } else {
                        alert(result.message || "数据错误!");
                        window.free();
                    }
                })
            });
        },
        clearState:function(node){
            if(this.orderHead){
                query("li",this.orderHead).forEach(function(n){
                    if(n!==node){
                        domAttr.set(n,"class","tableLi");
                    }
                });
            }
        },
        updateFooter:function(){
            if(g_sys_info.temp==="sjmdsvc"){
                if(query("li").length>0){
                    domStyle.set(this.tradeListInfo,"display","none");
                }else{
                    domStyle.set(this.tradeListInfo,"display","");
                }
            }
        }
    });
});