define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/registry",
    "../userInfo",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "dojo/query",
    "dojo/dom-attr",
    "dojo/_base/array",
    "dojo/Deferred",
    "dojo/DeferredList",
    "dojo/dom-style"
    ], function(declare, lang, registry,userInfo, json, xhr, query,domAttr,array,Deferred,DeferredList,domStyle) {
    return declare("widgets.common._WxConnectMixin", null, {
        isWxConnectLoaded:function(){
            return !!this.traList;
        },
        indexWxConnectElement:function(){
            this.traList = registry.byId("traList");
            this.friend = query(".friend")[0];
            this.cfriend = query(".c-friend")[0];
            this.wxCon = query(".wxConnect")[0];
            this.okBtn = query(".wxconnect")[0];
            this.cancelBtn = query(".wxconnectC")[0];
        },
        refreshAllList: function() {
            if (window.titleNode) {
                window.titleNode.innerHTML = "微信对话";
            }
            wxids = decodeURIComponent(window.did).split("&"), sid = wxids[0], tid = wxids[1];
            xhr("POST", {
                url: "../../wxcs/canConnect/" + g_sys_info.code + "?sid=" + sid + "&tid=" + tid,
                handleAs: "json",
                load: lang.hitch(this, function(result) {
                    window.loadData({
                        modalName: "XSY_TWBCM_FRIENDS",
                        filter: "01",
                        pageSize: "1",
                        pageIndex: "1",
                        param: {
                            "F_OPENID": tid,
                            "OPENID": sid
                        }
                    }).then(lang.hitch(this, function(data) {
                        if (sid == tid) { //不能关注自己
                            domStyle.set(this.friend,"display","none");
                            domStyle.set(this.cfriend,"display","none");
                        } else {
                            // 如果找到好友
                            if (data.length) {
                                // 判断关注标志
                                if (data[0].IS_F == 1) {
                                    // 隐藏关注
                                    domStyle.set(this.friend,"display","none");
                                    domStyle.set(this.cfriend,"display","");
                                } else {
                                    // 隐藏取消关注
                                    domStyle.set(this.friend,"display","");
                                    domStyle.set(this.cfriend,"display","none");
                                }
                            } else { //没有找到好友
                                // 隐藏取消关注
                                domStyle.set(this.friend,"display","");
                                domStyle.set(this.cfriend,"display","none");
                            }
                        }
                        if (result.success) {
                            this.wxCon.innerHTML = "确定要与TA对话吗？如果不需要，可直接点击取消。";
                        } else {
                            this.wxCon.innerHTML = result.message;
                            domStyle.set(this.okBtn,"display","none");
                            domStyle.set(this.cancelBtn,"display","none");
                            //query(".wxconnect")[0].style.display = "none";
                            //query(".wxconnectC")[0].style.display = "none";
                        }
                        this.traList.rs_wb_param = "({OPENID:'"+tid+"'})";
                        this.traList.refreshList();
                    }
                    ));
                })
            });
        },
        initWxConnectEvent: function() {
            this.connect(this.okBtn, "onclick", this.postCom);
            this.connect(this.cancelBtn, "onclick", this.cancelCom);
            this.connect(this.friend, "onclick", this.addFriend);
            this.connect(this.cfriend, "onclick", this.cancelFriend);
        },
        addFriend: function() {
            // 在好友表中加数据
            // 查找是否已有好友数据
            window.busy();
            var data,
            d = new Date();
            d = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds();
            window.loadData({
                modalName: "XSY_TWBCM_FRIENDS",
                filter: "01",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "OPENID": sid,
                    "F_OPENID": tid
                }
            }).then(lang.hitch(this, function(data1) {
                if (data1.length) {
                    data = {
                        o: {
                            OPENID: sid,
                            F_OPENID: tid
                        },
                        n: {
                            IS_F: 1,
                            ATION_DATE: d
                        }
                    };
                } else {
                    data = {
                        n: {
                            OPENID: sid,
                            F_OPENID: tid,
                            IS_F: 1,
                            ATION_DATE: d
                        }
                    };
                }
                xhr("POST", {
                    url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                    handleAs: "json",
                    content: {
                        data: json.toJson({
                            modalName: "XSY_TWBCM_FRIENDS",
                            data: [data]
                        })
                    },
                    load: lang.hitch(this, function(result) {
                        if (1 === result.rtnType) {
                            alert("关注成功，登录后可以在我的好友中找到TA哦~");
                            domStyle.set(this.friend,"display","none");
                            domStyle.set(this.cfriend,"display","");
                            //query(".friend")[0].style.display = "none";
                            //query(".c-friend")[0].style.display = "";
                            window.free();
                        } else {
                            alert(result.message || "数据错误!");
                            window.free();
                        }
                    })
                });
            }));

        },
        cancelFriend: function() {
            // 在好友中删除数据
            window.busy();
            var data,
            d = new Date();
            d = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds();
            window.loadData({
                modalName: "XSY_TWBCM_FRIENDS",
                filter: "01",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "OPENID": sid,
                    "F_OPENID": tid
                }
            }).then(lang.hitch(this, function(data1) {
                if (data1.length) {
                    data = {
                        o: {
                            OPENID: sid,
                            F_OPENID: tid
                        },
                        n: {
                            IS_F: 0,
                            UATION_DATE: d
                        }
                    };
                }
                xhr("POST", {
                    url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                    handleAs: "json",
                    content: {
                        data: json.toJson({
                            modalName: "XSY_TWBCM_FRIENDS",
                            data: [data]
                        })
                    },
                    load: lang.hitch(this, function(result) {
                        if (1 === result.rtnType) {
                            alert("取消关注成功。");
                            //query(".friend")[0].style.display = "";
                            //query(".c-friend")[0].style.display = "none";
                            domStyle.set(this.friend,"display","");
                            domStyle.set(this.cfriend,"display","none");
                            window.free();
                        } else {
                            alert(result.message || "数据错误!");
                            window.free();
                        }
                    })
                });
            }));
        },
        postCom: function() {
            window.busy();
            xhr("POST", {
                url: "../../wxcs/wxConnect/" + g_sys_info.code + "?sid=" + sid + "&tid=" + tid,
                handleAs: "json",
                load: lang.hitch(this, function(result) {
                    if (true === result.success) {
                        //alert(result.message);
                        this.wxCon.innerHTML = result.message;
                        domStyle.set(this.okBtn,"display","none");
                        domStyle.set(this.cancelBtn,"display","none");
                        //query(".wxconnect")[0].style.display = "none";
                        //query(".wxconnectC")[0].style.display = "none";
                        window.free();
                        window.closeWindow();
                    } else {
                        this.wxCon.innerHTML = result.message;
                        domStyle.set(this.okBtn,"display","none");
                        domStyle.set(this.cancelBtn,"display","none");
                        //query(".wxconnect")[0].style.display = "none";
                        //query(".wxconnectC")[0].style.display = "none";
                        window.free();
                    }
                })
            });
        },
        cancelCom: function() {
            window.closeWindow();
        }
    });
});