define([
    "dojo/_base/declare", 
    "dojo/_base/array",
    "dojo/_base/lang",
    "dijit/registry",
    "cqthink/app/plugins/geolocation"
],function(declare,array,lang,registry,geolocation){
    return declare("widgets.common._WxListMixin",null,{
        isWxListLoaded:function(){
            return !!this.wxList;
        },
        refreshAllList:function(){
            window.updateTitle("附近会员");
            //判断在微信端还是APP端,加载的模型和数据不一致
            geolocation.getCurrentPosition("查看附近会员需要获取您当前位置信息。").then(lang.hitch(this,function(data){
                if(data){
                    this.wxList.rs_wb_order = "DBO.fnGetDistance([D_LAT],[D_LON],"+data.coords.latitude+','+data.coords.longitude+")";
                    this.wxList.refreshList();
                    this.scrollTo({x:0,y:0});
                }
            }));
        },
        indexWxListElement:function(){
            this.wxList = registry.byId("wxList1");
        },
        initWxListEvent:function(){
            this.connect(this.wxList,"onDefRendered",function(data){
                if(data.data.items.length){
                    var items = data.data.items;
                    array.forEach(items,function(item){
                        item.NICKNAME = item.COM_NAME||item.NICKNAME||"无名氏";
                        item.HEADIMGURL = item.HEADIMGURL||"";
                        item.pvp = window.wx_openId?'<div><a style="color:blue;" href="#wxconnect-'+encodeURIComponent(window.wx_openId+"&"+item.OPENID)+'">和TA对话</a></div>':"";
                    });
                }
            });
        }
    });
});