define([
    "dojo/_base/declare", 
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/query",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom-style"
], function(declare, registry,domAttr,query,array,lang,domStyle) {
    return declare("widgets.common._MatListMixin",null,{
        isMatListLoaded:function(){
            return !!this.matList;
        },
        refreshAllList:function(){
            //window.updateTitle("商品列表");
            if(this.order_control){
                this.matList.rs_wb_order = "ISNULL([T12_TOTAL_SALE],[T18_TOTAL_SALE]) DESC";
                query("a",this.order_control).forEach(function(n){
                    if(!domAttr.get(n,"changeViewEf")){
                        if(domAttr.get(n,"name")=="ISNULL([T12_TOTAL_SALE],[T18_TOTAL_SALE])"){
                            domAttr.set(n,"class","arrow-down");
                            domAttr.set(n,"selected","true");
                        }else{
                            domAttr.set(n,"class","");
                            domAttr.set(n,"selected","false");
                        }
                    }
                });
            }
            if(window.did.indexOf('aid_')>-1){
                this.did = window.did;
                this.matList.rs_wb_flt = "20";
                this.matList.rs_wb_param = "({APP_ID:"+window.did.split("_")[1]+",INPUT:''})";
                this.matList.refreshList();
                this.curMatList = this.matList;
            }else if(window.did.indexOf('std_')>-1){
                this.did = window.did;
                this.matList.rs_wb_flt = "24";
                this.matList.rs_wb_param = "({MGID:"+window.did.split("_")[1]+",INPUT:''})";
                this.matList.refreshList();
                this.curMatList = this.matList;
            }else if(window.did.indexOf('matgroup_')>-1){
                this.did = window.did;
                this.matList.rs_wb_flt = "03";
                this.matList.rs_wb_param = "({AID:"+window.did.split("_")[1]+",MGID:"+window.did.split("_")[2]+",INPUT:''})";
                this.matList.refreshList();
                this.curMatList = this.matList;
            }else if(window.did.indexOf('dist_')>-1){
                this.did = window.did;
                this.matList.rs_wb_flt = "27";
                this.matList.rs_wb_param = "({DistID:"+window.did.split("_")[1]+",PGID:"+window.did.split("_")[2]+",INPUT:''})";
                this.matList.refreshList();
                this.curMatList = this.matList;
            }else{
                if (window.did != this.did) {
                    this.did = window.did;
                    this.matList.rs_wb_flt = "18";
                    this.matList.rs_wb_param = "({MGID:'"+window.did+"',INPUT:''})";
                    this.matList.refreshList();
                }else{
                    window.updateTitle(this.mGroupName);
                }
                this.curMatList = this.matList;//记录当前list2
            }
            setTimeout(window.free,100);
        },
        indexMatListElement:function(){
            if(!this.isMatListLoaded()){
                this.order_control = query(".order_control",this.bodyNode)[0];//找到商品列表中的排序
                this.matList = registry.byId("materList");//得到matlist节点的id
                this.searchMatBtn = query(".btn-search",this.bodyNode)[0];
            }
        },
        initMatListEvent:function(){
            this.connect(this.matList, "onDefRendered", function(data) {
                if(!window.did||window.did.indexOf("aid_")>-1){
                    this.mGroupName = "商品列表";//界面标题更新为商品列表
                }else if(window.did.indexOf("std_")>-1){
                    this.mGroupName = data.data.items[0]["T0_ProductGroupID.PGName"];//界面标题为品类名
                }else{
                    if(data.data&&data.data.items&&data.data.items.length){
                        this.mGroupName = data.data.items[0]["T4_MGName"];//界面标题为商品类别
                    }else{
                        this.mGroupName = '暂无商品';
                    }
                }
                //处理界面的标题
                window.updateTitle(this.mGroupName);
            });
            if(this.searchMatBtn){
                this.searchMatBtn.onclick = lang.hitch(this,this._onMatListSearch);
            }
            if(document.getElementById('search_name')){
                document.getElementById('search_name').onkeydown = lang.hitch(this,function(){
                    if(event.keyCode==13){
                        this._onMatListSearch();
                    }
                });
            }
            if(this.order_control){// 判断是否有商品列表中的排序节点
                this.connect(this.order_control,"onclick",function(e){
                    var dom = e.target;
                    while(dom&&"a"!==dom.tagName.toLowerCase()&&dom!=this.order_control){
                        dom = dom.parentNode;
                    }
                    if(dom&&dom!==this.order_control){
                        if(!domAttr.get(dom,"changeViewEf")){
                            var name = domAttr.get(dom,"name");
                            var cls = domAttr.get(dom,"class");
                            var orderDesc = domAttr.get(dom,"orderDesc");
                            var selected = domAttr.get(dom,"selected");
                            if(selected=="true"){
                                //更新查询条件
                                domAttr.set(dom,"class",(cls===""||cls==="arrow-down")?"arrow-up":"arrow-down");
                                this.curMatList.rs_wb_order = name?((cls===""||cls==="arrow-down")?name:name+" DESC"):"";
                            }else{
                                domAttr.set(dom,"selected","true");
                                this.curMatList.rs_wb_order = name+" "+orderDesc;
                                domAttr.set(dom,"class",orderDesc==="DESC"?"arrow-down":"arrow-up");
                            }
                            this._clearSearchBarStart(dom);
                            this.curMatList.refreshList();
                        }else{
                            domAttr.set(dom,"class",domAttr.get(dom,"class")==="verticalList"?"levelList":"verticalList");
                            domAttr.set(this.matList.domNode,"class",(domAttr.get(this.matList.domNode,"class")==="m-list matList")?"m-l-list matList":"m-list matList");
                        }
                    }
                });
            }
        },
        mGroupName:"",
        _clearSearchBarStart:function(node){
            if(this.order_control){
                query("a",this.order_control).forEach(function(n){
                    if(n!==node&&!domAttr.get(n,"changeViewEf")){
                        domAttr.set(n,"class","");
                        domAttr.set(n,"selected","false");
                    }
                });
            }
        },
        _onMatListSearch:function(){
            //if(document.getElementById('search_name').value){
                if(window.did.indexOf("aid_")>-1){
                    this.curMatList.rs_wb_param = "({APP_ID:'"+window.did.split("_")[1]+"',INPUT:'"+document.getElementById('search_name').value+"'})";
                }else if(window.did.indexOf("std_")>-1){
                    this.curMatList.rs_wb_param = "({MGID:'"+window.did.split("_")[1]+"',INPUT:'"+document.getElementById('search_name').value+"'})";
                }else{
                    this.curMatList.rs_wb_param = "({MGID:'"+window.did+"',INPUT:'"+document.getElementById('search_name').value+"'})";
                }
                this.curMatList.refreshList();
            //}
        },

 
        
    });
});