define([
    "dojo/_base/connect",
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojo/_base/xhr",
    "dojo/Deferred",
    "dojo/ready",
    "dojo/topic",
    "widgets/userInfo"
], function(connect, json, lang, xhr, Deferred, ready, topic, userInfo) {
    var appDeviceInfo = lang.getObject("mobile.appDeviceInfo", true),
    other = cqthinkinfo.appLoginInfo&&(window.plugins&&window.plugins.pushNotification || window.baidu_push)&&("ios"===cqthinkinfo.os || 
    "android"===cqthinkinfo.os)?null:{
        //不支持推送通知
        regist: function() {},
        bandPushMessage: function() {},
        getAppDeviceInfo: function() {},
        updateAppDeviceInfo: function() {
            //不支持推送通知的信息直接不做更新设备信息的操作
        }
    };
    var g_s = window.g_s || {
        getDateTime: function() {
            var d = new Date();
            return d.toISOString().substr(0, 10) + " " + d.toTimeString().substr(0, 8);
        },
        getDate: function() {
            return this.getDateTime().split(" ")[0];
        }
    };
    lang.mixin(appDeviceInfo, {
        //登录状态：0没有启动登录，1登录中未成功，2登录成功
        // loginState:0,
        _init: function() {
            if (!other) {
                // APP启动，首页ready之后直接调用
                this.updateAppDeviceInfo();
                // 侦听登录成功事件
                dojo.connect(widgets.common._NewRegisterMixin, "postRegistFuc", lang.hitch(this, function(){
                    setTimeout(lang.hitch(this, this.updateAppDeviceInfo), 100);
                }));
                //侦听准备登录事件
                //topic.subscribe("/cqthink/app/login/beforeLogin", lang.hitch(this, function(loginInfo) {
                //    this._loginBak = loginInfo && true !== loginInfo.readOnly && true === loginInfo.userLogin && loginInfo;
                //    this.loginState = 1;
                //}));
                //侦听登录成功事件
                //topic.subscribe("/cqthink/app/login/loginSuccess", lang.hitch(this, function() {
                //    if (this._loginBak) {
                //        this._curSvc = this._loginBak.info.svc;
                //        this.loginState = 2;
                //        this.updateAppDeviceInfo();
                //    }
                //}));
                //侦听注销事件
                //topic.subscribe("/cqthink/user/loginStatusChange", lang.hitch(this, function(hasLogin) {
                //    if (false === hasLogin) {
                //        this._curSvc = "";
                //        this.loginState = 0;
                //    }
                //}));
                //g_u加载成功之后才能更新设备信息到服务器，这里用到了g_d，所以必须等到g_d已创建
                //topic.subscribe("/cqthink/app/login/loginLoaded",lang.hitch(this,function(){
                //    setTimeout(lang.hitch(this,this.updateAppDeviceInfo),100);
                //}));
                //调用绑定推送通知事件
                this.bandPushMessage();
                //注册设备
                this.regist();
            }
        },
        updateAppDeviceInfo: function(){
            var o = this.getAppDeviceInfo();
            if (!o) {
                //若没有设备序列号信息，执行注册操作
                this.regist().then(lang.hitch(this, function() {
                    if (this.getAppDeviceInfo()) {
                        //若能够获取到设备信息，说明注册成功，就需要更新设备信息
                        this.updateAppDeviceInfo();
                    }
                }));
            }else{
                this._updateAppDeviceInfo();
            }
        },
        _updateAppDeviceInfo: function() {
            var o = this.getAppDeviceInfo(),
                n = lang.clone(o);
            n.DDATE = g_s.getDateTime();
            n.APP_ID = cqthinkinfo.APP_ID;
            n.AID = g_sys_info.aid;
            // 登录成功之后才有PID
            userInfo.hasLogin().then(function(s){
                if(s){
                    n.PID = userInfo.partnerId;
                }
            });
            var where = "";
            for(var k in o){
                where += " AND [" + k + "]='" + o[k] + "'";
            }
            var def = new Deferred();
            window.loadData({
                modalName: "XSY_TSSCF_DEVICE",
                where: where,
                pageIndex: 1,
                pageSize: 1
            }).then(function(rtn){
                var data = {};
                if(rtn.length == 1){
                    data.o = {};
                    for(var k in rtn[0]){
                        data.o[k] = rtn[0][k];
                    }
                }
                data.n = {};
                for(var k in n){
                    data.n[k] = n[k];
                }
                def.resolve(data);
            });
            def.then(function(dt){
                xhr("POST", {
                    url:"/w/data/update/" + window.g_sys_info.code,
                    handleAs:"json",
                    content:{
                        data:json.toJson({
                            modalName:"XSY_TSSCF_DEVICE",
                            data:[dt]
                        })
                    },
                    load:function(){
                    }
                });
            });
        },
        onNewPushMessage: function() {

        }
    },other ? other : "ios" === cqthinkinfo.os ? {
        //ios系统中推送通知的处理
        //注册设备信息
        regist: function() {
            var def = new Deferred();
            if(!this.deviceNo){
                window.plugins.pushNotification.register(lang.hitch(this,function(deviceNo) {
                    this.deviceNo = deviceNo;
                    def.resolve();
                }), function(res) {
                    def.resolve();
                }, {
                    "badge": "true",
                    "sound": "true",
                    "alert": "true",
                    "ecb": "onNotificationAPN"
                });
            }else{
                def.resolve();
            }
            return def;
        },
        //绑定设备收到推送通知的响应函数
        bandPushMessage: function() {
            window.onNotificationAPN = lang.hitch(this, function(e) {
                var str = "";
                for (var i in e) {
                    str += "," + i + ":" + e[i].toString();
                }
                window.plugins.pushNotification.setApplicationIconBadgeNumber(function(e) {
                }, function() {
                }, 0);
                if(e && e.alert) alert(e.alert);
                this.onNewPushMessage();
            });
        },
        //获取应用设备信息
        getAppDeviceInfo: function() {
            return this.deviceNo ? {
                "DEV_NO": this.deviceNo,
				"TYPE" : 0
            } : null;
        }
    } : "android" === cqthinkinfo.os ? {
		// android系统中推送通知的处理
		regist: function(){
			alert("android regist : " + this.deviceNo);
			var def = new Deferred();
			if(!this.deviceNo){
				// 将app key替换为百度提供的appkey值
				window.baidu_push.startWork("app key",lang.hitch(this, function(rtnJson){
					if(rtnJson.type === "onbind"){
						this.deviceNo = rtnJson.data.channelId;
						alert(this.deviceNo);
						def.resolve();
					}else if(rtnJson.type === "onnotificationarrived" || rtnJson.type === "onnotificationclicked"){
						if(rtnJson.data.description){
							alert(rtnJson.data.description);
						}
						this.onNewPushMessage();
					}
				}));
			}else{
				def.resolve();
			}
			return def;
		},
		bandPushMessage: function(){
			
		},
		getAppDeviceInfo: function(){
			return this.deviceNo ? {
				"DEV_NO": this.deviceNo,
				"TYPE" : 1
			} : null;
		}
	} : other);
    //现在只处理ios的应用
    appDeviceInfo._init();
    return appDeviceInfo;
});