define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "../orderCarRecord",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dojo/_base/array",
    "dojo/Deferred",
    "widgets/userInfo"
],function(declare,lang,orderCarRecord,xhr,json,array,Deferred,userInfo){
    return lang.mixin(lang.getObject("widgets.common.couponMixin", true),{
        //  获取可用的优惠券
        //  参数:
        //  购物车金额
        //  购物车商品
        getAvailableCoupons:function(){
            var def = new Deferred();
            //  如果是预售商品  则不能使用优惠券
            if(!orderCarRecord.IS_PRESALE)
            {
                //  获取购物车选中的商品
                var selectedMats = orderCarRecord.getSelectedMats(),
                    carItems = orderCarRecord.data.data.items,
                    mids = [],
                    totalAmt = 0;
                //  过滤掉购物车中选中的分销商品    并且计算购物车中直销商品的金额
                //  过滤掉 不允许积分支付的商品  2015-12-31 刘轩
                carItems = array.filter(carItems,function(item){
                    return ((item.T0_AID.APP_ID?item.T0_AID.APP_ID:item.T0_AID)==g_sys_info.aid)&&// 自己的商品
                        array.indexOf(selectedMats,item.T0_MID)>-1&&// 购物车中选中的商品
                        item.T0_IS_POINT==1;// 商品是否允许积分支付
                });
                array.forEach(carItems,function(item){
                    mids.push(item.T0_MID);
                    totalAmt += item.QTY*item.T3_RetailPrice;
                });
                userInfo.hasLogin().then(lang.hitch(this,function(s){
                    if(s)
                    {
                        //  查询我的可用的优惠券列表
                        //  条件:满抵金额大于当前要提交的购物车的金额
                        window.loadData({
                            modalName: "NY_TCRMK_COUPON",
                            filter: "05",
                            pageSize: "1",
                            pageIndex: "1",
                            orderBy:"[BID2.AMT] DESC",
                            param: {
                                "PID": userInfo.getUserInfo().partnerId,
                                "AMT": totalAmt
                            }
                        }).then(lang.hitch(this,function(data){
                            def.resolve(data);
                        }));
                    }
                    // 未登录   则直接返回空
                    else
                    {
                        def.resolve({});
                    }
                }));
            }
            else
            {
                def.resolve({});
            }
            
            return def;
        },
        // 查看商家是否有优惠活动
        getAppCoupons:function(){
            var def = new Deferred();
            window.loadData({
                modalName: "NY_TCRMK_DISCOUNTACT",
                filter: "02",
                pageSize: "2",
                pageIndex: "1",
                param: {}
            }).then(lang.hitch(this,function(data){
                if(data&&data.length)
                {
                    def.resolve(true);
                }
                else
                {
                    def.resolve(false);
                }
            }));
            return def;
        }
    });
});