define([
    "dojo/_base/lang",
    "dojo/_base/xhr",
    "dojo/Deferred"
],function(lang,xhr,Deferred){
    return lang.mixin(lang.getObject("widgets.common.matDisHandler",true),{
        currentDisInfo:{},
        getMatsDisRateByGroup:function(gid){
            var def = new Deferred();
            this._getDisInfo({
                matWhere:gid?"[MGroupID]='"+gid+"'":"1=1"
            },def);
            return def;
        },
        getMatsDisRateByID:function(mats,qtys){
            var def = new Deferred();
            this._getDisInfo({
                mats:mats.join(","),qtys:qtys&&qtys.join(",")||""
            },def);
            return def;
        },
        getMatsDisRateByGroupAid:function(gid){
            var def = new Deferred();
            this._getDisInfoByAid({
                matWhere:gid?"[MGroupID]='"+gid+"'":"1=1"
            },def);
            return def;
        },
        _getDisInfoByAid:function(param,def){
            xhr("POST",{
                url:"/w/data/GetMatsDisRateByAid/"+window.code+"-"+window.oepnId,
                handleAs:"json",
                content:{
                    aid:window.did
                },
                load:function(data){
                    var disInfo = {};
                    if(1==data.rtnType&&data.data&&data.data.items){
                        var item = null,len = data.data.items.length;
                        while(len--){
                            item = data.data.items[len];
                            disInfo[item.MID] = parseFloat(item.DIS_RATE);
                            disInfo[item.MID] = disInfo[item.MID]>=0?disInfo[item.MID]:1;
                        }
                    }
                    def.resolve(disInfo);
                },
                error:function(){
                    def.resolve({});
                }
            });
        },
        _getDisInfo:function(param,def){
            xhr("POST",{
                url:"/w/data/GetMatsDisRate/"+window.code+"-"+window.oepnId,
                handleAs:"json",
                load:function(data){
                    var disInfo = {};
                    if(1==data.rtnType&&data.data&&data.data.items){
                        var item = null,len = data.data.items.length;
                        while(len--){
                            item = data.data.items[len];
                            disInfo[item.MID] = parseFloat(item.DIS_RATE);
                            disInfo[item.MID] = disInfo[item.MID]>=0?disInfo[item.MID]:1;
                        }
                    }
                    def.resolve(disInfo);
                },
                error:function(){
                    def.resolve({});
                }
            });
        },
        setDisInfo:function(disInfo){
            this.currentDisInfo = lang.mixin(this.currentDisInfo||{},disInfo||{});
        },
        getCurrentDisInfo:function(){
            return this.currentDisInfo;
        }
        
    });
});