define([
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dojo/Deferred",
    "../orderCarRecord",
    "../userInfo"
    ], function(lang, array, xhr, json, Deferred, orderCarRecord, userInfo) {
    return lang.mixin(lang.getObject("widgets.common.orderHandler", true), {
        _addTranMats: function(mats, delType, r_mats, PACBUY_delType,city) {
            var def = new Deferred(),
                aidTotal = {}, aids = [];
            if((mats.length !=0 ) && (r_mats.length ==0 )){ //订单商品全是服务器商品修改配送方式
                delType = 3;
            }
            if (delType && (delType == 1||delType==3) || PACBUY_delType&&PACBUY_delType == 1) {
                def.resolve(true);
            } else {
                // 获取商品邮费信息
                var mids = [],amts = [],qtys = [];
                array.forEach(r_mats, function(mat) {
                    //如果没有每个货主的每个商品的金额
                    if (!aidTotal[mat.AID]) {
                        aids.push(mat.AID); //将商品AID放入aids中
                        aidTotal[mat.AID] = parseFloat(0);
                    }
                    //每个货主的商品金额
                    aidTotal[mat.AID] += parseFloat(mat.DeliAmount);
                    mids.push(mat.MID);
                    amts.push(mat.DeliAmount);
                    qtys.push(mat.QTY);
                });
                xhr("POST",{
                    url: "/w/TranFee/GetAppTranFee/" + window.code,
                    handleAs: "json",
                    content: {
                        mids:mids.join(","),//商品ID
                        amts:amts.join(","),//商品价格
                        qtys:qtys.join(","),//商品数量
                        city:city//区域ID
                    },
                    load: lang.hitch(this, function(result) {
                        if (1 === result.rtnType) {
                            var msg = "",
                                feeTtl = 0;
                            // 得到获取的邮费信息
                            for(var aid in result.data)
                            {
                                feeTtl += parseFloat(result.data[aid]);
                                msg =feeTtl>0?"订单需要加收"+window.fixedTo(feeTtl,3)+"元配送费":"";
                                mats.push({
                                    "MID": 29999,
                                    "AppliedQty": 1,
                                    "Price": result.data[aid],//appInfo.TRAN_FEE,
                                    "TranPrice": result.data[aid],//appInfo.TRAN_FEE, //结算价
                                    "DeliAmount": result.data[aid],//appInfo.TRAN_FEE,
                                    "State": "0",
                                    "IS_CANCEL": "0",
                                    "AID": aid,//appInfo.APP_ID,
                                    "Deposit": "0", // 2014-08-18处理优惠积分
                                    "D_TIMES": 1, //周期订单部分
                                    "E_NUM": 1,
                                    "IS_CYCLE": 0,
                                    "IS_PAUSE": 0
                                });
                            }
                            if (msg) {
                                //支持调用自定义的defConfirm方法.
                                this.customConfirm(msg).then(function(success) {
                                    def.resolve(success);
                                });
                            } else {
                                def.resolve(true);
                            }
                        } else {
                            alert(result.message || "获取邮费信息失败!");
                        }
                    })
                });
                
                //if(aids.length)
                //{
                    /*window.loadData({
                        modalName: "XSY_TSSCF_APP",
                        filter: "999",
                        pageSize: "1",
                        pageIndex: "1",
                        param: {
                            "INPUT": '',
                            "AID": aids
                        }
                    }).then(lang.hitch(this, function(data) {
                        var msg = "";
                        array.forEach(data, function(appInfo) {
                            var lmt = g_sys_info.aid == appInfo.APP_ID ? appInfo.DIR_LMT : appInfo.DIS_LMT;
                            if (lmt > 0 && lmt > aidTotal[appInfo.APP_ID]) {
                                msg += appInfo.APP_TITLE + "商品金额未满" + window.fixedTo(lmt, 3) + "，需加收" + window.fixedTo(appInfo.TRAN_FEE, 3) + "元配送费\n";
                                mats.push({
                                    "MID": 29999,
                                    "AppliedQty": 1,
                                    "Price": appInfo.TRAN_FEE,
                                    "TranPrice": appInfo.TRAN_FEE, //结算价
                                    "DeliAmount": appInfo.TRAN_FEE,
                                    "State": "0",
                                    "IS_CANCEL": "0",
                                    "AID": appInfo.APP_ID,
                                    "Deposit": "0", // 2014-08-18处理优惠积分
                                    "D_TIMES": 1, //周期订单部分
                                    "E_NUM": 1,
                                    "IS_CYCLE": 0,
                                    "IS_PAUSE": 0
                                });
                            }
                        });
                        if (msg) {
                            //支持调用自定义的defConfirm方法.
                            this.customConfirm(msg).then(function(success) {
                                def.resolve(success);
                            });
                        } else {
                            def.resolve(true);
                        }
                    }));*/
                //}
                //else
                //{
                //    def.resolve(true);
                //}
            }
            return def;
        },
        //支持调用自定义的defConfirm方法。defConfirm方法为异步方法
        customConfirm: function(msg) {
            if (window.defConfirm) {
                return window.defConfirm(msg);
            } else {
                //如未定义的defConfirm,调用原生confirm,并支持异步操作。
                var def = Deferred();
                def.resolve(confirm(msg));
                return def;
            }
        },
        _dealDeposit: function(mats) {
            var def = new Deferred();
            //加载分销商品ID，只有本帐套的商品才能定优惠政策
            window.loadData({
                modalName: "XSY_VBSSC_MAT",
                filter: "07",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "MID": array.map(mats, function(mat) {
                        return mat.MID;
                    })
                }
            }).then(lang.hitch(this, function(matData) {
                //找到商品ID和商品ID之间的对应关系
                var mids = [],
                    midHash = {};
                array.forEach(matData, function(mat) {
                    mids.push(mat.T0_MID);
                    midHash[mat.T0_MID] = mat.T0_MID;
                    midHash[mat.T0_MTID] = mat.T0_MID;
                });
                xhr("GET", {
                    url: "/w/data/GetMatsCredit/" + window.code + "-" + window.openId,
                    handleAs: "json",
                    content: {
                        mats: mids.join(",")
                    },
                    load: function(result) {
                        var desInfo = {};
                        if (result && result.data && result.data.items) {
                            //商品的积分政策
                            array.forEach(result.data.items, function(item) {
                                desInfo[item.MID] = parseFloat(item.CREDIT, 10) || 0;
                            });
                        }
                        array.forEach(mats, function(mat) {
                            mat.Deposit = mat.AppliedQty * (desInfo[midHash[mat.MID]] || 0);
                        });
                        //将提交结果直接返回给调用者
                        def.resolve(result);
                    },
                    error: function(err) {
                        //提交订单错误，返回错误及信息
                        def.resolve({
                            rtnType: "101",
                            message: err && err.message || "数据错误"
                        });
                    }
                });
            }));
            return def;
        },
        //获取商品信息，允许直接传入商品信息，没有传入时从购物车中读取
        _getMats: function(matInfo, delType, PACBUY_delType,city) {
            var def = new Deferred(),
                mats = [],
                r_mats = [];
            if (matInfo) {
                //找到所有要购买的商品
                var mids = [],
                    numCtlInfo = {};
                for (var mid in matInfo) {
                    mids.push(mid);
                }
                if (mids.length) {
                    //加载商品信息
                    window.loadData({
                        modalName: "XSY_VBSSC_MAT",
                        filter: "17",
                        pageSize: "1",
                        pageIndex: "1",
                        param: {
                            "MID": mids
                        }
                    }).then(lang.hitch(this, function(matData) {
                        //收集商品信息
                        // 将提交的数量为0 的商品过滤掉 2015-12-25 刘轩
                        matData = array.filter(matData,function(mat){
                            return matInfo[mat.T0_MID].QTY-0>0;
                        });
                        array.forEach(matData, function(mat) {
                            if (true !== (0 < mat.T3_RetailPrice)) {
                                mat.T3_RetailPrice = mat.T3_SettlePrice = matInfo[mat.T0_MID].AMT / matInfo[mat.T0_MID].QTY;
                            }
                            if (true !== (0 < mat.T3_SettlePrice)) {
                                mat.T3_SettlePrice = mat.T3_RetailPrice;
                            }
                            mats.push({
                                "MID": mat.T0_MID, // 商品ID
                                "GName": mat.T0_GName,
                                "T0_TPCH_NUM": mat.T0_TPCH_NUM,
                                "AppliedQty": matInfo[mat.T0_MID].QTY, // 商品数量
                                "Price": mat.T3_RetailPrice, // 商品零售价
                                "TranPrice": mat.T3_SettlePrice, // 商品分销价
                                "DeliAmount": mat.T3_RetailPrice * matInfo[mat.T0_MID].QTY, // 商品金额
                                "State": "0", // 审核
                                "IS_CANCEL": "0", // 作废
                                "AID": mat.T0_AID, // 帐套ID，谁的商品就是存谁的AID
                                "Deposit": 0, // 2014-08-18处理优惠积分
                                "D_TIMES": matInfo[mat.T0_MID].QTY * mat.T0_AssiUnitRate, //周期订单部分
                                "E_NUM": (mat.T0_IS_CYCLE == 1) ? 1 : matInfo[mat.T0_MID].QTY, //配送次数
                                "IS_CYCLE": mat.T0_IS_CYCLE, // 是否周期订单
                                "IS_PAUSE": 0 // 是否暂停配送
                            });
                            if(mat.T0_SERVICE_TYPE != "1"){ //服务类商品不收邮费
                                r_mats.push({
                                    "MID": mat.T0_MID, // 商品ID
                                    "DeliAmount": mat.R_AMNT ? mat.R_AMNT : mat.T3_RetailPrice * matInfo[mat.T0_MID].QTY,
                                    "AID": mat.T0_AID,
                                    "QTY":mat.QTY
                                });
                            }
                        });
                        //处理赠送积分和运费
                        this._dealDeposit(mats).then(lang.hitch(this, function() {
                            this._addTranMats(mats, delType, r_mats, PACBUY_delType,city).then(function(success) {
                                def.resolve(success ? mats : "");
                            });
                        }));
                    }));
                } else {
                    //没有要购买的商品
                    def.resolve([]);
                }
            } else {
                var items = orderCarRecord.data.data.items;
                var selectedMats = orderCarRecord.getSelectedMats();
                // 将提交订单中数量为0的行清空 刘轩 2015-12-25
                items = array.filter(items,function(item){
                    return item.QTY-0>0;
                });
                //从购物车中获取订单商品信息
                for (var index = 0; index < items.length; index++) {
                    if (0 === selectedMats.length || array.indexOf(selectedMats, items[index].T0_MID) >= 0) {
                        mats.push({
                            "MID": items[index].T0_MID, // 商品ID
                            "GName": items[index].T0_GName,
                            "T0_TPCH_NUM": items[index].T0_TPCH_NUM,
                            "AppliedQty": items[index].QTY, // 商品数量
                            "Price": items[index].PRE_REPRIC ? items[index].PRE_REPRIC : items[index].T3_RetailPrice, // 商品零售价
                            "TranPrice": items[index].PRE_DISPRIC ? items[index].PRE_DISPRIC : items[index].T3_SettlePrice, // 商品分销价
                            "DeliAmount": items[index].AMNT, // 商品金额
                            "State": "0", // 审核
                            "IS_CANCEL": "0", // 作废
                            "AID": items[index].T0_AID.APP_ID ? items[index].T0_AID.APP_ID : items[index].T0_AID, // 帐套ID，谁的商品就是存谁的AID
                            "Deposit": items[index].DIS || "0", // 2014-08-18处理优惠积分
                            "D_TIMES": items[index].QTY * items[index].T0_AssiUnitRate, //周期订单部分
                            "E_NUM": (items[index].T0_IS_CYCLE == 1) ? 1 : items[index].QTY, //配送次数
                            "IS_CYCLE": items[index].T0_IS_CYCLE, // 是否周期订单
                            "IS_PAUSE": 0 // 是否暂停配送
                        });
                        if(items[index].T0_SERVICE_TYPE != "1"){
                            r_mats.push({
                                "MID": items[index].T0_MID, // 商品ID
                                "DeliAmount": items[index].R_AMNT ? items[index].R_AMNT : items[index].AMNT,
                                "AID": items[index].T0_AID.APP_ID ? items[index].T0_AID.APP_ID : items[index].T0_AID, // 帐套ID，谁的商品就是存谁的AID
                                "QTY":items[index].QTY
                            });
                        }
                    }
                }
                //处理运费
                this._addTranMats(mats, delType, r_mats,PACBUY_delType,city).then(function(success) {
                    //this._addTranMats(mats,delType).then(function(success){
                    def.resolve(success ? mats : "");
                });
            }
            return def;
        },
        //获取完整订单信息
        //  参数:收货人
        //  参数:收货人电话
        //  参数:收货人地址
        //  参数:备注
        //  参数:商品信息,数组
        //  参数:是否从购物车提交
        //  参数:订单交易类型,0,B2C,1,C2C
        //  参数:需求提供者
        _getOrderInfo: function(name, tel, addr, remark, mats, fromOrderCar, type, spid, orderWay, odInfo, delType, couponId, PACBUY_TEAMID,PACBUY_delType) {
            //订单基本信息
            var info = {
                "ConsigneeName": name,
                "ConsigneeNumber": tel,
                "ConsigneeAddres": addr,
                "OPENID": window.wx_openId ? window.wx_openId : "", //关注者ID
                "Maker": name,
                "Remark": remark,
                ConsigneeGender: userInfo.getUserInfo().sex,
                "SRCPID": window.srcPid || "", //来源客户ID
                "HDID": orderCarRecord.HDID || "", //预售活动ID
                "DeptID": userInfo.getUserInfo().DeptID,
                Earnest: 0,
                IS_PRESALE: 0,
                TotalPrice: 0,
                mats: mats,
                "ORDERWAY": orderWay || "", //订货途径
                "SNDID": odInfo && odInfo.SNDID || "",
                "DeliveryTypeID": delType || 2,
                "COUPONID": couponId || "",
                "PACBUY_TEAMID":PACBUY_TEAMID || "", //拼团团队id,
                "PACBUY_delType":PACBUY_delType||"" //拼团商品是否包邮(1是包邮，0是不包邮)
            };
            //订单总额
            array.forEach(mats, function(mat) {
                info.TotalPrice += (mat.DeliAmount - 0) || 0;
            });
            if (fromOrderCar) {
                //定金
                info.Earnest = parseFloat(orderCarRecord.ear) || 0;
                //预售订单
                info.IS_PRESALE = orderCarRecord.IS_PRESALE || 0;
            }
            //如果有订单类型且订单类型是c2c
            if ( !! (type && type == 1)) {
                info.S_PID = spid;
                info.B_TYPE = type;
            }
            return info;
        },
        //获取验证订单信息的提示信息，通过验证时没有信息
        _validOrderInfoMessage: function(orderInfo) {
            var def = new Deferred();
            // 如果消费者是选择的自提 则不需要提交 收货信息 也不需要检查收货信息是否为空 2016-01-04 刘轩
            // 若是预约 则需要填写姓名和电话
            if (!orderInfo.ConsigneeName&&(orderInfo.DeliveryTypeID==2||orderInfo.DeliveryTypeID==3)) {
                def.resolve("姓名不能为空！");
            } else if (!orderInfo.ConsigneeNumber&&(orderInfo.DeliveryTypeID==2||orderInfo.DeliveryTypeID==3)) {
                def.resolve("电话不能为空！");
            } else if (!orderInfo.ConsigneeAddres && orderInfo.DeliveryTypeID==2) {//||orderInfo.DeliveryTypeID != 3
                def.resolve("地址不能为空！");
            } else if ("string" === orderInfo.mats) {
                def.resolve(orderInfo.mats);
            } else if (0 === orderInfo.mats.length) {
                def.resolve("请先选择商品");
            } else {
                //检查限购商品相关信息
                //mids:保存所有永久限购商品  yjMids：保存过滤掉分时限购的永久限购商品 fsMids：保存分时限购的商品
                var //matNum = {},//
                mids = [],
                yjMats = orderInfo.mats,
                yjMatNum = {},// 永久限购
                fsMatNum = {},// 分时限购
                yjMids = [],// 购物车中有永久限购数量的商品
                fsMids = [],
                fsWhere = "[T0_PartnerID.T1_OPENID]='"+userInfo.getUserInfo().openId+
                "' AND [T0_AID]=@AID AND [T4_IS_CANCEL]=0 AND (";//
                array.forEach(orderInfo.mats, function(mat) {
                    if (0 < mat.T0_TPCH_NUM) {
                        yjMids.push(mat.MID);
                        yjMatNum[mat.MID] = yjMatNum[mat.MID] || {
                            GName:mat.GName,
                            num: mat.T0_TPCH_NUM,
                            num2: 0,
                            num3: 0,
                        };
                        yjMatNum[mat.MID].num2 += mat.AppliedQty - 0;
                    }
                    if(mat.MID!=29999)
                    {
                        mids.push(mat.MID);
                    }
                });
                //加载商品限购的子表
                window.loadData({
                    modalName: "NY_TBSSC_MAT_ACTIVITY",
                    filter: "01",
                    pageSize: "1",
                    pageIndex: "1",
                    param: {
                        "MID": mids,
                        "CURTIME": g_s.getDateTime()
                    }
                }).then(lang.hitch(this, function(datas) {
                    if (datas.length) {
                        array.forEach(datas,function(data,i){
                            fsMids.push(data.MID);
                            if (0 < data.TPCH_NUM) {
                                fsMatNum[data.MID] = fsMatNum[data.MID] || {
                                    GName: data["MID.GName"],
                                    num: data.TPCH_NUM,
                                    num2: 0,
                                    num3: 0,
                                    sdate:data.StartDate,
                                    edate:data.EndDate
                                };
                                array.forEach(orderInfo.mats,function(mat){
                                    if(data.MID==mat.MID)
                                    {
                                        fsMatNum[data.MID].num2 += mat.AppliedQty - 0;//[data.MID]
                                    }
                                });
                                fsWhere +="([T4_MID]="+data.MID +" AND '"+fsMatNum[data.MID].sdate+"'<=[T0_BillDate] AND '"+fsMatNum[data.MID].edate+"'>=[T0_BillDate])"+(i==datas.length-1?"":" OR ");
                            }
                            // 如果分时限购的MID 在永久限购中 将永久限购中的MID删除
                            array.forEach(fsMids,function(fsMid,fsIndex){
                                array.forEach(yjMids,function(yjMid,yjIndex){
                                   if(fsMid==yjMid){
                                        yjMids.splice(yjIndex,1);
                                        delete yjMatNum[data.MID];
                                   } 
                                });
                            });
                        });
                        fsWhere += ")";
                    }
                    if (0 === yjMids.length && 0 === fsMids.length) { //没有限购商品
                        def.resolve();
                    } else {
                        var msg = "";
                        // 检查分时限购
                        if(datas.length)
                        {
                            window.loadData({
                                modalName: "XSY_VSDSG_DELIVERYBILL2",
                                //找到购物车中包含分时限购商品的订单
                                //应该要包括未支付的，如果有未支付的，就要提示他去支付而不是重新下单
                                //filter: "35",
                                pageSize: "1",
                                pageIndex: "1",
                                where:fsWhere
                            }).then(lang.hitch(this, function(data) {
                                //收集每个商品的未取消订单商品数量
                                array.forEach(data, function(mat) {
                                    fsMatNum[mat.T4_MID].num3 += mat.T4_AppliedQty - 0;
                                });
                                for (var mid in fsMatNum) {
                                    if (fsMatNum[mid].num - fsMatNum[mid].num2 - fsMatNum[mid].num3 < 0) {
                                        //所有数量超过限购数量的要给出提示
                                        msg += "购物车中商品" + fsMatNum[mid].GName + (fsMatNum[mid].num3 > 0 ? ("在"+fsMatNum[mid].sdate+"到"+fsMatNum[mid].edate+"的限购时间内，未取消订单数量" + window.fixedTo(fsMatNum[mid].num3, 0) + "加上") : "") + "本次购买数量" + window.fixedTo(fsMatNum[mid].num2, 0) + "大于限购数量" + window.fixedTo(fsMatNum[mid].num, 0) + "。\n";
                                    }
                                }
                                // 检查永久限购
                                window.loadData({
                                    modalName: "XSY_VSDSG_DELIVERYBILL2",
                                    //找到购物车中包含的限购商品的订单
                                    //应该要包括未支付的，如果有未支付的，就要提示他去支付而不是重新下单
                                    filter: "10",
                                    pageSize: "1",
                                    pageIndex: "1",
                                    param: {
                                        "OPENID": userInfo.getUserInfo().openId,
                                        "MID": yjMids
                                    }
                                }).then(function(data1) {
                                    //收集每个商品的未取消订单商品数量
                                    array.forEach(data1, function(mat) {
                                        yjMatNum[mat.T4_MID].num3 += mat.T4_AppliedQty - 0;
                                    });
                                    for (var mid in yjMatNum) {
                                        if (yjMatNum[mid].num - yjMatNum[mid].num2 - yjMatNum[mid].num3 < 0) {
                                            //所有数量超过限购数量的要给出提示
                                            msg += "购物车中商品" + yjMatNum[mid].GName + (yjMatNum[mid].num3 > 0 ? ("，未取消订单数量" + window.fixedTo(yjMatNum[mid].num3, 0) + "加上") : "") + "本次购买数量" + window.fixedTo(yjMatNum[mid].num2, 0) + "大于限购数量" + window.fixedTo(yjMatNum[mid].num, 0) + "。\n";
                                        }
                                    }
                                    def.resolve(msg);
                                });
                            }));
                        }
                        else
                        {
                        // 检查永久限购
                        window.loadData({
                            modalName: "XSY_VSDSG_DELIVERYBILL2",
                            //找到购物车中包含的限购商品的订单
                            //应该要包括未支付的，如果有未支付的，就要提示他去支付而不是重新下单
                            filter: "10",
                            pageSize: "1",
                            pageIndex: "1",
                            param: {
                                "OPENID": userInfo.getUserInfo().openId,
                                "MID": yjMids
                            }
                        }).then(function(data1) {
                            //收集每个商品的未取消订单商品数量
                            array.forEach(data1, function(mat) {
                                yjMatNum[mat.T4_MID].num3 += mat.T4_AppliedQty - 0;
                            });
                            for (var mid in yjMatNum) {
                                if (yjMatNum[mid].num - yjMatNum[mid].num2 - yjMatNum[mid].num3 < 0) {
                                    //所有数量超过限购数量的要给出提示
                                    msg += "购物车中商品" + yjMatNum[mid].GName + (yjMatNum[mid].num3 > 0 ? ("，未取消订单数量" + window.fixedTo(yjMatNum[mid].num3, 0) + "加上") : "") + "本次购买数量" + window.fixedTo(yjMatNum[mid].num2, 0) + "大于限购数量" + window.fixedTo(yjMatNum[mid].num, 0) + "。\n";
                                }
                            }
                            def.resolve(msg);
                        });
                        }
                    }
                }));
            }
            // 如果收货人或者地址为空时。在提交订单之前将收货人、地址、电话信息保存到address表中。2014-08-14，刘
            // 判断window的属性 是否修改个人信息 若配置为不修改 则不修改个人信息
            if ((!userInfo.getUserInfo().name || !userInfo.getUserInfo().addr)&&(window.mdfUserInfo==undefined||window.mdfUserInfo==1)) {
                userInfo.mdfUserInfo({
                    name: orderInfo.ConsigneeName,
                    tel: orderInfo.ConsigneeNumber,
                    addr: orderInfo.ConsigneeAddres
                });
            }
            return def;
        },
        // 检查订单数据合法性并提交订单
        __postOrder: function(orderInfo, def) {
            //检查订单数据的合法性
            this._validOrderInfoMessage(orderInfo).then(function(message) {
                if (message) {
                    //订单信息不合法，返回错误
                    def.resolve({
                        rtnType: "101",
                        message: message
                    });
                } else {
                    //订单信息合法，执行提交订单操作
                    xhr("POST", {
                        url: "/w/order/SaveOrder/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                        handleAs: "json",
                        content: {
                            data: json.toJson(orderInfo)
                        },
                        load: function(result) {
                            //将提交结果直接返回给调用者
                            def.resolve(result);
                        },
                        error: function(err) {
                            //提交订单错误，返回错误及信息
                            def.resolve({
                                rtnType: "101",
                                message: err && err.message || "数据错误"
                            });
                        }
                    });
                }
            });
        },
        //提交订单
        postOrder: function(name, tel, addr, remark, matInfo, delType, alterFunction, couponId, PACBUY_TEAMID,PACBUY_delType,city) {
            window.busy();
            var def = new Deferred();
            //获取商品信息
            this._getMats(matInfo, delType, PACBUY_delType,city).then(lang.hitch(this, function(mats) {
                //获取订单完整信息
                var orderInfo = this._getOrderInfo(name, tel, addr, remark, mats, !matInfo, null, null, 4, null, delType ,couponId, PACBUY_TEAMID,PACBUY_delType);
                //如果回调函数不为空，则调用回调函数修改订单信息
                var result = (alterFunction || function() {})(orderInfo);
                //出错时，返回值为false，终止提交
                if (false === result) {
                    def.resolve({
                        rtnType: "101",
                        message: "数据错误"
                    });
                } else if (result && result.then) { // 返回值为deferred时
                    result.then(lang.hitch(this, function(info) {
                        if (false === info) {
                            def.resolve({
                                rtnType: "101",
                                message: "数据错误"
                            });
                        } else {
                            this.__postOrder(info, def);
                        }
                    }));
                } else {
                    this.__postOrder(orderInfo, def);
                }
            }));
            def.then(window.free);
            return def;
        },
        payOrder: function(billCode, type, callback, total, noPoint) {
            window.busy();
            require(["widgets/orderPayHandler"], function(orderPayHandler) {
                if (type) {
                    orderPayHandler.pay({
                        billCode: billCode,
                        payType: type
                    }, callback);
                } else {
                    orderPayHandler.selectPayType(g_sys_info.aid, total, noPoint).then(function(payType) {
                        window.busy();
                        orderPayHandler.pay({
                            billCode: billCode,
                            payType: payType
                        }, callback);
                    });
                }
            });
        },
        //关于积分充值等虚拟商品不计算运费的获取商品信息的函数
        _getVirtualMats: function(matInfo) {
            var def = new Deferred(),
                mats = [];
            if (matInfo) {
                //找到所有要购买的商品
                var mids = [],
                    numCtlInfo = {};
                for (var mid in matInfo) {
                    mids.push(mid);
                }
                if (mids.length) {
                    //加载商品信息
                    window.loadData({
                        modalName: "XSY_VBSSC_MAT",
                        filter: "17",
                        pageSize: "1",
                        pageIndex: "1",
                        param: {
                            "MID": mids
                        }
                    }).then(lang.hitch(this, function(matData) {
                        //收集商品信息
                        // 将提交订单中数量为0的商品过滤掉 刘轩 2015-12-25
                        matData = array.filter(matData,function(mat){
                            return matInfo[mat.T0_MID].QTY-0>0;
                        });
                        array.forEach(matData, function(mat) {
                            if (true !== (0 < mat.T3_RetailPrice)) {
                                mat.T3_RetailPrice = mat.T3_SettlePrice = matInfo[mat.T0_MID].AMT / matInfo[mat.T0_MID].QTY;
                            }
                            if (true !== (0 < mat.T3_SettlePrice)) {
                                mat.T3_SettlePrice = mat.T3_RetailPrice;
                            }
                            mats.push({
                                "MID": mat.T0_MID, // 商品ID
                                "GName": mat.T0_GName,
                                "T0_TPCH_NUM": mat.T0_TPCH_NUM,
                                "AppliedQty": matInfo[mat.T0_MID].QTY, // 商品数量
                                "Price": mat.T3_RetailPrice, // 商品零售价
                                "TranPrice": mat.T3_SettlePrice, // 商品分销价
                                "DeliAmount": mat.T3_RetailPrice * matInfo[mat.T0_MID].QTY, // 商品金额
                                "State": "0", // 审核
                                "IS_CANCEL": "0", // 作废
                                "AID": mat.T0_AID, // 帐套ID，谁的商品就是存谁的AID
                                "Deposit": 0, // 2014-08-18处理优惠积分
                                "D_TIMES": matInfo[mat.T0_MID].QTY * mat.T0_AssiUnitRate, //周期订单部分
                                "E_NUM": (mat.T0_IS_CYCLE == 1) ? 1 : matInfo[mat.T0_MID].QTY, //配送次数
                                "IS_CYCLE": mat.T0_IS_CYCLE, // 是否周期订单
                                "IS_PAUSE": 0 // 是否暂停配送
                            });
                        });
                        //处理赠送积分和运费
                        this._dealDeposit(mats).then(lang.hitch(this, function() {
                            def.resolve(mats);
                        }));
                    }));
                } else {
                    //没有要购买的商品
                    def.resolve([]);
                }
            }
            return def;
        },
        //提交虚拟商品订单
        postVirtualOrder: function(name, tel, addr, remark, matInfo, type, spid, orderWay, odInfo) {
            window.busy();
            var def = new Deferred();
            //获取商品信息
            this._getVirtualMats(matInfo).then(lang.hitch(this, function(mats) {
                //获取订单完整信息
                var orderInfo = this._getOrderInfo(name, tel, addr, remark, mats, !matInfo, type, spid, orderWay, odInfo);
                //检查订单数据的合法性
                this._validOrderInfoMessage(orderInfo).then(function(message) {
                    if (message) {
                        //订单信息不合法，返回错误
                        def.resolve({
                            rtnType: "101",
                            message: message
                        });
                    } else {
                        //订单信息合法，执行提交订单操作
                        xhr("POST", {
                            url: "/w/order/SaveOrder/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                            handleAs: "json",
                            content: {
                                data: json.toJson(orderInfo)
                            },
                            load: function(result) {
                                //将提交结果直接返回给调用者
                                def.resolve(result);
                            },
                            error: function(err) {
                                //提交订单错误，返回错误及信息
                                def.resolve({
                                    rtnType: "101",
                                    message: err && err.message || "数据错误"
                                });
                            }
                        });
                    }
                });
            }));
            def.then(window.free);
            return def;
        }
    });
});