define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dijit/registry",
    "dojo/query",
    "widgets/userInfo",
    "dojo/topic",
    "dojo/dom-attr",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "cqthink/mobile/geoUtil",
    "cqthink/app/plugins/geolocation",
    "dojo/Deferred"
],function(declare, lang, domConstruct, registry, query, userInfo,topic,domAttr,json,xhr,geoUtil,geolocation,Deferred){
    return lang.mixin(lang.getObject("widgets.common.villagerInfo",true),{
        //成为村民
        toBeVillager:function(AID,PID){
            var def = new Deferred(); 
            var data ={
                o: {
                    AID: AID,
                    PID: PID //客户
                },
                n: {
                    AID: AID,
                    PID: PID, //客户
                    V_NAME:userInfo.getUserInfo().name,
                    BIRTH:userInfo.getUserInfo().birthDay
                }
            };
            xhr("POST", {
                url: "../../../w/data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    data: json.toJson({
                        modalName: "NY_TCRCS_VILLAGER",
                        data: [data]
                    })
                },
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                       def.resolve(true);
                    }else{
                        def.resolve(false);
                    }
                })
            });
            return def;
        },
        //发送村民关系更新请求
        //参数:AID:村 V_A_ID:当前村民  V_B_ID:村民B RS_ID:关系ID hasRS:表明是重置还是直接更新
        //返回值,无
        postUpdateRelationship:function(AID,V_A_ID,V_B_ID,RS_ID,IS_OPEN){
            //执行xhr,发送更新请求,执行服务器端程序
            //重置成功,给出重置成功的提示
            //重置失败,给出重置失败的提示
            var def = new Deferred();
            xhr("GET", {
                url: "/w/villager/postVillagerRelationship/" + window.code,//服务器端程序的路径
                handleAs: "json",
                content: {
                    AID:AID,
                    V_A_ID:V_A_ID,
                    V_B_ID:V_B_ID,
                    RS_ID:RS_ID,
                    IS_OPEN:IS_OPEN
                },
                load: lang.hitch(this, function(result) {
                    def.resolve(result);
                })
            });
            return def;
        },
        //处理村民之间的关系
        //参数:AID:村 V_A_ID:当前村民  V_B_ID:村民B RS_ID:关系ID
        //返回值,无
        relationshipWithHim:function(AID,V_A_ID,V_B_ID,RS_ID,IS_OPEN){
            var def = new Deferred();
            //通过在资源中新建过滤器的方式,根据AID,V_A_ID,V_B_ID查询数据
            window.loadData({
                modalName: "NY_TCRCS_VILLAGER_RELATION", //村民关系
                filter: "01",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "AID": AID,
                    "V_A_ID":V_A_ID,
                    "V_B_ID":V_B_ID
                }
            }).then(lang.hitch(this,function(data){
                if(data.length>0){
                    //如果返回的数据长度不为0,说明两个村民之间存在关系,提示是否重置关系
                    if(confirm("您与该村民已存在关系,是否重置?")){
                        this.postUpdateRelationship(AID,V_A_ID,V_B_ID,RS_ID,IS_OPEN).then(lang.hitch(this,function(result){
                            def.resolve(result);
                        }));
                    }
                }else{
                    //长度为0,直接进行更新
                    this.postUpdateRelationship(AID,V_A_ID,V_B_ID,RS_ID,IS_OPEN).then(lang.hitch(this,function(result){
                        def.resolve(result);
                    }));
                }
                
            }));
            return def;
        },
        //查询某一村民的社会关系
        //参数AID:村 VILLAGER_ID:村民AID
        //返回值:data:长度为零,说明该村民没有社会关系,不为零,表示该村民已有的社会关系
        qryVillagerRelationship:function(AID,VILLAGER_ID){
            //根据AID,VILLAGER_ID查询当前村民的社会关系,并返回
            //资源NY_TCRCS_VILLAGER_RELATION
            //使用window.loadData函数,通过在资源中新建资源过滤器来实现,参数AID,VILLAGER_ID
            var def = new Deferred();
            window.loadData({
                modalName: "NY_TCRCS_VILLAGER_RELATION", //村民关系
                filter: "02",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "AID": AID,
                    "V_A_ID":VILLAGER_ID
                }
            }).then(lang.hitch(this,function(data){
                def.resolve(data);
            }));
            return def;
        },
        //是否已经成为某一村村民
        //参数:AID:村 PID:客户ID 
        //返回值,data:表示是村民数据,false:表示不是该村村民
        isVillager:function(AID,PID){
            //根据AID ,PID查询资源中是否存在数据,代表存在该村民,返回true,否则,返回false
            //资源NY_TCRCS_VILLAGER
            var def = new Deferred();
            window.loadData({
                modalName: "NY_TCRCS_VILLAGER", //村民关系
                filter: "01",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "AID": AID,
                    "PID":PID
                }
            }).then(lang.hitch(this,function(data){
                if(data.length>0){
                    def.resolve(data);
                }else{
                    def.resolve(false);
                }
            }));
            return def;
        },
        //判断我与他是否存在关系
        //参数:AID:村，V_A_ID:我, V_B_ID:他
        //返回值:true/false
        isCreateRelationship:function(AID,V_A_ID, V_B_ID){
            var def = new Deferred();
            window.loadData({
                modalName: "NY_TCRCS_VILLAGER_RELATION", //村民关系
                filter: "01",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "AID": AID,
                    "V_A_ID":V_A_ID,
                    "V_B_ID":V_B_ID
                }
            }).then(lang.hitch(this,function(data){
                if(data.length>0){
                    def.resolve(true);
                }else{
                    def.resolve(false);
                }
            }));
            return def;
        }
    });
});