define([
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/dom-construct",
    "dojo/query",
    "dojo/_base/xhr",
    "dojo/ready",
    "dojo/topic",
    "dojo/dom-style",
    ], function(lang, array, connect, domConstruct, query, xhr, ready, topic, domStyle) {
    var config = lang.mixin(lang.getObject("widgets.config.wxConfig", true), {
        initWxConfig: function() {
            //alert("config")
            //获取Api参数
            xhr("GET", {
                url: "/w/WxAuth/GetSvcJsApiConfig/" + g_sys_info.code,
                content: {
                    u: location.href.split("#")[0]
                },
                handleAs: "json",
                load: lang.hitch(this, function(data) {
                    //alert(data && data.rtnType)
                    if (data && data.rtnType == 1) {
                        this.configWx(data.data);
                    }
                })
            });
        },
        configWx: function(data) {
            //配置微信接口
            wx.config({
                debug: false,
                appId: data.appId,
                timestamp: data.timestamp,
                nonceStr: data.nonceStr,
                signature: data.signature,
                jsApiList: this._getWxApiList()
            });
            wx.ready(lang.hitch(this, function(message) {
                //alert("message")
                this._onWxReady();
            }));
        },
        _onWxReady: function() {
            this._initRefreshList();
            //提供微信准备好的接口
            this.onWxReady();
        },
        _initRefreshList: function() {
            if (this._refreshListHanlder) {
                this._refreshListHanlder.remove();
            }
			if(this._refreshListHanlder2){
				this._refreshListHanlder2.remove();
			}
            this._refreshListHanlder = connect.connect(window, "onhashchange", this, this._refreshList);
			this._refreshListHanlder2 = connect.connect(history,"back",this,this._refreshList);
			this._refreshList();
        },
		_refreshList:function(){
			if(this._timer1){
				clearTimeout(this._timer1);
				clearTimeout(this._timer2);
				clearTimeout(this._timer3);
				clearTimeout(this._timer4);
			}
			this._timer1 = setTimeout(lang.hitch(this, this._bindEvent), 2000);
			this._timer1 = setTimeout(lang.hitch(this, this._bindEvent), 4000);
			this._timer1 = setTimeout(lang.hitch(this, this._bindEvent), 6000);
			this._timer1 = setTimeout(lang.hitch(this, this._bindEvent), 8000);
		},
		_bindEvent:function() {
			//alert("changing");
			try {
				array.forEach(this._getWxApiList(), function(api) {
					//alert("aaa")
					wx[api](this[api]());
				}, this);
			} catch (e) {
				//alert(e.message);
			}
			//alert("changed");
		},
        onWxReady: function() {},
        _getWxApiList: function() {
            return this.getShareApiList().concat(this.getActionApiList());
        },
        getShareApiList: function() {
            //这些事件需要对应的提供分享参数的毁掉函数
            return ["onMenuShareTimeline", //分享到朋友圈
            "onMenuShareAppMessage", //分享给朋友
            "onMenuShareQQ", //分享到QQ
            "onMenuShareWeibo", //分享到腾讯微博
            "onMenuShareQZone" //分享到QQ空间
            ];
        },
        onMenuShareTimeline: function() {
            return this._getShareInfo("onMenuShareTimeline");
        },
        onMenuShareAppMessage: function() {
            return this._getShareInfo("onMenuShareAppMessage");
        },
        onMenuShareQQ: function() {
            return this._getShareInfo("onMenuShareQQ");
        },
        onMenuShareWeibo: function() {
            return this._getShareInfo("onMenuShareWeibo");
        },
        onMenuShareQZone: function() {
            return this._getShareInfo("onMenuShareQZone");
        },
        _getShareInfo: function(api) {
            this.curView = window.getCurrentView();
            var nodes = query("img", this.curView.domNode),
                len = 0;
            while (len < nodes.length) {
                this.imgUrl = nodes[len].src;
                if (this.imgUrl.split("-").pop().match(/\d+/g) && nodes[len].width > 100) {
                    break;
                } else {
                    this.imgUrl = "";
                }
                len++;
            }
            var url = location.href.split("?")[0].split("#")[0];
            if(window.widgets&&widgets.userInfo){
                var info = widgets.userInfo.getUserInfo(),searchStr = "?";
                url += "?srcWxId="+(info.wxId||"")+"&srcPid="+(info.partnerId||"")
            }
            url += location.hash;
            
            return {
                title: document.title,
                link: url,
                desc: document.title,
                imgUrl: this.imgUrl,
                trigger: function() {},
                success: function() {},
                fail: function(message) {},
                cancel: function() {}
            };
        },
        getActionApiList: function() {
			return [];
		},
		alertDialog:null,
		showDialog:function(msg,def,type,cancelBtnName,okBtnName,jdKey){
    		if(!this.alertDialog){
    			return require([
    				"dojo/dom-construct",
    				"dojo/dom-style",
    				"dojox/mobile/SimpleDialog",
    				"dojox/mobile/Button",
    			],lang.hitch(this,function(domConstruct,domStyle,SimpleDialog,Button){
    			    this.alertDialog = new SimpleDialog({
                        //closeButton: true,
    				    //onCloseButtonClick:function(){
    				    //  this.executeAction(false);
    				    //}
    				});
    				_this = this;
    				this.alertDialog.executeAction = function(success){
    					if(this.def){
    						this.def.resolve(success);
    					}
    					_this.alertDialog.hide();
    				};
    				
    				this.alertDialog.msgNode = domConstruct.create("span",{
    					class:"msgDialog"
    				},this.alertDialog.containerNode);
    				
    				this.alertDialog.actionNode = domConstruct.create("div",{
    					class: "btnPDiv"
    				},this.alertDialog.containerNode);
    				
    				this.alertDialog.cancelButton = new Button({
    					label:cancelBtnName?cancelBtnName:"取消",
    					class:"cancelBtnDialog",
    					onClick:lang.hitch(this,function(){
    						this.alertDialog.executeAction(false);
    					})
    				});
    				this.alertDialog.actionNode.appendChild(this.alertDialog.cancelButton.domNode);
    				
    				this.alertDialog.okButton = new Button({
    					label:okBtnName?okBtnName:"确定",
    					class:"OKBtnDialog",
    					onClick:lang.hitch(this,function(){
    						this.alertDialog.executeAction(true);
    					})
    				});
    				this.alertDialog.actionNode.appendChild(this.alertDialog.okButton.domNode);
    				
    				this.alertDialog.startup();
    				return this.showDialog(msg,def,type,cancelBtnName,okBtnName,jdKey);
    			}));
    		}
    		//最多显示50个汉字
    		var reg = /[\.a-z0-9]/ig,msglen = msg.match(reg);
    		if(msglen !== null){
    		    var num = msg.length*2-msg.match(reg).length;
    		}else{
    		    var num = msg.length*2
    		}
    		if(jdKey){
    		    msg = msg.substr(0,jdKey);
    		} else if(num>99){
    		    msg = msg.substr(0,50)+"..."
    		}
    		this.alertDialog.msgNode.innerHTML = '<div>'+msg+'</div>';
    		domStyle.set(this.alertDialog.cancelButton.domNode,"display","alert"===type?"none":"");
    		if("alert"===type) domStyle.set(alertDialog.okButton.domNode,"margin-left","27.165%");
    		this.alertDialog.def = def;
    		this.alertDialog.show();
    		this.alertDialog.resize();
    	}
    });
    ready(function() {
        setTimeout(function() {
            ! //赵春辉   不能直接包含微信提供的js，其使用的AMD/CMD模式和dojo的加载机制有冲突，直接使用其程序会导致dojo加载模块失败
            function(a, b) {
                b(a, !0);
            }(this,

            function(a, b) {
                function c(b, c, d) {
                    a.WeixinJSBridge ? WeixinJSBridge.invoke(b, e(c),

                    function(a) {
                        g(b, a, d);
                    }) : j(b, d);
                }

                function d(b, c, d) {
                    a.WeixinJSBridge ? WeixinJSBridge.on(b,

                    function(a) {
                        d && d.trigger && d.trigger(a),
                        g(b, a, c)
                    }) : d ? j(b, d) : j(b, c)
                }

                function e(a) {
                    return a = a || {},
                    a.appId = C.appId,
                    a.verifyAppId = C.appId,
                    a.verifySignType = "sha1",
                    a.verifyTimestamp = C.timestamp + "",
                    a.verifyNonceStr = C.nonceStr,
                    a.verifySignature = C.signature,
                    a
                }

                function f(a) {
                    return {
                        timeStamp: a.timestamp + "",
                        nonceStr: a.nonceStr,
                        "package": a.package,
                        paySign: a.paySign,
                        signType: a.signType || "SHA1"
                    }
                }

                function g(a, b, c) {
                    var d, e, f;
                    switch (delete b.err_code, delete b.err_desc, delete b.err_detail, d = b.errMsg, d || (d = b.err_msg, delete b.err_msg, d = h(a, d), b.errMsg = d), c = c || {},
                    c._complete && (c._complete(b), delete c._complete), d = b.errMsg || "", C.debug && !c.isInnerInvoke && alert(JSON.stringify(b)), e = d.indexOf(":"), f = d.substring(e + 1)) {
                    case "ok":
                        c.success && c.success(b);
                        break;
                    case "cancel":
                        c.cancel && c.cancel(b);
                        break;
                    default:
                        c.fail && c.fail(b)
                    }
                    c.complete && c.complete(b)
                }

                function h(a, b) {
                    var e, f, c = a,
                        d = p[c];
                    return d && (c = d),
                    e = "ok",
                    b && (f = b.indexOf(":"), e = b.substring(f + 1), "confirm" == e && (e = "ok"), "failed" == e && (e = "fail"), - 1 != e.indexOf("failed_") && (e = e.substring(7)), - 1 != e.indexOf("fail_") && (e = e.substring(5)), e = e.replace(/_/g, " "), e = e.toLowerCase(), ("access denied" == e || "no permission to execute" == e) && (e = "permission denied"), "config" == c && "function not exist" == e && (e = "ok"), "" == e && (e = "fail")),
                    b = c + ":" + e
                }

                function i(a) {
                    var b, c, d, e;
                    if (a) {
                        for (b = 0, c = a.length; c > b; ++b) d = a[b],
                        e = o[d],
                        e && (a[b] = e);
                        return a
                    }
                }

                function j(a, b) {
                    if (!(!C.debug || b && b.isInnerInvoke)) {
                        var c = p[a];
                        c && (a = c),
                        b && b._complete && delete b._complete,
                        console.log('"' + a + '",', b || "")
                    }
                }

                function k() {
                    if (!(u || v || C.debug || "6.0.2" > z || B.systemType < 0)) {
                        var b = new Image;
                        B.appId = C.appId,
                        B.initTime = A.initEndTime - A.initStartTime,
                        B.preVerifyTime = A.preVerifyEndTime - A.preVerifyStartTime,
                        F.getNetworkType({
                            isInnerInvoke: !0,
                            success: function(a) {
                                B.networkType = a.networkType;
                                var c = "https://open.weixin.qq.com/sdk/report?v=" + B.version + "&o=" + B.isPreVerifyOk + "&s=" + B.systemType + "&c=" + B.clientVersion + "&a=" + B.appId + "&n=" + B.networkType + "&i=" + B.initTime + "&p=" + B.preVerifyTime + "&u=" + B.url;
                                b.src = c
                            }
                        })
                    }
                }

                function l() {
                    return (new Date).getTime()
                }

                function m(b) {
                    w && (a.WeixinJSBridge ? b() : q.addEventListener && q.addEventListener("WeixinJSBridgeReady", b, !1))
                }

                function n() {
                    F.invoke || (F.invoke = function(b, c, d) {
                        a.WeixinJSBridge && WeixinJSBridge.invoke(b, e(c), d)
                    },
                    F.on = function(b, c) {
                        a.WeixinJSBridge && WeixinJSBridge.on(b, c)
                    })
                }
                var o, p, q, r, s, t, u, v, w, x, y, z, A, B, C, D, E, F;
                if (!a.jWeixin) return o = {
                    config: "preVerifyJSAPI",
                    onMenuShareTimeline: "menu:share:timeline",
                    onMenuShareAppMessage: "menu:share:appmessage",
                    onMenuShareQQ: "menu:share:qq",
                    onMenuShareWeibo: "menu:share:weiboApp",
                    onMenuShareQZone: "menu:share:QZone",
                    previewImage: "imagePreview",
                    getLocation: "geoLocation",
                    openProductSpecificView: "openProductViewWithPid",
                    addCard: "batchAddCard",
                    openCard: "batchViewCard",
                    chooseWXPay: "getBrandWCPayRequest"
                },
                p = function() {
                    var b, a = {};
                    for (b in o) a[o[b]] = b;
                    return a
                }(),
                q = a.document,
                r = q.title,
                s = navigator.userAgent.toLowerCase(),
                t = navigator.platform.toLowerCase(),
                u = !(!t.match("mac") && !t.match("win")),
                v = -1 != s.indexOf("wxdebugger"),
                w = -1 != s.indexOf("micromessenger"),
                x = -1 != s.indexOf("android"),
                y = -1 != s.indexOf("iphone") || -1 != s.indexOf("ipad"),
                z = function() {
                    var a = s.match(/micromessenger\/(\d+\.\d+\.\d+)/) || s.match(/micromessenger\/(\d+\.\d+)/);
                    return a ? a[1] : ""
                }(),
                A = {
                    initStartTime: l(),
                    initEndTime: 0,
                    preVerifyStartTime: 0,
                    preVerifyEndTime: 0
                },
                B = {
                    version: 1,
                    appId: "",
                    initTime: 0,
                    preVerifyTime: 0,
                    networkType: "",
                    isPreVerifyOk: 1,
                    systemType: y ? 1 : x ? 2 : -1,
                    clientVersion: z,
                    url: encodeURIComponent(location.href)
                },
                C = {},
                D = {
                    _completes: []
                },
                E = {
                    state: 0,
                    data: {}
                },
                m(function() {
                    A.initEndTime = l()
                }),
                F = {
                    config: function(a) {
                        C = a,
                        j("config", a);
                        var b = C.check === !1 ? !1 : !0;
                        m(function() {
                            var a, d, e;
                            if (b) c(o.config, {
                                verifyJsApiList: i(C.jsApiList)
                            },

                            function() {
                                D._complete = function(a) {
                                    A.preVerifyEndTime = l(),
                                    E.state = 1,
                                    E.data = a
                                },
                                D.success = function() {
                                    B.isPreVerifyOk = 0
                                },
                                D.fail = function(a) {
                                    D._fail ? D._fail(a) : E.state = -1
                                };
                                var a = D._completes;
                                return a.push(function() {
                                    k()
                                }),
                                D.complete = function() {
                                    for (var c = 0,
                                    d = a.length; d > c; ++c) a[c]();
                                    D._completes = []
                                },
                                D
                            }()),
                            A.preVerifyStartTime = l();
                            else {
                                for (E.state = 1, a = D._completes, d = 0, e = a.length; e > d; ++d) a[d]();
                                D._completes = []
                            }
                        }),
                        C.beta && n()
                    },
                    ready: function(a) {
                        0 != E.state ? a() : (D._completes.push(a), !w && C.debug && a())
                    },
                    error: function(a) {
                        "6.0.2" > z || (-1 == E.state ? a(E.data) : D._fail = a)
                    },
                    checkJsApi: function(a) {
                        var b = function(a) {
                            var c, d, b = a.checkResult;
                            for (c in b) d = p[c],
                            d && (b[d] = b[c], delete b[c]);
                            return a
                        };
                        c("checkJsApi", {
                            jsApiList: i(a.jsApiList)
                        },

                        function() {
                            return a._complete = function(a) {
                                if (x) {
                                    var c = a.checkResult;
                                    c && (a.checkResult = JSON.parse(c))
                                }
                                a = b(a)
                            },
                            a
                        }())
                    },
                    onMenuShareTimeline: function(a) {
                        d(o.onMenuShareTimeline, {
                            complete: function() {
                                c("shareTimeline", {
                                    title: a.title || r,
                                    desc: a.title || r,
                                    img_url: a.imgUrl || "",
                                    link: a.link || location.href,
                                    type: a.type || "link",
                                    data_url: a.dataUrl || ""
                                },
                                a)
                            }
                        },
                        a)
                    },
                    onMenuShareAppMessage: function(a) {
                        d(o.onMenuShareAppMessage, {
                            complete: function() {
                                c("sendAppMessage", {
                                    title: a.title || r,
                                    desc: a.desc || "",
                                    link: a.link || location.href,
                                    img_url: a.imgUrl || "",
                                    type: a.type || "link",
                                    data_url: a.dataUrl || ""
                                },
                                a)
                            }
                        },
                        a)
                    },
                    onMenuShareQQ: function(a) {
                        d(o.onMenuShareQQ, {
                            complete: function() {
                                c("shareQQ", {
                                    title: a.title || r,
                                    desc: a.desc || "",
                                    img_url: a.imgUrl || "",
                                    link: a.link || location.href
                                },
                                a)
                            }
                        },
                        a)
                    },
                    onMenuShareWeibo: function(a) {
                        d(o.onMenuShareWeibo, {
                            complete: function() {
                                c("shareWeiboApp", {
                                    title: a.title || r,
                                    desc: a.desc || "",
                                    img_url: a.imgUrl || "",
                                    link: a.link || location.href
                                },
                                a)
                            }
                        },
                        a)
                    },
                    onMenuShareQZone: function(a) {
                        d(o.onMenuShareQZone, {
                            complete: function() {
                                c("shareQZone", {
                                    title: a.title || r,
                                    desc: a.desc || "",
                                    img_url: a.imgUrl || "",
                                    link: a.link || location.href
                                },
                                a)
                            }
                        },
                        a)
                    },
                    startRecord: function(a) {
                        c("startRecord", {},
                        a)
                    },
                    stopRecord: function(a) {
                        c("stopRecord", {},
                        a)
                    },
                    onVoiceRecordEnd: function(a) {
                        d("onVoiceRecordEnd", a)
                    },
                    playVoice: function(a) {
                        c("playVoice", {
                            localId: a.localId
                        },
                        a)
                    },
                    pauseVoice: function(a) {
                        c("pauseVoice", {
                            localId: a.localId
                        },
                        a)
                    },
                    stopVoice: function(a) {
                        c("stopVoice", {
                            localId: a.localId
                        },
                        a)
                    },
                    onVoicePlayEnd: function(a) {
                        d("onVoicePlayEnd", a)
                    },
                    uploadVoice: function(a) {
                        c("uploadVoice", {
                            localId: a.localId,
                            isShowProgressTips: 0 == a.isShowProgressTips ? 0 : 1
                        },
                        a)
                    },
                    downloadVoice: function(a) {
                        c("downloadVoice", {
                            serverId: a.serverId,
                            isShowProgressTips: 0 == a.isShowProgressTips ? 0 : 1
                        },
                        a)
                    },
                    translateVoice: function(a) {
                        c("translateVoice", {
                            localId: a.localId,
                            isShowProgressTips: 0 == a.isShowProgressTips ? 0 : 1
                        },
                        a)
                    },
                    chooseImage: function(a) {
                        c("chooseImage", {
                            scene: "1|2",
                            count: a.count || 9,
                            sizeType: a.sizeType || ["original", "compressed"],
                            sourceType: a.sourceType || ["album", "camera"]
                        },

                        function() {
                            return a._complete = function(a) {
                                if (x) {
                                    var b = a.localIds;
                                    b && (a.localIds = JSON.parse(b))
                                }
                            },
                            a
                        }())
                    },
                    previewImage: function(a) {
                        c(o.previewImage, {
                            current: a.current,
                            urls: a.urls
                        },
                        a)
                    },
                    uploadImage: function(a) {
                        c("uploadImage", {
                            localId: a.localId,
                            isShowProgressTips: 0 == a.isShowProgressTips ? 0 : 1
                        },
                        a)
                    },
                    downloadImage: function(a) {
                        c("downloadImage", {
                            serverId: a.serverId,
                            isShowProgressTips: 0 == a.isShowProgressTips ? 0 : 1
                        },
                        a)
                    },
                    getNetworkType: function(a) {
                        var b = function(a) {
                            var c, d, e, b = a.errMsg;
                            if (a.errMsg = "getNetworkType:ok", c = a.subtype, delete a.subtype, c) a.networkType = c;
                            else switch (d = b.indexOf(":"), e = b.substring(d + 1)) {
                            case "wifi":
                            case "edge":
                            case "wwan":
                                a.networkType = e;
                                break;
                            default:
                                a.errMsg = "getNetworkType:fail"
                            }
                            return a
                        };
                        c("getNetworkType", {},

                        function() {
                            return a._complete = function(a) {
                                a = b(a)
                            },
                            a
                        }())
                    },
                    openLocation: function(a) {
                        c("openLocation", {
                            latitude: a.latitude,
                            longitude: a.longitude,
                            name: a.name || "",
                            address: a.address || "",
                            scale: a.scale || 28,
                            infoUrl: a.infoUrl || ""
                        },
                        a)
                    },
                    getLocation: function(a) {
                        a = a || {},
                        c(o.getLocation, {
                            type: a.type || "wgs84"
                        },

                        function() {
                            return a._complete = function(a) {
                                delete a.type
                            },
                            a
                        }())
                    },
                    hideOptionMenu: function(a) {
                        c("hideOptionMenu", {},
                        a)
                    },
                    showOptionMenu: function(a) {
                        c("showOptionMenu", {},
                        a)
                    },
                    closeWindow: function(a) {
                        a = a || {},
                        c("closeWindow", {},
                        a)
                    },
                    hideMenuItems: function(a) {
                        c("hideMenuItems", {
                            menuList: a.menuList
                        },
                        a)
                    },
                    showMenuItems: function(a) {
                        c("showMenuItems", {
                            menuList: a.menuList
                        },
                        a)
                    },
                    hideAllNonBaseMenuItem: function(a) {
                        c("hideAllNonBaseMenuItem", {},
                        a)
                    },
                    showAllNonBaseMenuItem: function(a) {
                        c("showAllNonBaseMenuItem", {},
                        a)
                    },
                    scanQRCode: function(a) {
                        a = a || {},
                        c("scanQRCode", {
                            needResult: a.needResult || 0,
                            scanType: a.scanType || ["qrCode", "barCode"]
                        },

                        function() {
                            return a._complete = function(a) {
                                var b, c;
                                y && (b = a.resultStr, b && (c = JSON.parse(b), a.resultStr = c && c.scan_code && c.scan_code.scan_result))
                            },
                            a
                        }())
                    },
                    openProductSpecificView: function(a) {
                        c(o.openProductSpecificView, {
                            pid: a.productId,
                            view_type: a.viewType || 0,
                            ext_info: a.extInfo
                        },
                        a)
                    },
                    addCard: function(a) {
                        var e, f, g, h, b = a.cardList,
                            d = [];
                        for (e = 0, f = b.length; f > e; ++e) g = b[e],
                        h = {
                            card_id: g.cardId,
                            card_ext: g.cardExt
                        },
                        d.push(h);
                        c(o.addCard, {
                            card_list: d
                        },

                        function() {
                            return a._complete = function(a) {
                                var c, d, e, b = a.card_list;
                                if (b) {
                                    for (b = JSON.parse(b), c = 0, d = b.length; d > c; ++c) e = b[c],
                                    e.cardId = e.card_id,
                                    e.cardExt = e.card_ext,
                                    e.isSuccess = e.is_succ ? !0 : !1,
                                    delete e.card_id,
                                    delete e.card_ext,
                                    delete e.is_succ;
                                    a.cardList = b,
                                    delete a.card_list
                                }
                            },
                            a
                        }())
                    },
                    chooseCard: function(a) {
                        c("chooseCard", {
                            app_id: C.appId,
                            location_id: a.shopId || "",
                            sign_type: a.signType || "SHA1",
                            card_id: a.cardId || "",
                            card_type: a.cardType || "",
                            card_sign: a.cardSign,
                            time_stamp: a.timestamp + "",
                            nonce_str: a.nonceStr
                        },

                        function() {
                            return a._complete = function(a) {
                                a.cardList = a.choose_card_info,
                                delete a.choose_card_info
                            },
                            a
                        }())
                    },
                    openCard: function(a) {
                        var e, f, g, h, b = a.cardList,
                            d = [];
                        for (e = 0, f = b.length; f > e; ++e) g = b[e],
                        h = {
                            card_id: g.cardId,
                            code: g.code
                        },
                        d.push(h);
                        c(o.openCard, {
                            card_list: d
                        },
                        a)
                    },
                    chooseWXPay: function(a) {
                        c(o.chooseWXPay, f(a), a)
                    }
                },
                b && (a.wx = a.jWeixin = F),
                F
            });
			if(window.util&&window.util.versions&&window.util.versions.weixin){
				config.initWxConfig();
			}
        }, 1000);
    });
    return config;
});