define([
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/xhr",
    "dojo/dom-construct",
    "dojo/Deferred",
    "widgets/userInfo",
    "dojo/cookie",
    "dojo/dom-attr",
	"dojo/_base/json",
    "dojo/_base/connect"
],function(lang,array,xhr,domConstruct,Deferred,userInfo,cookie,domAttr,json,connect){
    var orderPayHandler = lang.mixin(lang.getObject("widgets.orderPayHandler",true),{
        payTypeDialog:null,
        //客户端支持的支付方式列表
        _getClientValidPayType:function(){
            //微信浏览器只有微信支付，否则有微信扫码支付和银联支付
            return window.WeixinJSBridge?[{
                type:"point",name:"积分支付"
            },{
                type:"weixin",name:"微信支付"
            },{
                type:"alipaywap",name:"在线支付"
            }]:[{
                type:"point",name:"积分支付"
            },{
                type:"unionpay",name:"银联支付"
            },{
                type:"chinapay",name:"银联电子支付"
            },{
                type:"alipaywap",name:"在线支付"
            },{
                type:"alipaydir",name:"在线支付"
            }];
        },
        //服务器端，商家支持的支付方式列表
        _getServerValidPayType:function(aid,total){
            var a=["weixin"];
            if(aid==window.g_sys_info.aid){
                if(window.g_sys_info.isCredit||(total&&total<=-userInfo.getUserInfo().arAmnt)){
                    a.push("point");
                }
            }
            if(window.util.versions.mobile){
                a.push("alipaywap");
            }else{
                a.push("alipaydir");
            }
            return array.filter(a,function(type){
                return -1<array.indexOf(window.g_sys_info.payType,type);
            });
        },
        //当前状态下顾客可选的支付方式
        getValidPayType:function(aid,total,notPoint){
            var serverValidType = this._getServerValidPayType(aid,total);
            if(notPoint){
                serverValidType = serverValidType.join(",").replace("point,","").replace(",point","").split(",");
            }
            return array.filter(this._getClientValidPayType(),function(item){
                return -1<array.indexOf(serverValidType,item.type);
            });
        },
        //若参数不合法，提示信息是什么
        _validPayParamMessage:function(param){
            switch(param.payType){
                case "upop":
                    break;
                case "chinapay":
                    break;
                case "weixin":
                    break;
                case "point":
                    break;
                case "alipaywap":
                    break;
                case "alipaydir":
                    break;
                default:
                    return "不支持的支付方式";
            }
            if (!param.billCode) {
                return "单据号不能为空";
            }
        },
        payEarnest:function(param,callback){
            return this._pay(param,callback,"/w/order/payEarnet/");
        },
        //发起支付请求，向服务器端发出支付需要的信息
        pay:function(param,callback){
            return this._pay(param,callback,"/w/order/payOrder/");
        },
        _pay:function(param,callback,baseUrl){
			if(this._lastPayTime&&Date.now()-this._lastPayTime<3000){
				return;
			}
			this._lastPayTime = Date.now();
			window.busy();
            var def = new Deferred(),message = this._validPayParamMessage(param);
            //变更 2015-11-06 刘丽 微信支付获取用户微信ID后返回支付无订单ID bug
            param.returnUrl = param.returnUrl||document.URL;
            if(message){
                alert(message);
                def.resolve();
            }else{
                if("weixin"==param.payType){
                    if(g_sys_info.wxType != 3&&window.WeixinJSBridge){
                        if(!cookie(g_sys_info.svcPlatCode+"_openid")){
                            //变更 2015-11-06 刘丽 微信支付获取用户微信ID后返回支付无订单ID bug
                            return window.directWxOpenId(g_sys_info.svcPlatCode,param.returnUrl+"_pay");
                        }else{
                            param.openId = cookie(g_sys_info.svcPlatCode+"_openid");
                        } 
                    }
                }
                xhr("POST", {
                    url: baseUrl + window.code+ "-" + window.openId + "?token=" + window.userInfo.token,
                    handleAs: "json",
                    content: param,
                    load: lang.hitch(this,function(result) {
                        /*alert(json.toJson(result));*/
                        if (result.rtnType == 1) {
                            param.data = result.data;
                            if(result.data&&result.data.payType){
                                param.payType = result.data.payType;
                            }
                            this._invokePayment(param,callback);
                            def.resolve(param);
                        } else {
                            alert(result.message);
                            callback();
                            def.resolve();
                            window.free();
                        }
                    }),
                    error:function(){
                        alert("发生错误");
                        def.resolve();
                        callback();
                        window.free();
                    }
                });
            }
            return def.then(function(){
                window.free();
            });
        },
        invokePayment:function(result,callback){
            console.log("对象widgets.orderPayHandler的方法invokePayment已废弃")
            return this._invokePayment(result,callback);
        },
        //执行支付操作，向目标服务器发起请求、调用浏览器的接口支付、生成二维码个付款方扫描
        _invokePayment:function(result,callback){
            if(result){
                /*alert(json.toJson(result));*/
                if(-1<"pointorcoin".indexOf(result.payType.toLowerCase())){
                    xhr("POST",{
                        url:result.data.action,
                        load:callback,
                        error:callback
                    });
                }else if("weixin"==result.payType){
                    if(window.WeixinJSBridge){
                        //判断微信类型g_sys_info
                        if(g_sys_info.wxType == 3){//如果为订阅号
                            //生成二维码
                            require([
                            "cqthink/image/qrCode"
                            ],function(qrCode){
                                var div1 = domConstruct.create("div",{
                                    "class":"paymentQrDiv"
                                },document.body),img1 = domConstruct.
                                create("div",{
                                    innerHTML:"请长按二维码支付喔~~",style:"font-size:20px;color:green;margin-top: 3%;"
                                },div1);
                                img1 = domConstruct.create("img",{
                                    "class":"paymentQrImg",
                                    src:qrCode.generatePNG(result.data.action,{
                                        modulesize: 5,
                                        margin: 2,
                                        ecclevel: "M"
                                    })
                                },div1);
                                img1 = domConstruct.create("span",{
                                    innerHTML:"完成",
                                    "class":"paymentQrBtn"
                                },div1);
                                img1.onclick = function(){
                                    div1.parentElement.removeChild(div1);
                                    div1 = null;
                                    callback&&callback();
                                };
                                img1 = domConstruct.create("span",{
                                    innerHTML:"取消",
                                    "class":"paymentQrBtn"
                                },div1);
                                img1.onclick = function(){
                                    div1.parentElement.removeChild(div1);
                                    div1 = null;
                                    callback&&callback();
                                };
                            })
                        }else{
                            WeixinJSBridge.invoke("getBrandWCPayRequest",result.data.param,function(res){
    						    callback&&callback();
    						});
                        }
                    }else{
                        require([
                            "cqthink/image/qrCode"
                        ],function(qrCode){
                            var div = domConstruct.create("div",{
                                "class":"paymentQrDiv"
                            },document.body),img = domConstruct.create("span",{
                                innerHTML:"微信扫一扫支付",style:"font-size:20px;color:green;"
                            },div);
                            img = domConstruct.create("img",{
                                "class":"paymentQrImg",
                                src:qrCode.generatePNG(result.data.action,{
                                    modulesize: 5,
                                    margin: 2,
                                    ecclevel: "M"
                                })
                            },div);
                            img = domConstruct.create("span",{
                                innerHTML:"完成",
                                "class":"paymentQrBtn"
                            },div);
                            img.onclick = function(){
                                div.parentElement.removeChild(div);
                                div = null;
                                callback&&callback();
                            };
                            img = domConstruct.create("span",{
                                innerHTML:"取消",
                                "class":"paymentQrBtn"
                            },div);
                            img.onclick = function(){
                                div.parentElement.removeChild(div);
                                div = null;
                                callback&&callback();
                            };
                        })
                    }
                }else{
                    if(window.WeixinJSBridge&&result.payType==="alipaywap"){
                        var action = result.data.action.split("?"),gotoUrl = action.shift();
                        if(action.length&&(!action[0])){
                            action.shift();
                        }
                        for(var key in result.data.param){
                            action.push(key+"="+result.data.param[key]);
                        }
                        return window._AP?_AP.pay(gotoUrl+"?"+action.join("&")):domConstruct.create("script",{
                            type:"text/javascript",
                            src:"/w/ap.js",
                            onload:function(){
                                _AP.pay(gotoUrl+"?"+action.join("&"));
                            }
                        });
                    }
                    var form = domConstruct.create("form", {
                        action: result.data.action,
                        style: "display:none;",
                        method:result.data.method||"post"
                    },document.body);
                    result = result.data.param;
                    for (var key in result) {
                        domConstruct.create("input", {
                            type: "hidden",
                            name: key,
                            id: key,
                            value: result[key]
                        },form);
                    }
                    form.submit();
                }
            }
        },
        refreshPaymentState:function(billCode){
            //需要和服务器端程序一起修改
            var def = new Deferred();
            xhr("GET",{
                url:"/w/order/refreshPayment/"+window.code+"-"+window.openId+"?token="+window.userInfo.token+"&billCode="+billCode,
                load:function(){
                    def.resolve();
                },
                error:function(){
                    def.resolve();
                }
            });
            return def;
        },
        selectPayType:function(aid,total,notPoint){
            window.free();
            var def = new Deferred();
            var items = this.getValidPayType(aid,total,notPoint);
            if(1==items.length){
                def.resolve(items[0].type);
            }else{
                require([
                    "dojox/mobile/SimpleDialog"
                ], lang.hitch(this,function(Dialog) {
                    this.payTypeDialog = new Dialog({
                        style: "width:280px;height:160px;background:white;z-index:10000;",
                        closeButton: true
                    });
                    div = domConstruct.create("div",{
                        "class":"paymentQrDiv"
                    },this.payTypeDialog.containerNode);
                    array.forEach(items,function(item){
                        domConstruct.create("li",{
                            "innerHTML":item.name,
                            "class":item.type,
                            "id":item.type
                        },div);
                    });
                    this.payTypeDialog.connect(div,"onclick",lang.hitch(this,function(e){
                        var dom = e.target;
                        if(dom&&dom.tagName=="LI"){
                            var type = domAttr.get(dom,"id");
                            this.payTypeDialog.hide();
                            def.resolve(type);
                            setTimeout(lang.hitch(this.payTypeDialog,this.payTypeDialog.destroyRecursive),100);
                        }
                    }));
                    this.payTypeDialog.connect(this.payTypeDialog,"onCloseButtonClick",function(){
                        setTimeout(lang.hitch(this,this.destroyRecursive),100);
                    });
                    this.payTypeDialog.startup();
                    this.payTypeDialog.show();
                }));
            }
            return def;
        }
    });
    
    if(array.some(orderPayHandler.getValidPayType(g_sys_info.aid,100,1),function(item){
        return "weixin"===item.type
    })&&g_sys_info.wxType!=3&&window.WeixinJSBridge&&(!cookie(g_sys_info.svcPlatCode+"_openid"))){
        //处理微信支付点两次的问题
        return window.directWxOpenId(g_sys_info.svcPlatCode,param.location.href);
    }
    
    return orderPayHandler;
});