define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-attr",
    "dojo/dom-class"
],function(declare,array,base,shelf,registry,query,domAttr,domClass){
    return declare("widgets.rct.Mud",[base,shelf],{
        getShelfId:function(){
            return "31129";
        },
        isMudLoaded:function(){
            return !!this.mudlist;
        },
        onTplLoaded:function(pane){
            this.indexMudElement();
            this.initMudEvent();
            this.refreshAllList();
        },
        refreshAllList:function(){
            this.mudlist.refreshList();
        },
        initData:function(){
            this.inherited(arguments);
            if(this.isMudLoaded()){
                this.refreshAllList();
            }
        },
        initMudEvent:function(){
            this.connect(this.mudheader,"onclick",this.mudheaderClick);
        },
        indexMudElement:function(){
            this.mudheader = query(".mudheader",this.domNode)[0];
            this.mudlist = registry.byNode(query(".mudlist",this.domNode)[0]);
            this.sudiolist = registry.byNode(query(".sudiolist",this.domNode)[0]);
        },
        mudheaderClick:function(e){
            var dom = e.target;
            while(dom&&dom.tagName!="LI"&&dom!=this.mudheader){
                dom = dom.parentNode;
            }
            if(dom&&dom.tagName=="LI"){
                // 清除选中
                if(query(".checked",this.mudheader)[0]){
                    domClass.remove(query(".checked",this.mudheader)[0],"checked");
                }
                domClass.add(dom,"checked");
                var list = domAttr.get(dom,"name");
                
                this[list].refreshList();
                
                // 显示隐藏列表
                array.forEach([this.mudlist.domNode,this.sudiolist.domNode],function(n){
                    if(domClass.contains(n,list)){
                        domClass.remove(n,"hide");
                    }else{
                        domClass.add(n,"hide");
                    }
                });
            }
        }
    });
});