define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "dojo/_base/lang",
    "dojo/query",
    "widgets/_ShelfMixin",
    "dijit/registry",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-construct"
],function(declare,base,lang,query,shelf,registry,array,domAttr,domClass,domStyle,domConstruct){
    return declare("widgets.rct.Pottery",[base,shelf],{
        getShelfId:function(){
            return "31126";
        },
        indexPottertElement:function(){
            this.group = query(".group",this.domNode)[0];
            this.GroupList = registry.byNode(query(".GroupList",this.domNode)[0]);
            this.MatList = registry.byNode(query(".MatList",this.domNode)[0]);
            this.HotMat = registry.byNode(query(".HotMat",this.domNode)[0]);
            this.NewMat = registry.byNode(query(".NewMat",this.domNode)[0]);
            this.LimitMat = registry.byNode(query(".LimitMat",this.domNode)[0]);
            this.APPList = registry.byNode(query(".APPList",this.APPList)[0]);
        },
        initPottertEvent:function(){
            this.connect(this.LimitMat,"onDefRendered",function(data){
                var items = data.data.items;
                array.forEach(items,function(item){
                    item.IconURLID = item["MID.T0_IconURLID"];
                    item.GName = item["MID.T0_GName"];
                    item.IS_begin = 0;
                    if(g_s.dateDiff('s',item["StartDate"],g_s.getDateTime())>0){
                        item.IS_begin = 1;
                    }
                });
            });
            this.connect(this.group,"onclick",this.groupOnClick);
            this.connect(this.GroupList,"onDefRendered",function(data){
                var items = data.data.items;
                array.forEach(items,function(item,i){
                    item.appendStyle = "";
                    if((i+1)%5==0){
                        item.appendStyle = "margin-right:0;";
                    }
                });
            });
            this.connect(this.MatList,"onDefRendered",function(data){
                var items = data.data.items;
                if(items.length==7){
                    setTimeout(lang.hitch(this,function(){
                        // 添加更多图标
                        var li = domConstruct.create("li",{
                            class:"four_item",
                            style:"margin-right:0;",
                            onclick:"window.moveToView('matList')"
                        },this.MatList.domNode);
                        var div = domConstruct.create("div");
                        li.appendChild(div);
                        div.appendChild(domConstruct.create("img",{
                            src:"../../Content/rct/images/gengduo.png"
                        }));
                        li.appendChild(domConstruct.create("div",{
                            class:"_txtEllipsis",
                            style:"margin-top:5px;",
                            innerHTML:"更多"
                        }));
                    }),100);
                }
                array.forEach(items,function(item,i){
                    item.appendStyle = "";
                    if((i+1)%4==0){
                        item.appendStyle = "margin-right:0;";
                    }
                });
            });
            this.connect(this.HotMat,"onDefRendered",function(data){
                var items = data.data.items;
                array.forEach(items,function(item,i){
                    item.appendStyle = "";
                    if((i+1)%4==0){
                        item.appendStyle = "margin-right:0;";
                    }
                });
            });
            this.connect(this.NewMat,"onDefRendered",function(data){
                var items = data.data.items;
                array.forEach(items,function(item,i){
                    item.appendStyle = "";
                    if((i+1)%4==0){
                        item.appendStyle = "margin-right:0;";
                    }
                });
            });
            this.connect(this.LimitMat,"onDefRendered",function(data){
                var items = data.data.items;
                if(items.length){
                    domClass.remove(query(".robItem",this.domNode)[0],"hide");
                    array.forEach(items,function(item,i){
                        item.appendStyle = "";
                        if((i+1)%4==0){
                            item.appendStyle = "margin-right:0;";
                        }
                    });
                }else{
                    domClass.add(query(".robItem",this.domNode)[0],"hide");
                }
            });
            // this.connect(this.GroupList.domNode,"onclick",this.moreOnClick);
        },
        // moreOnClick:function(e){
        //     var node = e.target;
        //     while(node!=this.GroupList.node){
        //         if(node.tagName=="LI"){
        //             break;
        //         }else{
        //             node =node.parentNode;
        //         }
        //     }
        //     if(node && domClass.contains(node,"moreGroup")){
        //         this.GroupList.rs_wb_page="1";
        //         this.GroupList.refreshList();
                
        //         domClass.add(query(".moreGroup",this.domNode)[0],"hide");
        //     }
        // },
        groupOnClick:function(e){
            var dom = e.target;
            if(dom && dom.tagName == "LI"){
                var titleli = domAttr.get(dom,"titleli");
                var children = dom.parentNode.children;
                for(var i=0;i<children.length;i++){
                    domClass.remove(children[i],"chooseli");
                }
                domClass.add(dom,"chooseli");
                domClass.add(query(".GroupList",this.domNode)[0],"hide");
                domClass.add(query(".MatList",this.domNode)[0],"hide");
                domClass.add(query(".APPList",this.domNode)[0],"hide");
                if(titleli=="1"){
                    domClass.remove(query(".GroupList",this.domNode)[0],"hide");
                }else if(titleli=="2"){
                    domClass.remove(query(".MatList",this.domNode)[0],"hide");
                }else{
                    domClass.remove(query(".APPList",this.domNode)[0],"hide");
                }
            }
        },
        refreshAllList:function(){
            this.GroupList.refreshList();
            this.MatList.refreshList();
            this.APPList.refreshList();
            this.HotMat.refreshList();
            this.NewMat.refreshList();
            this.LimitMat.refreshList();
        },
        onTplLoaded:function(){
            this.indexPottertElement();
            this.initPottertEvent();
            this.refreshAllList();
        }
    });
});