define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "dijit/registry",
    "dojo/query"
],function(declare,array,lang,base,shelf,registry,query){
    return declare("widgets.rct.Studio",[base,shelf],{
        getShelfId:function(){
            return "31128";
        },
        isStudioLoaded:function(){
            return !!this.studiolist;
        },
        onTplLoaded:function(pane){
            this.indexStudioElement();
            this.refreshAllList();
        },
        initData:function(){
            this.inherited(arguments);
            if(this.isStudioLoaded()){
                this.refreshAllList();
            }
        },
        indexStudioElement:function(){
            this.studiolist = registry.byNode(query(".studiolist",this.domNode)[0]);
            this.appDtl = registry.byNode(query(".appDtl",this.domNode)[0]);
        },
        refreshAllList:function(){
            // 加载工作室的所有商品
            window.loadData({
                modalName:"XSY_VBSSC_MAT",
                filter:"41",
                pageSize:1,
                pageIndex:1,
                param:{"AID":window.did},
                orderBy:"[T12_TOTAL_SALE] DESC"
            }).then(lang.hitch(this,function(data){
                var items = {},items1 = [];
                array.forEach(data,function(d){
                    if(!items[d.T0_MGroupID]){
                        items[d.T0_MGroupID] = d;
                        items1.push(d);
                    }
                });
                
                for(var i=0;i<items1.length;i++){
                    for(var j=0;j<data.length;j++){
                        if(data[j].T0_MGroupID==items1[i].T0_MGroupID){
                            if(!items1[i].mats){
                                items1[i].mats = [];
                            }
                            data[j].i = items1[i].mats.length+1;
                            data[j].appendStyle = "";
                            if((data[j].i%4)==0){
                                data[j].appendStyle = "margin-right:0;";
                            }
                            if(data[j].i>7){
                                data[j].show = 0;
                            }else{
                                data[j].show = 1;
                            }
                            items1[i].mats.push(data[j]);
                        }
                    }
                }
                
                var d = {};
                d.data = {};
                d.data.items = items1;
                this.studiolist.onDataReady(d);
            }));
            this.appDtl.refreshList();
        }
    });
});