define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-attr",
    "dojo/dom-class"
],function(declare,array,base,shelf,registry,query,domAttr,domClass){
    return declare("widgets.rct.Tool",[base,shelf],{
        getShelfId:function(){
            return "31130";
        },
        isToolLoaded:function(){
            return !!this.toollist;
        },
        onTplLoaded:function(pane){
            this.indexToolElement();
            this.initToolEvent();
            this.refreshAllList();
        },
        refreshAllList:function(){
            this.toollist.refreshList();
        },
        initData:function(){
            this.inherited(arguments);
            if(this.isToolLoaded()){
                this.refreshAllList();
            }
        },
        initToolEvent:function(){
            this.connect(this.toolheader,"onclick",this.toolheaderClick);
        },
        indexToolElement:function(){
            this.toolheader = query(".toolheader",this.domNode)[0];
            this.toollist = registry.byNode(query(".toollist",this.domNode)[0]);
            this.sudiolist = registry.byNode(query(".sudiolist",this.domNode)[0]);
        },
        toolheaderClick:function(e){
            var dom = e.target;
            while(dom&&dom.tagName!="LI"&&dom!=this.toolheader){
                dom = dom.parentNode;
            }
            if(dom&&dom.tagName=="LI"){
                // 清除选中
                if(query(".checked",this.toolheader)[0]){
                    domClass.remove(query(".checked",this.toolheader)[0],"checked");
                }
                domClass.add(dom,"checked");
                var list = domAttr.get(dom,"name");
                
                this[list].refreshList();
                
                // 显示隐藏列表
                array.forEach([this.toollist.domNode,this.sudiolist.domNode],function(n){
                    if(domClass.contains(n,list)){
                        domClass.remove(n,"hide");
                    }else{
                        domClass.add(n,"hide");
                    }
                });
            }
        }
    });
});