define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "widgets/sjmdsvc/OrderInfo_sjmd",
    "dijit/registry",
    "dojo/query",
    "widgets/userInfo",
    "dojo/_base/lang",
    "dojo/on",
    "dojo/_base/array",
    "dojo/_base/xhr"
    ], function(declare, Base, Shelf,orderInfo,registry,query,userInfo,lang,on,array,xhr) {
    return declare("widgets.sjmdsvc.prizeAward", [Base, Shelf,orderInfo], {
        getShelfId: function() {
            return "31121";
        },
       initData: function() {
            this.refreshAllList();
            this.inherited(arguments);
        },
        isPrizeAwardListLoaded:function(){
            return !!this.myPrize;  
        },
        onTplLoaded:function(){
            this.inPrizeAwardListElement();
            this.clickEvent();
            this.footerFloor.domNode.appendChild(query(".prizeBtn", this.domNode)[0]);
            this.refreshAllList();
        },
        inPrizeAwardListElement:function(){
            this.orderInfoAddrList = registry.byNode(query(".orderInfoAddrList",this.domNode)[0]); 
            this.orderInfoAddrListNode = query(".orderInfoAddrListNode",this.domNode)[0];
            this.prizeBtn = query('.prizeBtn',this.domNode)[0];
            this.myPrize = registry.byId('MyPrize');
            this.subscribe("cqthink/wx/chooseAddr/chooseAddrConfirm",function(addrId){
                this.addrId = addrId;
            });
            this.connect(this.orderInfoAddrList,"onDefRendered",function(data){
                var items = data.data.items;
                if(items.length)
                {
                    items[0].DETAILADDRESS = items[0]["D_P.DistName"]+items[0]["D_C.DistName"]+items[0]["D_X.DistName"]+items[0].DETAILADDRESS;
                    this.addrId = items[0]["ADDRESSID"];
                    this.city = items[0]["D_C.DistID"];
                }
            });
            this.connect(this.myPrize,"onDefRendered",function(data){
                var items = data.data.items;
                if(items.length == 1){
                    if(items[0].State != "0"){
                        alert('此奖品已领取');
                        window.moveToView('myPrize');
                        return;
                    }
                    this.ActivityID = items[0].ActivityID;
                    xhr("GET", {
                        url: "/w/prize/getPrizeInitMesg/" + window.code,
                        content: {
                            ActivityID: items[0].ActivityID
                        },
                        handleAs: "json",
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                query(".shuoming span",this.domNode)[0].innerHTML = result.Comment||"暂无领奖说明"; //活动说明
                            }
                        })
                    });
                }
            });
        },
        clickEvent:function(){
            this.labelType = query("label",this.domNode);
            this.connect(this.orderInfoAddrListNode,"onclick",this.addrClick);
            on(this.labelType,"click",function(){
                var inputBtn = query('.inputRradio');
                array.forEach(inputBtn,function(item){
                    item.dataset.checked = false;
                })
                this.dataset.checked = true;
            }) 
            this.connect(this.prizeBtn, "click" ,function(){
                var name = query('.consiName',this.domNode)[0].innerHTML,
                    phone =query('.consiTel',this.domNode)[0].innerHTML,
                    addr = query('.consiAddr',this.domNode)[0].innerHTML;
                    if(this.contactInformation(name,phone,addr)){
                        window.busy();
                        xhr('POST',{
                            url: "/w/prize/confirmBWR/" + window.code,
                            content: {
                                did: window.did,
                                name:name,
                                phone:phone,
                                addr:addr,
                                ActivityID:this.ActivityID
                            },
                            handleAs: "json",
                            load:lang.hitch(this,function(result){
                               if(result.rtnType == 1){
                                   alert('奖品领取成功');
                                   history.back();
                               }
                                window.free();
                            }),
                            error:lang.hitch(this,function(){
                                alert('服务器错误，请重新领奖')
                                window.free();    
                            })
                        })    
                    }
            })
        },
        contactInformation:function(name,phone,addr){
            if(name == ""){
                alert("收货人不能为空");
                return false;
            }
            if(phone == ""){
                alert('联系电话不能为空');
                return false;
            }
            if (!(/(^1[3|4|5|7|8][0-9]{9}$)/.test(phone))) {
                alert("电话格式错误！");
                return false;;
            }
            if(addr == ""){
                alert('收货地址不能为空');
                return false;
            }
            return true;
        },
        refreshAllList:function(){
            userInfo.hasLogin().then(lang.hitch(this,function(success){
                if(success){
                    // 获取收货人信息
                    // 如果有全局的addrId 则在数据库中加载数据
                    window.loadData({
                        modalName: "XSY_TCRCS_ADDRESS",
                        filter: this.addrId?"03":"01",
                        pageSize: "1",
                        pageIndex: "1",
                        orderBy:"[ISCONSIGNEEADRE] DESC",
                        param: this.addrId?{
                            "ADDRESSID": this.addrId
                        }:{
                            "PID":userInfo.getUserInfo().partnerId
                        }
                    }).then(lang.hitch(this,function(data){
                        var addrData = {
                            data:{items:data}
                        };
                        // 如果没有查到收货地址
                        if(!data.length)
                        {
                            this.customConfirm("您还没有收货地址,马上设置?").then(lang.hitch(this,function(s){
                                // 如果要去设置地址信息 则跳转到新增地址页面
                                if(s){
                                    // 发布事件 新增完成后直接返回提交订单页面
                                    window.moveToView("edtAddr");
                                }
                                // 否则直接刷新页面
                                else{
                                    this.orderInfoAddrList.onDataReady(addrData)
                                }
                            }));
                        }else
                        {
                            this.orderInfoAddrList.onDataReady(addrData);
                        }
                    }));
                }else{
                    window.nextPageOnLogin = this.did?"orderInfo-"+this.did:"orderInfo";
                    // 若没有登录
                    userInfo.showLogin();
                }
            }));    
        }
    });
});