define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojo/touch",
    "../userInfo",
    "dojo/_base/array"
],function(declare,base,shelf,registry,query,domClass,domAttr,xhr,json,lang,touch,userInfo,array){
    return declare("widgets.standardTmp01.AppCoupons",[base,shelf],{
        getShelfId:function(){
            return "31017";
        },
        isAppCouponsLoaded:function(){
            return !!this.appCoupons;
        },
        onTplLoaded:function(pane){
            this.indexAppCouponsElement();
            this.initAppCouponsEvent();
            this.refreshAllList();
        },
        indexAppCouponsElement:function(){
            this.appCoupons = registry.byNode(query(".appCoupons",this.domNode)[0]);
        },
        initAppCouponsEvent:function(){
            this.own(touch.release(this.appCoupons.domNode,lang.hitch(this,function(e){
                var dom = e.target;
                if(dom&&dom.tagName=="A"&&domClass.contains(dom,"reCoupons")){
                    var did = domAttr.get(dom,"DID");
                    this.reCouponsByPid(did);
                }
            })));
            this.connect(this.appCoupons,"onDefRendered",function(data){
                var items = data.data.items;
                // 将日期截断
                array.forEach(items,function(item){
                    var sd = item.STARTDATE.split(" "),
                    ed = item.VD.split(" ");
                    item.STARTDATE = sd[0]+" "+(sd[1]?(sd[1].split(":")[0]+":"+sd[1].split(":")[1]):"");
                    item.VD = ed[0]+" "+(ed[1]?(ed[1].split(":")[0]+":"+ed[1].split(":")[1]):"");
                });
            });
        },
        reCouponsByPid:function(did){
            if(this.isLQ){
                return;
            }
            this.isLQ = true;
            // 领取优惠券的消费者端接口
            xhr("POST", {
                url: "/w/market/GenCoupons/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    did:did
                },
                load: lang.hitch(this, function(result) {
                    this.isLQ = false;
                    if (1 === result.rtnType) {
                        var n = parseFloat(query(".coupons_re_num[did='"+did+"']",this.appCoupons.domNode)[0].innerHTML);
                        n = n + 1;
                        query(".coupons_re_num[did='"+did+"']",this.appCoupons.domNode)[0].innerHTML = n;
                        alert("领取成功");
                        
                    } else {
                        alert(result.message || "数据错误!");
                    }
                })
            });
        },
        refreshAllList:function(){
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    this.appCoupons.refreshList();
                }else{
                   window.nextPageOnLogin = "appCoupons";
                    // 若没有登录
                   userInfo.showLogin(); 
                }
            }));
        },
        initData:function(){
            this.inherited(arguments);
            if(this.isAppCouponsLoaded())
            {
                this.refreshAllList();
                window.free();
            }
        }
    });
});