define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "dojo/query",
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/topic",
    "dojo/_base/array"
],function(declare,base,ShelfMixin,query,registry,domAttr,topic,array){
    return declare("widgets.standardTmp01.ChooseAddr",[base,ShelfMixin],{
        getShelfId:function(){
            return "31059";
        },
        onTplLoaded:function(pane){
            this.indexChooseAddrElement();
            this.initChooseAddrEvent();
            this.refreshAllList();
            this.footerFloor.domNode.appendChild(this.btn);
        },
        initData:function(){
            if(this.isChooseAddrLoaded())
            {
                this.refreshAllList();
            }
            this.inherited(arguments);
        },
        isChooseAddrLoaded:function(){
            return !!this.toAddOrModifyAddr;
        },
        indexChooseAddrElement:function(){
            this.btn = query(".btn",this.domNode)[0];
            this.toAddOrModifyAddr = query(".toAddOrModifyAddr",this.domNode)[0];
            this.myAddr_ul = registry.byNode(query(".myAddr_ul",this.domNode)[0]);
        },
        initChooseAddrEvent:function(){
            this.connect(this.myAddr_ul.domNode,"onclick",this.addrClick);
            this.subscribe("cqthink/wx/chooseAddr/chooseAddrToChoose",function(addrId){
                this.addrId = addrId;
            });
            this.connect(this.myAddr_ul,"onDefRendered",function(data){
                var items = data.data.items;
                if(items.length)
                {
                    if(this.addrId)
                    {
                        array.forEach(items,function(item){
                            if(item.ADDRESSID==this.addrId)
                            {
                                item.ISSELECTED = 1;
                            }
                            else
                            {
                                item.ISSELECTED = 0;
                            }
                        },this);
                    }
                }
            });
            this.connect(this.toAddOrModifyAddr,"onclick",function(){
                // 直接进入新增的页面
                topic.publish("cqthink/wx/chooseAddr/addNewAddr","chooseAddr");
                window.moveToView("edtAddr");
            });
        },
        addrClick:function(e){
            var dom = e.target;
            while(dom&&dom.tagName!="LI"&&dom!=this.myAddr_ul.domNode){
                dom = dom.parentNode;
            }
            var addrId = domAttr.get(dom,"addrId");
            topic.publish("cqthink/wx/chooseAddr/chooseAddrConfirm",addrId);
            //window.moveToView("orderInfo");
            history.back();
        },
        refreshAllList:function(){
            this.myAddr_ul.refreshList();
        }
    });
});