define([
    "dojo/_base/declare", 
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "dojo/dom-construct",
    "dijit/registry",
    "dojo/query",
    "widgets/userInfo",
    "dojo/_base/xhr",
     "dojo/_base/json",
     "dojo/_base/lang",
     "dojo/dom-class",
     "dojo/dom-attr",
     "dojo/touch",
     "dijit/focus",
     "dojo/Deferred"
], function(declare, Base, Shelf,domConstruct,registry,query,userInfo,xhr,json,lang,domClass,domAttr,touch,focusUtil,Deferred) {
    return declare("widgets.standardTmp01.EdtAddr", [Base,Shelf], {
        toBackView:"myAddr",
        getShelfId:function(){
            return "31055";
        },
        isEdtAddrLoaded:function(){
            return !!this.d_s_btn;
        },/*
        back:function(){
            window.moveToView("myAddr");
        },*/
        onTplLoaded:function(pane){
            this.indexEdtAddrElement();
            this.initEdtAddrEvent();
            this.refreshAllList();
        },
        onBeforeTransitionOut:function(){
            domClass.add(this.bgPane,"hide");
            this.inherited(arguments);
        },
        indexEdtAddrElement:function(){
            this.d_s_btn = query(".d_s_btn",this.domNode)[0];
            this.del_addr = query(".del_addr",this.domNode)[0];
            this.save_addr = query(".save_addr",this.domNode)[0];
            this.D_P = query(".D_P",this.domNode)[0];//省
            this.D_C = query(".D_C",this.domNode)[0];//市
            this.D_X = query(".D_X",this.domNode)[0];//区/县
            this.ISCONSIGNEEADRE = query(".ISCONSIGNEEADRE",this.domNode)[0];
            this.bgFixedTop = query(".bgFixedTop",this.domNode)[0];
            this.bgPane = query(".bgPane",this.domNode)[0];//地区隐藏div
            this.bgaddrList = registry.byId("bgaddrList");
            document.body.appendChild(this.bgPane);
            this.footerFloor.domNode.appendChild(this.d_s_btn);
        },
        initEdtAddrEvent:function(){
            this.own(touch.release(query(".leftButtonArea",this.bgPane)[0],lang.hitch(this,this.distBack)));
            
            this.connect(this.bgaddrList.domNode,"onclick",this.bgaddrListClick);  
            //this.own(touch.release(this.bgaddrList.domNode,lang.hitch(this,this.bgaddrListClick)));
            this.connect(this.bgaddrList,"onDefRendered",function(data){
                this.toFreeListArea();
            });
            //省监听事件
            this.own(touch.release(this.D_P,lang.hitch(this,this.distClick)));
            //市监听事件
            this.own(touch.release(this.D_C,lang.hitch(this,this.distClick)));
            //监听区/县事件
            this.own(touch.release(this.D_X,lang.hitch(this,this.distClick)));
            this.connect(this.bgFixedTop,"onclick",this.bgFixedTopClick);
            //保存
            this.connect(this.save_addr,"onclick",this.save);
            //删除
            this.connect(this.del_addr,"onclick",this.del);
            this.own(touch.release(this.ISCONSIGNEEADRE,lang.hitch(this,function(){
                // 去掉节点的光标事件
                var activeElement = focusUtil.curNode;
                focusUtil.curNode && focusUtil.curNode.blur();
                
                if(domClass.contains(query(".ISCONSIGNEEADRE",this.domNode)[0],"default_checked")){
                    domClass.remove(query(".ISCONSIGNEEADRE",this.domNode)[0],"default_checked");
                }else{
                    domClass.add(query(".ISCONSIGNEEADRE",this.domNode)[0],"default_checked");
                }
            })));
            
            // 接收事件
            /*this.subscribe("cqthink/wx/chooseAddr/addNewAddr",function(view){
                this.toBackView = view;
            });*/
        },
        toBusyListArea:function(){
            domClass.remove(query(".listBusyArea",this.bgPane)[0],"hide");
        },
        toFreeListArea:function(){
            domClass.add(query(".listBusyArea",this.bgPane)[0],"hide");
        },
        distBack:function(e){
            // 如果返回按钮是隐藏的 点击时直接返回 不做任何处理
            if(domClass.contains(query(".leftButton",this.bgPane)[0],"hide"))
            {
                return;
            }
            // 如果点击的是里面的返回按钮 则找到父节点
            var dom = e.target;
            while(dom&&dom!=query(".leftButtonArea",this.bgPane)[0]){
                dom = dom.parentNode;
            }
            
            // 获取区划级别
            var Level = domAttr.get(query("li",this.bgaddrList.domNode)[0],"Level"),
                upDistId = 1;
            
            // 如果是点击的3级 则
            if(Level==3){
                //隐藏返回按钮
                domClass.add(query(".leftButton",this.bgPane)[0],"hide");
                this.D_C.innerHTML="市";
                this.D_X.innerHTML="区/县";
                domAttr.set(this.D_C,"dcId","");
                domAttr.set(this.D_X,"dxId","");
                domAttr.set(this.D_C,"distId","");
                domAttr.set(this.D_X,"distId","");
                
            }else if(Level==4){
                this.D_X.innerHTML="区/县";
                domAttr.set(this.D_X,"dxId","");
                domAttr.set(this.D_X,"distId","");
                upDistId = domAttr.get(this.D_P,"distId");
            }
            this.bgaddrList.rs_wb_flt = "07";
            this.bgaddrList.rs_wb_param = "({Level:'"+(Level-1)+"',DID:'"+upDistId+"'})";
            this.toBusyListArea();
            this.bgaddrList.refreshList();
            // 刷新列表时 使列表重新回到顶部
            this.bgaddrList.getParent().scrollTo({x:0,y:0});
        },
        bgaddrListClick:function(e){
            var dom = e.target;
            if(dom && dom.tagName=="LI"){
                var distId=domAttr.get(dom,"distId"),
                    Level = domAttr.get(dom,"Level"),
                    value = dom.innerHTML.replace(/(^\s*)|(\s*$)/g, "");//地区名字
                domClass.remove(query(".leftButton",this.bgPane)[0],"hide");
                // 省
                if(Level==2){
                    this.D_P.innerHTML=value;
                    domAttr.set(this.D_P,"dpId",distId);
                    domAttr.set(this.D_P,"distId",distId);
                    // 查询下级区划
                    this.bgaddrList.rs_wb_flt = "01";
                    this.bgaddrList.rs_wb_param = "({DID:'"+distId+"'})";
                    this.toBusyListArea();
                    this.bgaddrList.refreshList();
                    // 刷新列表时 使列表重新回到顶部
                    this.bgaddrList.getParent().scrollTo({x:0,y:0});
                }
                // 市
                else if(Level==3){
                    this.D_C.innerHTML=value;
                    domAttr.set(this.D_C,"dcId",distId);
                    domAttr.set(this.D_C,"distId",distId);
                    // 查询下级区划
                    this.bgaddrList.rs_wb_flt = "01";
                    this.bgaddrList.rs_wb_param = "({DID:'"+distId+"'})";
                    this.toBusyListArea();
                    this.bgaddrList.refreshList();
                    // 刷新列表时 使列表重新回到顶部
                    this.bgaddrList.getParent().scrollTo({x:0,y:0});
                }
                // 区/县
                else{
                    this.D_X.innerHTML = value; 
                    domAttr.set(this.D_X,"dxId",distId);
                    domAttr.set(this.D_X,"distId",distId);
                    domClass.add(this.bgPane,"hide");
                }
            }
        },
        distClick:function(e){
            var dom = e.target;
            
            // 去掉节点的光标事件
            var activeElement = focusUtil.curNode;
            focusUtil.curNode && focusUtil.curNode.blur();
            // 显示选择地区的pane
            domClass.remove(this.bgPane,"hide");
            var distId = 1;
            // 点击的是省
            if(domClass.contains(dom,"D_P"))
            {
                // 隐藏返回按钮
                domClass.add(query(".leftButton",this.bgPane)[0],"hide");
                this.D_X.innerHTML = "区/县";
                this.D_C.innerHTML = "市";
                domAttr.set(this.D_P,"dpId","");
                domAttr.set(this.D_X,"dxId","");
                domAttr.set(this.D_P,"distId","");
                domAttr.set(this.D_X,"distId","");
            }
            // 点击的是市
            else if(domClass.contains(dom,"D_C"))
            {
                // 显示返回按钮
                domClass.remove(query(".leftButton",this.bgPane)[0],"hide");
                distId = domAttr.get(this.D_P,"distId");
                this.D_X.innerHTML = "区/县";
                domAttr.set(this.D_X,"dxId","");
                domAttr.set(this.D_X,"distId","");
            }
            // 点击的是区/县
            else if(domClass.contains(dom,"D_X")){
                domClass.remove(query(".leftButton",this.bgPane)[0],"hide");
                distId = domAttr.get(this.D_C,"distId");
            }
            this.bgaddrList.rs_wb_flt = "01";
            if(!distId) {
                distId="1";
                domClass.add(query(".leftButton",this.bgPane)[0],"hide");
            }
            this.bgaddrList.rs_wb_param="({DID:'"+distId+"'})";
            this.toBusyListArea();
            this.bgaddrList.refreshList();
            
            // 刷新列表时 使列表重新回到顶部
            this.bgaddrList.getParent().scrollTo({x:0,y:0});
            registry.byId("addrbgFixed").resize();
        },
         // 如果点击非空白区域,则关闭div
        bgFixedTopClick:function(e){
            domClass.add(this.bgPane,"hide");
        },
        initData:function(){
            if(this.isEdtAddrLoaded()){
                this.refreshAllList();
            }
            this.inherited(arguments);
        },
        refreshAllList:function(){
            if(window.did){
                // 删除按钮的显示
                domClass.remove(this.del_addr,"hide");
                window.loadData({
                    modalName:"XSY_TCRCS_ADDRESS",
                    pageSize:"1",
                    pageIndex:"1",
                    filter:"03",
                    param:{ADDRESSID:window.did}
                }).then(lang.hitch(this,function(data){
                    if(data.length){
                        query(".CONSIGNEE",this.domNode)[0].value = data[0].CONSIGNEE;
                        query(".CONSIGNEETEL",this.domNode)[0].value = data[0].CONSIGNEETEL;
                        query(".D_P",this.domNode)[0].innerHTML = data[0]["D_P.DistName"];
                        query(".D_C",this.domNode)[0].innerHTML = data[0]["D_C.DistName"];
                        query(".D_X",this.domNode)[0].innerHTML = data[0]["D_X.DistName"];
                        domAttr.set(this.D_P,"dpId",data[0].D_P);
                        domAttr.set(this.D_C,"dcId",data[0].D_C);
                        domAttr.set(this.D_X,"dxId",data[0].D_X);
                        domAttr.set(this.D_P,"distId",data[0].D_P);
                        domAttr.set(this.D_C,"distId",data[0].D_C);
                        domAttr.set(this.D_X,"distId",data[0].D_X);
                        query(".DETAILADDRESS",this.domNode)[0].value = data[0].DETAILADDRESS;
                        if(data[0].ISCONSIGNEEADRE==1){
                            domClass.add(query(".ISCONSIGNEEADRE",this.domNode)[0],"default_checked");
                        }else{
                            domClass.remove(query(".ISCONSIGNEEADRE",this.domNode)[0],"default_checked");
                        }
                    }
                }));
            }
            else
            {
                query(".CONSIGNEE",this.domNode)[0].value = "";
                query(".CONSIGNEETEL",this.domNode)[0].value = "";
                domAttr.set(this.D_P,"dpId","");
                domAttr.set(this.D_C,"dcId","");
                domAttr.set(this.D_X,"dxId","");
                domAttr.set(this.D_P,"distId","");
                domAttr.set(this.D_C,"distId","");
                domAttr.set(this.D_X,"distId","");
                this.D_P.innerHTML="省";
                this.D_C.innerHTML="市";
                this.D_X.innerHTML="区/县";
                query(".DETAILADDRESS",this.domNode)[0].value = "";
                domClass.remove(query(".ISCONSIGNEEADRE",this.domNode)[0],"default_checked");
                // 删除按钮的隐藏
                domClass.add(this.del_addr,"hide");
            }
        },
        save:function(){
            //if(this.isSave){
            //    return;
            //}
            // var activeElement = focusUtil.curNode;
            // //if(this.PhoneNum == activeElement){
            // focusUtil.curNode && focusUtil.curNode.blur();
            //}
            var isdefult = 0;
            if(domClass.contains(query(".ISCONSIGNEEADRE",this.domNode)[0],"default_checked")){
                isdefult = 1;
            }
            var d_p = domAttr.get(query(".D_P",this.domNode)[0],"dpId"),
                d_c= domAttr.get(query(".D_C",this.domNode)[0],"dcId"),
                d_x= domAttr.get(query(".D_X",this.domNode)[0],"dxId");
            var info = {
                "PARTNERID":userInfo.getUserInfo().partnerId,
                "CONSIGNEE":query(".CONSIGNEE",this.domNode)[0].value,
                "CONSIGNEETEL":query(".CONSIGNEETEL",this.domNode)[0].value,
                "D_P":d_p,
                "D_C":d_c,
                "D_X":d_x,
                "DETAILADDRESS":query(".DETAILADDRESS",this.domNode)[0].value,
                "ISCONSIGNEEADRE":isdefult
            };
            var data = window.did?{
                n:info,
                o:{
                    ADDRESSID:window.did
                }
            }:{
                n:info
            };
            if(!info.CONSIGNEE || info.CONSIGNEE.replace(/(^\s*)|(\s*$)/g, "")==""){
                alert("请输入收货人！");
                return false;
            }
            if(!info.CONSIGNEETEL){
                alert("请输入收货人电话！");
                return false;
            }else if(!(/(^1[3|4|5|7|8][0-9]{9}$)/.test(info.CONSIGNEETEL))){
                alert("电话格式错误！");
                return false;
            }
            if(!info.DETAILADDRESS || info.DETAILADDRESS.replace(/(^\s*)|(\s*$)/g, "") == ""){
                alert("请输入收货地址！");
                return false;
            }
            if(!(d_p && d_c && d_x)){
                alert("地区信息不完整。");
                return false;
            }
            //this.isSave = true;
            window.busy();
            if(isdefult)
            {
                var defaultData = {
                    o:{
                        ISCONSIGNEEADRE:"1",
                        "PARTNERID":userInfo.getUserInfo().partnerId
                    },
                    n:{
                        ISCONSIGNEEADRE:"0"
                    }
                };
                xhr("POST", {
                    url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                    handleAs: "json",
                    content: {
                        data: json.toJson({
                            modalName: "XSY_TCRCS_ADDRESS ",
                            data: [defaultData]
                        })
                    },
                    load: lang.hitch(this, function(result) {
                        if (1 === result.rtnType) {
                            xhr("POST", {
                                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                                handleAs: "json",
                                content: {
                                    data: json.toJson({
                                        modalName: "XSY_TCRCS_ADDRESS ",
                                        data: [data]
                                    })
                                },
                                load: lang.hitch(this, function(result) {
                                    //this.isSave = false;
                                    if (1 === result.rtnType) {
                                        window.free();
                                        alert("保存成功");
                                        query(".CONSIGNEE",this.domNode)[0].value = "";
                                        query(".CONSIGNEETEL",this.domNode)[0].value = "";
                                        domAttr.set(this.D_P,"dpId","");
                                        domAttr.set(this.D_C,"dcId","");
                                        domAttr.set(this.D_X,"dxId","");
                                        domAttr.set(this.D_P,"distId","");
                                        domAttr.set(this.D_C,"distId","");
                                        domAttr.set(this.D_X,"distId","");
                                        this.D_P.innerHTML="省";
                                        this.D_C.innerHTML="市";
                                        this.D_X.innerHTML="区/县";
                                        query(".DETAILADDRESS",this.domNode)[0].value = "";
                                        domClass.add(query(".ISCONSIGNEEADRE",this.domNode)[0],".default_checked");
                                        // 返回到指定页面
                                        history.back();
                                    } else {
                                        window.free();
                                        alert("保存失败");
                                    }
                                })
                            });
                        } else {
                            //this.isSave = false;
                            window.free();
                            alert("保存失败");
                        }
                    })
                });
            }
            else{
                xhr("POST", {
                    url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                    handleAs: "json",
                    content: {
                        data: json.toJson({
                            modalName: "XSY_TCRCS_ADDRESS ",
                            data: [data]
                        })
                    },
                    load: lang.hitch(this, function(result) {
                        //this.isSave = false;
                        if (1 === result.rtnType) {
                            window.free();
                            alert("保存成功");
                            query(".CONSIGNEE",this.domNode)[0].value = "";
                            query(".CONSIGNEETEL",this.domNode)[0].value = "";
                            domAttr.set(this.D_P,"dpId","");
                            domAttr.set(this.D_C,"dcId","");
                            domAttr.set(this.D_X,"dxId","");
                            domAttr.set(this.D_P,"distId","");
                            domAttr.set(this.D_C,"distId","");
                            domAttr.set(this.D_X,"distId","");
                            this.D_P.innerHTML="省";
                            this.D_C.innerHTML="市";
                            this.D_X.innerHTML="区/县";
                            query(".DETAILADDRESS",this.domNode)[0].value = "";
                            domClass.add(query(".ISCONSIGNEEADRE",this.domNode)[0],".default_checked");
                            // 返回到指定的页面
                            //window.moveToView(this.toBackView);
                            history.back();
                        } else {
                            window.free();
                            alert("保存失败");
                        }
                    })
                });
            }
        },
        customConfirm: function(msg) {
            if (window.defConfirm) {
                return window.defConfirm(msg);
            } else {
                //如未定义的defConfirm,调用原生confirm,并支持异步操作。
                var def = Deferred();
                def.resolve(confirm(msg));
                return def;
            }
        },
        del:function(){
            this.customConfirm("确认删除?").then(lang.hitch(this,function(s){
                if(s){
                    var data = {
                        o:{
                            ADDRESSID:window.did
                        }
                    };
                    xhr("POST", {
                        url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                        handleAs: "json",
                        content: {
                            data: json.toJson({
                                modalName: "XSY_TCRCS_ADDRESS ",
                                data: [data]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                alert("删除成功");
                                query(".CONSIGNEE",this.domNode)[0].value = "";
                                query(".CONSIGNEETEL",this.domNode)[0].value = "";
                                domAttr.set(this.D_P,"dpId","");
                                domAttr.set(this.D_C,"dcId","");
                                domAttr.set(this.D_X,"dxId","");
                                domAttr.set(this.D_P,"distId","");
                                domAttr.set(this.D_C,"distId","");
                                domAttr.set(this.D_X,"distId","");
                                this.D_P.innerHTML="省";
                                this.D_C.innerHTML="市";
                                this.D_X.innerHTML="区/县";
                                query(".DETAILADDRESS",this.domNode)[0].value = "";
                                domClass.add(query(".ISCONSIGNEEADRE",this.domNode)[0],".default_checked");
                                window.moveToView("myAddr");
                                //history.back();
                            } else {
                                alert("删除失败");
                            }
                        })
                    });
                }
            }));
        }
       
    });
});