define([
    "dojo/_base/declare",
    "dojo/query",
    "dojo/_base/fx",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dijit/registry",
    "dojo/dom-style",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "widgets/common/_MatEvaListMixin",
    "dojo/_base/array"], function(declare,query,baseFx,domAttr,domClass,registry,domStyle,Base, shelf,MatEvaListMixin,array) {
    return declare("widgets.wyapp.MatEvaList", [Base,shelf,MatEvaListMixin], {
        getShelfId:function(){
            return "30349";
        },
        initData:function(){
            if(this.isMatEvaListLoaded()){
                this.refreshAllList();
            }
            this.inherited(arguments);
        },
        //重写索引页面方法
        indexMatEvaListElement:function(){
            this.inherited(arguments);
            this.divFirst = query(".divFirst")[0];
            this.borderTop = query(".borderTop")[0];
            this.wbEvaList = registry.byId("wbEvaList");
            
        },
         //重写事件方法
        initMatEvaListEvent:function(){
            this.connect(this.divFirst,"onclick",function(e){
                var dom = e.target;
                if(dom && dom.tagName=="SPAN"){
                    var name = domAttr.get(dom,"name");
                    domClass.remove(query(".changeEva",this.divFirst)[0],"changeEva");
                    domClass.add(dom,"changeEva");
                    var divId=(name=="evaList"?"wbEvaList":"evaList");
                    registry.byId(name).domNode.style.display = ""; 
                    registry.byId(name).refreshList();
                    registry.byId(divId).domNode.style.display = "none";
                }
            });
            //在刷新之前先执行重写的onDefRendered这个方法，
            this.connect(this.eList,"onDefRendered",function(data){
                var items = data.data.items;
                if(items.length){
                    array.forEach(items,function(item){
                        item.newDate = item.MKDT.split(" ")[0]+" "+item.MKDT.split(" ")[1].split(":")[0]+":"+item.MKDT.split(" ")[1].split(":")[1];
                    });
                }
            });
            this.connect(this.wbEvaList,"onDefRendered",function(data){
                var items = data.data.items;
                if(items.length){
                    array.forEach(items,function(item){
                        item.newDate = item.MKDT.split(" ")[0]+" "+item.MKDT.split(" ")[1].split(":")[0]+":"+item.MKDT.split(" ")[1].split(":")[1];
                    });
                }
            });
        },
        onTplLoaded:function(pane){
            //索引页面元素
            this.indexMatEvaListElement();
            //让头部固定不动
            this.headerFloor.domNode.appendChild(this.borderTop);
            if(window.util.isBrowser())
            {
                domStyle.set(this.headerFloor.domNode.childNodes[0],"display","none");
            }
            domStyle.set(this.headerFloor.domNode.parentNode,"display","block");
            //绑定事件
            this.initMatEvaListEvent();
            //刷新所有的list
            this.refreshAllList();
        }
    });
});