define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "dojo/query",
    "widgets/userInfo",
    "cqthink/mobile/TalkMsgList",
    "dojo/_base/lang",
    "dojo/dom-style",
    "widgets/_ShelfMixin"
],function(declare,base,query,userInfo,TalkMsgList,lang,domStyle,Shelf){
    return declare("widgets.standardTmp01.MsgList",[base,Shelf],{
        getShelfId:function(){
            return "30364";
        },
        onTplLoaded:function(pane){
            this.indexMsgListElement();
            this.bodyNode.appendChild(this.mList.domNode);
            this.refreshAllList();
        },
        isMsgListLoaded:function(){
            return !!this.msgListNode;
        },
        indexMsgListElement:function(){
            this.msgListNode = query(".msgListNode",this.domNode)[0];
            this.mList = new TalkMsgList({
                svcLogo:g_sys_info.icon.split("-").pop().split(".")[0],
                svcName:g_sys_info.title
            });
            this.mList.startup();
            //this.inherited(arguments);
        },
        refreshAllList:function(){
            domStyle.set(this.domNode,"height","100%");
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                this.mList.set({
                    "pid":s?userInfo.getUserInfo().partnerId:"",
                    "wxId":g_s.getGuid()
                });
                this.mList.resize();
                this.mList.refreshMsgList();
            }));
        },
        initData:function(){
            if(this.isMsgListLoaded()){
                this.refreshAllList();
            }
            this.inherited(arguments);
        }
    });
});