define([
    "dojo/_base/declare", 
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "dojo/dom-construct",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-attr"
], function(declare, Base, Shelf,domConstruct,registry,query,domAttr) {
    return declare("widgets.standardTmp01.MyAddr", [Base,Shelf], {
        getShelfId:function(){
            return "31052";
        },
        back:function(){
            if(this.targetView){
                window.moveToView(this.targetView);
            }
            else
            {
                window.moveToView("userSetting");
            }
        },
        isMyAddrLoaded:function(){
            return !!this.myAddr_ul;
        },
        initData:function(){
            if(this.isMyAddrLoaded())
            {
                this.refreshAllList();
            }
            this.inherited(arguments);
        },
        onTplLoaded:function(pane){
            //索引页面元素
            this.indexMyAddrElement();
            //绑定事件
            this.initMyAddrEvent();
            this.refreshAllList();
        },
        indexMyAddrElement:function(){
            this.myAddr_ul = registry.byNode(query(".myAddr_ul",this.domNode)[0]);
            this.stdSingleBtn = query(".stdSingleBtn",this.domNode)[0];
            this.btn = query(".addr_btn",this.domNode)[0];
            this.footerFloor.domNode.appendChild(this.btn);
        },
        refreshAllList:function(){
            this.myAddr_ul.refreshList();
        },
        initMyAddrEvent:function(){
            this.connect(this.stdSingleBtn,"onclick",function(){
                 moveToView("edtAddr");
            });
            this.connect(this.myAddr_ul.domNode,"onclick",function(e){
               var dom = e.target;
                while(dom && dom.tagName!="LI" && dom!=this.myAddr_ul.domNode){
                    dom = dom.parentNode;
                }
                var addrId = domAttr.get(dom,"addrId");
                window.moveToView("edtAddr",addrId);
            });
            this.subscribe("cqthink/wx/chooseAddr/manageMyAddr",function(){
                this.targetView = "nqbOrderInfo";
            });
        }
    });
});