define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "dijit/registry",
    "dojo/query",
    "widgets/userInfo",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/dom-attr"
],function(declare,base,shelf,registry,query,userInfo,lang,array,domStyle,domClass,domAttr){
    return declare("widgets.standardTmp01.MyCoupons",[base,shelf],{
        getShelfId:function(){
            return "31016";
        },
        isMyCouponsLoaded:function(){
            return !!this.myCoupons;
        },
        onTplLoaded:function(pane){
            this.indexMyCouponsElement();
            this.initMyCouponsEvent();
            this.refreshAllList();
            this.headerFloor.domNode.appendChild(this.couponsHeader);
            domStyle.set(this.headerFloor.domNode.parentNode,"display","block");
            domStyle.set(this.headerFloor.domNode.childNodes[0],"display","none");
        },
        indexMyCouponsElement:function(){
            this.myCoupons = registry.byNode(query(".myCoupons",this.domNode)[0]);
            this.couponsHeader = query(".couponsHeader",this.domNode)[0];
        },
        initMyCouponsEvent:function(){
            this.connect(this.myCoupons,"onDefRendered",function(data){
                var items = data.data.items;
                if(items.length)
                {
                    array.forEach(items,function(item){
                        item.bckImgCss = "";
                        item.txtColor = "";
                        // 已领取 未使用 未过期
                        // STATE=2 已领取 USEDATE="" 未使用 BID2.STARTDATE<当前时间<BID2.VD
                        if(item.STATE==2&&item.USEDATE==""&&item.BID2.STARTDATE<=g_s.getDateTime&&g_s.getDateTime()<=item.BID2.VD)
                        {
                            item.bckImgCss = "couponsNoUse";
                            item.txtColor = "txtNoUse";
                        }
                        // 已使用
                        // USEDATE!=""
                        if(item.USEDATE!="")
                        {
                            item.bckImgCss = "couponsHasUse";
                            item.txtColor = "txtOverDue";
                        }
                        // 已过期
                        // 当前时间>BID2.VD
                        if(g_s.getDateTime()>item.BID2.VD&&item.USEDATE=="")
                        {
                            item.bckImgCss = "couponsOverDue";
                            item.txtColor = "txtOverDue";
                        }
                    });
                }
            });
            this.connect(this.couponsHeader,"onclick",function(e){
                var dom = e.target;
                while(dom&&dom.tagName!="LI"&&dom!=this.couponsHeader)
                {
                    dom=dom.parentNode;
                }
                if(dom&&dom.tagName=="LI"&&dom!=this.couponsHeader)
                {
                    // 设置以前选中的节点为未选中
                    var filter = domAttr.get(dom,"filter");
                    if(query(".couponsSelected",this.couponsHeader)[0])
                    {
                        domClass.remove(query(".couponsSelected",this.couponsHeader)[0],"couponsSelected");
                    }
                    domClass.add(dom,"couponsSelected");
                    this.myCoupons.rs_wb_flt = filter;
                    this.myCoupons.refreshList();
                }
            });
        },
        refreshAllList:function(){
            // 判断是否已经登录
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s)
                {
                    this.myCoupons.refreshList();
                }
                else
                {
                    window.nextPageOnLogin = "myCoupons";
                    userInfo.showLogin();
                }
            }));
        },
        initData:function(){
            this.inherited(arguments);
            if(this.isMyCouponsLoaded())
            {
                this.refreshAllList();
                window.free();
            }
        }
    });
});