define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "dojo/_base/array",
    "dojox/mobile/Rating",
    "dojo/query",
     "dojo/_base/xhr",
    "dojo/_base/json",
    "dojo/_base/lang",
    "widgets/userInfo",
    "dijit/registry",
    "widgets/_ShelfMixin",
    "dojo/dom-style",
    "cqthink/image/common",
    "dojo/touch",
    "dojo/dom-class",
    "dojo/dom-attr",
    "cqthink/mobile/imgPrc/capture",
    "dojo/dom-construct",
    "dojo/Deferred"
], function(declare, base, array, Rating, query, xhr, json, lang, userInfo, registry, shelf, domStyle,imgCom,touch,domClass,domAttr,capture,domConstruct,Deferred) {
    return declare("widgets.standardTmp01.NewMatEva", [base, shelf], {
        getShelfId: function() {
            return "30636";
        },
        isMatEvaLoaded: function() {
            return !!this.subEvaEle;
        },
        onTplLoaded: function(pane) {
            //初始化全局页面元素
            this.indexMatEvaElement(); 
            //绑定点击事件
            this.initMatEvaEvent(); 
            this.refreshAllList();
        },
         initData: function() {
            this.inherited(arguments);
            if(this.isMatEvaLoaded()){
                this.refreshAllList(); 
            }
        },
        loadCurrentEvaData:function(did){
            var def = new Deferred();
            window.loadData({ 
                modalName: "XSY_TBSAV_MAT_CMMNT",
                where: "[DID]='" + this.did + "'"
            }).then(lang.hitch(this, function(data) {
                def.resolve(data);
            }));
            return def;
        },
        refreshAllList: function() { 
            var params = window.did.split("_"),title = "";
            //修改评价
            if (params.length === 1) { 
                //评论ID
                this.did = params[0]; 
                //加载评价信息
                this.loadCurrentEvaData().then(lang.hitch(this,function(data){
                    // 如果查询到评论信息
                    if(data.length){
                        this.initEvaData(data[0].SCORE,data[0].CONTENT);
                        // 判断是否有图片  有的话 显示在指定位置
                        if(data[0].IMGIDS){
                            var imgIds = data[0].IMGIDS.split(",");
                            if(imgIds.length>=4){
                                domClass.add(this.toTakePhotos,"hide");
                            }else{
                                domClass.remove(this.toTakePhotos,"hide");
                            }
                            array.forEach(imgIds,function(imgId){
                                this.createImg(imgId);
                            },this);
                        }else{
                            domClass.remove(this.toTakePhotos,"hide");
                        }
                        // 记录商品ID 用于查询评价的商品
                        window.mid = data[0].MID||data[0].RIID;
                        this.eid = data[0].BILLID;
                        this.wbid = data[0].WBID;
                        this.matEval.refreshList();
                        title = "修改评价";
                        window.updateTitle(title);
                    }
                    // 未查询到
                    else{
                        // 返回前一个页面
                        window.history();
                    }
                }));
            }
            //服务评价
            else if (params.length == 2) {
                this.initEvaData(5,"");
                //工单
                this.wbid = params[0]; 
                //服务人
                this.wcid = params[1];    
                this.did = "";
                title = "服务评价";
            }
            // 商品评价
            else { 
                this.initEvaData(5,"");
                this.did = "";
                // 评价的订单明细ID
                this.eid = params[0]; 
                //商品ID
                this.mid = params[1]; 
                // 评价的订单主表ID 用于评价成功后返回
                this.billid = params[2]; 
                // 商品ID
                window.mid = this.mid;
                this.matEval.refreshList();
                title = "商品评价";
            }
            window.updateTitle(title);
        },
        indexMatEvaElement: function() {
            this.inherited(arguments);
            this.matEvaFooter = query(".subEva", this.domNode)[0];
            this.footerFloor.domNode.appendChild(this.matEvaFooter);
            //找到要显示星星的节点
            var node = query(".star", this.domNode)[0]; 
            var scoreWidget = this.scoreWidget = new Rating({
                image: "../../Content/fdapp/images/xin2.png",
                numStars: 5,
                value: 5,
                id: "rating"
            });
            //追加星星到节点
            node.appendChild(this.scoreWidget.domNode); 
            // 监听星星区域点击事件
            this.scoreWidget.on("click", function(e) {
                var node = e.target;
                while (node && node.parentNode !== this) {
                    node = node.parentNode;
                }
                //把node指向this的 子节点
                scoreWidget.set("value", array.indexOf(this.childNodes, node) + 1); //设置分数
            });
            //修改星星评价的样式
            var domStar = query(".star>div")[0];
            domStyle.set(domStar, "float", "right");
            domStyle.set(domStar, "margin-top", "-13px");
            // 要评价的商品list
            this.matEval = registry.byId("matEval_ll");
            // 找到 提交评价 的节点
            this.subEvaEle = query(".subEva", this.domNode)[0]; 
            // 上传照片
            this.toTakePhotos = query(".toTakePhotos",this.domNode)[0];
            // 图片区域
            this.evaImgsList = query(".evaImgsList",this.domNode)[0];
        },
        initMatEvaEvent: function() {
            this.inherited(arguments);
            // 监听提交评价的点击事件
            this.connect(this.subEvaEle, "onclick", this.subEva); 
            // 监听图片区域点击事件
            this.own(touch.release(this.evaImgsList,lang.hitch(this,this.evaImgsListClick)));
            //this.connect(this.evaImgsList,"onclick",this.evaImgsListClick);
            
        },
        evaImgsListClick:function(e){
            var dom = e.target;
            if(domClass.contains(dom,"_itemClose")){
                domConstruct.destroy(dom.parentNode.parentNode);
                domClass.remove(this.toTakePhotos,"hide");
            }else{
                while(dom&&dom.tagName!="LI"&&dom!=this.evaImgsList){
                    dom = dom.parentNode;
                }
                if(dom&&domClass.contains(dom,"toTakePhotos")){
                    this.takePhotosClick();
                }
            }
        },
        takePhotosClick:function(){
            imgCom.selectImg().then(lang.hitch(this,function(url){
                if(url){
                    imgCom.resizeImage(url,640,640).then(lang.hitch(this,this.onPhotosSelected));
                }
            }));
        },
        onPhotosSelected:function(url){
            if(!url){
                return;
            }
            window.busy();
            xhr("POST", {
                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    data: json.toJson({
                        modalName: "APP_TBSSC_IMG_LIB",
                        data: [{n:{URL:url}}]
                    })
                },
                load:lang.hitch(this,function(result){
                    window.free();
                    if(result.rtnType==1&&result.data&&result.data.items&&result.data.items.length){
                        // 创建节点
                        // 上传成功后将图片的URL更新到指定位置
                        var imgId = result.data.items[0].DID;
                        this.createImg(imgId);
                        // 创建一个img节点
                        var imgs = query("img[upload='1']",query(".evaImgsList",this.domNode)[0]).length;
                        
                        // 隐藏拍照按钮
                        if(imgs>=5){
                            domClass.add(this.toTakePhotos,"hide");
                        }
                    }else{
                        alert(result.message || "数据错误!");
                    }
                })
            });
        },
        createImg:function(did){
            var li = domConstruct.create("li"),
                a = domConstruct.create("a",{},li),
                img = domConstruct.create("img",{
                    upload:1,
                    src:"/w/img/load/"+window.code+"-"+did+".png",
                    did:did
                },a);
            domConstruct.create("i",{
                class:"_itemClose"
            },a);
            this.evaImgsList.appendChild(li);
        },
        // 提交评价
        subEva: function() { 
            var con = query(".evaContent", this.domNode)[0].value, //内容
                score = this.scoreWidget.get("value"); //分数
            if (score == 0) {
                alert("请先给本次评价给分。");
                return;
            }
            if (!con) {
                alert("请填写评价内容。");
                return;
            }
            window.busy();
            // 上传的图片
            var imgs = "";
            query("img",this.evaImgsList).forEach(function(n){
                if(!domClass.contains(n,"uploadImg")){
                    var did = domAttr.get(n,"did");
                    imgs += did+",";
                }
            });
            if(imgs.length){
                imgs = imgs.substring(0,imgs.length-1);
            }
            var data = {
                CONTENT:con,
                SCORE:score,
                TITLE:""
            };
            // 修改评价
            if(this.did){
                data.DID = this.did;
                // 修改服务评价
                if(this.wbid){
                    data.RID = "XSY_TBSSC_WC";
                    data.WBID = this.wbid;
                }
                // 修改商品评价
                else{
                    data.RID = "XSY_TBSSC_MAT";
                    data.BILLID = this.eid;
                    data.IMGIDS = imgs;
                }
            }
            // 新增评价
            else{
                // 新增服务评价
                if(this.wbid){
                    data.RIID = this.wbid;
                    data.RID = "XSY_TBSSC_WC";
                    data.WBID = this.wbid;
                }
                // 新增商品评价
                else{
                    data.RIID = this.mid;
                    data.RID = "XSY_TBSSC_MAT";
                    data.BILLID = this.eid;
                    data.IMGIDS = imgs;
                }
            }
            xhr("POST",{
                url: "/w/order/comment/"+window.code,
                handleAs: "json",
                content: {
                    data: json.toJson(data)
                },
                load:lang.hitch(this,function(result){
                    window.free();
                    if(result.rtnType==1){
                        if (this.did) {
                            alert("修改评论成功。");
                            window.moveToView("matEvaList");
                        } else if (this.wbid) {
                            alert("发表评论成功。");
                            if (window.code === "SVC11105") {
                                window.moveToView("wbList_sjmd");
                            } else {
                                window.moveToView("wbList");
                            }
                        } else {
                            alert("发表评论成功。");
                            window.moveToView("orderDetail", this.billid);
                        }
                        this.initEvaData(5,"");
                    }else{
                        alert(result.message || "数据错误!");
                        // 未发表成功时不清空内容
                        //this.initEvaData(5,"");
                    }
                })
            });
        },
        initEvaData:function(score,content){
            query(".evaContent", this.domNode)[0].value = content;
            this.scoreWidget.set("value", score);
            // 销毁图片列表
            query("li",this.evaImgsList).forEach(function(n){
                if(!domClass.contains(n,"toTakePhotos")){
                    domConstruct.destroy(n);
                }
            });
        }
    });
});