define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/userInfo",
    "widgets/_ShelfMixin",
    "widgets/common/_NewsListMixin",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-style",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/touch"], function(declare, Base, userInfo,shelf,NewsListMixin,registry,query,domStyle,lang,array,domAttr,domClass,touch) {
    return declare("widgets.wyapp.NewsList", [Base,shelf,NewsListMixin], {
        openNewsGrp:true,
        getShelfId:function(){
            return "30342";
        },
        initData:function(){
            if(this.isNewsListLoaded()){
                this.refreshAllList();
                window.free();
            }
            this.inherited(arguments);
        },
        indexNewsListElement:function(){
            this.inherited(arguments);
            this.newsGepList = query(".newsGepList",this.domNode)[0];
            this.newgep = registry.byId("newgep");
            this.gepheader = query(".gepheader",this.domNode)[0];
            this.headerFloor.domNode.appendChild(this.gepheader);
            domStyle.set(this.headerFloor.domNode.childNodes[0],"display","none");
            domStyle.set(this.headerFloor.domNode.parentNode,"display","block");
        },
        initNewsListEvent:function(){
            this.inherited(arguments);
            this.connect(this.newgep.domNode,"onclick",this.newgepOnclick);
            this.connect(this.newgep,"onDefRendered",function(data){
              var items= data.data.items;
                if(items.length)
                {
                    domClass.remove(this.gepheader,"hide");
                    // 在原有的新闻列表上添加一个全部分类 避免商家添加了分类后 有的资讯未做分类 消费者查询不到
                    
                    /*items.push({
                        GRP_ID:"",
                        GEP_NAME:"全部"
                    });
                    // 将items重新排序
                    // 返回值 1:a在b前 -1:a在b后
                    items.sort(function(a,b){
                        if(!a.GRP_ID){
                            return 1;
                        }else if(a.GRP_ID>b.GRP_ID){
                            return 1;
                        }else{
                            return -1;
                        }
                    });*/
                    /*array.forEach(data.data.items,function(item,i){
                       item.index = i+1;
                    },this);*/
                    
                    this.loadNewGep("");//items[0].GRP_ID||""
                }else{
                    this.loadNewGep('');
                   domClass.add(this.gepheader,"hide");
                }
                setTimeout(lang.hitch(this,function(){
                    var w = 0;
                    query("li",this.newgep.domNode).forEach(function(n){
                        // 如果宽度不够64的 要按照内容节点的宽度来设置 否则设置为64
                        if(domStyle.get(query("a",n)[0],"width")>64){
                            domStyle.set(n,"width",(domStyle.get(query("a",n)[0],"width")+20)+"px");
                        }else{
                            domStyle.set(n,"width","64px");
                        }
                        w+=domStyle.get(n,"width");
                    });
                    domStyle.set(this.newgep.domNode.parentNode,"width",(w<domStyle.get(this.domNode,"width")?domStyle.get(this.domNode,"width"):w)+"px");
                }));
            });
        },
        newgepOnclick:function(e){
            var dom = e.target;
            while(dom&&dom.tagName!=="LI"&&dom!=this.newgep.domNode){
                dom = dom.parentNode;
            }
            if(dom && dom.tagName=="LI"){
                var gep= domAttr.get(dom,"gep");
                query("._itemW36LiChecked",this.newgep.domNode)[0]&&domClass.remove(query("._itemW36LiChecked",this.newgep.domNode)[0],"_itemW36LiChecked");
                domClass.add(dom,"_itemW36LiChecked");
                this.loadNewGep(gep);
            }
        },
        loadNewGep:function(gep){
            if(gep){
                this.nList.rs_wb_param = "({GRPID:"+gep+"})";
            }else{
                this.nList.rs_wb_param = "({GRPID:''})";
            }
            this.nList.rs_wb_order = "[IS_TOP] DESC,[NEWS_ID] DESC";
            this.nList.refreshList();
        },
        onTplLoaded:function(pane){
            //索引页面元素
            this.indexNewsListElement();
            //绑定事件
            this.initNewsListEvent();
            //刷新所有的list
            this.refreshAllList();
        }
    });
});