define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/query",
    "dijit/registry",
    "dojo/Deferred",
    "dojo/_base/xhr",
    "widgets/orderCarRecord",
    "widgets/userInfo",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/dom",
    "dojo/has",
    "dojo/dom-class",
    "dojo/topic"
], function(declare, lang, array, domAttr, query, registry, Deferred, xhr, orderCarRecord,userInfo, Base, Shelf, domConstruct, domStyle, dom, has, domClass,topic) {
    return declare("widgets.standardTmp01.NqbOrderCar",[Base,Shelf],{
        isOrderCarLoaded:function(){
            return !!this.orderCarList;
        },
        getShelfId:function(){
            return "30865";
        },
        reserveMsgNode:false,
        onShelfLoaded:function(){
          this.inherited(arguments);  
        },
        indexOrderCarElement:function(){
            this.orderCarList = registry.byId("orderCarList"); //购物车list2
            this.ttlPrice = query(".ttlPrice span",this.domNode)[0]||query(".ttlPrice span")[0]; //侦听购物车总计
            this.settlement = query(".checkOut",this.domNode)[0]||query(".checkOut")[0]; //侦听结算
            this.jifen = query(".jifen",this.domNode)[0]||query(".jifen")[0]; //积分
            this.bottomfooters = query(".footerArea",this.domNode)[0];
            
            // 无商品时样式
            this.noMats = query(".m-cart-e.add",this.domNode)[0];
            
            query(".shop_module_item_title",this.domNode)[0].innerHTML = "购物车";
            domStyle.set(query(".shop_module_item_title",this.domNode)[0],"display","block");
            domStyle.set(query(".shop_module_item_con",this.domNode)[0],"display","block");
            domStyle.set(this.headerFloor.domNode,"display","none");
        },
        initData:function(){
           
            if(this.orderCarList){
                this.refreshAllList();
                window.free();
            }
            this.inherited(arguments);
        },
        onTplLoaded:function(pane){
            this.indexOrderCarElement();
            this.initOrderCarEvent();
            this.orderCarFooterNode = query(".footerArea",pane.domNode)[0];
            this.orderCarBodyNode = query(".orderCarBody",pane.domNode)[0];
           // this.footerNode.appendChild(this.bottomfooters);
            this.footerFloor.domNode.appendChild(this.bottomfooters);
            this.updateCenterPaneHeight();
            //this.setHeaderstyle();      // 设置头部样式
            //domConstruct.place(this.orderCarFooterNode,this.footerFloor.domNode,"first");
            this.refreshAllList();
        },
        setHeaderstyle:function(){
            var headers=query(".shop_module_item",this.headerNode)[0];
            //domStyle.set(this.headerNode,{"width":"100%","height":"39px","background":"#ff4401"});
            //domStyle.set(headers,{"height":"39px"});
            domStyle.set(query("a", this.domNode)[0],'display', 'none');
            domConstruct.place('<span class="allEditors off_editor">编辑全部</span>', headers, 1);
            domConstruct.place('<p class="orderCarStyle">购物车(0)</p>', headers, 2);
        },
        setStyleList:function(){        //数据加载完后设置商品样式
            var arrQuery=[];
            array.forEach(this.classArr2,function(item){
                arrQuery.push(query('.classify_'+item,this.domNode));
             });
            this.setCommodityListStyle(arrQuery);
            dom.byId("checkAll").checked = false;
            query(".orderCarStyle", this.domNode)[0].innerHTML="购物车("+query("dt",this.domNode).length+")";
            //设置库存颜色，如果无库存显示红色
            array.forEach(query(".colors", this.domNode), function(item){
                if(!(/\d/.test(item.innerHTML))){
                    domStyle.set(item, 'color', 'red');
                }
            });
        },
        initOrderCarEvent:function(){
            this.connect(this.orderCarList, "onDefRendered", function(data) { //加载购物车list2之前
                orderCarRecord.data = data; // 购物车中数据
                orderCarRecord.total = 0; //定义购物车总计为0
                window.jifen = 0; //定义积分为0
                var orderCar = orderCarRecord.getOrderCar(),
                    appMats = []; //定义购物车中商品、数量
                this.classArr2=[];  //保存处理后的aid数据
                array.forEach(data.data.items, function(item, index) { // 循环购物车中商品、数量
                    item.type = index > 0 && item.T0_AID.APP_ID == data.data.items[index - 1].T0_AID.APP_ID ? 0 : 1;
                    
                    item.last = index < (data.data.items.length-1) && item.T0_AID.APP_ID == data.data.items[index + 1].T0_AID.APP_ID ? 0 : 1;
                    if (item.T0_MID) { // 如果有商品
                        // 如果有分时限购 则修改限购数量
                        
                        if(window.fsData.length)
                        {
                            array.forEach(window.fsData,function(fsData){
                                if(item.T0_MID==fsData.MID)
                                {
                                    item.T0_TPCH_NUM = fsData.TPCH_NUM;
                                }
                            });
                        }
                        //限购商品是0或者没有值的时候就在购物车数量和库存数量中取最小值，其中库存为0时会自动删除该商品
                        if (!item.T0_TPCH_NUM || item.T0_TPCH_NUM == 0) {
                            item.QTY = Math.min(orderCar[item.T0_MID], item.T9_SHELF_QTY);
                        } else {
                            item.QTY = Math.min(orderCar[item.T0_MID], item.T9_SHELF_QTY, item.T0_TPCH_NUM);
                        }
                        array.forEach(window.data, function(data12) { // 多买模式匹配商品优惠信息
                            if (item.T0_MID == data12.MID || item.T0_MID == data12["MID.T0_MTID"]) {
                                //item.DIS = data12.Price * item.QTY;
                                item.DIS = data12.Price;
                                item.DIS_D = data12.Price/item.QTY || 0;
                                window.jifen += data12.Price;
                            }
                        });
                        if(item.T9_SHELF_QTY == '0'){
                            item.kucun = '该商品暂无库存';
                        }else{
                            item.kucun = '库存 '+item.T9_SHELF_QTY
                        }
                        item.AMNT = window.fixedTo(item.QTY * item.T3_RetailPrice,3);
                        item.PRI = item.T0_MainUnitID.MeasureName;
                        orderCarRecord.total += item.AMNT;
                        item.SHELF_QTY = item.T9_SHELF_QTY; //库存数量

                        if (index > 0 && item.T0_AID.APP_ID == data.data.items[index - 1].T0_AID.APP_ID) {
                            array.forEach(appMats, function(appMats) {
                                if (item.T0_AID.APP_ID == appMats.appMatAid) {
                                    appMats.appMatAmnt = parseFloat(appMats.appMatAmnt) + parseFloat(item.AMNT);
                                }
                            });
                        } else {
                            appMats.push({
                                appMatAid: item.T0_AID.APP_ID,
                                appMatAmnt: item.AMNT
                            });
                        }
                        /*array.forEach(window.appData, function(appData) { //循环货主信息
                            if (item.T0_AID.APP_ID == appData.APP_ID) {
                                item.district = appData.TRAN_REGION;
                                if (appData.TRAN_AID) { //如果有物流货主，邮费为0
                                    item.postAge = "0";
                                    item.bagAmnt = "0";
                                } else {
                                    item.postAge = appData.TRAN_FEE;
                                    if (item.T0_AID.APP_ID == g_sys_info.aid) {
                                        item.bagAmnt = appData.DIR_LMT || "0";
                                    } else {
                                        item.bagAmnt = appData.DIS_LMT || "0";
                                    }
                                }
                            }
                        });*/
                    } else {
                        item.AMNT = "";
                    }
                }, this);
                var classArr=[];     //保存商家aid
                array.forEach(data.data.items, function(item) {
                     classArr.push(item.T0_AID.APP_ID);
                    array.forEach(appMats, function(appMats) {
                        if (item.T0_AID.APP_ID == appMats.appMatAid) {
                            item.isPostBag = (item.bagAmnt - appMats.appMatAmnt > 0) ? "0" : "1";
                            item.appMatAmnt = appMats.appMatAmnt;
                        } else {
                            //item.isPostBag = "0";
                        }
                    });
                });
                for(var i = 0;i < classArr.length ;i++){
                    if(i>0){
                        if(classArr[i] !== classArr[i-1]){
                            this.classArr2.push(classArr[i]);
                        }
                    }else{
                       this.classArr2.push(classArr[i]); 
                    }
                };
                if (this.did) {
                    orderCarRecord.setOrderCar(orderCar);
                }
                this.settlement.innerHTML = '结算('+0+')';
                this.ttlPrice.innerHTML = "￥" + window.fixedTo(0, 3);
                //this.jifen.innerHTML = window.fixedTo(0, 0); // 更新积分
                //window.orderMids = data.data.items.length ? window.orderMids : [];
                this.updateFooter();
            });
            this.connect(this.orderCarList.domNode, "onclick", lang.hitch(this,this._orderMatListClick)); // 侦听购物车
            this.connect(this.settlement, "onclick", lang.hitch(this, this._settleDown));// 侦听结算按钮
            this.connect(this.domNode, "onclick", this.clickEvent); //监听页面点击事件
            this.subscribe("widgets/show/view", function(id) {
                if (id === this.id) {
                    this.updateFooter();
                }
            });
        },
        setCommodityListStyle:function(arrQuery){ //设置商品下边框样式
            array.forEach(arrQuery,function(item){
               for(var i = 0; i < item.length; i++){
                  if(item.length==1){
                      domStyle.set(item[i],"border-bottom","1px solid #ff4401");
                  }else{
                      if(i=(item.length-1)){
                          domStyle.set(item[i],"border-bottom","1px solid #ff4401");
                      }
                  }
               }
            });
        },
        clickEvent:function(event){     //页面点击事件
            var btn = event.target.nodeName;
            var domTarget = event.target || evet.srcElement; //点击的节点
            if(domTarget.checked !== undefined){
                if(has("touch")){  //兼容手机端checkbox无法选中问题
                    if(domTarget.checked == true){ 
                       domTarget.checked=false;
                   }else{
                        domTarget.checked=true;
                   }
                }
            }
            switch(btn){
                case "INPUT" : //点击checkbox 时执行
                    if(domAttr.get(domTarget, "id") == "checkAll"){
                            array.forEach(query('input', this.domNode), function(item){
                                if(domTarget.checked){
                                    item.checked = true;
                                }else{
                                    item.checked = false; 
                                }
                            });
                    }else{
                        while (!(domTarget && domTarget.tagName == "DL")){//当父节点为DL时退出循环
                            if(domTarget.tagName == "BODY"){
                                break;
                            }
                            domTarget = domTarget.parentNode;
                            if(domTarget.tagName == "DD"){ //如果点击的父节为dd节点时执行
                                var string=domAttr.get(domTarget.parentNode,"class");
                                string=string.substring(string.lastIndexOf(" ")+1);
                                var arrs=query('.'+string, this.domNode);
                                array.forEach(arrs,function(item){
                                        array.forEach(query("input",item), function(item){
                                            if(event.target.checked){
                                                item.checked=true;
                                            }else{
                                               item.checked=false; 
                                            }
                                        })
                                    })
                            }else if(domTarget.tagName == "DT"){ //如果点击的父节为dt节点时执行
                                var string = domAttr.get(domTarget.parentNode,"class");
                                string = string.substring(string.lastIndexOf(" ")+1);
                                var arrs = query('.'+string, this.domNode);
                                var arr2=[];
                                    array.forEach(arrs, function(item){
                                        array.forEach(query("dt",item),function(item){
                                            array.forEach(query("input",item), function(item){
                                                arr2.push(item.checked)
                                            })
                                        })
                                    });
                                if(array.every(arr2,function(item){
                                    return item == true;
                                })){
                                  query("input",arrs[0])[0].checked=true;
                                }else{
                                  query("input",arrs[0])[0].checked=false;  
                                };
                                
                        }
                    }
                }; 
                    break;
                case "SPAN" :  //点击 编辑 按钮执行
                    if(domAttr.get(domTarget,"class")=="allEditors" || domAttr.get(domTarget,"class")=="allEditors off_editor"){
                       this.allEditorsAndEditor()
                    }else{
                        while(!(domTarget && domTarget.tagName == "DL")){
                            if(domTarget.tagName == "BODY"){
                                break;
                            }
                            domTarget = domTarget.parentNode; 
                            if(domTarget.tagName == "DD"){
                                var string=domAttr.get(domTarget.parentNode,"class");
                                    string=string.substring(string.lastIndexOf(" ")+1);
                                var arrs=query('.'+string, this.domNode);  
                                array.forEach(arrs, function(item){
                                    if(query("dt", item).length){
                                        if(domStyle.get(query(".cartIemWrap", item)[0],"display") == "inline-block"){
                                          domStyle.set(query(".cartIemWrap", item)[0], "display", "none");
                                          domStyle.set(query(".editor", item)[0], "display", "inline-block");
                                          event.target.innerHTML="完成";
                                          domClass.remove(event.target, 'status');
                                        }else if(domStyle.get(query(".cartIemWrap", item)[0],"display") == "none"){
                                          domStyle.set(query(".cartIemWrap", item)[0], "display", "inline-block");
                                          domStyle.set(query(".editor", item)[0], "display", "none");
                                          event.target.innerHTML="编辑";
                                          domClass.add(event.target, 'status');
                                        }
                                    }
                                 });
                                 //只有一个商家时不启用，编辑联动
                                var arrClass = array.map(query('dl'), function(item){
                                     return domAttr.get(item ,"class")
                                 })
                                if(!array.every(arrClass, function(item){
                                    return item == arrClass[0]
                                })){    //  多个商家时，启用编辑与编辑全部的联动功能
                                    if(array.every(query('.editorList'), function(item){
                                        return domAttr.get(item, "class") == 'editorList status';
                                    })){
                                        domClass.remove(query(".allEditors", this.domNode)[0], 'off_editor');
                                        this.allEditorsAndEditor()
                                    };
                                    if(array.every(query('.editorList'), function(item){
                                            return domAttr.get(item, "class") == 'editorList';
                                        })){
                                            domClass.add(query(".allEditors", this.domNode)[0], 'off_editor');
                                            this.allEditorsAndEditor()
                                    };
                                }
                                
                            }
                        }
                    };
                    
                    break;
                case "P" : //点击右下角批量删除后操作
                    if(domAttr.get(domTarget,"class")=="deletes"){
                        if(!confirm("确认删除选中商品？")){
                             return;
                        }
                        var arrDlClass = [], newarr = [], nums = 0, reg=/\d+/;
                        array.forEach(query("dt", this.domNode), function(item){
                            array.forEach(query('input' ,item), function(item, index){
                               if(item.checked == true){
                                    nums++;
                                     //从购物车中删除选中商品列表
                                    this._delMat(domAttr.get(item,"id").match(/\d+/)[0]);
                                    //删除选中商列表
                                    arrDlClass.push(domAttr.get(item.parentNode.parentNode.parentNode.parentNode, "class"));
                                    item.parentNode.parentNode.parentNode.parentNode.removeChild(item.parentNode.parentNode.parentNode);
                               }
                            }, this);
                        }, this);
                        for(var i = 0;i < arrDlClass.length ;i++){
                            if(i>0){
                                if(arrDlClass[i] !== arrDlClass[i-1]){
                                    newarr.push(arrDlClass[i]);
                                    }
                            }else{
                                newarr.push(arrDlClass[i]); 
                             }
                         };
                         //批量删除后的显示处理
                         array.forEach(newarr,function(item){
                            array.forEach(query(".classify_"+(item.match(reg)[0])), function(item){
                                    if((query('dt', item).length == 0) &&(query('dd', item).length == 0)){
                                        item.parentNode.removeChild(item);
                                    }
                                    if((query('dt', item).length == 0) &&(query('dd', item).length == 1)){
                                        domStyle.set(item, 'border-bottom', 'none');
                                    }
                            });
                            if(query(".classify_"+(item.match(reg)[0])).length == 1){
                                if(query("dt",query(".classify_"+(item.match(reg)[0]))[0]).length ==0){
                                   query(".classify_"+(item.match(reg)[0]))[0].parentNode.removeChild(query(".classify_"+(item.match(reg)[0]))[0]);
                                }
                            }
                            //删除列表后下变线的处理
                           for(var i = 0;i < query(".classify_"+(item.match(reg)[0])).length; i++){
                               if(i == (query(".classify_"+(item.match(reg)[0])).length-1)){
                                   domStyle.set(query(".classify_"+(item.match(reg)[0]))[i], "#ff4401" ,"#ff4401");
                               }
                           }
                         });
                        //如果删除了所有商品则刷新列表
                       if(!query("dt", this.domNode).length){
                            this.orderCarList.refreshList();
                            query(".allEditors", this.domNode)[0].innerHTML = "编辑全部";;
                        }
                    query(".orderCarStyle", this.domNode)[0].innerHTML="购物车("+query("dt",this.domNode).length+")";
                    }
                    break;
            }
            if(array.every(query('.checkboxList'), function(item){
                    return item.checked == true;
                }) == true){
                  dom.byId("checkAll").checked = true;
                }else{
                  dom.byId("checkAll").checked = false;  
             }
            //合计位置显示选中商品列表的价格之和
            var totalAmount = 0, selectedNum = 0;
            array.forEach(query("dt", this.domNode), function(item){
                if(query("input", item)[0].checked == true){
                    selectedNum++;
                    totalAmount += parseFloat(query(".amnt_"+domAttr.get(query("input", item)[0], "id").match(/\d+/)[0], item)[0].innerHTML);
                }
            });
            this.ttlPrice.innerHTML = "￥" + window.fixedTo(totalAmount, 3); //选中商品总价
            this.settlement.innerHTML = '结算('+selectedNum+')';
            //合计位置显示选中商品列表的积分之和
            var jifenArr = [],data = orderCarRecord.data.data.items;
            window.jifen = 0;
            array.forEach(query("dt input", this.domNode), function(item){
                if(item.checked == true){
                    jifenArr.push(domAttr.get(item,'id').match(/\d+/)[0]);
                }
            });
            array.forEach(jifenArr, function(item){
                array.forEach(data, function(jfitem){
                    if(item == jfitem.T0_MID){
                        jfitem.DIS = jfitem.DIS||0; 
                        window.jifen += jfitem.DIS;
                    }
                });
            });
            this.jifen.innerHTML = window.fixedTo(window.jifen, 0); // 更新积分
        },
        allEditorsAndEditor:function(){ //点 编辑全部 时执行
            if(domAttr.get(query(".allEditors", this.domNode)[0],"class").indexOf("off_editor") > 0){
                domStyle.set(query(".heji", this.domNode)[0], "display", "none");
                domStyle.set(query(".checkOut", this.domNode)[0], "display", "none");
                domStyle.set(query(".deletes", this.domNode)[0], "display", "block");
                query(".allEditors", this.domNode)[0].innerHTML = "完成";
                array.forEach(query(".editor", this.domNode), function(item){
                    domStyle.set(item, "display", "inline-block");
                });
                array.forEach(query(".cartIemWrap", this.domNode), function(item){
                    domStyle.set(item, "display", "none");
                });
                array.forEach(query(".editorList", this.domNode), function(item){
                    item.innerHTML = '完成';
                    domClass.remove(item, 'status');
                });
                domClass.remove(query(".allEditors", this.domNode)[0], 'off_editor');
           }else{
                query(".allEditors", this.domNode)[0].innerHTML = "编辑全部";
                domStyle.set(query(".heji", this.domNode)[0], "display", "block");
                domStyle.set(query(".checkOut", this.domNode)[0], "display", "block");
                domStyle.set(query(".deletes", this.domNode)[0], "display", "none");
                array.forEach(query(".editor", this.domNode), function(item){
                  domStyle.set(item, "display", "none");
                });
                array.forEach(query(".cartIemWrap", this.domNode), function(item){
                    domStyle.set(item, "display", "inline-block");
                });
                array.forEach(query(".editorList", this.domNode), function(item){
                    item.innerHTML = '编辑';
                    domClass.add(item, 'status');
                });
                domClass.add(query(".allEditors", this.domNode)[0], 'off_editor');
           }
        },
        _settleDown: function() {
            orderCarRecord.setSelectedMats([]); //初始化 结算数据
            //区分单买模式和购物车模式
            userInfo.hasLogin().then(function(s){
                if(s){
                    //获取选中商品的mid
                    var mid = [];
                    array.forEach(query('dt', this.domNode), function(item){
                        if(query('input', item)[0].checked){
                           mid.push(domAttr.get(query('input', item)[0], "id").match(/\d+/)[0])
                        }
                    })
                    // 判断是否选中商品
                    if(mid.length == 0){
                        alert("您还没有选购商品,不能结算！");
                        return false;
                    }
                    var data = orderCarRecord.data.data.items;
                    var arrList=[],oMid = [],nmid = [];
                    array.forEach(query('dt input', this.domNode),function(item){
                        if(item.checked){
                             nmid.push(domAttr.get(item,'id').match(/\d+/)[0]);
                        }
                    });
                    array.forEach(nmid,function(oitem){
                        array.forEach(data, function(item){
                            if(item.T0_MID == oitem&&item.T9_SHELF_QTY == '0'){
                                arrList.push(item.T0_GName);
                                oMid.push(item.T0_MID);
                            }
                        });
                    });
                    if(oMid.toString() == mid.toString()){
                        alert('您选够的商品暂无库存，请选购其他商品');
                        return false;
                    }
                   if(arrList.length != 0){
                        if(!confirm('当前商品 '+arrList.toString()+' 暂无库存,是否继续购买订单中其他商品?')){
                            return false;
                        }
                   }
                   if(oMid.length>0){ //检查库存，如果库存为0，则不提交改商品
                       array.forEach(oMid,function(item){
                           if(array.indexOf(mid,item)>0){
                               mid.splice(array.indexOf(mid,item),1);
                           }
                       });
                   }
                    orderCarRecord.setSelectedMats(mid);
                    window.moveToView("orderInfo");
                }else{
                    window.nextPageOnLogin = "orderInfo";
                    userInfo.showLogin();
                }
            });
        },
        refreshAllList:function(){
            window.updateTitle("购物车");
            // 清空全选的选中状态
            dom.byId("checkAll").checked = false;
            var car = orderCarRecord.getOrderCar(),
                mids = [];
            for (var mid in car) {
                if (mid) {
                    mids.push(mid);
                }
            }
            window.orderMids = mids;
            this.disInfo();
            
            //多买模式  更新本地购物车
        },
        updateFooter: function() {
            // 如果购物车中有商品 则显示 footer
            if (window.orderMids.length) {
                // 隐藏shelfFooter
                if(query(".shelfFooter",this.domNode)[0])
                {
                    domClass.remove(query(".shelfFooter",this.domNode)[0],"hide");
                }
                
                domClass.add(this.noMats,"hide");
                domClass.remove(this.bottomfooters,"hide");
            }
            // 否则 不显示footer
            else {
                //购物车无商品时显示的样式
                
                // 隐藏shelfFooter
                if(query(".shelfFooter",this.domNode)[0])
                {
                    domClass.add(query(".shelfFooter",this.domNode)[0],"hide");
                }
                domClass.remove(this.noMats,"hide");
                domClass.add(this.bottomfooters,"hide");
            }
        },
        // 初始化购物车信息
        disInfo: function() {
            // 获取分时限购信息
            window.fsData = [];
            window.loadData({
                modalName:"NY_TBSSC_MAT_ACTIVITY",
                filter: "01",
                pageSize:1,
                pageIndex:1,
                param:{"MID":window.orderMids,"CURTIME":g_s.getDateTime()}
            }).then(lang.hitch(this,function(fsData){
                // 如果有分时限购数据
                if(fsData.length)
                {
                    window.fsData = fsData;
                }
                // 取商品优惠信息
                window.loadData({
                    modalName: "XSY_TSDCD_PRICEDTS",
                    filter: "02",
                    pageSize: "1",
                    pageIndex: "1",
                    param: {
                        "MID": window.orderMids
                    }
                }).then(lang.hitch(this, function(data) {
                    if (data.length) {
                        window.data = data;
                    }
                    // 记录有赠送积分的商品
                    var mats = [];
                    array.forEach(window.data,function(mat){
                        mats.push(mat.MID);
                    });
                    // 获取商品的积分信息
                    this._dealDeposits(mats).then(lang.hitch(this,function(){
                        // 重新加载商品视图 查询当前商品是否能够被使用
                        window.loadData({
                            modalName: "XSY_VBSSC_MAT",
                            filter: "40",
                            pageSize: "1",
                            pageIndex: "1",
                            param: {
                                "MID": window.orderMids
                            }
                        }).then(lang.hitch(this, function(data1) {
                            var appIds = [],
                                car = orderCarRecord.getOrderCar(),
                                car1 = {}, orderMids = [],
                                num = 0;
                            if (data1.length) {
                                // 循环删除已经下架或者无库存的商品 并且重算window.orderMids
                                for (var i = 0; i < data1.length; i++) {
                                    appIds.push(data1[i].T0_AID);
                                    var mid = data1[i].T0_MID;
                                    // 如果购物车数量是0 则直接从购物车中删除 刘轩 2015-12-25
                                    if(car[mid]==0)
                                    {
                                        delete car[mid];
                                        window.orderMids.splice(array.indexOf(window.orderMids, mid), 1);
                                    }
                                    else
                                    {
                                        if (data1[i].T0_AID == g_sys_info.aid) { //如果是当前货主
                                            if (data1[i].T0_IsUse == 0 || 
                                            data1[i].T0_IsAllowSale == 0 || 
                                            data1[i].T9_SHELF_QTY <= 0||// 库存<=0时要删除购物车数据 2015-12-29 刘轩
                                            data1[i].T0_IS_ONLINESALE==0) {
                                                delete car[mid];
                                                window.orderMids.splice(array.indexOf(window.orderMids, mid), 1);
                                            } else {
                                                car1[mid] = car[mid];
                                                orderMids.push(mid);
                                            }
                                        } else {
                                            if (data1[i].T0_IsUse == 0 || 
                                            data1[i].T0_IsAllowSale == 0 || 
                                            data1[i].T9_SHELF_QTY <= 0 || // 库存<=0时要删除购物车数据 2015-12-29 刘轩
                                            data1[i].T0_IsAllSO == 0||
                                            data1[i].T0_IS_ONLINESALE==0) {
                                                delete car[mid];
                                                window.orderMids.splice(array.indexOf(window.orderMids, mid), 1);
                                            } else {
                                                car1[mid] = car[mid];
                                                orderMids.push(mid);
                                            }
                                        }
                                    }
                                }
                                // 更新购物车数据 库存为0时清除商品
                                orderCarRecord.setOrderCar(car1); 
                                window.orderMids = orderMids;
                            }
                            /*if (appIds) {
                                window.loadData({ //找货主的邮费信息
                                    modalName: "XSY_TSSCF_APP",
                                    filter: "999",
                                    pageSize: "1",
                                    pageIndex: "1",
                                    param: {
                                        "AID": appIds,
                                        "INPUT": ''
                                    }
                                }).then(lang.hitch(this, function(appData) {
                                    if (appData.length) {
                                        window.appData = appData;
                                    }
                                    this.updateFooter();
                                    this.orderCarList.refreshList();  
                                }));
                            }
                            else
                            {*/
                                this.updateFooter();
                                this.orderCarList.refreshList();  
                            //}
                            
                        }));
                    }));
                }));
            }));
            /*this.scrollTo({
                x: 0,
                y: 0
            });*/
        },
        //设置删后的商品列表样式
        setNewlistStyle:function(classStyleName){
            array.forEach(query("."+classStyleName), function(item){
                if((query('dt', item).length == 0) &&(query('dd', item).length == 0)){
                    item.parentNode.removeChild(item);
                }
                if((query('dt', item).length == 0) &&(query('dd', item).length == 1)){
                    domStyle.set(item, "border-bottom", "none");
                }
                
            });
            if(query("."+classStyleName).length == 1){
                if(query("dt",query("."+classStyleName)[0]).length == 0){
                   query("."+classStyleName)[0].parentNode.removeChild(query("."+classStyleName)[0]);
                }
            }
            //删除列表后多下变线的处理
           for(var i = 0;i < query("."+classStyleName).length; i++){
               if(i == (query("."+classStyleName).length-1)){
                   domStyle.set(query("."+classStyleName)[i], "border-bottom-color" ,"#ff4401");
               }
           } 
           //设置购物车头部数量信息
           query(".orderCarStyle", this.domNode)[0].innerHTML="购物车("+query("dt",this.domNode).length+")";
            //如果删除了所有商品则刷新列表
           if(!query("dt", this.domNode).length){
               var _this = this;
               setTimeout(function(){
                    _this.orderCarList.refreshList();
                    query(".allEditors", this.domNode)[0].innerHTML = "编辑全部";
               },50);
            }
        },
        customConfirm: function(msg) {
            if (window.defConfirm) {
                return window.defConfirm(msg);
            } else {
                //如未定义的defConfirm,调用原生confirm,并支持异步操作。
                var def = Deferred();
                def.resolve(confirm(msg));
                return def;
            }
        },
        _orderMatListClick: function(e) {
            if (e.target) {
                var c = domAttr.get(e.target, "class");
                var reg=/\d+/;   //正则匹配数字
                if (-1 < c.indexOf("add_")) {
                    this._addMatNum(c.match(reg)[0], 1, e);
                } else if (-1 < c.indexOf("des_")) {
                    this._addMatNum(c.match(reg)[0], - 1, e);
                } else if (-1 < c.indexOf("del_")) { // 点击删除按钮时
                    //弹出确认窗口
                    this.customConfirm("确认删除该商品吗？").then(lang.hitch(this,function(success) {
                        if(success)
                        {
                            this._delMat(c.match(reg)[0]); //取出class中的数字
                            this.disInfo();
                            //var classStyleName = domAttr.get(e.target.parentNode.parentNode.parentNode, "class").split(' ')[1];
                            //e.target.parentNode.parentNode.parentNode.removeChild(e.target.parentNode.parentNode);
                            //this.setNewlistStyle(classStyleName);
                        }
                    }));
                    
                } else {
                    return;
                }
            } else {
                return;
            }
        },
        _delMat: function(mid) {
            //window.busy();
            var car = orderCarRecord.getOrderCar(),
                index = orderCarRecord.data.data.items.length;
            while (index--) {
                if (orderCarRecord.data.data.items[index].T0_MID == mid) {
                    break;
                }
            }
            if (-1 < index) {
                delete car[mid];
                window.orderMids.splice(array.indexOf(window.orderMids, mid), 1);
                if (!this.did) { //如果是购物车模式
                    orderCarRecord.setOrderCar(car);
                }
                var node = query(".MID_" + mid, this.orderCarList.domNode)[0];
                node.parentNode.removeChild(node);
                orderCarRecord.total = orderCarRecord.total - orderCarRecord.data.data.items[index].QTY * orderCarRecord.data.data.items[index].T3_RetailPrice;
                //window.jifen = window.jifen - orderCarRecord.data.data.items[index].QTY * orderCarRecord.data.data.items[index].DIS_D || 0;
                var jifenlength = orderCarRecord.data.data.items.length;
                window.jifen=0;
                while (jifenlength--) {
                    if (orderCarRecord.data.data.items[jifenlength].DIS_D) {
                        window.jifen += orderCarRecord.data.data.items[jifenlength].DIS_D || 0;
                    }
                }
                //this.ttlPrice.innerHTML = "￥" + window.fixedTo(orderCarRecord.total, 3);
               // this.jifen.innerHTML = window.fixedTo(window.jifen, 0); // 更新积分
                orderCarRecord.data.data.items.splice(index, 1);
            }
            topic.publish("widgets/orderCarRecord/setOrderCar");
            //this.disInfo();
            //window.free();
        },
        _addMatNum: function(mid, inc, e) {
            var car = orderCarRecord.getOrderCar(),
                index = orderCarRecord.data.data.items.length;
            while (index--) {
                if (orderCarRecord.data.data.items[index].T0_MID == mid) {
                    break;
                }
            }
            //当商品数量减少为0时，弹出提示信息
            if(orderCarRecord.data.data.items[index].QTY == 1 && inc < 0){
                /*if(confirm("确认删除该商品吗？")){
                    var parent = e.target.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode;
                    var classStyleName2 = domAttr.get(parent.parentNode,"class").split(" ")[1];
                    parent.parentNode.removeChild(parent);
                    this.setNewlistStyle(classStyleName2)
                }else{
                    return false;
                }*/
                alert("商品数量无法再减少了!");
                return false;
            }
            //增加数量时  如果超过库存或者限购数量则不能增加
            if (index < 0 || (orderCarRecord.data.data.items[index].QTY - 1 + 1 + inc) > orderCarRecord.data.data.items[index].SHELF_QTY) {
                return;
            } else {
                if (index < 0 || (orderCarRecord.data.data.items[index].QTY - 1 + 1 + inc) > (orderCarRecord.data.data.items[index].T0_TPCH_NUM || 0) && (orderCarRecord.data.data.items[index].T0_TPCH_NUM || 0) > 0) {
                    return;
                }
                orderCarRecord.data.data.items[index].QTY += inc;

            }
            orderCarRecord.data.data.items[index].AMNT = orderCarRecord.data.data.items[index].QTY * orderCarRecord.data.data.items[index].T3_RetailPrice;
            // 更新积分
            //orderCarRecord.data.data.items[index].DIS = orderCarRecord.data.data.items[index].QTY * orderCarRecord.data.data.items[index].DIS_D;
            //window.jifen += inc * orderCarRecord.data.data.items[index].DIS_D || 0;
            orderCarRecord.data.data.items[index].DIS = orderCarRecord.data.data.items[index].DIS + orderCarRecord.data.data.items[index].DIS_D * inc;
            /*var jifenlength = orderCarRecord.data.data.items.length;
                window.jifen=0;
                while (jifenlength--) {
                    if (orderCarRecord.data.data.items[jifenlength].DIS_D) {
                        window.jifen += orderCarRecord.data.data.items[jifenlength].DIS_D || 0;
                    }
                }*/
            orderCarRecord.total += inc * orderCarRecord.data.data.items[index].T3_RetailPrice;
            //this.ttlPrice.innerHTML = "￥" + window.fixedTo(orderCarRecord.total, 3);
            //this.jifen.innerHTML = window.fixedTo(window.jifen, 0); // 更新积分
            //如果是多买模式  更新到orderCarRecord
            if (!this.did) {
                car[mid] += inc;
                if (0 === car[mid]) {
                    delete car[mid];
                    window.orderMids.splice(array.indexOf(window.orderMids, mid), 1);
                    orderCarRecord.setOrderCar(car);
                }
                orderCarRecord.setOrderCar(car);
            }
            if (orderCarRecord.data.data.items[index].QTY > 0) {
                query(".QTY_" + mid, this.orderCarList.domNode)[0].innerHTML = "x"+orderCarRecord.data.data.items[index].QTY;
                query(".QTY_" + mid, this.orderCarList.domNode)[1].innerHTML = orderCarRecord.data.data.items[index].QTY;
                //query(".AMNT_" + mid, this.orderCarList.domNode)[0].innerHTML = "小计：￥<span>" + window.fixedTo(orderCarRecord.data.data.items[index].AMNT, 3) + "</span>";
                var num=orderCarRecord.data.data.items[index].QTY * orderCarRecord.data.data.items[index].T3_RetailPrice;
                query(".amnt_" + mid, this.orderCarList.domNode)[0].innerHTML = window.fixedTo(num, 3); 
            }/*else {
                var node = query(".MID_" + mid, this.orderCarList.domNode)[0];
                //node.parentNode.removeChild(node);
            }*/
            topic.publish("widgets/orderCarRecord/setOrderCar");
            //this.disInfo();
        },
        _dealDeposits: function(mats) {
            var def = new Deferred();
            //加载分销商品ID，只有本帐套的商品才能定优惠政策
            window.loadData({
                modalName: "XSY_VBSSC_MAT",
                filter: "15",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "MID":array.map(mats,function(mat){
                        return mat;
                    })
                }
            }).then(lang.hitch(this,function(matData){
                //找到商品ID和商品ID之间的对应关系
                var mids = [],midHash = {},qtys = [];
                array.forEach(matData,function(mat){
                    mids.push(mat.T0_MID);
                    qtys.push(orderCarRecord.getOrderCar()[mat.T0_MID]);
                    midHash[mat.T0_MID] = mat.T0_MID;
                    midHash[mat.T0_MTID] = mat.T0_MID;
                });
                xhr("GET",{
                    url:"/w/data/GetMatsCreditByQty/"+window.code+"-"+window.openId,
                    handleAs:"json",
                    content: {
                        mats: mids.join(","),
                        qtys:qtys.join(",")
                    },
                    load:function(result) {
                        var desInfo = {};
                        if(result&&result.data&&result.data.items){
                            //商品的积分政策
                            array.forEach(result.data.items, function(item) {
                                desInfo[item.MID] = parseFloat(item.CREDIT,10)||0;
                            });
                        }
                        array.forEach(window.data,function(mat){
                            mat.Price = desInfo[midHash[mat.MID]]||0;
                        });
                        //将提交结果直接返回给调用者
                        def.resolve(window.data);
                    },
                    error:function(err){
                        //提交订单错误，返回错误及信息
                        def.resolve({
                            rtnType:"101",
                            message:err&&err.message||"数据错误"
                        });
                    }
                });
            }));
            return def;
        }
    });
});