define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "widgets/common/_OrderInfoMixin",
    "dojo/query",
    "widgets/userInfo",
    "widgets/common/couponMixin",
    "dojo/_base/lang",
    "dijit/registry",
    "widgets/orderCarRecord",
    "dojo/_base/array",
    "dojo/topic",
    "dojo/dom-attr",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dojo/dom-class"
],function(declare,base,shelf,orderInfoMixin,query,userInfo,couponMixin,lang,registry,orderCarRecord,array,topic,domAttr,xhr,json,domClass){
    return declare("widgets.standardTmp01.NqbOrderInfo",[base,shelf,orderInfoMixin],{
        isNqbOrderInfoLoaded:function(){
            return !!this.orderInfoBtn;
        },
        getShelfId:function(){
            return "31056";
        },
        initData:function(){
            this.inherited(arguments);
            if(this.isNqbOrderInfoLoaded())
            {
                this.refreshAllList();
            }
        },
        onTplLoaded:function(pane){
            this.indexOrderInfoElement();
            this.initOrderInfoEvent();
            this.refreshAllList();
            this.footerFloor.domNode.appendChild(this.orderInfoBtn);
        },
        indexOrderInfoElement:function(){
            this.inherited(arguments);
            this.orderInfoBtn = query(".orderInfoBtn",this.domNode)[0];
            this.radios = query(".radios",this.domNode)[0];
            this.currentPrice = query(".ttl",this.domNode)[0];
            this.orderInfoMats = registry.byNode(query(".orderInfoMats",this.domNode)[0]);
            this.orderInfoAddrList = registry.byNode(query(".orderInfoAddrList",this.domNode)[0]);
            this.ttl = query(".ttl",this.domNode)[0];
            this.orderInfoAddrListNode = query(".orderInfoAddrListNode",this.domNode)[0];
            this.orderCarPost = query(".orderCarMatsSub",this.domNode)[0];
        },
        initOrderInfoEvent:function(){
            this.inherited(arguments);
            this.connect(this.orderInfoMats,"onDefRendered",function(data){
                window.orderCarMids = {};
                var items = data.data.items,
                    ttl = 0,
                    aidsQty = {},
                    aidsAmnt = {};
                // 如果是拼团包邮的话 则不显示运费信息 2015-12-31 刘轩
                var PACBUY_delType = "",PACBUY_TEAMID = "",ChannelID = "";
                if(window.did.indexOf("PACBUY_TEAMID") !== -1){
                    var arr =  window.did.match(/\d+/g);
                    PACBUY_TEAMID = arr[0];
                    PACBUY_delType = arr[1]; //是否包邮(1包邮，0 不包邮)
                }
                if(window.did.indexOf("ChannelID")>-1){
                    ChannelID = window.did.split("_")[1];
                }
                if(items.length)
                {
                    // 购物车中商品数量
                    array.forEach(items,function(item,index){
                        //item.QTY = car[item.T0_MID];
                        // 商家的第一行数据
                        item.type = index > 0 && item.T0_AID.APP_ID == items[index - 1].T0_AID.APP_ID ? 0 : 1;
                        // 商家的最后一行数据
                        item.last = index < (items.length-1) && item.T0_AID.APP_ID == items[index + 1].T0_AID.APP_ID ? 0 : 1;
                        // 计算合计
                        ttl += parseFloat(item.QTY*item.T3_RetailPrice);
                        aidsAmnt[item.T0_AID.APP_ID] = parseFloat(aidsAmnt[item.T0_AID.APP_ID]||0)+parseFloat(item.QTY*item.T3_RetailPrice);
                        aidsQty[item.T0_AID.APP_ID] = parseFloat(aidsQty[item.T0_AID.APP_ID]||0)+item.QTY;
                        // 计算每个商家的邮费
                        
                        item.postAge = (PACBUY_delType==""||PACBUY_delType==0)?window.feeData[item.T0_AID.APP_ID]:0;
                    });
                    window.orderCarMids = aidsAmnt;
                    // 计算每个商家的商品小计
                    array.forEach(items,function(item){
                        item.ttlQty = aidsQty[item.T0_AID.APP_ID];
                        item.ttlAmnt = parseFloat(aidsAmnt[item.T0_AID.APP_ID])+
                        parseFloat((PACBUY_delType==""||PACBUY_delType==0)?window.feeData[item.T0_AID.APP_ID]:0);
                    });
                    // 将邮费放到合计中去
                    if(PACBUY_delType==""||PACBUY_delType==0){
                        for(var aid in window.feeData)
                        {
                            ttl +=parseFloat(window.feeData[aid]);
                        }
                    }
                    // 将提交的合计显示到指定位置
                    this.ttl.innerHTML = "￥"+window.fixedTo(ttl,3);
                    // 获取可用的优惠券
                    couponMixin.getAvailableCoupons().then(lang.hitch(this,function(availableCoupons){
                        // 不是拼团活动的才允许使用优惠券
                        if(availableCoupons&&PACBUY_TEAMID==""&&ChannelID=="")
                        {
                            window.availableCoupons = availableCoupons;
                        }
                        // 刷新优惠券的显示
                        this.couponType.refreshList();//刷新优惠券
                    }));
                }
                else
                {
                    this.ttl.innerHTML = "￥0.00";
                }
            });
            this.connect(this.orderInfoAddrListNode,"onclick",this.addrClick);
            this.subscribe("cqthink/wx/chooseAddr/chooseAddrConfirm",function(addrId){
                this.addrId = addrId;
            });
            this.connect(this.orderInfoAddrList,"onDefRendered",function(data){
                var items = data.data.items;
                if(items.length)
                {
                    items[0].DETAILADDRESS = items[0]["D_P.DistName"]+items[0]["D_C.DistName"]+items[0]["D_X.DistName"]+items[0].DETAILADDRESS;
                    this.addrId = items[0]["ADDRESSID"];
                    this.city = items[0]["D_C.DistID"];
                }
            });
        },
        radiosClick:function(e){
            // 切换选中状态
            this.inherited(arguments);
            
            // 如果是拼团包邮的话 则不显示运费信息 2015-12-31 刘轩
            var PACBUY_delType = "";
            if(window.did.indexOf("PACBUY_TEAMID") !== -1){
                var arr =  window.did.match(/\d+/g);
                PACBUY_delType = arr[1]; //是否包邮(1包邮，0 不包邮)
            }
            
            // 重算显示在页面上的邮费信息
            // 隐藏邮费节点
            query(".postAgeNode",this.orderInfoMats.domNode).forEach(function(n){
                // 自提
                if((this.radios?query("input:checked",this.radios)[0].value:"2")=="1")
                {
                    domClass.add(n,"hide");
                }else// 配送
                {
                    domClass.remove(n,"hide");
                }
            },this);
            // 重算商家金额小计
            query(".STxt15",this.orderInfoMats.domNode).forEach(function(n){
                var aid = domAttr.get(n,"aid");
                // 商家金额=原金额+-邮费
                if((this.radios?query("input:checked",this.radios)[0].value:"2")=="1")
                {
                    n.innerHTML = "￥"+window.fixedTo(parseFloat(window.orderCarMids[aid]),3);
                }
                else{
                    n.innerHTML = "￥"+window.fixedTo(parseFloat(window.orderCarMids[aid])+
                    parseFloat((PACBUY_delType==""||PACBUY_delType==0)?window.feeData[aid]:0),3);
                }
            },this);
            var ttl = 0,aid,feeTtl = 0;
            for(aid in window.orderCarMids)
            {
                ttl += parseFloat(window.orderCarMids[aid]);
            }
            for(aid in window.feeData)
            {
                feeTtl += parseFloat(window.feeData[aid]);
            }
            // 重新计算总计
            if((this.radios?query("input:checked",this.radios)[0].value:"2")=="1")
            {
                this.ttl.innerHTML = "￥"+window.fixedTo(ttl,3);//-feeTtl
            }
            else
            {
                this.ttl.innerHTML = "￥"+window.fixedTo(parseFloat(ttl)+
                parseFloat((PACBUY_delType==""||PACBUY_delType==0)?feeTtl:0),3);
            }
        },
        addrClick:function(e){
            topic.publish("cqthink/wx/chooseAddr/chooseAddrToChoose",this.addrId);
            window.moveToView("chooseAddr");
        },
        
        customConfirm: function(msg) {
            if (window.defConfirm) {
                return window.defConfirm(msg);
            } else {
                //如未定义的defConfirm,调用原生confirm,并支持异步操作。
                var def = Deferred();
                def.resolve(confirm(msg));
                return def;
            }
        },
        refreshAllList:function(){
            userInfo.hasLogin().then(lang.hitch(this,function(success){
                if(success){
                    // 将收货方式初始化到 商家配送
                    query("#orderInfoTransType1")[0].checked = true;
                    // 获取收货人信息
                    // 如果有全局的addrId 则在数据库中加载数据
                    window.loadData({
                        modalName: "XSY_TCRCS_ADDRESS",
                        filter: this.addrId?"03":"01",
                        pageSize: "1",
                        pageIndex: "1",
                        orderBy:"[ISCONSIGNEEADRE] DESC",
                        param: this.addrId?{
                            "ADDRESSID": this.addrId
                        }:{
                            "PID":userInfo.getUserInfo().partnerId
                        }
                    }).then(lang.hitch(this,function(data){
                        var addrData = {
                            data:{items:data}
                        };
                        // 如果没有查到收货地址
                        if(!data.length)
                        {
                            this.customConfirm("您还没有收货地址,马上设置?").then(lang.hitch(this,function(s){
                                // 如果要去设置地址信息 则跳转到新增地址页面
                                if(s){
                                    // 发布事件 新增完成后直接返回提交订单页面
                                    window.moveToView("edtAddr");
                                }
                                // 否则直接刷新页面
                                else{
                                    this._initPostOrderData(addrData);
                                }
                            }));
                            
                        }else
                        {
                            this._initPostOrderData(addrData);
                        }
                    }));
                }else{
                    window.nextPageOnLogin = this.did?"orderInfo-"+this.did:"orderInfo";
                    // 若没有登录
                    userInfo.showLogin();
                }
            }));
        },
        _initPostOrderData:function(addrData){
            this.orderInfoAddrList.onDataReady(addrData);
            window.availableCoupons = [];
            // 获取需要提交的商品的邮费信息
            var items = orderCarRecord.data.data.items,
                mids = [],
                qtys  =[],
                amts = [],
                // 城市信息
                city = addrData&&addrData.data&&addrData.data.items&&addrData.data.items[0]&&addrData.data.items[0]["D_C.DistID"]||"",
                selectedMats;
            // 得到购物车选中的商品
            selectedMats = orderCarRecord.getSelectedMats()||[];
            // 如果没有选中商品 返回时 刷新商品数据为空 并不计算运费
            if(!selectedMats.length)
            {
                var o = {};
                o.data = {};
                o.data.items = [];
                // 刷新商品信息 直接用购物车提交过来的data数据
                var matsData = o;
                this.orderInfoMats.onDataReady(matsData);
            }
            else
            {
                // 循环购物车的数据 获取提交订单页刷新的准备数据 过滤掉 未选中和选中数量为0 的数据
                var newItems = array.filter(items,function(item){
                    return array.indexOf(selectedMats,item.T0_MID)>-1&&item.QTY-0>0; 
                });
                array.forEach(newItems,function(item){
                    mids.push(item.T0_MID);
                    qtys.push(item.QTY);
                    amts.push(item.AMNT);
                });
                // 获取邮费信息
                window.feeData = {};
                xhr("POST",{
                    url: "/w/TranFee/GetAppTranFee/" + window.code,
                    handleAs: "json",
                    content: {
                        mids:mids.join(","),//商品ID
                        amts:amts.join(","),//商品价格
                        qtys:qtys.join(","),//商品数量
                        city:city//区域ID
                    },
                    load: lang.hitch(this, function(result) {
                        if (1 === result.rtnType) {
                            // 得到获取的邮费信息
                            window.feeData = result.data;
                            var o = {};
                            o.data = {};
                            o.data.items = newItems||[];
                            // 刷新商品信息 直接用购物车提交过来的data数据
                            var matsData = o;
                            this.orderInfoMats.onDataReady(matsData);
                        } else {
                            alert(result.message || "获取邮费信息失败!");
                        }
                    })
                });
            }
        },
        _postOrder2:function(){
            var name = query(".consiName", this.orderInfoAddrList.domNode)[0]&&
                query(".consiName", this.orderInfoAddrList.domNode)[0].innerHTML||"",
                tel = query(".consiTel", this.orderInfoAddrList.domNode)[0]&&
                    query(".consiTel", this.orderInfoAddrList.domNode)[0].innerHTML||"",
                addr = query(".consiAddr", this.orderInfoAddrList.domNode)[0]&&
                    query(".consiAddr", this.orderInfoAddrList.domNode)[0].innerHTML||"",
                remark = query(".to_remark",this.domNode)[0].value,
                delType = this.radios?query("input:checked",this.radios)[0].value:"2",
                couponId = domAttr.get(query(".couponTxt",this.domNode)[0],"did"),
                PACBUY_TEAMID = undefined,PACBUY_delType = undefined,
                ChannelID = "",
                addrId = this.addrId;
            if(window.did.indexOf("PACBUY_TEAMID") !== -1){
                var arr =  window.did.match(/\d+/g);
                PACBUY_TEAMID = arr[0]; //开团活动id;
                PACBUY_delType = arr[1]; //是否包邮(1包邮，0 不包邮)
            }
            if(window.did.indexOf("ChannelID")>-1){
                ChannelID = window.did.split("_")[1];
            }
            if(orderCarRecord.getSelectedMats().length==0)
            {
                alert("没有要提交的商品");
                return;
            }
            if(!this.addrId&&delType==2){
                alert("请先选择收货地址");
                return;
            }
            window.busy();
            require(["widgets/common/orderHandler"],lang.hitch(this,function(orderHandler){
                var resetInfo = function(orderInfo){
                    orderInfo.ChannelID = ChannelID;
                    orderInfo.AdreID = addrId;
                    return orderInfo;
                };
                orderHandler.postOrder(name,tel,addr,remark,null,delType,((ChannelID||addrId)?resetInfo:null),couponId,PACBUY_TEAMID,PACBUY_delType,this.city).then(lang.hitch(this,function(result){
                    if (1 === result.rtnType) {
                        var obj = orderCarRecord.getOrderCar();
                        array.forEach(orderCarRecord.getSelectedMats(), function(item){
                            for(var i in obj){
                                if(item == i){
                                    delete obj[i];
                                }
                            }
                        });
                        orderCarRecord.setOrderCar(obj);
                        orderCarRecord.clearMats();
                        orderCarRecord.carChanged = true;
                        
                        /*if(!this.did){
                            orderCarRecord.setOrderCar({});
                            orderCarRecord.carChanged = true;
                            orderCarRecord.setSelectedMats([]);
                        }*/
                        window.moveToView("orderDetail",result.data);
                        if(result.timeout){
                            alert("请在"+result.timeout+"内完成支付，否则订单会自动取消。");
                        }
                    } else if(result.message){
                        alert(result.message);
                    }
                }));
            }));
        }
    });
});