define([
    "dojo/_base/declare", 
    "widgets/_ViewBase",
    "dojo/query",
    "dojo/dom-style",
    "widgets/_ShelfMixin",
    "dijit/registry",
    "widgets/common/_OrderDetailMixin",
    "dojo/dom-construct",
    "dojo/Deferred",
    "dojo/_base/lang",
    "dojo/_base/xhr",
    "dojo/dom-class",
    "dojo/dom-attr"
], function(declare, Base,query,domStyle,Shelf,registry,OrderDetailMixin,domConstruct,Deferred,lang,xhr,domClass,domAttr) {
    return declare("widgets.standardTmp01.OrderDetail", [Base,Shelf,OrderDetailMixin], {
        getDtlByMyShelf:true,
        getShelfId:function(){
            return "30339";
        },
        onTplLoaded:function(pane){
            this.indexOrderDetailElement();
            this.initOrderDetailEvent();
            this.orderDetailFooterNode = query(".orderfooter",pane.domNode)[0];
            this.orderDetailBodyNode = query(".orderDetailViewBody",pane.domNode)[0];
            this.yf_font_detail  = query(".yf_font_detail",pane.domNode)[0];
            this.jf_font_detail = query(".jf_font_detail",pane.domNode)[0];
            this.app_title = query(".app_title")[0];//商家名称
            this.div_button = query(".div_button")[0];
            this.yfNode = query(".yfNode",this.domNode)[0];
            domConstruct.place(this.orderDetailFooterNode,this.footerFloor.domNode,"first");
            this.updateCenterPaneHeight();
            this.refreshAllList();
        },
        initData: function() {
            if(this.isOrderDetailLoaded()){
                this.refreshAllList();
                window.free();
            }
            this.inherited(arguments);
        },
        updateFooter:function(){
            if(this.orderDetailFooterNode){
                this.inherited(arguments);
                if (this.isCancel || this.isPay || (this.isPayEar && !this.canPay)) {
                    domStyle.set(this.footerFloor.domNode.parentNode,"height","47px");
                    domStyle.set(this.toPayHElement,"display","none");
                }else{
                    //this.initPayTypeElemet();
                    // this.isPreOrder：是否预售订单
                    // this.isPayEar: 预售订单是否已支付
                    // this.earnest:需要支付的定金
                    // this.epoint：定金使用的积分
                    // this.ecoin:定金使用的代金券
                    // this.totalPrice：订单总额
                    // this.coin :订单使用的代金券
                    // this.point：订单使用的积分
                    domStyle.set(this.toPayHElement,"display","");
                    domStyle.set(this.yfNode,"display","");
                    var pointDisplay = ((this.isPreOrder&&!this.isPayEar) ? 
                    this.earnest - this.epoint - this.ecoin - this.couponAmt: 
                    this.totalPrice - this.coin - this.point -this.couponAmt) ? 
                    "none" : "",
                    onlineDisplay = pointDisplay ? "" : "none";
                    var point= window.fixedTo(((this.isPreOrder && !this.isPayEar)? 
                    parseFloat(this.epoint) + parseFloat(this.ecoin) : 
                    parseFloat(this.point) + parseFloat(this.coin)+parseFloat(this.couponAmt)),3);//抵用的积分
                    var yfmongey = window.fixedTo(((this.isPreOrder && !this.isPayEar)?
                    this.earnest - this.epoint - this.ecoin-this.couponAmt:
                    this.totalPrice - this.coin - this.point-this.couponAmt),3);//应付金额
                    this.jf_font_detail.innerHTML = window.fixedTo(point,3);
                    this.yf_font_detail.innerHTML = "￥"+window.fixedTo(yfmongey,3);
                    domStyle.set(this.pointPayBtn, "display", pointDisplay); 
                    domStyle.set(this.aliPayBtn, "display", onlineDisplay);
                    domStyle.set(this.weixinPayBtn, "display", onlineDisplay);
                    domStyle.set(this.footerFloor.domNode.parentNode,"height",(parseInt(domStyle.get(this.div_button,"height"))+47)+"px");
                }
                this.updateCenterPaneHeight();
            }
        },
        tradeDetailClick: function(e) {
            var n = e.target;
            if (n&&n.tagName=="A") {
                var entryId = domAttr.get(n,"entryId")||"";
                if(entryId){
                    if(domClass.contains(n,"pauseOrder")||domClass.contains(n,"recoveryOrder")){
                        this.pauseOrderFun(entryId);
                    }else if(domClass.contains(n,"sign")){
                        this.sign(entryId);
                    }else if(domClass.contains(n,"more")){
                        var moreBtn = query("ul[entryId='"+entryId+"']",this.tradeDetailList.domNode)[0];
                        query("ul",this.tradeDetailList.domNode).forEach(function(d){
                            if(!domClass.contains(d,"hide")&&d!=moreBtn){
                                domClass.add(d,"hide");
                            }
                        });
                        // 已经隐藏 则显示 否则 隐藏
                        domClass[domClass.contains(moreBtn,"hide")?"remove":"add"](moreBtn,"hide");
                    }else if (domClass.contains(n,"cancelOrder")) {
                        this.cancelOrderFun(entryId);
                    }
                }
            }
        },
        initOrderDetailEvent:function(){
            this.inherited(arguments);
            this.connect(this.tradeHeadList.domNode, "onclick", this.tradeDetailClick);
        },
        cancelOrderFun: function(did) {
            this.inherited(arguments);
            this.refreshAllList();
            this.updateFooter();
        }
    });
});