define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-style",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dojo/Deferred",
    "widgets/userInfo"
    ], function(declare, Base, Shelf , registry ,query, domStyle, lang, array, domClass, xhr, json,Deferred,userInfo){
    return declare("widgets.sjmdsvc.pacBuyDetail", [Base, Shelf], {
        getShelfId: function() {
            return "31026";
        },
        getBaseShelfId:function(){
            return "31026";
        },
        ispacBuyDetailLoaded:function(){
            return !!this.pacBuyDetail;
        },
        initData: function() {
            this.inherited(arguments);
            if(this.ispacBuyDetailLoaded()){
                window.busy();
                this.refreshAllList();
            }
        },
        onTplLoaded:function(){
            this.initpacBuyDetailEvent();
        },
        initpacBuyDetailEvent:function(){
            this.picItems2 = registry.byId('picItems2');//图片滚动器
            this.connect(this.picItems2, "onBeforeRender", function() {//图片滚动器
                if (this.picItems2.items.length > 0) {
                    array.forEach(this.picItems2.items, function(item) {
                        item.src = "/w/img/load/" + g_sys_info.code + "-" + item.DID + ".png";
                        item.title = "";
                    });
                }
            });
            this.pacBuyDetail = registry.byId('pacBuyDetailList2');  
            this.connect(this.pacBuyDetail.domNode,"onclick",lang.hitch(this,function(e){ //点击 团
                var domTarget =e.target || window.event.target;
                if(domClass.contains(domTarget,"btnDetailPrice")){
                    window.busy();
                    xhr("POST", {
                        url: "/w/market/NewTeam/" + window.code,
                        handleAs: "json",
                        content: {
                            "actionId":window.did
                        },
                        load: lang.hitch(this, function(result) {
                            switch(result.rtnType){//开团成功
                                case 1:
                                    alert('开团成功');
                                    var arr = ["PACBUY_TEAMID_"+result.data.items[0].DID+"_FREEPOST_"+this.FREEPOST,this.PACPRICE];
                                    window.singleBuyMat(this.RIID,1,arr);
                                    break;
                                case 300: //自动登录
                                    this.loadDataFun().then(lang.hitch(this,function(data){
                                        if(data == true){
                                            xhr("POST", {//自动登录完成后，再开团
                                                url: "/w/market/NewTeam/" + window.code,
                                                handleAs: "json",
                                                content: {
                                                    "actionId":window.did
                                                },
                                                load:lang.hitch(this,function(result){
                                                    if(result.rtnType == 1){
                                                        window.busy();
                                                        alert('开团成功');
                                                        var arr = ["PACBUY_TEAMID_"+result.data.items[0].DID+"_FREEPOST_"+this.FREEPOST,this.PACPRICE];
                                                        window.singleBuyMat(this.RIID,1,arr);
                                                    }else{
                                                        window.free();
                                                        alert(result.message)
                                                    }
                                                })
                                            })
                                        };
                                    }));
                                    break;
                                default:
                                    window.free();
                                    alert(result.message);
                            }
                            
                        })
                    });
                }
            }));
            this.connect(this.pacBuyDetail,'onDefRendered',function(data){//加载商品图片
                this.RIID = data.data.items[0].MID.T0_MID;
                this.FREEPOST = data.data.items[0].FREEPOST;//拼团是否包邮
                this.PACPRICE = data.data.items[0].PACPRICE; //拼团活动价
                data = data.data.items;
                array.forEach(data,function(item){
                    if(new Date(item.SDATE) > new Date()){ //如果还未到开始时间   
                        item.startDate = item.SDATE.substr(0,16);
                    }else{
                        item.startDate = "";
                        item.endDate = item.DDATE.substr(0,16);
                    }
                });
               this.picItems2.where = "[RID]='XSY_TBSSC_MAT' AND [RIID]=" + this.RIID; 
               this.picItems2.refresh();
            });
        },
        refreshAllList:function(){
            this.inherited(arguments); 
            this.pacBuyDetail.refreshList();
            window.free();
        },
        loadDataFun:function(){
            var def = new Deferred();
            // 加载微信会员信息
            xhr("GET",{
                url:window.g_sys_info.url_usr,
                handleAs:"json",
                load:lang.hitch(this, function(data){
                    this.wxm = data && data.data && data.data.items[0];
                    def.resolve(data && data.data && data.data.items[0]);
                }),
                sync:false,
				preventCache:true,
				content:{
				    modalName:"XSY_TWBCM_WXM",
				    filter:"02",
				    hash:encodeURIComponent(json.toJson({
				        AID:window.g_sys_info.aid,
				        OPENID:window.wx_openId
				    }))
				}
            });
            def.then(lang.hitch(this, function(data){
                userInfo.hasLogin().then(lang.hitch(this, function(s){
                    if(!s && (!this.wxm || this.wxm.SUBSCRIBED == 0)){// 未关注 未注册
                        xhr("GET",{
                            url:"/w/user/WxAutoRegist/" + window.code,
                            handleAs:"json",
                            load:function(data){
                                if (1 === result.rtnType) {
        							if(result.data&&userInfo.serverUserInfoBack){
        								userInfo.serverUserInfoBack(result.data);
        							}
        							def.resolve(true);
        						} else {
        							//执行失败
        							alert("您输入的验证码不正确，请检查后重新输入！如您长时间未收到系统发送的验证码，请检查是否被拦截功能拦截，或请致电400-023-8993咨询！");
        							def.resolve(false);
        						}
                            },
                            sync: false,
                            preventCache: true
                        });
                    }else{
                        def.resolve(true);
                    }
                }));
            }));
        }
    });
});