define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-style",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class"
    ], function(declare, Base, Shelf , registry ,query, domStyle, lang ,array, domClass) {
    return declare("widgets.sjmdsvc.pacBuyList", [Base, Shelf], {
        getShelfId: function() {
            return "31024";
        },
        isPacBuyListLoaded:function(){
            return !!this.pacBuyList
        },
        initData: function() {
            this.inherited(arguments);
        },
        onTplLoaded:function(){
            if(this.isPacBuyListLoaded()){
                window.busy();
                this.refreshAllList()
            }
            this.initPacBuyListEvent();
        },
        initPacBuyListEvent:function(){
            this.pacBuyList = registry.byId('pacBuyList1');
            this.connect(this.pacBuyList ,'onDefRendered', function(data){
               data = data.data.items;
               array.forEach(data,function(item){
                    if(new Date(item.SDATE) > new Date()){ //如果还未到开始时间   
                        item.startDate = item.SDATE.substr(0,16);
                    }else{
                        item.startDate = ""
                        item.endDate = item.DDATE.substr(0,16);
                    }
                    item.discount = item.PACPRICE/item.MID.T3_RetailPrice*10; //折扣
                    if(item.discount < 0.1){
                        item.discount = 0.1;
                    }
               })
            })
        },
        refreshAllList:function(){
            this.inherited(arguments); 
            //this.initPacBuyListEvent()
        }
    });
});