define([
    "dojo/_base/declare", 
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "dojo/dom-construct",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/_base/lang",
    "widgets/userInfo",
    "dojo/dom-attr",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dojo/Deferred"
], function(declare, Base, Shelf,domConstruct,registry,query,domStyle,domClass,lang,userInfo,domAttr,xhr,json,Deferred) {
    return declare("widgets.zctapp.classRoomDtl", [Base,Shelf], {
        getShelfId:function(){
            return "31100";
        },
        onBeforeTransitionOut:function(){
            this.SignToHide();
            this.inherited(arguments);
        },
        blankOnClick:function(e){
            this.SignToHide();
        },
        // 如果点击非空白区域,则关闭div 
        SignToHide:function(){
            domClass.add(this.sign,"hide");
        },
        initData:function(){
            if(this.isClassRoomDtlLoaded()){
                this.refreshAllList();
            }
            this.inherited(arguments);
        },
        //点击报名，判断当前客户是否已经报名
        checkSign:function(){
            var def = new Deferred();
            //userInfo.hasLogin().then(lang.hitch(this,function(s){
            window.loadData({
                modalName:"XSY_TCRMK_CLASSROOM_P",
                where:"[PID]='"+userInfo.getUserInfo().partnerId+"' AND [BID]='"+window.did+"'"
            }).then(function(data){
                if(data.length){
                    def.resolve(true);
                }else{
                    def.resolve(false);
                }
            });
            //}));
            return def;
        },
        //点击报到，判断当前客户是否已经报到
        checkReport:function(){
            var def = new Deferred();
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                window.loadData({
                    modalName:"XSY_TCRMK_CLASSROOM_P",
                    where:"[PID]='"+userInfo.getUserInfo().partnerId+"' AND [BID]='"+window.did+"'"
                }).then(function(data){
                    if(data.length){
                        if(data[0].IS_REPORT==1){
                            def.resolve(true);
                        }else{
                            def.resolve(false);
                        }
                    }else{
                        def.resolve(false);
                    }
                });
            }));
            return def;
        },
        refreshAllList:function(){
            window.loadData({
                modalName:"XSY_TCRMK_CLASSROOM",
                where:"[DID]="+window.did
            }).then(lang.hitch(this,function(data){
                // 获取讲堂的报名开始结束时间 讲堂开始结束时间
                var SIGN_SDATE = data&&data[0]&&data[0].SIGN_SDATE,
                    SIGN_EDATE = data&&data[0]&&data[0].SIGN_EDATE,
                    SDATE = data&&data[0]&&data[0].SDATE,
                    EDATE = data&&data[0]&&data[0].EDATE;
                // 当前时间在报名时间之前
                if(g_s.dateDiff('s',SIGN_SDATE,g_s.getDateTime())<0){
                    // 不能报名 也不能报到
                    this.IsSign(false);
                }
                // 当前时间在报名时间范围内
                else if(g_s.dateDiff('s',SIGN_SDATE,g_s.getDateTime())>0 && g_s.dateDiff('s',SIGN_EDATE,g_s.getDateTime())<0){  
                    this.IsSign(true);
                } 
                // 当前时间在报名结束和讲堂结束时间范围内
                else if(g_s.dateDiff('s',SIGN_EDATE,g_s.getDateTime())>0 && g_s.dateDiff('s',EDATE,g_s.getDateTime())<0){
                    this.IsReport(false);
                }else{
                    this.IsReport(true);
                }
                var o = {};
                o.data = {};
                o.data.items = data;
                // 重算日期格式
                var sd = data[0].SDATE.split(" "),ed = data[0].EDATE.split(" ");
                
                data[0].SDATE = sd[0].split("-")[0]+"年"+sd[0].split("-")[1]+"月"+sd[0].split("-")[2]+"日"+" "+sd[1].split(":")[0]+"点"+(sd[1].split(":")[1]>0?sd[1].split(":")[1]+"分":"");
                if(sd[0]==ed[0]){
                    data[0].EDATE = ed[1]?(ed[1].split(":")[0]+"点"+(ed[1].split(":")[1]>0?ed[1].split(":")[1]+"分":"")):"24点";
                }else{
                    data[0].EDATE = ed[0].split("-")[0]+"年"+ed[0].split("-")[1]+"月"+ed[0].split("-")[2]+"日"+" "+ed[1].split(":")[0]+"点"+(ed[1].split(":")[1]>0?ed[1].split(":")[1]+"分":"");
                }
                this.classRoom_content.onDataReady(o);
                // this.classRoom_content.refreshList();
                this.bg_classRoom_img.refreshList();
                this.bg_classRoom_par.refreshList();
            }));
        },
        //当前时间是否在报名时间范围内
        IsSign:function(result){
            if(result){
                domClass.remove(this.class_report,"class_f6");
                domClass.add(this.class_report,"class_a3");
                // 判断当前人是否已经报名 
                // 如果已经报名 
                // 如果没有报名
                this.checkSign().then(lang.hitch(this,function(s){
                    // 未报名 才允许报名
                    if(!s){
                        domClass.add(this.class_signup,"class_f6");
                        domClass.remove(this.class_signup,"class_a3");
                    }else{
                        domClass.remove(this.class_signup,"class_f6");
                        domClass.add(this.class_signup,"class_a3");
                    }
                }));
            }else{
                domClass.remove(this.class_report,"class_f6");
                domClass.add(this.class_report,"class_a3");
                
                domClass.remove(this.class_signup,"class_f6");
                domClass.add(this.class_signup,"class_a3");
            }
        },
        //当前时间是否在签到范围内
        IsReport:function(result){
            if(result){
                domClass.remove(this.class_report,"class_f6");
                domClass.add(this.class_report,"class_a3");
                
                domClass.remove(this.class_signup,"class_f6");
                domClass.add(this.class_signup,"class_a3");
                
                // domClass.remove(this.bg_classRoom_par.domNode,"hide");
            }else{
                domClass.remove(this.class_signup,"class_f6");
                domClass.add(this.class_signup,"class_a3");
                // 检查是否签到
                this.checkReport().then(lang.hitch(this,function(s){
                    if(!s){
                        domClass.add(this.class_report,"class_f6");
                        domClass.remove(this.class_report,"class_a3");
                    }else{
                        domClass.remove(this.class_report,"class_f6");
                        domClass.add(this.class_report,"class_a3");
                        // domClass.remove(this.bg_classRoom_par.domNode,"hide");
                        
                    }
                }));
            }
        },
        indexClassRoomDtlElement:function(){
            this.classRoom_content = registry.byNode(query(".classRoom_content",this.domNode)[0]);
            this.classRoom_reply = query(".classRoom_reply",this.domNode)[0];
            //报名
            this.class_signup = query(".class_signup",this.domNode)[0];
            //报道
            this.class_report = query(".class_report",this.domNode)[0];
            this.class_submit = query(".class_submit",this.domNode)[0];
            this.signtop = query(".signtop",this.domNode)[0];
            this.bg_classRoom = registry.byId("bg_classRoom");
            this.bg_classRoom_par = registry.byNode(query(".bg_classRoom_par",this.domNode)[0]);
            this.bg_classRoom_img = registry.byNode(query(".bg_classRoom_img",this.domNode)[0]);
            this.sign = query(".sign",this.domNode)[0];
            document.body.appendChild(this.sign);
            this.footerFloor.domNode.appendChild(this.classRoom_reply);
        },
        isClassRoomDtlLoaded:function(){
            return !!this.classRoom_content;
        },
        initClassRoomDtlEvent:function(){
            this.connect(this.class_signup,"onclick",this.signUpOnClick);
            this.connect(this.class_report,"onclick",this.reportOnClick);
            //提交报名人信息
            this.connect(this.class_submit,"onclick",this.saveSignContent);
            this.connect(this.signtop,"onclick",this.bgFixedTopClick);
        },
        signUpOnClick:function(){
            if(domClass.contains(this.class_signup,"class_f6")){
                userInfo.hasLogin().then(lang.hitch(this,function(s){
                    if(!s){
                        alert("请先登录");
                        window.nextPageOnLogin = "classRoomDtl-"+window.did;
                        userInfo.showLogin();
                    }else{
                        this.checkSign().then(lang.hitch(this,function(s){
                            if(s){
                                alert("您已经报名");
                            }else{
                                domClass.remove(this.sign,"hide");
                                query(".PNAME",this.sign)[0].value = userInfo.getUserInfo().name;
                                query(".PTEL",this.sign)[0].value = userInfo.getUserInfo().tel;
                            }
                        }));
                    }
                }));
            }
        },
        reportOnClick:function(){
            if(!domClass.contains(this.class_report,"class_f6")){
                return;
            }
            // 检查是否已经登录
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(!s){
                    window.nextPageOnLogin = "classRoomDtl-"+window.did;
                    userInfo.showLogin();
                }else{
                    // 检查是否已经报名
                    this.checkSign().then(lang.hitch(this,function(s){
                        if(s){
                            window.busy();
                            var info = {
                                "IS_REPORT":1,
                                "REPORT_TIME":g_s.getDateTime()
                            };
                             var data ={
                                n:info,
                                o:{
                                    BID:window.did,
                                    PID:userInfo.getUserInfo().partnerId
                                }
                            };
                            xhr("POST", {
                                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                                handleAs: "json",
                                content: {
                                    data: json.toJson({
                                        modalName: "XSY_TCRMK_CLASSROOM_P ",
                                        data: [data]
                                    })
                                },
                                load: lang.hitch(this, function(result) {
                                    window.free();
                                    if (1 === result.rtnType) {
                                        alert("报到成功");
                                        this.refreshAllList();
                                    } else {
                                        
                                        alert("报到失败");
                                    }
                                })
                            });
                        }else{
                            alert("您未报名,不能报到");
                        }
                    }));
                }
            }));
        },
        saveSignContent:function(){
             var info = {
                BID:window.did,
                PID:userInfo.getUserInfo().partnerId,
                PNAME:query(".PNAME",this.sign)[0].value,
                PTEL:query(".PTEL",this.sign)[0].value,
                SIGN_TIME:g_s.getDateTime()
            };
            if(!info.PNAME || info.PNAME.replace(/(^\s*)|(\s*$)/g, "")==""){
                alert("请输入姓名！");
                return false;
            }
            if(!info.PTEL){
                alert("请输入联系电话！");
                return false;
            }else if(!(/(^1[3|4|5|7|8][0-9]{9}$)/.test(info.PTEL))){
                alert("电话格式错误！");
                return false;
            }
            var data ={
                n:info,
                o:{
                    BID:window.did,
                    PID:userInfo.getUserInfo().partnerId,
                }
            };
             xhr("POST", {
                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    data: json.toJson({
                        modalName: "XSY_TCRMK_CLASSROOM_P ",
                        data: [data]
                    })
                },
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        window.free();
                        alert("报名成功");
                        // 给报名人员发送短信
                        xhr("POST",{
                            url: "../../exec/exec/" + window.code,
                            handleAs: "json",
                            content: {
                                tp:"zct_cr_msg",
                                paramStr:info.PTEL
                            },
                            load: lang.hitch(this, function(result) {
                                if(result.rtnType==1){
                                    // 发送成功
                                    query(".PNAME")[0].value = "";
                                    query(".PTEL")[0].value = "";
                                    domClass.add(this.sign,"hide");
                                    this.refreshAllList();
                                }
                            })
                        });
                    } else {
                        window.free();
                        alert("报名失败");
                    }
                })
            });
        },
        onTplLoaded:function(pane){
            this.inherited(arguments);
            this.indexClassRoomDtlElement();
            this.initClassRoomDtlEvent();
            this.refreshAllList();
        },
    });
});
